Package: Hmisc
Version: 5.2-6
Date: 2026-06-18
Title: Harrell Miscellaneous
Authors@R: 
    c(person(given   = "Frank E",
             family  = "Harrell Jr",
             role    = c("aut", "cre"),
             email   = "fh@fharrell.com",
             comment = c(ORCID = "0000-0002-8271-5493")),
      person(given   = "Cole",
             family  = "Beck",
             role    = c("ctb"),
             email   = "cole.beck@vumc.org" ),
			person(given   = "Charles",
			       family  = "Dupont",
						 role    = "ctb") )
Depends: R (>= 4.2.0)
Imports: methods, ggplot2, cluster, rpart, nnet, foreign, gtable, grid,
        gridExtra, data.table, htmlTable (>= 1.11.0), viridisLite,
        htmltools, base64enc, colorspace, rmarkdown, knitr, Formula
Suggests: survival, qreport, acepack, chron, rms, mice, rstudioapi,
        tables, plotly (>= 4.5.6), rlang, VGAM, leaps, pcaPP, digest,
        parallel, polspline, abind, kableExtra, rio, lattice,
        latticeExtra, gt, sparkline, jsonlite, htmlwidgets, qs2,
        getPass, keyring, safer, htm2txt, boot
Description: Contains many functions useful for data
	analysis, high-level graphics, utility operations, functions for
	computing sample size and power, simulation, importing and annotating datasets,
	imputing missing values, advanced table making, variable clustering,
	character string manipulation, conversion of R objects to LaTeX and html code,
	recoding variables, caching, simplified parallel computing, encrypting and decrypting data using a safe workflow, general moving window statistical estimation, and assistance in interpreting principal component analysis.
License: GPL (>= 2)
LazyLoad: Yes
URL: https://hbiostat.org/R/Hmisc/
Encoding: UTF-8
Config/roxygen2/version: 8.0.0
NeedsCompilation: yes
Packaged: 2026-06-18 19:06:02 UTC; harrelfe
Author: Frank E Harrell Jr [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-8271-5493>),
  Cole Beck [ctb],
  Charles Dupont [ctb]
Maintainer: Frank E Harrell Jr <fh@fharrell.com>
Repository: CRAN
Date/Publication: 2026-06-19 05:10:39 UTC

Hmisc
=====

Harrell Miscellaneous

Current Goals
=============
* Continue to refine the summaryX class of functions that replace tables with graphics
   * See also bpplotM and tabulr
* See https://hbiostat.org/R/Hmisc/summaryFuns.pdf

Web Sites
=============
* Overall: https://hbiostat.org/R/Hmisc
* CRAN: http://cran.r-project.org/web/packages/Hmisc
* Changelog: https://github.com/harrelfe/Hmisc/commits/master

To Do
=====
* Consider using the haven package for importing SAS, Stata, and SPSS files; haven stores labels as the label attribute of each variable as does Hmisc; it converts date and time variables automatically and allows one to specify a format catalog along with the primary dataset
* See if the readstata13 package has advantages over the foreign package for Stata file import
* Consider creating xl.get using the readxl package to read .xls and .xlsx Excel files
* In impute.transcan, sense if a variable in data is not a factor whereas it was treated as a factor during aregImpute; it should be converted to factor before the line v[sub] <- ... levels(as.integer...)) is run

#' Combination Plot
#' 
#' Generates a plotly attribute plot given a series of possibly overlapping binary variables
#' 
#' Similar to the \code{UpSetR} package, draws a special dot chart sometimes called an attribute plot that depicts all possible combination of the binary variables.  By default a positive value, indicating that a certain condition pertains for a subject, is any of logical \code{TRUE}, numeric 1, \code{"yes"}, \code{"y"}, \code{"positive"}, \code{"+"} or \code{"present"} value, and all others are considered negative.  The user can override this determination by specifying her own \code{pos} function.  Case is ignored in the variable values.
#' 
#' The plot uses solid dots arranged in a vertical line to indicate which combination of conditions is being considered.  Frequencies of all possible combinations are shown above the dot chart.  Marginal frequencies of positive values for the input variables are shown to the left of the dot chart.  More information for all three of these component symbols is provided in hover text.
#'
#' Variables are sorted in descending order of marginal frqeuencies and likewise for combinations of variables.
#' 
#' @param formula a formula containing all the variables to be cross-tabulated, on the formula's right hand side.  There is no left hand side variable.  If \code{formula} is omitted, then all variables from \code{data} are analyzed.
#' @param data input data frame.  If none is specified the data are assumed to come from the parent frame.
#' @param subset an optional subsetting expression applied to \code{data}
#' @param na.action see \code{lm} etc.
#' @param vnames set to \code{"names"} to use variable names to label axes instead of variable labels.  When using the default \code{labels}, any variable not having a label will have its name used instead.
#' @param includenone set to \code{TRUE} to include the combination where all conditions are absent
#' @param showno set to \code{TRUE} to show a light dot for conditions that are not part of the currently tabulated combination
#' @param maxcomb maximum number of combinations to display
#' @param minfreq if specified, any combination having a frequency less than this will be omitted from the display
#' @param N set to an integer to override the global denominator, instead of using the number of rows in the data
#' @param pos a function of vector returning a logical vector with \code{TRUE} values indicating positive
#' @param obsname character string noun describing observations, default is \code{"subjects"}
#' @param ptsize point size, defaults to 35
#' @param width width of \code{plotly} plot
#' @param height height of \code{plotly} plot
#' @param \dots optional arguments to pass to \code{table}
#' 
#' @return \code{plotly} object
#' @author Frank Harrell
#' @examples
#' if (requireNamespace("plotly")) {
#'   g <- function() sample(0:1, n, prob=c(1 - p, p), replace=TRUE)
#'   set.seed(2); n <- 100; p <- 0.5
#'   x1 <- g(); label(x1) <- 'A long label for x1 that describes it'
#'   x2 <- g()
#'   x3 <- g(); label(x3) <- 'This is<br>a label for x3'
#'   x4 <- g()
#'   combplotp(~ x1 + x2 + x3 + x4, showno=TRUE, includenone=TRUE)
#'
#'   n <- 1500; p <- 0.05
#'   pain       <- g()
#'   anxiety    <- g()
#'   depression <- g()
#'   soreness   <- g()
#'   numbness   <- g()
#'   tiredness  <- g()
#'   sleepiness <- g()
#'   combplotp(~ pain + anxiety + depression + soreness + numbness +
#'             tiredness + sleepiness, showno=TRUE)
#' }
#' @export

combplotp <- function(formula, data=NULL, subset, na.action=na.retain,
                      vnames=c('labels', 'names'),
                      includenone=FALSE, showno=FALSE,
                      maxcomb=NULL, minfreq=NULL, N=NULL,
                      pos=function(x) 1 * (tolower(x) %in% 
                        c('true', 'yes', 'y', 'positive', '+', 'present', '1')),
                      obsname='subjects',
                      ptsize=35, width=NULL, height=NULL,
                      ...) {

  if (!requireNamespace("plotly"))
    stop("This function requires the 'plotly' package.")
  
  vnames <- match.arg(vnames)
  frac   <- markupSpecs$html$frac
  fr2    <- function(a, b) paste0(frac(a, b), ' = ', round(a / b, 3))
  
  Y <- if(missing(formula)) {
    if(! missing(subset)) stop('subset not allowed if formula missing')
    if(! length(data)) stop('data must be specified if formula missing')
    data
    } else {
      if(!missing(subset) && length(subset))
        model.frame(formula, data=data, subset=subset, na.action=na.action)
      else
        model.frame(formula, data=data, na.action=na.action)
      }
  # Get variable labels, defaulting to variable names
  labs <- if(vnames == 'names') structure(names(Y), names=names(Y))
  else {
    lbs <- sapply(Y, label)
    ifelse(lbs == '', names(Y), lbs)
  }

  # Convert Y to logical TRUE/FALSE
  Y <- lapply(Y, pos)
  # Compute marginal frequencies
  m <- sapply(Y, sum, na.rm=TRUE)
  # Sort variables in order of descending marginal frequency
  Y <- Y[order(m)]
  if(! length(N)) N <- length(Y[[1]])    # no. obs
  f <- as.data.frame(table(Y, ...))
  f <- f[f$Freq > 0, ]   # subset didn't work
  p <- ncol(f) - 1       # no. variables
  numcondpresent <- apply(f[, 1 : p], 1, function(u) sum(u == 1))
  Nc <- sum(f$Freq[numcondpresent > 0])  # no. obs with any condition
  if(! includenone && any(numcondpresent == 0))
      f <- f[numcondpresent > 0, ]

  # Sort combinations in descending order of frequency
  # Tie-breaker is row order when a combination has only one condition
  mdesc <- sort(m)
  mdesc <- 1 : length(mdesc)
  names(mdesc) <- names(sort(m))
  g <- function(x) {
    i <- x > 0
    ifelse(sum(i) == 1, mdesc[names(x)[i]], 0)
  }

  tiebr <- apply(f[, 1 : p], 1, g)
  i <- order(-f$Freq, -tiebr)
  f <- f[i, ]


  if(length(maxcomb) && maxcomb < nrow(f))     f <- f[1 : maxcomb, ]
  if(length(minfreq) && any(f$Freq < minfreq)) f <- f[f$Freq >= minfreq, ]
  
  n <- nrow(f)        # no. combinations
  X <- as.matrix(1 * (f[, 1 : p] == '1'))
  Freq <- f$Freq
  
  # String out information
  x <- y <- present <- txt <- xn <- frq <- NULL
  namx <- colnames(X)
  for(i in 1 : n) {
    x         <- c(x, rep(i, p))
    y         <- c(y, 1 : p)
    xi        <- X[i, ]
    present   <- c(present, xi)
    namespres <- if(! any(xi == 1)) 'none' else
                  paste(labs[namx][xi == 1], collapse='<br>')
    k         <- Freq[i]
    tx <- paste0('<b>', namespres, '</b><br>',
                 '<br>Count: ',                                k,
                 '<br>Fraction of ', obsname, ': ',            fr2(k, N),
                 '<br>Fraction of ', obsname, ' w/any cond: ', fr2(k, Nc))
    txt <- c(txt, rep(tx, p))
    xn  <- c(xn,  namx)
    frq <- c(frq, rep(k, p))
  }
  txt <- paste0(txt, '<br>Fraction of ', obsname, ' w/', namx[y], ': ',
                fr2(frq, m[namx[y]]))
  hdc <- plotlyParm$heightDotchartb
  if(! length(height)) height <- hdc(c(labs, '', ''), low=250, per=30)
  if(! length(width)) {
    # Find longest html line in labs
    w        <- unlist(strsplit(labs, '<br>'))
    longest  <- w[which.max(nchar(w))]
    nlongest <- nchar(longest)
    width    <- hdc(rep('X', n), per=23, low=450) + 8 * nlongest
  }
  auto <- .Options$plotlyauto
  if(length(auto) && auto) {height <- width <- NULL}
  P <- plotly::plot_ly(height=height, width=width)
  
  # Add grid lines to take control of their span
  yy <- 1 : p
  P <- plotly::add_segments(P,
                            x = ~ rep(-2, p), xend = ~ rep(n, p),
                            y = ~ 1 : p, yend = ~ 1 : p,
                            color = I('gray80'), line=list(width=0.75),
                            hoverinfo='none', showlegend=FALSE)
  
  P <- plotly::add_segments(P,
                            x = ~ 1 : n, xend = ~ 1 : n,
                            y = ~ rep(1, n), yend = ~ rep(p + 1.5, n),
                            color = I('gray80'), line=list(width=0.75),
                            hoverinfo='none', showlegend=FALSE)

  # Show main result as dot chart
  P <- plotly::add_markers(P,
                           x    = ~ x[present == 1],
                           y    = ~ y[present == 1],
                           text = ~ txt[present == 1],
                           hoverinfo='text',
                           color=I('black'), size=I(ptsize),
                           showlegend=FALSE)

  if(showno)
    P <- plotly::add_markers(P,
                             x = ~ x[present == 0],
                             y = ~ y[present == 0],
                             hoverinfo='none',
                             color=I('gray90'), size=I(ptsize),
                             showlegend=FALSE)
                             
  
  # Add a trace showing marginal frequencies on the left as segments
  relfreq <- m[namx] / max(m)
  tmf <- paste0('<b>', labs[namx],
                '</b><br><br>Marginal count: ',               m[namx],
                '<br>Fraction of ', obsname, ': ',            fr2(m[namx], N),
                '<br>Fraction of ', obsname, ' w/any cond: ', fr2(m[namx], Nc))
                
  P <- plotly::add_segments(P,
                            x = ~ rep(0, p), xend= ~ -2 * relfreq,
                            # y = ~ labs[namx], yend ~ labs[namx],
                            y = ~ 1 : p, yend ~ 1 : p,
                            text = ~ tmf,
                            hoverinfo='text', color=I('blue'), 
                            name='Marginal Counts',
                            showlegend=TRUE,
                            line=list(width=3)
                            )

  # Add a trace showing the individual combination frequencies on top
  relfreqc <- Freq / max(Freq)
  nn <- 1 : n
  xi <- X[i, ]
  present <- c(present, xi)
  namespres <- if(! any(xi == 1)) 'none' else
    paste(labs[namx][xi == 1], collapse='<br>')
  txtc <- character(n)
  for(i in 1 : n) {
    xi <- X[i, ]
    txtc[i] <- if(! any(xi == 1)) 'none' else
      paste(labs[namx][xi == 1], collapse='<br>')
  }
  txtc <- paste0('<b>', txtc, '</b>',
                 '<br><br>Count: ',                            Freq,
                 '<br>Fraction of ', obsname, ': ',            fr2(Freq, N),
                 '<br>Fraction of ', obsname, ' w/any cond: ', fr2(Freq, Nc))
  
  P <- plotly::add_segments(P,
                            x    = ~ nn,
                            xend = ~ nn,
                            y    = ~ rep(p + 0.5, n),
                            yend = ~ p + 0.5 + relfreqc,
                            text = ~ txtc,
                            hoverinfo='text', color=I('black'),
                            name='Combination Counts',
                            showlegend=TRUE, line=list(width=3))
  
  # Add variable labels as annotations
  P <- plotly::add_text(P,
                        x = ~ rep(n + 0.7, p), y = 1 : p,
                        text = ~ labs[namx],
                        textposition="middle right",
                        hoverinfo='none',
                        showlegend=FALSE)
  
                          
  # leave extra space for long label
  P <- plotly::layout(P,
                      xaxis = list(title='', tickvals=1 : n,
                                   range=c(-2, n + 0.4 * nlongest),
                                   showgrid=FALSE,
                                   showticklabels=FALSE, zeroline=FALSE),
                      yaxis = list(title='', tickvals=1 : p,
                                   showgrid=FALSE,
                                   showticklabels=FALSE),
                      legend= list(x=0.5, y=0, xanchor='center', yanchor='top', orientation='h'))

  P
}

##' Simulate Ordinal Markov Process
##'
##' Simulates longitudinal data for subjects following a first-order Markov process under a proportional odds model.  Optionally, response-dependent sampling can be done, e.g., if a subject hits a specified state at time t, measurements are removed for times t+1, t+3, t+5, ...  This is applicable when for example a study of hospitalized patients samples every day, Y=1 denotes patient discharge to home, and sampling is less frequent outside the hospital.  This example assumes that arriving home is not an absorbing state, i.e., a patient could return to the hospital.
##' @title simMarkovOrd
##' @param n number of subjects to simulate
##' @param y vector of possible y values in order (numeric, character, factor)
##' @param times vector of measurement times
##' @param initial initial value of `y` (baseline state; numeric, character, or factor matching `y`).  If length 1 this value is used for all subjects, otherwise it is a vector of length `n`.
##' @param X an optional vector of matrix of baseline covariate values passed to `g`.  If a vector, `X` represents a set of single values for all the covariates and those values are used for every subject.  Otherwise `X` is a matrix with rows corresponding to subjects and columns corresponding to covariates which `g` must know how to handle.  `g` only sees one row of `X` at a time.
##' @param absorb vector of absorbing states, a subset of `y` (numeric, character, or factor matching `y`).  The default is no absorbing states.  Observations are truncated when an absorbing state is simulated.
##' @param intercepts vector of intercepts in the proportional odds model.  There must be one fewer of these than the length of `y`.
##' @param g a user-specified function of three or more arguments which in order are `yprev` - the value of `y` at the previous time, the current time `t`, the `gap` between the previous time and the current time, an optional (usually named) covariate vector `X`, and optional arguments such as a regression coefficient value to simulate from.  The function needs to allow `yprev` to be a vector and `yprev` must not include any absorbing states.  The `g` function returns the linear predictor for the proportional odds model aside from `intercepts`.  The returned value must be a matrix with row names taken from `yprev`.  If the model is a proportional odds model, the returned value must be one column.  If it is a partial proportional odds model, the value must have one column for each distinct value of the response variable Y after the first one, with the levels of Y used as optional column names.  So columns correspond to `intercepts`. The different columns are used for `y`-specific contributions to the linear predictor (aside from `intercepts`) for a partial or constrained partial proportional odds model.  Parameters for partial proportional odds effects may be included in the ... arguments.
##' @param carry set to `TRUE` to carry absorbing state forward after it is first hit; the default is to end records for the subject once the absorbing state is hit
##' @param rdsample an optional function to do response-dependent sampling.  It is a function of these arguments, which are vectors that stop at any absorbing state: `times` (ascending measurement times for one subject), `y` (vector of ordinal outcomes at these times for one subject.  The function returns `NULL` if no observations are to be dropped, returns the vector of new times to sample.
##' @param ... additional arguments to pass to `g` such as a regresson coefficient
##' @return data frame with one row per subject per time, and columns id, time, yprev, y, values in ...
##' @author Frank Harrell
##' @seealso <https://hbiostat.org/R/Hmisc/markov/>
##' @export
##' @md
simMarkovOrd <- function(n=1, y, times, initial, X=NULL, absorb=NULL,
                         intercepts, g, carry=FALSE, rdsample=NULL, ...) {

  if(is.factor(y))       y       <- as.character(y)
  if(is.factor(initial)) initial <- as.character(initial)
  if(is.factor(absorb))  absorb  <- as.character(absorb)
  ychar <- is.character(y)

  if(length(initial) == 1) initial <- rep(initial, n)
  if(length(initial) != n) stop('initial must have length 1 or n')
  if(any(initial %in% absorb))
    stop('initial state cannot be an absorbing state')

  Xmat <- length(X) && is.matrix(X)
  if(Xmat && ! length(colnames(X)))
    stop('when a matrix, X must have column names')
  if(length(X) && ! Xmat && ! length(names(X)))
    stop('when a vector, elements of X must have names')
  
  nt     <- length(times)
  Y      <- Yp <- if(ychar) character(nt) else numeric(nt)
  gaps   <- numeric(nt)
  ID     <- Time <- Gap <- numeric(n * nt)
  YYprev <- YY <- if(ychar) character(n * nt) else numeric(n * nt)
  is     <- 1
  times.saved <- 0
  
  for(id in 1 : n) {
    tprev <- 0
    i     <- 0
    for(t in times) {
      i       <- i + 1
      gap     <- t - tprev
      gaps[i] <- gap
      yprev   <- if(i == 1) initial[id] else Y[i - 1]
      Yp[i]   <- yprev
      if(carry && (yprev %in% absorb)) Y[i] <- yprev
      else {
        xb    <- g(yprev, t, gap, X=if(Xmat) X[id, ] else X, ...)
        ## If partial PO model xb has 1 row (since yprev is scalar) and
        ## columns corresponding to intercepts.  If PO, is 1x1
        probs <- plogis(intercepts + xb)
        ## Compute cell probabilities from successive differences in
        ## exceedance probs
        probs <- c(1., probs) - c(probs, 0.)
        lo <- probs < 0.
        hi <- probs > 1.
        ## The following is needed for partial proportional odds models
        if(any(c(lo , hi))) {
          warning(paste('Probabilities < 0 or > 1 at time t=', t,
                        'id=', id,
                        ':', paste(probs[c(lo, hi)], collapse=' '),
                        'set to 0 or 1'))
          if(any(lo)) probs[lo] <- 0.
          if(any(hi)) probs[hi] <- 1.
          }
        Y[i]  <- sample(y, 1, prob=probs)
        if(! carry && (Y[i] %in% absorb)) break
      }
      tprev <- t
    }
    s     <- 1 : i
    atimes <- times[s]
    agaps  <- gaps[s]
    aYp    <- Yp[s]
    aY     <- Y[s]

    if(length(rdsample)) {
      stimes <- rdsample(atimes, aY)
      lt     <- length(stimes)
      if(lt) {
        times.saved <- times.saved + i - lt
        tsprev <- c(0, stimes[- lt])
        agaps   <- stimes - tsprev
        aY      <- aY[times %in% stimes]
        if(length(aY) != lt) stop('program logic error in simMarkovOrd')
        aYp     <- c(aYp[1], aY[- lt])
        atimes  <- stimes
      }
    }

    ie              <- is + length(aY) - 1
    ID    [is : ie] <- id
    Time  [is : ie] <- atimes
    Gap   [is : ie] <- agaps
    YYprev[is : ie] <- aYp
    YY    [is : ie] <- aY
    is              <- ie + 1
  }

  yy <- YY[1 : ie]
  if(ychar) yy <- factor(yy, levels=y)
  yyp <- YYprev[1 : ie]
  if(ychar) yyp <- factor(yyp, levels=setdiff(y, absorb))

  res <- data.frame(id=ID[1 : ie], time=Time[1 : ie], gap=Gap[1 : ie],
                    yprev=yyp, y=yy, ...)
  attr(res, 'times.saved.per.subject') <- times.saved / n
    
  ## Handle case where X is a constant vector to distribute to all obs
  if(length(X)) {
    if(Xmat) for(nam in colnames(X)) res[[nam]] <- X[res$id, nam]
    else
      for(nam in names(X)) res[[nam]] <- X[nam]
    }
  res
}    


#' State Occupancy Probabilities for First-Order Markov Ordinal Model
#'
#' @title soprobMarkovOrd
#' @inheritParams simMarkovOrd
#' @param y a vector of possible y values in order (numeric, character, factor)
#' @param times vector of measurement times
#' @param initial initial value of `y` (baseline state; numeric, character, factr)
#' @param absorb vector of absorbing states, a subset of `y`.  The default is no absorbing states. (numeric, character, factor)
#' @param intercepts vector of intercepts in the proportional odds model, with length one less than the length of `y`
#' @param ... additional arguments to pass to `g` such as covariate settings
#'
#' @return matrix with rows corresponding to times and columns corresponding to states, with values equal to exact state occupancy probabilities
#' @export
#' @author Frank Harrell
#' @seealso <https://hbiostat.org/R/Hmisc/markov/>
#' @export 
#' @md
soprobMarkovOrd <- function(y, times, initial, absorb=NULL,
                            intercepts, g, ...) {

  if(initial %in% absorb) stop('initial state cannot be an absorbing state')
  k  <- length(y)
  nt <- length(times)
  P  <- matrix(NA, nrow=nt, ncol=k)
  colnames(P) <- as.character(y)
  rownames(P) <- as.character(times)
  yna         <- setdiff(y, absorb)   # all states except absorbing ones
  yc          <- as.character(y)
  ynac        <- as.character(yna)

  ## Don't uncondition on initial state
  xb <- g(initial, times[1], times[1], ...)  # 3rd arg (gap) assumes time origin 0
  ## Since initial is scalar, xb has one row.  It has multiple columns if
  ## model is partial PO model, with columns exactly corresponding to intercepts
  pp <- plogis(intercepts + xb)
  ## Compute cell probabilities
  pp <- c(1., pp) - c(pp, 0.)
  P[1, ] <- pp

  tprev <- times[1]
  for(it in 2 : nt) {
    t <- times[it]
    gap <- t - tprev
    ## Compute linear predictor at all non-absorbing states
    xb <- g(yna, t, gap, ...)   #non-intercept part of x * beta
    ## g puts non-absorbing states as row names (= ynac)
    ## If partial PO model xb has > 1 column that correspond to intercepts

    ## Matrix of conditional probabilities of Y conditioning on previous Y
    ## Columns = k conditional probabilities conditional on a single previous state
    ## Rows    = all possible previous states
    ## When the row corresponds to an absorbing state, with prob. 1
    ## a subject will remain in that state so give it a prob of 1 and
    ## all other states a prob of 0

    cp <- matrix(NA, nrow=k, ncol=k, dimnames=list(yc, yc))
    for(yval in y) {   # current row
      yvalc <- as.character(yval)
      if(yval %in% absorb) {   # current row is an absorbing state
        cp[yvalc, setdiff(yc, yvalc)]    <- 0.  # P(moving to non-abs state)=0
        cp[yvalc, yvalc]                 <- 1.  # certainty in staying
      }
      else {  # current row is non-absorbing state
        pp <- plogis(intercepts + xb[yvalc, ])
        ## Compute cell probabilities
        pp <- c(1., pp) - c(pp, 0.)
        cp[yvalc, ] <- pp
      }
    }
    P[it, ] <- t(cp) %*% P[it - 1, ]
    tprev <- t
  }
  P
}


##' Simulate Comparisons For Use in Sequential Markov Longitudinal Clinical Trial Simulations
##'
##' Simulates sequential clinical trials of longitudinal ordinal outcomes using a first-order Markov model.  Looks are done sequentially after subject ID numbers given in the vector `looks` with the earliest possible look being after subject 2.  At each look, a subject's repeated records are either all used or all ignored depending on the sequent ID number.  For each true effect parameter value, simulation, and at each look, runs a function to compute the estimate of the parameter of interest along with its variance.  For each simulation, data are first simulated for the last look, and these data are sequentially revealed for earlier looks.  The user provides a function `g` that has extra arguments specifying the true effect of `parameter` the treatment `group` expecting treatments to be coded 1 and 2.  `parameter` is usually on the scale of a regression coefficient, e.g., a log odds ratio.  Fitting is done using the `rms::lrm()` function, unless non-proportional odds is allowed in which case `VGAM::vglm()` is used.  If `timecriterion` is specified, the function also, for the last data look only, computes the first time at which the criterion is satisfied for the subject or use the event time and event/censoring indicator computed by `timecriterion`.  The Cox/logrank chi-square statistic for comparing groups on the derived time variable is saved.  If `coxzph=TRUE`, the `survival` package correlation coefficient `rho` from the scaled partial residuals is also saved so that the user can later determine to what extent the Markov model resulted in the proportional hazards assumption being violated when analyzing on the time scale.  `vglm` is accelerated by saving the first successful fit for the largest sample size and using its coefficients as starting value for further `vglm` fits for any sample size for the same setting of `parameter`.
##' @title estSeqMarkovOrd
##' @inheritParams simMarkovOrd
##' @param y vector of possible y values in order (numeric, character, factor)
##' @param times vector of measurement times
##' @param initial a vector of probabilities summing to 1.0 that specifies the frequency distribution of initial values to be sampled from.  The vector must have names that correspond to values of `y` representing non-absorbing states.
##' @param absorb vector of absorbing states, a subset of `y`.  The default is no absorbing states.  Observations are truncated when an absorbing state is simulated.  May be numeric, character, or factor.
##' @param intercepts vector of intercepts in the proportional odds model.  There must be one fewer of these than the length of `y`.
##' @param parameter vector of true parameter (effects; group differences) values.  These are group 2:1 log odds ratios in the transition model, conditioning on the previous `y`.
##' @param looks integer vector of ID numbers at which maximum likelihood estimates and their estimated variances are computed.  For a single look specify a scalar value for `loops` equal to the number of subjects in the sample.
##' @param formula a formula object given to the `lrm()` function using variables with these name: `y`, `time`, `yprev`, and `group` (factor variable having values '1' and '2').  The `yprev` variable is converted to a factor before fitting the model unless `yprevfactor=FALSE`.
##' @param ppo a formula specifying the part of `formula` for which proportional odds is not to be assumed, i.e., that specifies a partial proportional odds model.  Specifying `ppo` triggers the use of `VGAM::vglm()` instead of `rms::lrm` and will make the simulations run slower.
##' @param yprevfactor see `formula`
##' @param groupContrast omit this argument if `group` has only one regression coefficient in `formula`.  Otherwise if `ppo` is omitted, provide `groupContrast` as a list of two lists that are passed to `rms::contrast.rms()` to compute the contrast of interest and its standard error.  The first list corresponds to group 1, the second to group 2, to get a 2:1 contrast.  If `ppo` is given and the group effect is not just a simple regression coefficient, specify as `groupContrast` a function of a `vglm` fit that computes the contrast of interest and its standard error and returns a list with elements named `Contrast` and `SE`.  For the latter type you can optionally have formal arguments `n1`, `n2`, and `parameter` that are passed to `groupContrast` to compute the standard error of the group contrast, where `n1` and `n2` respectively are the sample sizes for the two groups and `parameter` is the true group effect parameter value.
##' @param cscov applies if `ppo` is not used.  Set to `TRUE` to use the cluster sandwich covariance estimator of the variance of the group comparison.
##' @param timecriterion a function of a time-ordered vector of simulated ordinal responses `y` that returns a vector `FALSE` or `TRUE` values denoting whether the current `y` level met the condition of interest.  For example `estSeqMarkovOrd` will compute the first time at which `y >= 5` if you specify `timecriterion=function(y) y >= 5`.  This function is only called at the last data look for each simulated study.  To have more control, instead of `timecriterion` returning a logical vector have it return a numeric 2-vector containing, in order, the event/censoring time and the 1/0 event/censoring indicator.
##' @param sstat set to a function of the time vector and the corresponding vector of ordinal responses for a single group if you want to compute a Wilcoxon test on a derived quantity such as the number of days in a given state.  
##' @param coxzph set to `TRUE` if `timecriterion` is specified and you want to compute a statistic for testing proportional hazards at the last look of each simulated data
##' @param nsim number of simulations (default is 1)
##' @param maxest maximum acceptable absolute value of the contrast estimate, ignored if `NULL`.  Any values exceeding `maxest` will result in the estimate being set to `NA`.
##' @param maxvest like `maxest` but for the estimated variance of the contrast estimate
##' @param progress set to `TRUE` to send current iteration number to `pfile` every 10 iterations.  Each iteration will really involve multiple simulations, if `parameter` has length greater than 1.
##' @param pfile file to which to write progress information.  Defaults to `''` which is the console.  Ignored if `progress=FALSE`.
##' @return a data frame with number of rows equal to the product of `nsim`, the length of `looks`, and the length of `parameter`, with variables `sim`, `parameter`, `look`, `est` (log odds ratio for group), and `vest` (the variance of the latter).  If `timecriterion` is specified the data frame also contains `loghr` (Cox log hazard ratio for group), `lrchisq` (chi-square from Cox test for group), and if `coxph=TRUE`, `phchisq`, the chi-square for testing proportional hazards.  The attribute `etimefreq` is also present if `timecriterion` is present, and it probvides the frequency distribution of derived event times by group and censoring/event indicator.  If `sstat` is given, the attribute `sstat` is also present, and it contains an array with dimensions corresponding to simulations, parameter values within simulations, `id`, and a two-column subarray with columns `group` and `y`, the latter being the summary measure computed by the `sstat` function.  The returned data frame also has attribute `lrmcoef` which are the last-look logistic regression coefficient estimates over the `nsim` simulations and the parameter settings, and an attribute `failures` which is a data frame containing the variables `reason` and `frequency` cataloging the reasons for unsuccessful model fits.
##' @author Frank Harrell
##' @seealso `gbayesSeqSim()`, `simMarkovOrd()`, <https://hbiostat.org/R/Hmisc/markov/>
##' @export
##' @md

estSeqMarkovOrd <- function(y, times, initial, absorb=NULL, intercepts,
                            parameter, looks, g, formula, ppo=NULL,
                            yprevfactor=TRUE,
                            groupContrast=NULL, cscov=FALSE,
                            timecriterion=NULL, coxzph=FALSE,
                            sstat=NULL, rdsample=NULL,
                            maxest=NULL, maxvest=NULL,
                            nsim=1, progress=FALSE, pfile='') {

  olddd <- getOption('datadist')
  on.exit(options(datadist=olddd))

  isppo <- length(ppo) > 0
  if(isppo) {
    if(! inherits(ppo, 'formula')) stop('ppo must be a formula')
    if(! requireNamespace('VGAM'))
      stop('ppo specified and VGAM package not available')
    # VGAM wants you to declare FALSE to indicate non-PO
    vglm <- VGAM::vglm
    ppo  <- formula(paste('FALSE ~', as.character(ppo)[-1]))
  } else if (!requireNamespace("rms", quietly = TRUE))
    stop('ppo not specified and rms package not available')
  

  if(isppo && cscov) stop('may not specify cscov=TRUE with ppo')
  
  nas <- setdiff(y, absorb)    # non-absorbing states
  if(length(initial) != length(nas))
    stop('length of initial must be number of non-absorbing values of y')
  if(! all(sort(names(initial)) == sort(as.character(nas))))
    stop('names of elements in initial are incorrect')
  if(coxzph && ! length(timecriterion))
    stop('must specify timecriterion when coxzph=TRUE')
  
  looks   <- sort(looks)
  nlook   <- length(looks)
  N       <- max(looks)
  np      <- length(parameter)
  nc      <- nsim * nlook * np
  parm    <- est <- vest <- numeric(nc)
  look    <- sim <- integer(nc)
  ndy     <- length(y)
  
  Etimefreq <- NULL
  if(length(timecriterion)) {
    Etimefreq <-
      array(0, dim=c(nsim, np, 2, 2, length(times)),
            dimnames=list(paste('sim', 1 : nsim),
                          as.character(parameter),
                          c('1', '2'),
                          c('censored', 'event'),
                          as.character(times)))
    loghr <-   lrchisq <- rep(NA, nc) 
    if(coxzph) phchisq <- rep(NA, nc)
  }
  if(length(sstat))
    Sstat <- array(0L, dim=c(nsim, np, N, 2),
                   dimnames=list(paste('sim', 1 : nsim),
                                 as.character(parameter),
                                 paste('id', 1 : N),
                                 c('group', 'y')))

  groupContrastUsesN <-
    length(groupContrast) &&
       all(c('n1', 'n2', 'parameter') %in% names(formals(groupContrast)))

  ## For each simulation and each parameter value, simulate data for the
  ## whole study

  is    <- 0
  pname <- if(isppo) 'group2' else 'group=2'
  h <- function(time, y) {
    u <- timecriterion(y)
    if(! is.logical(u))
      return(list(etime=as.numeric(u[1]), event=as.integer(u[2])))
    # Note that if there are any absorbing events, the time vector
    # would already have been truncated at the first of such events
    if(any(u)) list(etime=as.numeric(min(time[u])), event=1L)
    else
               list(etime=as.numeric(max(time)),   event=0L)
  }

  lrmcoef  <- NULL
  co.na    <- NULL   # template of coef vector to be all NAs
  coefprev <- list() # to hold first working fit at last look for each parameter
  ## coefprev speeds up vglm (last look = maximum sample size)
  failures <- character(0)
  
  for(isim in 1 : nsim) {
    if(progress && (isim %% 10 == 0))
      cat('Simulation', isim, '\n', file=pfile)
    for(param in parameter) {
      cparam <- as.character(param)
      ## Sample N initial states
      initials <- sample(names(initial), N, replace=TRUE, prob=initial)
      if(is.numeric(y)) initials <- as.numeric(initials)
      ## Sample treatment groups 1 and 2
      X   <- matrix(sample(1 : 2, N, replace=TRUE), ncol=1,
                    dimnames=list(NULL, 'group'))
      ## For simMarkovOrd X must be a matrix if it varies
      sdata <- simMarkovOrd(n=N, y, times, initials, X=X, absorb=absorb,
                            intercepts=intercepts, g=g, parameter=param,
                            rdsample=rdsample)
      
      tsps <- attr(sdata, 'time.saved.per.subject')
      if(length(tsps))
        cat('Average number of measurement times saved per subject by response-dependent sampling:', round(tsps, 1), '\n')
      ## sdata is a data frame containing id, time, yprev, y, ...
      sdata$group <- as.factor(sdata$group)
      if(yprevfactor) sdata$yprev <- as.factor(sdata$yprev)
      if(isim == 1 && ! isppo) {
        .dd. <- rms::datadist(sdata)
        options(datadist=.dd.)   # requires rms 6.1-1
      }
      
      ## For each look compute the parameter estimate and its variance
      ## If a contrast is specified (say when treatment interacts with time)
      ## use that instead of a simple treatment effect
      ## For vglm speed up by taking as starting values the estimates
      ## from the last successful run

      for(l in looks) {
        ## Subjects are numbered consecutively with id=1,2,3,... and
        ## these correspond to sequential data looks when accumulated
        dat <- subset(sdata, id <= l)
        luy <- length(unique(dat$y))
        if(luy != ndy) {
          f <- paste('Simulated data for simulation with sample size', l,
                     'has', luy, 'distinct y values instead of the required',
                     ndy)
          fail <- TRUE
          } else {
            if(isppo) {
              cprev <- coefprev[[cparam]]
              ## Could not get system to find cprev when regular call inside try()
              ff <- call('vglm', formula,
                         VGAM::cumulative(parallel=ppo, reverse=TRUE),
                         coefstart=cprev, data=dat)
              f <- try(eval(ff), silent=TRUE)
            } else
              f <- try(rms::lrm(formula, data=dat, x=cscov, y=cscov), silent=TRUE)
            fail <- inherits(f, 'try-error')
          }
        
        if(fail) failures <- c(failures, as.character(f))
        else {
          if(isppo && l == max(looks) && ! length(coefprev[[cparam]]))
            coefprev[[cparam]] <- coef(f) 
          if(! length(co.na)) {   # save template to insert for failures
            co.na <- coef(f)
            co.na[] <- NA
          }
        }
        if(cscov && ! fail) f <- rms::robcov(f, dat$id)
        is         <- is + 1
        sim [is]   <- isim
        parm[is]   <- param
        look[is]   <- l
        if(fail) {
          est [is] <- NA
          vest[is] <- NA
        } else {
          if(length(groupContrast)) {
            fc <- if(isppo) (if(groupContrastUsesN)
                               groupContrast(f, n1=sum(dat$group == '1'),
                                                n2=sum(dat$group == '2'),
                                                parameter=param)
                               else
                                 groupContrast(f))
                  else
                    rms::contrast(f, groupContrast[[2]], groupContrast[[1]])
            est [is] <- fc$Contrast
            vest[is] <- (fc$SE) ^ 2
          }
          else {
            est [is]   <- coef(f)[pname]
            vest[is]   <- vcov(f)[pname, pname]
          }
          if(length(maxest) && abs(est[is]) > maxest) {
            failures <- c(failures, paste0('|contrast|>', maxest))
            est[is] <- vest[is] <- NA
            fail <- TRUE
          } else if(length(maxvest) && vest[is] > maxvest) {
            failures <- c(failures, paste0('variance>', maxvest))
            est[is] <- vest[is] <- NA
            fail <- TRUE
          }
        }    # end else if not fail
      }  # end looks
      co <- if(fail) co.na else coef(f)
      if(! length(lrmcoef))
        lrmcoef <- array(0., dim=c(length(parameter), nsim, length(co)),
                         dimnames=list(as.character(parameter),
                                       paste('sim', 1 : nsim),
                                       names(co)))

      ww <- try(lrmcoef[as.character(param), isim, ] <- co)
      if(inherits(ww, 'try-error')) {
        wf <- 'estSeqMarkovOrd.err'
        prn(dimnames(lrmcoef), file=wf)
        prn(as.character(param), file=wf)
        prn(isim, file=wf)
        prn(co, file=wf)
        stop('non-conformable coefficients in estSeqMarkovOrd.  See file estSeqMarkovOrd.err in current working directory.')
        }
      
      if(length(timecriterion)) {
        # Separately for each subject compute the time until the
        # criterion is satisfied.  Right censor at last observed time if it
        # doesn't occur
        setDT(sdata, key=c('group', 'id', 'time'))
        d <- sdata[, h(time, y), by=.(group, id)]
        
        fit <- survival::coxph(Surv(etime, event) ~ group, data=d)
        loghr  [is] <- fit$coef
        lrchisq[is] <- 2. * diff(fit$loglik)
        if(coxzph)
          phchisq[is] <- survival::cox.zph(fit, transform='identity',
                                           global=FALSE)$table[, 'chisq']

        for(gr in c('1', '2')) {
          for(ev in 0 : 1) {
            utimes <- with(subset(d, group == gr & event == ev),
                           as.character(etime))
            utimes <- factor(utimes, as.character(times))
            tab    <- table(utimes)
            Etimefreq[isim, as.character(param), gr, ev + 1, ] <-
              Etimefreq[isim, as.character(param), gr, ev + 1, ] + tab
          } # end censored vs event
        } # end group
      } # end timecriterion
      if(length(sstat)) {
        ## Separately for each subject compute the summary statistic
        sds <- sdata[, ys := sstat(time, y), by=.(group, id)]
        Sstat[isim, as.character(param), sds$id, ] <-
          cbind(sds$group, sds$ys)
      }  # end sstat
    }  # end param
  } # end sim
  
  res <- data.frame(sim=sim, parameter=parm, look=look,
                    est=est, vest=vest)
  if(length(timecriterion)) {
    res$loghr   <- loghr
    res$lrchisq <- lrchisq
    if(coxzph) res$phchisq <- phchisq
    attr(res, 'etimefreq') <- Etimefreq
  }
  if(length(sstat)) attr(res, 'sstat') <- Sstat
  attr(res, 'lrmcoef') <- lrmcoef
  failures <- if(length(failures))
                as.data.frame(table(failure=failures))
              else
                data.frame(failure='', Freq=0)
  attr(res, 'failures') <- failures
  res
}

#' Compute Parameters for Proportional Odds Markov Model
#'
#' Given a vector `intercepts` of initial guesses at the intercepts in a Markov proportional odds model, and a vector `extra` if there are other parameters, solves for the `intercepts` and `extra` vectors that yields a set of occupancy probabilities at time `t` that equal, as closely as possible, a vector of target values.
#' @title intMarkovOrd
#' @inheritParams simMarkovOrd
#' @param intercepts vector of initial guesses for the intercepts
#' @param extra an optional vector of intial guesses for other parameters passed to `g` such as regression coefficients for previous states and for general time trends.  Name the elements of `extra` for more informative output.
#' @param target vector of target state occupancy probabilities at time `t`.  If `extra` is specified, `target` must be a matrix where row names are character versions of `t` and columns represent occupancy probabilities corresponding to values of `y` at the time given in the row.
#' @param t target times.  Can have more than one element only if `extra` is given.
#' @param ftarget an optional function defining constraints that relate to transition probabilities.  The function returns a penalty which is a sum of absolute differences in probabilities from target probabilities over possibly multiple targets.  The `ftarget` function must have two arguments: `intercepts` and `extra`.
#' @param onlycrit set to `TRUE` to only return the achieved objective criterion and not print anything
#' @param constraints a function of two arguments: the vector of current intercept values and the vector of `extra` parameters, returning `TRUE` if that vector meets the constrains and `FALSE` otherwise
#' @param printsop set to `TRUE` to print solved-for state occupancy probabilities for groups 1 and 2 and log odds ratios corresponding to them
#' @param ... optional arguments to pass to [stats::nlm()].  If this is specified, the arguments that `intMarkovOrd` normally sends to `nlm` are not used.
#'
#' @return list containing two vectors named `intercepts` and `extra` unless `oncrit=TRUE` in which case the best achieved sum of absolute errors is returned
#' @author Frank Harrell
#' @export
#' @md
#' @seealso <https://hbiostat.org/R/Hmisc/markov/>
intMarkovOrd <- function(y, times, initial, absorb=NULL,
                         intercepts, extra=NULL, g, target, t, ftarget=NULL,
                         onlycrit=FALSE, constraints=NULL,
                         printsop=FALSE, ...) {

  if(any(diff(intercepts) > 0)) stop('initial intercepts are out of order')
  
  t <- as.character(t)
  if(length(t) > 1 && (! is.matrix(target) || nrow(target) != length(t)))
    stop('target must be a matrix with # rows = length of t')
  if(length(t) == 1) target <- matrix(target, nrow=1, dimnames=list(t, NULL))
  for(ti in t)
    if(abs(sum(target[ti, ]) - 1.) > 1e-5)
      stop('each row of target must sum to 1')
  
  h <- function(a) {
    ## Compute state occupancy probabilities at time t for current
    ## vector of intercept values and extra
    ints <- a[1 : (length(a) - length(extra))]
    if(any(diff(ints) > 0.)) return(1000.)
    if(length(extra)) extra <- a[-(1 : length(ints))]
    if(length(constraints) && ! constraints(ints, extra)) return(1000.)
    s <- soprobMarkovOrd(y, times, initial=initial, absorb=absorb,
                         intercepts=ints, g=g, X=1, extra=extra)[t,, drop=FALSE ]
    # Objective function to minimize: sum of absolute differences with targets
    # with restriction that intercepts be in descending order
    crit <- 0.  # if(any(diff(ints) > 0.)) 1000. else 0.
    for(tim in rownames(s)) crit <- crit + sum(abs(s[tim, ] - target[tim, ]))
    if(length(ftarget)) crit <- crit + ftarget(intercepts=ints, extra=extra)
    crit
  }

  if(length(list(...)))
    u <- nlm(h, c(intercepts, extra), ...)
  else
    u <- nlm(h, c(intercepts, extra), iterlim=300)

  if(onlycrit) return(u$minimum)
  
  cat('\nIterations:', u$iterations, '\n')
  cat('Sum of absolute errors:', u$minimum, '\n')
  ints <- u$estimate[1 : (length(u$estimate) - length(extra))]
  if(length(extra)) extra <- structure(u$estimate[-(1 : length(ints))],
                                       names=names(extra))
  
  cat('Intercepts:', round(ints, 3), '\n')
  if(length(extra)) {
    cat('\nExtra parameters:\n\n')
    print(round(extra, 4))
    }
  s1 <- soprobMarkovOrd(y, times, initial=initial, absorb=absorb,
                        intercepts=ints, g=g, X=1, extra=extra)
  if(printsop) {
    cat('\nOccupancy probabilities for group 1:\n\n')
    print(round(s1, 3))
    }
  # Show occupancy probabilities for group 2
  s2 <- soprobMarkovOrd(y, times, initial=initial, absorb=absorb,
                        intercepts=ints, g=g, X=2, extra=extra)
  if(printsop) {
    cat('\nOccupancy probabilities for group 2:\n\n')
    print(round(s2, 3))
    }

  ## Compute log odds ratios at day t

  if(printsop) for(ti in t) {
    ## Get cumulative probabilities from right to left except for the first    
    s1t <- rev(cumsum(rev(s1[ti, -1])))
    s2t <- rev(cumsum(rev(s2[ti, -1])))
    lor <- round(qlogis(s2t) - qlogis(s1t), 3)
    cat('\nLog odds ratios at', paste0('t=', ti),
        'from occupancy probabilities:' , lor, '\n')
    }
  list(intercepts=ints, extra=extra)
}


#' State Occupancy Probabilities for First-Order Markov Ordinal Model from a Model Fit
#'
#' Computes state occupancy probabilities for a single setting of baseline covariates.  If the model fit was from `rms::blrm()`, these probabilities are from all the posterior draws of the basic model parameters.  Otherwise they are maximum likelihood point estimates.
#'
#' @title soprobMarkovOrdm
#' @param object a fit object created by `blrm`, `lrm`, `orm`, `VGAM::vglm()`, or `VGAM::vgam()`
#' @param data a single observation list or data frame with covariate settings, including the initial state for Y
#' @param times vector of measurement times
#' @param ylevels a vector of ordered levels of the outcome variable (numeric or character)
#' @param absorb vector of absorbing states, a subset of `ylevels`.  The default is no absorbing states. (numeric, character, factor)
#' @param tvarname name of time variable, defaulting to `time`
#' @param pvarname name of previous state variable, defaulting to `yprev`
#' @param gap name of time gap variable, defaults assuming that gap time is not in the model
#'
#' @return if `object` was not a Bayesian model, a matrix with rows corresponding to times and columns corresponding to states, with values equal to exact state occupancy probabilities.  If `object` was created by `blrm`, the result is a 3-dimensional array with the posterior draws as the first dimension.
#' @export
#' @author Frank Harrell
#' @seealso <https://hbiostat.org/R/Hmisc/markov/>
#' @md
soprobMarkovOrdm <- function(object, data, times, ylevels, absorb=NULL,
                             tvarname='time', pvarname='yprev',
                             gap=NULL) {

  cl <- class(object)[1]
  ftypes <- c(lrm='rms', orm='rms', blrm='rmsb', vglm='vgam', vgam='vgam')
  ftype  <- ftypes[cl]
  if(is.na(ftype)) stop(paste('object must be a fit from one of:',
                              paste(ftypes, collapse=' ')))

  ## For VGAM objects, predict() did not find the right function when
  ## inside the rms package
  
  prd <-
    switch(ftype,
           rms =function(obj, data) predict(obj, data, type='fitted.ind'),
           vgam=function(obj, data) VGAM::predict(obj, data, type='response'),
           rmsb=function(obj, data) predict(obj, data, type='fitted.ind',
                                            posterior.summary='all'))
  
  if(pvarname %nin% names(data))
    stop(paste(pvarname, 'is not in data'))
  if(length(absorb) && (pvarname %in% absorb))
    stop('initial state cannot be an absorbing state')
  
  nd <- if(ftype == 'rmsb' && length(object$draws)) nrow(object$draws) else 0
  if((nd == 0) != (ftype != 'rmsb'))
    stop('model fit inconsistent with having posterior draws')
  
  k  <- length(ylevels)
  s  <- length(times)
  P  <- if(nd == 0)
          array(NA, c(s, k),
  						dimnames=list(as.character(times), 
  													as.character(ylevels))) else
          array(NA, c(nd, s, k),
  						dimnames=list(paste('draw', 1 : nd), as.character(times), 
  													as.character(ylevels)))
  # Never uncondition on initial state
  data[[tvarname]] <- times[1]
  if(length(gap)) data[[gap]] <- times[1]
  data <- as.data.frame(data)
  p <- prd(object, data)
  if(nd == 0) P[1, ] <- p else P[, 1, ] <- p

  # cp: matrix of conditional probabilities of Y conditioning on previous time Y
  # Columns = k conditional probabilities conditional on a single previous state
  # Rows    = all possible previous states
  # This is for a single posterior draw (or for a frequentist fit)
  rnameprev   <- paste('t-1', ylevels)
  rnameprevna <- paste('t-1', setdiff(ylevels, absorb))
  if(length(absorb)) {
    rnamepreva <- paste('t-1', absorb)
    cnamea     <- paste('t',   absorb)
    }
  cp <- matrix(0., nrow=k, ncol=k, 
               dimnames=list(rnameprev, paste('t', ylevels)))
  ## cp is initialized to zero, which will remain the values for
  ## probabilities of moving out of absorbing (row) states
  ## Set probabilities of staying in absorbing states to 1
  if(length(absorb)) cp[cbind(rnamepreva, cnamea)] <- 1.
  
  data <- as.list(data)
  yna  <- setdiff(ylevels, absorb)  # non-absorbing states
  data[[pvarname]] <- yna   # don't request estimates for absorbing states
  edata <- expand.grid(data)
  for(it in 2 : s) {
    edata[[tvarname]] <- times[it]
    if(length(gap)) edata[[gap]] <- times[it] - times[it - 1]
    pp <- prd(object, edata)
    if(nd == 0) {
      ## If there are absorbing states, make a bigger version of
      ## the cell probability matrix that includes them
      ## Rows representing absorbing states have P(stating in that state)=1
      cp[rnameprevna, ] <- pp
      
      ## Compute unconditional probabilities of being in all possible states
      ## at current time t
      P[it, ] <- t(cp) %*% P[it - 1, ]
    }
    else {
      for(idraw in 1 : nd) {
        cp[rnameprevna, ] <- pp[idraw, ,]
        P[idraw, it, ] <- t(cp) %*% P[idraw, it - 1, ]
      }
    }
  }
  P
}

utils::globalVariables(c('id', 'group', 'event', ':=', 'ys'))

#' plotly Multiple
#'
#' Generates multiple plotly graphics, driven by specs in a data frame
#'
#' Generates multiple \code{plotly} traces and combines them with \code{plotly::subplot}.  The traces are controlled by specifications in data frame \code{data} plus various arguments.  \code{data} must contain these variables: \code{x}, \code{y}, and \code{tracename} (if \code{color} is not an "AsIs" color such as \code{~ I('black')}), and can contain these optional variables: \code{xhi}, \code{yhi} (rows containing \code{NA} for both \code{xhi} and \code{yhi} represent points, and those with non-\code{NA} \code{xhi} or \code{yhi} represent segments, \code{connect} (set to \code{TRUE} for rows for points, to connect the symbols), \code{legendgroup} (see \code{plotly} documentation), and \code{htext} (hovertext).  If the \code{color} argument is given and it is not an "AsIs" color, the variable named in the \code{color} formula must also be in \code{data}.  Likewise for \code{size}.  If the \code{multplot} is given, the variable given in the formula must be in \code{data}.  If \code{strata} is present, another level of separate plots is generated by levels of \code{strata}, within levels of \code{multplot}.
#'
#' If \code{fitter} is specified, x,y coordinates for an individual plot are
#' run through \code{fitter}, and a line plot is made instead of showing data points.  Alternatively you can specify \code{fitter='ecdf'} to compute and plot emirical cumulative distribution functions.
#'
#' @param data input data frame
#' @param x formula specifying the x-axis variable
#' @param y formula for y-axis variable
#' @param xhi formula for upper x variable limits (\code{x} taken to be lower value)
#' @param yhi formula for upper y variable limit (\code{y} taken to be lower value)
#' @param htext formula for hovertext variable
#' @param multplot formula specifying a variable in \code{data} that when stratified on produces a separate plot
#' @param strata formula specifying an optional stratification variable
#' @param fitter a fitting such as \code{loess} that comes with a \code{predict} method.  Alternatively specify \code{fitter='ecdf'} to use an internal function for computing and displaying ECDFs, which moves the analysis variable from the y-axis to the x-axis
#' @param color \code{plotly} formula specifying a color variable or e.g. \code{~ I('black')}.  To keep colors constant over multiple plots you will need to specify an AsIs color when you don't have a variable representing color groups.
#' @param size \code{plotly} formula specifying a symbol size variable or AsIs
#' @param showpts if \code{fitter} is given, set to \code{TRUE} to show raw data points in addition to smooth fits
#' @param rotate set to \code{TRUE} to reverse the roles of \code{x} and \code{y}, for example to get horizontal dot charts with error bars
#' @param xlab x-axis label.  May contain html.
#' @param ylab a named vector of y-axis labels, possibly containing html (see example below).  The names of the vector must correspond to levels of the \code{multplot} variable.  \code{ylab} can be unnamed if \code{multplot} is not used.
#' @param ylabpos position of y-axis labels.  Default is on top left of plot.  Specify \code{ylabpos='y'} for usual y-axis placement.
#' @param xlim 2-vector of x-axis limits, optional
#' @param ylim 2-vector of y-axis limits, optional
#' @param shareX specifies whether x-axes should be shared when they align vertically over multiple plots
#' @param shareY specifies whether y-axes should be shared when they align horizontally over multiple plots
#' @param nrows the number of rows to produce using \code{subplot}
#' @param ncols the number of columns to produce using \code{subplot} (specify at most one of \code{nrows,ncols})
#' @param height height of the combined image in pixels
#' @param width width of the combined image in pixels
#' @param colors the color palette.  Leave unspecified to use the default \code{plotly} palette
#' @param alphaSegments alpha transparency for line segments (when \code{xhi} or \code{yhi} is not \code{NA})
#' @param alphaCline alpha transparency for lines used to connect points
#' @param digits number of significant digits to use in constructing hovertext
#' @param zeroline set to \code{FALSE} to suppress vertical line at x=0
#'
#' @return \code{plotly} object produced by \code{subplot}
#' @author Frank Harrell
#' @examples
#' \dontrun{
#' set.seed(1)
#' pts     <- expand.grid(v=c('y1', 'y2', 'y3'), x=1:4, g=c('a', 'b'), yhi=NA,
#'                        tracename='mean', legendgroup='mean',
#'                        connect=TRUE, size=4)
#'
#' pts$y   <- round(runif(nrow(pts)), 2)
#'
#' segs     <- expand.grid(v=c('y1', 'y2', 'y3'), x=1:4, g=c('a', 'b'),
#'                         tracename='limits', legendgroup='limits',
#'                         connect=NA, size=6)
#' segs$y   <- runif(nrow(pts))
#' segs$yhi <- segs$y + runif(nrow(pts), .05, .15)
#'
#' z <- rbind(pts, segs)
#'
#' xlab <- labelPlotmath('X<sub>12</sub>', 'm/sec<sup>2</sup>', html=TRUE)
#' ylab <- c(y1=labelPlotmath('Y1', 'cm', html=TRUE),
#'           y2='Y2',
#'           y3=labelPlotmath('Y3', 'mm', html=TRUE))
#'
#' W=plotlyM(z, multplot=~v, color=~g, xlab=xlab, ylab=ylab, ncols=2,
#'           colors=c('black', 'blue'))
#'
#' W2=plotlyM(z, multplot=~v, color=~I('black'), xlab=xlab, ylab=ylab,
#'            colors=c('black', 'blue'))
#' 
#' }
#' @export
plotlyM <- function(data, x=~x, y=~y, xhi=~xhi, yhi=~yhi, htext=NULL,
                    multplot=NULL, strata=NULL, fitter=NULL,
                    color=NULL, size=NULL,
                    showpts=! length(fitter),
                    rotate=FALSE, xlab=NULL, ylab=NULL,
                    ylabpos=c('top', 'y'),
                    xlim=NULL, ylim=NULL,
                    shareX=TRUE, shareY=FALSE, height=NULL, width=NULL,
                    nrows=NULL, ncols=NULL,
                    colors=NULL, alphaSegments=1, alphaCline=0.3, digits=4,
                    zeroline=TRUE) {
  
  if (!requireNamespace("plotly"))
    stop("This function requires the 'plotly' package.")
  auto <- .Options$plotlyauto
  if(length(auto) && auto) height <- width <- NULL
  
  ylabpos <- match.arg(ylabpos)

  if(rotate) {
    xf  <- y   #~ y
    yf  <- x   #~ x
    xfe <- yhi #~ yhi
    yfe <- xhi #~ xhi
    
  } else {
    xf  <- x    #~ x
    yf  <- y    #~ y
    xfe <- xhi  #~ xhi
    yfe <- yhi  #~ yhi
  }

  xn   <- all.vars(xf) #x)
  yn   <- all.vars(yf) #y)
  xhin <- all.vars(xfe) #xhi)
  yhin <- all.vars(yfe) #yhi)

  n <- nrow(data)
  if(! length(multplot)) {
    multplot <- ~ .v.
    data$.v. <- rep(' ', n)
  } else data$.v. <- data[[all.vars(multplot)]]

  vlevs  <- levels(as.factor(data$.v.))
  lastv  <- vlevs[length(vlevs)]

  strpres <- length(strata) > 0
  strata <- if(strpres) as.factor(data[[all.vars(strata)]])
            else
              as.factor(rep('', nrow(data)))
  stlevs <- levels(strata)
  lasts  <- stlevs[length(stlevs)]
  if(! length(nrows) && ! length(ncols) && strpres)
    ncols <- length(stlevs)

  if(length(ylab) && ! length(names(ylab))) names(ylab) <- vlevs
  if(! length(ylab)) ylab <- structure(vlevs, names=vlevs)

  fmt <- function(x) htmlSN(x, digits=digits)

  nam <- names(data)
  if(xhin  %nin% nam)         data[[xhin]]     <- rep(NA, n)
  if(yhin  %nin% nam)         data[[yhin]]     <- rep(NA, n)
  if('connect' %nin% nam)     data$connect     <- rep(FALSE, n)
  if('tracename' %in% nam && 'legendgroup' %nin% nam)
    data$legendgroup <- data$tracename

  if(length(color)) {
    ## ~ I('black') will not show inherits('AsIs') but all.vars is char(0)
    colasis         <- ! length(all.vars(color))
    traceform       <- if(colasis) ~ tracename
    legendgroupform <- if(colasis) ~ legendgroup
    colvar          <- if(! colasis) all.vars(color)
  }
  else if(length(size)) {
    sizeasis        <- ! length(all.vars(color))
    traceform       <- if(sizeasis) ~ tracename
    legendgroupform <- if(sizeasis) ~ legendgroup
    sizevar         <- if(! sizeasis) all.vars(size)
    }
  else {
    traceform       <- if('tracename'   %in% nam) ~ tracename
    legendgroupform <- if('legendgroup' %in% nam) ~ legendgroup
    colasis         <- FALSE
    colvar          <- NULL
    sizeasis        <- FALSE
    sizevar         <- NULL
    }
  
  if(length(color)) legendgroupform <- color

  usualfitter <- length(fitter) && is.function(fitter)
  is.ecdf     <- length(fitter) && is.character(fitter) && fitter == 'ecdf'
  xpresent    <- ! is.ecdf
  
  runfit <- if(usualfitter) function() {
    xv <- all.vars(xf)
    yv <- all.vars(yf)
    x  <- pt[[xv]]
    y  <- pt[[yv]]
    g  <- if(length(colvar))
            pt[[colvar]] else rep('', nrow(pt))
    g  <- as.factor(g)
    d  <- data.frame(x, y, g)
    Dp <- NULL
    xgrid <- seq(min(x, na.rm=TRUE), max(x, na.rm=TRUE), length=150)
    dx <- data.frame(x = xgrid)
    for(gv in levels(g)) {
      f  <- fitter(y ~ x, data=subset(d, g == gv))
      y  <- predict(f, newdata=dx)
      dp <- cbind(dx, y, g=gv)
      Dp <- rbind(Dp, dp)
    }
    names(Dp) <- c(xv, yv, if(length(colvar)) colvar else 'g')
    Dp
  }
  else
    if(is.ecdf) function() {
      yv <- all.vars(xf)
      y  <- pt[[yv]]
      g  <- if(length(colvar))
              pt[[colvar]] else rep('', nrow(pt))
      g  <- as.factor(g)
      Dp <- NULL
      rng <- range(y, na.rm=TRUE)
      for(gv in levels(g)) {
        j    <- g == gv & ! is.na(y)
        yg   <- sort(y[j])
        n    <- length(yg)
        vals <- unique(yg)   # see stats::ecdf
        a <- approx(vals, cumsum(tabulate(match(yg, vals))) / n,
                    method='constant', yleft=0, yright=1, f=0,
                    ties='ordered', xout=vals)
        delta <- diff(rng) * 0.025
        a$x   <- c(min(a$x) - delta, a$x, max(a$x) + delta)
        a$y   <- c(0, a$y, 1)
        dp <- data.frame(x = a$x, y = a$y, g=gv)
        Dp <- rbind(Dp, dp)
      }
      names(Dp) <- c(yv, 'ecdf', if(length(colvar)) colvar else 'g')
      Dp
    }

  xlabc <- if(length(xlab)) paste0(xlab, ': ')
  llab <- ifelse('tracename' %in% nam,
                 as.character(data$tracename), 'Limits')
  wl <- function(n, hin)
    paste0(xlabc, fmt(data[[hin]]),
           '<br>', llab, ':[',
           fmt(data[[n]]), ', ',
           fmt(data[[hin]]), ']')
  
    if(! length(htext)) { 
      nhi <- is.na(data[[xhin]]) + is.na(data[[yhin]])
      whi <- ifelse(nhi == 2, 'xy',       ## which vars missing hi?
                    ifelse(nhi == 0, '',
                           ifelse(is.na(data[[xhin]]), 'x', 'y')))
    data$htxt <- ifelse(whi == 'xy',
                        paste0(xlabc, fmt(data[[xn]]),
                               '<br>',
                               ylab[data$.v.], ':', fmt(data[[yn]])),
                 ifelse(whi == 'x', wl(yn, yhin),
                 ifelse(whi == 'y', wl(xn, xhin),
                        paste0(xlabc, fmt(data[[xn]]),
                               '<br>', xn, ' ', llab, ': [',
                               fmt(data[[xn]]), ', ', fmt(data[[xhin]]), ']',
                               '<br>', yn, ' ', llab, ': [',
                               fmt(data[[yn]]), ', ', fmt(data[[yhin]]), ']'))))
    htext <- ~ htxt
    }
  p <- plotly::plot_ly(height=height, width=width, colors=colors)
  ## For some reason colors doesn't always take in add_*
  P <- list()
  iv <- 0
#  axislab <- character(0)
#  axn1 <- if(rotate) 'yaxis' else 'xaxis'
#  axn2 <- if(rotate) 'xaxis' else 'yaxis'

  for(vn in vlevs) {
    for(sn in stlevs) {
      iv <- iv + 1
      whichaxis <- if(iv == 1) '' else iv
      if(is.ecdf) {
        ax1 <- ylab[vn]
        ax2 <- 'Cumulative Probability'
        xn  <- yn
        xf  <- yf
        yf  <- ~ ecdf
      } else {
        ax1 <- if(rotate) ylab[vn] else xlab
        ax2 <- if(rotate) xlab else ylab[vn]
      }

      w  <- subset(data, .v. == vn & strata == sn)
      wxn <- w[[xn]]  # if(xpresent) w[[xn]] else 1 : nrow(w)
      j <- if(length(colvar)) order(w[[colvar]], wxn)
           else
             if(length(sizevar)) order(w[[sizevar]], wxn)
           else order(wxn)
      w <- w[j, ]
      r <- p
      ipt <- is.na(w[[yhin]]) & is.na(w[[xhin]])
      pt  <- w[ipt, ]
      conct <- is.logical(pt$connect) && pt$connect[1]
      if(nrow(pt)) {
        if(length(fitter)) {
          Dp <- runfit()
          r <- plotly::add_lines(r, data=Dp, x=xf, y=yf,
                                 name=traceform, legendgroup=legendgroupform,
                                 showlegend=vn==lastv & sn==lasts,
                                 color=color, size=size,
                                 colors=colors,
                                 line=if(is.ecdf) list(shape='hv'))
        }
        if(showpts) {
          r <- plotly::add_markers(r, data=pt, x=xf, y=yf,
                                   name=traceform, legendgroup=legendgroupform,
                                   showlegend=vn==lastv & sn==lasts,
                                   color=color, size=size,
                                   text=htext, hoverinfo='text', colors=colors)
          if(conct)
            r <- plotly::add_lines(r, data=pt, x=xf, y=yf,
                                   name=traceform, legendgroup=legendgroupform,
                                   showlegend=FALSE, color=color,
                                   size=I(1),
                                   hoverinfo='none', colors=colors, alpha=alphaCline)
        }
      }
      
      s <- w[! ipt, ]
        
      if(nrow(s)) {
        ## If only one of xhi and yhi is missing, need to copy non-NA
        ## value from x/y.  Must go to extra trouble to preserve factors
        m <- is.na(s[[xhin]])
        if(any(m)) {
          a <- s[[xn]]
          a[! m] <- s[! m, xhin]
          s[[xhin]] <- a
        }
        m <- is.na(s[[yhin]])
        if(any(m)) {
          a <- s[[yn]]
          a[! m] <- s[! m, yhin]
          s[[yhin]] <- a
          }

        r <-
          plotly::add_segments(r, data=s, x=xf, y=yf, xend=xfe, yend=yfe,
                               name=traceform, legendgroup=legendgroupform,
                               showlegend=vn==lastv & sn==lasts,
                               color=color, size=size,
                               colors=colors, alpha=alphaSegments,
                               text=htext, hoverinfo='text')
        }
      ## rdocumentation.org/packages/plotly/versions/4.7.1/topics/add_annotations
      ## https://plot.ly/r/text-and-annotations/
			## plot.ly/r/text-and-annotations/#set-annotation-coordinate-references      
      firstst <- length(stlevs) > 1 && vn == vlevs[1]
      if(firstst || ylabpos == 'top') {
        lab <- ax2
        if(firstst) lab <- paste0(lab, '<br>', sn)
        r <- plotly::add_annotations(r,  x=0, y=1,
                                     xref='paper', xanchor='left',
                                     yref='paper', yanchor='bottom',
                                     text=paste0('<b>', lab, '</b>'),
                                     showarrow=FALSE,
                                     font=list(color='rgba(25, 25, 112, 1.0)',
                                               size=14))
        ## midnight blue
        }
      r <- plotly::layout(r, xaxis=list(title=ax1, range=xlim,
                                        zeroline=zeroline),
                          yaxis=list(title=if(ylabpos == 'y') ax2 else '',
                                     range=ylim))
      P[[iv]] <- r
    }
  }
  if(length(ncols)) nrows <- ceil(iv / ncols)
  if(length(stlevs) > 1) shareY <- TRUE
  if(length(P) == 1) P <- P[[1]]
  else {
    P <- if(length(nrows))
           plotly::subplot(P, shareX=shareX, shareY=shareY,
                           titleX=TRUE, titleY=TRUE, nrows=nrows)
         else
           plotly::subplot(P, shareX=shareX, shareY=shareY,
                           titleX=TRUE, titleY=TRUE)
    }
  P
}
utils::globalVariables('.v.')

C Output from Public domain Ratfor, version 1.01
      subroutine cidxcp(x1,x2,y,e,n,method,outx, nrel,nuncer,c1,c2,gamma
     *1,gamma2,gamma,sd,c12,c21)
      implicit double precision (a-h,o-z)
      double precision x1(n),x2(n),y(n)
      logical e(n),outx
      integer n,method,i,j
      double precision nrel,nuncer,nconc1,nconc2,c1,c2,gamma1,gamma2, su
     *mr,sumr2,sumw,sumw2,sumrw, wi,ri,sumc,c12,c21,gamma,sd
      double precision dx,dx2,dy
      nconc1=0d0
      nconc2=0d0
      nrel=0d0
      nuncer=0d0
      sumr=0d0
      sumr2=0d0
      sumw=0d0
      sumw2=0d0
      sumrw=0d0
      sumc=0d0
      do23000 i=1,n 
      wi=0d0
      ri=0d0
      do23002 j=1,n 
      dx=x1(i)-x1(j)
      dx2=x2(i)-x2(j)
      if((i.ne.j) .and. (.not.outx .or. dx.ne.0. .or. dx2.ne.0.))then
      dy=y(i)-y(j)
      if((e(i).and.(dy.lt.0.)).or.(e(i).and..not.e(j).and.(dy.eq.0.)))th
     *en
      nrel=nrel+1d0
      nconc1=nconc1+(z(dx.lt.0.)+.5d0*z(dx.eq.0.))
      nconc2=nconc2+(z(dx2.lt.0.)+.5d0*z(dx2.eq.0.))
      ri=ri+1d0
      if(method.eq.1)then
      wi=wi+(z(dx.lt.dx2)-z(dx.gt.dx2))
      sumc=sumc+z(dx.lt.dx2)
      else
      wi=wi+(z(dx.lt.0..and.dx2.ge.0.)-z(dx.gt.0..and.dx2.le.0.))
      sumc=sumc+z(dx.lt.0..and.dx2.ge.0.)
      endif
      else
      if((e(j).and.(dy.gt.0.)).or.(e(j).and..not.e(i).and.(dy.eq.0.)))th
     *en
      nrel=nrel+1d0
      nconc1=nconc1+(z(dx.gt.0.)+.5d0*z(dx.eq.0.))
      nconc2=nconc2+(z(dx2.gt.0.)+.5d0*z(dx2.eq.0.))
      ri=ri+1d0
      if(method.eq.1)then
      wi=wi+(z(dx.gt.dx2)-z(dx.lt.dx2))
      sumc=sumc+z(dx.gt.dx2)
      else
      wi=wi+(z(dx.gt.0..and.dx2.le.0.)-z(dx.lt.0..and.dx2.ge.0.))
      sumc=sumc+z(dx.gt.0..and.dx2.le.0.)
      endif
      else
      if(.not.(e(i).and.e(j)))then
      nuncer=nuncer+1d0
      endif
      endif
      endif
      endif
23002 continue
23003 continue
      sumr=sumr+ri
      sumr2=sumr2+ri*ri
      sumw=sumw+wi
      sumw2=sumw2+wi*wi
      sumrw=sumrw+ri*wi
23000 continue
23001 continue
      c1=nconc1/nrel
      gamma1=2d0*(c1-.5d0)
      c2=nconc2/nrel
      gamma2=2d0*(c2-.5d0)
      gamma=sumw/sumr
      sd=sumr2*sumw**2-2d0*sumr*sumw*sumrw+sumw2*sumr**2
      sd=2d0*dsqrt(sd)/sumr/sumr
      c12=sumc/sumr
      c21=sumc/sumr-gamma
      return
      end
      function z(a)
      double precision z
      logical a
      if(a)then
      z=1d0
      else
      z=0d0
      endif
      return
      end

latexCheckOptions <- function(...) {
if (any(sapply(options()[c("latexcmd","dviExtension","xdvicmd")], is.null)))
  stop("This example uses the pdflatex system command and R's pdf() graphics\n",
       "device and therefore requires that the three options\n",
       "      options()[c(\"latexcmd\",\"dviExtension\",\"xdvicmd\")]\n",
       "all be set to non-NULL values.  Please see the comments in the \"Details\"\n",
       "section of ?microplot::microplot for some recommendations, and the\n",
       "\"System options\" paragraph in the \"Details\" section of ?Hmisc::latex\n",
       "for full discussion of the options available and suggested values for\n",
       "several operating systems.  If you wish to use the latex system command\n",
       "and a compatible graphics device, see the discussion in ?Hmisc::latex",
       call.=FALSE)
}

C Output from Public domain Ratfor, version 1.01
      subroutine jacklins(x, w, n, k, res)
      integer n, k, l
      double precision x(n), w(n-1,k), res(n,k), sj
      do23000 l = 1, k 
      do23002 j = 1, n 
      sj = 0d0
      do23004 i = 1, n 
      if(i .lt. j)then
      sj = sj + w(i,l) * x(i)
      endif
      if(i .gt. j)then
      sj = sj + w(i-1,l) * x(i)
      endif
23004 continue
23005 continue
      res(j,l) = sj
23002 continue
23003 continue
23000 continue
23001 continue
      return
      end

C Output from Public domain Ratfor, version 1.01
C------------------------------------------------------------------------
C       Compute c-index (c) and Brown-Hollander-Krowar-Goodman-Kruskal-Somer
C       rank correlation (gamma) between X and Y with censoring indicator E
C       Also returns number of relevant, concordant, and uncertain pairs
C       (nrel, nconc, nuncert) and estimated s.d. of gamma (sd) using
C       Quade formula (see SAS PROC MATPAR).  Pairs with tied x are
C       excluded if outx=.TRUE.
C
C       F. Harrell  27Nov90
C                   Modification of SAS Procedure KGKC (1980)
C-------------------------------------------------------------------------
      subroutine cidxcn(x,y,e,n,nrel,nconc,nuncert,c,gamma,sd,outx)
      implicit double precision (a-h,o-z)
      double precision x(n),y(n),dx,dy
      logical e(n),outx
      double precision nrel,nuncert,nconc
      nconc=0d0
      nrel=0d0
      nuncert=0d0
      sumr=0d0
      sumr2=0d0
      sumw=0d0
      sumw2=0d0
      sumrw=0d0
      do23000 i=1,n 
      wi=0d0
      ri=0d0
      do23002 j=1,n
      if(j.ne.i)then
      dx=x(i)-x(j)
      dy=y(i)-y(j)
      if(dx.ne.0. .or. .not.outx)then
      if((e(i).and.dy.lt.0.).or.(e(i).and..not.e(j).and.dy.eq.0.))then
      if(dx.lt.0.)then
      nconc=nconc+1d0
      wi=wi+1d0 
      else
      if(dx.eq.0.)then
      nconc=nconc+.5d0
      else
      wi=wi-1d0
      endif
      endif
      nrel=nrel+1d0
      ri=ri+1d0 
      else
      if((e(j).and.dy.gt.0.).or.(e(j).and..not.e(i).and.dy.eq.0.))then
      if(dx.gt.0.)then
      nconc=nconc+1d0
      wi=wi+1d0 
      else
      if(dx.eq.0.)then
      nconc=nconc+.5d0
      else
      wi=wi-1d0
      endif
      endif
      nrel=nrel+1d0
      ri=ri+1d0 
      else
      if(.not.(e(i).and.e(j)))then
      nuncert=nuncert+1d0 
      endif
      endif
      endif
      endif
      endif
23002 continue
23003 continue
      sumr=sumr+ri
      sumr2=sumr2+ri*ri
      sumw=sumw+wi
      sumw2=sumw2+wi*wi
      sumrw=sumrw+ri*wi
23000 continue
23001 continue
      c=nconc/nrel
      gamma=2.*(c-.5)
Ccall dblepr('sumr',4,sumr,1)
Ccall dblepr('sumw',4,sumw,1)
Ccall dblepr('sumr2',5,sumr2,1)
Ccall dblepr('sumw2',5,sumw2,1)
Ccall dblepr('sumrw',5,sumrw,1)
      sd=sumr2*sumw**2-2d0*sumr*sumw*sumrw+sumw2*sumr**2
      sd=2.*dsqrt(sd)/sumr/sumr
      return
      end

subroutine cutgn(x, n, m, g)
  use ISO_FORTRAN_ENV
  implicit none
  integer(int32), intent(in)  :: n, m
  real(real64),   intent(in)  :: x(n)
  integer(int32), intent(out) :: g(n)
  integer(int32)              :: is, ie, ng, k, i, lte
  real(real64)                :: lastval

  ie = 0_int32
  g  = 0_int32
  ng = 0_int32

  do
   is  = ie + 1_int32
   lte = is + m - 1_int32   ! last targeted element in group
   ! Just use the insufficient group < m obs.; pool it with previous group
   ! by not incrementing ng
    if(lte > n) then
      g(is : n) = ng
      return
    end if

    ! If the mth observation is the nth, finish with
    ! the current group as the final group
    ng = ng + 1_int32
    if(lte == n) then
      g(is : n) = ng
      return
    end if

    ! There are observations beyond the last of the m in the current group
    ! See if the values beyond the mth current group's value are tied
    ! with the last value in the current group.  If so, pool observations
    ! into the current group up intil the observation that differs from
    ! the last of the m
    lastval = x(lte)
    if(x(lte + 1_int32) == lastval) then
      ! See how far the tied values go, and consume all of those tied at lastval
      k = 1_int32
      if(lte + 2_int32 <= n) then
        do i=lte + 2_int32, n
          if(x(i) /= lastval) exit
          k = k + 1_int32
        end do
      end if
      ie = lte + k
      g(is : ie) = ng
    else
      ie = lte
      g(is : ie) = ng
    end if
  if(ie == n) return
  end do

end subroutine cutgn

C Output from Public domain Ratfor, version 1.01
      subroutine rcorr(xx, n, p, itype, dmat, npair, x, y, rx, ry, work,
     * iwork)
      integer p, npair(p,p)
      double precision xx(n,p), dmat(p,p), x(n), y(n), rx(n), ry(n), wor
     *k(n)
      integer iwork(n)
      double precision sumx, sumx2, sumy, sumy2, sumxy, z, a, b, xk, yk,
     * d
      sumx = 0d0
      sumy = 0d0
      sumx2 = 0d0
      sumy2 = 0d0
      sumxy = 0d0
      do23000 i = 1, p 
      np = 0
      do23002 k = 1, n 
      if(xx(k, i) .lt. 1d49)then
      np = np + 1
      endif
23002 continue
23003 continue
      npair(i, i) = np
      do23006 j = (i + 1), p 
      m = 0
      if(itype .eq. 1)then
      sumx = 0d0
      sumy = 0d0
      sumx2 = 0d0
      sumy2 = 0d0
      sumxy = 0d0
      endif
      do23010 k = 1, n 
      xk = xx(k, i)
      yk = xx(k, j)
      if(xk .lt. 1d49 .and. yk .lt. 1d49)then
      m = m + 1
      if(itype .eq. 1)then
      a = xk
      b = yk
      sumx = sumx + a
      sumx2 = sumx2 + a * a
      sumy = sumy + b
      sumy2 = sumy2 + b * b
      sumxy = sumxy + a * b
      else
      x(m) = xk
      y(m) = yk
      endif
      endif
23010 continue
23011 continue
      npair(i, j) = m
      if(m .gt. 1)then
      if(itype .eq. 1)then
      z = m
      d = (sumxy - sumx * sumy / z) / dsqrt((sumx2 - sumx * sumx / z) * 
     *(sumy2 - sumy * sumy / z))
      else
      call docorr(x, y, m, d, rx, ry, work, iwork)
      endif
      dmat(i, j) = d
      else
      dmat(i, j) = 1d50
      endif
23006 continue
23007 continue
23000 continue
23001 continue
      do23020 i = 1, p 
      dmat(i, i) = 1d0
      do23022 j = (i + 1), p 
      dmat(j, i) = dmat(i, j)
      npair(j, i) = npair(i, j)
23022 continue
23023 continue
23020 continue
23021 continue
      return
      end
      subroutine docorr(x, y, n, d, rx, ry, work, iwork)
      double precision x(1), y(1), rx(n), ry(n), work(1)
      integer iwork(1)
      double precision sumx, sumx2, sumy, sumy2, sumxy, a, b, z, d
      call rank(n, x, work, iwork, rx)
      call rank(n, y, work, iwork, ry)
      sumx = 0d0
      sumx2 = 0d0
      sumy = 0d0
      sumy2 = 0d0
      sumxy = 0d0
      do23024 i = 1, n 
      a = rx(i)
      b = ry(i)
      sumx = sumx + a
      sumx2 = sumx2 + a * a
      sumy = sumy + b
      sumy2 = sumy2 + b * b
      sumxy = sumxy + a * b
23024 continue
23025 continue
      z = n
      d = (sumxy - sumx * sumy / z) / dsqrt((sumx2 - sumx * sumx / z) * 
     *(sumy2 - sumy * sumy / z))
      return
      end

ffCompress <- function(obj, float=c('single', 'double'), print=FALSE) {
  float <- match.arg(float)
  if(! requireNamespace('ff', quietly=TRUE))
    stop('ff package not available')
  nam <- names(obj)
  p   <- length(nam)
  if(print) cat(p, 'variables; Processing variable:')
  vmode <- label <- units <- character(p)
  names(vmode) <- names(label) <- names(units) <- nam

  vm <- function(m, na, neg) {
    ## For integers, given maximum absolute value, whether or not NAs
    ## are present, and whether negative values are present, computes
    ## the ff vmode; compute # bits needed:
    b <- if(m == 0) 0 else 1 + floor(log2(m))
    if(b > 32) 'double'
    else if(na || neg || b > 16) {   ## NAs or negatives present
      if(b > 16) 'integer' else if(b > 8) 'short' else 'byte'
    }
    else { ## no NAs or negatives, 16 or fewer bits
      if(b > 8) 'ushort' else if(b > 4) 'ubyte' else
      if(b > 2) 'nibble' else 'quad'
    }
  }
    
  for(i in 1 : p) {
    if(print) cat(i,'')
    x <- obj[[i]]
    at <- attributes(x)
    if(length(lab <- at$label) | length(un <- at$units)) {
      class(x) <- setdiff(class(x), 'labelled')
      if(length(lab)) {
        label[i] <- lab
        attr(x, 'label') <- NULL
      }
      if(length(un)) {
        units[i] <- un
        attr(x, 'units') <- NULL
      }
      if(is.matrix(x)) class(x) <- c('AsIs', class(x))
      obj[[i]] <- x
    }
    else if(is.matrix(x)) {
      ## As above, e.g. if x is Surv() ffdf will break it into separate
      ## variables if not I(Surv())
      class(x) <- c('AsIs', class(x))
      obj[[i]] <- x
    }
    x <- unclass(x)
    n  <- length(x)
    x  <- x[! is.na(x)]
    lx <- length(x)
    s  <- storage.mode(x)
    vmode[i] <-
      if(s %in% c('character', 'logical')) s
      else if(! length(x)) 'logical'  ## 2 bits if all NAs
        else {
        frac <- any(floor(x) != x)
        if(frac) float
        else vm(max(abs(x)), lx < n, any(x < 0))
      }
  }
  if(print) cat('\n')
  if(all(c(label, units) == ''))
    ff::as.ffdf(obj, vmode=vmode, VERBOSE=print)
  else {
    f <- ff::as.ffdf(obj, vmode=vmode, VERBOSE=print)
    class(f) <- c('ffdflabel', 'ffdf')
    if(any(label != '')) attr(f, 'label') <- label
    if(any(units != '')) attr(f, 'units') <- units
    f
  }
}

as.data.frame.ffdflabel <- function(x, ...) {
  if(! requireNamespace('ff', quietly=TRUE))
    stop('ff package not available')
  nam <- names(x)
  lab <- attr(x, 'label')[nam]
  un  <- attr(x, 'units')[nam]
  class(x) <- setdiff(class(x), 'ffdflabel')
  x <- ff::as.data.frame.ffdf(x)
  for(n in nam) {
    if(lab[n] != '') label(x[[n]]) <- lab[n]
    if(length(un) && un[n]  != '') attr(x[[n]], 'units') <- un[n]
  }
  x
}
  
'[.ffdflabel' <- function(x, ...) {
  if(! requireNamespace('ff', quietly=TRUE))
    stop('ff package not available')
  nam <- names(x)
  lab <- attr(x, 'label')[nam]
  un  <- attr(x, 'units')[nam]
  class(x) <- setdiff(class(x), 'ffdflabel')
  x <- NextMethod('[')
  cx  <- class(x)
  nam <- names(x)
  lab <- lab[nam]
  if(length(un)) un <- un[nam]
  if('ffdf' %in% cx) {
    attr(x, 'label') <- lab
    attr(x, 'units') <- un
    class(x) <- c('ffdflabel', cx)
  }
  else if(is.data.frame(x)) {
    for(n in nam) {
      if(lab[n] != '')               label(x[[n]])         <- lab[n]
      if(length(un) && un[n]  != '') attr(x[[n]], 'units') <- un[n]
    }
  }
  x
}

# From ff documentation:

# byte 8 bit signed integer with NA
# short 16 bit signed integer with NA
# integer 32 bit signed integer with NA

# quad 2 bit unsigned integer without NA
# nibble 4 bit unsigned integer without NA
# ubyte 8 bit unsigned integer without NA
# ushort 16 bit unsigned integer without NA

require(Hmisc)
w <- data.frame(age=30:40, z=letters[1:11], aa=1:11)
w <- upData(w, labels=c(age='Age label from LabelsUnits',
                        z='z label from LabelsUnits'),
            units=c(z='m/sec'))
LabelsUnits <- extractlabs(w)
LabelsUnits
w <- upData(w, labels=c(age='age label from w', z='z label from w'))
age <- 1:9
label(age) <- 'age label from free-standing variable'

vlab(age)
hlab(age)
hlabs(age, z)
vlab(aa)

rm(LabelsUnits)
vlab(age)
hlab(age)
hlabs(age, z)

options(current_ds='w')
vlab(age)
hlab(age)
hlabs(age, z)

rm(w)
vlab(age)
vlab(z)    # z doesn't exist
hlab(age)
hlabs(age, z)

/* Macro exportlib

    Exports all SAS datasets in a data library to csv files.  One of
    the datasets is assumed to be the result of PROC FORMAT CNTLOUT=
    if any user formats are referenced.  Numeric variables are
    formatted in BEST16 format so that date/time variables will be
    exported with their internal numeric values.  A special file
    _contents_.csv is created to hold, for all datasets combined, the
    dataset name, dataset label, variable names, labels, formats,
    types, and lengths.

    Usage:

    %INCLUDE "foo\exportlib.sas";    * Define macro;
    LIBNAME lib ...;                 * E.g. LIBNAME d SASV5XPT "foo.xpt";
    %exportlib(lib, outdir, tempdir);
    
    Arguments:
        lib     - SAS libname for input datasets
        outdir  - directory in which to write .csv files (default ".")
        tempdir - temporary directory to hold generated SAS code
                  (default C:/WINDOWS/TEMP)
                                                                             */
%macro exportlib(lib,  outdir, tempdir);
%IF %QUOTE(&outdir)=   %THEN %LET outdir=.;
%IF %QUOTE(&tempdir)=  %THEN %LET tempdir=C:/WINDOWS/TEMP;
OPTIONS NOFMTERR;
PROC COPY IN=&lib OUT=work;RUN;
PROC CONTENTS DATA=work._ALL_ NOPRINT
    OUT=_contents_(KEEP=memname memlabel name type label format length
                        nobs);RUN;
PROC EXPORT DATA=_contents_ OUTFILE="&outdir/_contents_.csv" REPLACE;RUN;
DATA _NULL_; SET _contents_; BY MEMNAME;
    FILE "&tempdir/_export_.sas"; RETAIN bk -1;
    if FIRST.MEMNAME & (NOBS > 0) THEN DO;
        PUT "DATA " MEMNAME "; SET " MEMNAME ";FORMAT _NUMERIC_ BEST14.;RUN;";
        PUT "PROC EXPORT DATA=" MEMNAME " OUTFILE=" '"' "&outdir/" 
            MEMNAME +bk ".csv" '" ' "REPLACE;RUN;";
        END;
    RUN;
%INCLUDE "&tempdir/_export_.sas";RUN;
%MEND exportlib;

##' parallel Package Easy Front-End
##'
##' Given a function `onecore` that runs the needed set of simulations on
##' one CPU core, and given a total number of repetitions `reps`, determines
##' the number of available cores and by default uses one less than that.
##' By default the number of cores is one less than the number available
##' on your machine.
##' reps is divided as evenly as possible over these cores, and batches
##' are run on the cores using the `parallel` package `mclapply` function.
##' The current per-core repetition number is continually updated in
##' your system's temporary directory (/tmp for Linux and Mac, TEMP for Windows)
##' in a file name progressX.log where X is the core number.
##' The random number seed is set for each core and is equal to
##' the scalar `seed` - core number + 1.  The default seed is a random
##' number between 0 and 10000 but it's best if the user provides the
##' seed so the simulation is reproducible.
##' The total run time is computed and printed
##' onefile must create a named list of all the results created during
##' that one simulation batch.  Elements of this list must be data frames,
##' vectors, matrices, or arrays.   Upon completion of all batches,
##' all the results are rbind'd and saved in a single list.
##'
##' onecore must have an argument `reps` that will tell the function
##' how many simulations to run for one batch, another argument `showprogress`
##' which is a function to be called inside onecore to write to the
##' progress file for the current core and repetition, and an argument `core`
##' which informs `onecore` which sequential core number (batch number) it is
##' processing.
##' When calling `showprogress` inside `onecore`, the arguments, in order,
##' must be the integer value of the repetition to be noted, the number of reps,
##' `core`, an optional 4th argument `other` that can contain a single
##' character string to add to the output, and an optional 5th argument `pr`.
##' You can set `pr=FALSE` to suppress printing and have `showprogress`
##' return the file name for holding progress information if you want to
##' customize printing.
##'
##' If any of the objects appearing as list elements produced by onecore
##' are multi-dimensional arrays, you must specify an integer value for
##' `along`.  This specifies to the `abind` package `abind` function
##' the dimension along which to bind the arrays.  For example, if the
##' first dimension of the array corresponding to repetitions, you would
##' specify along=1.   All arrays present must use the same `along` unless
##' `along` is a named vector and the names match elements of the
##' simulation result object.
##' Set `simplify=FALSE` if you don't want the result simplified if
##' onecore produces only one list element.  The default returns the
##' first (and only) list element rather than the list if there is only one
##' element.
##'
##' When `onecore` returns a `data.table`, `runParallel` simplifies all this and merely
##' rbinds all the per-core data tables into one large data table.  In that case when you
##' have `onecore` include a column containing a simulation number, it is wise to prepend
##' that number with the core number so that you will have unique simulation IDs when
##' all the cores' results are combined.
##'
##' See [here](https://hbiostat.org/rflow/parallel.html) for examples.
##'
##' @title runParallel
##' @param onecore function to run the analysis on one core
##' @param reps total number of repetitions
##' @param seed species the base random number seed.  The seed used for core i will be `seed` + `i`.
##' @param cores number of cores to use, defaulting to one less than the number available
##' @param simplify set to FALSE to not create an outer list if a `onecore` result has only one element
##' @param along see Details
##' @return result from combining all the parallel runs, formatting as similar to the result produced from one run as possible
##' @author Frank Harrell
##' @md
runParallel <- function(onecore, reps, seed=round(runif(1, 0, 10000)),
                        cores=max(1, parallel::detectCores() - 1),
                        simplify=TRUE, along) {

  if(! requireNamespace('parallel', quietly=TRUE))
    stop('requires parallel package')
  
  progressDir <- if(Sys.info()['sysname'] == 'Darwin') '/tmp' else paste0(dirname(tempdir()))
  stime <- Sys.time()

  ## Function to divide n things as evenly as possible into m groups
  ## See https://math.stackexchange.com/questions/199690
  evenly <- function(n, m) {
    a <- floor(n / m)
    r <- n %% m
    w <- c(rep(a + 1, r), rep(a, m - r))
    if(sum(w) != n) stop('program logic error')
    w
  }
  repsc <- evenly(reps, cores)
  showprogress <- function(i=0, reps=0, core, other='', pr=TRUE) {
    file <- paste0(progressDir, '/progress', core, '.log')
    if(other != '') other <- paste0(other, '   ')
    if(pr) cat(other, i, ' of ', reps, '\n', sep='', file=file)
    invisible(file)
    }
  ff <- function(i) {
    set.seed(seed + i - 1)
    onecore(reps=repsc[i], showprogress=showprogress, core=i)
  }
  v <- parallel::mclapply(1 : cores, ff, mc.cores=cores, mc.set.seed=FALSE)
  v1 <- v[[1]]
  ite <- sapply(v, function(z) inherits(z, 'try-error'))
  if(any(ite)) {
    z <- sapply(v, function(x) {
      x <- as.character(attr(x, 'condition'))
      if(length(x)) x else '' })
    stop(paste(z, collapse=';'))
    }
  etime <- Sys.time()
  cat('\nRun time:', format(etime - stime), 'using', cores, 'cores\n')
  ## Separately for each element of each list in w, stack the results so
  ## the use can treat them as if from a single run
  ## If the result of onecore is a data table, just rbind all the data tables
  ## The user may want to concatenate the core number to the simulation number in that case
  
  if(data.table::is.data.table(v1)) return(data.table::rbindlist(v))

  m <- length(v1)   # number of elements in a per-core list
  R <- vector('list', m)
  names(R) <- names(v1)

  u <- function(j) {
    x <- lapply(v, function(x) x[[j]])
    z <- x[[1]]
    if(is.matrix(z)) x <- do.call('rbind', x)
    else
      if(is.list(z)) x <- data.table::rbindlist(x)
    else if(is.array(z)) {
      if(! requireNamespace('abind', quietly=TRUE))
        stop('must install the abind package to handle arrays')
      al <- if(length(along) == 1) along else along[names(v1)[j]]
      x <- do.call(abind::abind, list(x, along=al))
    }
    else if(! is.atomic(z))
      stop(paste('list element', j,
       ' of result returned by onecore is not data.frame, matrix, array, or vector'))
    else x <- unlist(x)   # vectors
    x
    }
    
  for(j in 1: m)         R[[j]] <- u(j)
  if(simplify && m == 1) R[[1]] else R
  }

##' Pair-up and Compute Differences
##'
##' This function sets up for plotting half-width confidence intervals for differences, sorting by descending order of differences within major categories, especially for dot charts as produced by [dotchartpl()]. Given a numeric vector `x` and a grouping (superpositioning) vector `group` with exactly two levels, computes differences in possibly transformed `x` between levels of `group` for the two observations that are equal on `major` and `minor`.  If `lower` and `upper` are specified, using `conf.int` and approximate normality on the transformed scale to backsolve for the standard errors of estimates, and uses approximate normality to get confidence intervals on differences by taking the square root of the sum of squares of the two standard errors.  Coordinates for plotting half-width confidence intervals are also computed.  These intervals may be plotted on the same scale as `x`, having the property that they overlap the two `x` values if and only if there is no "significant" difference at the `conf.int` level.
##' @title pairUpDiff
##' @param x a numeric vector
##' @param major an optional factor or character vector
##' @param minor an optional factor or character vector
##' @param group a required factor or character vector with two levels
##' @param refgroup a character string specifying which level of `group` is to be subtracted
##' @param lower an optional numeric vector giving the lower `conf.int` confidence limit for `x`
##' @param upper similar to `lower` but for the upper limit
##' @param minkeep the minimum value of `x` required to keep the observation.  An observation is kept if either `group` has `x` exceeding or equalling `minkeep`.  Default is to keep all observations.
##' @param sortdiff set to `FALSE` to avoid sorting observations by descending between-`group` differences
##' @param conf.int confidence level; must have been the value used to compute `lower` and `upper` if they are provided 
##' @return a list of two objects both sorted by descending values of differences in `x`.  The `X` object is a data frame that contains the original variables sorted by descending differences across `group` and in addition a variable `subscripts` denoting the subscripts of original observations with possible re-sorting and dropping depending on `sortdiff` and `minkeep`.  The `D` data frame contains sorted differences (`diff`), `major`, `minor`, `sd` of difference, `lower` and `upper` confidence limits for the difference, `mid`, the midpoint of the two `x` values involved in the difference, `lowermid`, the midpoint minus 1/2 the width of the confidence interval, and `uppermid`, the midpoint plus 1/2 the width of the confidence interval.  Another element returned is `dropped` which is a vector of `major` / `minor` combinations dropped due to `minkeep`.
##' @author Frank Harrell
##' @export
##' @md
##' @examples
##' x <- c(1, 4, 7, 2, 5, 3, 6)
##' pairUpDiff(x, c(rep('A', 4), rep('B', 3)),
##'   c('u','u','v','v','z','z','q'),
##'   c('a','b','a','b','a','b','a'), 'a', x-.1, x+.1)
    
pairUpDiff <- function(x, major=NULL, minor=NULL, group, refgroup,
                       lower=NULL, upper=NULL, minkeep=NULL,
                       sortdiff=TRUE, conf.int=0.95) {

  n <- length(x)
  major <- if(! length(major)) rep(' ', n) else as.character(major)
  minor <- if(! length(minor)) rep(' ', n) else as.character(minor)
  ## Note: R will not let you use z[cbind(...)] if one of the dimensions
  ## is of length 1 and equal to ''; needed to use ' '
  group <- as.character(group)
  glev  <- unique(group)
  if(length(glev) != 2) stop('group must have two distinct values')
  if(refgroup %nin% glev) stop('refgroup must be one of the group values')
  altgroup <- setdiff(glev, refgroup)

  mm <- c(major, minor)
  sep <- if(! any(grepl(':', mm))) ':'
         else
           if(! any(grepl('|', mm))) '|'
         else
           if(! any(grepl(';', mm))) ';'
         else
           if(! any(grepl('!', mm))) '!'
         else
           stop('major or minor contain all delimiters :|;!')
  
  m  <- paste0(major, sep, minor)
  u  <- unique(m)
  lu <- length(u)

  lowup <- length(lower) * length(upper) > 0
  zcrit <- qnorm((1 + conf.int) / 2)

  ## See if any observations should be dropped
  dropped <- NULL
  if(length(minkeep)) {
    xa       <- xb <- structure(rep(NA, lu), names=u)
    j        <- group == refgroup
    xa[m[j]] <- x[j]
    j        <- group == altgroup
    xb[m[j]] <- x[j]
    j        <- ! is.na(xa + xb) & (xa < minkeep & xb < minkeep)
    if(any(j)) {
      dropped <- names(xa)[j]
      u  <- setdiff(u, dropped)
      lu <- length(u)
      }
    }
  
  xa <- xb <- sda <- sdb <- diff <- mid <- dsd <- dlower <-
    dupper <- dlowermid <- duppermid <-  structure(rep(NA, lu), names=u)
  j     <- (group == refgroup) & (m %nin% dropped)
  w     <- m[j]
  xa[w] <- x[j]
  if(lowup) sda[w] <- 0.5 * (upper[j] - lower[j]) / zcrit
    
  j     <- (group == altgroup) & (m %nin% dropped)
  w     <- m[j]
  xb[w] <- x[j]
  if(lowup) sdb[w] <- 0.5 * (upper[j] - lower[j]) / zcrit

  diff[u]   <- xb[u] - xa[u]
  if(lowup) {
    dsd[u]    <- sqrt(sda[u] ^ 2 + sdb[u] ^ 2)
    dlower[u] <- diff[u] - zcrit * dsd[u]
    dupper[u] <- diff[u] + zcrit * dsd[u]
    }
  mid[u]    <- (xa[u] + xb[u]) / 2.
  if(lowup) {
    dlowermid[u] <- mid[u] - 0.5 * zcrit * dsd[u]
    duppermid[u] <- mid[u] + 0.5 * zcrit * dsd[u]
    }

  k  <- strsplit(u, sep)
  ma <- sapply(k, function(x) x[[1]])
  mi <- sapply(k, function(x) x[[2]])

ww <- list(x, major, minor, group, lower, upper, subscripts=1:length(x))

  Z <- if(lowup) 
         data.frame(x, major, minor, group, lower, upper,
                    subscripts=1 : length(x))
       else
         data.frame(x, major, minor, group, subscripts=1 : length(x))

  if(length(dropped)) Z <- Z[m %nin% dropped, ]
  if(sortdiff) {
    m <- paste0(Z$major, sep, Z$minor)
    ## diff[m] is a table lookup; difference will be same for both groups
    j <- order(Z$major, ifelse(is.na(diff[m]), -Inf, - diff[m]))
    Z <- Z[j, ]
    }

  ## Variables referenced below have already had observations dropped
  ## due to minkeep
  D <- data.frame(diff=diff[u], major=ma, minor=mi, sd=dsd[u],
                  lower=dlower[u], upper=dupper[u],
                  mid=mid[u], lowermid=dlowermid[u], uppermid=duppermid[u])
  if(sortdiff) {
    j <- order(D$major, ifelse(is.na(D$diff), -Inf, -D$diff))
    D <- D[j, ]
    }
  list(X=Z, D=D, dropped=dropped)
  }

! Converted from Ratfor 2024-10-26 using ChatGPT and the following request:
! Convert the following Ratfor code to Fortran 2018 using Fortran ISO environment without using module

subroutine rcorr(xx, n, p, itype, dmat, npair, x, y, rx, ry, work, iwork)
    use ISO_FORTRAN_ENV
    implicit none
    integer, intent(in) :: n, p, itype
    real(REAL64), intent(in) :: xx(n, p)
    real(REAL64), intent(out) :: dmat(p, p)
    integer, intent(out) :: npair(p, p)
    real(REAL64), intent(out) :: x(n), y(n), rx(n), ry(n), work(n)
    integer, intent(out) :: iwork(n)
    real(REAL64) :: meanx, meany, vx, vy, xyn
    integer :: i, j, m
    logical, allocatable :: nna(:)
    real(REAL64), parameter :: nab = 1.0e49_real64   ! signifies missing value
  
    allocate(nna(n))
  
    dmat = 1.0e50_real64

    ! Loop through each pair of variables
    do i = 1, p
      dmat(i, i)  = 1e0_real64
      npair(i, i) = count(xx(:, i) < nab)
  
      do j = i + 1, p
        nna = (xx(:, i) < nab) .and. (xx(:, j) < nab)
        m   = count(nna)
        npair(i, j) = m
        if(m < 2) cycle

        x(1:m) = pack(xx(:, i), nna)
        y(1:m) = pack(xx(:, j), nna)

        if(itype == 2) then     ! replace x and y with their ranks
          call rank(m, x, work, iwork, rx)
          call rank(m, y, work, iwork, ry)
          x(1:m) = rx(1:m)
          y(1:m) = ry(1:m)
        end if

        xyn = real(m, REAL64)
        meanx = sum(x(1:m)) / xyn
        meany = sum(y(1:m)) / xyn
        x(1:m) = x(1:m) - meanx
        y(1:m) = y(1:m) - meany
        vx    = sum(x(1:m) ** 2)
        vy    = sum(y(1:m) ** 2)
        if(vx .eq. 0e0_real64 .or. vy .eq. 0e0_real64) cycle
        dmat(i, j) = sum(x(1:m) * y(1:m)) / sqrt(vx * vy)
      end do
    end do
  
    ! Finish symmetric matrices
    do i = 1, p
      do j = i + 1, p
        dmat(j, i)  = dmat(i, j)
        npair(j, i) = npair(i, j)
      end do
    end do
  
    deallocate(nna)
    return
  end subroutine rcorr
  

# Function to automatically reorder variables for use with aregImpute
# Modification of function written by Yong Hao Pua
# Specify nperm=integer to obtain that many formulae with random
# permutation of order of variables; omit nperm to obtain formula
# with variables sorted by decreasing number of NAs

reformM <- function(formula, data, nperm) {

  tlabels <- attr(terms(formula), "term.labels")   ## minor tweak!
  cs <- all.vars(formula)
  data <- data[, cs]
  ismiss <- function(x) if(is.character(x)) is.na(x) | x==''  else is.na(x)
  m <- sapply(data, ismiss)
  miss.per.obs <- apply(m, 1, sum)
  miss.per.var <- apply(m, 2, sum)
  # Percent of observations with any missings:
  pm <- ceiling(100 * sum(miss.per.obs > 0) / length(miss.per.obs))
  nimpute = max(5, pm)
  cat("Recommended number of imputations:", nimpute, "\n")

  if(missing(nperm)) {
    j <- order(miss.per.var, decreasing=TRUE) # var with highest NA freq first
    formula <- as.formula(paste('~', paste(tlabels[j], collapse=' + ')))
  }
  else {
    formula <- list()
    prev <- character(0)
    # Could add logic to sample() until permutation is different from
    # all previous permutations
    for(i in 1 : nperm) {
      ## Try up to 10 times to get a unique permutation
      for(j in 1 : 10) {
        f <- paste('~', paste(sample(tlabels), collapse=' + '))
        if(f %nin% prev) {
          prev <- c(prev, f)
          formula[[i]] <- as.formula(f)
          break
        }
      }
    }

    if(nperm == 1) formula <- formula[[1]]
  }
  formula
}

# Converted from R code provided by Hans Werner Borchers <hwborchers@googlemail.com>
# ax = x-limits for region of interest
# ay = y-limits " "
# x, y = coordinates of points to avoid
# Assume x, y are sorted in y-order, e.g
# o = order(y); x <- x[o]; y <- y[o]
# n = length(x) = length(y)
# z = c(D[m], d[m], d[m+1]), d=sort(c(ax,x)), D=diff(d), m=which.max(D)
# Output: area, rect[4]
# To convert to Fortran:
#  sudo apt-get install ratfor
#  ratfor -o ../maxempr.f maxempr.r
SUBROUTINE maxempr(ax, ay, x, y, n, w, h, z, area, rect)
IMPLICIT DOUBLE PRECISION (a-h,o-z)
INTEGER n
DOUBLE PRECISION ax(2), ay(2), x(n), y(n), z(3), rect(4), maxr, li
# check vertical slices
maxr = z(1) * dabs(ay(2) - ay(1))
rect(1) = z(2)
rect(2) = ay(1)
rect(3) = z(3)
rect(4) = ay(2)

do i=1,n {
  tl = ax(1); tr = ax(2)
  if (i < n) {
    do j=(i+1),n {
      if (x(j) > tl & x(j) < tr) {
        ## check horizontal slices (j == i+1)
        ## and (all) rectangles above (x(i), y(i))
        area = (tr - tl) * (y(j) - y(i))
        if (area > maxr & ((tr - tl) > w) & ((y(j) - y(i)) > h)) {
          maxr = area
          rect(1) = tl
          rect(2) = y(i)
          rect(3) = tr
          rect(4) = y(j)
        }
        if (x(j) > x(i)) tr = x(j)
        else             tl = x(j)
      }
    }
  }
  ## check open rectangles above (x(i), y(i))
  area = (tr - tl) * (ay(2) - y(i))
  if (area > maxr & ((tr - tl) > w) &
            ((ay(2) - y(i)) > h)) {
    maxr = area
    rect(1) = tl
    rect(2) = y(i)
    rect(3) = tr
    rect(4) = ay(2)
  }
  ## check open rectangles below (x(i), y(i))
  ri = ax(2); li = ax(1)
  do k=1,n {
    if(y(k) < y(i) & x(k) > x(i)) ri = dmin1(ri, x(k))
    if(y(k) < y(i) & x(k) < x(i)) li = dmax1(li, x(k))
  }
  area = (ri - li) * (ay(2) - y(i))
  if (area > maxr & ((ri - li) > w) &
            ((y(i) - ay(1)) > h)) {
    maxr = area
    rect(1) = li
    rect(2) = ay(1)
    rect(3) = ri
    rect(4) = y(i)
  }
}
area = maxr
return
end

#  ratfor -o ../hoeffd.f hoeffd.r
#
SUBROUTINE hoeffd(xx, n, p, dmat, aadmat, madmat, npair, x, y, rx, ry, rj)
IMPLICIT DOUBLE PRECISION (a-h,o-z)
INTEGER p, npair(p,p)
DOUBLE PRECISION xx(n,p), dmat(p,p), aadmat(p,p), madmat(p,p), x(n), y(n), rx(n), ry(n), rj(n), maxad

    DO i=1, p {
        np=0
        DO k=1, n {
            if(xx(k,i) < 1d49) np = np + 1
        }
        npair(i,i) = np

        DO j=(i+1),p {
            m = 0
            DO k=1,n {
                xk = xx(k,i)
                yk = xx(k,j)
                if(xk < 1d49 & yk < 1d49) {
                    m = m + 1
                    x(m) = xk
                    y(m) = yk
                }
            }
            npair(i,j) = m
            if(m > 4) {
                CALL hoeff(x, y, m, d, aad, maxad, rx, ry, rj)
                dmat(i,j) = d
                aadmat(i,j) = aad
                madmat(i,j) = maxad
            }
            else dmat(i,j) = 1d50
        }
    }
    DO i=1,p {
        dmat(i,i) = 1d0/30d0
        DO j=(i+1),p {
            dmat(j,i) = dmat(i,j)
            npair(j,i) = npair(i,j)
            aadmat(j,i) = aadmat(i,j)
            madmat(j,i) = madmat(i,j)
        }
    }
    RETURN
END  

SUBROUTINE hoeff(x, y, n, d, aad, maxad, rx, ry, rj)
IMPLICIT DOUBLE PRECISION (a-h,o-z)
DOUBLE PRECISION x(n), y(n), rx(n), ry(n), rj(n), maxad
#	INTEGER iwork(1)
#	CALL rank(n, x, work, iwork, rx)
#	CALL rank(n, y, work, iwork, ry)
    CALL jrank(x, y, n, rx, ry, rj)
    q = 0d0
    r = 0d0
    s = 0d0
    aad = 0d0
    maxad = 0d0
    z = n
    DO i=1,n {
        rxi = rx(i)
        ryi = ry(i)
        rji = rj(i)
        ad  = dabs((rji/z) - (rxi/z)*(ryi/z))
        aad = aad + ad
        maxad = dmax1(maxad, ad)
	q = q + (rxi-1d0)*(rxi-2d0)*(ryi-1d0)*(ryi-2d0)
	r = r + (rxi-2d0)*(ryi-2d0)*(rji-1d0)
	s = s + (rji-1d0)*(rji-2d0)
    }
    aad = aad / z
    d = (q-2d0*(z-2d0)*r+(z-2d0)*(z-3d0)*s)/z/(z-1d0)/(z-2d0)/(z-3d0)/(z-4d0)
    RETURN
END

#	Use C version of this which is much faster (since uses a sort)
#	SUBROUTINE rank(x, n, r)   # simple rank with midranks for ties
#	REAL*4 x(1), r(1)
#	DO i=1,n {
#	  xi=x(i)
#	  ir=2   # will be 2*rank(x(i))
#	  DO j=1,n {
#	    if(i.ne.j) {
#	      if(x(j)<xi) ir=ir+2
#	      if(x(j)==xi) ir=ir+1
#	    }
#	  }
#	  r(i)=float(ir)/2.0
#	}
#	RETURN
#	END

SUBROUTINE jrank(x, y, n, rx, ry, r) # joint rank with midranks for ties
INTEGER n
DOUBLE PRECISION x(n), y(n), rx(n), ry(n), r(n), cx, cy, ri, rix, riy, xi, yi
    DO i=1,n {
        xi  = x(i)
	yi  = y(i)
        ri  = 1d0
        rix = 1d0
        riy = 1d0
        DO j=1,n {
            if(i .ne. j) {
	        cx = 0d0
                if(x(j) < xi) cx = 1d0
                if(x(j) == xi) cx = .5d0
                cy = 0d0
                if(y(j) < yi) cy = 1d0
                if(y(j) == yi) cy = .5d0
                rix = rix + cx
                riy = riy + cy
	        ri  = ri + cx*cy
            }
        }
        rx(i) = rix
        ry(i) = riy
        r(i) = ri
    }
    RETURN
END

      SUBROUTINE largrec(x, y, n, xlim, ylim, width, height,
     &                   numbins, itype, rx, ry)
C     *********************************************************
C     * x(n) - array of x values of data points
      DOUBLE PRECISION x(*)
C     * y(n) - array of y values of data points
      DOUBLE PRECISION y(*)
C     * n - number of data points
      INTEGER n
C     * xlim(2) - contains left and right limits of x axis
      DOUBLE PRECISION xlim(2)
C     * ylim(2) - contains bottom and top limits of y axis
      DOUBLE PRECISION ylim(2)
C     * width - minimum allowable width of empty space
      DOUBLE PRECISION width
C     * height - minimum allowable height of empty space
      DOUBLE PRECISION height
C     * numbins - number of blocks to chunk axis ranges into
      INTEGER numbins
C     * itype - how to favor box size
      INTEGER itype
C     * rx(2) - left and right limits of found box
      DOUBLE PRECISION rx(2)
C     * ry(2) - top and bottom limits of found box
      DOUBLE PRECISION ry(2)
C     * xd - x distance between x limits
      DOUBLE PRECISION xd
C     * yd - y distance between y limits
      DOUBLE PRECISION yd
C     * xinc - amount to add to x axis search box bounds
      DOUBLE PRECISION xinc
C     * yinc - amount to add to y axis search box bounds
      DOUBLE PRECISION yinc
C     * xl - left search box bound
      DOUBLE PRECISION xl
C     * xr - right search box bound
      DOUBLE PRECISION xr
C     * yb - bottom search box bound
      DOUBLE PRECISION yb
C     * yt - top search box bound
      DOUBLE PRECISION yt
C     * i - itterator variable
      INTEGER i
C     * area - area of empty space
      DOUBLE PRECISION area
C     * w - width of empty space
      DOUBLE PRECISION w
C     * h - height of empty space
      DOUBLE PRECISION h
C     * ar - tempory area storage
      DOUBLE PRECISION ar
C
      xd   = xlim(2)-xlim(1)
      yd   = ylim(2)-ylim(1)
      xinc = xd / numbins
      yinc = yd / numbins
      rx(1) = 1d30
      rx(2) = 1d30
      ry(1) = 1d30
      ry(2) = 1d30
      IF(width .GE. xd .OR. height .GE. yd) THEN
         RETURN
      ENDIF
C
      w = 0d0
      h = 0d0
      area = 0d0
C
      xl=xlim(1)
      DO WHILE (xl .LE. xlim(2)-width)
         yb = ylim(1)
         DO WHILE (yb .LE. ylim(2)-height)
            xr = xl + width
            DO WHILE (xr .LE. xlim(2))
               yt = yb + height
               DO WHILE (yt .LE. ylim(2))
                  DO i=1,n
                     IF(x(i) .GE. xl .AND. x(i) .LE. xr .AND.
     &                    y(i) .GE. yb .AND. y(i) .LE. yt) GO TO 1
                  ENDDO
                  ar = (yt-yb)*(xr-xl)
                  if((itype.EQ.1 .AND. ar .GT. area) .OR. 
     &               (itype.EQ.2 .AND. yt-yb .GE. h .AND. 
     &                                 xr-xl .GE. w)) THEN
                     area = ar
                     w = xr - xl
                     h = yt - yb
                     rx(1) = xl
                     rx(2) = xr
                     ry(1) = yb
                     ry(2) = yt
                  ENDIF
                  yt = yt + yinc
               ENDDO
               xr = xr + xinc
            ENDDO
 1          CONTINUE
            yb = yb + yinc
         ENDDO
         xl = xl + xinc
      ENDDO
      RETURN
      END

ggfreqScatter <- function(x, y, by=NULL, bins=50, g=10, cuts=NULL,
                          xtrans  = function(x) x,
                          ytrans  = function(y) y,
                          xbreaks = pretty(x, 10),
                          ybreaks = pretty(y, 10),
                          xminor  = NULL,
                          yminor  = NULL,
                          xlab=as.character(substitute(x)),
                          ylab=as.character(substitute(y)),
                          fcolors=viridisLite::viridis(10),
                          nsize=FALSE, stick=FALSE,
                          html=FALSE, prfreq=FALSE, ...) {

  xlab <- if(! missing(xlab)) xlab
          else if(label(x) != '') label(x, plot=TRUE, html=html) else xlab
  ylab <- if(! missing(ylab)) ylab
          else if(label(y) != '') label(y, plot=TRUE, html=html) else ylab

  nx <- is.numeric(x); ny <- is.numeric(y)
  xbreaks <- if(nx) xbreaks; ybreaks <- if(ny) ybreaks
  bins <- rep(bins, length.out=2)

  bypres <- length(by) > 0
  if(! bypres) by <- rep(0, times=length(x))
  
  i <-  ! (is.na(x) | is.na(y))
  x <- xtrans(x[i]); y <- ytrans(y[i])
  by <- by[i]
  
  if(nx) {
    rx <- range(x)
    sx <- diff(rx) / bins[1]
    x  <- rx[1] + sx * round((x - rx[1]) / sx)
  }
  if(ny) {
    ry <- range(y)
    sy <- diff(ry) / bins[2]
    y  <- ry[1] + sy * round((y - ry[1]) / sy)
  }
  
  k <- as.data.frame(table(by, x, y))
  k <- k[k$Freq > 0, ]
  if(nx) k$x <- as.numeric(as.character(k$x))
  if(ny) k$y <- as.numeric(as.character(k$y))
  if(prfreq) print(table(k$Freq))

  if(stick) {
    if(! ny) stop('stick=TRUE only works with numeric y')
    Y <- k$y
    f <- k$Freq
    m <- max(f)
    z <- 1.15 * m / sy
    k$y1 <- Y - f / z / 2
    k$y2 <- Y + f / z / 2
    k$y3 <- ifelse(f == m, NA, Y - m / z / 2)
    k$y4 <- ifelse(f == m, NA, Y - f / z / 2)
    k$y5 <- ifelse(f == m, NA, Y + f / z / 2)
    k$y6 <- ifelse(f == m, NA, Y + m / z / 2)
    w <- ggplot(k, aes(x=x, y=y, label=.data$Freq)) +
      geom_segment(aes(x=x, y=y1, xend=x, yend=y2, color=I('black')), data=k) +
      geom_segment(aes(x=x, y=y3, xend=x, yend=y4, color=I('lightgray')), data=k) +
      geom_segment(aes(x=x, y=y5, xend=x, yend=y6, color=I('lightgray')), data=k) +
      xlab(xlab) + ylab(ylab) +
      labs(caption=paste0('Maximum frequency:', m))
    if(bypres) w <- w + facet_wrap(~ by)
    return(w)
    }

  if(g == 0) {
    w <-  if(nsize)
            ggplot(k, aes(x=x, y=y, size=.data$Freq ^ 0.25, label=.data$Freq)) +
              geom_point(...) +
              scale_size_continuous() +
              xlab(xlab) + ylab(ylab) +
              guides(size = guide_legend(title='Frequency'))
       else
         ggplot(k, aes(x=x, y=y, label=.data$Freq,
                       color=.data$Freq ^ 0.25)) +
                   geom_point(...) +
                   scale_color_gradientn(colors=fcolors) +
                   guides(alpha = FALSE, 
                          color = guide_legend(title='Frequency')) +
           xlab(xlab) + ylab(ylab)
    if(bypres) w <- w + facet_wrap(~ by)
    return(w)
  }
  
  k$fg <- if(length(cuts)) cut2(k$Freq, cuts=cuts) else cut2(k$Freq, g=g)

  ufreq <- sort(unique(k$Freq))
  few <- length(ufreq) <= 15
  brn <- if(few) ufreq else unique(quantile(k$Freq, seq(0, g) / g))
  w <- if(nsize)
         ggplot(k, aes(x=x, y=y, size=.data$Freq ^ 0.25, label=.data$Freq)) +
           geom_point(...) +
           scale_size_continuous(breaks=brn ^ 0.25, labels=round(brn)) +
           xlab(xlab) + ylab(ylab) +
           guides(size = guide_legend(title='Frequency'))
       else
         ggplot(k, aes(x=x, y=y, label=.data$Freq,
                       color=if(few) .data$Freq else as.integer(fg))) + # k$Freq
           geom_point(...) +
           scale_color_gradientn(colors=fcolors,
                                 breaks=if(few) ufreq else 1 : length(levels(k$fg)),
                                 labels=if(few) ufreq else levels(k$fg)) +
           guides(alpha = 'none', 
                  color = guide_legend(title='Frequency')) +
           xlab(xlab) + ylab(ylab)

  if(nx) w <- w + scale_x_continuous(breaks=xtrans(xbreaks),
                                     labels=format(xbreaks),
                                     minor_breaks=if(length(xminor))
                                                    xtrans(xminor))
  if(ny) w <- w + scale_y_continuous(breaks=ytrans(ybreaks),
                                     labels=format(ybreaks),
                                     minor_breaks=if(length(yminor))
                                                    ytrans(yminor))
  if(bypres) w <- w + facet_wrap(~ by)
  w
}

utils::globalVariables(c('fg','y1','y2','y3','y4','y5','y6'))

    subroutine hlqest(x, ran, nn, retval)
      use ISO_FORTRAN_ENV
        implicit none
        integer(int32), intent(in)  :: nn
        real(real64),   intent(in)  :: x(nn)
        real(real64),   intent(in)  :: ran(1000)
        real(real64),   intent(out) :: retval
        
        integer(int64)  :: n, np, sm, l, k1, k2, sq, mdlrow, k, i, j, iran
        real   (real64) :: am, amn, amx
        integer(int64), allocatable :: lb(:), rb(:), q(:)

        n    = nn
        iran = 0

        ! Handle small n
        if (n < 3) then
            retval = (x(1) + x(n)) / 2.0
            return
        endif

        ! Allocate memory for lb, rb, and q
        allocate(lb(n), rb(n), q(n))

        ! Total number of pairs and the median(s) index
        np = n  * (n  + 1) / 2
        k1 = (np + 1) / 2
        k2 = (np + 2) / 2

        ! Initialize lb and rb
        lb = [(i, i=1, n)]       ! Vectorized initialization of lb
        rb = n                   ! Vectorized initialization of rb to n for all elements

        sm = np                ! Total number of pairs
        l  = 0                 ! Number of pairs less than those in set at step m
        am = x((n + 1) / 2) + x((n + 2) / 2)

        ! Main iterative process
        do
            j   = n

            ! Vectorized loop to compute q and sq
            q  = 0
            sq = 0

            do i = 1, n
                do while (j >= i)
                    if (x(i) + x(j) < am) then
                        q(i) = j - i + 1
                        sq = sq + q(i)
                        exit
                    endif
                    j = j - 1
                end do
            end do

            ! Handle case where partitions are the same (ties)
            if (sq == l) then
                amx = x(1) + x(1)
                amn = x(n) + x(n)
                do i = 1, n
                    if (lb(i) > rb(i)) cycle
                    amn = min(amn, x(lb(i)) + x(i))  ! Vectorized min within bounds
                    amx = max(amx, x(rb(i)) + x(i))  ! Vectorized max within bounds
                end do
                am = (amn + amx) / 2.0
                if ((am <= amn) .or. (am > amx)) am = amx
                if ((amn /= amx) .and. (sm /= 2)) cycle
                retval = am / 2.0
                exit
            endif  ! end if(sq == l)

            ! Handle if we're nearly done (values on the border)
            if (sq == k2 - 1 .or. sq == k1) then
              amx = x(1) + x(1)
              amn = x(n) + x(n)
            
                ! Loop over all rows to find max of those < am and min of those >= am, considering q
                do i = 1, n
                    if (q(i) > 0) amx = max(amx, x(i) + x(i + q(i) - 1))
                        ! There are q(i) pairs in row i that satisfy x[i] + x[j] < am
                    if (q(i) < (n - i + 1)) amn = min(amn, x(i) + x(i + q(i)))
                        ! There are (n - i + 1 - q(i)) pairs in row i that satisfy x[i] + x[j] >= am
                end do

                ! Handle case where k1 < k2 (when we need the average of two values)
                if (k1 < k2) then
                    retval = (amn + amx) / 4.0
                else if (sq == k1) then
                  retval = amx / 2.0
                else if (sq == k1 - 1) then
                  retval = amn / 2.0
                else
                  retval = (amn + amx) / 4.0
                end if
                exit
            endif  ! end if(sq == k2 - 1 .or ...)

            ! Update bounds based on the size of sq using vectorization
            if (sq < k1) then
                lb = [(i + q(i), i=1, n)]  ! Vectorized update of left bounds
            else
                rb = [(i + q(i) - 1, i=1, n)]  ! Vectorized update of right bounds
            endif

            ! Recalculate sm and l using vectorized array operations
            l = sum(lb - [(i, i=1, n)])          ! Vectorized summation of lb - i
            sm = sum(rb - lb + 1)                ! Vectorized summation of pairs still in set

            ! If we still have more than 2 pairs, pick a random row and continue
            if (sm > 2) then
                iran = iran + 1
                if(iran > 1000) iran = 1
                k = int(ran(iran) * dble(sm))  
                do i = 1, n
                    j = i
                    if (k <= rb(i) - lb(i)) exit
                    k = k - rb(i) + lb(i) - 1
                end do
                mdlrow = (lb(j) + rb(j)) / 2
                am = x(j) + x(mdlrow)
                cycle
            endif

            amx = x(1) + x(1)     ! ?
            amn = x(n) + x(n)     ! ?
      
            ! Otherwise, finalize and exit
            do i = 1, n
                if (lb(i) > rb(i)) cycle
                amn = min(amn, x(lb(i)) + x(i))
                amx = max(amx, x(rb(i)) + x(i))
            end do
            am = (amx + amn) / 2.0
            if ((am <= amn) .or. (am > amx)) am = amx
            if ((am /= amx .and. sm /= 2))   cycle
            retval = am / 2.0
            exit
        end do

        ! Deallocate memory
        deallocate(lb, rb, q)
        return
    end subroutine hlqest

C Output from Public domain Ratfor, version 1.01
      subroutine wclosest(w, x, lw, lx, j)
      implicit double precision (a-h,o-z)
      integer lw, lx, j(lw)
      double precision w(lw), x(lx)
      do23000 i=1,lw 
      wi=w(i)
      dmin=1d40
      m=0
      do23002 k=1,lx 
      d = dabs(x(k) - wi)
      if(d .lt. dmin)then
      dmin = d
      m = k
      endif
23002 continue
23003 continue
      j(i) = m
23000 continue
23001 continue
      return
      end
      subroutine wclosepw(w, x, r, f, lw, lx, xd, j)
      implicit double precision (a-h,o-z)
      double precision w(lw),x(lx),r(lw),xd(lx)
      integer lw, lx, j(lw)
      do23006 i=1, lw 
      wi = w(i)
      dmean = 0d0
      do23008 k=1, lx 
      xd(k) = dabs(x(k) - wi)
      dmean = dmean + xd(k)
23008 continue
23009 continue
      dmean = f * dmean / lx
      sump = 0d0
      do23010 k=1, lx 
      z = min(xd(k)/dmean, 1d0)
      xd(k) = (1d0 - z**3)**3
      sump = sump + xd(k)
23010 continue
23011 continue
      prob = 0d0
      ri = r(i)
      m = 1
      do23012 k=1, lx 
      prob = prob + xd(k) / sump
      if(ri .gt. prob)then
      m = m + 1
      endif
23012 continue
23013 continue
      j(i) = m
23006 continue
23007 continue
      return
      end

C Output from Public domain Ratfor, version 1.01
      subroutine maxempr(ax, ay, x, y, n, w, h, z, area, rect)
      implicit double precision (a-h,o-z)
      integer n
      double precision ax(2), ay(2), x(n), y(n), z(3), rect(4), maxr, li
      maxr = z(1) * dabs(ay(2) - ay(1))
      rect(1) = z(2)
      rect(2) = ay(1)
      rect(3) = z(3)
      rect(4) = ay(2)
      do23000 i=1,n 
      tl = ax(1)
      tr = ax(2)
      if(i .lt. n)then
      do23004 j=(i+1),n 
      if(x(j) .gt. tl .and. x(j) .lt. tr)then
      area = (tr - tl) * (y(j) - y(i))
      if(area .gt. maxr .and. ((tr - tl) .gt. w) .and. ((y(j) - y(i)) .g
     *t. h))then
      maxr = area
      rect(1) = tl
      rect(2) = y(i)
      rect(3) = tr
      rect(4) = y(j)
      endif
      if(x(j) .gt. x(i))then
      tr = x(j)
      else
      tl = x(j)
      endif
      endif
23004 continue
23005 continue
      endif
      area = (tr - tl) * (ay(2) - y(i))
      if(area .gt. maxr .and. ((tr - tl) .gt. w) .and. ((ay(2) - y(i)) .
     *gt. h))then
      maxr = area
      rect(1) = tl
      rect(2) = y(i)
      rect(3) = tr
      rect(4) = ay(2)
      endif
      ri = ax(2)
      li = ax(1)
      do23014 k=1,n 
      if(y(k) .lt. y(i) .and. x(k) .gt. x(i))then
      ri = dmin1(ri, x(k))
      endif
      if(y(k) .lt. y(i) .and. x(k) .lt. x(i))then
      li = dmax1(li, x(k))
      endif
23014 continue
23015 continue
      area = (ri - li) * (ay(2) - y(i))
      if(area .gt. maxr .and. ((ri - li) .gt. w) .and. ((y(i) - ay(1)) .
     *gt. h))then
      maxr = area
      rect(1) = li
      rect(2) = ay(1)
      rect(3) = ri
      rect(4) = y(i)
      endif
23000 continue
23001 continue
      area = maxr
      return
      end

! Converted from Ratfor to Fortran 2018 by ChatGPT 2024-10-26
! Instruction to ChatGPT:
! Convert the following Ratfor code to Fortran 2018 using Fortran ISO environment without using module, and make the z function strictly internal to the subroutine

subroutine cidxcp(x1, x2, y, e, n, method, outx, nrel, nuncer, c1, c2, gamma1, gamma2, gamma, sd, c12, c21)
    use ISO_FORTRAN_ENV, only: REAL64, INT32
    implicit none
    integer(INT32), intent(in) :: n, method
    real(REAL64), intent(in) :: x1(n), x2(n), y(n)
    logical, intent(in) :: e(n), outx
    real(REAL64), intent(out) :: nrel, nuncer, c1, c2, gamma1, gamma2, gamma, sd, c12, c21
  
    integer(INT32) :: i, j
    real(REAL64) :: nconc1, nconc2, sumr, sumr2, sumw, sumw2, sumrw, sumc
    real(REAL64) :: wi, ri, dx, dx2, dy
  
    ! Initialize accumulation variables
    nconc1 = 0.0_REAL64; nconc2 = 0.0_REAL64; nrel = 0.0_REAL64; nuncer = 0.0_REAL64
    sumr = 0.0_REAL64; sumr2 = 0.0_REAL64; sumw = 0.0_REAL64
    sumw2 = 0.0_REAL64; sumrw = 0.0_REAL64; sumc = 0.0_REAL64
  
    do i = 1, n
      wi = 0.0_REAL64; ri = 0.0_REAL64
      do j = 1, n
        dx = x1(i) - x1(j)
        dx2 = x2(i) - x2(j)
        
        if ((i /= j) .and. (.not. outx .or. dx /= 0.0_REAL64 .or. dx2 /= 0.0_REAL64)) then
          dy = y(i) - y(j)
          
          if ((e(i) .and. (dy < 0.0_REAL64)) .or. (e(i) .and. .not. e(j) .and. (dy == 0.0_REAL64))) then
            nrel = nrel + 1.0_REAL64
            nconc1 = nconc1 + (z(dx < 0.0_REAL64) + 0.5_REAL64 * z(dx == 0.0_REAL64))
            nconc2 = nconc2 + (z(dx2 < 0.0_REAL64) + 0.5_REAL64 * z(dx2 == 0.0_REAL64))
            ri = ri + 1.0_REAL64
            
            if (method == 1) then
              wi = wi + (z(dx < dx2) - z(dx > dx2))
              sumc = sumc + z(dx < dx2)
            else
              wi = wi + (z(dx < 0.0_REAL64 .and. dx2 >= 0.0_REAL64) - z(dx > 0.0_REAL64 .and. dx2 <= 0.0_REAL64))
              sumc = sumc + z(dx < 0.0_REAL64 .and. dx2 >= 0.0_REAL64)
            endif
  
          else if ((e(j) .and. (dy > 0.0_REAL64)) .or. (e(j) .and. .not. e(i) .and. (dy == 0.0_REAL64))) then
            nrel = nrel + 1.0_REAL64
            nconc1 = nconc1 + (z(dx > 0.0_REAL64) + 0.5_REAL64 * z(dx == 0.0_REAL64))
            nconc2 = nconc2 + (z(dx2 > 0.0_REAL64) + 0.5_REAL64 * z(dx2 == 0.0_REAL64))
            ri = ri + 1.0_REAL64
            
            if (method == 1) then
              wi = wi + (z(dx > dx2) - z(dx < dx2))
              sumc = sumc + z(dx > dx2)
            else
              wi = wi + (z(dx > 0.0_REAL64 .and. dx2 <= 0.0_REAL64) - z(dx < 0.0_REAL64 .and. dx2 >= 0.0_REAL64))
              sumc = sumc + z(dx > 0.0_REAL64 .and. dx2 <= 0.0_REAL64)
            endif
  
          else if (.not. (e(i) .and. e(j))) then
            nuncer = nuncer + 1.0_REAL64
          endif
        endif
      end do
      
      sumr = sumr + ri
      sumr2 = sumr2 + ri * ri
      sumw = sumw + wi
      sumw2 = sumw2 + wi * wi
      sumrw = sumrw + ri * wi
    end do
  
    ! Calculate outputs
    c1 = nconc1 / nrel
    gamma1 = 2.0_REAL64 * (c1 - 0.5_REAL64)
    c2 = nconc2 / nrel
    gamma2 = 2.0_REAL64 * (c2 - 0.5_REAL64)
    gamma = sumw / sumr
    sd = 2.0_REAL64 * sqrt(sumr2 * sumw**2 - 2.0_REAL64 * sumr * sumw * sumrw + sumw2 * sumr**2) / sumr / sumr
    c12 = sumc / sumr
    c21 = sumc / sumr - gamma
  
  contains
  
    real(REAL64) function z(a)
      logical, intent(in) :: a
      if (a) then
        z = 1.0_REAL64
      else
        z = 0.0_REAL64
      endif
    end function z
  
  end subroutine cidxcp
  

##' Easy Extraction of Labels/Units Expressions for Plotting
##'
##' Given a single unquoted variable, first looks to see if a non-`NULL` `LabelsUnits` object exists (produced by `extractlabs()`).  When `LabelsUnits` does not exist or is `NULL`, looks up the attributes in the current dataset, which defaults to `d` or may be specified by `options(current_ds='name of the data frame/table')`.  Finally the existence of a variable of the given name in the global environment is checked. When a variable is not found in any of these three sources or has a blank `label` and `units`, an `expression()` with the variable name alone is returned.  If `html=TRUE`, HTML strings are constructed instead, suitable for `plotly` graphics.
##'
##' The result is useful for `xlab` and `ylab` in base plotting functions or in `ggplot2`, along with being useful for `labs` in `ggplot2`.  See example.
##' @title hlab
##' @param x a single variable name, unquoted
##' @param name a single character string providing an alternate way to name `x` that is useful when `hlab` is called from another function such as `hlabs`
##' @param html set to `TRUE` to return HTML strings instead of `plotmath` expressions
##' @param plotmath set to `FALSE` to use plain text instead of plotmath
##' @return an expression created by `labelPlotmath` with `plotmath=TRUE`
##' @author Frank Harrell
##' @seealso [label()], [units()], [contents()], [hlabs()], [extractlabs()], [plotmath]
##' @md
##' @examples
##' d <- data.frame(x=1:10, y=(1:10)/10)
##' d <- upData(d, labels=c(x='X', y='Y'), units=c(x='mmHg'), print=FALSE)
##' hlab(x)
##' hlab(x, html=TRUE)
##' hlab(z)
##' require(ggplot2)
##' ggplot(d, aes(x, y)) + geom_point() + labs(x=hlab(x), y=hlab(y))
##' # Can use xlab(hlab(x)) + ylab(hlab(y)) also
##' # Store names, labels, units for all variables in d in object
##' LabelsUnits <- extractlabs(d)
##' # Remove d; labels/units still found
##' rm(d)
##' hlab(x)
##' # Remove LabelsUnits and use a current dataset named
##' # d2 instead of the default d
##' rm(LabelsUnits)
##' options(current_ds='d2')
hlab <- function(x, name=NULL, html=FALSE, plotmath=TRUE) {
  xname <- if(length(name)) name else as.character(substitute(x))
  ldef  <- labelPlotmath(xname, html=html, plotmath=plotmath)

  lu    <- if(exists('LabelsUnits')) LabelsUnits
  if(length(lu)) {
    if(xname %nin% lu$name) return(ldef)
    lu <- lu[xname][1]
    if(lu$label != '' || lu$units != '')
      return(labelPlotmath(lu$label, lu$units, html=html, plotmath=plotmath))
  }
  
  currds <- getOption('current_ds', 'd')
  if(exists(currds)) {
    d <- get(currds)
    if(xname %in% names(d)) {
      xx <- d[[xname]]
      at <- attributes(xx)
      if(length(c(at$label, at$units)) > 0)
        return(label(xx, plot=plotmath, default=xname, html=html))
    }
  }

  if(exists(xname, envir=parent.frame()))
    label(x, plot=plotmath, default=xname, html=html) else ldef
}

##' Front-end to ggplot2 labs Function
##'
##' Runs `x`, `y`, or both through [hlab()] and passes the constructed labels to the [ggplot2::labs] function to specify x- and y-axis labels specially formatted for units of measurement
##' @title hlabs
##' @param x a single variable name, unquoted
##' @param y a single variable name, unquoted
##' @param html set to `TRUE` to render in html (for `plotly`), otherwise the result is `plotmath` expressions
##' @return result of [ggplot2::labs()]
##' @author Frank Harrell
##' @md
##' @examples
##' # Name the current dataset d, or specify a name with
##' # options(curr_ds='...') or run `extractlabs`, then
##' # ggplot(d, aes(x,y)) + geom_point() + hlabs(x,y)
##' # to specify only the x-axis label use hlabs(x), or to
##' # specify only the y-axis label use hlabs(y=...)
hlabs <- function(x, y, html=FALSE) {
  xname <- as.character(substitute(x))   # results in '' if no x
  yname <- as.character(substitute(y))
  if(yname == '')      labs(x=hlab(x, name=xname, html=html))
  else if(xname == '') labs(y=hlab(y, name=yname, html=html))
  else                 labs(x=hlab(x, name=xname, html=html),
                            y=hlab(y, name=yname, html=html))
}

##' Easily Retrieve Text Form of Labels/Units
##'
##' Uses the same search method as `hlab` returns label and units in a character string with units, if present, in brackets
##' @title vlab
##' @param x a single variable name, unquoted
##' @param name optional character string to use as variable name 
##' @return character string
##' @author Frank Harrell
##' @md
##' @seealso [hlab()]
vlab <- function(x, name=NULL) {
  xname <- if(length(name)) name else as.character(substitute(x))
  hlab(x, name=xname, html=FALSE, plotmath=FALSE)
}


##' Extract Labels and Units From Multiple Datasets
##'
##' For one or more data frames/tables extracts all labels and units and comb ines them over dataset, dropping any variables not having either labels or units defined.  The resulting data table is returned and is used by the `hlab` function if the user stores the result in an objectnamed `LabelsUnits`.  The result is `NULL` if no variable in any dataset has a non-blank `label` or `units`.  Variables found in more than one dataset with duplicate `label` and `units` are consolidated.  A warning message is issued when duplicate variables have conflicting labels or units, and by default, details are printed.  No attempt is made to resolve these conflicts.
##' @title extractlabs 
##' @param ... one ore more data frames or data tables
##' @param print set to `FALSE` to not print details about variables with conflicting attributes
##' @return a data table
##' @author Frank Harrell
##' @md
##' @seealso [label()], [contents()], [units()], [hlab()]
##' @examples
##' d <- data.frame(x=1:10, y=(1:10)/10)
##' d <- upData(d, labels=c(x='X', y='Y'), units=c(x='mmHg'), print=FALSE)
##' d2 <- d
##' units(d2$x) <- 'cm'
##' LabelsUnits <- extractlabs(d, d2)
##' LabelsUnits
extractlabs <- function(..., print=TRUE) {
  dotlist <- list(...)
  labu <- function(d)
    list(name=names(d), label=sapply(d, label), units=sapply(d, units))
  u <- data.table::rbindlist(lapply(dotlist, labu))
  data.table::setkeyv(u, 'name')
  lu <- if(any(u$label != '') || any(u$units != ''))
          u[label != '' | units != '']
  w <- lu[, .(nc=length(unique(paste(label, units, sep='|')))), by=name]
  nconflict <- sum(w$nc > 1)
  if(nconflict) {
    warning(paste(nconflict,
        'variables have conflicting labels/units from different datasets'))
    if(print) {
      cname <- w$name[w$nc > 1]
      cat('Variable names with inconsistent attributes:\n')
      print(lu[name %in% cname])
      cat('\n')
      }
    }
  unique(lu)
  }

utils::globalVariables(c('name', 'LabelsUnits'))

#------------------------------------------------------------------------
#       Compute c-index (c) and Brown-Hollander-Krowar-Goodman-Kruskal-Somer
#       rank correlation (gamma) between X and Y with censoring indicator E
#       Also returns number of relevant, concordant, and uncertain pairs
#       (nrel, nconc, nuncert) and estimated s.d. of gamma (sd) using
#       Quade formula (see SAS PROC MATPAR).  Pairs with tied x are
#       excluded if outx=.TRUE.
#
#       F. Harrell  27Nov90
#                   Modification of SAS Procedure KGKC (1980)
#-------------------------------------------------------------------------
SUBROUTINE cidxcn(x,y,e,n,nrel,nconc,nuncert,c,gamma,sd,outx)
IMPLICIT DOUBLE PRECISION (a-h,o-z)
DOUBLE PRECISION x(n),y(n),dx,dy
LOGICAL e(n),outx
DOUBLE PRECISION nrel,nuncert,nconc
nconc=0d0
nrel=0d0
nuncert=0d0
sumr=0d0
sumr2=0d0
sumw=0d0
sumw2=0d0
sumrw=0d0
do i=1,n                                        {
        wi=0d0
        ri=0d0
        do j=1,n
        if(j^=i)        {
                dx=x(i)-x(j)
                dy=y(i)-y(j)
                if(dx!=0. | !outx)      {
                        if((e(i)&dy<0.)|(e(i)&!e(j)&dy==0.))    {
                                if(dx<0.)       {
                                  nconc=nconc+1d0
                                  wi=wi+1d0     } 
                               else
                                if(dx==0.)nconc=nconc+.5d0 
                               else
                                wi=wi-1d0
                                nrel=nrel+1d0
                                ri=ri+1d0       } 
                       else     
                        if((e(j)&dy>0.)|(e(j)&!e(i)&dy==0.))    {
                                if(dx>0.)       {
                                   nconc=nconc+1d0
                                   wi=wi+1d0    } 
                               else
                                if(dx==0.) nconc=nconc+.5d0 
                               else 
                                   wi=wi-1d0
                                nrel=nrel+1d0
                                ri=ri+1d0               } 
                       else
                        if(!(e(i)&e(j)))nuncert=nuncert+1d0  }
                                                                } 
                sumr=sumr+ri
                sumr2=sumr2+ri*ri
                sumw=sumw+wi
                sumw2=sumw2+wi*wi
                sumrw=sumrw+ri*wi
                                                }
c=nconc/nrel
gamma=2.*(c-.5)
#call dblepr('sumr',4,sumr,1)
#call dblepr('sumw',4,sumw,1)
#call dblepr('sumr2',5,sumr2,1)
#call dblepr('sumw2',5,sumw2,1)
#call dblepr('sumrw',5,sumrw,1)
sd=sumr2*sumw**2-2d0*sumr*sumw*sumrw+sumw2*sumr**2
sd=2.*dsqrt(sd)/sumr/sumr
return
end

C Output from Public domain Ratfor, version 1.01
      subroutine hoeffd(xx, n, p, dmat, aadmat, madmat, npair, x, y, rx,
     * ry, rj)
      implicit double precision (a-h,o-z)
      integer p, npair(p,p)
      double precision xx(n,p), dmat(p,p), aadmat(p,p), madmat(p,p), x(n
     *), y(n), rx(n), ry(n), rj(n), maxad
      do23000 i=1, p 
      np=0
      do23002 k=1, n 
      if(xx(k,i) .lt. 1d49)then
      np = np + 1
      endif
23002 continue
23003 continue
      npair(i,i) = np
      do23006 j=(i+1),p 
      m = 0
      do23008 k=1,n 
      xk = xx(k,i)
      yk = xx(k,j)
      if(xk .lt. 1d49 .and. yk .lt. 1d49)then
      m = m + 1
      x(m) = xk
      y(m) = yk
      endif
23008 continue
23009 continue
      npair(i,j) = m
      if(m .gt. 4)then
      call hoeff(x, y, m, d, aad, maxad, rx, ry, rj)
      dmat(i,j) = d
      aadmat(i,j) = aad
      madmat(i,j) = maxad
      else
      dmat(i,j) = 1d50
      endif
23006 continue
23007 continue
23000 continue
23001 continue
      do23014 i=1,p 
      dmat(i,i) = 1d0/30d0
      do23016 j=(i+1),p 
      dmat(j,i) = dmat(i,j)
      npair(j,i) = npair(i,j)
      aadmat(j,i) = aadmat(i,j)
      madmat(j,i) = madmat(i,j)
23016 continue
23017 continue
23014 continue
23015 continue
      return
      end
      subroutine hoeff(x, y, n, d, aad, maxad, rx, ry, rj)
      implicit double precision (a-h,o-z)
      double precision x(n), y(n), rx(n), ry(n), rj(n), maxad
      call jrank(x, y, n, rx, ry, rj)
      q = 0d0
      r = 0d0
      s = 0d0
      aad = 0d0
      maxad = 0d0
      z = n
      do23018 i=1,n 
      rxi = rx(i)
      ryi = ry(i)
      rji = rj(i)
      ad = dabs((rji/z) - (rxi/z)*(ryi/z))
      aad = aad + ad
      maxad = dmax1(maxad, ad)
      q = q + (rxi-1d0)*(rxi-2d0)*(ryi-1d0)*(ryi-2d0)
      r = r + (rxi-2d0)*(ryi-2d0)*(rji-1d0)
      s = s + (rji-1d0)*(rji-2d0)
23018 continue
23019 continue
      aad = aad / z
      d = (q-2d0*(z-2d0)*r+(z-2d0)*(z-3d0)*s)/z/(z-1d0)/(z-2d0)/(z-3d0)/
     *(z-4d0)
      return
      end
      subroutine jrank(x, y, n, rx, ry, r)
      integer n
      double precision x(n), y(n), rx(n), ry(n), r(n), cx, cy, ri, rix, 
     *riy, xi, yi
      do23020 i=1,n 
      xi = x(i)
      yi = y(i)
      ri = 1d0
      rix = 1d0
      riy = 1d0
      do23022 j=1,n 
      if(i .ne. j)then
      cx = 0d0
      if(x(j) .lt. xi)then
      cx = 1d0
      endif
      if(x(j) .eq. xi)then
      cx = .5d0
      endif
      cy = 0d0
      if(y(j) .lt. yi)then
      cy = 1d0
      endif
      if(y(j) .eq. yi)then
      cy = .5d0
      endif
      rix = rix + cx
      riy = riy + cy
      ri = ri + cx*cy
      endif
23022 continue
23023 continue
      rx(i) = rix
      ry(i) = riy
      r(i) = ri
23020 continue
23021 continue
      return
      end

require(Hmisc)
require(survival)
yrs <- runif(30, 0, 10)
ev  <- sample(0:1, 30, TRUE)
w <- bootkm(Surv(yrs, ev), times=5)
describe(w)
quantile(w, c(.025, .975))

# Try with only 2 events
ev <- c(1, 1, rep(0, 28))
w <- bootkm(Surv(yrs, ev), times=5)
describe(w)
quantile(w, c(.025, .975))

require(Hmisc)
require(survival)
n <- 100
set.seed(1)
d <- data.frame(sbp=rnorm(n, 120, 10),
                dbp=rnorm(n, 80, 10),
                age=rnorm(n, 50, 10),
                days=sample(1:n, n, TRUE),
                S1=Surv(2*runif(n)), S2=Surv(runif(n)),
                race=sample(c('Asian', 'Black/AA', 'White'), n, TRUE),
                sex=sample(c('Female', 'Male'), n, TRUE),
                treat=sample(c('A', 'B'), n, TRUE),
                region=sample(c('North America','Europe'), n, TRUE),
                meda=sample(0:1, n, TRUE), medb=sample(0:1, n, TRUE))

d <- upData(d, labels=c(sbp='Systolic BP', dbp='Diastolic BP',
                 race='Race', sex='Sex', treat='Treatment',
                 days='Time Since Randomization',
                 S1='Hospitalization', S2='Re-Operation',
                 meda='Medication A', medb='Medication B'),
            units=c(sbp='mmHg', dbp='mmHg', age='years', days='days'))

Png <- function(z) png(paste('/tmp/summaryS', z, '.png', sep=''))
Png(1)
s <- summaryS(age + sbp + dbp ~ days + region + treat,  data=d)
# d2 <- subset(d, region=='Europe')
# par(mfrow=c(2,1))
# with(d2, plot(days, dbp, col=as.integer(treat)))
# ss <- subset(s, region=='Europe' & yvar == 'dbp')
# dim(ss)
# with(ss, plot(days, y, col=as.integer(treat)))

# plot(s)   # 3 pages
plot(s, groups='treat')

Png(1)
plot(s, groups='treat', datadensity=TRUE,
     scat1d.opts=list(lwd=.5, nhistSpike=0))
dev.off()
Png(2)
require(lattice)
plot(s, groups='treat', panel=panel.loess,
     key=list(space='bottom', columns=2),
     datadensity=TRUE, scat1d.opts=list(lwd=.5))
dev.off()
# Show both points and smooth curves:
Png(3)
plot(s, groups='treat',
     panel=function(...) {panel.xyplot(...); panel.loess(...)})
dev.off()
plot(s, y ~ days | yvar * region, groups='treat')

# Make your own plot using data frame created by summaryP
xyplot(y ~ days | yvar * region, groups=treat, data=s,
       scales=list(y='free', rot=0))

# Use loess to estimate the probability of two different types of events as
# a function of time
s <- summaryS(meda + medb ~ days + treat + region, data=d)
pan <- function(...)
  panel.plsmo(..., type='l', label.curves=max(which.packet()) == 1,
              datadensity=TRUE)
Png(4)
plot(s, groups='treat', panel=pan, paneldoesgroups=TRUE,
     scat1d.opts=list(lwd=.7), cex.strip=.8)
dev.off()

# Demonstrate dot charts of summary statistics
s <- summaryS(age + sbp + dbp ~ region + treat, data=d, fun=mean)
plot(s)
Png(5)
plot(s, groups='treat', funlabel=expression(bar(X)))
dev.off()

# Compute parametric confidence limits for mean, and include sample sizes
f <- function(x) {
  x <- x[! is.na(x)]
  c(smean.cl.normal(x, na.rm=FALSE), n=length(x))
}
s <- summaryS(age + sbp + dbp ~ region + treat, data=d, fun=f)
# Draw [ ] for lower and upper confidence limits in addition to thick line
Png(6)
plot(s, funlabel=expression(bar(X) %+-% t[0.975] %*% s),
     pch.stats=c(Lower=91, Upper=93))  # type show.pch() to see defs.
dev.off()
Png(7)
plot(s, textonly='n', textplot='Mean', digits=1)
dev.off()

# Customize printing of statistics to use X bar symbol and smaller
# font for n=...
cust <- function(y) {
  means <- format(round(y[, 'Mean'], 1))
  ns    <- format(y[, 'n'])
  simplyformatted <- paste('X=', means, ' n=', ns, '  ', sep='')
  s <- NULL
  for(i in 1:length(ns)) {
    w <- paste('paste(bar(X)==', means[i], ',~~scriptstyle(n==', ns[i],
               '))', sep='')
    s <- c(s, parse(text=w))
  }
  list(result=s,
       longest=simplyformatted[which.max(nchar(simplyformatted))])
}
Png(8)
plot(s, groups='treat', cex.values=.65,
     textplot='Mean', custom=cust,
     key=list(space='bottom', columns=2,
       text=c('Treatment A:','Treatment B:')))
dev.off()

## Stratifying by region and treat fit an exponential distribution to
## S1 and S2 and estimate the probability of an event within 0.5 years

f <- function(y) {
  hazard <- sum(y[,2]) / sum(y[,1])
  1. - exp(- hazard * 0.5)
}

s <- summaryS(S1 + S2 ~ region + treat, data=d, fun=f)
plot(s, groups='treat', funlabel='Prob[Event Within 6m]', xlim=c(.3, .7))


## Demonstrate simultaneous use of fun and panel
## First show the same quantile intervals used in panel.bppplot by
## default, stratified by region and day

d <- upData(d, days=round(days / 30) * 30)
g <- function(y) {
  probs <- c(0.05, 0.125, 0.25, 0.375)
  probs <- sort(c(probs, 1 - probs))
  y <- y[! is.na(y)]
  w <- hdquantile(y, probs)
  m <- hdquantile(y, 0.5, se=TRUE)
  se <- as.numeric(attr(m, 'se'))
  c(Median=as.numeric(m), w, se=se, n=length(y))
}
s <- summaryS(sbp + dbp ~ days + region, fun=g, data=d)
Png(9)
plot(s, groups='region', panel=mbarclPanel, paneldoesgroups=TRUE)
dev.off()

# Similar but use half-violin plots
s <- summaryS(sbp + dbp ~ days + region, data=d)
Png('9v')
plot(s, groups='region', panel=medvPanel, paneldoesgroups=TRUE)
dev.off()

## Show Wilson confidence intervals for proportions, and confidence
## intervals for difference in two proportions
g <- function(y) {
  y <- y[!is.na(y)]
  n <- length(y)
  p <- mean(y)
  se <- sqrt(p * (1. - p) / n)
  structure(c(binconf(sum(y), n), se=se, n=n),
            names=c('Proportion', 'Lower', 'Upper', 'se', 'n'))
}
s <- summaryS(meda + medb ~ days + region, fun=g, data=d)
Png(10)
plot(s, groups='region', panel=mbarclPanel, paneldoesgroups=TRUE)
dev.off()

##' Find File With Latest Modification Time
##'
##' Subject to matching on `pattern` finds the last modified file, and if `verbose` is `TRUE` reports on how many total files matched `pattern`.
##' @title latestFile
##' @param pattern a regular expression; see [base::list.files()]
##' @param path full path, defaulting to current working directory
##' @param verbose set to `FALSE` to not report on total number of matching files
##' @return the name of the last modified file
##' @author Frank Harrell
##' @seealso [base::list.files()]
##' @md
latestFile <- function(pattern, path='.', verbose=TRUE) {
  f <- list.files(path=path, pattern=pattern)
  if(length(f) == 1) return(f)
  if(length(f) == 0) {
    warning(paste('no files matching', pattern, 'were found'))
    return(character(0))
  }

  i <- file.info(f, extra_cols=FALSE)
  mtime <- i$mtime
  j <- order(mtime, decreasing=TRUE)[1]
  if(verbose) cat('\nLast modified file: ', f[j],
                  '  (of ', length(f), ' files)\n\n', sep='')
  f[j]
}

#' Pseudomedian
#' 
#' Uses fast Fortran code to compute the pseudomedian of a numeric vector.  The pseudomedian is the median of all possible midpoints of two observations.  The pseudomedian is also called the Hodges-Lehmann one-sample estimator.  The Fortran code is was originally from JF Monahan, and was converted to C++ in the `DescTools` package.  It has been converted to Fortran 2018 here.  Bootstrap confidence intervals are optionally computed.
#' 
#' If n > 250,000 a random sample of 250,000 values of `x` is used to limit execution time.  For n > 1,000 only the percentile bootstrap confidence interval is computed.
#' 
#' Bootstrapping uses the Fortran subroutine directly, for efficiency.
#' 
#' @title pMedian
#' @param x a numeric vector
#' @param na.rm set to `TRUE` to exclude `NA`s before computing the pseudomedian
#' @param conf.int confidence level, defaulting to 0 so that no confidence limits are computed.  Set to a number between 0 and 1 to compute bootstrap confidence limits
#' @param B number of bootstrap samples if `conf.int > 0`
#' @param type type of bootstrap interval, defaulting to `'percentile'` for n >= 150 or `'bca'` for n < 150
#
#' @return a scalar numeric value if `conf.int = 0`, or a 3-vector otherwise, with named elements `estimate, lower, upper` and attribute `type`.  If the number of non-missing values is less than 5, `NA` is returned for both lower and upper limits.
#' @export
#' @md
#' @seealso <https://dl.acm.org/toc/toms/1984/10/3/>, <https://www4.stat.ncsu.edu/~monahan/jul10/>, <https://www.fharrell.com/post/aci/>
#' @examples
#' x <- c(1:4, 10000)
#' pMedian(x)
#' pMedian(x, conf.int=0.95)
#' # Compare with brute force calculation and with wilcox.test
#' w <- outer(x, x, '+')
#' median(w[lower.tri(w, diag=TRUE)]) / 2
#' wilcox.test(x, conf.int=TRUE)

pMedian <- function(x, na.rm = FALSE, conf.int=0, B=1000, type=c('percentile', 'bca')) {
  mtype <- missing(type)
  type  <- match.arg(type)
  if(na.rm) x <- x[! is.na(x)]
  n <- length(x)
  g <- function(z) if(conf.int == 0) z else c(estimate=z, lower=NA_real_, upper=NA_real_)
  if(n == 0) return(g(NA_real_))
  if(n == 1) return(g(as.double(x)))
  if(! na.rm && anyNA(x)) return(g(NA_real_))
  nmax <- 250000L
  if(n > nmax) {
    n <- nmax
    x <- sample(x, nmax)
    warning('n > 250000; pMedian is using a random sample of 250000 values')
  }
  w   <- as.double(runif(1000))
  n   <- as.integer(n)
  res <- .Fortran(F_hlqest, as.double(sort(x)), w, n,
                  result=double(1))$result
  if(conf.int == 0) return(res)
  if(n < 5) return(c(estimate=res, lower=NA, upper=NA))
  if(! requireNamespace('boot', quietly=TRUE))
    stop('conf.int > 0 requires the boot package to be installed')
  comp <- function(x, i)
    .Fortran(F_hlqest, as.double(sort(x[i])), w, n,
                  result=double(1))$result
  b  <- boot::boot(x, statistic=comp, R=B)
  if(mtype) type <- if(n >= 150) 'percentile' else 'bca'
  if(type == 'bca' && n > 1000) {
    warning('type="bca" is too slow for n > 1000; reverting to percentile method')
    type <- 'percentile'
  }
  cl <- boot::boot.ci(b, type=if(type == 'percentile') 'perc' else 'bca',
                      conf=conf.int)[[if(type == 'percentile') 'percent' else 'bca']]
  l <- length(cl)
  res <- c(estimate=res, lower=cl[l - 1], upper=cl[l])
  attr(res, 'type') <- type
  res
}

#' Summarize Strength of Relationships Using R-Squared From Linear Regression
#'
#' Function to use `leaps::regsubsets()` to briefly describe which variables more strongly predict another variable.  Variables are in a numeric matrix and are assumed to be transformed so that relationships are linear (e.g., using `redun()` or `transcan()`.)
#' 
#' @title r2describe
#' @param x numeric matrix with 2 or more columns
#' @param nvmax maxmum number of columns of x to use in predicting a given column
#'
#' @return nothing
#' @export
#' @md
#' @author Frank Harrell
#'
#' @examples
#' \dontrun{
#' r <- redun(...)
#' r2describe(r$scores)
#' }
r2describe <- function(x, nvmax=10) {
    if(! requireNamespace('leaps', quietly=TRUE))
    stop('You must install the leaps package to use r2describe')
   
   if(! is.numeric(x) || ! is.matrix(x)) 
    stop('x must be a numeric matrix')
    if(ncol(x) < 2) stop('x must have at least 2 columns')

    p <- ncol(x)
    nam <- colnames(x)

    cat('\nStrongest Predictors of Each Variable With Cumulative R^2\n')
 
    for(k in 1 : p) {
      fchar <- capture.output(  # don't allow regular output
        f <- leaps::regsubsets(x[, -k], x[, k], method='forward',
                               nbest=1, nvmax=min(p - 1, nvmax)))
      s <- summary(f)
      w <- s$which[, -1, drop=FALSE]   # omit intercept
      xnm <- colnames(w)
      xadded <- character(0)
      for(l in 1 : nrow(w)) {
        varnow <- xnm[w[l,]]
        varnew <- setdiff(varnow, xadded)
        xadded <- c(xadded, varnew)
        }
      rsq <- structure(s$rsq, names=xadded)
      l <- which(rsq >= 0.985)
      if(length(l)) rsq <- rsq[1 : min(l)]
      cat('\n', nam[k], '\n', sep='')
      fw <- character(0)
      xadded <- names(rsq)
      for(l in 1 : length(rsq))
        fw <- paste0(fw, if(l > 1) ' + ', xadded[l],
                         ' (', round(rsq[l], 3), ')')
    cat(strwrap(fw), sep='\n')
    }
    invisible()
}

# Given w, an n-1 by k matrix of weights, say for linear statistics,
# computes all n leave-out-one linear statistics separately by each
# column of w for the data n-vector x

subroutine jacklins(x, w, n, k, res)
INTEGER n, k, l
DOUBLE PRECISION x(n), w(n-1,k), res(n,k), sj

do l = 1, k {
  do j = 1, n {
    sj = 0d0
    do i = 1, n {
      if(i < j) sj = sj + w(i,l) * x(i)
      if(i > j) sj = sj + w(i-1,l) * x(i)
    }
    res(j,l) = sj
  }
}
return
end

##' Data from The Analysis of Biological Data by Shitlock and Schluter
##'
##' Fetches csv files for exercises in the book
##' @title getabd
##' @param name name of dataset to fetch.  Omit to get a data table listing all available datasets.
##' @param lowernames set to `TRUE` to change variable names to lower case
##' @param allow set to `NULL` to convert underscores in variable names to periods
##' @return data frame with attributes `label` and `url`
##' @author Frank Harrell
##' @md
##' @export
getabd <- function(name='', lowernames=FALSE, allow='_') {
# Source: https://biostat.app.vumc.org/MsciBiostatIIDatasets
  
abd <- read.csv(textConnection('
x1|name|label|url|x2
|02-e-2a|Deaths from tigers|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02e2aDeathsFromTigers.csv|
|02-e-2b|Desert bird abundance|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02e2bDesertBirdAbundance.csv|
|02-e-3a|Bird malaria|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02e3aBirdMalaria.csv|
|02-e-3b|Guppy father and son comparison|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02e3bGuppyFatherSonAttractiveness.csv|
|02-e-3c|Human hemoglobin and elevation|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02e3cHumanHemoglobinElevation.csv|
|02-e-4a|Measles outbreaks|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02e4aMeaslesOutbreaks.csv|
|02-q-05|Fish fry survival|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02q05FrySurvival.csv|
|02-q-06|Endangered species|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02q06EndangeredSpecies.csv|
|02-q-07|Famine and schizophrenia|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02q07FamineSchizophrenia.csv|
|02-q-12|Convictions and income|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02q12ConvictionsAndIncome.csv|
|02-q-17|Anemone personality|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02q17AnemonePersonality.csv|
|02-q-19|Firefly spermatophore mass|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02q19FireflySpermatophoreMass.csv|
|02-q-22|Criminal convictions|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02q22CriminalConvictions.csv|
|02-q-26|Neotropical tree photosynthesis|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02q26NeotropicalTreePhotosynthesis.csv|
|02-q-28|Sneakers and cannibalism|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02q28SneakerCannibalism.csv|
|02-q-32|Toxoplasma and accidents|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02q32ToxoplasmaAccidents.csv|
|02-q-33|ADHD and birth month|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02q33BirthMonthADHD.csv|
|02-q-35|Food intake and lifespan|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02q35FoodReductionLifespan.csv|
|02-q-37|Number of hurricanes|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02q37Hurricanes.csv|
|03-e-1|Gliding snakes|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter03/chap03e1GlidingSnakes.csv|
|03-t-1|Criminal convictions|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter02/chap02q12and22CriminalConvictions.csv|
|03-e-2|Amputated spiders|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter03/chap03e2SpiderAmputation.csv|
|03-e-3|Stickleback lateral plates|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter03/chap03e3SticklebackPlates.csv|
|03-q-01|Systolic blood pressure|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter03/chap03q01SystolicBP.csv|
|03-q-02|Systolic blood pressure, larger sample|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter03/chap03q02SystolicBP.csv|
|03-q-04|Kenya finches|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter03/chap03q04KenyaFinches.csv|
|03-q-09|Rigor mortis|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter03/chap03q09Rigormortis.csv|
|03-q-14|Vasopressin voles|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter03/chap03q14VasopressinVoles.csv|
|03-q-15|Diet breadth El Verde|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter03/chap03q15DietBreadthElVerde.csv|
|03-q-19|Sparrow reprodution|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter03/chap03q19SparrowReproductiveSuccess.csv|
|03-q-21|Yeast mutant growth rate|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter03/chap03q21YeastMutantGrowth.csv|
|03-q-22|Zebra fish boldness|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter03/chap03q22ZebraFishBoldness.csv|
|03-q-28|Sea urchin bindin|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter03/chap03q28SeaUrchinBindin.csv|
|04-e-1|Human gene lengths|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter04/chap04e1HumanGeneLengths.csv|
|04-q-07|Firefly flashes|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter04/chap04q07FireflyFlash.csv|
|04-q-09|Gene regulatory networks|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter04/chap04q09NumberGenesRegulated.csv|
|04-q-18|Corpseflowers|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter04/chap04q18Corpseflowers.csv|
|07-e-2|Sex and the X chromosome|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07e2SexAndX.csv|
|07-e-3|Sex of Radiologists offspring|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07e3RadiologistOffspringSex.csv|
|07-q-2|Which ear for questions|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q2QuestionEar.csv|
|07-q-03|Honesty wallets|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q03LostWallets.csv|
|07-q-04|John Wayne|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q04GenghisKhanCancer.csv|
|07-q-05|Cocaine on dollars|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q05CocaineDollars.csv|
|07-q-07|Eyelash mites|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q07FollicleMites.csv|
|07-q-08|Garden spider cannibalism|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q08GardenSpiderCannibalism.csv|
|07-q-09|Range shifts with climate change|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q09ClimateRangeShifts.csv|
|07-q-11|Mouse fetal testosterone|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q11FetalTestosterone.csv|
|07-q-14|Christmas deaths|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q14WaitingForChristmas.csv|
|07-q-15|Plant chemical defenses|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q15Latex.csv|
|07-q-16|Heroin on dollars|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q16HeroinDollars.csv|
|07-q-18|Selective looking|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q18SelectiveLooking.csv|
|07-q-19|Food injuries|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q19CutsFromFood.csv|
|07-q-20|Finding love through pets|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q20LoveThroughPets.csv|
|07-q-23|Butter side down|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q23ButterSideDown.csv|
|07-q-23|Surgical site infections|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q23SurgicalSiteInfections.csv|
|07-q-25|Helping at the nest|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q25HelpingAtNest.csv|
|07-q-26|Dog food pate |http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q26DogFoodPate.csv|
|07-q-27|Moods and seasons|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q27SuicideSeason.csv|
|07-q-28|Road kill|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q28RoadKill.csv|
|07-q-30|Catfish hunting pigeons|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter07/chap07q30CatfishHunting.csv|
|08-e-1|Days of birth|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08e1DayOfBirth.csv|
|08-e-4|Gene content of chromosomes|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08e4XGeneContent.csv|
|08-e-5|Number of boys in two-child families|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08e5NumberOfBoys.csv|
|08-e-6|Mass extinctions|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08e6MassExtinctions.csv|
|08-q-1|Testing spatial computer program|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08q1testingComputerProgram.csv|
|08-q-02|Shad parasites|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08q02ShadParasites.csv|
|08-q-03|Resistance to bacteria|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08q03F2Resistance.csv|
|08-q-05|World Cup|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08q05WorldCup.csv|
|08-q-6|Coin flipping|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08q6CoinFlipping.csv|
|08-q-12|Spirit bear genetics|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08q12SpiritBearGenetics.csv|
|08-q-14|Bird window crashes|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08q14BirdWindowCrash.csv|
|08-q-14|Cavalry|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08q14Cavalry.csv|
|08-q-16|Hospital weekend or weekday|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08q16HospitalAdmission.csv|
|08-q-16|Truffles|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08q16Truffles.csv|
|08-q-18|Anemonefish sexes|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08q18AnemonefishSexes.csv|
|08-q-19|Hurricanes|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08q19Hurricanes.csv|
|08-q-21|Falling cats|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08q21FallingCatsByMonth.csv|
|08-q-24|Dodder growth orientation|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08q24DodderGrowth.csv|
|08-q-25|Dodder and &#945;-pinene|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter08/chap08q25DodderWithPinene.csv|
|09-e-2|Aspirin vs. cancer|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09e2AspirinCancer.csv|
|09-e-3|Toxoplasmosis|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09e3ToxoplasmaAndAccidents.csv|
|09-e-3|Parasite control of behavior|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09e3ParasiteBrainWarp.csv|
|09-e-4|Vampire bats and estrous|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09e4VampireBites.csv|
|09-q-01|Coffee and cancer|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q01CoffeeAndCancer.csv|
|09-q-02|Divorce after diagnosis|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q02DiseaseAndDivorce.csv|
|09-q-04|Pigeon rumps|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q04PigeonRumps.csv|
|09-q-05|Malaria transmission|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q05MalariaAndMosquitoFeeding.csv|
|09-q-06|Redback spider sexual cannibalism|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q06RedbackSpiderCannibalism.csv|
|09-q-07|Reed frogs and fire|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q07FrogsFire.csv|
|09-q-08|Fish sex change|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q08FishSexChange.csv|
|09-q-09|TV violence|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q09TVAndAggression.csv|
|09-q-10|Drinking and heart disease|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q10AlcoholHeartAttacks.csv|
|09-q-11|Postnatal depression|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q11PostnatalDepression.csv|
|09-q-12|Migraines with auras|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q12MigraineShunts.csv|
|09-q-14|Mediterranean diet|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q14MedDiet.csv|
|09-q-16|Prairie dog multiple mating|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q16PrairieDogMultipleMating.csv|
|09-q-17|Intuition about lying|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q17LyingIntuition.csv|
|09-q-19|Contagious yawning|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q19Yawning.csv|
|09-q-20|Daycare and leukemia|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q20ALLDaycare.csv|
|09-q-21|Blue termites|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q21BlueTermites.csv|
|09-q-22|Self recognition|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q22SelfRecognition.csv|
|09-q-24|Heat and sterility|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q24HeatSterility.csv|
|09-q-26|Just because|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q26Because.csv|
|09-q-27|Bereavement and health|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q27WidowHealth.csv|
|09-q-29|Denomination effect|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q29Denomination.csv|
|09-q-30|Firearms and suicide|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q30FirearmsSuicide.csv|
|09-q-31|Nectar spurs|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q31NectarSpurs.csv|
|09-q-33|Kuru|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter09/chap09q33Kuru.csv|
|10-e-6|Deaths from Spanish flu 1918|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter10/chap10e6DeathsSpanishFlu1918.csv|
|10-q-17|Tree growth rate|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter10/chap10q17TreeGrowthRate.csv|
|10-q-19|Health expenditures|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter10/chap10q19HealthExpenditures.csv|
|11-e-2|Stalk-eyed flies|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter11/chap11e2Stalkies.csv|
|11-e-3|Human body temperature|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter11/chap11e3Temperature.csv|
|11-q-01|Range shifts with climate change|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter11/chap11q01RangeShiftsWithClimateChange.csv|
|11-q-06|Wolf jaws|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter11/chap11q06WolfTeeth.csv|
|11-q-13|Syrup swimming|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter11/chap11q13SyrupSwimming.csv|
|11-q-16|Dolphins clockwise|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter11/chap11q16DolphinsClockwise.csv|
|11-q-17|Koala bellows|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter11/chap11q17KoalaBellows.csv|
|11-q-18|Stickleback preferences|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter11/chap11q18SticklebackPreference.csv|
|11-q-21|Hurricanes and soil lead|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter11/chap11q21SoilLeadAndHurricanes.csv|
|11-q-22|Hurricanes and blood lead|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter11/chap11q22BloodLeadKatrina.csv|
|11-q-24|Walking in circles|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter11/chap11q24WalkingInCircles.csv|
|11-q-25|Sloth inner ears|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter11/chap11q25SlothEars.csv|
|12-e-2|Blackbird testosterone|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12e2BlackbirdTestosterone.csv|
|12-e-3|Horned lizards|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12e3HornedLizards.csv|
|12-e-4|Brook trout vs. salmon|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12e4ChinookWithBrookTrout.csv|
|12-q-01|Death and taxes|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12q01DeathAndTaxes.csv|
|12-q-6|Testes size|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12q6TestesSize.csv|
|12-q-09|Cichlids|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12q09Cichlids.csv|
|12-q-10|"Will"s and presidents|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12q10WillsPresidents.csv|
|12-q-12|Ostrich temperatures|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12q12OstrichTemp.csv|
|12-q-14|Iguanas|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12q14Iguanas.csv|
|12-q-16|Mosquitoes and beer|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12q16BeerAndMosquitoes.csv|
|12-q-17|HIV immunity|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12q17HIVAntibody.csv|
|12-q-18|Stalkie eyesmall|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12q18StalkieEyespan.csv|
|12-q-20|Electric fish|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12q20ElectricFish.csv|
|12-q-24|Weddell seal dives|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12q24WeddellSeals.csv|
|12-q-26|Hyena giggles|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12q26HyenaGiggles.csv|
|12-q-31|Rat reciprocity|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12q31RatReciprocity.csv|
|12-q-32|Glassware|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12q32BeerGlassShape.csv|
|12-q-33|Spinocerebellar ataxia |http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter12/chap12q33SpinocerebellarAtaxia.csv|
|13-e-1|Marine reserves|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13e1MarineReserve.csv|
|13-e-4|Sexual Conflict|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13e4SexualConflict.csv|
|13-e-5|Sagebrush crickets|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13e5SagebrushCrickets.csv|
|13-q-01|Country Health Expenditure|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q01CountryHealthExpenditure.csv|
|13-q-02|Goldeneye parasitism|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q02GoldeneyeParasitism.csv|
|13-q-03|Recycling|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q03Recycling.csv|
|13-q-07|Senicio seed set |http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q07SeedSet.csv|
|13-q-08|Lion infanticide|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q08Lions.csv|
|13-q-09|Newts|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q09Newts.csv|
|13-q-13|Worm sperm|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q13WormSperm.csv|
|13-q-14|Dioecy|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q14Dioecy.csv|
|13-q-15|Mosquitoes|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q15Mosquitoes.csv|
|13-q-16|Beetles and angiosperms|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q16BeetleAngiosperms.csv|
|13-q-18|Zebra finches|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q18ZebraFinches.csv|
|13-q-19|Sports vs. Biology, Sex partners|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q19SportsVsBiology.csv|
|13-q-20|Salmon color|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q20SalmonColor.csv|
|13-q-21|Stress and incompatible mates|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q21StressAndIncompatibleMates.csv|
|13-q-25| Clearcuts|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q25Clearcuts.csv|
|13-q-26| Zebra finch beaks|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q26ZebraFinchBeaks.csv|
|13-q-27|Vuvuzela|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q27Vuvuzela.csv|
|19-q-28|Pseudoscorpions|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap19q28Pseudoscorpions.csv|
|13-q-29|Army ants and silverfish|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q29ArmyAntSilverfish.csv|
|13-q-30|Wolbachia, mosquitoes, and dengue|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q30WolbachiaAndDengue.csv|
|13-q-32|Gut flora and autoimmune disease|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter13/chap13q32GutFloraAutoimmune.csv|
|15-e-1|Knees who say night|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15e1KneesWhoSayNight.csv|
|15-e-6|Walking sticks|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15e6WalkingStickFemurs.csv|
|15-q-01|Caffeine and nectar|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q01HoneybeeCaffeine.csv|
|15-q-03|Exam repeatability|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q03ExamGrades.csv|
|15-q-04|Plant population persistence|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q04PlantPopulationPersistence.csv|
|15-q-08|Disorders|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q08DisordersAndGeneExpression.csv|
|15-q-11|Dung beetles|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q11DungBeetleCondition.csv|
|15-q-13|Ricketsiella and aphid Color|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q13RicketsiellaColor.csv|
|15-q-14|Tsetse learning|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q14TsetseLearning.csv|
|15-q-15|Eelgrass|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q15EelgrassGenotypes.csv|
|15-q-17|Daphnia resistance|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q17DaphniaResistance.csv|
|15-q-20|Nemotode lifespan|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q20NematodeLifespan.csv|
|15-q-22|Walking stick heads|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q22WalkingStickHeads.csv|
|15-q-23|Lodgepole pine cones|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q23LodgepolePineCones.csv|
|15-q-24|Lupus mice|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q24LupusProneMice.csv|
|15-q-25|Lizard sprint speed|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q25LizardSprintSpeed.csv|
|15-q-26|Mosquito poisoning|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q26MalariaFungusVenom.csv|
|15-q-27|Meaningless math|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q27NonsenseMathEffect.csv|
|15-q-28|Fly self-medication|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q28FlySelfMedication.csv|
|15-q-30|Fiddler crab claw-fans|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q30FiddlerCrabFans.csv|
|15-q-32|Hippocampal volume loss|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter15/chap15q32HippocampalVolumeRatio.csv|
|16-e-1|Flipping birds|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16e1FlippingBird.csv|
|16-e-2|Wolf inbreeding|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16e2InbreedingWolves.csv|
|16-e-5|Indian rope trick|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16e5IndianRopeTrick.csv|
|16-q-01|Hyena age|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q01Hyena%20GigglesAndAge.csv|
|16-q-03|TB resistance|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q03TBResistance.csv|
|16-q-05|Godwits|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q05GodwitArrivalDates.csv|
|16-q-10|Earwig forceps|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q10EarwigForceps.csv|
|16-q-12|Cricket immunity|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q12CricketImmunitySpermViability.csv|
|16-q-13|Lefthandedness and violence|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q13LefthandednessAndViolence.csv|
|16-q-14|Telomeres and stress|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q14TelomeresAndStress.csv|
|16-q-15|Language and grey matter|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q15LanguageGreyMatter.csv|
|16-q-16|Green space|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q16GreenSpaceBiodiversity.csv|
|16-q-18|Salmon and salmonberries|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q18SalmonSalmonberries.csv|
|16-q-19|Liver preparation|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q19LiverPreparation.csv|
|16-q-20|Sleep and performance|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q20SleepAndPerformance.csv|
|16-q-22|Trillium|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q22TrilliumRecruitment.csv|
|16-q-23|Cocaine|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q23CocaineHigh.csv|
|16-q-24|Extrovertism and neuroticism|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q24ExtroversionNeuroticism.csv|
|16-q-26|Chocolate and Nobel Prizes|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q26ChocolateAndNobel.csv|
|16-q-27|Antibody tumor screening|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter16/chap16q27AntibodyTumorScreening.csv|
|17-e-1|Lion ages|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17e1LionNoses.csv|
|17-e-3|Plant species and biomass|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17e3PlantDiversityAndStability.csv|
|17-e-8|Shrinking seals|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17e8ShrinkingSeals.csv|
|17-f-5_2|Junco outlier|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17f5_2JuncoOutlier.csv|
|17-f-5_3|Desert pool fish species|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17f5_3DesertPoolFish.csv|
|17-f-5_4|Cap color|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17f5_4BlueTitCapColor.csv|
|17-f-5_4|Cockroach neurons|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17f5_4CockroachNeurons.csv|
|17-f-6_3|Iris pollen|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17f6_3IrisPollination.csv|
|17-f-8_1|Iron and plankton growth|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17f8_1IronAndPhytoplanktonGrowth.csv|
|17-f-8_2|Plant species and productivity|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17f8_2PondPlantsAndProductivity.csv|
|17-f-9_1|Guppy temperature mortality|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17f9_1GuppyColdDeath.csv|
|17-q-01|Faces and aggression|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q01FacesAndPenalties.csv|
|17-q-06|Zoo mortality|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q06ZooMortality.csv|
|17-q-07|Progesterone|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q07ProgesteroneExercise.csv|
|17-q-10|Hybrid pollen sterility|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q10HybridPollenSterility.csv|
|17-q-11|Rattlensake digestion|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q11RattlesnakeDigestion.csv|
|17-q-12|Lizard bites|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q12LizardBite.csv|
|17-q-14|Hypoxanthine|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q14HypoxanthineTimeOfDeath.csv|
|17-q-15|Social spiders|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q15SocialSpiderColonies.csv|
|17-q-17|Earthworms and nitrogen|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q17EarthwormsAndNitrogen.csv|
|17-q-18|Cypress respiration|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q18CypressRespiration.csv|
|17-q-19|Grassland nutrients|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q19GrasslandNutrientsPlantSpecies.csv|
|17-q-20|Primate mass and metabolic rate|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q20PrimateMassMetabolicRate.csv|
|17-q-22|Flycatcher patch|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q22FlycatcherPatch.csv|
|17-q-23|Tree seedlings and sunflecks|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q23TreeSeedlingsAndSunflecks.csv|
|17-q-24|Penguin treadmill|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q24PenguinTreadmill.csv|
|17-q-25|Beetle wings and horns|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q25BeetleWingsAndHorns.csv|
|17-q-26|Song of extinct katydid|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q26SongExtinctKatydid.csv|
|17-q-27|Daphnia parasites|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q27DaphniaParasiteLongevity.csv|
|17-q-28|Brain metabolism|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q28BrainMetabolism.csv|
|17-q-29|Mosquito bites|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q29DEETMosquiteBites.csv|
|17-q-30|Nuclear teeth|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q30NuclearTeeth.csv|
|17-q-31|Last supper portion sizes|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q31LastSupperPortionSize.csv|
|17-q-32|Coral snake mimics|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q32CoralSnakeMimics.csv|
|17-q-33|Egg laying date and climate change|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q33EggLayingMismatch.csv|
|17-q-34|Fathers age and mutations|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q34FatherAgeMutations.csv|
|17-q-35|Anthrax mortality|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q35AnthraxMortality.csv|
|17-q-36|Stork stress|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter17/chap17q36StorkStress.csv|
|18-e-2|Zooplanckton|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter18/chap18e2ZooplanktonDepredation.csv|
|18-e-3|Intertidal algae|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter18/chap18e3IntertidalAlgae.csv|
|18-e-4|Mole rats|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter18/chap18e4MoleRatLayabouts.csv|
|18-q-06|Hippocampus lesions|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter18/chap18q06HippocampusLesions.csv|
|18-q-07|SP and female lifespan|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter18/chap18q07flyLifeSpan.csv|
|18-q-08|Bee genes|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter18/chap18q08BeeGeneExpression.csv|
|18-q-11|Mouse empathy|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter18/chap18q11MouseEmpathy.csv|
|18-q-12|Neanderthal brains|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter18/chap18q12NeanderthalBrainSize.csv|
|18-q-15|Larval fish|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter18/chap18q15ExploitedLarvalFish.csv|
|18-q-18|Opsin expression|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter18/chap18q18OpsinExpression.csv|
|19-e-1|Two-digit "psychic"|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter19/chap19e1TwoDigitNumbers.csv|
|19-e-2|Chimp language centers|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter19/chap19e2ChimpBrains.csv|
|19-q-11|Snail love darts|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter19/chap19q11LoveDarts.csv|
|19-q-13|Leaf bacteria|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter19/chap19q13BacteriaPerLeaf.csv|
|19-q-15|Speed of light|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter19/chap19q15SpeedOfLight.csv|
|20-e-3|Unruly passengers|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter20/chap20e3UnrulyPassengers.csv|
|20-e-4|Conservation scoop|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter20/chap20e4ConservationScoop.csv|
|20-q-07|Yeast regulatory genes|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter20/chap20q07YeastRegulatoryGenes.csv|
|20-q-08|Silverswords|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter20/chap20q08SilverswordWaitingTimes.csv|
|20-q-15|Vole dispersal|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter20/chap20q15VoleDispersal.csv|
|20-q-18|Bee lifespans|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter20/chap20q18BeeLifespans.csv|
|21-p-3|Selection|http://whitlockschluter.zoology.ubc.ca/wp-content/data/chapter21/selection.csv|
'), sep='|')

nam <- abd$name
lab <- abd$label
url <- abd$url

if(name == '') return(data.frame(name=nam, label=lab))

i <- nam == name
if(! any(i)) stop(paste('No dataset named', name))
cat('Retrieving ', lab[i], ' dataset\n', sep='') 
w <- csv.get(url[i], lowernames=lowernames, allow=allow)
attr(w, 'label') <- lab[i]
attr(w, 'url'  ) <- url[i]  
w
}

##' Check for Changes in List of Objects
##'
##' Given an RDS file name and a list of objects, does the following:
##' * makes a vector of hashes, one for each object.  Function objects are run through `deparse` so that the environment of the function will not be considered.
##' * see if the file exists; if not, return a list with result=NULL, `hash` = new vector of hashes, `changed='All'`
##' * if the file exists, read the file and its hash attribute as `prevhash`
##' * if `prevhash` is not identical to hash:
##'     if `.print.=TRUE` (default), print to console a summary of what's changed
##'     return a list with result=NULL, `hash` = new hash vector, changed
##' * if `prevhash = hash`, return a list with result=file object, `hash`=new hash,  changed=''
##'
##' Set `options(debughash=TRUE)` to trace results in `/tmp/debughash.txt`
##' @title hashCheck
##' @param ... a list of objects including data frames, vectors, functions, and all other types of R objects that represent dependencies of a certain calculation
##' @param file name of file in which results are stored
##' @param .print. set to `FALSE` to suppress printing information messages about what has changed
##' @param .names. vector of names of original arguments if not calling `hashCheck` directly
##' @return a `list` with elements `result` (the computations), `hash` (the new hash), and `changed` which details what changed to make computations need to be run
##' @author Frank Harrell
##' @md
hashCheck <- function(..., file, .print.=TRUE, .names.=NULL) {
  .d.      <- list(...)
  .nam.    <- if(length(.names.)) .names. else as.character(sys.call())[-1]
  .nam.    <- .nam.[1 : length(.d.)]
  names(.d.) <- .nam.
  
  .debug. <- length(.Options$debughash) && .Options$debughash
  ct <- if(.debug.)
          function(...) cat(..., '\n', file='/tmp/debughash.txt', append=TRUE)
        else
          function(...) {}

  if(! requireNamespace('digest', quietly=TRUE))
    stop('must install digest package to use hashCheck or runifChanged')

  ct(.nam.)
  .g. <- function(x) digest::digest(if(is.function(x)) deparse(x) else x)
  .hash. <- sapply(.d., .g.)
  if(.debug.) prn(.hash., file='/tmp/debughash.txt')
  
  .prevhash. <- NULL
  if(! file.exists(file)) {
    ct('no file', file)
    return(list(result=NULL, hash=.hash., changed='All'))
    }

  R        <- readRDS(file)
  .prevhash. <- attr(R, 'hash')
if(! length(.prevhash.)) {
    if(.print.) cat('\nRe-run because of no previous hash\n\n')
    ct('no previous hash')
    return(list(result=NULL, hash=.hash., changed='No previous hash'))
    }

  samelen <- length(.hash.) == length(.prevhash.)
  if(samelen && all(.hash. == .prevhash.)) {
    ct('no change')
    return(list(result=R, hash=.hash., changed=''))
    }
  .s. <- character(0)

  if(! samelen) {
    .a. <- names(.prevhash.)
    .b. <- names(.hash.)
    .w. <- setdiff(.a., .b.)
    if(length(.w.))
      .s. <- c(.s., paste('objects removed:',
                      paste(.w., collapse=' ')))
    .w. <- setdiff(.b., .a.)
    if(length(.w.))
      .s. <- c(.s., paste('objects added:',
                      paste(.w., collapse=' ')))
  } else 
    .s. <- c(.s., paste('changes in the following objects:',
                    paste(.nam.[.hash. != .prevhash.], collapse=' ')))

  .s. <- paste(.s., collapse=';')
  ct(.s.)
      
  if(.print.) cat('\nRe-run because of', .s., '\n\n')

  list(result=NULL, hash=.hash., changed=.s.)
}


##' Re-run Code if an Input Changed
##'
##' Uses `hashCheck` to run a function and save the results if specified inputs have changed, otherwise to retrieve results from a file.  This makes it easy to see if any objects changed that require re-running a long simulation, and reports on any changes.  The file name is taken as the chunk name appended with `.rds` unless it is given as `file=`.  `fun` has no arguments.  Set `.inclfun.=FALSE` to not include `fun` in the hash check (for legacy uses).  The typical workflow is as follows.
##' ```
##' f <- function(       ) {
##' # . . . do the real work with multiple function calls ...
##' }
##' seed <- 3
##' set.seed(seed)
##' w <- runifChanged(f, seed, obj1, obj2, ....)
##' ```
##' `seed, obj1, obj2`, ... are all the objects that `f()` uses that if changed
##' would give a different result of `f()`.  This can include functions such as
##' those in a package, and `f` will be re-run if any of the function's code
##' changes.  `f` is also re-run if the code inside `f` changes.
##' The result of `f` is stored with `saveRDS` by default in file named `xxx.rds`
##' where `xxx` is the label for the current chunk.  To control this use instead
##' `file=xxx.rds` add the file argument to `runifChanged(...)`.  If nothing has
##' changed and the file already exists, the file is read to create the result
##' object (e.g., `w` above).  If `f()` needs to be run, the hashed input objects
##' are stored as attributes for the result then the enhanced result is written to the file.
##'
##' See [here](https://hbiostat.org/rflow/caching.html) for examples.
##' 
##' @title runifChanged
##' @param fun the (usually slow) function to run
##' @param ... input objects the result of running the function is dependent on
##' @param file file in which to store the result of `fun` augmented by attributes containing hash digests
##' @param .print. set to `TRUE` to list which objects changed that neessitated re-running `f`
##' @param .inclfun. set to `FALSE` to not include `fun` in the hash digest, i.e., to not require re-running `fun` if only `fun` itself has changed 
##' @return the result of running `fun`
##' @author Frank Harrell
##' @md
runifChanged <- function(fun, ..., file=NULL, .print.=TRUE, .inclfun.=TRUE) {
  if(! length(file)) {
    file <- knitr::opts_current$get('label')
    if(! length(file))
      stop('attempt to run runifChanged without file= outside a knitr chunk')
    file <- paste0(file, '.rds')
  }
  w <- list(...)
  .names. <- (as.character(sys.call())[-1])[1 : (length(w) + 1)]

  hashobj <- if(! .inclfun.) hashCheck(..., file=file,
                                       .print.=.print., .names.=.names.[-1])
             else {
               w <- c(list(fun), w)
               w$file    <- file
               w$.print. <- .print.
               w$.names. <- .names.
               do.call(hashCheck, w)
               }

  hash    <- hashobj$hash
  result  <- hashobj$result
  if(! length(result)) {
    result <- fun()
    attr(result, 'hash') <- hash
    saveRDS(result, file, compress='xz')
  }
  result
}

SUBROUTINE wclosest(w, x, lw, lx, j)
IMPLICIT DOUBLE PRECISION (a-h,o-z)
INTEGER lw, lx, j(lw)
DOUBLE PRECISION w(lw), x(lx)

do i=1,lw {
  wi=w(i)
  dmin=1d40
  m=0
  do k=1,lx {
    d = dabs(x(k) - wi)
    if(d < dmin) {
      dmin = d
      m = k
    }
  }
  j(i) = m
}
return
end

SUBROUTINE wclosepw(w, x, r, f, lw, lx, xd, j)
IMPLICIT DOUBLE PRECISION (a-h,o-z)
DOUBLE PRECISION w(lw),x(lx),r(lw),xd(lx)
INTEGER lw, lx, j(lw)
do i=1, lw {
  wi = w(i)
  dmean = 0d0
  do k=1, lx {
    xd(k) = dabs(x(k) - wi)
    dmean = dmean + xd(k)
  }
  dmean = f * dmean / lx
  sump = 0d0
  do k=1, lx {
    z = min(xd(k)/dmean, 1d0)
    xd(k) = (1d0 - z**3)**3
    sump = sump + xd(k)
  }
  prob = 0d0
  ri = r(i)
  m = 1
  do k=1, lx {
    prob = prob + xd(k) / sump
    if(ri > prob) m = m + 1
  }
  j(i) = m
}
return
end

##' Melt a Dataset To Examine All Xs vs Y
##'
##' Uses a formula with one or more left hand side variables (Y) and one or more right hand side variables (X).  Uses [data.table::melt()] to melt `data` so that each X is played against the same Y if `tall='right'` (the default) or each Y is played against the same X combination if `tall='left'`.  The resulting data table has variables Y with their original names (if `tall='right'`) or variables X with their original names (if `tall='left'`), `variable`, and `value`.  By default `variable` is taken as `label()`s of the `tall` variables.
##' @title meltData
##' @param formula a formula
##' @param data data frame or table
##' @param tall see above
##' @param vnames set to `names` to always use variable names instead of labels for X
##' @param sepunits set to `TRUE` to create a separate variable `Units` to hold units of measurement.  The variable is not created if no original variables have a non-blank `units` attribute.
##' @param ... passed to `label()`
##' @return data table
##' @author Frank Harrell
##' @md
##' @seealso [label()]
##' @examples
##' d <- data.frame(y1=(1:10)/10, y2=(1:10)/100, x1=1:10, x2=101:110)
##' label(d$x1) <- 'X1'
##' units(d$x1) <- 'mmHg'
##' m=meltData(y1 + y2 ~ x1 + x2, data=d, units=TRUE) # consider also html=TRUE
##' print(m)
##' m=meltData(y1 + y2 ~ x1 + x2, data=d, tall='left')
##' print(m)
meltData <- function(formula, data, tall=c('right', 'left'),
                     vnames=c('labels', 'names'), sepunits=FALSE, ...) {
  tall   <- match.arg(tall)
  vnames <- match.arg(vnames)
  s <- data.table::copy(data)
  if(! is.data.table(s)) data.table::setDT(s)

  v <- all.vars(formula)
  k <- as.character(formula)
  y <- all.vars(as.formula(paste('~', k[2])))
  x <- all.vars(as.formula(paste('~', k[3])))
  s <- s[, ..v]
  
  labs  <- sapply(s, label, ...)
  labs  <- ifelse(labs == '', names(labs), labs)
  Units <- sapply(s, Hmisc::units)
  id    <- switch(tall,
                  right = y,
                  left  = x)
  ## data.table wants all variables to be melted to have the same type
  for(n in setdiff(v, id)) {
    z <- s[[n]]
    if(! is.factor(z)) set(s, j=n, value=as.double(z))
    }
  m <- data.table::melt(s, id.var=id)
  if(sepunits && any(Units != ''))
    m[, Units := Units[as.character(variable)]]
  if(vnames == 'labels')
    m[, variable := factor(labs[as.character(variable)],
                           levels=labs[levels(variable)]) ]
  m
}

utils::globalVariables(c('..v','.SD','variable'))

#' Merge Multiple Data Frames or Data Tables
#'
#' Merges an arbitrarily large series of data frames or data tables containing common \code{id} variables.  Information about number of observations and number of unique \code{id}s in individual and final merged datasets is printed.  The first data frame/table has special meaning in that all of its observations are kept whether they match \code{id}s in other data frames or not.  For all other data frames, by default non-matching observations are dropped.  The first data frame is also the one against which counts of unique \code{id}s are compared.  Sometimes \code{merge} drops variable attributes such as \code{labels} and \code{units}.  These are restored by \code{Merge}.
#'
#' @param \dots two or more dataframes or data tables
#' @param id a formula containing all the identification variables such that the combination of these variables uniquely identifies subjects or records of interest.  May be omitted for data tables; in that case the \code{key} function retrieves the id variables.
#' @param all set to \code{FALSE} to drop observations not found in second and later data frames (only applies if not using \code{data.table})
#' @param verbose set to \code{FALSE} to not print information about observations
#' @export
#' @examples
#' \dontrun{
#' a <- data.frame(sid=1:3, age=c(20,30,40))
#' b <- data.frame(sid=c(1,2,2), bp=c(120,130,140))
#' d <- data.frame(sid=c(1,3,4), wt=c(170,180,190))
#' all <- Merge(a, b, d, id = ~ sid)
#' # First file should be the master file and must
#' # contain all ids that ever occur.  ids not in the master will
#' # not be merged from other datasets.
#' a <- data.table(a); setkey(a, sid)
#' # data.table also does not allow duplicates without allow.cartesian=TRUE
#' b <- data.table(sid=1:2, bp=c(120,130)); setkey(b, sid)
#' d <- data.table(d); setkey(d, sid)
#' all <- Merge(a, b, d)
#' }

Merge <- function(..., id=NULL, all=TRUE, verbose=TRUE) {
  
  w <- list(...)
  nams <- (as.character(sys.call())[-1])[1 : length(w)]
  m <- length(nams)
  ## If argument is a function call, e.g., subset(mydata, age > 20)
  ## find name of first argument and omit any dollar sign prefix and []
  for(i in 1 : m) {
    x <-       nams[i]
    x <-       gsub('subset\\(',   '', x)
    x <-       gsub(',.*',         '', x)
    x <-       gsub('\\[.*'  ,     '', x)
    nams[i] <- gsub('(.*)\\$(.*)', '\\2', x)
  }
  d1   <- w[[1]]
  idt <- 'data.table' %in% class(d1)
  if(idt && ! requireNamespace("data.table", quietly = TRUE))
    stop("The 'data.table' package is required to operate on data tables.")

  if(length(id)) id <- all.vars(id)
  else {
    if(! idt) stop('must specify id if not using data.tables')
    id <- key(d1)
    if(! length(id)) stop('id not given and first data table has no keys')
    }
  m <- length(w)
  va <- n <- nu <- integer(m)
  nin1 <- nnin1 <- rep(NA, m)
  did <- if(idt) d1[, id, with=FALSE] else d1[id]
  idc1 <- unique(as.character(interaction(did)))
  id.union <- id.intersection <- idc1
  ## Unique variables, and their labels and units
  uvar <- lab <- un <- character(0)
  for(i in 1 : m) {
    d <- w[[i]]
    nd <- names(d)
    if(any(id %nin% nd))
      stop(paste('data frame', nams[i], 'does not contain id variables',
                 paste(id, collapse=', ')))
    j <- nd %nin% uvar
    uvar <- c(uvar, nd[j])
    lab  <- c(lab,  sapply(d, label)[j])
    un   <- c(un,   sapply(d, units)[j])
    idt  <- is.data.table(d)
    M <- if(i == 1) d
    else
      merge(M, d, by=id, all.x=TRUE, all.y=all)
    did   <- if(idt) d[, id, with=FALSE] else d[id]
    idc   <- unique(as.character(interaction(did)))
    di    <- dim(d)
    va[i] <- di[2]
    n [i] <- di[1]
    nu[i] <- length(unique(idc))
    if(i > 1) {
      nin1 [i] <- sum(idc %in%  idc1)
      nnin1[i] <- sum(idc %nin% idc1)
      id.union <- union(id.union, idc)
      id.intersection <- intersect(id.intersection, idc)
    }
  }
  ## Restore labels and units if needed
  nm <- names(M)
  names(lab) <- uvar
  names(un ) <- uvar
  anych <- FALSE
  if(any(c(lab, un) != ''))
    for(i in 1 : ncol(M)) {
      x  <- M[[i]]
      ni <- nm[i]
      changed <- FALSE
      if(ni %nin% names(lab))
        stop(paste('Unexpected variable:', ni))
      if(lab[ni] != '' && ! length(attr(x, 'label'))) {
        label(x) <- lab[ni]
        changed <- TRUE
      }
      if(un[ni] != '' && ! length(attr(x, 'units'))) {
        units(x) <- un[ni]
        changed <- TRUE
      }
      if(changed) M[[i]] <- x
      anych <- anych | changed
    }
  
  nams  <- c(nams, 'Merged')
  va    <- c(va, ncol(M))
  n     <- c(n, nrow(M))
  did   <- if(is.data.table(M)) M[, id, with=FALSE] else M[id]
  idc   <- unique(as.character(interaction(did)))
  nu    <- c(nu, length(unique(idc)))
  nin1  <- c(nin1,  sum(idc %in%  idc1))
  nnin1 <- c(nnin1, sum(idc %nin% idc1))
  info  <- cbind(Vars=va, Obs=n, 'Unique IDs'=nu, 'IDs in #1'=nin1,
                 'IDs not in #1'=nnin1)
  rownames(info) <- nams
  if(verbose) {
    print(info)
    cat('\nNumber of unique IDs in any data frame :', length(id.union), '\n')
    cat(  'Number of unique IDs in all data frames:', length(id.intersection),
        '\n')
    if(anych) cat('\nLabels or units restored\n')
  }
  attr(M, 'info') <- info
  M
}

! Converted from Ratfor to Fortran 2018 by Claude AI 2024-10-26
subroutine cidxcn(x, y, e, n, nrel, nconc, nuncert, c, gamma, sd, outx)
    use, intrinsic :: iso_fortran_env, only: real64
    implicit none
    
    ! Arguments
    integer, intent(in) :: n
    real(real64), intent(in) :: x(n), y(n)
    logical, intent(in) :: e(n), outx
    real(real64), intent(out) :: nrel, nconc, nuncert, c, gamma, sd
    
    ! Local variables
    integer :: i, j
    real(real64) :: dx, dy, wi, ri
    real(real64) :: sumr, sumr2, sumw, sumw2, sumrw
    
    ! Initialize counters and sums
    nconc = 0.0_real64
    nrel = 0.0_real64
    nuncert = 0.0_real64
    sumr = 0.0_real64
    sumr2 = 0.0_real64
    sumw = 0.0_real64
    sumw2 = 0.0_real64
    sumrw = 0.0_real64
    
    ! Main computation loop
    do i = 1, n
        wi = 0.0_real64
        ri = 0.0_real64
        
        do j = 1, n
            if (j /= i) then
                dx = x(i) - x(j)
                dy = y(i) - y(j)
                
                ! Check if pair should be considered based on x ties
                if (dx /= 0.0_real64 .or. (.not. outx)) then
                    ! Case 1: i is uncensored and y(i) < y(j)
                    ! or i is uncensored, j is censored, and y values are equal
                    if ((e(i) .and. dy < 0.0_real64) .or. &
                        (e(i) .and. .not. e(j) .and. dy == 0.0_real64)) then
                        
                        if (dx < 0.0_real64) then
                            nconc = nconc + 1.0_real64
                            wi = wi + 1.0_real64
                        else if (dx == 0.0_real64) then
                            nconc = nconc + 0.5_real64
                        else
                            wi = wi - 1.0_real64
                        end if
                        nrel = nrel + 1.0_real64
                        ri = ri + 1.0_real64
                        
                    ! Case 2: j is uncensored and y(j) > y(i)
                    ! or j is uncensored, i is censored, and y values are equal
                    else if ((e(j) .and. dy > 0.0_real64) .or. &
                            (e(j) .and. .not. e(i) .and. dy == 0.0_real64)) then
                        
                        if (dx > 0.0_real64) then
                            nconc = nconc + 1.0_real64
                            wi = wi + 1.0_real64
                        else if (dx == 0.0_real64) then
                            nconc = nconc + 0.5_real64
                        else
                            wi = wi - 1.0_real64
                        end if
                        nrel = nrel + 1.0_real64
                        ri = ri + 1.0_real64
                        
                    ! Case 3: Uncertain pair (both censored)
                    else if (.not. (e(i) .and. e(j))) then
                        nuncert = nuncert + 1.0_real64
                    end if
                end if
            end if
        end do
        
        ! Accumulate sums for standard deviation calculation
        sumr = sumr + ri
        sumr2 = sumr2 + ri * ri
        sumw = sumw + wi
        sumw2 = sumw2 + wi * wi
        sumrw = sumrw + ri * wi
    end do
    
    ! Calculate c-index and gamma
    c = nconc / nrel
    gamma = 2.0_real64 * (c - 0.5_real64)
    
    ! Calculate standard deviation using Quade formula
    sd = sumr2 * sumw**2 - 2.0_real64 * sumr * sumw * sumrw + sumw2 * sumr**2
    sd = 2.0_real64 * sqrt(sd) / (sumr * sumr)
    
end subroutine cidxcn

##' Generalized R^2 Measures
##'
##' Computes various generalized R^2 measures related to the Maddala-Cox-Snell (MCS) R^2 for regression models fitted with maximum likelihood.  The original MCS R^2 is labeled `R2` in the result.  This measure uses the raw sample size `n` and does not penalize for the number of free parameters, so it can be rewarded for overfitting.  A measure adjusted for the number of fitted regression coefficients `p` uses the analogy to R^2 in linear models by computing `1 - exp(- lr / n) * (n-1)/(n-p-1)` if `padj=2`, which is approximately `1 - exp(- (lr - p) / n)`, the version used if `padj=1` (the default).  The latter measure is appealing because the expected value of the likelihood ratio chi-square statistic `lr` is `p` under the global null hypothesis of no predictors being associated with the response variable.  See <https://hbiostat.org/bib/r2.html> for more details.
##'
##' It is well known that in logistic regression the MCS R^2 cannot achieve a value of 1.0 even with a perfect model, which prompted Nagelkerke to divide the R^2 measure by its maximum attainable value.  This is not necessarily the best recalibration of R^2 throughout its range.  An alternative is to use the formulas above but to replace the raw sample size `n` with the effective sample size, which for data with many ties can be significantly lower than the number of observations.  As used in the `popower()` and `describe()` functions, in the context of a Wilcoxon test or the proportional odds model, the effective sample size is `n * (1 - f)` where `f` is the sums of cubes of the proportion of observations at each distict value of the response variable.  Whitehead derived this from an approximation to the variance of a log odds ratio in a proportional odds model.  To obtain R^2 measures using the effective sample size, either provide `ess` as a single number specifying the effective sample size, or specify a vector of frequencies of distinct Y values from which the effective sample size will be computed.  In the context of survival analysis, the single number effective sample size you may wish to specify is the number of uncensored observations.  This is exactly correct when estimating the hazard rate from a simple exponential distribution or when using the Cox PH/log-rank test.  For failure time distributions with a very high early hazard, censored observations contain enough information that the effective sample size is greater than the number of events.  See Benedetti et al, 1982.
##'
##' If the effective sample size equals the raw sample size, measures involving the effective sample size are set to \code{NA}.
##' @title R2Measures
##' @param lr likelihoood ratio chi-square statistic
##' @param p number of non-intercepts in the model that achieved `lr`
##' @param n raw number of observations
##' @param ess if a single number, is the effective sample size.  If a vector of numbers is assumed to be the frequency tabulation of all distinct values of the outcome variable, from which the effective sample size is computed.
##' @param padj set to 2 to use the classical adjusted R^2 penalty, 1 (the default) to subtract `p` from `lr`
##' @return named vector of R2 measures.  The notation for results is `R^2(p, n)` where the `p` component is empty for unadjusted estimates and `n` is the sample size used (actual sample size for first measures, effective sample size for remaining ones).  For indexes that are not adjusted, only `n` appears.
##' @author Frank Harrell
##' @md
##' @export
##' @references
##' Smith TJ and McKenna CM (2013): A comparison of logistic regression pseudo R^2 indices.  Multiple Linear Regression Viewpoints 39:17-26.  <https://www.glmj.org/archives/articles/Smith_v39n2.pdf>
##' 
##' Benedetti JK, et al (1982): Effective sample size for tests of censored survival data.  Biometrika 69:343--349.
##' 
##' Mittlbock M, Schemper M (1996): Explained variation for logistic regression.  Stat in Med 15:1987-1997.
##' 
##' Date, S: R-squared, adjusted R-squared and pseudo R-squared. <https://timeseriesreasoning.com/contents/r-squared-adjusted-r-squared-pseudo-r-squared/>
##' 
##' UCLA: What are pseudo R-squareds? <https://stats.oarc.ucla.edu/other/mult-pkg/faq/general/faq-what-are-pseudo-r-squareds/>
##' 
##' Allison P (2013): What's the beset R-squared for logistic regression? <https://statisticalhorizons.com/r2logistic/>
##' 
##' Menard S (2000): Coefficients of determination for multiple logistic regression analysis.  The Am Statistician 54:17-24.
##'
##' Whitehead J (1993): Sample size calculations for ordered categorical data.  Stat in Med 12:2257-2271.  See errata (1994) 13:871 and letter to the editor by Julious SA, Campbell MJ (1996) 15:1065-1066 showing that for 2-category Y the Whitehead sample size formula agrees closely with the usual formula for comparing two proportions.
##' @examples
##' x <- c(rep(0, 50), rep(1, 50))
##' y <- x
##' # f <- lrm(y ~ x)
##' # f   # Nagelkerke R^2=1.0
##' # lr <- f$stats['Model L.R.']
##' # 1 - exp(- lr / 100)  # Maddala-Cox-Snell (MCS) 0.75
##' lr <- 138.6267  # manually so don't need rms package
##'
##' R2Measures(lr, 1, 100, c(50, 50))  # 0.84 Effective n=75
##' R2Measures(lr, 1, 100, 50)         # 0.94
##' # MCS requires unreasonable effective sample size = minimum outcome
##' # frequency to get close to the 1.0 that Nagelkerke R^2 achieves

R2Measures <- function(lr, p, n, ess=NULL, padj=1) {
  R     <- numeric(0)
  r2    <- 1. - exp(- lr / n)
  adj <- function() if(padj == 1) 1. - exp(- max(lr - p, 0) / n)
           else
             1. - exp(- lr / n) * (n - 1.) / (n - p - 1.)
  r2adj <- adj()
  R <- c(R2=r2, R2adj=r2adj)
  g <- function(p, n) {
    n <- as.character(round(n, 1))
    sub <- ifelse(p == 0, n, paste0(p, ',', n))
    paste0('R2(', sub, ')')
  }
  name    <- g(c(0, p), c(n, n))

  if(length(ess)) {
    ## Replace n with effective sample size
    nr <- n
    n <- if(length(ess) == 1) ess else {
      P <- ess / sum(ess)
      n * (1. - sum(P ^ 3))
        }
    r2    <- 1. - exp(- lr / n)
    r2adj <- adj()
    if(n == nr) r2 <- r2adj <- NA
    name  <- c(name, g(c(0, p), c(n, n)))
    R     <- c(R, r2, r2adj)
  }
  names(R) <- name
  R
}

## Tests contraint option with a small data frame

require(Hmisc)
w <- data.frame(x1=c(NA, 1:4,    NA),
                x2=c(1,  3,2,4,5, 6),
                x3=c(11,15,12,13,17,18))
aregImpute(~ x1 + x2 + x3, data=w, nk=0,
           constraint=list(x1 = expression(d$x3 %in% 12:13)))

## Test on a larger dataset by showing that inconsequential constraints
## result in the same object as an unconstrained run, except for 3 elements

set.seed(1)
n <- 2000
w <- data.frame(x1=runif(n), x2=ifelse(runif(n) < 0.05, NA, runif(n)),
                x3=ifelse(runif(n) < 0.05, NA, runif(n)))
set.seed(1)
z1 <- aregImpute(~ x1 + x2 + x3, data=w)
z1$call <- z1$constraint <- z1$countqual <- NULL
set.seed(1)
z2 <- aregImpute(~ x1 + x2 + x3, data=w,
                 constraint=list(x2=expression(rep(TRUE, nrow(d))),
                                 x3=expression(rep(TRUE, nrow(d)))))
z2$call <- z2$constraint <- z2$countqual <- NULL
identical(z1, z2)

## Apply real constraints and make sure constraints were satisfied for
## imputed values
set.seed(3)
z <- aregImpute(~ x1 + x2 + x3, data=w,
                constraint=list(x2=expression(d$x2 >= 0.3 & d$x2 <= 0.4),
                                x3=expression(d$x3 > r$x1)))
u <- z$imputed$x2
range(u)
table(round(u, 2))
j <- is.na(w$x3)
for(i in 1 : 5) {
  d <- completer(z, nimpute=i, oneimpute=TRUE, w)
  with(d[j, ], cat(mean(x3 > x1), ''))
}

##' Add Spike Histograms and Extended Box Plots to `ggplot`
##'
##' For an example see [this](https://hbiostat.org/rflow/analysis.html#fig-table1).  Note that it was not possible to just create the layers needed to be added, as creating these particular layers in isolation resulted in a `ggplot` error.
##' @title addggLayers
##' @param g a `ggplot` object
##' @param data data frame/table containing raw data
##' @param type specifies either extended box plot or spike histogram.  Both are horizontal so are showing the distribution of the x-axis variable.
##' @param ylim y-axis limits to use for scaling the height of the added plots, if you don't want to use the limits that `ggplot` has stored
##' @param by the name of a variable in `data` used to stratify raw data
##' @param value name of x-variable
##' @param frac fraction of y-axis range to devote to vertical aspect of the added plot
##' @param mult fudge factor for scaling y aspect
##' @param facet optional faceting variable
##' @param pos position for added plot
##' @param showN sete to `FALSE` to not show sample sizes
##' @return the original `ggplot` object with more layers added
##' @seealso `spikecomp()`
##' @author Frank Harrell
##' @md
addggLayers <- function(g, data,
                        type=c('ebp', 'spike'),
                        ylim=layer_scales(g)$y$get_limits(),
                        by='variable', value='value',
                        frac=0.065, mult=1., facet=NULL,
                        pos=c('bottom', 'top'), showN=TRUE) {
  type <- match.arg(type)
  pos  <- match.arg(pos)
  d    <- data.table::copy(data)
  data.table::setDT(d)
  if(by %nin% names(data)) {
    by <- '.by.'
    d[, .by. := rep('', .N)]
    }
  data.table::setnames(d, c(by, value), c('.by.', '.value.'))

  scomp <- function(x)
    list(segments = spikecomp(x, normalize=TRUE, tresult='segments'))
  comp  <- switch(type,
                  ebp   = ebpcomp,
                  spike = scomp)

  vars <- d[, unique(.by.)]
  r    <- list()
  for(v in vars) {
    x <- d[.by. == v, .value.]
    r[[v]] <- comp(x)
  }
  R <- list()
  for(n in names(r[[1]]))
    R[[n]] <- data.table::rbindlist(lapply(r, function(z) z[[n]]), idcol=by)

  ## Transform y from ebpcomp which has y in [-1, 1]
  ## -->  ylim[1] + (y + 1.) * diff(ylim) * frac / 2.
  b <- mult * diff(ylim) * frac / 2.

  switch(type,
         ebp   = switch(pos,
                        bottom = {a <- ylim[1] + b},
                        top    = {a <- ylim[2] - b} ),
         spike = switch(pos,
                        bottom = {a <- ylim[1]},
                        top    = {a <- ylim[2]; b <- -b} )          )

  for(geo in names(R)) {
    dat <- R[[geo]]
    if(length(facet)) dat[, names(facet) := facet]
    g <- g +
      switch(geo,
             lines    = geom_path(aes(x=x, y=a + b * y), alpha=I(0.6),
                                  data=dat),
             segments = geom_segment(aes(x=x, xend=x,
                                         y=a + b * y1, yend=a + b * y2),
                                     data=dat),
             points   = geom_point(aes(x=x, y=a + b * y),
                                       col=I('blue'), size=I(0.8), data=dat),
             points2  = geom_point(aes(x=x, y=a + b * y),
                                       size=I(0.2), alpha=I(0.4),
                                   data=dat) )
  }

  if(showN && 'points' %in% names(R) && 'N' %in% names(R$points) &&
     diff(range(R$points[, N])) > 0)
    g <- g + geom_text(aes(x=Inf, y=Inf, label=paste0('N=', N),
                           hjust=1, vjust=1, size=I(2)), data=R$points)

  g
  }

utils::globalVariables(c('y', '.by.','.N','.value.','N','..v','.SD','variable'))

##' Combine Infrequent Levels of a Categorical Variable
##'
##' After turning `x` into a `factor` if it is not one already, combines
##' levels of `x` whose frequency falls below a specified relative frequency `minlev` or absolute count `m`.  When `x` is not treated as ordered, all of the
##' small frequency levels are combined into `"OTHER"`, unless `plevels=TRUE`.
##' When `ord=TRUE` or `x` is an ordered factor, only consecutive levels
##' are combined.  New levels are constructed by concatenating the levels with
##' `sep` as a separator.  This is useful when comparing ordinal regression
##' with polytomous (multinomial) regression and there are too many
##' categories for polytomous regression.  `combine.levels` is also useful
##' when assumptions of ordinal models are being checked empirically by
##' computing exceedance probabilities for various cutoffs of the
##' dependent variable.
##' @title combine.levels
##' @param x a factor, `ordered` factor, or numeric or character variable that will be turned into a `factor`
##' @param minlev the minimum proportion of observations in a cell before that cell is combined with one or more cells.  If more than one cell has fewer than minlev*n observations, all such cells are combined into a new cell labeled `"OTHER"`.  Otherwise, the lowest frequency cell is combined with the next lowest frequency cell, and the level name is the combination of the two old level levels. When `ord=TRUE` combinations happen only for consecutive levels.
##' @param m alternative to `minlev`, is the minimum number of observations in a cell before it will be combined with others
##' @param ord set to `TRUE` to treat `x` as if it were an ordered factor, which allows only consecutive levels to be combined
##' @param plevels by default `combine.levels` pools low-frequency levels into a category named `OTHER` when `x` is not ordered and `ord=FALSE`.  To instead name this category the concatenation of all the pooled level names, separated by a comma, set `plevels=TRUE`.
##' @param sep the separator for concatenating levels when `plevels=TRUE`
##' @return a factor variable, or if `ord=TRUE` an ordered factor variable
##' @author Frank Harrell
##' @examples
##' x <- c(rep('A', 1), rep('B', 3), rep('C', 4), rep('D',1), rep('E',1))
##' combine.levels(x, m=3)
##' combine.levels(x, m=3, plevels=TRUE)
##' combine.levels(x, ord=TRUE, m=3)
##' x <- c(rep('A', 1), rep('B', 3), rep('C', 4), rep('D',1), rep('E',1),
##'        rep('F',1))
##' combine.levels(x, ord=TRUE, m=3)

## Modified 27Feb23 - added ord
combine.levels <- function(x, minlev=.05, m, ord=is.ordered(x),
                           plevels=FALSE, sep=',') {

  x  <- as.factor(x)
  i  <- ! is.na(x)
  nu <- length(unique(x[i]))
  if(nu < 2) return(x)
  notna <- sum(i)
  if(notna == 0) return(x)
  lev <- levels(x)
  n   <- table(x)   # excludes NAs in tabulation
  f   <- n / notna
  if(! missing(m)) minlev <- m / notna
  i   <- f < minlev
  si  <- sum(i)
  if(si == 0) return(x)

  if(ord) {
    if(nu > 250) warning('combine.levels with ord=TRUE is slow with more than 250 distinct values.\nConsider using cut2().')
    if(missing(m)) m <- round(minlev * notna)
    if(sum(n) < 2 * m)
      stop(paste('with m=', m, 'must have >=', 2 * m,
                 'non-missing observations'))
    levs <- newlevs <- names(n)
    names(n) <- NULL
    l <- length(levs)
    while(TRUE) {  
      ## Find first value of x having < m observations when counting
      ## by the current combined levels
      ## If it's the first level, combine it with the 2nd level
      ## If it's the last level, combine it with the next-to-last level
      ## Otherwise, combine it with the smaller of the previous level
      ## and the next level
      ## factor() below makes tapply keep levels in order
      freq <- tapply(n, factor(newlevs, unique(newlevs)), sum)
      i    <- which.min(freq)
      if(freq[i] >= m) break
      l <- length(freq)
      j <- if(i == 1) 1:2
           else if(i == l) (l-1) : l
           else if(freq[i-1] < freq[i+1]) (i-1) : i else i : (i+1)
      ## freq,i,j are aligned with unique(newlevs)
      ## Need to make changes index into the longer newlevs
      unewlevs <- names(freq)
      newlevs[newlevs %in% unewlevs[j]] <- paste(unewlevs[j], collapse=sep)
    }
    levels(x) <- newlevs
    return(ordered(x))
  }

  comb <- if(si == 1) names(sort(f))[1 : 2]
  else names(f)[i]
  
  keepsep <- setdiff(names(f), comb)
  names(keepsep) <- keepsep
  w <- c(list(OTHER=comb), keepsep)
  if(plevels) names(w)[1] <- paste(comb, collapse=sep)
  levels(x) <- w
  x
}

! Converted from Ratfor 2024-10-26 using ChatGPT and the following request:
! Convert the following Ratfor code to Fortran 2018 using Fortran ISO environment without using module

subroutine maxempr(ax, ay, x, y, n, w, h, z, area, rect)
    use ISO_FORTRAN_ENV, only: REAL64, INT32
    implicit none
  
    integer(INT32), intent(in) :: n
    real(REAL64), intent(in) :: ax(2), ay(2), x(n), y(n), w, h, z(3)
    real(REAL64), intent(out) :: area, rect(4)
    real(REAL64) :: maxr, tl, tr, li, ri
    real(REAL64) :: area_candidate
    integer(INT32) :: i, j, k
  
    ! Initialize max area and set initial rectangle boundaries
    maxr = z(1) * abs(ay(2) - ay(1))
    rect(1) = z(2)
    rect(2) = ay(1)
    rect(3) = z(3)
    rect(4) = ay(2)
  
    ! Iterate through points to determine largest rectangles
    do i = 1, n
      tl = ax(1)
      tr = ax(2)
  
      if (i < n) then
        do j = i + 1, n
          if (x(j) > tl .and. x(j) < tr) then
            ! Check horizontal slices (j == i + 1)
            area_candidate = (tr - tl) * (y(j) - y(i))
            if (area_candidate > maxr .and. (tr - tl) > w .and. (y(j) - y(i)) > h) then
              maxr = area_candidate
              rect(1) = tl
              rect(2) = y(i)
              rect(3) = tr
              rect(4) = y(j)
            end if
  
            ! Update boundaries based on current point
            if (x(j) > x(i)) then
              tr = x(j)
            else
              tl = x(j)
            end if
          end if
        end do
      end if
  
      ! Check open rectangles above (x(i), y(i))
      area_candidate = (tr - tl) * (ay(2) - y(i))
      if (area_candidate > maxr .and. (tr - tl) > w .and. (ay(2) - y(i)) > h) then
        maxr = area_candidate
        rect(1) = tl
        rect(2) = y(i)
        rect(3) = tr
        rect(4) = ay(2)
      end if
  
      ! Check open rectangles below (x(i), y(i))
      ri = ax(2)
      li = ax(1)
      do k = 1, n
        if (y(k) < y(i) .and. x(k) > x(i)) ri = min(ri, x(k))
        if (y(k) < y(i) .and. x(k) < x(i)) li = max(li, x(k))
      end do
  
      area_candidate = (ri - li) * (y(i) - ay(1))
      if (area_candidate > maxr .and. (ri - li) > w .and. (y(i) - ay(1)) > h) then
        maxr = area_candidate
        rect(1) = li
        rect(2) = ay(1)
        rect(3) = ri
        rect(4) = y(i)
      end if
    end do
  
    area = maxr
    return
  end subroutine maxempr
  

##' Create imputed dataset(s) using \code{transcan} and \code{aregImpute} objects
##'
##' Similar in function to `mice::complete`, this function uses `transcan` and `aregImpute` objects to impute missing data
##' and returns the completed dataset(s) as a dataframe or a list.
##' It assumes that `transcan` is used for single regression imputation.
##' @title completer
##' @param a          An object of class `transcan` or `aregImpute`
##' @param nimpute    A numeric vector between 1 and `a$n.impute`. For `transcan` object, this is set to 1. For `aregImpute` object, returns a list of `nimpute` datasets when `oneimpute` is set to `FALSE` (default).
##' @param oneimpute  A logical vector. When set to `TRUE`, returns a single completed dataset for the imputation number specified by `nimpute`
##' @param mydata     A data frame in which its missing values will be imputed.
##' @return           A single or a list of completed dataset(s).
##' @author           Yong-Hao Pua, Singapore General Hospital
##' @md
##' @examples
##' \dontrun{
##' mtcars$hp[1:5]    <- NA
##' mtcars$wt[1:10]   <- NA
##' myrform <- ~ wt + hp + I(carb)
##' mytranscan  <- transcan( myrform,  data = mtcars, imputed = TRUE,
##'   pl = FALSE, pr = FALSE, trantab = TRUE, long = TRUE)
##' myareg      <- aregImpute(myrform, data = mtcars, x=TRUE, n.impute = 5)
##' completer(mytranscan)                    # single completed dataset
##' completer(myareg, 3, oneimpute = TRUE)
##' # single completed dataset based on the `n.impute`th set of multiple imputation
##' completer(myareg, 3)
##' # list of completed datasets based on first `nimpute` sets of multiple imputation
##' completer(myareg)
##' # list of completed datasets based on all available sets of multiple imputation
##' # To get a stacked data frame of all completed datasets use
##' # do.call(rbind, completer(myareg, data=mydata))
##' # or use rbindlist in data.table
##' }
completer <- function (a, nimpute, oneimpute = FALSE, mydata) {


  trans <- inherits(a, 'transcan')
  areg  <- inherits(a, 'aregImpute')
  ni    <- a$n.impute

  if (trans)  nimpute <- 1
  if(missing(nimpute)) nimpute <- ni
  if(areg && nimpute > ni)
    stop ("'nimpute' cannot exceed ", ni, ".")

  if(missing(mydata)) mydata   <- eval(a$call$data)

  impute.transcan_args <- list(x = a, imputation = nimpute, data = mydata,  list.out = TRUE, pr = FALSE)
  if(trans) impute.transcan_args$imputation <- NULL   # remove `imputation` arg for transcan


  imputed_dflist <-
    if (trans | (areg & oneimpute) ) {
      # single completed dataset from transcan or aregImpute
      imputed <- do.call("impute.transcan", impute.transcan_args)
      mydata [ , names(imputed)] <- as.data.frame(imputed)
      return(mydata)
    } else {
      # list of completed datasets from aregImpute
      lapply(seq_len(nimpute), function(x){
        imputed <- do.call("impute.transcan", impute.transcan_args)
        mydata [ , names(imputed)] <- as.data.frame(imputed)
        return(mydata)
      })
    }

  return(imputed_dflist)
  }

#' Mean-center a data matrix and QR transform it
#'
#' For a numeric matrix `x` (or a numeric vector that is automatically changed to a one-column matrix), computes column means and subtracts them from `x` columns, and passes this matrix to [base::qr()] to orthogonalize columns.  Columns of the transformed `x` are negated as needed so that original directions are preserved (which are arbitrary with QR decomposition).  Instead of the default `qr` operation for which sums of squares of column values are 1.0, `qrxcenter` makes all the transformed columns have standard deviation of 1.0.
#' @title qrxcenter
#' @param x a numeric matrix or vector with at least 2 rows
#' @param ... passed to [base::qr()]
#'
#' @return a list with components `x` (transformed data matrix), `R` (the matrix that can be used to transform raw `x` and to transform regression coefficients computed on transformed `x` back to the original space), `Ri` (transforms transformed `x` back to original scale except for `xbar`), and `xbar` (vector of means of original `x` columns`)
#' @export
#' @md
#'
#' @examples
#' set.seed(1)
#' age <- 1:10
#' country <- sample(c('Slovenia', 'Italy', 'France'), 10, TRUE)
#' x <- model.matrix(~ age + country)[, -1]
#' x
#' w <- qrxcenter(x)
#' w
#' # Reproduce w$x
#' sweep(x, 2, w$xbar) %*% w$R
#' # Reproduce x from w$x
#' sweep(w$x %*% w$Ri, 2, w$xbar, FUN='+')
#' # See also https://hbiostat.org/r/examples/gtrans/gtrans#sec-splinebasis
qrxcenter <- function(x, ...) {
  if(! is.matrix(x)) x <- is.matrix(x)
  d    <- dim(x)
  n    <- d[1]
  p    <- d[2]
  if(n <= 2) stop('requires n > 1')

  x    <- scale(x, center=TRUE, scale=FALSE)
  xbar <- as.vector(attr(x, 'scaled:center'))  
  QR   <- qr(x, ...)
  Q    <- qr.Q(QR)
  RR   <- qr.R(QR)
  sgns <- sign(diag(RR))
  # Each column of Q squared sums to 1; make sum of squares = n - 1
  # This makes SDs 1.0
  sn <- sqrt(n - 1)
  x     <- sweep(Q,  MARGIN = 2, STATS = sgns, FUN = `*`) * sn
  RR    <- sweep(RR, MARGIN = 1, STATS = sgns, FUN = `*`) / sn

  list(x=x, R = backsolve(RR, diag(p)), Ri = RR, xbar=xbar)
}

##' Computation of Coordinates of Extended Box Plots Elements
##'
##' For an extended box plots computes all the elements needed for plotting it.  This is typically used when adding to a `ggplot2` plot.
##' @title ebpcomp
##' @param x a numeric variable
##' @param qref quantiles for major corners
##' @param probs quantiles for minor corners
##' @return list with elements `segments`, `lines`, `points`, `points2`
##' @author Frank Harrell
##' @md
##' @examples
##' ebpcomp(1:1000)
ebpcomp <- function(x, qref=c(.5, .25, .75),
                    probs= c(.05, .125, .25, .375)) {
  w <- 1.

  x <- x[! is.na(x)]
  probs2 <- sort(c(probs, 1. - probs))

  m  <- length(probs)
  m2 <- length(probs2)
  j  <- c(1, sort(rep(2 : m2, 2)), - sort(- rep(1 : (m2 - 1),2)))
  z  <- c(sort(rep(probs, 2)),     - sort(- rep(probs[1 : (m - 1)], 2)))
  z  <- c(z, -z, probs[1])
  k  <- max(z)
  k  <- if(k > .48) .5 else k
  
  if(length(qref)) {
    size.qref <- pmin(qref, 1 - qref)
    size.qref[qref == .5] <- k
  }
  
  q  <- quantile(x, c(probs2, qref))
  qo <- quantile(x, c(0.01, 0.99))
  Segs <- if(length(qref)) list(x=q[-(1 : m2)],
                                y1= -w * size.qref / k,
                                y2=  w * size.qref / k)
  Lines <- list(x=q[j], y=w * z / k)
  Mean  <- list(x=mean(x), y=0, N=length(x))
  Extreme <- list(x=qo, y=0)
  return(list(segments=Segs, lines=Lines, points=Mean, points2=Extreme))
}

##' Compute Elements of a Spike Histogram
##'
##' Derives the line segment coordinates need to draw a spike histogram.  This is useful for adding elements to `ggplot2` plots and for the `describe` function to construct spike histograms.  Date/time variables are handled by doing calculations on the underlying numeric scale then converting back to the original class.  For them the left endpoint of the first bin is taken as the minimal data value instead of rounded using `pretty()`.
##' @title spikecomp
##' @param x a numeric variable
##' @param method specifies the binning and output method.  The default is `'tryactual'` and is intended to be used for spike histograms plotted in a way that allows for random x-coordinates and data gaps.  No binning is done if there are less than 100 distinct values and the closest distinct `x` values are distinguishable (not with 1/500th of the data range of each other).  Binning uses `pretty`.  When `trans` is specified to transform `x` to reduce long tails due to outliers, `pretty` rounding is not done, and `lumptails` is ignored.  `method='grid'` is intended for sparkline spike histograms drawn with bar charts, where plotting is done in a way that x-coordinates must be equally spaced.  For this method, extensive binning information is returned.  For either `'tryactual'` or `'grid'`, the default if `trans` is omitted is to put all values beyond the 0.01 or 0.99 quantiles into a single bin so that outliers will not create long nearly empty tails.  When `y` is specified, `method` is ignored.
##' @param lumptails the quantile to use for lumping values into a single left and a single right bin for two of the methods.  When outer quantiles using `lumptails` equal outer quantiles using `2*lumptails`, `lumptails` is ignored as this indicates a large number of ties in the tails of the distribution.
##' @param normalize set to `FALSE` to not divide frequencies by maximum frequency
##' @param y a vector of frequencies corresponding to `x` if you want the (`x`, `y`) pairs to be taken as a possibly irregular-spaced frequency tabulation for which you want to convert to a regularly-spaced tabulation like `count='tabulate'` produces.  If there is a constant gap between `x` values, the original pairs are return, with possible removal of `NA`s.
##' @param trans a list with three elements: the name of a transformation to make on `x`, the transformation function, and the inverse transformation function.  The latter is used for `method='grid'`.  When `trans` is given `lumptails` is ignored.  `trans` applies only to `method='tryactual'`.
##' @param tresult applies only to `method='tryactual'`.  The default `'list'` returns a list with elements `x`, `y`, and `roundedTo`.  `method='segments'` returns a list suitable for drawing line segments, with elements `x, y1, y2`.  `method='roundeddata'` returns a list with elements `x` (non-tabulated rounded data vector after excluding `NA`s) and vector `roundedTo`.
##' @return when `y` is specified, a list with elements `x` and `y`.  When `method='tryactual'` the returned value depends on `tresult`.  For `method='grid'`, a list with elements `x` and `y` and scalar element `roundedTo` containing the typical bin width.  Here `x` is a character string.
##' @author Frank Harrell
##' @md
##' @examples
##' spikecomp(1:1000)
##' spikecomp(1:1000, method='grid')
##' \dontrun{
##' On a data.table d use ggplot2 to make spike histograms by country and sex groups
##' s <- d[, spikecomp(x, tresult='segments'), by=.(country, sex)]
##' ggplot(s) + geom_segment(aes(x=x, y=y1, xend=x, yend=y2, alpha=I(0.3))) +
##'    scale_y_continuous(breaks=NULL, labels=NULL) + ylab('') +
##'    facet_grid(country ~ sex)
##' }

spikecomp <- function(x, method=c('tryactual', 'simple', 'grid'),
                      lumptails=0.01, normalize=TRUE, y, trans=NULL,
                      tresult=c('list', 'segments', 'roundeddata')) {

  method  <- match.arg(method)
  tresult <- match.arg(tresult)
  
  cx <- intersect(class(x),
                  c("Date", "POSIXt", "POSIXct", "dates", "times", "chron"))
  isdot <- testDateTime(x, 'either')    # date, time, or date-time var.
  if(length(cx)) x <- unclass(x)
  reclass <-
    if(length(cx)) function(x) structure(x, class=cx) else function(x) x

  ## floor(x) accounting for inexact decimal arithmetic, e.g.
  ## (0.58 - 0.48) / 0.01 = 0.99999999999998, signif -> 10.0
  floors <- function(x) floor(signif(x, 12))
  
  tpres  <- length(trans)
  ftrans <- itrans <- function(x) x
  if(tpres) {
    ftrans <- trans[[2]]
    itrans <- trans[[3]]
    lumptails <- 0.0
  }

  if(! missing(y)) {
    i <- ! is.na(x + y)
    x <- x[i]; y <- y[i]
    } else x <- x[! is.na(x)]

  xo <- x           # original x before rounding/curtailing/trans
  x  <- ftrans(unclass(x))
  
  ## y is specified; re-align a grid
  if(! missing(y)) {
    if(length(unique(diff(sort(x)))) == 1)
      return(list(x=reclass(x), y=y))
    if(! all(y == round(y))) stop('y must be integer for spikecomp')
    p <- pretty(range(x), 100)
    r <- if(length(cx)) range(x) else range(p)
    delta <- p[2] - p[1]
    xg <- seq(r[1], r[2], by=delta)
    xi <- 1 + round((x - r[1]) / delta)
    if(any(xi < 1))
      warning('possible logic error in spikecomp when y was specified')
    f <- tabulate(rep(xi, y))
    l <- min(length(f), length(xg))
    return(list(x=reclass(itrans(xg[1:l])), y=f[1:l]))
  }
  
  ux      <- sort(unique(x))
  nd      <- length(ux)  # no. distinct x
  closest <- min(diff(ux))
  qu      <- quantile(x, c(lumptails, 1. - lumptails), type=1)
  sgn <- function(x) if(isdot) x else signif(x, 6)
  qu  <- sgn(qu)
  qu2 <- sgn(quantile(x, c(2. * lumptails, 1. - 2. * lumptails), type=1))
 
  if(method == 'tryactual') {
    leavealone <- FALSE
    r <- range(x)
    d <- diff(r) / 100.
    if(tpres) p <- seq(r[1], r[2], d)
    else if(nd >= 100 || (nd > 20 && closest < d / 500.)) {
      if(lumptails > 0.) {
        if(qu[1] == qu2[1]) qu[1] <- -Inf
        if(qu[2] == qu2[2]) qu[2] <- Inf
      }
      uxc <- if(lumptails == 0.) ux else ux[ux > qu[1] & ux < qu[2]]
      p   <- pretty(uxc, 100)
      d   <- p[2] - p[1]
      r   <- range(p)
    } else if(nd <= 100) leavealone <- TRUE
    if(leavealone) d <- 0.
    else {
      ix <- 1 + floors((x - r[1]) / d)
      x  <- r[1] + (ix - 1) * d
      }
    if(tresult == 'roundeddata')
      return(list(x = reclass(itrans(x)), roundedTo=d))

    tab <- table(x)
    y   <- unname(tab)
    if(normalize) y <- y / max(y)
    x   <- reclass(itrans(as.numeric(names(tab))))
    return(
    switch(tresult,
           list     = list(x = x, y = y, roundedTo = d),
           segments = list(x = as.vector(x), y1 = rep(0., length(y)), y2 = as.vector(y),
                           roundedTo = d) ) )
  }

  ## method = 'grid'

  # Find limits such that most of the data are interior to these limits
  # The limits start with the outer quantiles (default 0.01, 0.99)
  # When an outer quantile equals the quantile at twice the probability (0.02, 0.98),
  # ignore the quantile and don't set limits.
  # Then take the interior values and run through pretty(..., 100).
  ## If the lowest pretty value is <= the current lower limit,
  ## remove all pretty values <= lower limit and replace lower limit
  ## with highest x < remaining pretty values
  ## Similar for pretty values >= upper limit

  lims <- qu
  lf <- rt <- TRUE
  if(qu2[1] == qu[1]) lf <- FALSE
  if(qu2[2] == qu[2]) rt <- FALSE
  lims     <- sgn(lims)
  ux       <- sgn(ux)
  uxinside <- if(lf) ux[ux > lims[1]] else ux
  if(rt) uxinside <- uxinside[uxinside < lims[2]]
  p    <- pretty(uxinside, 100)
  psgn <- sgn(p)
  if(psgn[1] != psgn[2]) p <- psgn  
  r <- range(p)
  if(lf && r[1] <= lims[1]) {
    p <- p[p > lims[1]]
    lims[1] <- max(ux[ux < min(p)])
  }
  if(rt && r[2] >= lims[2]) {
    p <- p[p < lims[2]]
    lims[2] <- min(x[x > max(p)])
  }
  r <- range(p)
  d <- p[2] - p[1]
  ## Don't let increment go below the closest together observed data
  d <- max(min(diff(uxinside)), p[2] - p[1])
  p <- seq(r[1], r[2], d)
  
  ## Make an integer version ix of x as follows
  ## Let k be the number intervals formed by the remaining pretty values
  ## (length(p) - 1).
  ## For x <= lims[1] let ix=1
  ## For interior x between lims[1] and lims[2] exclusive, let
  ## ix=2, 3, ..., k+1
  ## For x >= lims[2] let ix=k+2
  ## This works with tabulate() which tabulates positive integers only
  k  <- length(p) - 1
  ## pmin(k + 1, ...) makes last interval inclusive
  ix <- pmin(k + 1, 2 + floors((x - r[1]) / d))
  if(! lf && any(ix < 2)) warning('possible logic error 1 in spikecomp')
  if(lf) ix[x < r[1]] <- 1
  if(rt) ix[x > r[2]] <- k + 2

  freq <- tabulate(ix)
  ## Shift left one position of left tail curtailment was not done
  if((freq[1] > 0) != lf) warning('program logic error 2 in spikecomp')
  if(! lf) freq <- freq[-1]
  
  gr <- function(x) {
    lu <- length(unique(x))
    if(lu <= 10) {
      tab <- table(sgn(x))
      paste(paste0(names(tab),
                   ifelse(tab == 1, '', paste0(' (', tab, ')'))),
            collapse='; ')
    }
    else {
      xr <- sgn(range(x))
      if(xr[1] == xr[2]) xr[1]
      else paste0(xr[1], ' - ', xr[2], ' (',
                  lu, ' distinct)')
    }
  }
  
  class(xo)    <- cx
  fqu          <- sgn(itrans(qu))
  class(fqu)   <- cx
  fp           <- sgn(itrans(p))
  class(fp)    <- cx
  xrange       <- rep('', length(freq))
  xrnz         <- as.vector(tapply(xo, ix, gr))
 
  xrange[freq != 0] <- xrnz
  closep <- rep(')', length(fp) - 1)
  closep[length(closep)] <- ']'
  bins <- c(if(lf)
              paste0('[', min(xo), ', ', fp[1], ')'),
            paste0('[', fp[-length(fp)], ', ', fp[-1], closep),
            if(rt)
              paste0('(', fp[length(p)], ', ', max(xo), ']') )
  xrange <- paste0('Bin: ', bins, '<br>Observed:<br>', xrange)
  quf <- paste0('Q<sub>', c(lumptails, 1. - lumptails), '</sub>:',
                if(isdot) fqu else signif(fqu))
  if(lf) xrange[1] <- paste0(quf[1], '<br>', xrange[1])
  if(rt) xrange[length(xrange)] <-
           paste0(quf[2], '<br>', xrange[length(xrange)])
  if(length(xrange) != length(freq))
    warning('program logic error in spikecomp; lengths: ',
         length(xrange), ' ', length(freq))
  list(x=xrange, y=freq / (if(normalize) max(freq) else 1.),
       roundedTo=d)
  }

#' Debug Printing Function Generator
#' 
#' Takes the name of a system `options(opt=)` and checks to see if option `opt` is
#' set to `TRUE`, taking its default value to be `FALSE`.  If `TRUE`, a function is
#' created that calls [prn()] to print an object with the object's name in the
#' description along with the option name and the name of the function within which
#' the generated function was called, if any.  If option `opt` is not set, a dummy function
#' is generated instead.  If `options(debug_file=)` is set when the generated function
#' is called, [prn()] output will be appended to that file name instead of the console.
#' At any time, set `options(debug_file='')` to resume printing to the console.
#'
#' @param opt character string containing an option name
#'
#' @returns a function
#' @export
#' @md
#' @author Fran Harrell
#'
#' @examples
#' dfun <- Fdebug('my_option_name')   # my_option_name not currently set
#' dfun
#' dfun(sqrt(2))
#' options(my_option_name=TRUE)
#' dfun <- Fdebug('my_option_name')
#' dfun
#' dfun(sqrt(2))
#' # options(debug_file='/tmp/z') to append output to /tmp/z
#' options(my_option_name=NULL)
Fdebug <- function(opt) {
  if(getOption(opt, FALSE)) {
    deb <- function(x, txt, callingfun, file=getOption('debug_file', '')) {
      if(length(callingfun))
        txt  <- paste0(txt, ': ', callingfun)
      head <- deparse(substitute(x), width.cutoff=500)[1]
      prn(x, txt, head=head, file=file)
    }
  formals(deb)$txt <- opt
  formals(deb)$callingfun <- as.character(sys.call(-1)[1])
  }
  else deb <- function(x, txt, callingfun, file) {NULL}
  deb
}

#' Moving and Hiding Table of Contents
#' 
#' Moving and hiding table of contents for Rmd HTML documents
#' 
#' \code{hidingTOC} creates a table of contents in a Rmd document that
#' can be hidden at the press of a button. It also generate buttons that allow
#' the hiding or unhiding of the diffrent level depths of the table of contents.
#'
#' @param buttonLabel the text on the button that hides and unhides the
#'   table of contents. Defaults to \code{Contents}.
#' @param levels the max depth of the table of contents that it is desired to
#'   have control over the display of.  (defaults to 3)
#' @param posCollapse if \code{'margin'} then display the depth select buttons
#'   vertically along the side of the page choosen by \code{buttonSide}. If
#'   \code{'top'} then display the depth select buttons horizontally under the
#'   button that hides the TOC. Defaults to \code{'margin'}. \code{'bottom'} is
#'   currently unimplemented.
#' @param tocSide which side of the page should the table of contents be placed
#'   on. Can be either \code{'right'} or \code{'left'}. Defaults to
#'   \code{'right'}
#' @param buttonSide which side of the page should the button that hides the TOC
#'   be placed on. Can be either \code{'right'} or \code{'left'}. Defaults to
#'   \code{'right'}
#' @param hidden Logical should the table of contents be hidden at page load
#'   Defaults to \code{FALSE}
#'
#' @return a HTML formated text string to be inserted into an markdown document
#' @author Thomas Dupont
#' @examples
#' \dontrun{
#' hidingTOC()
#' }
#' @export

hidingTOC <- function(buttonLabel="Contents", levels=3,
                      tocSide=c('right','left'), buttonSide=c('right','left'),
                      posCollapse=c('margin','top','bottom'), hidden=FALSE) {

    ## Make javascript functions that controll the hiding and unhiding of
    ## different levels of the TOC
    ## This is done by switching on elements with id equal to TOC or class equal
    ## tocify-subheader and with attribute data-tag values less then or equal to
    ## the requested level and by switching off elements with attribute data-tag
    ## values greater then the requested level.
    makeLevelExpandFun <- function(level, maxLevels) {
        ## Sanity check to make sure that level is never greater then maxLevels
        if (level > maxLevels)
            stop("level value ", level, " is greater then maxLevels value ", maxLevels)

        ## There are 2 special cases.
        return(if (level == 1L) {
                   ## Where the reqested level equals 1. Unhide the element with id
                   ## equal to TOC and hide the elements with class equal to
                   ## tocify-subheader.
                   'function expandLevel1(){$("#TOC").toggle(true);$(".tocify-subheader").toggle(false)}'
               } else if (level == maxLevels) {
                   ## Where the requested level is equal to maxLevels then just unhide
                   ## all elements with id equal to TOC or class equal to
                   ## tocify-subheader.
                   paste0('function expandLevel', level, '(){$("#TOC,.tocify-subheader").toggle(true)}')
               } else {
                   ## General case level greater then 1 and less then maxLevels. Unhide
                   ## the elements with id equal to TOC or class equal to
                   ## tocify-subheader with attribute data-tag values less then or
                   ## equal to the requested level. Then hide elements with class
                   ## tocify-subheader with attribute data-tag values greater then the
                   ## requested level but less then or equal to maxLevels.
                   paste0("function expandLevel", level, '(){$("#TOC,',
                          paste0('.tocify-subheader[data-tag=',seq.int(2L, level),']', collapse=','),
                          '").toggle(true);$("',
                          paste0('.tocify-subheader[data-tag=',seq.int(level+1L, maxLevels),']', collapse=','),
                          '").toggle(false)}')
               })
    }

    ## basic HTML skeleton to inwhich to place various values
    skeleton <- '<style type="text/css">%s</style><script>function toggleTOC(){$("#TOC").toggle();$(".toc-level-select-group").toggle()}%s</script><div id="toc-controls">%s<br/>%s</div>
'
    buttonSide <- match.arg(buttonSide)
    tocSide <- match.arg(tocSide)
    posCollapse <- match.arg(posCollapse)
    if(posCollapse == 'bottom') {
        stop("arguement posCollapse = bottom is not supported yet")
    }

    if(tocSide != buttonSide)
        stop("non-symmetric values for tocSide and buttonSide are not supported")
    
    if(!missing(hidden) && (length(hidden) == 0L || (!is.logical(hidden) && !is.numeric(hidden))))
        stop("hidden must be of logical type")

    levelSequence <- seq_len(levels)

    ## CSS text
    cssText <- paste0(".toc-level-select-group{clear:both}#TOC{position:fixed;top:0;",
                      tocSide, ':0;margin:',
                      switch(posCollapse,
                             margin = '23px ',
                             top = '44px '),
                      switch(posCollapse,
                             margin = '20px ',
                             top = '0px '),
                      '20px ',
                      switch(posCollapse,
                             margin = '20px',
                             top = '0px'),
                      ';z-index:9',
                      if(hidden) ";display:none",
                      '}#toc-controls{position:fixed;top:0;',
                      buttonSide, ':0;margin:0px}.col-md-3{width: 0%}.col-md-9{width: 100%}',
                      'div.container-fluid.main-container{max-width:none;margin-left:0px;margin-right:none}')



    ## Generate the javascript text needed for the TOC level display buttons'
    ## functions.
    scriptText <- paste0(vapply(levelSequence, makeLevelExpandFun, "", maxLevels=levels),
                         collapse="")

    ## Which side the buttons should be pulled to.
    pullClass <- if(buttonSide == "right") {
                     "pull-right"
                 } else {
                     "pull-left"
                 }

    ## Generate the hiding button HTML text.
    buttonText <- paste0('<button type="button" id="toc-toggle" class="btn btn-default btn-xs toc-folding-btn ',
                         pullClass, '" onclick="toggleTOC()">', buttonLabel, '</button>')
    
    ## Generate the level buttons' HTML text.
    levelButtonText <- paste0('<div class="toc-level-select-group',
                              switch(posCollapse,
                                     margin = paste0(" ", pullClass),
                                     ""),
                              '">',
                              paste0('<button id="toc-expand-level', levelSequence,
                                     '" type="button" class="btn btn-default btn-xs toc-collapsing-btn',
                                     switch(posCollapse,
                                            margin = paste0(" ", pullClass),
                                            ""),
                                     '" onclick="expandLevel',
                                     levelSequence, '()">', levelSequence, '</button>',
                                     collapse=switch(posCollapse,
                                                     margin = "<br/>",
                                                     top="",
                                                     stop("Unknown value for posCollapse ", posCollapse))),
                              "</div>")

    return(sprintf(skeleton, cssText, scriptText, buttonText, levelButtonText))
}

require(rms)

set.seed(1)
n <- 500
x1 <- runif(n)
x2 <- runif(n)
L  <- x1 + 2*x2
y  <- rbinom(n, 1, plogis(L))
x2[1:300] <- NA
d <- data.frame(x1, x2, y)
a <- aregImpute(~ y + x1 + x2, n.impute=50, data=d)

f <- fit.mult.impute(y ~ x1 + x2, lrm, a, data=d)
f
anova(f)

h <- fit.mult.impute(y ~ x1 + x2, lrm, a, data=d, lrt=TRUE)
processMI(h, which='anova')

##' Render `plotly` Graphic from a `ggplot2` Object
##'
##' Uses `plotly::ggplotly()` to render a `plotly` graphic with a specified tooltip attribute, removing extraneous text that `ggplotly` puts in hover text when `tooltip='label'`
##' @title ggplotlyr
##' @param ggobject an object produced by `ggplot`
##' @param tooltip attribute specified to `ggplot` to hold hover text
##' @param remove extraneous text to remove from hover text.  Default is set to assume `tooltip='label'` and assumed the user specified `aes(..., label=txt)`.  If you instead specified `aes(..., label=myvar)` use `remove='myvar: '`.
##' @param ... other arguments passed to `ggplotly`
##' @return a `plotly` object
##' @author Frank Harrell
##' @export
##' @md
ggplotlyr <- function(ggobject, tooltip='label', remove='txt: ', ...) {
  
  if (!requireNamespace("plotly"))
    stop("This function requires the 'plotly' package.")
  
# Get around a bug in tooltip construction with ggplotly
# See https://stackoverflow.com/questions/66316337
  g <- plotly::ggplotly(ggobject, tooltip=tooltip, ...)
	if(! length(remove) || remove == '') return(g)
  d <- g$x$data
  for(i in 1 : length(d)) {
    w <- d[[i]]$text
     if(length(w)) d[[i]]$text <- gsub(remove, '', w)
	  }
   g$x$data <- d
   g
	}

##' Store and Encrypt R Objects or Files or Read and Decrypt Them
##'
##' `qcrypt` is used to protect sensitive information on a user's computer or when transmitting a copy of the file to another R user.  Unencrypted information only exists for a moment, and the encryption password does not appear in the user's script but instead is managed by the `keyring` package to remember the password across R sessions, and the `getPass` package, which pops up a password entry window and does not allow the password to be visible.  The password is requested only once, except perhaps when the user logs out of their operating system session or reboots.
##'
##' The keyring can be bypassed and the password entered in a popup window by specifying `service=NA`.  This is the preferred approach when sending an encrypted file to a user on a different computer.
##'
##' `qcrypt` writes R objects to disk in a temporary file using the `qs2` package `qs_save` function.  The file is quickly encrypted using the `safer` package, and the temporary unencrypted `qs2` file is deleted.  When reading an encrypted file the process is reversed and uses `qs2::qs_read`.
##'
##' To save an object in an encrypted file, specify the object as the first argument `obj` and specify a base file name as a character string in the second argument `base`.  The full `qs2` file name will be of the form `base.qs2.encrypted` in the user's current working directory.  To unencrypt the file into a short-lived temporary file and use `qs2::qs_read` to read it, specify the base file name as a character string with the first argument, and do not specify the `base` argument.
##'
##' Alternatively, `qcrypt` can be used to encrypt or decrypt existing files of any type using the same password and keyring mechanism.  The former is done by specifying `file` that does not end in `'.encrypted'` and the latter is done by ending `file` with `'.encrypted'`.  When `file` does not contain a path it is assumed to be in the current working directory.  When a file is encrypted the original file is removed.  Files are decrypted into a temporary directory created by `tempdir()`, with the name of the file being the value of `file` with `'.encrypted'` removed.
##'
##' Interactive password provision works when running `R`, `Rscript`, `RStudio`, or `Quarto` but does not work when running `R CMD BATCH`.  `getPass` fails under `RStudio` on Macs.
##'
##' It is also possible to pass the password as the `pw` argument.  This is only safe if running interactively and the password is defined by typing e.g. `pw <- 'whateverpassword'` in the console, then running the script interactively with `pw=pw` added to the `qcrypt` call.
##'
##' See [R Workflow](https://hbiostat.org/rflow/fcreate.html#sec-fcreate-secure) for more information.
##' @title qcrypt
##' @param obj an R object to write to disk and encrypt (if `base` is specified) or the base file name to read and uncrypted (if `base` is not specified).  Not used when `file` is given.
##' @param base base file name when creating a file.  Not used when `file` is given.
##' @param service a fairly arbitrary `keyring` service name.  The default is almost always OK unless you need to use different passwords for different files.  `service` is ignored if `pw` is specified as an argument.
##' @param file full name of file to encrypt or decrypt
##' @param pw a single character string containing an actual password
##' @return (invisibly) the full encrypted file name if writing the file, or the restored R object if reading the file.  When decrypting a general file with `file=`, the returned value is the full path to a temporary file containing the decrypted data.
##' @author Frank Harrell
##' @md
##' @export
##' @examples
##' \dontrun{
##' # Suppose x is a data.table or data.frame
##' # The first time qcrypt is run with a service a password will
##' # be requested.  It will be remembered across sessions thanks to
##' # the keyring package
##' qcrypt(x, 'x')   # creates x.qs2.encrypted in current working directory
##' x <- qcrypt('x') # unencrypts x.qs2.encrypted into a temporary
##'                  # directory, uses qs2::qs_read to read it, and
##'                  # stores the result in x
##' # Encrypt a general file using a different password
##' qcrypt(file='report.pdf', service='pdfkey')
##' # Decrypt that file
##' fi <- qcrypt(file='report.pdf.encrypted', service='pdfkey')
##' fi contains the full unencrypted file name which is in a temporary directory
##' # Encrypt without using a keyring
##' qcrypt(x, 'x', service=NA)
##' x <- qcrypt('x', service=NA)
##'
##' pw <- 'somepassword'     # run this in the console
##' x <- qcrypt('x', pw=pw)  # interactively run this in a script
##' }
qcrypt <- function(obj, base, service = "R-keyring-service", file, pw) {
  if (missing(pw)) {
    if (!is.na(service) && !requireNamespace("keyring", quietly = TRUE)) {
      stop("you must install the keyring package to use qcrypt with service != NA")
    }
    if (!requireNamespace("getPass", quietly = TRUE)) {
      stop("you must install the getPass package to use qcrypt")
    }
    if (!requireNamespace("qs2", quietly = TRUE)) {
      stop("you must install the qs2 package to use qcrypt")
    }
    if (!requireNamespace("safer", quietly = TRUE)) {
      stop("you must install the safer package to use qcrypt")
    }

    if (is.na(service)) {
      prompt <- if (!missing(base)) {
        "Define password for storing encrypted data: "
      } else {
        "Enter password previously used to store data: "
      }
      pw <- getPass::getPass(msg = prompt, noblank = TRUE)
    } else {
      pw <- tryCatch(keyring::key_get(service), error = function(...) "")

      if (pw == "") {
        prompt <- if (!missing(base)) {
          "Define password for storing encrypted data: "
        } else {
          "Enter password previously used to store data: "
        }
        pw <- getPass::getPass(msg = prompt, noblank = TRUE)
        keyring::key_set_with_value(service, password = pw)
      }
      pw <- keyring::key_get(service)
    }
  }
  tf <- tempfile()

  if (!missing(file)) {
    if (!grepl("\\.encrypted$", file)) { # encrypt
      f <- paste0(file, ".encrypted")
      unlink(f) # just in case; encrypt_file throws an error if file exists
      safer::encrypt_file(file, key = pw, outfile = f)
      unlink(file)
      return(invisible(f))
    } else { # decrypt
      fout <- paste(tempdir(), sub("\\.encrypted$", "", basename(file)), sep = "/")
      safer::decrypt_file(file, key = pw, outfile = fout)
      return(invisible(fout))
    }
  }

  if (!missing(base)) { # base specified -> create file
    qs2::qs_save(obj, tf)
    f <- paste0(base, ".qs2.encrypted")
    unlink(f) # just in case
    safer::encrypt_file(tf, key = pw, outfile = f)
    unlink(tf) # quickly remove unencrypted file
    return(invisible(f))
  }

  # base is missing and base file name is assumed to be in the first argument, obs

  f <- paste0(obj, ".qs2.encrypted")
  safer::decrypt_file(f, key = pw, outfile = tf)
  x <- qs2::qs_read(tf)
  unlink(tf) # quickly remove unencrypted file
  x
}

##' Plot Correlation Matrix and Correlation vs. Time Gap
##'
##' Constructs two `ggplot2` graphics.  The first is a half matrix of rectangles where the height of the rectangle is proportional to the absolute value of the correlation coefficient, with positive and negative coefficients shown in different colors.  The second graphic is a variogram-like graph of correlation coefficients on the y-axis and absolute time gap on the x-axis, with a `loess` smoother added.  The times are obtained from the correlation matrix's row and column names if these are numeric.  If any names are not numeric, the times are taken as the integers 1, 2, 3, ...  The two graphics are `ggplotly`-ready if you use `plotly::ggplotly(..., tooltip='label')`.
##' @title plotCorrM
##' @param r correlation matrix
##' @param what specifies whether to return plots or the data frame used in making the plots
##' @param type specifies whether to use bottom-aligned rectangles (the default) or centered circles
##' @param xlab x-axis label for correlation matrix
##' @param ylab y-axis label for correlation matrix
##' @param maxsize maximum circle size if `type='circle'`
##' @param xangle angle for placing x-axis labels, defaulting to 0.  Consider using `xangle=45` when labels are long.
##' @return a list containing two `ggplot2` objects if `what='plots'`, or a data frame if `what='data'`
##' @author Frank Harrell
##' @md
##' @export
##' @examples
##' set.seed(1)
##' r <- cor(matrix(rnorm(100), ncol=10))
##' g <- plotCorrM(r)
##' g[[1]]  # plot matrix
##' g[[2]]  # plot correlation vs gap time
##' # ggplotlyr(g[[2]])
##' # ggplotlyr uses ggplotly with tooltip='label' then removes
##' # txt: from hover text
plotCorrM <- function(r, what=c('plots', 'data'),
                      type=c('rectangle', 'circle'),
                      xlab='', ylab='', maxsize=12, xangle=0) {
  what <- match.arg(what)
  type <- match.arg(type)
  p <- dim(r)[1]
  v <- dimnames(r)[[1]]
  if(! length(v)) v <- as.character(1 : p)
  vn <- as.numeric(v)
  if(any(is.na(vn))) vn <- 1 : p

  mn  <- min(abs(r))
  R   <- as.vector(r)
  x   <- as.vector(col(r))
  y   <- as.vector(row(r))
  txt <- paste0(v[x], ' vs. ', v[y], '<br>r=', round(R, 3))
  d   <- subset(data.frame(x, y, delta=abs(vn[x] - vn[y]), r=R, txt), x < y)
  if(what == 'data') return(d)
  mx <- max(abs(d$r))
  
  g1 <-
    switch(type,
           rectangle = ggplot(d,
                              aes(x=x, y=y,
                                  color=ifelse(r > 0, '+', '-'), label=txt)) +
             geom_segment(aes(x=x, y=y, xend=x, yend=y + 0.9 * abs(r) / mx),
                          size=3),
           circle    = ggplot(d,
                              aes(x=x, y=y,
                                  color=ifelse(r > 0, '+', '-'), label=txt,
                                  size=abs(r))) +
             geom_point() + scale_size(range = c(0, maxsize)) )
           
    g1 <- g1 + scale_x_continuous(breaks = 1 : p, labels=v) +
      scale_y_continuous(breaks = 1 : p, labels=v) +
      guides(color = guide_legend(title=''),
             size  = guide_legend(title='r')) +
      xlab(xlab) + ylab(ylab) +
      theme(axis.text.x=element_text(angle=xangle,
                                     hjust=if(xangle != 0) 1)) +
      labs(subtitle=paste0('max |r|:', round(mx, 3),
                           '  min |r|:', round(mn, 3)))
  
  # Would not run loess if use text=txt
  # Need to run ggplotly with tooltip='label'
  g2 <- ggplot(d, aes(x=delta, y=r, label=txt)) +
    geom_point() + geom_smooth(method=loess) +
    xlab('Absolute Time Difference') + ylab('Correlation')
  list(g1, g2)
  }

utils::globalVariables('delta')

! Converted from Ratfor 2024-10-26 using ChatGPT and the following request:
! Convert the following Ratfor code to Fortran 2018 using Fortran ISO environment without using module

subroutine jacklins(x, w, n, k, res)
    use ISO_FORTRAN_ENV, only: REAL64, INT32
    implicit none
  
    integer(INT32), intent(in) :: n, k
    real(REAL64), intent(in) :: x(n), w(n-1, k)
    real(REAL64), intent(out) :: res(n, k)
    integer(INT32) :: l, j, i
    real(REAL64) :: sj
  
    ! Compute leave-out-one linear statistics for each column
    do l = 1, k
      do j = 1, n
        sj = 0.0_REAL64
        do i = 1, n
          if (i < j) then
            sj = sj + w(i, l) * x(i)
          else if (i > j) then
            sj = sj + w(i - 1, l) * x(i)
          endif
        end do
        res(j, l) = sj
      end do
    end do
  
    return
  end subroutine jacklins

##' Simple HTML Table of Verbatim Output
##'
##' Uses `capture.output` to capture as character strings the results of
##' running `print()` on each element of `...`.  If an element of `...` has
##' length of 1 and is a blank string, nothing is printed for that cell
##' other than its name (not in verbatim).
##' @title htmltabc
##' @param ... objects to `print()`.  The arguments must be named with the labels you want to print before the verbatim `print()`.
##' @param cols number of columns in the html table
##' @param propts an option list of arguments to pass to the `print()` methods; default is to not quote character strings
##' @return character string of html
##' @author Frank Harrell
##' @md
htmltabv <- function(..., cols=2, propts=list(quote=FALSE)) {
  tab <- function(x, nam) {
    nr <- ceiling(length(x) / cols)
    w  <- character(nr)
    j <- 1
    for(i in 1 : nr) {
      xx <- x[j : min(j + cols - 1, length(x))]
      if(length(xx) < cols) xx <- c(xx, rep('', cols - length(xx)))
      w[i] <- paste0('<tr>', paste(paste0('<td>', xx, '</td>'),
                                   collapse='<td>&nbsp;</td>'),
                     '</tr>')
      j <- j + cols
    }
    w
  }
  dot <- list(...)
  nam <- names(dot)
  n <- length(dot)
  x <- character(n)
  for(i in 1 : n) {
    di <- dot[[i]]
    z <- if(length(di) == 1 && trimws(di) == '') di
    else capture.output(do.call('print', c(list(dot[[i]]), propts)))
    z <- paste(z, collapse='\n')
    x[i] <- paste0(nam[i], '<pre>', z, '</pre>')
    }
  paste0('<table>', paste(tab(x, nam), collapse=' '),  '</table>\n')
}

library(rms)
set.seed(4)
n <- c(20000,2000,200)[1]
x2 <- rnorm(n)
x1 <- sqrt(.5) * x2 + rnorm(n, sd=sqrt(1-.5))
y  <- 1 * x1 + 1 * x2 + rnorm(n)

type <- c('mcar','mar.x2')[2]

x1m <- if(type=='mcar') ifelse(runif(n) < .5, x1, NA) else
 ifelse(rnorm(n,sd=.8) < x2, x1, NA)  # MAR on x2, R2 50%, 50% missing
coef(ols(y ~ x1+x2))
coef(ols(y ~ x1m + x2))

Ecdf(x1)
Ecdf(x1m, lty=2, add=TRUE)
Ecdf(x1[is.na(x1m)], lty=2, lwd=3, add=TRUE)

plot(x2, x1m)
plsmo(x2, is.na(x1m), datadensity=TRUE)
dd <- datadist(x2,x1m)
options(datadist='dd')
f <- lrm(is.na(x1m) ~ rcs(x2,4))
plot(Predict(f, x2, fun=plogis))


d <- data.frame(x1,x1m,x2,y)

# Find best-validating (in terms of bootstrap R^2) value of nk
g <- aregImpute(~ y + x1m + x2, nk=c(0,3:5), data=d)
g
# nk=0 is best with respect to mean and median absolute deviations
# Another good model is one that forces the target variable (x1m) to
# be transformed linearly using tlinear=TRUE

g <- aregImpute(~y + x1m + x2, nk=0, n.impute=5, data=d, pr=F, 
    type=c('pmm','regression')[1], plotTrans=FALSE)
s <- is.na(x1m)
c(mean(g$imputed$x1), mean(x1[s]))
ix1 <- g$imputed$x1[,5]
x1i <- x1m
x1i[s] <- ix1
rcorr(cbind(x1,x2,y)[s,])
rcorr(cbind(x1i,x2,y)[s,])
# allowing x1 to be nonlinearly transformed seems to increase the
# correlation between imputed x1 and x2 and imputed x1 and y,
# in addition to variance of imputed values increasing

f <- fit.mult.impute(y ~ x1m + x2, ols, xtrans=g, data=d, pr=F)
coef(f)



g2 <- g
g1 <- g
plot(g1)
# Ecdf(g2, add=TRUE, col='blue') ??

# For MARx2, pmm works reasonably well when nk=3, regression doesn't
# both work well when nk=0
# For MCAR, pmm works well when nk=3, regression works moderately
# well but imputed values have higher variance than real x1 values
# when x1m is missing, and coefficient of x2 on y is 0.92 when n=20000
# Did not get worse by setting nk=6
# Regression imputation works fine with nk=6 with ~y+I(x1m)+x2
# Problem with I(y)+x1m+I(x2)

plot(g)
Ecdf(x1, add=TRUE, col='blue')
Ecdf(x1m, lty=2, add=TRUE)
Ecdf(x1[is.na(x1m)], lty=2, lwd=3, add=TRUE)


# Look at distribution of residuals from areg for various nk
s <- !is.na(x1m)
f <- lm.fit.qr.bare(cbind(y,x2)[s,],x1m[s])
Ecdf(resid(f), lwd=2, col='gray')
py <- f$fitted.values
ry <- resid(f)

g <- areg(cbind(y,x2), x1m, nk=6, xtype=rep('l',2))
p <- g$linear.predictors
r <- resid(g)
Ecdf(r, add=TRUE, col='blue')

plot(py, p)
coef(lm.fit.qr.bare(py,p))
plot(ry,r)
coef(lm.fit.qr.bare(ry,r))
cor(ry,r)
sd(ry)
sd(r)
pr  <- predict(g, cbind(x1, x2))
pr2 <- g$linear.predictors
length(pr); length(pr2)
Pr <- fitted(f)
plot(Pr,pr2)

if(FALSE) {
obs.trans <- pr + r
plot(obs.trans, y)
w <- lm.fit.qr.bare(obs.trans,y)
coef(w)
w$rsquared
}

# Strip out aregImpute code for regression imputation, force linearity,
# no bootstrap, x1 is only variable with NAs

ai <- function(x1, x2, y) {
  n <- length(x1)
  na <- (1:n)[is.na(x1)]
  nna <- length(na)
  j <- (1:n)[-na]
  
  f <- lm.fit.qr.bare(cbind(y,x2)[j,], x1[j])
  prn(coef(f))
  
  # Predicted mean x1 for only those that missing:
  predx1 <- matxv(cbind(y,x2)[na,], coef(f))
  Ecdf(predx1, add=TRUE, col='blue')
  res <- f$residuals
  rp <- length(na) > length(res)
  px1  <- predx1 + sample(res, length(na), replace=rp)
  px1e <- approxExtrap(f$fitted.values, f$fitted.values, xout=px1)$y
  print(describe(abs(px1-px1e)))
  Ecdf(px1e, add=TRUE, col='green')
  x1[na] <- px1e
  x1
}

x1i <- ai(x1m, x2, y)
ols(y ~ x1i + x2)

subroutine cidxcp(x1,x2,y,e,n,method,outx,
	nrel,nuncer,c1,c2,gamma1,gamma2,gamma,sd,c12,c21)
implicit DOUBLE PRECISION (a-h,o-z)
DOUBLE PRECISION x1(n),x2(n),y(n)
logical e(n),outx
integer n,method,i,j
DOUBLE PRECISION nrel,nuncer,nconc1,nconc2,c1,c2,gamma1,gamma2,
	sumr,sumr2,sumw,sumw2,sumrw,
	wi,ri,sumc,c12,c21,gamma,sd
DOUBLE PRECISION dx,dx2,dy
nconc1=0d0;nconc2=0d0;nrel=0d0;nuncer=0d0;sumr=0d0;sumr2=0d0;sumw=0d0;
sumw2=0d0;sumrw=0d0;sumc=0d0;
do i=1,n {
  wi=0d0;ri=0d0;
  do j=1,n {
    dx=x1(i)-x1(j);dx2=x2(i)-x2(j);
    if((i!=j) & (!outx | dx!=0. | dx2!=0.)) {
      dy=y(i)-y(j);
      if ((e(i)&(dy<0.))|(e(i)&^e(j)&(dy==0.)))	{
        nrel=nrel+1d0;
        nconc1=nconc1+(z(dx<0.)+.5D0*z(dx==0.));
        nconc2=nconc2+(z(dx2<0.)+.5D0*z(dx2==0.));
        ri=ri+1d0;
        if (method==1) {
          wi=wi+(z(dx<dx2)-z(dx>dx2));
          sumc=sumc+z(dx<dx2);
        }
        else {
          wi=wi+(z(dx<0.&dx2>=0.)-z(dx>0.&dx2<=0.));
          sumc=sumc+z(dx<0.&dx2>=0.);
        }
      }
      else if ((e(j)&(dy>0.))|(e(j)&^e(i)&(dy==0.))) {
        nrel=nrel+1d0;
        nconc1=nconc1+(z(dx>0.)+.5D0*z(dx==0.));
        nconc2=nconc2+(z(dx2>0.)+.5D0*z(dx2==0.));
        ri=ri+1d0;
        if (method==1) {
          wi=wi+(z(dx>dx2)-z(dx<dx2));
          sumc=sumc+z(dx>dx2);
        }
        else {
          wi=wi+(z(dx>0.&dx2<=0.)-z(dx<0.&dx2>=0.));
          sumc=sumc+z(dx>0.&dx2<=0.);
        }
      }
      else if (^(e(i)&e(j))) nuncer=nuncer+1d0;
    }
  }
  sumr=sumr+ri; sumr2=sumr2+ri*ri
  sumw=sumw+wi; sumw2=sumw2+wi*wi; sumrw=sumrw+ri*wi
}
c1=nconc1/nrel; gamma1=2D0*(c1-.5D0);
c2=nconc2/nrel; gamma2=2D0*(c2-.5D0);
gamma=sumw/sumr
sd=sumr2*sumw**2-2D0*sumr*sumw*sumrw+sumw2*sumr**2;
sd=2D0*dsqrt(sd)/sumr/sumr;
c12=sumc/sumr; c21=sumc/sumr-gamma
return
end

function z(a)
DOUBLE PRECISION z
logical a
if(a)z=1d0
else z=0d0
return
end

require(Hmisc)
require(ggplot2)

set.seed(1)
n <- 1000000
x <- runif(n)
y <- x ^ 2 + runif(n)
system.time(f <- lowess(x, y))   # 1.3s
plot(f, type='l')

system.time(m <- movStats(y ~ x, melt=TRUE))   # 0.4s
ggplot(m, aes(x=x, y=y, color=Statistic)) + geom_line()

##' Moving Estimates Using Overlapping Windows
##'
##' Function to compute moving averages and other statistics as a function
##' of a continuous variable, possibly stratified by other variables.
##' Estimates are made by creating overlapping moving windows and
##' computing the statistics defined in the stat function for each window.
##' The default method, `space='n'` creates varying-width intervals each having a sample size of `2*eps +1`, and the smooth estimates are made every `xinc` observations.  Outer intervals are not symmetric in sample size (but the mean x in those intervals will reflect that) unless `eps=nignore`, as outer intervals are centered at observations `nignore` and `n - nignore + 1` where the default for `nignore` is 10.  The mean x-variable within each windows is taken to represent that window.  If `trans` and `itrans` are given, x means are computed on the `trans(x)` scale and then `itrans`'d.  For `space='x'`, by default estimates are made on to the `nignore` smallest to the `nignore` largest
##' observed values of the x variable to avoid extrapolation and to
##' help getting the moving statistics off on an adequate start for
##' the left tail.  Also by default the moving estimates are smoothed using `supsmu`.
##' When `melt=TRUE` you can feed the result into `ggplot` like this:
##' `ggplot(w, aes(x=age, y=crea, col=Type)) + geom_line() +`
##'   `facet_wrap(~ Statistic)`
##'
##' See [here](https://hbiostat.org/rflow/analysis.html#sec-analysis-assoc) for several examples.
##'
##' @title movStats
##' @author Frank Harrell
##' @md
##' @param formula a formula with the analysis variable on the left and the x-variable on the right, following by optional stratification variables
##' @param stat function of one argument that returns a named list of computed values.  Defaults to computing mean and quartiles + N except when y is binary in which case it computes moving proportions.  If y has two columns the default statistics are Kaplan-Meier estimates of cumulative incidence at a vector of `times`.
##' @param discrete set to `TRUE` if x-axis variable is discrete and no intervals should be created for windows
##' @param space defines whether intervals used fixed width or fixed sample size
##' @param eps tolerance for window (half width of window).  For `space='x'` is in data units, otherwise is the sample size for half the window, not counting the middle target point.
##' @param varyeps applies to `space='n'` and causes a smaller `eps` to be used in strata with fewer than `` observations so as to arrive at three x points
##' @param nignore see description, default is to exclude `nignore=10` points on the left and right tails from estimation and plotting
##' @param xinc increment in x to evaluate stats, default is xlim range/100 for `space='x'`.  For `space='n'` `xinc` defaults to m observations, where m = max(n/200, 1).
##' @param xlim 2-vector of limits to evaluate if `space='x'` (default is `nignore` smallest to `nignore` largest)
##' @param times vector of times for evaluating one minus Kaplan-Meier estimates
##' @param tunits time units when `times` is given
##' @param msmooth set to `'smoothed'` or `'both'` to compute `lowess`-smooth moving estimates. `msmooth='both'` will display both.  `'raw'` will display only the moving statistics.  `msmooth='smoothed'` (the default) will display only he smoothed moving estimates.
##' @param tsmooth defaults to the super-smoother `'supsmu'` for after-moving smoothing.  Use `tsmooth='lowess'` to instead use `lowess`.
##' @param bass the `supsmu` `bass` parameter used to smooth the moving statistics if `tsmooth='supsmu'`.  The default of 8 represents quite heavy smoothing.
##' @param span the `lowess` `span` used to smooth the moving statistics
##' @param maxdim passed to `hare`, default is 6
##' @param penalty passed to `hare`, default is to use BIC.  Specify 2 to use AIC.
##' @param trans transformation to apply to x
##' @param itrans inverse transformation
##' @param loess set to TRUE to also compute loess estimates
##' @param ols set to TRUE to include rcspline estimate of mean using ols
##' @param qreg set to TRUE to include quantile regression estimates w rcspline
##' @param lrm set to TRUE to include logistic regression estimates w rcspline
##' @param orm set to TRUE to include ordinal logistic regression estimates w rcspline (mean + quantiles in `tau`)
##' @param hare set to TRUE to include hazard regression estimtes of incidence at `times`, using the `polspline` package
##' @param ordsurv set to TRUE to include ordinal regression estimates of incidence at `times`, using the `rms` package `adapt_orm` and `survest.orm` functions
##' @param lrm_args a `list` of optional arguments to pass to `lrm` when `lrm=TRUE`, e.g., `list(maxit=20)`
##' @param family link function for ordinal regression (see `rms::orm`)
##' @param k number of knots to use for ols, lrm,  qreg restricted cubic splines.  Linearity is forced for binary `y` when the minimum of the number of events and number of non-events is below 10 for a by-group.  For `ordsurv=TRUE` is the maximum number of knots tried and is passed as argument `maxk` to the `rms` `adapt_orm` function.
##' @param tau quantile numbers to estimate with quantile regression
##' @param melt set to TRUE to melt data table and derive Type and Statistic
##' @param data data frame or data table to analyze
##' @param pr defaults to no printing of window information.  Use `pr='plain'` to print in the ordinary way, `pr='kable` to convert the object to `knitr::kable` and print, or `pr='margin'` to convert to `kable` and place in the `Quarto` right margin.  For the latter two `results='asis'` must be in the chunk header.
##' @param data data.table or data.frame, default is calling frame
##' @return a data table, with attribute `infon` which is a data frame with rows corresponding to strata and columns `N`, `Wmean`, `Wmin`, `Wmax` if `stat` computed `N`.  These summarize the number of observations used in the windows.  If `varyeps=TRUE` there is an additional column `eps` with the computed per-stratum `eps`.  When `space='n'` and `xinc` is not given, the computed `xinc` also appears as a column.  An additional attribute `info` is a `kable` object ready for printing to describe the window characteristics.
##'
movStats <- function(formula, stat=NULL, discrete=FALSE,
                     space=c('n', 'x'),
                     eps =if(space=='n') 15, varyeps=FALSE, nignore=10,
                     xinc=NULL, xlim=NULL,
                     times=NULL, tunits='year',
                     msmooth=c('smoothed', 'raw', 'both'),
                     tsmooth=c('supsmu', 'lowess'),
                     bass=8, span=1/4, maxdim=6, penalty=NULL,
                     trans=function(x) x, itrans=function(x) x,
                     loess=FALSE,
                     ols=FALSE, qreg=FALSE, lrm=FALSE,
                     orm=FALSE, hare=FALSE, ordsurv=FALSE,
                     lrm_args=NULL, family='logistic',
                     k=5, tau=(1:3)/4, melt=FALSE,
                     data=environment(formula),
                     pr=c('none', 'kable', 'plain', 'margin')) {
  space   <- match.arg(space)
  msmooth <- match.arg(msmooth)
  movlab  <- 'Moving '
  if(discrete) {
    msmooth <- 'raw'
    movlab  <- ''
    }
  else sform <- eval(bquote(y ~ rms::rcs(x, .(k))))

  tsmooth <- match.arg(tsmooth)
  pr      <- match.arg(pr)

  if(! requireNamespace('data.table', quietly=TRUE))
    stop('data.table package must be installed')
  if(ols || qreg || lrm)
    if(! requireNamespace('rms', quietly=TRUE))
      stop('rms package must be installed if using ols, qreg, or lrm')

  if(pr %in% c('kable', 'margin'))
    if(! requireNamespace('kableExtra', quietly=TRUE))
      stop('must install kableExtra package if pr is kable or margin')

  mf   <- model.frame(formula, data=data)
  v    <- names(mf)
  Y    <- mf[[1]]
  sec  <- NCOL(Y) == 2
  if(sec && ! length(times))
    stop('when dependent variable has two columns you must specify times')
  if(sec && (loess || ols || qreg || lrm || orm))
    stop('loess, ols, qreg, lrm, orm do not apply when dependent variable has two columns')
  if(varyeps && space == 'x')
    stop('varyeps applies only to space="n"')

  if(sec) {
    if(hare) if(! requireNamespace('polspline', quietly=TRUE))
               stop('polspline package must be installed if hare=TRUE')
    if(ordsurv) if(! requireNamespace('rms', quietly=TRUE))
               stop('rms package must be installed if ordsurv=TRUE')

    Y2 <- Y[, 2]
    Y  <- Y[, 1]
    } else Y2 <- rep(1, nrow(mf))

  X  <- trans(mf[[2]])
  bythere <- length(v) > 2
  By <- if(bythere)
          do.call(interaction, c(mf[3:length(mf)], list(sep='::')))
        else
          rep(1, length(X))
  i  <- is.na(X) | is.na(Y) | is.na(Y2) | is.na(By)
  if(any(i)) {
    i  <- ! i
    X  <- X [i]
    Y  <- Y [i]
    Y2 <- Y2[i]
    By <- By[i]
  }

  ybin <- ! sec && all(Y %in% 0:1)

  qformat <- function(x)
    fcase(x == 0.05, 'P5', x == 0.1, 'P10',
          x == 0.25, 'Q1', x == 0.5, 'Median', x == 0.75, 'Q3',
          x == 0.9, 'P90', x == 0.95, 'P95',
          default=as.character(x))


  if(! length(stat))
    stat <- if(ybin) function(y)
      if(discrete) list(Proportion = mean(y), N= length(y)) else
                   list('Moving Proportion' = mean(y), N = length(y))
            else if(sec)
              function(y, y2) {
                # km.quick is in Hmisc
                z <- c(1. - km.quick(survival::Surv(y, y2), times), length(y))
                names(z) <- c(paste0(movlab, times, '-', tunits), 'N')
                as.list(z)
              }
             else
              function(y) {
                if(! length(y)) return(list(Mean=NA, Median=NA, Q1=NA, Q3=NA))
                qu <- quantile(y, (1:3)/4)

                z <- list('Mean'   = mean(y),
                     'Median' = qu[2],
                     'Q1'     = qu[1],
                     'Q3'     = qu[3],
                     N=length(y))
                names(z)[1:4] <- paste0(movlab, names(z)[1:4])
                z
              }

  statx <- function(y, y2, x) {
    s <- if(sec) stat(y, y2) else stat(y)
    if(! discrete && space == 'n') s$.xmean. <- mean(x)
    s
  }

  R    <- NULL
  Xinc <- xinc

  uby  <- if(is.factor(By)) levels(By) else sort(unique(By))
  needxinc <- space == 'n' && ! length(Xinc)
  info <- if(discrete) matrix(NA, nrow=length(uby), ncol=1,
                              dimnames=list(uby, 'N'))
          else
            matrix(NA,
                   nrow=length(uby),
                   ncol=5 + needxinc,
                   dimnames=list(uby, c('N', 'Wmean', 'Wmin', 'Wmax',
                                        'eps', if(needxinc) 'xinc')))

  if(discrete) xlev <- if(is.factor(X)) levels(X) else sort(unique(X))

  for(by in uby) {
    j <- By == by
    if(sum(j) < nignore) {
      warning(paste('Stratum', by, 'has <', nignore, 'observations and is ignored'))
      next
    }
    x  <- X [j]
    y  <- Y [j]
    y2 <- Y2[j]
    n  <- length(x)

    if(discrete) {
      xv   <- x
      xseq <- xlev
    }
    else
      switch(space,
           x = {
             xl <- xlim
             if(! length(xl)) {
               xs <- sort(x)
               xl <- c(xs[nignore], xs[n - nignore + 1])
               if(diff(xl) >= 25) xl <- round(xl)
             }
             xinc <- Xinc
             if(! length(xinc)) xinc <- diff(xl) / 100.
             xseq <- seq(xl[1], xl[2], by=xinc)
             xv   <- x
           },
           n = {
             i    <- order(x)
             x    <- x [i]
             y    <- y [i]
             y2   <- y2[i]
             xinc <- Xinc
             if(! length(xinc)) {
               xinc <- max(floor(n / 200.), 1)
               info[by, 'xinc'] <- xinc
               }
             xseq <- seq(nignore, n - nignore + 1, by=xinc)
             xv   <- 1 : n
             } )

    ep <- eps
    if(space == 'n' && varyeps) {
      ## Requirement to have >= 3 x-points; new eps=h
      ## First estimate at observation min(xseq), last at max(xseq)
      ## First window goes to min(xseq) + h on right
      ## Last  window goes to max(xseq) - h on left
      ## Need difference in these two to be >= 2*xinc
      lowesteps <- floor((max(xseq) - min(xseq) - 2 * xinc) / 2.)
      if(lowesteps < eps) ep <- lowesteps
      info[by, 'eps'] <- ep
      }

    if(discrete) m <- data.table::data.table(x, y, y2, tx=xv)
    else {
      s <- data.table::data.table(x, y, y2, xv)
      a <- data.table::data.table(tx=xseq, key='tx')     # target xs for estimation
      a[, .q(lo, hi) := .(tx - ep, tx + ep)] # define all windows
      m <- a[s, on=.(lo <= xv, hi >= xv)]    # non-equi join
      }
    data.table::setkey(m, tx)

    ## Non-equi join adds observations tx=NA
    m <- m[! is.na(tx), ]
    w <- m[, statx(y, y2, x), by=tx]
    info[by, 'N'] <- n
    if('N' %in% names(w)) {
      N <- w[, N]
      if(! discrete) info[by, 2:4] <- c(round(mean(N), 1), min(N), max(N))
      }

    if(! discrete && space == 'n') {
      w[, tx      := .xmean.]
      w[, .xmean. := NULL   ]
      }

    if(msmooth != 'raw') {
      computed <- setdiff(names(w), c('tx', 'N'))
      for(vv in computed) {
        smoothed <- switch(tsmooth,
                           lowess = lowess(w[, tx], w[[vv]], f   =span),
                           supsmu = supsmu(w[, tx], w[[vv]], bass=bass))
        if(length(smoothed$x) < 2)
          stop(paste0('Only 1 x point for stratum ', by,
                      ' with ', n,
                      ' observations. Consider specifying varyeps=TRUE.'))
        smfun <- function(x) approx(smoothed, xout=x)$y
        switch(msmooth,
               smoothed = {
                 w[, (vv) := smfun(tx)]
               },
               both = {
                 newname <- sub('Moving', 'Moving-smoothed', vv)
                 w[, (newname) := smfun(tx)]
               }
               )
        }
    }

    ## Also compute loess estimates
    dat <- data.frame(x=w[, tx])
    if(loess) {
      np <- loess(y ~ x, data=s)
      pc <- predict(np, dat)
      if(ybin)
        w[, 'Loess Proportion' := pc]
      else
        w[, `Loess Mean`       := pc]
    }

    if(ols) {
      f <- rms::ols(sform, data=s)
      pc <- predict(f, dat)
      w[, `OLS Mean` := pc]
    }

    if(lrm) {
      f <- if(min(s[, sum(y == 1)], s[, sum(y == 0)]) < 10) f <- rms::lrm(y ~ x, data=s)
      else if(length(lrm_args))
        do.call(rms::lrm, c(list(sform, data=s), lrm_args))
        else rms::lrm(sform, data=s)
      pc <- predict(f, dat, type='fitted')
      w[, 'LR Proportion' := pc]
    }

    if(orm) {
      f <- rms::orm(sform, data=s, family=family)
      pc <- predict(f, dat, type='mean')
      w[, 'ORM Mean' := pc]
      if(length(tau)) {
        pc <- predict(f, dat)
        qu <- Quantile(f)
        for(ta in tau) {
          w[, ormqest := qu(ta, pc)]
          cta <- qformat(ta)
          data.table::setnames(w, 'ormqest', paste('ORM', cta))
        }
      }
    }

    if(qreg)
      for(ta in tau) {
        f  <- rms::Rq(sform, tau=ta, data=s)
        pc <- predict(f, dat)
        w[, qrest := pc]
        cta <- qformat(ta)
        data.table::setnames(w, 'qrest', paste('QR', cta))
      }

    if(hare) {
      f <- if(length(penalty))
             polspline::hare(y, y2, x, maxdim=maxdim, penalty=penalty)
           else
             polspline::hare(y, y2, x, maxdim=maxdim)
      for(ti in times) {
        inc <- polspline::phare(ti, dat$x, f)
        newname <- paste0('HARE ', ti, '-', tunits)
        w[, (newname) := inc]
      }
    }

    if(ordsurv) {
      aorm <- getFromNamespace('adapt_orm', 'rms')
      f <- aorm(x, rms::Ocens(y, ifelse(y2 == 1, y, Inf)), maxk=k)
      for(ti in times) {
        inc     <- 1 - rms::survest(f, dat, times=ti, conf.int=0)$surv
        newname <- paste0('orm ', ti, '-', tunits)
        w[, (newname) := inc]
      }
    }

    w[, by := by]
    R <- rbind(R, w)
  }

  R[, tx := itrans(tx)]
  if(bythere) {
    if(length(v) == 3) data.table::setnames(R, c('tx', 'by'), v[2:3])
    else {
      splitby <- strsplit(R[, by], split='::')
      data.table::setnames(R, 'tx', v[2])
      data.table::set(R, j='by', value=NULL)   # remove 'by'
      for(iby in 3 : length(v))
        data.table::set(R, j=v[iby],
                        value=sapply(splitby, function(u) u[[iby - 2]]))
    }
  }
  else {
    R[, by := NULL]
    data.table::setnames(R, 'tx', v[2])
  }
  if(melt) {
    if(sec) v[1] <- 'incidence'
    # Exclude N if present or would mess up melt
    if('N' %in% names(R)) R[, N := NULL]
    R <- data.table::melt(R, id.vars=v[-1], variable.name='Statistic',
              value.name=v[1])
    if(sec) {
      addlab <- function(x) {
        label(x) <- 'Cumulative Incidence'
        x
      }
      R[, incidence := addlab(incidence)]
    }

    R[, Type      := sub (' .*', '', Statistic)]
    R[, Statistic := sub ('.* ', '', Statistic)]
    R[, Type      := gsub('~', ' ',  Type)]
    R[, Statistic := gsub('~', ' ',  Statistic)]
  }

  if('eps' %in% colnames(info) && all(is.na(info[, 'eps'])))
    info <- info[, setdiff(colnames(info), 'eps'), drop=FALSE]
  if(! bythere) row.names(info) <- NULL
  infon <- info

  if(pr %in% c('kable', 'margin')) {
    n <- colnames(info)
    nam <- .q(N=N, Wmean=Mean, Wmin=Min, Wmax=Max, eps=eps, xinc=xinc)
    colnames(info) <- nam[n]
    ## rownames returns "1" "2" "3" ... even if row names not really there
    ri   <- rownames(info)
    rnp  <- length(ri) && ! all(ri == as.character(1 : length(ri)))
    ghead <- c(if(rnp) c(' ' = 1),
               c(' ' = 1, 'Window Sample Sizes' = 3),
               if('eps'  %in% n) c(' ' = 1),
               if('xinc' %in% n) c(' ' = 1))
    info <- if(discrete) knitr::kable(info)
            else
              info <- knitr::kable(info) |>
                kableExtra::add_header_above(ghead) |>
                kableExtra::kable_styling(font_size=9)
    }

  if(pr == 'margin' && ! requireNamespace('qreport', quietly=TRUE))
    stop('must install qreport package when specifying pr=margin')

  switch(pr,
         plain  = print(info),
         kable  = cat(info),
         margin = qreport::makecolmarg(info) )

  attr(R, 'infon') <- infon
  attr(R, 'info')  <- info

  R
  }

utils::globalVariables(c('lo', 'hi', 'tx', '.xmean.', 'Loess Mean', 'OLS Mean',
  'ormqest', 'qrest', 'incidence', 'Type', 'Statistic', 'Min', 'Max'))

require(Hmisc)
n <- 500
set.seed(1)
d <- data.frame(
  race         = sample(c('Asian', 'Black/AA', 'White'), n, TRUE),
  sex          = sample(c('Female', 'Male'), n, TRUE),
  treat        = sample(c('A', 'B'), n, TRUE),
  smoking      = sample(c('Smoker', 'Non-smoker'), n, TRUE),
  hypertension = sample(c('Hypertensive', 'Non-Hypertensive'), n, TRUE),
  region       = sample(c('North America','Europe','South America',
                          'Europe', 'Asia', 'Central America'), n, TRUE))

d <- upData(d, labels=c(race='Race', sex='Sex'))

dm <- addMarginal(d, region)
s <- summaryP(race + sex + smoking + hypertension ~
              region + treat,  data=dm)

require(ggplot2)
## add exclude1=FALSE to include female category
ggplot(s, groups='treat', exclude1=TRUE, abblen=12)
ggplot(s, groups='region')

## plotly graphic

options(grType='plotly')
plot(s, groups='treat', marginVal='All', marginLabel='All Regions',
     xlim=c(0,1))

## Make sure plotly graphic works with simpler cases

s <- summaryP(race + sex + smoking + hypertension ~
                treat,  data=dm)
plot(s)
plot(s, groups='treat')
s <- summaryP(race + sex + smoking + hypertension ~ 1, data=dm)
plot(s)

##' Find Sequential Exclusions Due to NAs
##'
##' Finds the variable with the highest number of `NA`s.  From the non-`NA`s on that variable find the next variable from those remaining with the highest number of `NA`s.  Proceed in like fashion.  The resulting variable summarizes sequential exclusions in a hierarchical fashion.  See [this](https://hbiostat.org/rflow/doverview.html#sec-doverview-filter) for more information.
##' @title seqFreq
##' @param ... any number of variables
##' @param labels if specified variable labels will be used in place of variable names
##' @param noneNA set to `TRUE` to not include 'none' as a level in the result
##' @return `factor` variable with `obs.per.numcond` attribute
##' @author Frank Harrell
##' @md
##' @export
seqFreq <- function(..., labels=NULL, noneNA=FALSE) {
  d <- list(...)
  k <- length(d)
  if(length(labels)) nam <- labels
  else {
    s <- as.character(sys.call()[-1])[1 : k]
    nam <- names(d)
    if(! length(nam)) nam <- rep('', k)
    nam <- ifelse(nam == '', s, nam)
    }

  ispos <- function(x) {
    w <- if(is.logical(x)) x
    else if(is.numeric(x)) x > 0
    else tolower(as.character(x)) %in%
           c('present', 'yes', 'y', 'true', 'positive', 'pos', '+')
    w[is.na(x)] <- FALSE
    1L * w
  }

  names(d) <- nam
  x <- sapply(d, ispos)  # creates a matrix
  # Count number of positives per observation
  po   <- apply(x, 1, sum)
  cond <- c(sum(po == 0), tabulate(po, nbins=k))

  j <- integer(k)
  w <- rep(0, nrow(x))
  for(i in 1 : k) {
    freqs <- apply(x, 2, sum)
    if(all(freqs == 0)) break
    imax  <- which.max(freqs)
    j[i]  <- imax
    w <- ifelse(w == 0 & x[, imax], imax, w)
    x[x[, imax] == 1, ] <- 0
  }
j <- j[j != 0]
x <- if(noneNA) factor(w, j, nam[j]) else
                factor(w, c(0, j), c('none', nam[j]))
attr(x, 'obs.per.numcond') <- cond
x
}

#' rmClose
#' 
#' Remove close values from a numeric vector that are not at the outer limtis.  This is useful for removing axis breaks that overlap when plotting.
#'
#' @param x a numeric vector with no `NA`s
#' @param minfrac minimum allowed spacing between consecutive ordered `x`, as a fraction of the range of `x`
#'
#' @returns a sorted numeric vector of non-close values of `x`
#' @export
#' @md
#' @author Frank Harrell
#' @examples
#' rmClose(c(1, 2, 4, 47, 48, 49, 50), minfrac=0.07)
rmClose <- function(x, minfrac=0.05) {
  x <- unique(sort(x))
  mindist <- minfrac * diff(range(x)) 
  n <- length(x)
  selected      <- x[1]
  last_selected <- x[1]  # Always select the first point
  
  for (i in 2 : n) {
    if (x[i] - last_selected >= mindist) {
      selected <- c(selected, x[i])
      last_selected <- x[i]
    }
  }
  return(selected)
}

# Code not used:
 # repeat {
 #   prn(x)
 #   n <- length(x)
 #   if(n < 3) return(x)
 #   if(x[n - 1] > x[n] - mindist) {
 #     x <- x[- (n - 1)]
 #     next
 #   }
 #   gaps <- diff(c(- mindist * 2, x))
 #   mind <- min(gaps[- c(1, n)])
 #   prn(gaps); prn(mind)
 #   if(mind >= mindist) return(x)
 #   candidates <- setdiff(which(gaps == mind), c(1, n))
 #   prn(candidates)
 #   x <- x[- candidates[1]]
 # }
 #}

#' Minimally Group an Ordinal Variable So Bootstrap Samples Will Contain All Distinct Values
#'
#' When bootstrapping models for ordinal Y when Y is fairly continuous, it is frequently the case that one or more bootstrap samples will not include one or more of the distinct original Y values.  When fitting an ordinal model (including a Cox PH model), this means that an intercept cannot be estimated, and the parameter vectors will not align over bootstrap samples.  To prevent this from happening, some grouping of Y may be necessary.  The `ordGroupBoot` function uses [Hmisc::cutGn()] to group Y so that the minimum number in any group is guaranteed to not exceed a certain integer `m`.  `ordGroupBoot` tries a range of `m` and stops at the lowest `m` such that either all `B` tested bootstrap samples contain all the original distinct values of Y (if `B`>0), or that the probability that a given sample of size `n` with replacement will contain all the distinct original values exceeds `aprob` (`B`=0).  This probability is computed approximately using an approximation to the probability of complete sample coverage from the _coupon collector's problem_ and is quite accurate for our purposes.
#'
#' @param y a numeric vector
#' @param B number of bootstrap samples to test, or zero to use a coverage probability approximation
#' @param m range of minimum group sizes to test; the default range is usually adequate
#' @param what specifies that either the mean `y` in each group should be returned, a `factor` version of this with interval endpoints in the levels, or the computed value of `m` should be returned
#' @param aprob minimum coverage probability sought
#' @param pr set to `FALSE` to not print the computed value of the minimum `m` satisfying the needed condition
#'
#' @returns a numeric vector corresponding to `y` but grouped, containing eithr the mean of `y` in each group or a factor variable representing grouped `y`, either with the minimum `m` that satisfied the required sample covrage
#' @seealso [cutGn()]
#' @export
#' @author Frank Harrell
#' @md
#'
#' @examples
#' set.seed(1)
#' x <- c(1:6, NA, 7:22)
#' ordGroupBoot(x, m=5:10)
#' ordGroupBoot(x, m=5:10, B=5000, what='factor')
ordGroupBoot <- function(y, B=0, m=7:min(15, floor(n / 3)),
                         what=c('mean', 'factor', 'm'),
                         aprob=0.9999, pr=TRUE) {
  what <- match.arg(what)
  n    <- sum(! is.na(y))

  for(mm in m) {
    yr  <- cutGn(y, m=mm, what=if(what == 'm') 'mean' else what)
    if(B == 0) {
      tab <- table(yr)
      p <- 1 - sum(exp(- tab))
      if(p > aprob) {
        if(pr) cat('Minimum m:', mm, '\n')
        return(if(what == 'm') mm else yr)
      }
      next
    }
    yru <- unique(yr)
    for(i in 1 : B) {
      yb <- sample(yr, replace=TRUE)
      if(! all(yru %in% yb)) break
    }
    if(i == B) {
      if(pr) cat('Minimum m:', mm, '\n')
      return(if(what == 'm') mm else yr)
    }
  }
  stop('no value of m tested will sufficiently guarantee coverage of original values in samples with replacement')
}

! Converted from Ratfor to Fortran 2018 by Claude AI 2024-10-26
!
! Hoeffding's D Statistics Implementation
! Modern Fortran without module structure

subroutine hoeffd(xx, n, p, dmat, aadmat, madmat, npair, x, y, rx, ry, rj)
  use, intrinsic :: iso_fortran_env, only: real64
  implicit none
  
  ! Arguments
  integer, intent(in) :: n, p
  real(real64), intent(in) :: xx(n,p)
  real(real64), intent(out) :: dmat(p,p), aadmat(p,p), madmat(p,p)
  integer, intent(out) :: npair(p,p)
  real(real64), intent(out) :: x(n), y(n), rx(n), ry(n), rj(n)
  
  ! Local variables
  integer :: i, j, k, m, np
  real(real64) :: xk, yk, d, aad, maxad
  real(real64), parameter :: LARGE_VAL = 1.0e49_real64
  
  ! Initialize arrays
  dmat = 0.0_real64
  aadmat = 0.0_real64
  madmat = 0.0_real64
  npair = 0
  
  do i = 1, p
    np = count(xx(:,i) < LARGE_VAL)
    npair(i,i) = np
    
    do j = i+1, p
      m = 0
      do k = 1, n
        xk = xx(k,i)
        yk = xx(k,j)
        if (xk < LARGE_VAL .and. yk < LARGE_VAL) then
          m = m + 1
          x(m) = xk
          y(m) = yk
        end if
      end do
      
      npair(i,j) = m
      if (m > 4) then
        call hoeff(x, y, m, d, aad, maxad, rx, ry, rj)
        dmat(i,j) = d
        aadmat(i,j) = aad
        madmat(i,j) = maxad
      else
        dmat(i,j) = LARGE_VAL
      end if
    end do
  end do
  
  ! Fill lower triangle
  do i = 1, p
    dmat(i,i) = 1.0_real64/30.0_real64
    do j = i+1, p
      dmat(j,i) = dmat(i,j)
      npair(j,i) = npair(i,j)
      aadmat(j,i) = aadmat(i,j)
      madmat(j,i) = madmat(i,j)
    end do
  end do
  
end subroutine hoeffd

subroutine hoeff(x, y, n, d, aad, maxad, rx, ry, rj)
  use, intrinsic :: iso_fortran_env, only: real64
  implicit none
  
  ! Arguments
  integer, intent(in) :: n
  real(real64), intent(in) :: x(n), y(n)
  real(real64), intent(out) :: d, aad, maxad
  real(real64), intent(out) :: rx(n), ry(n), rj(n)
  
  ! Local variables
  integer :: i
  real(real64) :: q, r, s, z, rxi, ryi, rji, ad
  
  call jrank(x, y, n, rx, ry, rj)
  
  q = 0.0_real64
  r = 0.0_real64
  s = 0.0_real64
  aad = 0.0_real64
  maxad = 0.0_real64
  z = real(n, real64)
  
  do i = 1, n
    rxi = rx(i)
    ryi = ry(i)
    rji = rj(i)
    ad = abs((rji/z) - (rxi/z)*(ryi/z))
    aad = aad + ad
    maxad = max(maxad, ad)
    q = q + (rxi-1.0_real64)*(rxi-2.0_real64)*(ryi-1.0_real64)*(ryi-2.0_real64)
    r = r + (rxi-2.0_real64)*(ryi-2.0_real64)*(rji-1.0_real64)
    s = s + (rji-1.0_real64)*(rji-2.0_real64)
  end do
  
  aad = aad / z
  d = (q-2.0_real64*(z-2.0_real64)*r+(z-2.0_real64)*(z-3.0_real64)*s) / &
      (z*(z-1.0_real64)*(z-2.0_real64)*(z-3.0_real64)*(z-4.0_real64))
  
end subroutine hoeff

subroutine jrank(x, y, n, rx, ry, r)
  use, intrinsic :: iso_fortran_env, only: real64
  implicit none
  
  ! Arguments
  integer, intent(in) :: n
  real(real64), intent(in) :: x(n), y(n)
  real(real64), intent(out) :: rx(n), ry(n), r(n)
  
  ! Local variables
  integer :: i, j
  real(real64) :: xi, yi, ri, rix, riy, cx, cy
  
  do i = 1, n
    xi = x(i)
    yi = y(i)
    ri = 1.0_real64
    rix = 1.0_real64
    riy = 1.0_real64
    
    do j = 1, n
      if (i /= j) then
        cx = merge(0.5_real64, merge(1.0_real64, 0.0_real64, x(j) < xi), x(j) == xi)
        cy = merge(0.5_real64, merge(1.0_real64, 0.0_real64, y(j) < yi), y(j) == yi)
        
        rix = rix + cx
        riy = riy + cy
        ri = ri + cx*cy
      end if
    end do
    
    rx(i) = rix
    ry(i) = riy
    r(i) = ri
  end do
  
end subroutine jrank

#' Add a lowess smoother without counfidence bands.
#'
#' Automatically selects \code{iter=0} for \code{lowess} if \code{y} is binary, otherwise uses \code{iter=3}.
#'
#'
#' @param mapping,data,geom,position,show.legend,inherit.aes see ggplot2 documentation
#' @param span see \code{f} argument to \code{lowess}
#' @param fun a function to transform smoothed \code{y}
#' @param fullrange should the fit span the full range of the plot, or just
#'   the data
#' @param n number of points to evaluate smoother at
#' @param na.rm If \code{FALSE} (the default), removes missing values with
#'    a warning.  If \code{TRUE} silently removes missing values.
#' @param ... other arguments are passed to smoothing function
#' @return a data.frame with additional columns
#'   \item{y}{predicted value}
#' @seealso
#'   \code{\link{lowess}} for \code{loess} smoother.
#' @export
#' @examples
#' \donttest{
#' require(ggplot2)
#' c <- ggplot(mtcars, aes(qsec, wt))
#' c + stat_plsmo()
#' c + stat_plsmo() + geom_point()
#'
#' c + stat_plsmo(span = 0.1) + geom_point()
#'
#' # Smoothers for subsets
#' c <- ggplot(mtcars, aes(y=wt, x=mpg)) + facet_grid(. ~ cyl)
#' c + stat_plsmo() + geom_point()
#' c + stat_plsmo(fullrange = TRUE) + geom_point()
#'
#' # Geoms and stats are automatically split by aesthetics that are factors
#' c <- ggplot(mtcars, aes(y=wt, x=mpg, colour=factor(cyl)))
#' c + stat_plsmo() + geom_point()
#' c + stat_plsmo(aes(fill = factor(cyl))) + geom_point()
#' c + stat_plsmo(fullrange=TRUE) + geom_point()
#'
#' # Example with logistic regression
#' data("kyphosis", package="rpart")
#' qplot(Age, as.numeric(Kyphosis) - 1, data = kyphosis) + stat_plsmo()
#' }

stat_plsmo <- function (mapping = NULL, data = NULL, geom = "smooth",
                        position = "identity",
                        n = 80, fullrange = FALSE, span=2/3, fun=function(x) x,
                        na.rm = FALSE, show.legend = NA, inherit.aes = TRUE,
                        ...) {

  layer(
    stat = StatPlsmo, data = data, mapping = mapping, geom = geom,
    position = position, show.legend = show.legend, inherit.aes = inherit.aes,
    params = list(
      n = n,
      fullrange = fullrange,
      span = span,
      fun = fun,
      na.rm = na.rm,
      ...)
  )
}

StatPlsmo <- ggplot2::ggproto("StatPlsmo", ggplot2::Stat,
  required_aes = c("x", "y"),

  setup_data = function(data, params) {
    rows <- tapply(data$x, data$group, \(x) length(unique(x)))
    if (anyNA(data$group)) {
      rows <- c(length(unique(data$x[is.na(data$group)])), rows)
    }

    if (all(rows == 1) && length(rows) > 1) {
      message("geom_plsmo: Only one unique x value each group.",
        "Maybe you want aes(group = 1)?")
      return(data.frame())
    }

    data
  },

  compute_group = function(., data, scales, n=80, span=2/3, fun=function(x) x,
                        fullrange=FALSE, xseq = NULL, na.rm = FALSE) {
    data <- remove_missing(data, na.rm, c("x", "y"), name="stat_plsmo")
    if (length(unique(data$x)) < 2) {
      # Not enough data to perform fit
      return(data.frame())
    }

    if (is.null(xseq)) {
      if (is.integer(data$x)) {
        if (fullrange) {
          xseq <- scales$x$dimension()
        } else {
          xseq <- sort(unique(data$x))
        }
      } else {
        if (fullrange) {
          range <- scales$x$dimension()
        } else {
          range <- range(data$x, na.rm = TRUE)
        }
        xseq <- seq(range[1], range[2], length.out = n)
      }
    }

    n_y <- length(unique(data$y[!is.na(data$y)]))

    z <- lowess(data$x, data$y,
      iter = if (n_y < 3) 0 else 3,
      f = span
    )
    z <- approx(z, xout = xseq)
    z$y <- fun(z$y)
    as.data.frame(z)
  }
)

##' Compute Coordinates of an Empirical Distribution Function
##'
##' For a numeric vector uses the R built-in `ecdf` function to compute
##' coordinates of the ECDF, with extension slightly below and above the
##' range of `x` by default.  This is useful for `ggplot2` where the ECDF may need to be transformed.  The returned object is suitable for creating stratified statistics using `data.table` and other methods.
##' @title ecdfSteps
##' @param x numeric vector, possibly with `NA`s that are ignored
##' @param extend a 2-vector do extend the range of x (low, high).  Set `extend=FALSE` to not extend `x`, or leave it missing to extend it 1/20th of the observed range on other side.
##' @return a list with components `x` and `y`
##' @author Frank Harrell
##' @md
##' @seealso [stats::ecdf()]
##' @examples
##' ecdfSteps(0:10)
##' \dontrun{
##' # Use data.table for obtaining ECDFs by country and region
##' w <- d[, ecdfSteps(z, extend=c(1,11)), by=.(country, region)]  # d is a DT
##' # Use ggplot2 to make one graph with multiple regions' ECDFs
##' # and use faceting for countries
##' ggplot(w, aes(x, y, color=region)) + geom_step() +
##'        facet_wrap(~ country)
##' }
ecdfSteps <- function(x, extend) {
  u <- sort(unique(x))
  if(missing(extend) || is.numeric(extend) || extend) {
    if(missing(extend)) {
      r <- range(u)
      eps <- diff(r) / 20.
      extend <- c(r[1] - eps, r[2] + eps)
    }
    u <- c(extend[1], u, extend[2])
  }
  list(x=u, y=ecdf(x)(u))
}

! Converted from Ratfor 2024-10-26 using ChatGPT and the following request:
! Convert the following Ratfor code to Fortran 2018 using Fortran ISO environment without using module

subroutine wclosest(w, x, lw, lx, j)
    use ISO_FORTRAN_ENV, only: REAL64
    implicit none
    integer, intent(in) :: lw, lx
    integer, intent(out) :: j(lw)
    real(REAL64), intent(in) :: w(lw), x(lx)
    real(REAL64) :: wi, dmin, d
    integer :: i, k, m
  
    do i = 1, lw
      wi = w(i)
      dmin = 1.0e40_real64
      m = 0
      do k = 1, lx
        d = abs(x(k) - wi)
        if (d < dmin) then
          dmin = d
          m = k
        end if
      end do
      j(i) = m
    end do
  
    return
  end subroutine wclosest
  
  subroutine wclosepw(w, x, r, f, lw, lx, xd, j)
    use ISO_FORTRAN_ENV, only: REAL64
    implicit none
    integer, intent(in) :: lw, lx
    integer, intent(out) :: j(lw)
    real(REAL64), intent(in) :: w(lw), x(lx), r(lw), f
    real(REAL64), intent(out) :: xd(lx)
    real(REAL64) :: wi, dmean, sump, z, prob, ri
    integer :: i, k, m
  
    do i = 1, lw
      wi = w(i)
      dmean = 0.0_real64
  
      ! Calculate mean distance
      do k = 1, lx
        xd(k) = abs(x(k) - wi)
        dmean = dmean + xd(k)
      end do
      dmean = f * dmean / real(lx, REAL64)
  
      ! Adjust probabilities
      sump = 0.0_real64
      do k = 1, lx
        z = min(xd(k) / dmean, 1.0_real64)
        xd(k) = (1.0_real64 - z**3)**3
        sump = sump + xd(k)
      end do
  
      ! Determine index based on probabilities
      prob = 0.0_real64
      ri = r(i)
      m = 1
      do k = 1, lx
        prob = prob + xd(k) / sump
        if (ri > prob) m = m + 1
      end do
      j(i) = m
    end do
  
    return
  end subroutine wclosepw
  

#' printL
#' 
#' Print an object or a named list of objects.  When multiple objects are given, their names are printed before their contents.  When an object is a vector that is not longer than `maxoneline` and its elements are not named, all the elements will be printed on one line separated by commas.  When `dec` is given, numeric vectors or numeric columns of data frames or data tables are rounded to the nearest `dec` before printing.  This function is especially helpful when printing objects in a Quarto or RMarkdown document and the code is not currently being shown to place the output in context.
#'
#' @param ... any number of objects to `print()`
#' @param dec optional decimal places to the right of the decimal point for rounding
#' @param maxoneline controls how many elements may be printed on a single line for `vector` objects
#'
#' @return nothing
#' @author Frank Harrell
#' @export
#' @md
#' @seealso [prn()]
#'
#' @examples
#' w <- pi + 1 : 2
#' printL(w=w)
#' printL(w, dec=3)
#' printL('this is it'=c(pi, pi, 1, 2),
#'        yyy=pi,
#'        z=data.frame(x=pi+1:2, y=3:4, z=c('a', 'b')),
#'        qq=1:10,
#'        dec=4)
#'        
printL <- function(..., dec=NULL, maxoneline=5) {
  z  <- list(...)
  ns <- names(z)
  if(! length(ns)) {
    if(length(z) > 1) stop('must name arguments')
    names(z) <- ' '
  }
  for(n in names(z)) {
    x <- z[[n]]
    l <- length(x)
    if(is.numeric(x) && length(dec)) x <- round(x, dec)
    if(is.vector(x) &&
       (l == 1 || (l <= maxoneline && ! length(names(x))))) {
      x <- paste(x, collapse=', ')
      cat(if(n != ' ') c(n, ': '), x, '\n\n', sep='')
    } else {
      if(is.list(x) && length(dec))
        for(j in 1 : length(x))
          if(is.numeric(x[[j]])) x[[j]] <- round(x[[j]], dec)
      if(n != ' ') cat(n, ':\n', sep='') else cat('\n')
      print(x)
      cat('\n')
    }
  }
  invisible()
}

##' Enhanced Output for Principal and Sparse Principal Components
##'
##' Expands any categorical predictors into indicator variables, and calls `princomp` (if `method='regular'` (the default)) or `sPCAgrid` in the `pcaPP` package (`method='sparse'`) to compute lasso-penalized sparse principal components.  By default all variables are first scaled by their standard deviation after observations with any `NA`s on any variables in `formula` are removed.  Loadings of standardized variables, and if `orig=TRUE` loadings on the original data scale are printed.  If `pl=TRUE` a scree plot is drawn with text added to indicate cumulative proportions of variance explained.  If `sw=TRUE`, the `leaps` package `regsubsets` function is used to approximate the PCs using forward stepwise regression with the original variables as individual predictors.
##'
##' A `print` method prints the results and a `plot` method plots the scree plot of variance explained.
##' @title princmp
##' @param formula a formula with no left hand side, or a numeric matrix
##' @param data a data frame or table.  By default variables come from the calling environment.
##' @param method specifies whether to use regular or sparse principal components are computed
##' @param k the number of components to plot, display, and return
##' @param kapprox the number of components to approximate with stepwise regression when `sw=TRUE`
##' @param cor set to `FALSE` to compute PCs on the original data scale, which is useful if all variables have the same units of measurement
##' @param sw set to `TRUE` to run stepwise regression PC prediction/approximation
##' @param nvmax maximum number of predictors to allow in stepwise regression PC approximations
##' @return a list of class `princmp` with elements `scores`, a k-column matrix with principal component scores, with `NA`s when the input data had an `NA`, and other components useful for printing and plotting.  If `k=1` `scores` is a vector.  Other components include `vars` (vector of variances explained), `method`, `k`.
##' @author Frank Harrell
##' @export
##' @md
princmp <- function(formula, data=environment(formula),
                    method=c('regular', 'sparse'),
                    k=min(5, p - 1), kapprox=min(5, k),
                    cor=TRUE, sw=FALSE, nvmax=5) {
  method <- match.arg(method)
  if(method == 'sparse')
    if(! requireNamespace('pcaPP', quietly=TRUE))
      stop('You must install the pcaPP package to use method="sparse"')

  isf <- inherits(formula, 'formula')
  X <- if(isf) model.matrix.lm(formula, data) else as.matrix(formula)
  
  if(isf) X  <- X[, -1, drop=FALSE]  # remove intercept
  p  <- ncol(X)
  res <- list(n=nrow(X), ndata=if(! missing(data)) nrow(data),
              method=method, k=k, kapprox=kapprox, cor=cor, nvmax=nvmax)
  g  <- switch(method,
               regular = stats::princomp(X, cor=cor),
               sparse  = pcaPP::sPCAgrid(X, k=ncol(X) - 1, method='sd',
                                  center=mean,
                                  scale=if(cor) sd else function(x) 1.,
                                  scores=TRUE, maxiter=10) )
  
  co        <- unclass(g$loadings)
  type      <- switch(method, regular='', sparse='Sparse ')
  res$scoef <- co
  res$scale <- g$scale
  p         <- ncol(co)
  sds       <- g$scale
  co        <- co / matrix(rep(sds, p), nrow=length(sds))
  res$coef  <- co
  vars      <- g$sdev^2
  res$vars  <- vars

  if(sw) {
    if(! requireNamespace('leaps', quietly=TRUE))
      stop('You must install the leaps package when sw=TRUE')
    swa <- list()

    for(j in 1 : kapprox) {
      fchar <- capture.output(  # don't allow regular output
        f <- leaps::regsubsets(X, g$scores[, j], method='forward',
                               nbest=1, nvmax=min(p - 1, nvmax)))
      debug <- getOption('princmpdebug', FALSE)
      if(debug) cat('Debugging turned on\n')
      if(j == 1 && debug)
        saveRDS(list(X=X, g=g, f=f), file='/tmp/princmp.rds')
      s <- summary(f)
      w <- s$which[, -1, drop=FALSE]   # omit intercept
      xnm <- colnames(w)
      xadded <- character(0)
      for(l in 1 : nrow(w)) {
        varnow <- xnm[w[l,]]
        varnew <- setdiff(varnow, xadded)
        xadded <- c(xadded, varnew)
        }
      rsq <- structure(s$rsq, names=xadded)
      l <- which(rsq >= 0.999)
      if(length(l)) rsq <- rsq[1 : min(l)]
      swa[[j]] <- rsq
    }
    res$sw <- swa
    }
    
  ## Use predict method with newdata to ensure that PCs NA when
  ## original variables NA
  ## See https://stackoverflow.com/questions/5616210
  if(isf) X  <- model.matrix.lm(formula, data, na.action=na.pass)
  pcs        <- predict(g, newdata=X)
  pcs        <- pcs[, 1 : min(k, ncol(pcs)), drop=FALSE]
  res$scores <- pcs
  class(res) <- 'princmp'
  res
}

##' Print Results of princmp
##'
##' Simple print method for [princmp()]
##' @title print.princmp
##' @param x results of `princmp`
##' @param which specifies which loadings to print, the default being `'none'` and other values being `'standardized'`, `'original'`, or `'both'`
##' @param k number of components to show, defaults to `k` specified to `princmp`
##' @param ... unused
##' @return nothing
##' @author Frank Harrell
##' @export
##' @md
print.princmp <- function(x,
                          which=c('none', 'standardized', 'original', 'both'),
                          k=x$k, ...) {
  which <- match.arg(which)
  prz <- function(x, m) {
    x <- format(round(x, m), zero.print=FALSE)
    print(x, quote=FALSE)
  }
  method  <- x$method
  type <- switch(method,
                 regular = '',
                 sparse  = 'Sparse ')
  cat(type, 'Principal Components Analysis\n', sep='')
  if(length(x$ndata) && x$ndata != x$n)
    cat('Used', x$n, 'observations with no NAs out of', x$ndata, '\n')

  co <- x$scoef
  if(which %in% c('standardized', 'both')) {
    cat('\n', type, 'PC Coefficients of Standardized Variables\n', sep='')
    prz(co[, 1 : k], 3)
  }
  p <- ncol(x$coef)
  if(which %in% c('original', 'both')) {
    sds <- x$scale
    cat('\n', type, 'PC Coefficients of Original Variables\n', sep='')
    co <- co / matrix(rep(sds, p), nrow=length(sds))
    prz(co[, 1 : k], 5)
  }
  sw <- x$sw
  lsw <- length(sw)
  if(lsw) {
    cat('\nStepwise Approximations to PCs With Cumulative R^2\n')
    for(j in 1 : lsw) {
      cat('\nPC', j, '\n')
      rsq <- sw[[j]]
      fw <- character(0)
      xadded <- names(rsq)
      for(l in 1 : length(rsq))
        fw <- paste0(fw, if(l > 1) ' + ', xadded[l],
                     ' (', round(rsq[l], 3), ')')
      cat(strwrap(fw), sep='\n')
    }
  }
  invisible()
}

##' Plot Method for princmp
##'
##' Uses base graphics to by default plot the scree plot from a [princmp()] result, showing cumultive proportion of variance explained.  Alternatively the standardized PC loadings are shown in a `ggplot2` bar chart.
##' @title plot.princmp
##' @param x results of `princmp`
##' @param which '`scree`' or '`loadings'`
##' @param k number of components to show, default is `k` specified to `princmp`
##' @param offset controls positioning of text labels for cumulative fraction of variance explained
##' @param col color of plotted text in scree plot
##' @param adj angle for plotting text in scree plot
##' @param ylim y-axis scree plotting limits, a 2-vector
##' @param add set to `TRUE` to add a line to an existing scree plot without drawing axes
##' @param abbrev an integer specifying the variable name length above which names are passed through [abbreviate(..., minlength=abbrev)]
##' @param nrow number of rows to use in plotting loadings.  Defaults to the `ggplot2` `facet_wrap` default.
##' @param ... unused
##' @return `ggplot2` object if `which='loadings'`
##' @export
##' @author Frank Harrell
plot.princmp <- function(x, which=c('scree', 'loadings'),
                         k=x$k, offset=0.8, col=1, adj=0,
                         ylim=NULL, add=FALSE, abbrev=25, nrow=NULL,
                         ...) {
  which <- match.arg(which)
  if(which == 'scree') {
  vars <- x$vars

  cumv <- cumsum(vars) / sum(vars)
  if(add) lines(1:k, vars[1:k], type='b', col=col)
  else {
    plot(1:k, vars[1:k], type='b', ylab='Variance',
         xlab=if(k <= 10) '' else 'Component',
         axes=FALSE, col=col, ylim=ylim)
    axis(1, at=1:k,
         labels = if(k > 10) 1 : k else
                  as.expression(sapply(1 : k, function(x) bquote(PC[.(x)]))))
    axis(2)
    }
  text(1:k, vars[1:k] + offset * par('cxy')[2],
       as.character(round(cumv[1:k], 2)),
       srt=45, adj=adj, cex=.65, xpd=NA, col=col)
  return(invisible())
  }

  co    <- x$scoef[, 1 : k, drop=FALSE]
  
  xname <- abbreviate(rownames(co), minlength=abbrev)
  p     <- length(xname)
  b     <- as.vector(co)
  r     <- range(abs(b))
  sub   <- paste0('Range of |loading|:', round(r[1], 3),
                  ' - ', round(r[2], 3))
  d <- data.frame(b    = abs(b),
                  y    = as.vector(p + 1 - row(co)),
                  comp = factor(as.vector(col(co)),
                                levels=1 : k,
                                labels=paste0('PC[', 1 : k, ']')),
                  x    = 1,
                  sign = ifelse(b >= 0., '+', '-'))
  g <- ggplot(d,  aes(x=.data$x, y=.data$y, color=.data$sign)) +
    geom_segment(aes(x=.data$x, y=.data$y, xend=.data$x + 0.9 * .data$b / r[2], yend=.data$y),
                 size=3) +
    facet_wrap(~ .data$comp, labeller='label_parsed', nrow=nrow) +
    scale_x_continuous(breaks = 1 : k,
                       labels=as.expression(sapply(1 : k,
                                 function(x) bquote(PC[.(x)])))) +
    scale_y_continuous(breaks = 1 : p, labels=rev(xname)) +
    guides(x='none', color = guide_legend(title='')) +
    xlab('Standardized Loading (Absolute)') + ylab('') + labs(caption=sub) +
    theme(legend.position='bottom')
  g
}

# For a variety of sample sizes and distribution of number of ties solve
# for the value of aprob that makes ordGroupBoot(x, aprob=aprob) agree the
# most with ordGroupBoot(x, B=1000)
# Note that output is expected to include an Error

require(rms)
set.seed(1)
d <- NULL
for(i in 1 : 200) {   # use 2000 for production run
  if(i %% 100 == 0) cat(i, '')
  n <- sample(c(rep(20 : 300, 2), 21 : 3000, 1), 1)
  x <- runif(n)
  r <- sample(1 : 3, 1)
  x <- round(runif(n), r)
  ap <- sample(c(.9995, .99975, .9999, .99995), 1)
  mcandidates <- 7 : min(16, floor(n * 0.4))
  ma <- try(ordGroupBoot(x, aprob=ap, m = mcandidates, what='m', pr=FALSE))
  mb <- try(ordGroupBoot(x, B=1000,   m = mcandidates, what='m', pr=FALSE))
  if(inherits(ma, 'try-error')) ma <- NA
  if(inherits(mb, 'try-error')) mb <- NA
  w <- data.frame(n, r, ap, ma, mb, ad=abs(ma - mb))
  d <- rbind(d, w)
}
with(d, table(ad))
mn <- function(x) mean(x, na.rm=TRUE)
with(d, tapply(ad, r, mn))
with(d, tapply(ad, ap, mn))

dd <- datadist(d); options(datadist='dd')
f <- lrm(ad ~ n + r + log(ap), data=d)
f
ggplot(Predict(f))

# Need ma to be >= mb
with(d, tapply(ma >= mb, ap, mn))   # best aprob=0.9999; overshoots by 1.4 on avg.

#' @title Step function confidence intervals for ggplot2
#' @description Produces a step function confidence interval for survival curves.  This function is taken from
#' the \code{utile.visuals} package by Eric Finnesgard.  That package is not used because of its
#' strong dependencies.
#' @param mapping Aesthetic mappings with aes() function. Like geom_ribbon(), you must provide
#' columns for x, ymin (lower limit), ymax (upper limit).
#' @param data The data to be displayed in this layer. Can inherit from ggplot parent.
#' @param stat The statistical transformation to use on the data for this layer, as a string.
#' Defaults to 'identity'.
#' @param position Position adjustment, either as a string, or the result of a call to a
#' position adjustment function.
#' @param na.rm If FALSE, the default, missing values are removed with a warning. If TRUE,
#' missing values are silently removed.
#' @param ... Optional. Any other ggplot geom_ribbon() arguments.
#' @note Originally adapted from the survminer package <https://github.com/kassambara/survminer>.
#' @examples
#' require(survival)
#' require(ggplot2)
#'
#' f <- survfit(Surv(time, status) ~ trt, data = diabetic)
#' d <- with(f, data.frame(time, surv, lower, upper, trt=rep(names(f$strata), f$strata)))
#' ggplot(d, aes(x = time, y=surv)) +
#'   geom_step(aes(color = trt)) +
#'   geom_stepconfint(aes(ymin = lower, ymax = upper, fill = trt), alpha = 0.3) +
#'   coord_cartesian(c(0, 50)) +
#'   scale_x_continuous(expand = c(0.02,0)) +
#'   labs(x = 'Time', y = 'Freedom From Event') +
#'   scale_color_manual(
#'     values = c('#d83641', '#1A45A7'),
#'     name = 'Treatment',
#'     labels = c('None', 'Laser'),
#'     aesthetics = c('colour', 'fill'))
#' @export
#' @author Eric Finnesgard
geom_stepconfint <- function (
  mapping = NULL, data = NULL, stat = "identity",
  position = "identity", na.rm = FALSE, ...) {
  ggplot2::layer(
    mapping = mapping,
    data = data,
    stat = stat,
    geom = ggplot2::ggproto(
      `_class` = 'GeomConfint',
      `_inherit` = ggplot2::GeomRibbon,
      required_aes = c("x", "ymin", "ymax"),
      draw_group = function (self, data, panel_scales, coord, na.rm = FALSE) {
        if (na.rm) data <- data[stats::complete.cases(self$required_aes), ]
        data <- data[order(data$group, data$x), ]
        data <- self$stairstep_confint(data)
        ggplot2::GeomRibbon$draw_group(data, panel_scales, coord, na.rm = FALSE)
      },
      stairstep_confint = function (data) {
        data <- as.data.frame(data)[order(data$x), ]
        n <- nrow(data)
        ys <- rep(1:n, each = 2)[-2 * n]
        xs <- c(1, rep(2:n, each = 2))
        data.frame(
          x = data$x[xs],
          ymin = data$ymin[ys],
          ymax = data$ymax[ys],
          data[xs, setdiff(names(data), c("x", "ymin", "ymax"))]
        )
      }
    ),
    position = position,
    params = list(na.rm = na.rm, ...)
  )
}

##' Simulate Bayesian Sequential Treatment Comparisons Using a Gaussian Model
##'
##' Simulate a sequential trial under a Gaussian model for parameter estimates, and Gaussian priors using simulated estimates and variances returned by `estSeqSim`.  For each row of the data frame `est` and for each prior/assertion combination, computes the posterior probability of the assertion.
##' @title gbayesSeqSim
##' @param est data frame created by `estSeqSim()`
##' @param asserts list of lists.  The first element of each list is the user-specified name for each assertion/prior combination, e.g., `"efficacy"`.  The other elements are, in order, a character string equal to "<", ">", or "in", a parameter value `cutoff` (for "<" and ">") or a 2-vector specifying an interval for "in", and either a prior distribution mean and standard deviation named `mu` and `sigma` respectively, or a parameter value (`"cutprior"`) and tail area `"tailprob"`.  If the latter is used, `mu` is assumed to be zero and `sigma` is solved for such that P(parameter > 'cutprior') = P(parameter < - 'cutprior') = `tailprob`.
##' @return a data frame with number of rows equal to that of `est` with a number of new columns equal to the number of assertions added.  The new columns are named `p1`, `p2`, `p3`, ... (posterior probabilities), `mean1`, `mean2`, ... (posterior means), and `sd1`, `sd2`, ... (posterior standard deviations).  The returned data frame also has an attribute `asserts` added which is the original `asserts` augmented with any derived `mu` and `sigma` and converted to a data frame, and another attribute `alabels` which is a named vector used to map `p1`, `p2`, ... to the user-provided labels in `asserts`.
##' @author Frank Harrell
##' @seealso `gbayes()`, `estSeqSim()`, `simMarkovOrd()`, `estSeqMarkovOrd()`
##' @examples
##' \dontrun{
##' # Simulate Bayesian operating characteristics for an unadjusted
##' # proportional odds comparison (Wilcoxon test)
##' # For 100 simulations, 5 looks, 2 true parameter values, and
##' # 2 assertion/prior combinations, compute the posterior probability
##' # Use a low-level logistic regression call to speed up simuluations
##' # Use data.table to compute various summary measures
##' # Total simulation time: 2s
##' lfit <- function(x, y) {
##' f <- rms::lrm.fit(x, y)
##'   k <- length(coef(f))
##'   c(coef(f)[k], vcov(f)[k, k])
##' }
##' gdat <- function(beta, n1, n2) {
##'   # Cell probabilities for a 7-category ordinal outcome for the control group
##'   p <- c(2, 1, 2, 7, 8, 38, 42) / 100
##'
##'   # Compute cell probabilities for the treated group
##'   p2 <- pomodm(p=p, odds.ratio=exp(beta))
##'   y1 <- sample(1 : 7, n1, p,  replace=TRUE)
##'   y2 <- sample(1 : 7, n2, p2, replace=TRUE)
##'   list(y1=y1, y2=y2)
##' }
##' 
##' # Assertion 1: log(OR) < 0 under prior with prior mean 0.1 and sigma 1 on log OR scale
##' # Assertion 2: OR between 0.9 and 1/0.9 with prior mean 0 and sigma computed so that
##' # P(OR > 2) = 0.05
##' asserts <- list(list('Efficacy', '<', 0, mu=0.1, sigma=1),
##'                 list('Similarity', 'in', log(c(0.9, 1/0.9)),
##'                      cutprior=log(2), tailprob=0.05))
##'
##' set.seed(1)
##' est <- estSeqSim(c(0, log(0.7)), looks=c(50, 75, 95, 100, 200),
##'                    gendat=gdat,
##'                    fitter=lfit, nsim=100)
##' z <- gbayesSeqSim(est, asserts)
##' head(z)
##' attr(z, 'asserts')
##' 
##' # Compute the proportion of simulations that hit targets (different target posterior
##' # probabilities for efficacy vs. similarity)
##'
##' # For the efficacy assessment compute the first look at which the target
##' # was hit (set to infinity if never hit)
##' require(data.table)
##' z <- data.table(z)
##' u <- z[, .(first=min(p1 > 0.95)), by=.(parameter, sim)]
##' # Compute the proportion of simulations that ever hit the target and
##' # that hit it by the 100th subject
##' u[, .(ever=mean(first < Inf)),  by=.(parameter)]
##' u[, .(by75=mean(first <= 100)), by=.(parameter)]
##' }
##' @md
gbayesSeqSim <- function(est, asserts) {
  nas     <- length(asserts)
  alabels <- character(nas)
  for(i in 1 : nas) {
    a <- asserts[[i]]
    nam <- names(a)
    if(nam[1] == '') nam[1] <- 'label'
    if(nam[2] == '') nam[2] <- 'dir'
    if(nam[3] == '') nam[3] <- 'cutoff'
    names(a)  <- nam
    if((length(a$cutoff) == 2) != (a$dir == 'in'))
      stop('mismatch of direction and length of cutoff in asserts')
    if(any(c('mu', 'sigma') %nin% names(a))) {
      a$mu    <- 0
      a$sigma <- - a$cutprior / qnorm(a$tailprob)
      if(a$sigma <= 0) stop('error in specification of cutoff or tailprob')
    }
    w <- format(round(a$cutoff, 3))
    a$assertion <- paste(if(a$dir %in% c('<','>')) a$dir,
                         if(length(a$cutoff) == 2)
                           paste0('[', w[1], ',', w[2], ']')
                         else
                           w[1])
    asserts[[i]] <- a
    alabels[i]   <- a$label
  }

  N <- nrow(est)

  ests  <- est$est
  vests <- est$vest
  ## For each simulated parameter estimate and variance compute nas
  ## posterior probabilities

  for(i in 1 : nas) {
    a      <- asserts[[i]]
    dir    <- a$dir
    cutoff <- a$cutoff
    mu     <- a$mu
    sigma2  <- (a$sigma) ^ 2
    var.post  <- 1. / (1. / sigma2 + 1. / vests)
    mean.post <- (mu / sigma2 + ests / vests) * var.post
    sd.post   <- sqrt(var.post)

    pp <-
      switch(dir,
             '<'  = pnorm(cutoff, mean.post, sd.post),
             '>'  = pnorm(cutoff, mean.post, sd.post, lower.tail=FALSE),
             'in' = pnorm(cutoff[2], mean.post, sd.post) -
                    pnorm(cutoff[1], mean.post, sd.post))
    label(pp) <- a$label
    est[[paste0('p', i)]]    <- pp
    est[[paste0('mean', i)]] <- mean.post
    est[[paste0('sd', i)]]   <- sd.post
  }

  a <- asserts
  w <- NULL
  for(j in 1 : nas) {
    a <- asserts[[j]]
    a$dir <- a$cutoff <- NULL
    if(any(c('cutprior', 'tailprob') %nin% names(a)))
      a$cutprior <- a$tailprob <- NA
    w <- rbind(w, as.data.frame(a))
    }
  attr(est, 'asserts') <- w
  names(alabels) <- paste0('p', 1 : nas)
  attr(est, 'alabels') <- alabels
  est
}

##' Simulate Comparisons For Use in Sequential Clinical Trial Simulations
##'
##' Simulates sequential clinical trials.  Looks are done sequentially at observation numbers given in the vector `looks` with the earliest possible look being at observation 2.  For each true effect parameter value, simulation, and at each look, runs a function to compute the estimate of the parameter of interest along with its variance.  For each simulation, data are first simulated for the last look, and these data are sequentially revealed for earlier looks.  The user provides a function `gendat` that given a true effect of `parameter` and the two sample sizes (for treatment groups 1 and 2) returns a list with vectors `y1` and `y2` containing simulated data.  The user also provides a function `fitter` with arguments `x` (group indicator 0/1) and `y` (response variable) that returns a 2-vector containing the effect estimate and its variance.  `parameter` is usually on the scale of a regression coefficient, e.g., a log odds ratio.
##' @title estSeqSim
##' @param parameter vector of true parameter (effects; group differences) values
##' @param looks integer vector of observation numbers at which posterior probabilities are computed
##' @param gendat a function of three arguments: true parameter value (scalar), sample size for first group, sample size for second group
##' @param fitter a function of two arguments: 0/1 group indicator vector and the dependent variable vector
##' @param nsim number of simulations (default is 1)
##' @param progress set to `TRUE` to send current iteration number to the console
##' @return a data frame with number of rows equal to the product of `nsim`, the length of `looks`, and the length of `parameter`.
##' @author Frank Harrell
##' @seealso `gbayesSeqSim()`, `simMarkovOrd()`, `estSeqMarkovOrd()`
##' @examples
##' if (requireNamespace("rms", quietly = TRUE)) {
##'   # Run 50 simulations, 5 looks, 2 true parameter values
##'   # Total simulation time: 2s
##'   lfit <- function(x, y) {
##'   f <- rms::lrm.fit(x, y)
##'     k <- length(coef(f))
##'     c(coef(f)[k], vcov(f)[k, k])
##'   }
##'   gdat <- function(beta, n1, n2) {
##'     # Cell probabilities for a 7-category ordinal outcome for the control group
##'     p <- c(2, 1, 2, 7, 8, 38, 42) / 100
##'
##'     # Compute cell probabilities for the treated group
##'     p2 <- pomodm(p=p, odds.ratio=exp(beta))
##'     y1 <- sample(1 : 7, n1, p,  replace=TRUE)
##'     y2 <- sample(1 : 7, n2, p2, replace=TRUE)
##'     list(y1=y1, y2=y2)
##'   }
##'
##'   set.seed(1)
##'   est <- estSeqSim(c(0, log(0.7)), looks=c(50, 75, 95, 100, 200),
##'                     gendat=gdat,
##'                     fitter=lfit, nsim=50)
##'   head(est)
##' }
##' @md
estSeqSim <- function(parameter, looks, gendat, fitter, nsim=1,
                      progress=FALSE) {

  looks  <- sort(looks)
  nlook  <- length(looks)
  N      <- max(looks)
  np     <- length(parameter)
  nc     <- nsim * nlook * np
  parm   <- est <- vest <- numeric(nc)
  look   <- sim <- integer(nc)
  
  ## For each simulation and each parameter value, simulate data for the
  ## whole study

  is <- 0
  for(isim in 1 : nsim) {
    if(progress) cat('Simulation', isim, '\r')
    for(param in parameter) {
      X   <- sample(0 : 1, N, replace=TRUE)
      dat <- gendat(param, sum(X == 0), sum(X == 1))
      Y   <- rep(NA, N)
      Y[X == 0] <- dat$y1
      Y[X == 1] <- dat$y2

      ## For each look compute the parameter estimate and its variance

      for(l in looks) {
        f  <- fitter(X[1 : l], Y[1 : l])
        is         <- is + 1
        sim[is]    <- isim
        parm[is]   <- param
        look[is]   <- l
        est[is]    <- f[1]
        vest[is]   <- f[2]
      }  # end looks
    }  # end param
  } # end sim
  
  if(progress) cat('\n')

  data.frame(sim=sim, parameter=parm, look=look,
             est=est, vest=vest)
}

#' Dual Standard Deviations
#'
#' Computes one standard deviation for the lower half of the distribution of a numeric vector and another SD for the upper half.  By default the center of the distribution for purposes of splitting into "halves" is the mean.  The user may override this with `center`.  When splitting into halves, observations equal to the `center` value are included in both subsets.  
#' 
#' The purpose of dual SDs is to describe variability for asymmetric distributions.  Symmetric distributions are also handled, though slightly less efficiently than a single SD does.
#' 
#' @param x a numeric vector
#' @param na.rm set to `TRUE` to find any `NA` values and remove them before computing SDs.
#' @param nmin the minimum number of non-`NA` obesrvations that must be present for two SDs to be computed.  If the mumber of non-missing values falls below `nmin`, the regular SD is duplicated in the result.
#' @param center center point for making the two subsets.  The sample mean is used to compute the two SDs no matter what is specified for `center`.
#'
#' @returns a 2-vector of SDs with names `bottom` and `top`
#' @md
#' @seealso [pMedian()]
#' @author Frank Harrell
#' @export
#'
#' @examples
#' set.seed(1)
#' x <- rnorm(20000)
#' sd(x)
#' dualSD(x)
#' y <- exp(x)
#' s1 <- sd(y)
#' s2 <- dualSD(y)
#' s1
#' s2
#' quantile(y, c(0.025, 0.975))
#' mean(y) + 1.96 * c(-1, 1) * s1
#' mean(y) + 1.96 * c(- s2['bottom'], s2['top'])
#' c(mean=mean(y), pseudomedian=pMedian(y), median=median(y))

dualSD <- function(x, na.rm=FALSE, nmin=10, center=xbar) {
  if(na.rm) x <- x[! is.na(x)]
  n <- length(x)
  if(n < nmin) {
    s <- sd(x)
    return(c(bottom=s, top=s))
  }

  xbar <- mean(x)
  s   <- function(x) sqrt(sum((x - xbar) ^ 2) / (length(x) - 1))
  a   <- s(x[x <= center])
  b   <- s(x[x >= center])
  return(c(bottom=a, top=b))
}

require(Hmisc)
set.seed(177)
sex <- factor(sample(c("m","f"), 500, rep=TRUE))
age <- rnorm(500, 50, 5)
bp  <- rnorm(500, 120, 7)
units(age) <- 'Years'; units(bp) <- 'mmHg'
label(bp) <- 'Systolic Blood Pressure'
L <- .5*(sex == 'm') + 0.1 * (age - 50)
y <- rbinom(500, 1, plogis(L))
png('/tmp/summaryRc.png', height=750)
#spar(mfrow=c(3,2), top=2, cex.axis=1)
par(mfrow=c(3,2))
summaryRc(y ~ age + bp)
# For x limits use 1st and 99th percentiles to frame extended box plots
summaryRc(y ~ age + bp, bpplot='top', datadensity=FALSE, trim=.01)
summaryRc(y ~ age + bp + stratify(sex),
          label.curves=list(keys='lines'), nloc=list(x=.1, y=.05))
dev.off()

require(Hmisc)

pm <- function(x, method=c('uniroot', 'optimize', 'bruteforce', 'cpp', 'fortran')) {
  method <- match.arg(method)
  if(method == 'fortran') return(pMedian(x))
  if(method == 'cpp') return(hlqest(x))
  if(method == 'bruteforce') { # good for N < 1000 but still slower than otheres
    w <- outer(x, x, '+')
    return(median(w[lower.tri(w, diag=TRUE)]) / 2)
  }
  r <- range(x)
  # Compute [0.1] normalized ranks just for numeric reasons
  nrank <- function(x) (rank(x) - 1) / (length(x) - 1)
  if(method == 'uniroot') {
    obj <- function(mu) sum(nrank(abs(x - mu)) * sign(x - mu))
    xs <- seq(r[1], r[2], length=100)
    o  <- sapply(xs, obj)
    zero <- approx(o, xs, xout=0)$y
    R <- uniroot(obj, r, tol=1e-6)
    if(abs(obj(zero)) < abs(R$f.root)) return(zero)
    R$root
  } else {
    obj <- function(mu) sum(nrank(abs(x - mu)) * sign(x - mu)) ^ 2
    optimize(obj, r, tol=1e-7)$minimum
    # optim(r[2], obj, method=if(FALSE)'L-BFGS-B' else 'Brent', lower=r[1], upper=r[3])$par
  }
}

# Compile C++ code from DescTools package
hl <- readLines('https://raw.githubusercontent.com/AndriSignorell/DescTools/refs/heads/master/src/hlqest.cpp')
Rcpp::sourceCpp(code=paste(hl, collapse='\n'))
# Code is also stored in ~/rr/pseudomedian/hlqest.cpp

set.seed(1)
w <- NULL
for(n in seq(5, 1000, by=5)) {
  x <- round(runif(n) * 100)
  w <- rbind(w, data.frame(n=n,
                           brute=pm(x, 'bruteforce'), cpp=pm(x, 'cpp'), fortran=pm(x, 'fortran'),
                           root=pm(x, 'uniroot'), mean=mean(x), median=median(x)))
}
for(i in 2: 4) for(j in (i + 1) : 5) cat(i, j, max(abs(w[,i] - w[,j])), '\n')
with(w, plot(n, root - cpp))
table(w$cpp >= pmin(w$mean, w$median) & w$cpp <= pmax(w$mean, w$median))
w[which.max(abs(w$cpp - w$root)),]
set.seed(1)
x <- round(runif(5) * 100)
x
x  <- c(20, 27, 37, 57, 91)
xcpp  <- pm(x, 'cpp')
xroot <- pm(x, 'uniroot')
pm(x, 'optimize')
c(xcpp, xroot)
xs <- seq(20, 91, by=0.1)
obj <- sapply(xs, function(z) sum(rank(abs(x - z)) * sign(x - z)))
approx(obj, xs, xout=0)
plot(xs, obj)
abline(v=xcpp,  col='red')
abline(v=xroot, col='blue')
abline(h=0, col=gray(0.5))

g <- function(method, n=10000) {
  for(i in 1 : 1000) {
    x <- runif(n)
    pm(x, method)
  }
}

system.time(g('bruteforce', 200))
system.time(g('uniroot', 1000))
system.time(g('cpp'))
system.time(g('fortran'))

x <- runif(5e6)
system.time(a <- pm(x, 'cpp'))
system.time(b <- pm(x, 'fortran'))
a; b

set.seed(1)
N <- integer(1000); dif <- numeric(1000)
for(i in 1 : 1000) {
  n <- sample(1 : 75000, 1)
  x <- round(runif(n) * 100)
  N[i] <- n
  dif[i] <- abs(pm(x, 'cpp') - pm(x, 'fortran'))
}
hist(dif, nclass=50)
plot(N, dif)


# Original Fortran function fails at N=46507
# The square root of the largest integer in R is (2^31 - 1) is 46341
# So the problem is in the computation of N*(N+1)/2 pairs in hlqest
# C++ function uses long integers; changed Fortran to use INTEGER*8 likewise

##' General File Import Using `rio`
##'
##' This is a front-end for the `rio` package's `import` function.  `fImport` includes options for setting variable names to lower case and to change underscores in names to periods.  Variables on the imported data frame that have `label`s are converted to Hmisc package `labelled` class so that subsetting the data frame will preserve the labels.
##' @title fImport
##' @param file name of file to import, or full URL.  `rio` determines the file type from the file suffix unless you override this with `format`
##' @param format format of file to import, usually not needed.  See `rio::import()` for details
##' @param lowernames defaults to changing variable names to all lower case unless the name as mixed upper and lower case, which results in keeping the original characters in the name.  Set `lowernames='no'` to leave variable names as they were created in the original file export, or set `lowernames='yes'` to set all names to lower case whether they have mixed case or not.  For all options, a check is made to see if the name conversions would result in any duplicate names.  If so, the original names are retained and a warning message issued.
##' @param und. set to `TRUE` to change all underscores in names to periods
##' @param ... more arguments to pass to `rio::import()`
##' @return a data frame created by `rio`, unless a `rio` option is given to use another format
##' @md
##' @seealso `upData`, especially the `moveUnits` option
##' @author Frank Harrell
##' @examples
##' \dontrun{
##' # Get a Stata dataset
##' d <- fImport('http://www.principlesofeconometrics.com/stata/alcohol.dta')
##' contents(d)
##' }
fImport <- function(file, format,
                    lowernames=c('not mixed', 'no', 'yes'),
                    und.=FALSE, ...) {
if(! requireNamespace('rio', quietly=TRUE))
    stop('requires rio package to be installed')

lowernames <- match.arg(lowernames)

d <- rio::import(file, format, ...)
n <- names(d)

labs <- sapply(d, label)
# Make labelled variables have labelled class so subsetting will preserve labels]
for(x in n[labs != '']) label(d[[x]]) <- labs[x]

chkdup <- function(new, old, txt) {
    j <- duplicated(new)
    if(any(j)) {
      warning(paste('variables would have duplicate names if', txt, ':\n',
                    paste(old[j], collapse=', ')))
      return(old)
    }
    new
}

if(und.) {
    m <- gsub('_', '\\.', n)
    n <- chkdup(m, n, '_ changed to . so und. set to FALSE')
}

if(lowernames == 'yes') {
    m <- tolower(n)
    n <- chkdup(m, n, 'changed to all lower case so lowernames set to no')
}

if(lowernames == 'not mixed') {
    mixed <- grepl('[A-Z]', n) & grepl('[a-z]', n)
    m <- ifelse(mixed, n, tolower(n))
    n <- chkdup(m, n, 'changed upper case-only variable names to all lower case so lowernames set to no')
}

names(d) <- n
d
}

##' Number of Coincident Points
##'
##' Computes the number of x,y pairs that are likely to be obscured in a regular scatterplot, in the sense of overlapping pairs after binning into `bins` x `bins` squares where `bins` defaults to 400.  `NA`s are removed first.
##' @title nCoincident
##' @param x numeric vector
##' @param y numeric vector
##' @param bins number of bins in both directions
##' @return integer count
##' @author Frank Harrell
##' @md
##' @examples
##' nCoincident(c(1:5, 4:5), c(1:5, 4:5)/10)
nCoincident <- function(x, y, bins=400) {
  i  <- ! is.na(x + y)   # exclude points missing on x or y
  x  <- x[i]
  y  <- y[i]
  rx <- range(x)
  ry <- range(y)
  x  <- round((x - rx[1]) / diff(rx) * 300)
  y  <- round((y - ry[1]) / diff(ry) * 300)
  z  <- paste(x, y)
  length(z) - length(unique(z))
}

SUBROUTINE rcorr(xx, n, p, itype, dmat, npair, x, y, rx, ry, work, iwork)
INTEGER p, npair(p,p)
DOUBLE PRECISION xx(n,p), dmat(p,p), x(n), y(n), rx(n), ry(n), work(n)
INTEGER iwork(n)
DOUBLE PRECISION sumx, sumx2, sumy, sumy2, sumxy, z, a, b, xk, yk, d

# The following is just to prevent a gfortran possible uninitialized var warning 
sumx = 0d0; sumy = 0d0; sumx2 = 0d0; sumy2 = 0d0; sumxy = 0d0

DO i = 1, p {
  np = 0
  DO k = 1, n {
    if(xx(k, i) < 1d49) np  =  np + 1
  }
  npair(i, i) = np

  DO j = (i + 1), p {
    m = 0
    if(itype == 1) {
      sumx = 0d0; sumy = 0d0; sumx2 = 0d0; sumy2 = 0d0; sumxy = 0d0
    }
    DO k = 1, n {
      xk = xx(k, i)
      yk = xx(k, j)
      if(xk < 1d49 & yk < 1d49) {
        m = m + 1
        if(itype == 1) {
          a = xk; b = yk
          sumx  = sumx + a
          sumx2 = sumx2 + a * a
          sumy  = sumy + b
          sumy2 = sumy2 + b * b
          sumxy = sumxy + a * b
        } else {
          x(m) = xk
          y(m) = yk
        }
      }
    }
    npair(i, j) = m
    if(m > 1) {
      if(itype == 1) {
        z = m
        d = (sumxy - sumx * sumy / z) / dsqrt((sumx2 - sumx * sumx / z) * (sumy2 - sumy * sumy / z))
      } else CALL docorr(x, y, m, d, rx, ry, work, iwork)
      dmat(i, j) = d
    } else dmat(i, j) = 1d50
  }
}
DO i = 1, p {
  dmat(i, i) = 1d0
  DO j = (i + 1), p {
    dmat(j, i)  = dmat(i, j)
    npair(j, i) = npair(i, j)
  }
}
RETURN
END  

	SUBROUTINE docorr(x, y, n, d, rx, ry, work, iwork)
	DOUBLE PRECISION x(1), y(1), rx(n), ry(n), work(1)
	INTEGER iwork(1)
	DOUBLE PRECISION sumx, sumx2, sumy, sumy2, sumxy, a, b, z, d
	CALL rank(n, x, work, iwork, rx)
	CALL rank(n, y, work, iwork, ry)
	sumx = 0d0; sumx2 = 0d0; sumy = 0d0; sumy2 = 0d0; sumxy = 0d0
	DO i = 1, n {
	  a = rx(i)
	  b = ry(i)
	  sumx  = sumx + a
	  sumx2 = sumx2 + a * a
	  sumy  = sumy + b
	  sumy2 = sumy2 + b * b
	  sumxy = sumxy + a * b
	}
	z = n
	d = (sumxy - sumx * sumy / z) / dsqrt((sumx2 - sumx * sumx / z) * (sumy2 - sumy * sumy / z))	
	RETURN
	END	

##' Test Character Variables for Dates and Times
##'
##' For a vector `x`, if it is already a date-time, date, or time variable, the type is returned if `convert=FALSE`, or a list with that type, the original vector, and `numna=0` is returned.  Otherwise if `x` is not a character vector, a type of `notcharacter` is returned, or a list that includes the original `x` and `type='notcharacter'`.  When `x` is character, the main logic is applied.  The default logic (when `m=0`) is to consider `x` a date-time variable when its format is YYYY-MM-DD HH:MM:SS (:SS is optional) in more than 1/2 of the non-missing observations.  It is considered to be a date if its format is YYYY-MM-DD or MM/DD/YYYY or DD-MMM-YYYY in more than 1/2 of the non-missing observations (MMM=3-letter month).  A time variable has the format HH:MM:SS or HH:MM.  Blank values of `x` (after trimming) are set to `NA` before proceeding.
##' @title testCharDateTime
##' @param x input vector of any type, but interesting cases are for character `x`
##' @param p minimum proportion of non-missing non-blank values of `x` for which the format is one of the formats described before considering `x` to be of that type
##' @param m if greater than 0, a test is applied: the number of distinct illegal values of `x` (values containing a letter or underscore) must not exceed `m`, or type `character` will be returned.  `p` is set to `1.0` when `m` > 0.
##' @param convert set to `TRUE` to convert the variable under the dominant format.  If all values are `NA`, `type` will be set to `'character'`.
##' @param existing set to `TRUE` to return a character string with the current type of variable without examining pattern matches
##' @return if `convert=FALSE`, a single character string with the type of `x`: `"character", "datetime", "date", "time"`.  If `convert=TRUE`, a list with components named `type`, `x` (converted to `POSIXct`, `Date`, or `chron` times format), and `numna`, the number of originally non-`NA` values of `x` that could not be converted to the predominant format.  If there were any non-covertible dates/times,
##' the returned vector is given an additional class `special.miss` and an
##' attribute `special.miss` which is a list with original character values
##' (`codes`) and observation numbers (`obs`).  These are summarized by
##' `describe()`.
##' @md
##' @author Frank Harrell
##' @examples
##' for(conv in c(FALSE, TRUE)) {
##'   print(testCharDateTime(c('2023-03-11', '2023-04-11', 'a', 'b', 'c'), convert=conv))
##'   print(testCharDateTime(c('2023-03-11', '2023-04-11', 'a', 'b'), convert=conv))
##'   print(testCharDateTime(c('2023-03-11 11:12:13', '2023-04-11 11:13:14', 'a', 'b'), convert=conv))
##'   print(testCharDateTime(c('2023-03-11 11:12', '2023-04-11 11:13', 'a', 'b'), convert=conv))
##'   print(testCharDateTime(c('3/11/2023', '4/11/2023', 'a', 'b'), convert=conv))
##' }
##' x <- c(paste0('2023-03-0', 1:9), 'a', 'a', 'a', 'b')
##' y <- testCharDateTime(x, convert=TRUE)$x
##' describe(y)  # note counts of special missing values a, b

testCharDateTime <- function(x, p=0.5, m=0, convert=FALSE, existing=FALSE) {
  ret <- function(type, x, numna=0)
    if(convert) list(type=type, x=x, numna=numna) else type

  cl <- class(x)
  if(any(cl %in% c('POSIXt', 'POSIXct', 'chron'))) return(ret('datetime', x))
  if(any(cl %in% c('Date', 'dates')))              return(ret('date',     x))
  if(any(cl == 'times'))                           return(ret('time',     x))
  if(! is.character(x))                            return(ret('notcharacter', x))

  if(existing) return('character')
  
  y                <- x
  y[trimws(y) == ''] <- NA
  x                <- x[! is.na(x)]
  if(! length(x)) return(ret('character', y, numna=length(y)))
  if(m > 0) {
    p      <- 1.0
    ischar <- grep('[a-z,A-Z,_]', x)
    uchar  <- unique(x[ischar])
    lu     <- length(uchar)
    if(lu) {
      if(lu > m) return(ret('character', y)) # more than m unique char values
      x <- x[- ischar]                       # values with no alpha characters
      if(! length(x)) return(ret('character', y))
    }
  }
  # If p=1.0 all non-NA non-blank values must be legal date/time
  # Minimum length for those is 5 characters, max is 19
  # Save some time for this case
  if(p == 1.0) {
    len <- range(nchar(x))
    if(len[1] < 5 | len[2] > 19) return(ret('character', y))
    }
  
  rex <- c(
    '^[0-9]{4}-[0-1][0-9]-[0-3][0-9] [0-2][0-9]:[0-5][0-9]:[0-5][0-9]$',
    '^[0-9]{4}-[0-1][0-9]-[0-3][0-9] [0-2][0-9]:[0-5][0-9]$',
    '^[0-9]{4}-[0-1][0-9]-[0-3][0-9]$',
    '^[0-9]{1,2}/[0-9]{1,2}/[0-9]{4}$',
    '^[0-3][0-9]-(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)-[0-9]{4}$',
    '^[0-2][0-9]:[0-5][0-9]:[0-5][0-9]$',
    '^[0-2][0-9]:[0-5][0-9]$' )
  types <- c('datetime', 'datetime', 'date', 'date', 'date', 'time', 'time')
  nx <- length(x)
  for(i in 1 : 6) {
    ty <- types[i]
    rx <- rex[i]
    ngood <- sum(grepl(rx, x, ignore.case=TRUE))
    if(ngood / nx >= p) {
      if(! convert) return(ty)
      nna  <- ! is.na(y)
      good <- grepl(rx, y, ignore.case=TRUE)
      bad  <- nna & ! good
      j    <- nna & good
      z    <- rep(NA, length(y))
      fm <- c('', '', '%Y-%m-%d', '%m/%d/%Y', '%d-%b-%Y', '')[i]
      if(i > 4) if(! requireNamespace('chron', quietly=TRUE))
                  stop('chron package is required for pure time variables')
      sec <- if(i %in% c(2, 7)) ':00' else ''
      zj <- switch(ty,
                   datetime = as.POSIXct(y[j]),,
                   date     = as.Date(y[j], format=fm),
                   time     = chron::chron(times.=paste0(y[j], sec))   )
      z[j]     <- zj
      class(z) <- class(zj)
      lab      <- label(y)
      if(lab != '') label(z) <- lab
      un                     <- units(y)
      if(un  != '') units(z) <- un
      if(any(bad)) {
        class(z) <- c('special.miss', class(z))
        attr(z, 'special.miss') <- list(codes=y[bad], obs=which(bad))
        }
      return(list(type=ty, x=z, numna=nx - ngood))
    }
  }
  ret('character', y)
}

---
title: "Hmisc Examples"
author: "FE Harrell<br><small>Department of Biostatistics<br>Vanderbilt University</small>"
date: '`r Sys.Date()`'
output:
  rmdformats::readthedown:
    thumbnails: false
    lightbox: true
    gallery: true
    highlight: tango
    use_bookdown: true
    toc_depth: 3
    fig_caption: true
csl: american-medical-association.csl
bibliography: /home/harrelfe/bib/harrelfe.bib
description: "Hmisc examples using plotly interactive graphics in an html report"
---
 
<!-- Usage:   RStudio ... Knit or md2rmdreadthedown examples
              mv examples.html ~/web/R/Hmisc/    -->

**NOTE**: remove the `csl` and `bibliography` lines above if you don't have any bibliographic citations.


# Introduction
This is a set of reproducible examples for the R[@R] `Hmisc` package[@Hmisc], put together in an `rmarkdown` html document using `RStudio` and `knitr`.  When viewing the resulting [html file](https://hbiostat.org/R/Hmisc/examples.html) you can see all the code, and there exist options to download the entire `rmarkdown` script, which is especially helpful for seeing how `knitr` chunks are specified.  Graphics that have a [plotly](http://plot.ly/r) method for them are rendered using `plotly` instead of using defaults such as base graphics, `lattice`, or `ggplot2`.  That way the plots are somewhat interactive, e.g., allow for drill-down for more information without the viewer needing to install `R`.
    
Much of the tabular output produced here was created using `html` methods, which are especially easy to implement with `rmarkdown` and make for output that can be directly opened using word processors.  Jump to [Computing Environment](#compenv) for a list of packages used here, and their version numbers.

`Rmarkdown` themes such as `bookdown` and [rmdformats::readthedown](https://github.com/juba/rmdformats) (the latter is used here) allow one to number figures and the symbolically reference them.  The `knitrSet` `capfile='captions.md'` argument below capitalizes on this to make it easy for the user to insert a table of figures anywhere in the report.  Here we place it at the end.  A caption listed in the table of figures is the short caption (`scap=` or `fig.scap` in the chunk header) if there is one, otherwise the long caption is used.  If neither caption is used, that figure will not appear in the table of figures.

The full script for this report may be found [here](https://github.com/harrelfe/Hmisc/blob/master/inst/tests/examples.Rmd).


# Setup

```{r setup,results='hide'}
require(Hmisc)
knitrSet(lang='markdown', h=4.5, fig.path='png/', fig.align='left',
         capfile='captions.md')  # + sometimes ,cache=TRUE
# knitrSet redirects all messages to messages.txt
options(grType='plotly') # for certain graphics functions
mu <- markupSpecs$html   # markupSpecs is in Hmisc
cap  <- mu$cap           # function to output html caption
lcap <- mu$lcap          # for continuation for long caption
# These last 2 functions are used by the putHfig function in Hmisc
cat('', file='captions.md')   # initialize table of short captions
```

The following (<code>r mu$styles()</code>) defines HTML styles and javascript functions, such as <code>ffig, smg</code> and the function for expanding and collapsing text as done by the <code>expcoll</code> function. 
`r mu$styles()`

Here is an example using <code>expcoll</code>.  Click on the down arrow to expand; it turns to an up arrow which can be clicked to contract.

`r mu$expcoll('Example table<br>', html(data.frame(x1=runif(10), x2=letters[1:10]),file=FALSE))`

Here is an example using a `knitr` hook function `markupSpec$html$uncover` which is communicated to `knitr` by `knitrSet`.

<script>
function uncover(id) {
    var x = document.getElementById(id);
    x.style.display = 'block';
}
</script>

```{r, uncover=TRUE, label='Press Here', id='script'}
1 + 1
```

To make the html output use the entire wide screen run the R command `mu$widescreen()`.

# Fetching Data, Modifying Variables, and Printing Data Dictionary
The `getHdata` function is used to fetch a dataset from the Vanderbilt `DataSets` web site `hbiostat.org/data`.  The `upData` function is used to

- create a new variable from an old one
- add labels to 2 variables
- add units to the new variable
- remove the old variable
- automatically move units of measurements from parenthetical expressions in labels to separate `units` attributed used by `Hmisc` and `rms` functions for table making and graphics

`contents` is used to print a data dictionary, run through an `html` method for nicer output.  Information about the data source may be found [here](https://hbiostat.org/data/repo/pbc.html).  Click on the number of levels in the `contents` table to jump to the value labels for the variable.

```{r metadata,results='asis'}
getHdata(pbc)

# Have upData move units from labels to separate attribute
pbc <- upData(pbc,
              fu.yrs = fu.days / 365.25,
              labels = c(fu.yrs = 'Follow-up Time',
                         status = 'Death or Liver Transplantation'),
              units = c(fu.yrs = 'year'),
              drop  = 'fu.days',
              moveUnits=TRUE, html=TRUE)
# The following can also be done by running this command
# to put the results in a new browser tab:
# getHdata(pbc, 'contents')
html(contents(pbc), maxlevels=10, levelType='table')
```

# Descriptive Statistics Without Stratification

The html method is used for the `describe` function, and the output is put in a scrollable box.  Other than for the overall title and variable names and labels, the output size used here is 80 (0.8 &times; the usual font size[^1]).  But the graphical display of the descriptives statistics that follows this is probably better.

[^1]: The default is 75% size.

```{r describe,results='asis'}
# did have results='asis' above
d <- describe(pbc)
html(d, size=80, scroll=TRUE)

# prList is in Hmisc; useful for plotting or printing a list of objects
# Can just use plot(d) if don't care about the mess
# If using html output these 2 images would not be rendered no matter what
p <- plot(d)
# The option htmlfig=2 causes markupSpecs$html$cap() to be used to
# HTML-typeset as a figure caption and to put the sub-sub section
# marker ### in front of the caption.  htmlfig is the only reason
# results='asis' was needed in the chunk header
# We define a long caption for one of the plots, which does not appear
# in the table of contents
# prList works for html notebooks but not html documents
# prList(p, lcap=c('', 'These are spike histograms'), htmlfig=2)
```

You can also re-form multiple `plotly` graphs into a [single HTML object](http://stackoverflow.com/questions/35193612).  If you want to have total control over long and short figure captions, use the Hmisc `putHfig` function to render the result, with a caption and a short caption for the table of contents. That would have fixed a problem with the chunk below: when `plotly` graphics are not rendered in the usual way, the figure is not numbered and no caption appears.

```{r plotlym,cap='This used the <code>htmltools tagList</code> function.',scap='Two <code>plotly</code> graphics combined into one'}
htmltools::tagList(p)    # lapply(p, plotly::as.widget)
```

You can also create figure captions outside of R code by using the <code>smg, fcap</code> HTML tags defined in <code>markupSpecs</code>.  The long caption not appearing in the table of contents will be in a separate line without ###.

# Stratified Descriptive Statistics

Produce stratified quantiles, means/SD, and proportions by treatment group.  Plot the results before rendering as an advanced html table:

- categorical variables: a single dot chart
- continuous variables: a series of extended box plots

```{r summaryM,cap=paste('Proportions and', mu$chisq(), 'tests for categorical variables')}
s <- summaryM(bili + albumin + stage + protime + sex + age + spiders +
              alk.phos + sgot + chol ~ drug, data=pbc,
							overall=FALSE, test=TRUE)
plot(s, which='categorical')
```

To construct the caption outside of the code chunk use e.g. ### r cap('Proportions and', mu$chisq(), 'tests for categorical variables') where a backtick is placed before r and after the last ).

```{r summaryM2,results='asis',cap='Extended box plots for the first 4 continuous variables'}
plot(s, which='continuous', vars=1 : 4)
```

```{r summaryM3,cap='Extended box plots for the remaining continuous variables'}
plot(s, which='continuous', vars=5 : 7)
```

```{r summaryM4}
html(s, caption='Baseline characteristics by randomized treatment',
     exclude1=TRUE, npct='both', digits=3, middle.bold=TRUE,
     prmsd=TRUE, brmsd=TRUE, msdsize=mu$smaller2)
```
Now show almost the full raw data for one continuous variable stratified by treatment.  This display spike histograms using at most 100 bins, and also shows the mean and quantiles similar to what is in an extended box plot: 0.05, 0.25, 0.5, 0.75, 0.95.  Measures of spread are also shown if the user clicks on their legend entries: Gini's mean difference (mean absolute difference between any two values) and the SD.  These can be seen as horizontal lines up against the minimum x-value.
```{r histbox,cap="Spike histograms, means, quantiles, Gini's mean difference, and SD stratified by treatment",scap="Stratified spike histograms and quantiles"}
with(pbc, histboxp(x=sgot, group=drug, sd=TRUE))
```

The following is a better way to display proportions, for categorical variables.  If computing marginal statistics by running the dataset through the `Hmisc` `addMarginal` function, the `plot` method with `options(grType='plotly')` is especially useful.

```{r summaryM5,cap='Proportions (large symbols) and proportions stratified by treatment (small symbols)',scap='Proportions with and without stratification by treatment'}
pbcm <- addMarginal(pbc, drug)
s <- summaryP(stage + sex + spiders ~ drug, data=pbc)
# putHcap('Proportions stratified by treatment')
plot(s, groups='drug')
s <- summaryP(stage + sex + spiders ~ drug, data=pbcm)
plot(s, marginVal='All', marginLabel='All Treatment Groups')
```

# Better Demonstration of Boxplot Replacement
```{r support,cap="Spike histograms, means, quantiles, Gini's mean difference, and SD for MAP stratified by diagnosis",scap="Stratified spike histograms and quantiles for MAP"}
getHdata(support2)
with(support2, histboxp(x=meanbp, group=dzgroup, sd=TRUE, bins=200))
```

# Changing Size of Figure Captions
As explained [here](https://stackoverflow.com/questions/45018397), one can place captions under figures using ordinary `knitr` capabilities, and one can change the size of captions.  The following example defines a `CSS` style to make captions small (here `0.6em`), and produces a plot with a caption.  Unlike using `putHfig` captions given in `knitr` chunks do not also appear in the table of contents.

<style>
p.caption {
  font-size: 0.6em;
}
</style>

```{r simplecap,cap='This is a simple figure caption'}
# Note: in the chunk header cap is an alias for fig.cap defined by knitrSet
plot(runif(10))
```

# Computing Environment[^2] {#compenv}
`r mu$session()`

# Bibliographic File Managament
## Find and Install `.csl` Reference Style Files
```{r findbib,eval=FALSE}
# Note: mu was defined in an earlier code chunk
# Only need to install .csl file once.
mu$installcsl(rec=TRUE)   # get list of recommended styles
mu$installcsl()     # web search of styles meeting your criteria
# Install a .csl file to your project directory:
mu$installcsl('american-medical-association')
```

`r markupSpecs$markdown$tof()`

Note: the hidden R command that rendered the table of figures (including short captions) was `markupSpecs$markdown$tof()`.


[^2]: `mu` is a copy of the part of the `Hmisc` package object `markupSpecs` that is for html.  It includes a function `session` that renders the session environment (including package versions) in html.


# References

\name{somers2}
\alias{somers2}
\title{
Somers' Dxy Rank Correlation
}
\description{
Computes Somers' Dxy rank correlation between a variable \code{x} and a
binary (0-1) variable \code{y}, and the corresponding receiver operating
characteristic curve area \code{c}. Note that \code{Dxy = 2(c-0.5)}.  
\code{somers} allows for a \code{weights} variable, which specifies frequencies
to associate with each observation.
}
\usage{
somers2(x, y, weights=NULL, normwt=FALSE, na.rm=TRUE)
}
\arguments{
\item{x}{
typically a predictor variable. \code{NA}s are allowed.
}
\item{y}{
a numeric outcome variable coded \code{0-1}. \code{NA}s are allowed.
}
\item{weights}{
a numeric vector of observation weights (usually frequencies).  Omit
or specify a zero-length vector to do an unweighted analysis.
}
\item{normwt}{
set to \code{TRUE} to make \code{weights} sum to the actual number of non-missing
observations.
}
\item{na.rm}{
set to \code{FALSE} to suppress checking for NAs.
}}
\value{
a vector with the named elements \code{C}, \code{Dxy}, \code{n} (number of non-missing
pairs), and \code{Missing}. Uses the formula 
\code{C = (mean(rank(x)[y == 1]) - (n1 + 1)/2)/(n - n1)}, where \code{n1} is the
frequency of \code{y=1}.
}
\details{
The \code{rcorr.cens} function, which although slower than \code{somers2} for large
sample sizes, can also be used to obtain Dxy for non-censored binary
\code{y}, and it has the advantage of computing the standard deviation of
the correlation index.
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University School of Medicine
\cr
\email{fh@fharrell.com}
}
\seealso{
\code{\link{rcorr.cens}}, \code{\link{rank}}, \code{\link{wtd.rank}}, 
}
\examples{
set.seed(1)
predicted <- runif(200)
dead      <- sample(0:1, 200, TRUE)
roc.area <- somers2(predicted, dead)["C"]

# Check weights
x <- 1:6
y <- c(0,0,1,0,1,1)
f <- c(3,2,2,3,2,1)
somers2(x, y)
somers2(rep(x, f), rep(y, f))
somers2(x, y, f)
}
\keyword{nonparametric}
\concept{logistic regression model}
\concept{predictive accuracy}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/abd.r
\name{getabd}
\alias{getabd}
\title{getabd}
\usage{
getabd(name = "", lowernames = FALSE, allow = "_")
}
\arguments{
\item{name}{name of dataset to fetch.  Omit to get a data table listing all available datasets.}

\item{lowernames}{set to \code{TRUE} to change variable names to lower case}

\item{allow}{set to \code{NULL} to convert underscores in variable names to periods}
}
\value{
data frame with attributes \code{label} and \code{url}
}
\description{
Data from The Analysis of Biological Data by Shitlock and Schluter
}
\details{
Fetches csv files for exercises in the book
}
\author{
Frank Harrell
}

\name{bpplot}
\alias{bpplot}
\title{
Box-percentile plots
}
\description{
Producess side-by-side box-percentile plots from several vectors or a
list of vectors.  
}
\usage{
bpplot(\dots, name=TRUE, main="Box-Percentile Plot", 
       xlab="", ylab="", srtx=0, plotopts=NULL)
}
\arguments{
\item{...}{
vectors or lists containing 
numeric components (e.g., the output of \code{split}).
}
\item{name}{
character vector of names for the groups.  
Default is \code{TRUE} to put names on the x-axis.  Such names are taken from the 
data vectors or the \code{names} attribute of the first argument if it is a list.
Set \code{name} to \code{FALSE} to suppress names.
If a character vector is supplied the names in the vector are
used to label the groups.
}
\item{main}{
main title for the plot.
}
\item{xlab}{
x axis label.
}
\item{ylab}{
y axis label.
}
\item{srtx}{rotation angle for x-axis labels.  Default is zero.}
\item{plotopts}{a list of other parameters to send to \code{plot}}
}
\value{
There are no returned values
}
\section{Side Effects}{
A plot is created on the current graphics device.
}
\section{BACKGROUND}{
Box-percentile plots are similiar to boxplots, except box-percentile plots
supply more information about the univariate distributions.  At any height
the width of the irregular "box" is proportional to the percentile of that
height, up to the 50th percentile, and above the 50th percentile the width
is proportional to 100 minus the percentile.  Thus, the width at any given
height is proportional to the percent of observations that are more 
extreme in that direction.  As in boxplots, the median, 25th and 75th 
percentiles are marked with line segments across the box.
}
\author{
Jeffrey Banfield
\cr
\email{umsfjban@bill.oscs.montana.edu}
\cr
Modified by F. Harrell 30Jun97
}
\references{
Esty WW, Banfield J: The box-percentile plot.  J Statistical
Software 8 No. 17, 2003.
}
\seealso{
\code{\link{panel.bpplot}}, \code{\link{boxplot}}, \code{\link{Ecdf}},
\code{\link[lattice:xyplot]{bwplot}} 
}
\examples{
set.seed(1)
x1 <- rnorm(500)
x2 <- runif(500, -2, 2)
x3 <- abs(rnorm(500))-2
bpplot(x1, x2, x3)
g <- sample(1:2, 500, replace=TRUE)
bpplot(split(x2, g), name=c('Group 1','Group 2'))
rm(x1,x2,x3,g)
}
\keyword{nonparametric}
\keyword{hplot}
% Converted by Sd2Rd version 1.21.

\name{string.bounding.box}
\alias{string.bounding.box}
\title{Determine Dimensions of Strings}
\description{
  This determines the number of rows and maximum number of columns of
  each string in a vector.
}
\usage{
string.bounding.box(string, type = c("chars", "width"))
}
\arguments{
  \item{string}{vector of strings}
  \item{type}{character: whether to count characters or screen columns}
}
\value{
  \item{rows}{vector containing the number of character rows in each string}
  \item{columns}{vector containing the maximum number of character
    columns in each string}
}
\author{Charles Dupont}
\seealso{\code{\link{nchar}}, \code{\link{stringDims}}}
\examples{
a <- c("this is a single line string", "This is a\nmulti-line string")
stringDims(a)
}
\keyword{print}

\name{first.word}
\alias{first.word}
\title{First Word in a String or Expression}
\description{
\code{first.word} finds the first word in an expression.  A word is defined by
unlisting the elements of the expression found by the S parser and then
accepting any elements whose first character is either a letter or period.
The principal intended use is for the automatic generation of temporary
file names where it is important to exclude special characters from
the file name. For Microsoft Windows, periods in names are deleted and
only up to the first 8 characters of the word is returned.
}
\usage{
first.word(x, i=1, expr=substitute(x))
}
\arguments{
\item{x}{
any scalar character string
}
\item{i}{
word number, default value = 1.  Used when the second or \code{i}th word is
wanted.  Currently only the \code{i=1} case is implemented.
}
\item{expr}{
any S object of mode \code{expression}.
}
}
\value{
a character string
}
\author{
Frank E. Harrell, Jr.,
\cr
Department of Biostatistics,
\cr
Vanderbilt University,
\cr
\email{fh@fharrell.com}


Richard M. Heiberger,
\cr
Department of Statistics,
\cr
Temple University, Philadelphia, PA.
\cr
\email{rmh@temple.edu}
}
\examples{
first.word(expr=expression(y ~ x + log(w)))
}
\keyword{character}
\keyword{manip}

\name{addMarginal}
\alias{addMarginal}
\title{Add Marginal Observations}
\usage{
addMarginal(data, ..., label = "All", margloc=c('last', 'first'), nested)
}
\arguments{
  \item{data}{a data frame}
	\item{\dots}{a list of names of variables to marginalize}
	\item{label}{category name for added marginal observations}
	\item{margloc}{location for marginal category within factor variable
		specifying categories.  Set to \code{"first"} to override the
		default - to put a category with value \code{label} as the first
		category.}
	\item{nested}{a single unquoted variable name if used}
}
\description{
Given a data frame and the names of variable, doubles the
data frame for each variable with a new category
\code{"All"} by default, or by the value of \code{label}.
A new variable \code{.marginal.} is added to the resulting data frame,
with value \code{""} if the observation is an original one, and with
value equal to the names of the variable being marginalized (separated
by commas) otherwise.  If there is another stratification variable
besides the one in \dots, and that variable is nested inside the
variable in \dots, specify \code{nested=variable name} to have the value
of that variable set fo \code{label} whenever marginal observations are
created for \dots.  See the state-city example below.
}
\examples{
d <- expand.grid(sex=c('female', 'male'), country=c('US', 'Romania'),
                 reps=1:2)
addMarginal(d, sex, country)

# Example of nested variables
d <- data.frame(state=c('AL', 'AL', 'GA', 'GA', 'GA'),
                city=c('Mobile', 'Montgomery', 'Valdosto',
                       'Augusta', 'Atlanta'),
                x=1:5, stringsAsFactors=TRUE)
addMarginal(d, state, nested=city) # cite set to 'All' when state is
}
\keyword{utilities}
\keyword{manip}

\name{simplifyDims}
\alias{simplifyDims}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{List Simplification}
\description{
  Takes a list where each element is a group of rows that have been
  spanned by a multirow row and combines it into one large matrix.
}
\usage{
simplifyDims(x)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{list of spanned rows}
}
\details{
  All rows must have the same number of columns.  This is used to format
  the list for printing.
}
\value{
  a matrix that contains all of the spanned rows.
}
\author{Charles Dupont}
\seealso{\code{\link{rbind}}}
\examples{
a <- list(a = matrix(1:25, ncol=5), b = matrix(1:10, ncol=5), c = 1:5)

simplifyDims(a)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{print}

\name{latexDotchart}
\alias{latexDotchart}
\title{Enhanced Dot Chart for LaTeX Picture Environment with epic}
\description{
\code{latexDotchart}  is a translation of the \code{dotchart3} function
for producing a vector of character strings containing LaTeX picture
environment markup that mimics \code{dotchart3} output.  The LaTeX
\code{epic} and \code{color} packages are required.  The \code{add} and
\code{horizontal=FALSE} options are not available for
\code{latexDotchart}, however. 
}
\usage{
latexDotchart(data, labels, groups=NULL, gdata=NA, 
  xlab='', auxdata, auxgdata=NULL, auxtitle,
  w=4, h=4, margin,      
  lines=TRUE, dotsize = .075, size='small', size.labels='small',
  size.group.labels='normalsize', ttlabels=FALSE, sort.=TRUE,
  xaxis=TRUE, lcolor='gray', ...)
}
\arguments{
  \item{data}{a numeric vector whose values are shown on the x-axis}
  \item{labels}{a vector of labels for each point, corresponding to
	\code{x}.  If omitted, \code{names(data)} are used, and if there are
	no \code{names}, integers prefixed by \code{"#"} are used.}
  \item{groups}{an optional categorical variable indicating how
	\code{data} values are grouped}
  \item{gdata}{data values for groups, typically summaries such as group
	medians}
  \item{xlab}{x-axis title}
  \item{auxdata}{
	a vector of auxiliary data, of the same length
	as the first (\code{data}) argument.  If present, this
	vector of values will be printed outside the right margin of the dot
	chart.  Usually \code{auxdata} represents cell sizes.
  }
  \item{auxgdata}{
	similar to \code{auxdata} but corresponding to the \code{gdata}
	argument.  These usually represent overall sample sizes for each
	group of lines.}
  \item{auxtitle}{
	if \code{auxdata} is given, \code{auxtitle} specifies a column
	heading for the extra printed data in the chart, e.g., \code{"N"}}
  \item{w}{width of picture in inches}
  \item{h}{height of picture in inches}
  \item{margin}{a 4-vector representing, in inches, the margin to the
	left of the x-axis, below the y-axis, to the right of the x-axis,
	and above the y-axis.  By default these are computed making educated
	cases about how to accommodate \code{auxdata} etc.}
  \item{lines}{set to \code{FALSE} to suppress drawing of reference
	lines}
  \item{dotsize}{diameter of filled circles, in inches, for drawing dots}
  \item{size}{size of text in picture.  This and the next two arguments
	are LaTeX font commands without the opening backslash, e.g.,
	\code{'normalsize'}, \code{'small'}, \code{'large'}, \code{smaller[2]}.}
  \item{size.labels}{size of labels}
  \item{size.group.labels}{size of labels corresponding to \code{groups}}
  \item{ttlabels}{set to \code{TRUE} to use typewriter monospaced font
	for labels}
  \item{sort.}{
	set to \code{FALSE} to keep \code{latexDotchart} from sorting the input
	data, i.e., it will assume that the data are already properly
	arranged.  This is especially useful when you are using \code{gdata}
	and \code{groups} and you want to control the
	order that groups appear on the chart (from top to bottom).}
  \item{xaxis}{set to \code{FALSE} to suppress drawing x-axis}
  \item{lcolor}{
	color for horizontal reference lines.  Default is \code{"gray"}}
  \item{...}{ignored}
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\seealso{
\code{\link[Hmisc]{dotchart3}}
}
\examples{
\dontrun{
z <- latexDotchart(c(.1,.2), c('a','bbAAb'), xlab='This Label',
                   auxdata=c(.1,.2), auxtitle='Zcriteria')
f <- '/tmp/t.tex'
cat('\\documentclass{article}\n\\usepackage{epic,color}\n\\begin{document}\n', file=f)
cat(z, sep='\n', file=f, append=TRUE)
cat('\\end{document}\n', file=f, append=TRUE)

set.seed(135)
maj <- factor(c(rep('North',13),rep('South',13)))
g <- paste('Category',rep(letters[1:13],2))
n <- sample(1:15000, 26, replace=TRUE)
y1 <- runif(26)
y2 <- pmax(0, y1 - runif(26, 0, .1))
z <- latexDotchart(y1, g, groups=maj, auxdata=n, auxtitle='n', xlab='Y',
                   size.group.labels='large', ttlabels=TRUE)
f <- '/tmp/t2.tex'
cat('\\documentclass{article}\n\\usepackage{epic,color}\n\\begin{document}\n\\framebox{', file=f)
cat(z, sep='\n', file=f, append=TRUE)
cat('}\\end{document}\n', file=f, append=TRUE)
}
}
\keyword{hplot}

\name{samplesize.bin}
\alias{samplesize.bin}
\title{
  Sample Size for 2-sample Binomial
}
\description{
  Computes sample size(s) for 2-sample binomial problem given vector or
  scalar probabilities in the two groups.
}
\usage{
samplesize.bin(alpha, beta, pit, pic, rho=0.5)
}
\arguments{
  \item{alpha}{
    scalar ONE-SIDED test size, or two-sided size/2
  }
  \item{beta}{
    scalar or vector of powers
  }
  \item{pit}{
    hypothesized treatment probability of success
  }
  \item{pic}{
    hypothesized control probability of success
  }
  \item{rho}{
    proportion of the sample devoted to treated group (\eqn{0 <\code{rho} < 1})
  }
}
\value{
  TOTAL sample size(s)
}
\section{AUTHOR}{
  Rick Chappell\cr
  Dept. of Statistics and Human Oncology\cr
  University of Wisconsin at Madison\cr
  \email{chappell@stat.wisc.edu}
}
\examples{
alpha <- .05
beta <- c(.70,.80,.90,.95)


# N1 is a matrix of total sample sizes whose
# rows vary by hypothesized treatment success probability and
# columns vary by power
# See Meinert's book for formulae.


N1 <- samplesize.bin(alpha, beta, pit=.55, pic=.5)
N1 <- rbind(N1, samplesize.bin(alpha, beta, pit=.60, pic=.5))
N1 <- rbind(N1, samplesize.bin(alpha, beta, pit=.65, pic=.5))
N1 <- rbind(N1, samplesize.bin(alpha, beta, pit=.70, pic=.5))
attr(N1,"dimnames") <- NULL


#Accounting for 5\% noncompliance in the treated group
inflation <- (1/.95)**2
print(round(N1*inflation+.5,0))
}
\keyword{htest}
\keyword{category}
\concept{study design}
\concept{power}

\name{cpower}
\alias{cpower}
\title{
Power of Cox/log-rank Two-Sample Test
}
\description{
Assumes exponential distributions for both treatment groups.
Uses the George-Desu method along with
formulas of Schoenfeld that allow estimation of the expected number of
events in the two groups.  
To allow for drop-ins (noncompliance to control therapy, crossover to
intervention) and noncompliance of the intervention, the method of
Lachin and Foulkes is used.
}
\usage{
cpower(tref, n, mc, r, accrual, tmin, noncomp.c=0, noncomp.i=0, 
       alpha=0.05, nc, ni, pr=TRUE)
}
\arguments{
\item{tref}{
time at which mortalities estimated
}
\item{n}{
total sample size (both groups combined).  If allocation is unequal
so that there are not \code{n/2} observations in each group, you may specify
the sample sizes in \code{nc} and \code{ni}.
}
\item{mc}{
tref-year mortality, control
}
\item{r}{
\% reduction in \code{mc} by intervention
}
\item{accrual}{
duration of accrual period
}
\item{tmin}{
minimum follow-up time
}
\item{noncomp.c}{
\% non-compliant in control group (drop-ins)
}
\item{noncomp.i}{
\% non-compliant in intervention group (non-adherers)
}
\item{alpha}{
type I error probability.  A 2-tailed test is assumed.
}
\item{nc}{
number of subjects in control group
}
\item{ni}{
number of subjects in intervention group.  \code{nc} and \code{ni} are specified
exclusive of \code{n}.
}
\item{pr}{
set to \code{FALSE} to suppress printing of details
}}
\value{
power
}
\section{Side Effects}{
prints
}
\details{
For handling noncompliance, uses a modification of formula (5.4) of
Lachin and Foulkes.  Their method is based on a test for the difference
in two hazard rates, whereas \code{cpower} is based on testing the difference
in two log hazards.  It is assumed here that the same correction factor
can be approximately applied to the log hazard ratio as Lachin and Foulkes applied to
the hazard difference.


Note that Schoenfeld approximates the variance
of the log hazard ratio by \code{4/m}, where \code{m} is the total number of events,
whereas the George-Desu method uses the slightly better \code{1/m1 + 1/m2}.
Power from this function will thus differ slightly from that obtained with
the SAS \code{samsizc} program.
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
f.harrell@vanderbilt.edu
}
\references{
Peterson B, George SL: Controlled Clinical Trials 14:511--522; 1993.


Lachin JM, Foulkes MA: Biometrics 42:507--519; 1986.


Schoenfeld D: Biometrics 39:499--503; 1983.
}
\seealso{
\code{\link{spower}}, \code{\link{ciapower}}, \code{\link{bpower}}
}
\examples{
#In this example, 4 plots are drawn on one page, one plot for each
#combination of noncompliance percentage.  Within a plot, the
#5-year mortality \% in the control group is on the x-axis, and
#separate curves are drawn for several \% reductions in mortality
#with the intervention.  The accrual period is 1.5y, with all
#patients followed at least 5y and some 6.5y.


par(mfrow=c(2,2),oma=c(3,0,3,0))


morts <- seq(10,25,length=50)
red <- c(10,15,20,25)


for(noncomp in c(0,10,15,-1)) {
  if(noncomp>=0) nc.i <- nc.c <- noncomp else {nc.i <- 25; nc.c <- 15}
  z <- paste("Drop-in ",nc.c,"\%, Non-adherence ",nc.i,"\%",sep="")
  plot(0,0,xlim=range(morts),ylim=c(0,1),
           xlab="5-year Mortality in Control Patients (\%)",
           ylab="Power",type="n")
  title(z)
  cat(z,"\n")
  lty <- 0
  for(r in red) {
        lty <- lty+1
        power <- morts
        i <- 0
        for(m in morts) {
          i <- i+1
          power[i] <- cpower(5, 14000, m/100, r, 1.5, 5, nc.c, nc.i, pr=FALSE)
        }
        lines(morts, power, lty=lty)
  }
  if(noncomp==0)legend(18,.55,rev(paste(red,"\% reduction",sep="")),
           lty=4:1,bty="n")
}
mtitle("Power vs Non-Adherence for Main Comparison",
           ll="alpha=.05, 2-tailed, Total N=14000",cex.l=.8)
#
# Point sample size requirement vs. mortality reduction
# Root finder (uniroot()) assumes needed sample size is between
# 1000 and 40000
#
nc.i <- 25; nc.c <- 15; mort <- .18
red <- seq(10,25,by=.25)
samsiz <- red


i <- 0
for(r in red) {
  i <- i+1
  samsiz[i] <- uniroot(function(x) cpower(5, x, mort, r, 1.5, 5,
                                          nc.c, nc.i, pr=FALSE) - .8,
                       c(1000,40000))$root
}


samsiz <- samsiz/1000
par(mfrow=c(1,1))
plot(red, samsiz, xlab='\% Reduction in 5-Year Mortality',
	 ylab='Total Sample Size (Thousands)', type='n')
lines(red, samsiz, lwd=2)
title('Sample Size for Power=0.80\nDrop-in 15\%, Non-adherence 25\%')
title(sub='alpha=0.05, 2-tailed', adj=0)
}
\keyword{htest}
\keyword{survival}
\concept{power}
\concept{study design}

\name{dotchart2}
\alias{dotchart2}
\title{
Enhanced Dot Chart
}
\description{
\code{dotchart2} is an enhanced version of the \code{dotchart} function 
with several new options.
}
\usage{
dotchart2(data, labels, groups=NULL, gdata=NA, horizontal=TRUE, pch=16,
          xlab='', ylab='', xlim=NULL, auxdata, auxgdata=NULL, auxtitle,
          lty=1, lines=TRUE, dotsize = .8,
          cex = par("cex"), cex.labels = cex,
          cex.group.labels = cex.labels*1.25, sort.=TRUE, 
	      add=FALSE, dotfont=par('font'), groupfont=2, 
	      reset.par=add, xaxis=TRUE, width.factor=1.1,
          lcolor='gray', leavepar=FALSE,
          axisat=NULL, axislabels=NULL, ...)
}
\arguments{
  \item{data}{a numeric vector whose values are shown on the x-axis}
  \item{labels}{a vector of labels for each point, corresponding to
	\code{x}.  If omitted, \code{names(data)} are used, and if there are
	no \code{names}, integers prefixed by \code{"#"} are used.}
  \item{groups}{an optional categorical variable indicating how
	\code{data} values are grouped}
  \item{gdata}{data values for groups, typically summaries such as group
	medians}
  \item{horizontal}{set to \code{FALSE} to make the chart vertical
	instead of the default}
  \item{pch}{
	default character number or value for plotting dots in dot charts.
	The default is 16.}
  \item{xlab}{x-axis title}
  \item{ylab}{y-axis title}
  \item{xlim}{x-axis limits.  Applies only to \code{horizontal=TRUE}.}
  \item{auxdata}{
	a vector of auxiliary data given to \code{dotchart2}, of the same length
	as the first (\code{data}) argument.  If present, this
	vector of values will be printed outside the right margin of the dot
	chart.  Usually \code{auxdata} represents cell sizes.
  }
  \item{auxgdata}{
	similar to \code{auxdata} but corresponding to the \code{gdata}
	argument.  These usually represent overall sample sizes for each
	group of lines.}
  \item{auxtitle}{
	if \code{auxdata} is given, \code{auxtitle} specifies a column
	heading for the extra printed data in the chart, e.g., \code{"N"}}
  \item{lty}{line type for horizontal lines.  Default is 1 for R, 2 for S-Plus}
  \item{lines}{set to \code{FALSE} to suppress drawing of reference
	lines}
  \item{dotsize}{
	\code{cex} value for drawing dots.  Default is 0.8.  Note that the original
	\code{dotchart} function used a default of 1.2.}
  \item{cex}{see \code{\link{par}}}
  \item{cex.labels}{
	\code{cex} parameter that applies only to the line labels for the
	dot chart \code{cex} parameter for major grouping labels for
	\code{dotchart2}.  Defaults to \code{cex}.}
  \item{cex.group.labels}{value of \code{cex} corresponding to \code{gdata}}
  \item{sort.}{
	set to \code{FALSE} to keep \code{dotchart2} from sorting the input
	data, i.e., it will assume that the data are already properly
	arranged.  This is especially useful when you are using \code{gdata}
	and \code{groups} and you want to control the
	order that groups appear on the chart (from top to bottom).}
  \item{add}{set to \code{TRUE} to add to an existing plot}
  \item{dotfont}{
	font number of plotting dots.  Default is one.  Use \code{-1} to
	use "outline" fonts.  For example, \code{pch=183, dotfont=-1}
	plots an open circle for UNIX on postscript.  \code{pch=1} makes
	an open octagon under Windows.}
  \item{groupfont}{
	font number to use in drawing \code{group} labels for \code{dotchart2}.
	Default is \code{2} for boldface.
  }
  \item{reset.par}{
	set to \code{FALSE} to cause \code{dotchart2} to not reset the \code{par}
	parameters when finished.  This is useful when \code{add=TRUE} is about to
	be used in another call.  The default is to reset the \code{par}
	parameters if \code{add=TRUE} and not if \code{add=FALSE}, i.e., the
	program assumes that only one set of points will be added to an
	existing set.  If you fail to use \code{reset.par=TRUE} for the 
	first of a series of plots, the next call to \code{plot} with
	\code{add=TRUE} will result in distorted x-axis scaling.}
  \item{xaxis}{set to \code{FALSE} to suppress drawing x-axis}
  \item{width.factor}{
	When the calculated left margin turns out to be faulty, specify a
	factor by which to multiple the left margin as \code{width.factor} to get
	the appropriate space for labels on horizonal charts.}
  \item{lcolor}{
	color for horizontal reference lines.  Default is \code{"gray"} for R,
	\code{par("col")} for S-Plus.}
  \item{leavepar}{set to \code{TRUE} to leave \code{par()} unchanged.
	This assumes the user has allocated sufficient left and right
	margins for a horizontal dot chart.}
  \item{axisat}{a vector of tick mark locations to pass to \code{axis}.
	Useful if transforming the data axis}
  \item{axislabels}{a vector of strings specifying axis tick mark
	labels.  Useful if transforming the data axis}
  \item{...}{arguments passed to \code{plot.default}}
}
\section{Side Effects}{
\code{dotchart} will leave \code{par} altered if \code{reset.par=FALSE}.
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\seealso{
\code{\link{dotchart}}
}
\examples{
set.seed(135)
maj <- factor(c(rep('North',13),rep('South',13)))
g <- paste('Category',rep(letters[1:13],2))
n <- sample(1:15000, 26, replace=TRUE)
y1 <- runif(26)
y2 <- pmax(0, y1 - runif(26, 0, .1))
dotchart2(y1, g, groups=maj, auxdata=n, auxtitle='n', xlab='Y')
dotchart2(y2, g, groups=maj, pch=17, add=TRUE)
## Compare with dotchart function (no superpositioning or auxdata allowed):
## dotchart(y1, g, groups=maj, xlab='Y')

## To plot using a transformed scale add for example
## axisat=sqrt(pretty(y)), axislabels=pretty(y)
}
\keyword{hplot}

\name{mhgr}
\alias{mhgr}
\alias{print.mhgr}
\alias{lrcum}
\alias{print.lrcum}
\title{Miscellaneous Functions for Epidemiology}
\description{
  The \code{mhgr} function computes the Cochran-Mantel-Haenszel stratified
  risk ratio and its confidence limits using the Greenland-Robins variance
  estimator.

The \code{lrcum} function takes the results of a series of 2x2 tables
representing the relationship between test positivity and diagnosis and
computes positive and negative likelihood ratios (with all their
deficiencies) and the variance of
their logarithms.  Cumulative likelihood ratios and their confidence
intervals (assuming independence of tests) are computed, assuming a
string of all positive tests or a string of all negative tests.  The
method of Simel et al as described in Altman et al is used.
}
\usage{
mhgr(y, group, strata, conf.int = 0.95)
\method{print}{mhgr}(x, \dots)

lrcum(a, b, c, d, conf.int = 0.95)
\method{print}{lrcum}(x, dec=3, \dots)
}
\arguments{
  \item{y}{a binary response variable}
  \item{group}{a variable with two unique values specifying comparison groups}
  \item{strata}{the stratification variable}
  \item{conf.int}{confidence level}
  \item{x}{an object created by \code{mhgr} or \code{lrcum}}
  \item{a}{frequency of true positive tests}
  \item{b}{frequency of false positive tests}
  \item{c}{frequency of false negative tests}
  \item{d}{frequency of true negative tests}
  \item{dec}{number of places to the right of the decimal to print for
    \code{lrcum}}
  \item{\dots}{addtitional arguments to be passed to other print functions}
}
\details{
  Uses equations 4 and 13 from Greenland and Robins.
}
\value{
  a list of class \code{"mhgr"} or of class \code{"lrcum"}.
}
\references{
  Greenland S, Robins JM (1985): Estimation of a common effect parameter
  from sparse follow-up data.  Biometrics 41:55-68.

  Altman DG, Machin D, Bryant TN, Gardner MJ, Eds. (2000): Statistics with
  Confidence, 2nd Ed.  Bristol: BMJ Books, 105-110.

  Simel DL, Samsa GP, Matchar DB (1991): Likelihood ratios with
  confidence: sample size estimation for diagnostic test studies.  J
  Clin Epi 44:763-770.
}
\author{Frank E Harrell Jr \email{fh@fharrell.com}}
\seealso{\code{\link{logrank}}}
\examples{
# Greate Migraine dataset used in Example 28.6 in the SAS PROC FREQ guide
d <- expand.grid(response=c('Better','Same'),
                 treatment=c('Active','Placebo'),
                 sex=c('female','male'))
d$count <- c(16, 11, 5, 20, 12, 16, 7, 19)
d
# Expand data frame to represent raw data
r <- rep(1:8, d$count)
d <- d[r,]
with(d, mhgr(response=='Better', treatment, sex))

# Discrete survival time example, to get Cox-Mantel relative risk and CL
# From Stokes ME, Davis CS, Koch GG, Categorical Data Analysis Using the
# SAS System, 2nd Edition, Sectino 17.3, p. 596-599
#
# Input data in Table 17.5
d <- expand.grid(treatment=c('A','P'), center=1:3)
d$healed2w    <- c(15,15,17,12, 7, 3)
d$healed4w    <- c(17,17,17,13,17,17)
d$notHealed4w <- c( 2, 7,10,15,16,18)
d
# Reformat to the way most people would collect raw data
d1 <- d[rep(1:6, d$healed2w),]
d1$time <- '2'
d1$y <- 1
d2 <- d[rep(1:6, d$healed4w),]
d2$time <- '4'
d2$y <- 1
d3 <- d[rep(1:6, d$notHealed4w),]
d3$time <- '4'
d3$y <- 0
d <- rbind(d1, d2, d3)
d$healed2w <- d$healed4w <- d$notHealed4w <- NULL
d
# Finally, duplicate appropriate observations to create 2 and 4-week
# risk sets.  Healed and not healed at 4w need to be in the 2-week
# risk set as not healed
d2w      <- subset(d, time=='4')
d2w$time <- '2'
d2w$y    <- 0
d24      <- rbind(d, d2w)
with(d24, table(y, treatment, time, center))
# Matches Table 17.6

with(d24, mhgr(y, treatment, interaction(center, time, sep=';')))

# Get cumulative likelihood ratios and their 0.95 confidence intervals
# based on the following two tables
#
#          Disease       Disease
#          +     -       +     -
# Test +   39    3       20    5
# Test -   21   17       22   15

lrcum(c(39,20), c(3,5), c(21,22), c(17,15))
}
\keyword{category}
\keyword{htest}
\concept{epidemiology}

\name{prselect}
\Rdversion{1.1}
\alias{prselect}
\title{Selectively Print Lines of a Text Vector}
\description{
  Given one or two regular expressions or exact text matches, removes
  elements of the input vector that match these specifications. Omitted
  lines are replaced by \ldots.  This is useful for selectively
  suppressing some of the printed output of R functions such as
  regression fitting functions, especially in the context of making
  statistical reports using Sweave or Odfweave.
}
\usage{
prselect(x, start = NULL, stop = NULL, i = 0, j = 0, pr = TRUE)
}
\arguments{
  \item{x}{
    input character vector
  }
  \item{start}{
    text or regular expression to look for starting line to omit.  If
    omitted, deletions start at the first line.
  }
  \item{stop}{
    text or regular expression to look for ending line to omit. If
    omitted, deletions proceed until the last line.
  }
  \item{i}{
    increment in number of first line to delete after match is found
  }
  \item{j}{
    increment in number of last line to delete after match is found
  }
  \item{pr}{
    set to \code{FALSE} to suppress printing
  }
}
\value{an invisible vector of retained lines of text}
\author{Frank Harrell}
\seealso{
  \code{\link[utils]{Sweave}}
}
\examples{
x <- c('the','cat','ran','past','the','dog')
prselect(x, 'big','bad')     # omit nothing- no match
prselect(x, 'the','past')    # omit first 4 lines
prselect(x,'the','junk')     # omit nothing- no match for stop
prselect(x,'ran','dog')      # omit last 4 lines
prselect(x,'cat')            # omit lines 2-
prselect(x,'cat',i=1)        # omit lines 3-
prselect(x,'cat','past')     # omit lines 2-4
prselect(x,'cat','past',j=1) # omit lines 2-5
prselect(x,'cat','past',j=-1)# omit lines 2-3
prselect(x,'t$','dog')       # omit lines 2-6; t must be at end

# Example for Sweave: run a regression analysis with the rms package
# then selectively output only a portion of what print.ols prints.
# (Thanks to \email{romain.francois@dbmail.com})
# <<z,eval=FALSE,echo=T>>=
# library(rms)
# y <- rnorm(20); x1 <- rnorm(20); x2 <- rnorm(20)
# ols(y ~ x1 + x2)
# <<echo=F>>=
# z <- capture.output( {
# <<z>>
#    } )
# prselect(z, 'Residuals:') # keep only summary stats; or:
# prselect(z, stop='Coefficients', j=-1)  # keep coefficients, rmse, R^2; or:
# prselect(z, 'Coefficients', 'Residual standard error', j=-1) # omit coef
# @
}
\keyword{manip}
\keyword{utilities}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ecdfSteps.r
\name{ecdfSteps}
\alias{ecdfSteps}
\title{ecdfSteps}
\usage{
ecdfSteps(x, extend)
}
\arguments{
\item{x}{numeric vector, possibly with \code{NA}s that are ignored}

\item{extend}{a 2-vector do extend the range of x (low, high).  Set \code{extend=FALSE} to not extend \code{x}, or leave it missing to extend it 1/20th of the observed range on other side.}
}
\value{
a list with components \code{x} and \code{y}
}
\description{
Compute Coordinates of an Empirical Distribution Function
}
\details{
For a numeric vector uses the R built-in \code{ecdf} function to compute
coordinates of the ECDF, with extension slightly below and above the
range of \code{x} by default.  This is useful for \code{ggplot2} where the ECDF may need to be transformed.  The returned object is suitable for creating stratified statistics using \code{data.table} and other methods.
}
\examples{
ecdfSteps(0:10)
\dontrun{
# Use data.table for obtaining ECDFs by country and region
w <- d[, ecdfSteps(z, extend=c(1,11)), by=.(country, region)]  # d is a DT
# Use ggplot2 to make one graph with multiple regions' ECDFs
# and use faceting for countries
ggplot(w, aes(x, y, color=region)) + geom_step() +
       facet_wrap(~ country)
}
}
\seealso{
\code{\link[stats:ecdf]{stats::ecdf()}}
}
\author{
Frank Harrell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/addggLayers.r
\name{addggLayers}
\alias{addggLayers}
\title{addggLayers}
\usage{
addggLayers(
  g,
  data,
  type = c("ebp", "spike"),
  ylim = layer_scales(g)$y$get_limits(),
  by = "variable",
  value = "value",
  frac = 0.065,
  mult = 1,
  facet = NULL,
  pos = c("bottom", "top"),
  showN = TRUE
)
}
\arguments{
\item{g}{a \code{ggplot} object}

\item{data}{data frame/table containing raw data}

\item{type}{specifies either extended box plot or spike histogram.  Both are horizontal so are showing the distribution of the x-axis variable.}

\item{ylim}{y-axis limits to use for scaling the height of the added plots, if you don't want to use the limits that \code{ggplot} has stored}

\item{by}{the name of a variable in \code{data} used to stratify raw data}

\item{value}{name of x-variable}

\item{frac}{fraction of y-axis range to devote to vertical aspect of the added plot}

\item{mult}{fudge factor for scaling y aspect}

\item{facet}{optional faceting variable}

\item{pos}{position for added plot}

\item{showN}{sete to \code{FALSE} to not show sample sizes}
}
\value{
the original \code{ggplot} object with more layers added
}
\description{
Add Spike Histograms and Extended Box Plots to \code{ggplot}
}
\details{
For an example see \href{https://hbiostat.org/rflow/analysis.html#fig-table1}{this}.  Note that it was not possible to just create the layers needed to be added, as creating these particular layers in isolation resulted in a \code{ggplot} error.
}
\seealso{
\code{spikecomp()}
}
\author{
Frank Harrell
}

\name{nobsY}
\alias{nobsY}
\title{Compute Number of Observations for Left Hand Side of Formula}
\usage{
nobsY(formula, group=NULL, data = NULL, subset = NULL,
      na.action = na.retain, matrixna=c('all', 'any'))
}
\arguments{
  \item{formula}{a formula object}
	\item{group}{character string containing optional name of a
		stratification variable for computing sample sizes}
  \item{data}{a data frame}
  \item{subset}{an optional subsetting criterion}
  \item{na.action}{an optional \code{NA}-handling function}
	\item{matrixna}{set to \code{"all"} if an observation is to be
		considered \code{NA} if all the columns of the variable are
		\code{NA}, otherwise use \code{matrixna="any"} to consider the row
		missing if any of the columns are missing}
}
\value{an integer, with an attribute \code{"formula"} containing the
	original formula but with an \code{id} variable (if present) removed}
\description{
After removing any artificial observations added by
\code{addMarginal}, computes the number of
non-missing observations for all left-hand-side variables in
\code{formula}.  If \code{formula} contains a term \code{id(variable)}
\code{variable} is assumed to be a subject ID variable, and only unique
subject IDs are counted.  If group is given and its value is the name of
a variable in the right-hand-side of the model, an additional object
\code{nobsg} is returned that is a matrix with as many columns as there
are left-hand variables, and as many rows as there are levels to the
\code{group} variable.  This matrix has the further breakdown of unique
non-missing observations by \code{group}.  The concatenation of all ID
variables, is returned in a \code{list} element \code{id}.
}
\examples{
d <- expand.grid(sex=c('female', 'male', NA),
                 country=c('US', 'Romania'),
                 reps=1:2)
d$subject.id <- c(0, 0, 3:12)
dm <- addMarginal(d, sex, country)
dim(dm)
nobsY(sex + country ~ 1, data=d)
nobsY(sex + country ~ id(subject.id), data=d)
nobsY(sex + country ~ id(subject.id) + reps, group='reps', data=d)
nobsY(sex ~ 1, data=d)
nobsY(sex ~ 1, data=dm)
nobsY(sex ~ id(subject.id), data=dm)
}
\keyword{utilities}
\keyword{manip}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/princmp.r
\name{princmp}
\alias{princmp}
\title{princmp}
\usage{
princmp(
  formula,
  data = environment(formula),
  method = c("regular", "sparse"),
  k = min(5, p - 1),
  kapprox = min(5, k),
  cor = TRUE,
  sw = FALSE,
  nvmax = 5
)
}
\arguments{
\item{formula}{a formula with no left hand side, or a numeric matrix}

\item{data}{a data frame or table.  By default variables come from the calling environment.}

\item{method}{specifies whether to use regular or sparse principal components are computed}

\item{k}{the number of components to plot, display, and return}

\item{kapprox}{the number of components to approximate with stepwise regression when \code{sw=TRUE}}

\item{cor}{set to \code{FALSE} to compute PCs on the original data scale, which is useful if all variables have the same units of measurement}

\item{sw}{set to \code{TRUE} to run stepwise regression PC prediction/approximation}

\item{nvmax}{maximum number of predictors to allow in stepwise regression PC approximations}
}
\value{
a list of class \code{princmp} with elements \code{scores}, a k-column matrix with principal component scores, with \code{NA}s when the input data had an \code{NA}, and other components useful for printing and plotting.  If \code{k=1} \code{scores} is a vector.  Other components include \code{vars} (vector of variances explained), \code{method}, \code{k}.
}
\description{
Enhanced Output for Principal and Sparse Principal Components
}
\details{
Expands any categorical predictors into indicator variables, and calls \code{princomp} (if \code{method='regular'} (the default)) or \code{sPCAgrid} in the \code{pcaPP} package (\code{method='sparse'}) to compute lasso-penalized sparse principal components.  By default all variables are first scaled by their standard deviation after observations with any \code{NA}s on any variables in \code{formula} are removed.  Loadings of standardized variables, and if \code{orig=TRUE} loadings on the original data scale are printed.  If \code{pl=TRUE} a scree plot is drawn with text added to indicate cumulative proportions of variance explained.  If \code{sw=TRUE}, the \code{leaps} package \code{regsubsets} function is used to approximate the PCs using forward stepwise regression with the original variables as individual predictors.

A \code{print} method prints the results and a \code{plot} method plots the scree plot of variance explained.
}
\author{
Frank Harrell
}

\name{summaryRc}
\alias{summaryRc}
\title{Graphical Summarization of Continuous Variables Against a Response}
\description{
	\code{summaryRc} is a continuous version of \code{\link{summary.formula}}
	with \code{method='response'}.  It uses the \code{\link{plsmo}}
	function to compute the possibly stratified \code{\link{lowess}}
	nonparametric regression estimates, and plots them along with the data
	density, with selected quantiles of the overall distribution (over
	strata) of each \code{x} shown as arrows on top of the graph.  All the
	\code{x} variables must be numeric and continuous or nearly continuous.
}
\usage{
summaryRc(formula, data=NULL, subset=NULL,
          na.action=NULL, fun = function(x) x,
          na.rm = TRUE, ylab=NULL, ylim=NULL, xlim=NULL,
          nloc=NULL, datadensity=NULL,
          quant = c(0.05, 0.1, 0.25, 0.5, 0.75,
                    0.90, 0.95), quantloc=c('top','bottom'),
          cex.quant=.6, srt.quant=0,
          bpplot = c('none', 'top', 'top outside', 'top inside', 'bottom'),
          height.bpplot=0.08,
          trim=NULL, test = FALSE, vnames = c('labels', 'names'), \dots)
}
\arguments{
  \item{formula}{
    An \R formula with additive effects.  The \code{formula} may contain
		one or more invocations of the \code{stratify} function whose
		arguments are defined below.  This causes 
    the entire analysis to be stratified by cross-classifications of the
    combined list of stratification factors.  This stratification will be
    reflected as separate \code{lowess} curves.}
  \item{data}{
    name or number of a data frame.  Default is the current frame.
  }
  \item{subset}{
    a logical vector or integer vector of subscripts used to specify the
    subset of data to use in the analysis.  The default is to use all
    observations in the data frame.
  }
  \item{na.action}{
    function for handling missing data in the input data.  The default is
    a function defined here called \code{na.retain}, which keeps all
    observations for processing, with missing variables or not.
  }
  \item{fun}{
    function for transforming \code{lowess} estimates.  Default is the
		identity function.}
  \item{na.rm}{
    \code{TRUE} (the default) to exclude \code{NA}s before passing data to
    \code{fun} to compute statistics, \code{FALSE} otherwise.
  }
	\item{ylab}{\code{y}-axis label.  Default is label attribute of
		\code{y} variable, or its name.}
	\item{ylim}{\code{y}-axis limits.  By default each graph is scaled on
		its own.}
	\item{xlim}{a list with elements named as the variable names appearing
		on the \code{x}-axis, with each element being a 2-vector specifying
		lower and upper limits.  Any variable not appearing in the list will
		have its limits computed and possibly \code{trim}med.}
	\item{nloc}{location for sample size.  Specify \code{nloc=FALSE} to
		suppress, or \code{nloc=list(x=,y=)} where \code{x,y} are relative
		coordinates in the data window.  Default position is in the largest
		empty space.}
	\item{datadensity}{see \code{\link{plsmo}}.  Defaults to \code{TRUE}
		if there is a \code{stratify} variable, \code{FALSE} otherwise.}
  \item{quant}{
    vector of quantiles to use for summarizing the marginal distribution
		of each \code{x}. This must be numbers between 0 and 1
    inclusive.  Use \code{NULL} to omit quantiles.
  }
	\item{quantloc}{specify \code{quantloc='bottom'} to place at the
		bottom of each plot rather than the default}
	\item{cex.quant}{character size for writing which quantiles are
		represented.  Set to \code{0} to suppress quantile labels.}
	\item{srt.quant}{angle for text for quantile labels}
	\item{bpplot}{if not \code{'none'} will draw extended box plot at
		location given by \code{bpplot}, and quantiles discussed above will
		be suppressed.  Specifying \code{bpplot='top'} is the same as
		specifying \code{bpplot='top inside'}.}
	\item{height.bpplot}{height in inches of the horizontal extended box plot}
	\item{trim}{The default is to plot from the 10th smallest to the 10th
		largest \code{x} if the number of non-NAs exceeds 200, otherwise to
		use the entire range of \code{x}.  Specify another quantile to use
		other limits, e.g.,  \code{trim=0.01} will use the first and last
		percentiles}
  \item{test}{
    Set to \code{TRUE} to plot test statistics (not yet implemented).
  }
  \item{vnames}{
    By default, plots are usually labeled with variable labels
    (see the \code{label} and \code{sas.get} functions).  To use the shorter
    variable names, specify \code{vnames="names"}.
  }
  \item{...}{arguments passed to \code{\link{plsmo}}}
}
\value{no value is returned}
\author{
  Frank Harrell\cr
  Department of Biostatistics\cr
  Vanderbilt University\cr
  \email{fh@fharrell.com}
}
\seealso{
  \code{\link{plsmo}}, \code{\link{stratify}},
  \code{\link{label}}, \code{\link{formula}}, \code{\link{panel.bpplot}} 
}
\examples{
options(digits=3)
set.seed(177)
sex <- factor(sample(c("m","f"), 500, rep=TRUE))
age <- rnorm(500, 50, 5)
bp  <- rnorm(500, 120, 7)
units(age) <- 'Years'; units(bp) <- 'mmHg'
label(bp) <- 'Systolic Blood Pressure'
L <- .5*(sex == 'm') + 0.1 * (age - 50)
y <- rbinom(500, 1, plogis(L))
par(mfrow=c(1,2))
summaryRc(y ~ age + bp)
# For x limits use 1st and 99th percentiles to frame extended box plots
summaryRc(y ~ age + bp, bpplot='top', datadensity=FALSE, trim=.01)
summaryRc(y ~ age + bp + stratify(sex),
          label.curves=list(keys='lines'), nloc=list(x=.1, y=.05))
y2 <- rbinom(500, 1, plogis(L + .5))
Y <- cbind(y, y2)
summaryRc(Y ~ age + bp + stratify(sex),
          label.curves=list(keys='lines'), nloc=list(x=.1, y=.05))
}
\keyword{hplot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nCoincident.r
\name{nCoincident}
\alias{nCoincident}
\title{nCoincident}
\usage{
nCoincident(x, y, bins = 400)
}
\arguments{
\item{x}{numeric vector}

\item{y}{numeric vector}

\item{bins}{number of bins in both directions}
}
\value{
integer count
}
\description{
Number of Coincident Points
}
\details{
Computes the number of x,y pairs that are likely to be obscured in a regular scatterplot, in the sense of overlapping pairs after binning into \code{bins} x \code{bins} squares where \code{bins} defaults to 400.  \code{NA}s are removed first.
}
\examples{
nCoincident(c(1:5, 4:5), c(1:5, 4:5)/10)
}
\author{
Frank Harrell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pMedian.r
\name{pMedian}
\alias{pMedian}
\title{pMedian}
\usage{
pMedian(
  x,
  na.rm = FALSE,
  conf.int = 0,
  B = 1000,
  type = c("percentile", "bca")
)
}
\arguments{
\item{x}{a numeric vector}

\item{na.rm}{set to \code{TRUE} to exclude \code{NA}s before computing the pseudomedian}

\item{conf.int}{confidence level, defaulting to 0 so that no confidence limits are computed.  Set to a number between 0 and 1 to compute bootstrap confidence limits}

\item{B}{number of bootstrap samples if \code{conf.int > 0}}

\item{type}{type of bootstrap interval, defaulting to \code{'percentile'} for n >= 150 or \code{'bca'} for n < 150}
}
\value{
a scalar numeric value if \code{conf.int = 0}, or a 3-vector otherwise, with named elements \verb{estimate, lower, upper} and attribute \code{type}.  If the number of non-missing values is less than 5, \code{NA} is returned for both lower and upper limits.
}
\description{
Pseudomedian
}
\details{
Uses fast Fortran code to compute the pseudomedian of a numeric vector.  The pseudomedian is the median of all possible midpoints of two observations.  The pseudomedian is also called the Hodges-Lehmann one-sample estimator.  The Fortran code is was originally from JF Monahan, and was converted to C++ in the \code{DescTools} package.  It has been converted to Fortran 2018 here.  Bootstrap confidence intervals are optionally computed.

If n > 250,000 a random sample of 250,000 values of \code{x} is used to limit execution time.  For n > 1,000 only the percentile bootstrap confidence interval is computed.

Bootstrapping uses the Fortran subroutine directly, for efficiency.
}
\examples{
x <- c(1:4, 10000)
pMedian(x)
pMedian(x, conf.int=0.95)
# Compare with brute force calculation and with wilcox.test
w <- outer(x, x, '+')
median(w[lower.tri(w, diag=TRUE)]) / 2
wilcox.test(x, conf.int=TRUE)
}
\seealso{
\url{https://dl.acm.org/toc/toms/1984/10/3/}, \url{https://www4.stat.ncsu.edu/~monahan/jul10/}, \url{https://www.fharrell.com/post/aci/}
}

\name{show.pch}
\alias{show.pch}
\alias{show.col}
\alias{character.table}
\title{Display Colors, Plotting Symbols, and Symbol Numeric Equivalents}
\description{
\code{show.pch} plots the definitions of the \code{pch} parameters.
\code{show.col} plots definitions of integer-valued colors.
\code{character.table} draws numeric equivalents of all latin
characters; the character on line \code{xy} and column \code{z} of the
table has numeric code \code{"xyz"}, which you would surround in quotes
and preceed by a backslash.
}
\usage{
show.pch(object = par("font"))
show.col(object=NULL)
character.table(font=1)
}
\arguments{
  \item{object}{font for \code{show.pch}, ignored for \code{show.col}.}
  \item{font}{font}
}
\author{Pierre Joyet \email{pierre.joyet@bluewin.ch}, Frank Harrell}
\seealso{\code{\link{points}}, \code{\link{text}}}
\examples{
\dontrun{
show.pch()
show.col()
character.table()
}}
\keyword{aplot}

\name{minor.tick}
\alias{minor.tick}
\title{Minor Tick Marks}
\description{
Adds minor tick marks to an existing plot.  All minor tick marks that
will fit on the axes will be drawn.
}
\usage{
minor.tick(nx=2, ny=2, tick.ratio=0.5, x.args = list(), y.args = list())
}
\arguments{
\item{nx}{
number of intervals in which to divide the area between major tick marks on
the X-axis.  Set to 1 to suppress minor tick marks.
}
\item{ny}{
same as \code{nx} but for the Y-axis.
}
\item{tick.ratio}{
ratio of lengths of minor tick marks to major tick marks.  The length
of major tick marks is retrieved from \code{par("tck")}.}
\item{x.args}{
additionl arguments (e.g. \code{post}, \code{lwd}) used by \code{axis()} function when rendering the X-axis.}
\item{y.args}{
same as \code{x.args} but for Y-axis.}
}
\section{Side Effects}{
plots
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
\cr
Earl Bellinger
\cr
Max Planck Institute
\cr
\email{earlbellinger@gmail.com}
\cr
Viktor Horvath
\cr
Brandeis University
\cr
\email{vhorvath@brandeis.edu}
}
\seealso{
\code{\link{axis}}
}
\examples{
# Plot with default settings
plot(runif(20), runif(20))
minor.tick()

# Plot with arguments passed to axis()
plot(c(0,1), c(0,1), type = 'n', axes = FALSE, ann = FALSE)
# setting up a plot without axes and annotation
points(runif(20), runif(20))                       # plotting data
axis(1, pos = 0.5, lwd = 2)                        # showing X-axis at Y = 0.5 with formatting
axis(2, col = 2)                                   # formatted Y-axis
minor.tick( nx = 4, ny = 4, tick.ratio = 0.3,
            x.args = list(pos = 0.5, lwd = 2),     # X-minor tick format argumnets
            y.args = list(col = 2))                # Y-minor tick format arguments
}
\keyword{aplot}
\keyword{hplot}

\name{.in.}
\alias{\%nin\%}
\title{
Find Matching (or Non-Matching) Elements
}
\description{
  For two vectors or scalars \code{a} and \code{b},
  \code{\%nin\%} returns
  \code{TRUE} if the element in \code{a} is not in \code{b}.
}
\usage{
a \%nin\% b
}
\arguments{
\item{a}{
a vector (numeric, character, factor)
}
\item{b}{
a vector (numeric, character, factor), matching the mode of a
}}
\value{
vector of logical values with length equal to length of \code{a}.
}
\seealso{
\code{\link{match}}
}
\examples{
c('a','b','c') %nin% c('a','b')
}
\keyword{manip}
\keyword{character}

\name{cnvrt.coords}
\alias{cnvrt.coords}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Convert between the 5 different coordinate sytems on a graphical device}
\description{
  Takes a set of coordinates in any of the 5 coordinate systems (usr,
  plt, fig, dev, or tdev) and returns the same points in all 5
  coordinate systems.
}
\usage{
cnvrt.coords(x, y = NULL, input = c("usr", "plt", "fig", "dev","tdev"))
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{Vector, Matrix, or list of x coordinates (or x and y
    coordinates), NA's allowed. }
  \item{y}{y coordinates (if \code{x} is a vector), NA's allowed. }
  \item{input}{Character scalar indicating the coordinate system of the
    input points. }
}
\details{
  Every plot has 5 coordinate systems:

  usr (User): the coordinate system of the data, this is shown by the
  tick marks and axis labels.

  plt (Plot): Plot area, coordinates range from 0 to 1 with 0
  corresponding to the x and y axes and 1 corresponding to the top and
  right of the plot area.  Margins of the plot correspond to plot
  coordinates less than 0 or greater than 1.

  fig (Figure): Figure area, coordinates range from 0 to 1 with 0
  corresponding to the bottom and left edges of the figure (including
  margins, label areas) and 1 corresponds to the top and right edges.
  fig and dev coordinates will be identical if there is only 1 figure
  area on the device (layout, mfrow, or mfcol has not been used).

  dev (Device): Device area, coordinates range from 0 to 1 with 0
  corresponding to the bottom and left of the device region within the
  outer margins and 1 is the top and right of the region withing the
  outer margins.  If the outer margins are all set to 0 then tdev and
  dev should be identical.

  tdev (Total Device): Total Device area, coordinates range from 0 to 1 with 0
  corresponding to the bottom and left edges of the device (piece of
  paper, window on screen) and 1 corresponds to the top and right edges.
}
\value{
  A list with 5 components, each component is a list with vectors named
  x and y.  The 5 sublists are:
  \item{usr}{The coordinates of the input points in usr (User) coordinates.}
  \item{plt}{The coordinates of the input points in plt (Plot)
    coordinates.}
  \item{fig}{The coordinates of the input points in fig (Figure)
    coordinates.}
  \item{dev}{The coordinates of the input points in dev (Device)
    coordinates.}
  \item{tdev}{The coordinates of the input points in tdev (Total Device)
    coordinates.
  }
}
%\references{ ~put references to the literature/web site here ~ }
\author{Greg Snow \email{greg.snow@imail.org}}
\note{ You must provide both x and y, but one of them may be \code{NA}.

This function is becoming depricated with the new functions
\code{grconvertX} and \code{grconvertY} in R version 2.7.0 and beyond.
These new functions use the correct coordinate system names and have
more coordinate systems available, you should start using them instead.
}

% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{ \code{\link{par}} specifically 'usr','plt', and 'fig'.  Also
  'xpd' for plotting outside of the plotting region and 'mfrow' and
  'mfcol' for multi figure plotting. \code{\link{subplot}},
  \code{grconvertX} and \code{grconvertY} in R2.7.0 and later}
\examples{

old.par <- par(no.readonly=TRUE)

par(mfrow=c(2,2),xpd=NA)

# generate some sample data
tmp.x <- rnorm(25, 10, 2)
tmp.y <- rnorm(25, 50, 10)
tmp.z <- rnorm(25, 0, 1)

plot( tmp.x, tmp.y)

# draw a diagonal line across the plot area
tmp1 <- cnvrt.coords( c(0,1), c(0,1), input='plt' )
lines(tmp1$usr, col='blue')

# draw a diagonal line accross figure region
tmp2 <- cnvrt.coords( c(0,1), c(1,0), input='fig')
lines(tmp2$usr, col='red')

# save coordinate of point 1 and y value near top of plot for future plots
tmp.point1 <- cnvrt.coords(tmp.x[1], tmp.y[1])
tmp.range1 <- cnvrt.coords(NA, 0.98, input='plt')

# make a second plot and draw a line linking point 1 in each plot
plot(tmp.y, tmp.z)

tmp.point2 <- cnvrt.coords( tmp.point1$dev, input='dev' )
arrows( tmp.y[1], tmp.z[1], tmp.point2$usr$x, tmp.point2$usr$y,
 col='green')

# draw another plot and add rectangle showing same range in 2 plots

plot(tmp.x, tmp.z)
tmp.range2 <- cnvrt.coords(NA, 0.02, input='plt')
tmp.range3 <- cnvrt.coords(NA, tmp.range1$dev$y, input='dev')
rect( 9, tmp.range2$usr$y, 11, tmp.range3$usr$y, border='yellow')

# put a label just to the right of the plot and
#  near the top of the figure region.
text( cnvrt.coords(1.05, NA, input='plt')$usr$x,
	cnvrt.coords(NA, 0.75, input='fig')$usr$y,
	"Label", adj=0)

par(mfrow=c(1,1))

## create a subplot within another plot (see also subplot)

plot(1:10, 1:10)

tmp <- cnvrt.coords( c( 1, 4, 6, 9), c(6, 9, 1, 4) )

par(plt = c(tmp$dev$x[1:2], tmp$dev$y[1:2]), new=TRUE)
hist(rnorm(100))

par(fig = c(tmp$dev$x[3:4], tmp$dev$y[3:4]), new=TRUE)
hist(rnorm(100))

par(old.par)

}

\keyword{ dplot }% at least one, from doc/KEYWORDS
\keyword{ aplot }% __ONLY ONE__ keyword per line

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/princmp.r
\name{print.princmp}
\alias{print.princmp}
\title{print.princmp}
\usage{
\method{print}{princmp}(x, which = c("none", "standardized", "original", "both"), k = x$k, ...)
}
\arguments{
\item{x}{results of \code{princmp}}

\item{which}{specifies which loadings to print, the default being \code{'none'} and other values being \code{'standardized'}, \code{'original'}, or \code{'both'}}

\item{k}{number of components to show, defaults to \code{k} specified to \code{princmp}}

\item{...}{unused}
}
\value{
nothing
}
\description{
Print Results of princmp
}
\details{
Simple print method for \code{\link[=princmp]{princmp()}}
}
\author{
Frank Harrell
}

\name{summaryS}
\alias{summaryS}
\alias{plot.summaryS}
\alias{plotp.summaryS}
\alias{mbarclPanel}
\alias{medvPanel}
\alias{mbarclpl}
\alias{medvpl}
\title{Summarize Multiple Response Variables and Make Multipanel Scatter
	or Dot Plot}
\description{
Multiple left-hand formula variables along with right-hand side
conditioning variables are reshaped into a "tall and thin" data frame if
\code{fun} is not specified.  The resulting raw data can be plotted with
the \code{plot} method using user-specified \code{panel} functions for
\code{lattice} graphics, typically to make a scatterplot or \code{loess}
smooths, or both.  The \code{Hmisc} \code{panel.plsmo} function is handy
in this context.  Instead, if \code{fun} is specified, this function
takes individual response variables (which may be matrices, as in
\code{\link[survival]{Surv}} objects) and creates one or more summary
statistics that will be computed while the resulting data frame is being
collapsed to one row per condition.  The \code{plot} method in this case
plots a multi-panel dot chart using the \code{lattice}
\code{\link[lattice]{dotplot}} function if \code{panel} is not specified
to \code{plot}.  There is an option to print
selected statistics as text on the panels.  \code{summaryS} pays special
attention to \code{Hmisc} variable annotations: \code{label, units}.
When \code{panel} is specified in addition to \code{fun}, a special
\code{x-y} plot is made that assumes that the \code{x}-axis variable
(typically time) is discrete.  This is used for example to plot multiple
quantile intervals as vertical lines next to the main point.  A special
panel function \code{mvarclPanel} is provided for this purpose.

The \code{plotp} method produces corresponding \code{plotly} graphics.

When \code{fun} is given and \code{panel} is omitted, and the result of
\code{fun} is a vector of more than one 
statistic, the first statistic is taken as the main one.  Any columns
with names not in \code{textonly} will figure into the calculation of
axis limits.  Those in \code{textonly} will be printed right under the
dot lines in the dot chart.  Statistics with names in \code{textplot}
will figure into limits, be plotted, and printed.  \code{pch.stats} can
be used to specify symbols for statistics after the first column.  When
\code{fun} computed three columns that are plotted, columns two and
three are taken as confidence limits for which horizontal "error bars"
are drawn.  Two levels with different thicknesses are drawn if there are
four plotted summary statistics beyond the first.

\code{mbarclPanel} is used to draw multiple vertical lines around the
main points, such as a series of quantile intervals stratified by
\code{x} and paneling variables.  If \code{mbarclPanel} finds a column
of an arument \code{yother} that is named \code{"se"}, and if there are
exactly two levels to a superpositioning variable, the half-height of
the approximate 0.95 confidence interval for the difference between two
point estimates is shown, positioned at the midpoint of the two point
estimates at an \code{x} value.  This assume normality of point
estimates, and the standard error of the difference is the square root
of the sum of squares of the two standard errors.  By positioning the
intervals in this fashion, a failure of the two point estimates to touch
the half-confidence interval is consistent with rejecting the null
hypothesis of no difference at the 0.05 level.

\code{mbarclpl} is the \code{sfun} function corresponding to
\code{mbarclPanel} for \code{plotp}, and \code{medvpl} is the
\code{sfun} replacement for \code{medvPanel}.

\code{medvPanel} takes raw data and plots median \code{y} vs. \code{x},
along with confidence intervals and half-interval for the difference in
medians as with \code{mbarclPanel}.  Quantile intervals are optional.
Very transparent vertical violin plots are added by default.  Unlike
\code{panel.violin}, only half of the violin is plotted, and when there
are two superpose groups they are side-by-side in different colors.

For \code{plotp}, the function corresponding to \code{medvPanel} is
\code{medvpl}, which draws back-to-back spike histograms, optional Gini
mean difference, optional SD, quantiles (thin line version of box
plot with 0.05 0.25 0.5 0.75 0.95 quantiles), and half-width confidence
interval for differences in medians.  For quantiles, the Harrell-Davis
estimator is used.
}
\usage{
summaryS(formula, fun = NULL, data = NULL, subset = NULL,
         na.action = na.retain, continuous=10, \dots)

\method{plot}{summaryS}(x, formula=NULL, groups=NULL, panel=NULL,
           paneldoesgroups=FALSE, datadensity=NULL, ylab='',
           funlabel=NULL, textonly='n', textplot=NULL,
           digits=3, custom=NULL,
           xlim=NULL, ylim=NULL, cex.strip=1, cex.values=0.5, pch.stats=NULL,
           key=list(columns=length(groupslevels),
             x=.75, y=-.04, cex=.9,
             col=trellis.par.get('superpose.symbol')$col, corner=c(0,1)),
           outerlabels=TRUE, autoarrange=TRUE, scat1d.opts=NULL, \dots)

\method{plotp}{summaryS}(data, formula=NULL, groups=NULL, sfun=NULL,
           fitter=NULL, showpts=! length(fitter), funlabel=NULL,
           digits=5, xlim=NULL, ylim=NULL,
           shareX=TRUE, shareY=FALSE, autoarrange=TRUE, \dots)

mbarclPanel(x, y, subscripts, groups=NULL, yother, \dots)

medvPanel(x, y, subscripts, groups=NULL, violin=TRUE, quantiles=FALSE, \dots)

mbarclpl(x, y, groups=NULL, yother, yvar=NULL, maintracename='y',
         xlim=NULL, ylim=NULL, xname='x', alphaSegments=0.45, \dots)

medvpl(x, y, groups=NULL, yvar=NULL, maintracename='y',
       xlim=NULL, ylim=NULL, xlab=xname, ylab=NULL, xname='x',
       zeroline=FALSE, yother=NULL, alphaSegments=0.45,
       dhistboxp.opts=NULL, \dots)
}
\arguments{
  \item{formula}{a formula with possibly multiple left and right-side
		variables separated by \code{+}.  Analysis (response) variables are
		on the left and are typically numeric.  For \code{plot},
           \code{formula} is optional and overrides the default formula
           inferred for the reshaped data frame.}
  \item{fun}{an optional summarization function, e.g., \code{\link{smean.sd}}}
  \item{data}{optional input data frame.  For \code{plotp} is the object
       produced by \code{summaryS}.}
  \item{subset}{optional subsetting criteria}
  \item{na.action}{function for dealing with \code{NA}s when
		constructing the model data frame}
	\item{continuous}{minimum number of unique values for a numeric
           variable to have to be considered continuous}
  \item{\dots}{ignored for \code{summaryS} and \code{mbarclPanel},
		passed to \code{strip} and \code{panel} for \code{plot}.  Passed to
		the \code{\link{density}} function by \code{medvPanel}.  For
       \code{plotp}, are passed to \code{plotlyM} and \code{sfun}.  For
       \code{mbarclpl}, passed to \code{plotlyM}.}
	\item{x}{an object created by \code{summaryS}.  For \code{mbarclPanel}
		is an \code{x}-axis argument provided by \code{lattice}}
	\item{groups}{a character string or factor specifying that one of the
           conditioning variables is used for superpositioning and not
           paneling}
  \item{panel}{optional \code{lattice} \code{panel} function}
  \item{paneldoesgroups}{set to \code{TRUE} if, like
           \code{\link{panel.plsmo}}, the paneling function internally
           handles superpositioning for \code{groups}}
  \item{datadensity}{set to \code{TRUE} to add rug plots etc. using
    \code{\link{scat1d}}}
	\item{ylab}{optional \code{y}-axis label}
	\item{funlabel}{optional axis label for when \code{fun} is given}
	\item{textonly}{names of statistics to print and not plot.  By
           default, any statistic named \code{"n"} is only printed.}
	\item{textplot}{names of statistics to print and plot}
	\item{digits}{used if any statistics are printed as text (including
       \code{plotly} hovertext), to specify
           the number of significant digits to render}
	\item{custom}{a function that customizes formatting of statistics that
           are printed as text.  This is useful for generating plotmath
           notation.  See the example in the tests directory.}
	\item{xlim}{optional \code{x}-axis limits}
	\item{ylim}{optional \code{y}-axis limits}			 
	\item{cex.strip}{size of strip labels}
	\item{cex.values}{size of statistics printed as text}
	\item{pch.stats}{symbols to use for statistics (not included the one
           one in columne one) that are plotted.  This is a named
           vectors, with names exactly matching those created by
           \code{fun}.  When a column does not have an entry in
           \code{pch.stats}, no point is drawn for that column.}
	\item{key}{\code{lattice} \code{key} specification}
	\item{outerlabels}{set to \code{FALSE} to not pass two-way charts
    through \code{\link[latticeExtra]{useOuterStrips}}}
	\item{autoarrange}{set to \code{FALSE} to prevent \code{plot} from
    trying to optimize which conditioning variable is vertical}
	\item{scat1d.opts}{a list of options to specify to \code{\link{scat1d}}}
	\item{y, subscripts}{provided by \code{lattice}}
	\item{yother}{passed to the panel function from the \code{plot} method
		based on multiple statistics computed}
	\item{violin}{controls whether violin plots are included}
	\item{quantiles}{controls whether quantile intervals are included}
	\item{sfun}{a function called by \code{plotp.summaryS} to compute and
       plot user-specified summary measures.  Two functions for doing
       this are provided here: \code{mbarclpl, medvpl}.}
  \item{fitter}{a fitting function such as \code{loess} to smooth
       points.  The smoothed values over a systematic grid will be
       evaluated and plotted as curves.}
  \item{showpts}{set to \code{TRUE} to show raw data points in additon
    to smoothed curves}
	\item{shareX}{\code{TRUE} to cause \code{plotly} to share a single
    x-axis when graphs are aligned vertically}
	\item{shareY}{\code{TRUE} to cause \code{plotly} to share a single
    y-axis when graphs are aligned horizontally}
	\item{yvar}{a character or factor variable used to stratify the
    analysis into multiple y-variables}
	\item{maintracename}{a default trace name when it can't be inferred}
	\item{xname}{x-axis variable name for hover text when it can't be
    inferred}
	\item{xlab}{x-axis label when it can't be inferred}
	\item{alphaSegments}{alpha saturation to draw line segments for
    \code{plotly}}
	\item{dhistboxp.opts}{\code{list} of options to pass to \code{dhistboxp}}
	\item{zeroline}{set to \code{FALSE} to suppress \code{plotly} zero
    line at x=0}
}
\value{a data frame with added attributes for \code{summaryS} or a
           \code{lattice} object ready to render for \code{plot}}
\author{Frank Harrell}
\seealso{\code{\link{summary}}, \code{\link{summarize}}}
\examples{
# See tests directory file summaryS.r for more examples, and summarySp.r
# for plotp examples
n <- 100
set.seed(1)
d <- data.frame(sbp=rnorm(n, 120, 10),
                dbp=rnorm(n, 80, 10),
                age=rnorm(n, 50, 10),
                days=sample(1:n, n, TRUE),
                S1=Surv(2*runif(n)), S2=Surv(runif(n)),
                race=sample(c('Asian', 'Black/AA', 'White'), n, TRUE),
                sex=sample(c('Female', 'Male'), n, TRUE),
                treat=sample(c('A', 'B'), n, TRUE),
                region=sample(c('North America','Europe'), n, TRUE),
                meda=sample(0:1, n, TRUE), medb=sample(0:1, n, TRUE))

d <- upData(d, labels=c(sbp='Systolic BP', dbp='Diastolic BP',
            race='Race', sex='Sex', treat='Treatment',
            days='Time Since Randomization',
            S1='Hospitalization', S2='Re-Operation',
            meda='Medication A', medb='Medication B'),
            units=c(sbp='mmHg', dbp='mmHg', age='Year', days='Days'))

s <- summaryS(age + sbp + dbp ~ days + region + treat,  data=d)
# plot(s)   # 3 pages
plot(s, groups='treat', datadensity=TRUE,
     scat1d.opts=list(lwd=.5, nhistSpike=0))
plot(s, groups='treat', panel=panel.loess, key=list(space='bottom', columns=2),
     datadensity=TRUE, scat1d.opts=list(lwd=.5))

# To make a plotly graph when the stratification variable region is not
# present, run the following (showpts adds raw data points):
# plotp(s, groups='treat', fitter=loess, showpts=TRUE)

# Make your own plot using data frame created by summaryP
# xyplot(y ~ days | yvar * region, groups=treat, data=s,
#        scales=list(y='free', rot=0))

# Use loess to estimate the probability of two different types of events as
# a function of time
s <- summaryS(meda + medb ~ days + treat + region, data=d)
pan <- function(...)
   panel.plsmo(..., type='l', label.curves=max(which.packet()) == 1,
               datadensity=TRUE)
plot(s, groups='treat', panel=pan, paneldoesgroups=TRUE,
     scat1d.opts=list(lwd=.7), cex.strip=.8)

# Repeat using intervals instead of nonparametric smoother
pan <- function(...)  # really need mobs > 96 to est. proportion
  panel.plsmo(..., type='l', label.curves=max(which.packet()) == 1,
              method='intervals', mobs=5)

plot(s, groups='treat', panel=pan, paneldoesgroups=TRUE, xlim=c(0, 150))


# Demonstrate dot charts of summary statistics
s <- summaryS(age + sbp + dbp ~ region + treat, data=d, fun=mean)
plot(s)
plot(s, groups='treat', funlabel=expression(bar(X)))
# Compute parametric confidence limits for mean, and include sample
# sizes by naming a column "n"

f <- function(x) {
  x <- x[! is.na(x)]
  c(smean.cl.normal(x, na.rm=FALSE), n=length(x))
}
s <- summaryS(age + sbp + dbp ~ region + treat, data=d, fun=f)
plot(s, funlabel=expression(bar(X) \%+-\% t[0.975] \%*\% s))
plot(s, groups='treat', cex.values=.65,
     key=list(space='bottom', columns=2,
       text=c('Treatment A:','Treatment B:')))

# For discrete time, plot Harrell-Davis quantiles of y variables across
# time using different line characteristics to distinguish quantiles
d <- upData(d, days=round(days / 30) * 30)
g <- function(y) {
  probs <- c(0.05, 0.125, 0.25, 0.375)
  probs <- sort(c(probs, 1 - probs))
  y <- y[! is.na(y)]
  w <- hdquantile(y, probs)
  m <- hdquantile(y, 0.5, se=TRUE)
  se <- as.numeric(attr(m, 'se'))
  c(Median=as.numeric(m), w, se=se, n=length(y))
}
s <- summaryS(sbp + dbp ~ days + region, fun=g, data=d)
plot(s, panel=mbarclPanel)
plot(s, groups='region', panel=mbarclPanel, paneldoesgroups=TRUE)

# For discrete time, plot median y vs x along with CL for difference,
# using Harrell-Davis median estimator and its s.e., and use violin
# plots

s <- summaryS(sbp + dbp ~ days + region, data=d)
plot(s, groups='region', panel=medvPanel, paneldoesgroups=TRUE)

# Proportions and Wilson confidence limits, plus approx. Gaussian
# based half/width confidence limits for difference in probabilities
g <- function(y) {
  y <- y[!is.na(y)]
  n <- length(y)
  p <- mean(y)
  se <- sqrt(p * (1. - p) / n)
  structure(c(binconf(sum(y), n), se=se, n=n),
            names=c('Proportion', 'Lower', 'Upper', 'se', 'n'))
}
s <- summaryS(meda + medb ~ days + region, fun=g, data=d)
plot(s, groups='region', panel=mbarclPanel, paneldoesgroups=TRUE)
}
\keyword{category}
\keyword{hplot}
\keyword{manip}
\keyword{grouping}
\concept{stratification}
\concept{aggregation}

\name{symbol.freq}
\alias{symbol.freq}
\title{Graphic Representation of a Frequency Table}
\description{
This function can be used to represent
contingency tables graphically.  Frequency counts are represented as
the heights of "thermometers" by default; you can also specify
\code{symbol='circle'} to the function.  There is an option to include
marginal frequencies, which are plotted on a halved scale so as to not
overwhelm the plot.   If you do not ask for marginal frequencies to be
plotted using \code{marginals=T}, \code{symbol.freq} will ask you to click
the mouse where a reference symbol is to be drawn to assist in reading
the scale of the frequencies.

\code{label} attributes, if present, are used for x- and y-axis labels.
Otherwise, names of calling arguments are used.
}
\usage{
symbol.freq(x, y, symbol = c("thermometer", "circle"),
            marginals = FALSE, orig.scale = FALSE,
            inches = 0.25, width = 0.15, subset, srtx = 0, ...)
}
\arguments{
  \item{x}{first variable to cross-classify}
  \item{y}{second variable}
  \item{symbol}{specify \code{"thermometer"} (the default) or \code{"circle"}}
  \item{marginals}{set to \code{TRUE} to add marginal frequencies
	(scaled by half) to the plot}
  \item{orig.scale}{set to \code{TRUE} when the first two arguments are
	numeric variables; this uses their original values for x and y
	coordinates)} 
  \item{inches}{see \code{\link{symbols}}}
  \item{width}{see \code{thermometers} option in \code{symbols}}
  \item{subset}{the usual subsetting vector}
  \item{srtx}{rotation angle for x-axis labels}
  \item{\dots}{other arguments to pass to \code{symbols}}
}
\author{Frank Harrell}
\seealso{\code{\link{symbols}}}
\examples{
\dontrun{
getHdata(titanic)
attach(titanic)
age.tertile <- cut2(titanic$age, g=3)
symbol.freq(age.tertile, pclass, marginals=T, srtx=45)
detach(2)
}}
\keyword{hplot}

\name{contents}
\alias{contents}
\alias{contents.data.frame}
\alias{print.contents.data.frame}
\alias{html.contents.data.frame}
\alias{contents.list}
\alias{print.contents.list}
\title{Metadata for a Data Frame}
\description{
  \code{contents} is a generic method for which \code{contents.data.frame}
  is currently the only method.  \code{contents.data.frame} creates an
  object containing the following attributes of the variables 
  from a data frame: names, labels (if any), units (if any), number of
  factor levels (if any), factor levels,
  class, storage mode, and number of NAs.  \code{print.contents.data.frame}
  will print the results, with options for sorting the variables.
  \code{html.contents.data.frame} creates HTML code for displaying the
  results.  This code has hyperlinks so that if the user clicks on the
  number of levels the browser jumps to the correct part of a table of
  factor levels for all the \code{factor} variables.  If long labels are
  present (\code{"longlabel"} attributes on variables), these are printed
  at the bottom and the \code{html} method links to them through the
  regular labels.  Variables having the same \code{levels} in the same
  order have the levels factored out for brevity.

  \code{contents.list} prints a directory of datasets when
  \code{\link{sasxport.get}} imported more than one SAS dataset.
}
\usage{
contents(object, \dots)
\method{contents}{data.frame}(object, sortlevels=FALSE, id=NULL,
  range=NULL, values=NULL, \dots)
\method{print}{contents.data.frame}(x,
    sort=c('none','names','labels','NAs'), prlevels=TRUE, maxlevels=Inf,
    number=FALSE, \dots) 
\method{html}{contents.data.frame}(object,
           sort=c('none','names','labels','NAs'), prlevels=TRUE, maxlevels=Inf,
           levelType=c('list','table'),
           number=FALSE, nshow=TRUE, \dots)
\method{contents}{list}(object, dslabels, \dots)
\method{print}{contents.list}(x,
    sort=c('none','names','labels','NAs','vars'), \dots)
}
\arguments{
  \item{object}{
    a data frame.  For \code{html} is an object created by
    \code{contents}.  For \code{contents.list} is a list of data frames.
  }
  \item{sortlevels}{set to \code{TRUE} to sort levels of all factor
  variables into alphabetic order.  This is especially useful when two
  variables use the same levels but in different orders.  They will
  still be recognized by the \code{html} method as having identical
  levels if sorted.}
  \item{id}{an optional subject ID variable name that if present in
		\code{object} will cause the number of unique IDs to be printed in
    the contents header}
	\item{range}{an optional variable name that if present in \code{object}
    will cause its range to be printed in the contents header}
	\item{values}{an optional variable name that if present in
    \code{object} will cause its unique values to be printed in the
    contents header}
  \item{x}{
    an object created by \code{contents}
  }
  \item{sort}{
    Default is to print the variables in their original order in the
    data frame.  Specify one of 
    \code{"names"}, \code{"labels"}, or \code{"NAs"} to sort the variables by,
    respectively, alphabetically by names, alphabetically by labels, or by
    increaseing order of number of missing values.  For
    \code{contents.list}, \code{sort} may also be the value
    \code{"vars"} to cause sorting by the number of variables in the dataset.
  }
  \item{prlevels}{
    set to \code{FALSE} to not print all levels of \code{factor} variables
  }
	\item{maxlevels}{maximum number of levels to print for a \code{factor} variable}
  \item{number}{
	set to \code{TRUE} to have the \code{print} and \code{latex} methods
	number the variables by their order in the data frame
  }
  \item{nshow}{set to \code{FALSE} to suppress outputting number of
   observations and number of \code{NA}s; useful when these counts
   would unblind information to blinded reviewers}
  \item{levelType}{
    By default, bullet lists of category levels are
    constructed in html.  Set \code{levelType='table'} to put levels in
    html table format.
  }
  \item{\dots}{
    arguments passed from \code{html} to \code{format.df},
    unused otherwise
  }
  \item{dslabels}{
    named vector of SAS dataset labels, created for
    example by \code{\link{sasdsLabels}}
  }
}
\value{
  an object of class \code{"contents.data.frame"} or
  \code{"contents.list"}.  For the \code{html} method is an \code{html}
  character vector object.
}

\author{
  Frank Harrell
  \cr
  Vanderbilt University
  \cr
  \email{fh@fharrell.com}
}
\seealso{
  \code{\link{describe}}, \code{\link{html}}, \code{\link{upData}}
}
\examples{
set.seed(1)
dfr <- data.frame(x=rnorm(400),y=sample(c('male','female'),400,TRUE),
                  stringsAsFactors=TRUE)
contents(dfr)
dfr <- upData(dfr, labels=c(x='Label for x', y='Label for y'))
attr(dfr$x, 'longlabel') <-
 'A very long label for x that can continue onto multiple long lines of text'

k <- contents(dfr)
print(k, sort='names', prlevels=FALSE)
\dontrun{
html(k)
html(contents(dfr))            # same result
latex(k$contents)              # latex.default just the main information
}
}
\keyword{data}
\keyword{interface}
\concept{html}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fImport.r
\name{fImport}
\alias{fImport}
\title{fImport}
\usage{
fImport(
  file,
  format,
  lowernames = c("not mixed", "no", "yes"),
  und. = FALSE,
  ...
)
}
\arguments{
\item{file}{name of file to import, or full URL.  \code{rio} determines the file type from the file suffix unless you override this with \code{format}}

\item{format}{format of file to import, usually not needed.  See \code{rio::import()} for details}

\item{lowernames}{defaults to changing variable names to all lower case unless the name as mixed upper and lower case, which results in keeping the original characters in the name.  Set \code{lowernames='no'} to leave variable names as they were created in the original file export, or set \code{lowernames='yes'} to set all names to lower case whether they have mixed case or not.  For all options, a check is made to see if the name conversions would result in any duplicate names.  If so, the original names are retained and a warning message issued.}

\item{und.}{set to \code{TRUE} to change all underscores in names to periods}

\item{...}{more arguments to pass to \code{rio::import()}}
}
\value{
a data frame created by \code{rio}, unless a \code{rio} option is given to use another format
}
\description{
General File Import Using \code{rio}
}
\details{
This is a front-end for the \code{rio} package's \code{import} function.  \code{fImport} includes options for setting variable names to lower case and to change underscores in names to periods.  Variables on the imported data frame that have \code{label}s are converted to Hmisc package \code{labelled} class so that subsetting the data frame will preserve the labels.
}
\examples{
\dontrun{
# Get a Stata dataset
d <- fImport('http://www.principlesofeconometrics.com/stata/alcohol.dta')
contents(d)
}
}
\seealso{
\code{upData}, especially the \code{moveUnits} option
}
\author{
Frank Harrell
}

\name{gbayes}
\alias{gbayes}
\alias{plot.gbayes}
\alias{gbayes2}
\alias{gbayesMixPredNoData}
\alias{gbayesMixPost}
\alias{gbayesMixPowerNP}
\alias{gbayes1PowerNP}
\title{
Gaussian Bayesian Posterior and Predictive Distributions
}
\description{
\code{gbayes} derives the (Gaussian) posterior and optionally the predictive
distribution when both the prior and the likelihood are Gaussian, and
when the statistic of interest comes from a 2-sample problem.
This function is especially useful in obtaining the expected power of
a statistical test, averaging over the distribution of the population
effect parameter (e.g., log hazard ratio) that is obtained using
pilot data.  \code{gbayes} is also useful for summarizing studies for
which the statistic of interest is approximately Gaussian with
known variance.  An example is given for comparing two proportions
using the angular transformation, for which the variance is
independent of unknown parameters except for very extreme probabilities.
A \code{plot} method is also given.  This plots the prior, posterior, and
predictive distributions on a single graph using a nice default for
the x-axis limits and using the \code{labcurve} function for automatic
labeling of the curves.


\code{gbayes2} uses the method of Spiegelhalter and Freedman (1986) to compute the
probability of correctly concluding that a new treatment is superior
to a control.  By this we mean that a 1-\code{alpha} normal
theory-based confidence interval for the new minus old treatment
effect lies wholly to the right of \code{delta.w}, where \code{delta.w} is the
minimally worthwhile treatment effect (which can be zero to be
consistent with ordinary null hypothesis testing, a method not always
making sense).  This kind of power function is averaged over a prior
distribution for the unknown treatment effect.  This procedure is
applicable to the situation where a prior distribution is not to be
used in constructing the test statistic or confidence interval, but is
only used for specifying the distribution of \code{delta}, the parameter of
interest.


Even though \code{gbayes2}
assumes that the test statistic has a normal distribution with known
variance (which is strongly a function of the sample size in the two
treatment groups), the prior distribution function can be completely
general.  Instead of using a step-function for the prior distribution
as Spiegelhalter and Freedman used in their appendix, \code{gbayes2} uses
the built-in \code{integrate} function for numerical integration.
\code{gbayes2} also allows the variance of the test statistic to be general
as long as it is evaluated by the user.  The conditional power given the
parameter of interest \code{delta} is \code{1 - pnorm((delta.w - delta)/sd + z)}, where z
is the normal critical value corresponding to 1 - \code{alpha}/2.

\code{gbayesMixPredNoData} derives the predictive distribution of a
statistic that is Gaussian given \code{delta} when no data have yet been
observed and when the prior is a mixture of two Gaussians.

\code{gbayesMixPost} derives the posterior density, cdf, or posterior
mean of \code{delta} given 
the statistic \code{x}, when the prior for \code{delta} is a mixture of two
Gaussians and when \code{x} is Gaussian given \code{delta}.

\code{gbayesMixPowerNP} computes the power for a test for \code{delta} > \code{delta.w}
for the case where (1) a Gaussian prior or mixture of two Gaussian priors
is used as the prior distribution, (2) this prior is used in forming
the statistical test or credible interval, (3) no prior is used for
the distribution of \code{delta} for computing power but instead a fixed
single \code{delta} is given (as in traditional frequentist hypothesis
tests), and (4) the test statistic has a Gaussian likelihood with
known variance (and mean equal to the specified \code{delta}).
\code{gbayesMixPowerNP} is handy where you want to use an earlier study in
testing for treatment effects in a new study, but you want to mix with
this prior a non-informative prior.  The mixing probability \code{mix} can
be thought of as the "applicability" of the previous study.  As with
\code{gbayes2}, power here means the probability that the new study will
yield a left credible interval that is to the right of \code{delta.w}.
\code{gbayes1PowerNP} is a special case of \code{gbayesMixPowerNP} when the
prior is a single Gaussian.
}
\usage{
gbayes(mean.prior, var.prior, m1, m2, stat, var.stat, 
       n1, n2, cut.prior, cut.prob.prior=0.025)

\method{plot}{gbayes}(x, xlim, ylim, name.stat='z', \dots)

gbayes2(sd, prior, delta.w=0, alpha=0.05, upper=Inf, prior.aux)

gbayesMixPredNoData(mix=NA, d0=NA, v0=NA, d1=NA, v1=NA,
                    what=c('density','cdf'))

gbayesMixPost(x=NA, v=NA, mix=1, d0=NA, v0=NA, d1=NA, v1=NA,
              what=c('density','cdf','postmean'))

gbayesMixPowerNP(pcdf, delta, v, delta.w=0, mix, interval,
                 nsim=0, alpha=0.05)

gbayes1PowerNP(d0, v0, delta, v, delta.w=0, alpha=0.05)
}
\arguments{
\item{mean.prior}{
mean of the prior distribution
}
\item{cut.prior,cut.prob.prior,var.prior}{
variance of the prior.  Use a large number such as 10000 to effectively
use a flat (noninformative) prior.  Sometimes it is useful to compute
the variance so that the prior probability that \code{stat} is greater than
some impressive value \code{u} is only \code{alpha}.  The correct
\code{var.prior} to use is then \code{((u-mean.prior)/qnorm(1-alpha))^2}.
You can specify \code{cut.prior=u} and \code{cut.prob.prior=alpha} (whose default is 0.025)
in place of \code{var.prior} to have \code{gbayes} compute the prior variance in this
manner. 
}
\item{m1}{
sample size in group 1
}
\item{m2}{
sample size in group 2
}
\item{stat}{
statistic comparing groups 1 and 2, e.g., log hazard ratio, difference
in means, difference in angular transformations of proportions
}
\item{var.stat}{
variance of \code{stat}, assumed to be known.  \code{var.stat} should either
be a constant (allowed if \code{n1} is not specified), or a function of
two arguments which specify the sample sizes in groups 1 and 2. 
Calculations will be approximate when the variance is estimated from the data.
}
\item{x}{
an object returned by \code{gbayes} or the value of the statistic which
is an estimator of delta, the parameter of interest
}
\item{sd}{
the standard deviation of the treatment effect
}
\item{prior}{
a function of possibly a vector of unknown treatment effects,
returning the prior density at those values
}
\item{pcdf}{
a function computing the posterior CDF of the treatment effect
\code{delta}, such as a function created by \code{gbayesMixPost} with
\code{what="cdf"}.
}
\item{delta}{
a true unknown single treatment effect to detect
}
\item{v}{
the variance of the statistic \code{x}, e.g., \code{s^2 * (1/n1 + 1/n2)}.
Neither \code{x} nor \code{v} need to be defined to
\code{gbayesMixPost}, as they can be defined at run time to the function
created by \code{gbayesMixPost}.
}
\item{n1}{
number of future observations in group 1, for obtaining a predictive
distribution
}
\item{n2}{
number of future observations in group 2
}
\item{xlim}{
vector of 2 x-axis limits.  Default is the mean of the posterior plus or
minus 6 standard deviations of the posterior.
}
\item{ylim}{
vector of 2 y-axis limits.  Default is the range over combined prior and 
posterior densities.
}
\item{name.stat}{
label for x-axis.  Default is \code{"z"}.
}
\item{...}{
optional arguments passed to \code{labcurve} from \code{plot.gbayes}
}
\item{delta.w}{
the minimum worthwhile treatment difference to detech.  The default is
zero for a plain uninteristing null hypothesis.
}
\item{alpha}{
type I error, or more accurately one minus the confidence level for a
two-sided confidence limit for the treatment effect
}
\item{upper}{
upper limit of integration over the prior distribution multiplied by
the normal likelihood for the treatment effect statistic.  Default is
infinity.
}
\item{prior.aux}{
argument to pass to \code{prior} from \code{integrate} through \code{gbayes2}.
Inside of \code{power} the argument must be named \code{prior.aux} if it
exists.  You can pass multiple parameters by passing \code{prior.aux} as a
list and pulling off elements of the list inside \code{prior}.  This setup
was used because of difficulties in passing \code{\dots} arguments through
\code{integrate} for some situations.
}
\item{mix}{
mixing probability or weight for the Gaussian prior having mean \code{d0}
and variance \code{v0}.  \code{mix} must be between 0 and 1, inclusive.
}
\item{d0}{
mean of the first Gaussian distribution (only Gaussian for
\code{gbayes1PowerNP} and is a required argument)
}
\item{v0}{
variance of the first Gaussian (only Gaussian for
\code{gbayes1PowerNP} and is a required argument)
}
\item{d1}{
mean of the second Gaussian (if \code{mix} < 1)
}
\item{v1}{
variance of the second Gaussian (if \code{mix} < 1).  Any of these last 5
arguments can be omitted to \code{gbayesMixPredNoData} as they can be
provided at run time to the function created by \code{gbayesMixPredNoData}.
}
\item{what}{
specifies whether the predictive density or the CDF is to be
computed.  Default is \code{"density"}.
}
\item{interval}{
a 2-vector containing the lower and upper limit for possible values of
the test statistic \code{x} that would result in a left credible interval
exceeding \code{delta.w} with probability 1-\code{alpha}/2
}
\item{nsim}{
defaults to zero, causing \code{gbayesMixPowerNP} to solve numerically for the
critical value of \code{x}, then to compute the power accordingly.  Specify
a nonzero number such as 20000 for \code{nsim} to instead have the function
estimate power by simulation.  In this case 0.95 confidence limits on
the estimated power are also computed.  This approach is sometimes
necessary if \code{uniroot} can't solve the equation for the critical value.
}}
\value{
\code{gbayes} returns a list of class \code{"gbayes"} containing the following
names elements: \code{mean.prior},\code{var.prior},\code{mean.post}, \code{var.post}, and
if \code{n1} is specified, \code{mean.pred} and \code{var.pred}.  Note that
\code{mean.pred} is  identical to \code{mean.post}.  \code{gbayes2} returns a single
number which is the probability of correctly rejecting the null
hypothesis in favor of the new treatment.  \code{gbayesMixPredNoData}
returns a function that can be used to evaluate the predictive density
or cumulative distribution.  \code{gbayesMixPost} returns a function that
can be used to evaluate the posterior density or cdf.  \code{gbayesMixPowerNP}
returns a vector containing two values if \code{nsim} = 0.  The first value is the
critical value for the test statistic that will make the left credible
interval > \code{delta.w}, and the second value is the power.  If \code{nsim} > 0,
it returns the power estimate and confidence limits for it if \code{nsim} >
0.  The examples show how to use these functions.  
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University School of Medicine
\cr
\email{fh@fharrell.com}
}
\seealso{\code{\link{gbayesSeqSim}}}
\references{
Spiegelhalter DJ, Freedman LS, Parmar MKB (1994): Bayesian approaches to
randomized trials.  JRSS A 157:357--416.  Results for \code{gbayes} are derived from
Equations 1, 2, 3, and 6.


Spiegelhalter DJ, Freedman LS (1986): A predictive approach to
selecting the size of a clinical trial, based on subjective clinical
opinion.  Stat in Med 5:1--13.


Joseph, Lawrence and Belisle, Patrick (1997): Bayesian sample size
determination for normal means and differences between normal means.
The Statistician 46:209--226.

Grouin, JM, Coste M, Bunouf P, Lecoutre B (2007): Bayesian sample size
determination in non-sequential clinical trials: Statistical aspects and
some regulatory considerations.  Stat in Med 26:4914--4924.
}
\examples{
# Compare 2 proportions using the var stabilizing transformation
# arcsin(sqrt((x+3/8)/(n+3/4))) (Anscombe), which has variance 
# 1/[4(n+.5)]


m1 <- 100;     m2 <- 150
deaths1 <- 10; deaths2 <- 30


f <- function(events,n) asin(sqrt((events+3/8)/(n+3/4)))
stat <- f(deaths1,m1) - f(deaths2,m2)
var.stat <- function(m1, m2) 1/4/(m1+.5) + 1/4/(m2+.5)
cat("Test statistic:",format(stat),"  s.d.:",
    format(sqrt(var.stat(m1,m2))), "\n")
#Use unbiased prior with variance 1000 (almost flat)
b <- gbayes(0, 1000, m1, m2, stat, var.stat, 2*m1, 2*m2)
print(b)
plot(b)
#To get posterior Prob[parameter > w] use 
# 1-pnorm(w, b$mean.post, sqrt(b$var.post))


#If g(effect, n1, n2) is the power function to
#detect an effect of 'effect' with samples size for groups 1 and 2
#of n1,n2, estimate the expected power by getting 1000 random
#draws from the posterior distribution, computing power for
#each value of the population effect, and averaging the 1000 powers
#This code assumes that g will accept vector-valued 'effect'
#For the 2-sample proportion problem just addressed, 'effect'
#could be taken approximately as the change in the arcsin of
#the square root of the probability of the event


g <- function(effect, n1, n2, alpha=.05) {
  sd <- sqrt(var.stat(n1,n2))
  z <- qnorm(1 - alpha/2)
  effect <- abs(effect)
  1 - pnorm(z - effect/sd) + pnorm(-z - effect/sd)
}


effects <- rnorm(1000, b$mean.post, sqrt(b$var.post))
powers <- g(effects, 500, 500)
hist(powers, nclass=35, xlab='Power')
describe(powers)




# gbayes2 examples
# First consider a study with a binary response where the
# sample size is n1=500 in the new treatment arm and n2=300
# in the control arm.  The parameter of interest is the 
# treated:control log odds ratio, which has variance
# 1/[n1 p1 (1-p1)] + 1/[n2 p2 (1-p2)].  This is not
# really constant so we average the variance over plausible
# values of the probabilities of response p1 and p2.  We
# think that these are between .4 and .6 and we take a 
# further short cut


v <- function(n1, n2, p1, p2) 1/(n1*p1*(1-p1)) + 1/(n2*p2*(1-p2))
n1 <- 500; n2 <- 300
ps <- seq(.4, .6, length=100)
vguess <- quantile(v(n1, n2, ps, ps), .75)
vguess
#        75\% 
# 0.02183459


# The minimally interesting treatment effect is an odds ratio
# of 1.1.  The prior distribution on the log odds ratio is
# a 50:50 mixture of a vague Gaussian (mean 0, sd 100) and
# an informative prior from a previous study (mean 1, sd 1)


prior <- function(delta) 
  0.5*dnorm(delta, 0, 100)+0.5*dnorm(delta, 1, 1)
deltas <- seq(-5, 5, length=150)
plot(deltas, prior(deltas), type='l')


# Now compute the power, averaged over this prior
gbayes2(sqrt(vguess), prior, log(1.1))
# [1] 0.6133338


# See how much power is lost by ignoring the previous
# study completely


gbayes2(sqrt(vguess), function(delta)dnorm(delta, 0, 100), log(1.1))
# [1] 0.4984588


# What happens to the power if we really don't believe the treatment
# is very effective?  Let's use a prior distribution for the log
# odds ratio that is uniform between log(1.2) and log(1.3).
# Also check the power against a true null hypothesis


prior2 <- function(delta) dunif(delta, log(1.2), log(1.3))
gbayes2(sqrt(vguess), prior2, log(1.1))
# [1] 0.1385113


gbayes2(sqrt(vguess), prior2, 0)
# [1] 0.3264065


# Compare this with the power of a two-sample binomial test to
# detect an odds ratio of 1.25
bpower(.5, odds.ratio=1.25, n1=500, n2=300)
#     Power 
# 0.3307486


# For the original prior, consider a new study with equal
# sample sizes n in the two arms.  Solve for n to get a
# power of 0.9.  For the variance of the log odds ratio
# assume a common p in the center of a range of suspected
# probabilities of response, 0.3.  For this example we
# use a zero null value and the uniform prior above


v   <- function(n) 2/(n*.3*.7)
pow <- function(n) gbayes2(sqrt(v(n)), prior2)
uniroot(function(n) pow(n)-0.9, c(50,10000))$root
# [1] 2119.675
# Check this value
pow(2119.675)
# [1] 0.9


# Get the posterior density when there is a mixture of two priors,
# with mixing probability 0.5.  The first prior is almost
# non-informative (normal with mean 0 and variance 10000) and the
# second has mean 2 and variance 0.3.  The test statistic has a value
# of 3 with variance 0.4.
f <- gbayesMixPost(3, 4, mix=0.5, d0=0, v0=10000, d1=2, v1=0.3)


args(f)


# Plot this density
delta <- seq(-2, 6, length=150)
plot(delta, f(delta), type='l')


# Add to the plot the posterior density that used only
# the almost non-informative prior
lines(delta, f(delta, mix=1), lty=2)


# The same but for an observed statistic of zero
lines(delta, f(delta, mix=1, x=0), lty=3)


# Derive the CDF instead of the density
g <- gbayesMixPost(3, 4, mix=0.5, d0=0, v0=10000, d1=2, v1=0.3,
                   what='cdf')
# Had mix=0 or 1, gbayes1PowerNP could have been used instead
# of gbayesMixPowerNP below


# Compute the power to detect an effect of delta=1 if the variance
# of the test statistic is 0.2
gbayesMixPowerNP(g, 1, 0.2, interval=c(-10,12))


# Do the same thing by simulation
gbayesMixPowerNP(g, 1, 0.2, interval=c(-10,12), nsim=20000)


# Compute by what factor the sample size needs to be larger
# (the variance needs to be smaller) so that the power is 0.9
ratios <- seq(1, 4, length=50)
pow <- single(50)
for(i in 1:50) 
  pow[i] <- gbayesMixPowerNP(g, 1, 0.2/ratios[i], interval=c(-10,12))[2]


# Solve for ratio using reverse linear interpolation
approx(pow, ratios, xout=0.9)$y


# Check this by computing power
gbayesMixPowerNP(g, 1, 0.2/2.1, interval=c(-10,12))
# So the study will have to be 2.1 times as large as earlier thought
}
\keyword{htest}
\concept{study design}
\concept{power}

\name{src}
\alias{src}
\title{Source a File from the Current Working Directory}
\description{
\code{src} concatenates \code{".s"} to its argument, quotes the result,
and \code{source}s in the file.  It sets \code{options(last.source)} to
this file name so that \code{src()} can be issued to re-\code{source}
the file when it is edited.
}
\usage{
src(x)
}
\arguments{
  \item{x}{an unquoted file name aside from \code{".s"}.  This base file
  name must be a legal S name.}
}
\section{Side Effects}{
  Sets system option \code{last.source}
}
\author{Frank Harrell}
\seealso{\code{\link{source}}}
\examples{
\dontrun{
src(myfile)   # source("myfile.s")
src()         # re-source myfile.s
}
}
\keyword{file}
\keyword{programming}
\keyword{utilities}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/printL.r
\name{printL}
\alias{printL}
\title{printL}
\usage{
printL(..., dec = NULL, maxoneline = 5)
}
\arguments{
\item{...}{any number of objects to \code{print()}}

\item{dec}{optional decimal places to the right of the decimal point for rounding}

\item{maxoneline}{controls how many elements may be printed on a single line for \code{vector} objects}
}
\value{
nothing
}
\description{
Print an object or a named list of objects.  When multiple objects are given, their names are printed before their contents.  When an object is a vector that is not longer than \code{maxoneline} and its elements are not named, all the elements will be printed on one line separated by commas.  When \code{dec} is given, numeric vectors or numeric columns of data frames or data tables are rounded to the nearest \code{dec} before printing.  This function is especially helpful when printing objects in a Quarto or RMarkdown document and the code is not currently being shown to place the output in context.
}
\examples{
w <- pi + 1 : 2
printL(w=w)
printL(w, dec=3)
printL('this is it'=c(pi, pi, 1, 2),
       yyy=pi,
       z=data.frame(x=pi+1:2, y=3:4, z=c('a', 'b')),
       qq=1:10,
       dec=4)
       
}
\seealso{
\code{\link[=prn]{prn()}}
}
\author{
Frank Harrell
}

\name{summaryM}
\alias{summaryM}
\alias{print.summaryM}
\alias{plot.summaryM}
\alias{latex.summaryM}
\alias{html.summaryM}
\alias{printsummaryM}
\title{Summarize Mixed Data Types vs. Groups}
\description{
  \code{summaryM} summarizes the variables listed in an S formula,
  computing descriptive statistics and optionally statistical tests for
  group differences.  This function is typically used when there are
  multiple left-hand-side variables that are independently against by
  groups marked by a single right-hand-side variable.  The summary
  statistics may be passed to \code{print} methods, \code{plot} methods
  for making annotated dot charts and extended box plots, and 
  \code{latex} methods for typesetting tables using LaTeX.  The
	\code{html} method uses \code{htmlTable::htmlTable} to typeset the
	table in html, by passing information to the \code{latex} method with
	\code{html=TRUE}.  This is for use with Quarto/RMarkdown.
  The \code{print} methods use the \code{print.char.matrix} function to
  print boxed tables when \code{options(prType=)} has not been given or
	when \code{prType='plain'}.  For plain tables, \code{print} calls the
	internal function \code{printsummaryM}.  When \code{prType='latex'}
	the \code{latex} method is invoked, and when \code{prType='html'} html
	is rendered.  In Quarto/RMarkdown, proper rendering will result even
	if \code{results='asis'} does not appear in the chunk header.  When
	rendering in html at the console due to having \code{options(prType='html')}
	the table will be rendered in a viewer.

	The \code{plot} method creates \code{plotly} graphics if
	\code{options(grType='plotly')}, otherwise base graphics are used.
	\code{plotly} graphics provide extra information such as which
	quantile is being displayed when hovering the mouse.  Test statistics
	are displayed by hovering over the mean.

  Continuous variables are described by three quantiles (quartiles by
  default) when printing, or by the following quantiles when plotting
  expended box plots using the \code{\link{bpplt}} function:
  0.05, 0.125, 0.25, 0.375, 0.5, 0.625, 0.75, 0.875, 0.95.  The box
  plots are scaled to the 0.025 and 0.975 quantiles of each continuous
  left-hand-side variable.  Categorical variables are 
  described by counts and percentages.
  
  The left hand side of \code{formula} may contain \code{mChoice}
  ("multiple choice") variables.  When \code{test=TRUE} each choice is
  tested separately as a binary categorical response.

  The \code{plot} method for \code{method="reverse"} creates a temporary
  function \code{Key} as is done by the \code{xYplot} and
  \code{Ecdf.formula} functions.  After \code{plot}
  runs, you can type \code{Key()} to put a legend in a default location, or
  e.g. \code{Key(locator(1))} to draw a legend where you click the left
  mouse button.  This key is for categorical variables, so to have the
  opportunity to put the key on the graph you will probably want to use
  the command \code{plot(object, which="categorical")}.  A second function
  \code{Key2} is created if continuous variables are being plotted.  It is
  used the same as \code{Key}.  If the \code{which} argument is not
  specified to \code{plot}, two pages of plots will be produced.  If you
  don't define \code{par(mfrow=)} yourself,
  \code{plot.summaryM} will try to lay out a multi-panel
  graph to best fit all the individual charts for continuous
  variables.
}
\usage{
summaryM(formula, groups=NULL, data=NULL, subset, na.action=na.retain,
         overall=FALSE, continuous=10, na.include=FALSE,
         quant=c(0.025, 0.05, 0.125, 0.25, 0.375, 0.5, 0.625,
                 0.75, 0.875, 0.95, 0.975),
         nmin=100, test=FALSE,
         conTest=conTestkw, catTest=catTestchisq,
         ordTest=ordTestpo)

\method{print}{summaryM}(...)

printsummaryM(x, digits, prn = any(n != N),
      what=c('proportion', '\%'), pctdig = if(what == '\%') 0 else 2,
      npct = c('numerator', 'both', 'denominator', 'none'),
      exclude1 = TRUE, vnames = c('labels', 'names'), prUnits = TRUE,
      sep = '/', abbreviate.dimnames = FALSE,
      prefix.width = max(nchar(lab)), min.colwidth, formatArgs=NULL, round=NULL,
      prtest = c('P','stat','df','name'), prmsd = FALSE, long = FALSE,
      pdig = 3, eps = 0.001, prob = c(0.25, 0.5, 0.75), prN = FALSE, \dots)

\method{plot}{summaryM}(x, vnames = c('labels', 'names'),
     which = c('both', 'categorical', 'continuous'), vars=NULL,
     xlim = c(0,1),
     xlab = 'Proportion',
     pch = c(16, 1, 2, 17, 15, 3, 4, 5, 0), exclude1 = TRUE,
     main, ncols=2,
     prtest = c('P', 'stat', 'df', 'name'), pdig = 3, eps = 0.001,
     conType = c('bp', 'dot', 'raw'), cex.means = 0.5, cex=par('cex'),
     height='auto', width=700, \dots)

\method{latex}{summaryM}(object, title =
      first.word(deparse(substitute(object))),
      file=paste(title, 'tex', sep='.'), append=FALSE, digits, 
      prn = any(n != N), what=c('proportion', '\%'),
      pctdig = if(what == '\%') 0 else 2,
      npct = c('numerator', 'both', 'denominator', 'slash', 'none'),
      npct.size = if(html) mspecs$html$smaller else 'scriptsize',
      Nsize = if(html) mspecs$html$smaller else 'scriptsize',
      exclude1 = TRUE,
      vnames=c("labels", "names"), prUnits = TRUE, middle.bold = FALSE,
      outer.size = if(html) mspecs$html$smaller else "scriptsize",
      caption, rowlabel = "", rowsep=html,
      insert.bottom = TRUE, dcolumn = FALSE, formatArgs=NULL, round=NULL,
      prtest = c('P', 'stat', 'df', 'name'), prmsd = FALSE,
      msdsize = if(html) function(x) x else NULL, brmsd=FALSE,
      long = FALSE, pdig = 3, eps = 0.001,
      auxCol = NULL, table.env=TRUE, tabenv1=FALSE, prob=c(0.25, 0.5, 0.75),
      prN=FALSE, legend.bottom=FALSE, html=FALSE,
      mspecs=markupSpecs, \dots)

\method{html}{summaryM}(object, \dots)
}
\arguments{
  \item{formula}{
    An S formula with additive effects.  There may be several variables
    on the right hand side separated by "+",
		or the numeral \code{1}, indicating that
    there is no grouping variable so that only margin summaries are
    produced.  The right hand side variable, if present, must be a
    discrete variable producing a limited number of groups.  On the
    left hand side there may be any number of variables, separated by
    "+", and these may be of mixed types.  These variables are analyzed
    separately by the grouping variable.
  }
	\item{groups}{if there is more than one right-hand variable, specify
    \code{groups} as a character string containing the name of the
		variable used to produce columns of the table.  The remaining right
      hand variables are combined to produce levels that cause separate
      tables or plots to be produced.}
  \item{x}{an object created by \code{summaryM}.  For
    \code{conTestkw} a numeric vector, and for \code{ordTestpo}, a numeric
    or factor variable that can be considered ordered}
  \item{data}{
    name or number of a data frame.  Default is the current frame.
  }
  \item{subset}{
    a logical vector or integer vector of subscripts used to specify the
    subset of data to use in the analysis.  The default is to use all
    observations in the data frame.
  }
  \item{na.action}{
    function for handling missing data in the input data.  The default is
    a function defined here called \code{na.retain}, which keeps all
    observations for processing, with missing variables or not.
  }
  \item{overall}{
    Setting \code{overall=TRUE} makes a new column with
    overall statistics for the whole sample.  If \code{test=TRUE} these
    marginal statistics are ignored in doing statistical tests.
  }
  \item{continuous}{
    specifies the threshold for when a variable is considered to be
    continuous (when there are at least \code{continuous} unique values).
    \code{factor} variables are always considered to be categorical no matter
    how many levels they have.
  }
  \item{na.include}{
	Set \code{na.include=TRUE} to keep missing values of categorical
      variables from being excluded from the table.  
  }
  \item{nmin}{
    For categories of the response variable in which there
    are less than or equal to \code{nmin} non-missing observations, the raw
    data are retained for later plotting in place of box plots.
  }
  \item{test}{
    Set to \code{TRUE} to compute test
    statistics using tests specified in \code{conTest} and \code{catTest}.
  }
  \item{conTest}{
    a function of two arguments (grouping variable and a continuous
    variable) that returns a list with components \code{P} (the computed
    P-value), \code{stat} (the test statistic, either chi-square or F),
    \code{df} (degrees of freedom), \code{testname} (test name),
		\code{namefun} (\code{"chisq", "fstat"}), \code{statname}
    (statistic name), an optional component \code{latexstat} (LaTeX
    representation of \code{statname}), an optional component
    \code{plotmathstat} (for R - the \code{plotmath} representation of
    \code{statname}, as a character string),  and an
    optional component \code{note} 
    that contains a character string note about the test (e.g.,
    \code{"test not done because n < 5"}).  \code{conTest} is applied to
      continuous variables 
    on the right-hand-side of the formula when \code{method="reverse"}.  The
    default uses the \code{spearman2} function to run the Wilcoxon or
    Kruskal-Wallis test using the F distribution.
  }
  \item{catTest}{
    a function of a frequency table (an integer matrix) that returns a
    list with the same components as created by \code{conTest}.  By default,
    the Pearson chi-square test is done, without continuity correction
    (the continuity correction would make the test conservative like the
    Fisher exact test).
  }
  \item{ordTest}{
    a function of a frequency table (an integer matrix) that returns a
    list with the same components as created by \code{conTest}.  By default,
    the Proportional odds likelihood ratio test is done.
  }
  \item{\dots}{
    For \code{Key} and \code{Key2} these arguments are passed to \code{key},
    \code{text}, or \code{mtitle}.  For \code{print} methods these are
    optional arguments to \code{print.char.matrix}. For \code{latex} methods
    these are passed to \code{latex.default}.  For \code{html} the
		arguments are passed the \code{latex.summaryM}, and the arguments
		may not include \code{file}.  For \code{print} the arguments are
		passed to \code{printsummaryM} or \code{latex.summaryM} depending on
		\code{options(prType=)}.
  }
  \item{object}{an object created by \code{summaryM}}
  \item{quant}{
    vector of quantiles to use for summarizing continuous variables.
	These must be numbers between 0 and 1
    inclusive and must include the numbers 0.5, 0.25, and 0.75 which are
    used for printing and for plotting 
    quantile intervals.  The outer quantiles are used for scaling the x-axes
    for such plots.  Specify outer quantiles as \code{0} and \code{1} to
    scale the x-axes using the whole observed data ranges instead of the
    default (a 0.95 quantile interval).  Box-percentile plots are drawn
    using all but the outer quantiles.
  }
  \item{prob}{
    vector of quantiles to use for summarizing continuous variables.
    These must be numbers between 0 and 1 inclusive and have previously been
    included in the \code{quant} argument of \code{summaryM}.  The vector
    must be of length three.  By default it contains 0.25, 0.5, and 0.75.

    Warning: specifying 0 and 1 as two of the quantiles will result in
    computing the minimum and maximum of the variable.  As for many random
    variables the minimum will continue to become smaller as the sample size
    grows, and the maximum will continue to get larger.  Thus the min and max
    are not recommended as summary statistics.
  }
  \item{vnames}{
    By default, tables and plots are usually labeled with variable labels
    (see the \code{label} and \code{sas.get} functions).  To use the shorter
    variable names, specify \code{vnames="name"}.
  }
  \item{pch}{
    vector of plotting characters to represent different groups, in order
    of group levels.
  }
  \item{abbreviate.dimnames}{see \code{print.char.matrix}}
  \item{prefix.width}{see \code{print.char.matrix}}
  \item{min.colwidth}{
    minimum column width to use for boxes printed with \code{print.char.matrix}.
    The default is the maximum of the minimum column label length and
      the minimum length of entries in the data cells.
  }
  \item{formatArgs}{
    a list containing other arguments to pass to \code{format.default} such as
    \code{scientific}, e.g., \code{formatArgs=list(scientific=c(-5,5))}.  For
    \code{print.summary.formula.reverse} and
	\code{format.summary.formula.reverse}, \code{formatArgs} applies only to
    statistics computed on continuous variables, not to percents,
    numerators, and denominators.  The \code{round} argument may be preferred.
  }
  \item{digits}{
    number of significant digits to print.  Default is to use the current
    value of the \code{digits} system option.
  }
	\item{what}{specifies whether proportions or percentages are to be
      printed or LaTeX'd} 
  \item{pctdig}{
    number of digits to the right of the decimal place for printing
    percentages or proportions. The default is zero if \code{what='\%'},
		so percents will be rounded to the nearest percent.  The default is
    2 for proportions.
  }
  \item{prn}{
    set to \code{TRUE} to print the number of non-missing observations on the
    current (row) variable.  The default is to print these only if any of
    the counts of non-missing values differs from the total number of
    non-missing values of the left-hand-side variable.
  }
  \item{prN}{
    set to \code{TRUE} to print the number of non-missing observations on
    rows that contain continuous variables.
  }
  \item{npct}{
    specifies which counts are to be printed to the right of percentages.
    The default is to print the frequency (numerator of the percent) in
    parentheses.  You can specify \code{"both"} to print both numerator and
    denominator as a fraction, \code{"denominator"}, \code{"slash"} to
		typeset horizontally using a forward slash, or \code{"none"}.
  }
  \item{npct.size}{
    the size for typesetting \code{npct} information which appears after
      percents. The default is \code{"scriptsize"}.
  }
  \item{Nsize}{
    When a second row of column headings is added showing sample sizes,
    \code{Nsize} specifies the LaTeX size for these subheadings.  Default
    is \code{"scriptsize"}.
  }
  \item{exclude1}{
    By default, \code{summaryM} objects will be printed, plotted,  or typeset by
    removing redundant entries from percentage tables for categorical
    variables.  For example, if you print the percent of females, you
    don't need to print the percent of males.  To override this, set
      \code{exclude1=FALSE}. 
  }
  \item{prUnits}{
    set to \code{FALSE} to suppress printing or latexing \code{units}
    attributes of variables, when \code{method='reverse'} or \code{'response'}
  }
  \item{sep}{
    character to use to separate quantiles when printing tables
  }
  \item{prtest}{
    a vector of test statistic components to print if \code{test=TRUE} was in
    effect when \code{summaryM} was called.  Defaults to printing all
    components.  Specify \code{prtest=FALSE} or \code{prtest="none"} to not
    print any tests.  This applies to \code{print}, \code{latex}, and
    \code{plot} methods.
  }
  \item{round}{
	Specify \code{round} to round
	the quantiles and optional mean and standard deviation to
	\code{round} digits after the decimal point.  Set \code{round='auto'}
      to try an automatic choice.
	}
  \item{prmsd}{
    set to \code{TRUE} to print mean and SD after the three quantiles, for
    continuous variables
  }
  \item{msdsize}{
    defaults to \code{NULL} to use the current font size for the mean and
    standard deviation if \code{prmsd} is \code{TRUE}.  Set to a character
    string or function to specify an alternate LaTeX font size.
  }
	\item{brmsd}{set to \code{TRUE} to put the mean and standard deviation
    on a separate line, for html}
  \item{long}{
    set to \code{TRUE} to print the results for the first category on its own
    line, not on the same line with the variable label
  }
  \item{pdig}{
    number of digits to the right of the decimal place for printing
    P-values.  Default is \code{3}.  This is passed to \code{format.pval}.
  }
  \item{eps}{
    P-values less than \code{eps} will be printed as \code{< eps}.  See
    \code{format.pval}.
  }
  \item{auxCol}{
    an optional auxiliary column of information, right justified, to add
    in front of statistics typeset by
    \code{latex.summaryM}.  This argument is a list with a
    single element that has a name specifying the column heading.  If this
    name includes a newline character, the portions of the string before
    and after the newline form respectively the main heading and the
    subheading (typically set in smaller font), respectively.  See the
    \code{extracolheads} argument to \code{latex.default}.  \code{auxCol}
    is filled with blanks when a variable being summarized takes up more
    than one row in the output.  This happens with categorical variables.
  }
	\item{table.env}{set to \code{FALSE} to use \code{tabular} environment
    with no caption}
	\item{tabenv1}{set to \code{TRUE} in the case of stratification when
      you want only the first stratum's table to be in a table
      environment.  This is useful when using \code{hyperref}.}
  \item{which}{Specifies whether to plot results for categorical variables,
    continuous variables, or both (the default).}
	\item{vars}{Subscripts (indexes) of variables to plot for
    \code{plotly} graphics.  Default is to plot all variables of each
    type (categorical or continuous).}
  \item{conType}{
    For drawing plots for continuous variables,
	extended box plots (box-percentile-type plots) are drawn by default,
      using all quantiles in \code{quant} except for the outermost ones
      which are using for scaling the overall plot based on the
      non-stratified marginal distribution of the current response variable.
    Specify \code{conType='dot'} to draw dot plots showing the three
      quartiles instead.  For extended box plots, means are drawn
    with a solid dot and vertical reference lines are placed at the three
    quartiles.  Specify \code{conType='raw'} to make a strip chart showing
    the raw data.  This can only be used if the sample size for each
    right-hand-side group is less than or equal to \code{nmin}.}
  \item{cex.means}{
    character size for means in box-percentile plots; default is .5}
  \item{cex}{character size for other plotted items}
	\item{height,width}{dimensions in pixels for the \code{plotly}
    \code{subplot} object containing all the extended box plots.  If
    \code{height="auto"}, \code{plot.summaryM} will set \code{height}
    based on the number of 
    continuous variables and \code{ncols} or for dot charts it will use
    \code{Hmisc::plotlyHeightDotchart}.  At present \code{height} is
    ignored for extended box plots due to vertical spacing problem with
    \code{plotly} graphics.}
  \item{xlim}{
    vector of length two specifying x-axis limits.  This is only used
      for plotting categorical variables.  Limits for continuous
      variables are determined by the outer quantiles specified in
      \code{quant}. 
  }
  \item{xlab}{x-axis label}
  \item{main}{a main title.  This applies only to the plot for
    categorical variables.}
	\item{ncols}{number of columns for \code{plotly} graphics for extended
    box plots.  Defaults to 2.  Recommendation is for 1-2.}
  \item{caption}{character string containing LaTeX table captions.}
  \item{title}{
    name of resulting LaTeX file omitting the \code{.tex} suffix.  Default
    is the name of the \code{summary} object.  If \code{caption} is specied,
    \code{title} is also used for the table's symbolic reference label. 
  }
	\item{file}{name of file to write LaTeX code to. Specifying
      \code{file=""} will cause LaTeX code to just be printed to
      standard output rather than be stored in a  permanent file.
		}
  \item{append}{specify \code{TRUE} to add code to an existing file}
  \item{rowlabel}{see \code{latex.default} (under the help file
    \code{latex})}
	\item{rowsep}{if \code{html} is \code{TRUE}, instructs the function to
    use a horizontal line to separate variables from one another.
    Recommended if \code{brmsd} is \code{TRUE}.  Ignored for LaTeX.}
  \item{middle.bold}{
    set to \code{TRUE} to have LaTeX use bold face for the middle
    quantile
  }
  \item{outer.size}{the font size for outer quantiles
  }
  \item{insert.bottom}{
    set to \code{FALSE} to suppress inclusion of definitions placed at the
    bottom of LaTeX tables.  You can also specify a character string
      containing other text that overrides the automatic text.  At
    present such text always appears in the main caption for LaTeX.
  }
  \item{legend.bottom}{
    set to \code{TRUE} to separate the table caption and legend.  This
    will place table legends at the bottom of LaTeX tables.
  }
	\item{html}{set to \code{TRUE} to typeset with html}
	\item{mspecs}{list defining markup syntax for various languages,
    defaults to Hmisc \code{markupSpecs} which the user can use as a
    starting point for editing}
  \item{dcolumn}{see \code{latex}}
  }
\value{
  a list.  \code{plot.summaryM} returns the number
  of pages of plots that were made if using base graphics, or
  \code{plotly} objects created by \code{plotly::subplot} otherwise.
	If both categorical and continuous variables were plotted, the
    returned object is a list with two named elements \code{Categorical}
    and \code{Continuous} each containing \code{plotly} objects.
    Otherwise a \code{plotly} object is returned.
    The \code{latex} method returns attributes \code{legend} and
    \code{nstrata}.
}
\section{Side Effects}{
  \code{plot.summaryM} creates a function \code{Key} and
  \code{Key2} in frame 0 that will draw legends, if base graphics are
    being used.
}
\author{
  Frank Harrell
  \cr
  Department of Biostatistics
  \cr
  Vanderbilt University
  \cr
  \email{fh@fharrell.com}
}
\references{
  Harrell FE (2004): Statistical tables and plots using S and LaTeX.
  Document available from
    \url{https://hbiostat.org/R/Hmisc/summary.pdf}. 
}
\seealso{
  \code{\link{mChoice}}, \code{\link{label}}, \code{\link{dotchart3}},
  \code{\link{print.char.matrix}}, \code{\link{update}},
  \code{\link{formula}}, 
  \code{\link{format.default}}, \code{\link{latex}},
  \code{\link{latexTranslate}}, \code{\link{bpplt}},
	\code{\link{tabulr}}, \code{\link{bpplotM}}, \code{\link{summaryP}}
}
\examples{
options(digits=3)
set.seed(173)
sex <- factor(sample(c("m","f"), 500, rep=TRUE))
country <- factor(sample(c('US', 'Canada'), 500, rep=TRUE))
age <- rnorm(500, 50, 5)
sbp <- rnorm(500, 120, 12)
label(sbp) <- 'Systolic BP'
units(sbp) <- 'mmHg'
treatment <- factor(sample(c("Drug","Placebo"), 500, rep=TRUE))
treatment[1]
sbp[1] <- NA

# Generate a 3-choice variable; each of 3 variables has 5 possible levels
symp <- c('Headache','Stomach Ache','Hangnail',
          'Muscle Ache','Depressed')
symptom1 <- sample(symp, 500,TRUE)
symptom2 <- sample(symp, 500,TRUE)
symptom3 <- sample(symp, 500,TRUE)
Symptoms <- mChoice(symptom1, symptom2, symptom3, label='Primary Symptoms')
table(as.character(Symptoms))

# Note: In this example, some subjects have the same symptom checked
# multiple times; in practice these redundant selections would be NAs
# mChoice will ignore these redundant selections

f <- summaryM(age + sex + sbp + Symptoms ~ treatment, test=TRUE)
f
# trio of numbers represent 25th, 50th, 75th percentile
print(f, long=TRUE)
plot(f)    # first specify options(grType='plotly') to use plotly
plot(f, conType='dot', prtest='P')
bpplt()    # annotated example showing layout of bp plot

# Produce separate tables by country
f <- summaryM(age + sex + sbp + Symptoms ~ treatment + country,
              groups='treatment', test=TRUE)
f

\dontrun{
getHdata(pbc)
s5 <- summaryM(bili + albumin + stage + protime + sex + 
               age + spiders ~ drug, data=pbc)

print(s5, npct='both')
# npct='both' : print both numerators and denominators
plot(s5, which='categorical')
Key(locator(1))  # draw legend at mouse click
par(oma=c(3,0,0,0))  # leave outer margin at bottom
plot(s5, which='continuous')  # see also bpplotM
Key2()           # draw legend at lower left corner of plot
                 # oma= above makes this default key fit the page better

options(digits=3)
w <- latex(s5, npct='both', here=TRUE, file='')

options(grType='plotly')
pbc <- upData(pbc, moveUnits = TRUE)
s <- summaryM(bili + albumin + alk.phos + copper + spiders + sex ~
              drug, data=pbc, test=TRUE)
# Render html
options(prType='html')
s   # invokes print.summaryM
a <- plot(s)
a$Categorical
a$Continuous
plot(s, which='con')
}
}
\keyword{category}
\keyword{interface}
\keyword{hplot}
\keyword{manip}
\concept{grouping}
\concept{stratification}
\concept{aggregation}

\name{capitalize}
\alias{capitalize}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ capitalize the first letter of a string}
\description{
Capitalizes the first letter of each element of the string vector.
}
\usage{
capitalize(string)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{string}{ String to be capitalized }
}
\value{
  Returns a vector of charaters with the first letter capitalized
}
\author{ Charles Dupont }
\examples{
capitalize(c("Hello", "bob", "daN"))
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ manip }
\keyword{ character }% __ONLY ONE__ keyword per line

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Merge.r
\name{Merge}
\alias{Merge}
\title{Merge Multiple Data Frames or Data Tables}
\usage{
Merge(..., id, all = TRUE, verbose = TRUE)
}
\arguments{
\item{\dots}{two or more dataframes or data tables}

\item{id}{a formula containing all the identification variables such that the combination of these variables uniquely identifies subjects or records of interest.  May be omitted for data tables; in that case the \code{key} function retrieves the id variables.}

\item{all}{set to \code{FALSE} to drop observations not found in second and later data frames (only applies if not using \code{data.table})}

\item{verbose}{set to \code{FALSE} to not print information about observations}
}
\description{
Merges an arbitrarily large series of data frames or data tables containing common \code{id} variables (keys for data tables).  Information about number of observations and number of unique \code{id}s in individual and final merged datasets is printed.  The first data frame has special meaning in that all of its observations are kept whether they match \code{id}s in other data frames or not.  For all other data frames, by default non-matching observations are dropped.  The first data frame is also the one against which counts of unique \code{id}s are compared.  Sometimes \code{merge} drops variable attributes such as \code{labels} and \code{units}.  These are restored by \code{Merge}.  If all objects are of class \code{data.table}, faster merging will be done using the \code{data.table} package's join operation.  This assumes that all objects have identical key variables and those of the variables on which to merge.
}
\examples{
\dontrun{
a <- data.frame(sid=1:3, age=c(20,30,40))
b <- data.frame(sid=c(1,2,2), bp=c(120,130,140))
d <- data.frame(sid=c(1,3,4), wt=c(170,180,190))
all <- Merge(a, b, d, id = ~ sid)
# For data.table, first file must be the master file and must
# contain all ids that ever occur.  ids not in the master will
# not be merged from other datasets.
a <- data.table(a); setkey(a, sid)
# data.table also does not allow duplicates without allow.cartesian=TRUE
b <- data.table(sid=1:2, bp=c(120,130)); setkey(b, sid)
d <- data.table(d); setkey(d, sid)
all <- Merge(a, b, d)
}
}

\name{yearDays}
\alias{yearDays}
\alias{monthDays}
\title{ Get Number of Days in Year or Month }
\description{Returns the number of days in a specific year or month.}
\usage{
yearDays(time)

monthDays(time)
}
\arguments{
  \item{time}{
    A POSIXt or Date object describing the month or year in
    question.
  }
}
\author{ Charles Dupont }
\seealso{ \code{\link{POSIXt}}, \code{\link{Date}} }
\keyword{ utilities }
\keyword{ chron }

\name{t.test.cluster}
\alias{t.test.cluster}
\alias{print.t.test.cluster}
\title{t-test for Clustered Data}
\description{
Does a 2-sample t-test for clustered data.
}
\usage{
t.test.cluster(y, cluster, group, conf.int = 0.95)
\method{print}{t.test.cluster}(x, digits, \dots)
}
\arguments{
  \item{y}{normally distributed response variable to test}
  \item{cluster}{cluster identifiers, e.g. subject ID}
  \item{group}{grouping variable with two values}
  \item{conf.int}{confidence coefficient to use for confidence limits}
  \item{x}{an object created by \code{t.test.cluster}}
  \item{digits}{number of significant digits to print}
  \item{\dots}{unused}
}
\value{
  a matrix of statistics of class \code{t.test.cluster}
}
\references{
  Donner A, Birkett N, Buck C, Am J Epi 114:906-914, 1981.

  Donner A, Klar N, J Clin Epi 49:435-439, 1996.
  
  Hsieh FY, Stat in Med 8:1195-1201, 1988.
}
\author{Frank Harrell}
\seealso{\code{\link{t.test}}}
\examples{
set.seed(1)
y <- rnorm(800)
group <- sample(1:2, 800, TRUE)
cluster <- sample(1:40, 800, TRUE)
table(cluster,group)
t.test(y ~ group)   # R only
t.test.cluster(y, cluster, group)
# Note: negate estimates of differences from t.test to
# compare with t.test.cluster
}
\keyword{htest}

\name{num.intercepts}
\alias{num.intercepts}
\title{Extract number of intercepts}
\description{
  Extract the number of intercepts from a model
}
\usage{
num.intercepts(fit, type=c('fit', 'var', 'coef'))
}
\arguments{
  \item{fit}{a model fit object}
  
  \item{type}{
    the default is to return the formal number of intercepts used when fitting
    the model.  Set \code{type='var'} to return the actual number of
    intercepts stored in the \code{var} object, or \code{type='coef'} to
    return the actual number in the fitted coefficients.  The former will be
    less than the number fitted for \code{\link[rms]{orm}} fits, and the
    latter for \code{orm} fits passed through
    \code{\link{fit.mult.impute}}.  If the \code{var} object is not present, the number of intercepts is determined from the \code{ab} element of the \code{info.matrix} object if it is present.
  }
}
\value{
  \code{num.intercepts} returns an integer with the number of intercepts
  in the model.
}
\seealso{
  \code{\link[rms]{orm}}, \code{\link{fit.mult.impute}}
}

\name{transcan}
\alias{transcan}
\alias{summary.transcan}
\alias{print.transcan}
\alias{plot.transcan}
\alias{ggplot.transcan}
\alias{impute.transcan}
\alias{predict.transcan}
\alias{Function}
\alias{Function.transcan}
\alias{fit.mult.impute}
\alias{vcov.default}
\alias{vcov.fit.mult.impute}
\alias{[.transcan}
\alias{invertTabulated}
\title{
  Transformations/Imputations using Canonical Variates
}
\description{
  \code{transcan} is a nonlinear additive transformation and imputation
  function, and there are several functions for using and operating on
  its results.  \code{transcan} automatically transforms continuous and
  categorical variables to have maximum correlation with the best linear
  combination of the other variables.  There is also an option to use a
  substitute criterion - maximum correlation with the first principal
  component of the other variables.  Continuous variables are expanded
  as restricted cubic splines and categorical variables are expanded as
  contrasts (e.g., dummy variables).  By default, the first canonical
  variate is used to find optimum linear combinations of component
  columns.  This function is similar to \code{\link[acepack]{ace}} except that
  transformations for continuous variables are fitted using restricted
  cubic splines, monotonicity restrictions are not allowed, and
  \code{NA}s are allowed.  When a variable has any \code{NA}s,
  transformed scores for that variable are imputed using least squares
  multiple regression incorporating optimum transformations, or
  \code{NA}s are optionally set to constants.  Shrinkage can be used to
  safeguard against overfitting when imputing.  Optionally, imputed
  values on the original scale are also computed and returned.  For this
  purpose, recursive partitioning or multinomial logistic models can
  optionally be used to impute categorical variables, using what is
  predicted to be the most probable category.
  
  By default, \code{transcan} imputes \code{NA}s with \dQuote{best
  guess} expected values of transformed variables, back transformed to
  the original scale. Values thus imputed are most like conditional
  medians assuming the transformations make variables' distributions
  symmetric (imputed values are similar to conditionl modes for
  categorical variables).  By instead specifying \code{n.impute},
  \code{transcan} does approximate multiple imputation from the
  distribution of each variable conditional on all other variables.
  This is done by sampling \code{n.impute} residuals from the
  transformed variable, with replacement (a la bootstrapping), or by
  default, using Rubin's approximate Bayesian bootstrap, where a sample
  of size \var{n} with replacement is selected from the residuals on
  \var{n} non-missing values of the target variable, and then a sample
  of size \var{m} with replacement is chosen from this sample, where
  \var{m} is the number of missing values needing imputation for the
  current multiple imputation  repetition.  Neither of these bootstrap
  procedures assume normality or even symmetry of residuals. For
  sometimes-missing categorical variables, optimal scores are computed
  by adding the \dQuote{best guess} predicted mean score to random
  residuals off this score.  Then categories having scores closest to
  these predicted scores are taken as the random multiple imputations
  (\code{impcat = "rpart"} is not currently allowed
  with \code{n.impute}).  The literature recommends using \code{n.impute
  = 5} or greater. \code{transcan} provides only an approximation to
  multiple imputation, especially since it \dQuote{freezes} the
  imputation model before drawing the multiple imputations rather than
  using different estimates of regression coefficients for each
  imputation.  For multiple imputation, the \code{\link{aregImpute}} function
  provides a much better approximation to the full Bayesian approach
  while still not requiring linearity assumptions.
  
  When you specify \code{n.impute} to \code{transcan} you can use
  \code{fit.mult.impute} to re-fit any model \code{n.impute} times based
  on \code{n.impute} completed datasets (if there are any sometimes
  missing variables not specified to \code{transcan}, some observations
  will still be dropped from these fits).  After fitting \code{n.impute}
  models, \code{fit.mult.impute} will return the fit object from the
  last imputation, with \code{coefficients} replaced by the average of
  the \code{n.impute} coefficient vectors and with a component
  \code{var} equal to the imputation-corrected variance-covariance
  matrix.  \code{fit.mult.impute} can also use the object created by the
  \code{\link[mice]{mice}} function in the \pkg{mice} library to draw the
  multiple imputations, as well as objects created by
  \code{\link{aregImpute}}.  The following components of fit objects are
  also replaced with averages over the \code{n.impute} model fits:
  \code{linear.predictors}, \code{fitted.values}, \code{stats},
  \code{means}, \code{icoef}, \code{scale}, \code{center},
  \code{y.imputed}.
  
  The \code{\link{summary}} method for \code{transcan} prints the function
  call, \eqn{R^2} achieved in transforming each variable, and for each
  variable the coefficients of all other transformed variables that are
  used to estimate the transformation of the initial variable.  If
  \code{imputed=TRUE} was used in the call to transcan, also uses the
  \code{describe} function to print a summary of imputed values.  If
  \code{long = TRUE}, also prints all imputed values with observation
  identifiers.  There is also a simple function \code{print.transcan}
  which merely prints the transformation matrix and the function call.
  It has an optional argument \code{long}, which if set to \code{TRUE}
  causes detailed parameters to be printed.  Instead of plotting while
  \code{transcan} is running, you can plot the final transformations
  after the fact using \code{plot.transcan} or \code{ggplot.transcan},
  if the option \code{trantab  = TRUE} was specified to \code{transcan}.
  If in addition the option 
  \code{imputed = TRUE} was specified to \code{transcan},
  \code{plot} and \code{ggplot} will show the location of imputed values
  (including multiples) along the axes.  For \code{ggplot}, imputed
  values are shown as red plus signs.
  
  \code{\link{impute}} method for \code{transcan} does imputations for a
  selected original data variable, on the original scale (if
  \code{imputed=TRUE} was given to \code{transcan}).  If you do not
  specify a variable to \code{impute}, it will do imputations for all
  variables given to \code{transcan} which had at least one missing
  value.  This assumes that the original variables are accessible (i.e.,
  they have been attached) and that you want the imputed variables to
  have the same names are the original variables. If \code{n.impute} was
  specified to \code{transcan} you must tell \code{\link{impute}} which
  \code{imputation} to use.   Results are stored in \code{.GlobalEnv}
  when \code{list.out} is not specified  (it is recommended to use
  \code{list.out=TRUE}).   
  
  The \code{\link{predict}} method for \code{transcan} computes
  predicted variables and imputed values from a matrix of new data.
  This matrix should have the same column variables as the original
  matrix used with \code{transcan}, and in the same order (unless a
  formula was used with \code{transcan}).
  
  The \code{\link{Function}} function is a generic function
  generator. \code{Function.transcan} creates \R functions to transform
  variables using transformations created by \code{transcan}. These
  functions are useful for getting predicted values with predictors set
  to values on the original scale.
  
  The \code{\link{vcov}} methods are defined here so that
  imputation-corrected variance-covariance matrices are readily
  extracted from \code{fit.mult.impute} objects, and so that
  \code{fit.mult.impute} can easily compute traditional covariance
  matrices for individual completed datasets.
  
  The subscript method for \code{transcan} preserves attributes.

  The \code{invertTabulated} function does either inverse linear
  interpolation or uses sampling to sample qualifying x-values having
  y-values near the desired values.  The latter is used to get inverse
  values having a reasonable distribution (e.g., no floor or ceiling
  effects) when the transformation has a flat or nearly flat segment,
  resulting in a many-to-one transformation in that region.  Sampling
  weights are a combination of the frequency of occurrence of x-values
  that are within \code{tolInverse} times the range of \code{y} and the
  squared distance between the associated y-values and the target
  y-value (\code{aty}).
}
\usage{
transcan(x, method=c("canonical","pc"),
         categorical=NULL, asis=NULL, nk, imputed=FALSE, n.impute,
         boot.method=c('approximate bayesian', 'simple'),
         trantab=FALSE, transformed=FALSE, 
         impcat=c("score", "multinom", "rpart"),
         mincut=40, 
         inverse=c('linearInterp','sample'), tolInverse=.05,
         pr=TRUE, pl=TRUE, allpl=FALSE, show.na=TRUE, 
         imputed.actual=c('none','datadensity','hist','qq','ecdf'),
         iter.max=50, eps=.1, curtail=TRUE, 
         imp.con=FALSE, shrink=FALSE, init.cat="mode", 
         nres=if(boot.method=='simple')200 else 400,
         data, subset, na.action, treeinfo=FALSE, 
         rhsImp=c('mean','random'), details.impcat='', \dots)

\method{summary}{transcan}(object, long=FALSE, digits=6, \dots)

\method{print}{transcan}(x, long=FALSE, \dots)

\method{plot}{transcan}(x, \dots)

\method{ggplot}{transcan}(data, mapping, scale=FALSE, \dots, environment)

\method{impute}{transcan}(x, var, imputation, name, pos.in, data, 
       list.out=FALSE, pr=TRUE, check=TRUE, \dots)

fit.mult.impute(formula, fitter, xtrans, data, n.impute, fit.reps=FALSE,
                dtrans, derived, vcovOpts=NULL, pr=TRUE, subset, \dots)

\method{predict}{transcan}(object, newdata, iter.max=50, eps=0.01, curtail=TRUE,
        type=c("transformed","original"),
        inverse, tolInverse, check=FALSE, \dots)

Function(object, \dots)

\method{Function}{transcan}(object, prefix=".", suffix="", pos=-1, \dots)

invertTabulated(x, y, freq=rep(1,length(x)), 
                aty, name='value',
                inverse=c('linearInterp','sample'),
                tolInverse=0.05, rule=2)

\method{vcov}{default}(object, regcoef.only=FALSE, \dots)

\method{vcov}{fit.mult.impute}(object, regcoef.only=TRUE,
                intercepts='mid', \dots)

}
\arguments{
  \item{x}{
    a matrix containing continuous variable values and codes for
    categorical variables.  The matrix must have column names
    (\code{dimnames}).  If row names are present, they are used in
    forming the \code{names} attribute of imputed values if
    \code{imputed = TRUE}.  \code{x} may also be a formula, in which
    case the model matrix is created automatically, using data in the
    calling frame.  Advantages of using a formula are that
    \verb{categorical} variables can be determined automatically by a
    variable being a \code{\link{factor}} variable, and variables with
    two unique levels are modeled \verb{asis}. Variables with 3 unique
    values are considered to be \verb{categorical} if a formula is
    specified.  For a formula you may also specify that a variable is to
    remain untransformed by enclosing its name with the identify
    function, e.g. \code{I(x3)}.  The user may add other variable names
    to the \code{asis} and \code{categorical} vectors.  For
    \code{invertTabulated}, \code{x} is a vector or a list with three
    components: the x vector, the corresponding vector of transformed
    values, and the corresponding vector of frequencies of the pair of
    original and transformed variables. For \code{print}, \code{plot},
    \code{ggplot}, \code{impute}, and \code{predict}, \code{x} is an
		object created by \code{transcan}.
  }
  \item{formula}{
    any \R model formula
  }
  \item{fitter}{
    any \R, \code{rms}, modeling function (not in quotes) that computes
    a vector of \code{\link{coefficients}} and for which
    \code{\link{vcov}} will return a variance-covariance matrix.  E.g.,
    \code{fitter = \link{lm}}, \code{\link{glm}},
		\code{\link[rms]{ols}}. At present models 
    involving non-regression parameters (e.g., scale parameters in
    parametric survival models) are not handled fully.
  }
  \item{xtrans}{
    an object created by \code{transcan}, \code{\link{aregImpute}}, or
    \code{\link[mice]{mice}}
  }
  \item{method}{
    use \code{method="canonical"} or any abbreviation thereof, to use
    canonical variates (the default). \code{method="pc"} transforms a
    variable instead so as to maximize the correlation with the first
    principal component of the other variables.
  }
  \item{categorical}{
    a character vector of names of variables in \code{x} which are
    categorical, for which the ordering of re-scored values is not
    necessarily preserved. If \code{categorical} is omitted, it is
    assumed that all variables are continuous (or binary).  Set
    \code{categorical="*"} to treat all variables as categorical.
  }
  \item{asis}{
    a character vector of names of variables that are not to be
    transformed. For these variables, the guts of
    \code{\link[stats]{lm.fit}} \code{method="qr"} is used to impute
    missing values. You may want to treat binary variables \verb{asis}
    (this is automatic if using a formula).  If \code{imputed = TRUE},
    you may want to use \samp{"categorical"} for binary variables if you
    want to force imputed values to be one of the original data
    values. Set \code{asis="*"} to treat all variables \verb{asis}.
  }
  \item{nk}{
    number of knots to use in expanding each continuous variable (not
    listed in \code{asis}) in a restricted cubic spline function.
    Default is 3 (yielding 2 parameters for a variable) if
    \eqn{\var{n} < 30}, 4 if
    \eqn{30 <= \var{n} < 100}{30 \eq \var{n} < 100}, and 5 if
    \eqn{\var{n} \ge 100}{\var{n} >= 100} (4 parameters).
  }
  \item{imputed}{
    Set to \code{TRUE} to return a list containing imputed values on the
    original scale. If the transformation for a variable is
    non-monotonic, imputed values are not unique.  \code{transcan} uses
    the \code{\link{approx}} function, which returns the highest value
    of the variable with the transformed score equalling the imputed
    score. \code{imputed=TRUE} also causes original-scale imputed values
    to be shown as tick marks on the top margin of each graph when
    \code{show.na=TRUE} (for the final iteration only). For categorical
    predictors, these imputed values are passed through the
    \code{\link{jitter}} function so that their frequencies can be
    visualized.  When \code{n.impute} is used, each \code{NA} will have
    \code{n.impute} tick marks.
  }
  \item{n.impute}{
    number of multiple imputations.  If omitted, single predicted
    expected value imputation is used.  \code{n.impute=5} is frequently
    recommended.
  }
  \item{boot.method}{
    default is to use the approximate Bayesian bootstrap (sample with
    replacement from sample with replacement of the vector of residuals).
    You can also specify \code{boot.method="simple"} to use the usual
    bootstrap one-stage sampling with replacement.
  }
  \item{trantab}{
    Set to \code{TRUE} to add an attribute \code{trantab} to the
    returned matrix. This contains a vector of lists each with
    components \code{x} and \code{y} containing the unique values and
    corresponding transformed values for the columns of \code{x}.  This
    is set up to be used easily with the \code{\link{approx}} function.
    You must specify \code{trantab=TRUE} if you want to later use the
    \code{predict.transcan} function with \code{type = "original"}.
  }
  \item{transformed}{
    set to \code{TRUE} to cause \code{transcan} to return an object
    \code{transformed} containing the matrix of transformed variables  
  }
  \item{impcat}{
    This argument tells how to impute categorical variables on the
    original scale.  The default is \code{impcat="score"} to impute the
    category whose canonical variate score is closest to the predicted
    score. Use \code{impcat="rpart"} to impute categorical variables
    using the values of all other transformed predictors in conjunction
	with the \code{\link[rpart]{rpart}} function.  A better but somewhat
	slower approach is to 
    use \code{impcat="multinom"} to fit a multinomial logistic model to
    the categorical variable, at the last iteraction of the
    \code{transcan} algorithm.  This uses the \code{\link{multinom}}
    function in the \pkg{nnet} library of the \pkg{MASS} package (which
    is assumed to have been installed by the user) to fit a polytomous
    logistic model to the current working transformations of all the
    other variables (using conditional mean imputation for missing
    predictors).  Multiple imputations are made by drawing multinomial
    values from the vector of predicted probabilities of category
    membership for the missing categorical values.
  }
  \item{mincut}{
    If \code{imputed=TRUE}, there are categorical variables, and
    \code{impcat = "rpart"}, \code{mincut} specifies the lowest node size
    that will be allowed to be split.  The default is 40.
  }
  \item{inverse}{
    By default, imputed values are back-solved on the original scale
    using inverse linear interpolation on the fitted tabulated
    transformed values. This will cause distorted distributions of
    imputed values (e.g., floor and ceiling effects) when the estimated
    transformation has a flat or nearly flat section.  To instead use
    the \code{invertTabulated} function (see above) with the
    \code{"sample"} option, specify \code{inverse="sample"}.  
  }
  \item{tolInverse}{
    the multiplyer of the range of transformed values, weighted by
    \code{freq} and by the distance measure, for determining the set of
    x values having y values within a tolerance of the value of
    \code{aty} in \code{invertTabulated}.  For \code{predict.transcan},
    \code{inverse} and \code{tolInverse} are obtained from options that
    were specified to \code{transcan} by default.  Otherwise, if not
    specified by the user, these default to the defaults used to
    \code{invertTabulated}.
  }
  \item{pr}{
    For \code{transcan}, set to \code{FALSE} to suppress printing
    \eqn{R^2} and shrinkage factors.  Set \code{impute.transcan=FALSE}
    to suppress messages concerning the number of \code{NA} values
    imputed. Set \code{fit.mult.impute=FALSE} to suppress printing
    variance inflation factors accounting for imputation, rate of
    missing information, and degrees of freedom.
  }
  \item{pl}{
    Set to \code{FALSE} to suppress plotting the final transformations
    with distribution of scores for imputed values (if
    \code{show.na=TRUE}).
  }
  \item{allpl}{
    Set to \code{TRUE} to plot transformations for intermediate iterations.
  }
  \item{show.na}{
    Set to \code{FALSE} to suppress the distribution of scores assigned
    to missing values (as tick marks on the right margin of each
    graph). See also \code{imputed}.
  }
  \item{imputed.actual}{
    The default is \samp{"none"} to suppress plotting of actual
    vs. imputed values for all variables having any \code{NA} values.
    Other choices are \samp{"datadensity"} to use
    \code{\link{datadensity}} to make a single plot, \samp{"hist"} to
    make a series of back-to-back histograms, \samp{"qq"} to make a
    series of q-q plots, or \samp{"ecdf"} to make a series of empirical
    cdfs.  For \code{imputed.actual="datadensity"} for example you get a
    rug plot of the non-missing values for the variable with beneath it
    a rug plot of the imputed values. When \code{imputed.actual} is not
    \samp{"none"}, \code{imputed} is automatically set to \code{TRUE}.
  }
  \item{iter.max}{
    maximum number of iterations to perform for \code{transcan} or
    \code{predict}. For \code{\link{predict}}, only one iteration is
    used if there are no \code{NA} values in the data or if
    \code{imp.con} was used.
  }
  \item{eps}{
    convergence criterion for \code{transcan} and \code{\link{predict}}.
    \code{eps} is the maximum change in transformed values from one
    iteration to the next.  If for a given iteration all new
    transformations of variables differ by less than \code{eps} (with or
    without negating the transformation to allow for \dQuote{flipping})
    from the transformations in the previous iteration, one more
    iteration is done for \code{transcan}. During this last iteration,
    individual transformations are not updated but coefficients of
    transformations are.  This improves stability of coefficients of
    canonical variates on the right-hand-side. \code{eps} is ignored
    when \code{rhsImp="random"}.
  }
  \item{curtail}{
    for \code{transcan}, causes imputed values on the transformed scale
    to be truncated so that their ranges are within the ranges of
    non-imputed transformed values. For \code{\link{predict}},
    \code{curtail} defaults to \code{TRUE} to truncate predicted
    transformed values to their ranges in the original fit (\code{xt}).
  }
  \item{imp.con}{
    for \code{transcan}, set to \code{TRUE} to impute \code{NA} values
    on the original scales with constants (medians or most frequent
    category codes).  Set to a vector of constants to instead always use
    these constants for imputation. These imputed values are ignored
    when fitting the current working transformation for asingle
    variable.
  }
  \item{shrink}{
    default is \code{FALSE} to use ordinary least squares or canonical
    variate estimates. For the purposes of imputing \code{NA}s, you may
    want to set \code{shrink=TRUE} to avoid overfitting when developing
    a prediction equation to predict each variables from all the others
    (see details below).
  }
  \item{init.cat}{
    method for initializing scorings of categorical variables.  Default
    is \samp{"mode"} to use a dummy variable set to 1 if the value is
    the most frequent value (this is the default). Use \samp{"random"}
    to use a random 0-1 variable.  Set to \samp{"asis"} to use the
    original integer codes asstarting scores.
  }
  \item{nres}{
    number of residuals to store if \code{n.impute} is specified.  If
    the dataset has fewer than \code{nres} observations, all residuals
    are saved. Otherwise a random sample of the residuals of length
    \code{nres} without replacement is saved.  The default for
    \code{nres} is higher if \code{boot.method="approximate bayesian"}.
  }
  \item{data}{
    Data frame used to fill the formula.  For \code{ggplot} is the
		result of \code{transcan} with \code{trantab=TRUE}.
  }
  \item{subset}{
    an integer or logical vector specifying the subset of observations
    to fit
  }
  \item{na.action}{
    These may be used if \code{x} is a formula.  The default
    \code{na.action} is \code{na.retain} (defined by \code{transcan})
    which keeps all observations with any \code{NA} values. For
    \code{impute.transcan}, \code{data} is a data frame to use as the
    source of variables to be imputed, rather than using
    \code{pos.in}.  For \code{fit.mult.impute}, \code{data} is
    mandatory and is a data frame containing the data to be used in
    fitting the model but before imputations are applied.  Variables
    omitted from \code{data} are assumed to be available from frame1
    and do not need to be imputed.
  }
  \item{treeinfo}{
    Set to \code{TRUE} to get additional information printed when
    \code{impcat="rpart"}, such as the predicted probabilities of
    category membership.
  }
  \item{rhsImp}{
    Set to \samp{"random"} to use random draw imputation when a
    sometimes missing variable is moved to be a predictor of other
    sometimes missing variables.  Default is \code{rhsImp="mean"}, which
    uses conditional mean imputation on the transformed scale.
    Residuals used are residuals from the transformed scale.  When
    \samp{"random"} is used, \code{transcan} runs 5 iterations and
    ignores \code{eps}.
  }
  \item{details.impcat}{
    set to a character scalar that is the name of a category variable to
    include in the resulting \code{transcan} object an element
    \code{details.impcat} containing details of how the categorical
    variable was multiply imputed.
  }
  \item{\dots}{
    arguments passed to \code{\link{scat1d}} or to the \code{fitter}
    function (for \code{fit.mult.impute}).  For \code{ggplot.transcan},
		these arguments are passed to \code{facet_wrap}, e.g. \code{ncol=2}.
  }
  \item{long}{
    for \code{\link{summary}}, set to \code{TRUE} to print all imputed
    values. For \code{\link{print}}, set to \code{TRUE} to print details
    of transformations/imputations.  
  }
  \item{digits}{
    number of significant digits for printing values by
    \code{\link{summary}}
  }
	\item{scale}{for \code{ggplot.transcan} set \code{scale=TRUE} to
		scale transformed values to [0,1] before plotting.}
	\item{mapping,environment}{not used; needed because of rules about generics}
  \item{var}{
    For \code{\link{impute}}, is a variable that was originally a column
    in \code{x}, for which imputated values are to be filled
    in. \code{imputed=TRUE} must have been used in \code{transcan}.
    Omit \code{var} to impute all variables, creating new variables in
    position \code{pos} (see \code{\link{assign}}).
  }
  \item{imputation}{
    specifies which of the multiple imputations to use for filling in
    \code{NA} values
  }
  \item{name}{
    name of variable to impute, for \code{\link{impute}} function.
    Default is character string version of the second argument
    (\code{var}) in the call to \code{\link{impute}}. For
    \code{invertTabulated}, is the name of variable being transformed
    (used only for warning messages).
  }
  \item{pos.in}{
    location as defined by \code{\link{assign}} to find variables that
	need to be 
    imputed, when all variables are to be imputed automatically by
    \code{impute.transcan} (i.e., when no input variable name is
    specified).  Default is position that contains
    the first variable to be imputed.
  }
  \item{list.out}{
    If \code{var} is not specified, you can set \code{list.out=TRUE} to
    have \code{impute.transcan} return a list containing variables with
    needed values imputed.  This list will contain a single imputation.
    Variables not needing imputation are copied to the list as-is.  You
    can use this list for analysis just like a data frame.
  }
  \item{check}{
    set to \code{FALSE} to suppress certain warning messages
  }
  \item{newdata}{
    a new data matrix for which to compute transformed
    variables. Categorical variables must use the same integer codes as
    were used in the call to \code{transcan}.  If a formula was
    originally specified to \code{transcan} (instead of a data matrix),
    \code{newdata} is optional and if given must be a data frame; a
    model frame is generated automatically from the previous formula.
    The \code{na.action} is handled automatically, and the levels for
    factor variables must be the same and in the same order as were used
    in the original variables specified in the formula given to
    \code{transcan}.
  }
  \item{fit.reps}{
    set to \code{TRUE} to save all fit objects from the fit for each
    imputation in \code{fit.mult.impute}.  Then the object returned will
    have a component \code{fits} which is a list whose \var{i}th
    element is the \var{i}th fit object. 
  }
  \item{dtrans}{
    provides an approach to creating derived variables from a single
    filled-in dataset.  The function specified as \code{dtrans} can even
    reshape the imputed dataset.  An example of such usage is fitting
    time-dependent covariates in a Cox model that are created by
    \dQuote{start,stop} intervals.  Imputations may be done on a one
    record per subject data frame that is converted by \code{dtrans} to
    multiple records per subject.  The imputation can enforce
    consistency of certain variables across records so that for example
    a missing value of \var{sex} will not be imputed as \samp{male} for
    one of the subject's records and \samp{female} as another.  An
    example of how \code{dtrans} might be specified is
    \code{dtrans=function(w) \{w$age <- w$years + w$months/12; w\}}
    where \code{months} might havebeen imputed but \code{years} was
    never missing.  An outline for using `dtrans` to impute missing
		baseline variables in a longitudinal analysis appears in Details below.
  }
  \item{derived}{
    an expression containing \R expressions for computing derived
    variables that are used in the model formula.  This is useful when
    multiple imputations are done for component variables but the actual
    model uses combinations of these (e.g., ratios or other
    derivations). For a single derived variable you can specify for
    example \code{derived=expression(ratio <- weight/height)}.  For
    multiple derived variables use the form
    \code{derived=expression(\{ratio <- weight/height; product <-
      weight*height\})} or put the expression on separate input lines.
    To monitor the multiply-imputed derived variables you can add to the
    \code{expression} a command such as \code{print(describe(ratio))}.
    See the example below.  Note that \code{derived} is not yet
    implemented.  
  }
	\item{vcovOpts}{a list of named additional arguments to pass to the
		\code{vcov} method for \code{fitter}.  Useful for \code{orm} models
		for retaining all intercepts
		(\code{vcovOpts=list(intercepts='all')}) instead of just the middle one.}
  \item{type}{
    By default, the matrix of transformed variables is returned, with
    imputed values on the transformed scale.  If you had specified
    \code{trantab=TRUE} to \code{transcan}, specifying
    \code{type="original"} does the table look-ups with linear
    interpolation to return the input matrix \code{x} but with imputed
    values on the original scale inserted for \code{NA} values.  For
    categorical variables, the method used here is to select the
    category code having a corresponding scaled value closest to the
    predicted transformed value.  This corresponds to the default
    \code{impcat}.  Note: imputed values
    thus returned when \code{type="original"} are single expected value
   imputations even in \code{n.impute} is given.
 }
 \item{object}{
   an object created by \code{transcan}, or an object to be converted to
   \R function code, typically a model fit object of some sort  
 }
 \item{prefix, suffix}{
   When creating separate \R functions for each variable in \code{x},
   the name of the new function will be \code{prefix} placed in front of
   the variable name, and \code{suffix} placed in back of the name.  The
   default is to use names of the form \samp{.varname}, where
   \var{varname} is the variable name.
 }
 \item{pos}{
   position as in \code{\link{assign}} at which to store new functions
   (for \code{\link{Function}}). Default is \code{pos=-1}.
 }
 \item{y}{
   a vector corresponding to \code{x} for \code{invertTabulated}, if its
   first argument \code{x} is not a list
 }
 \item{freq}{
   a vector of frequencies corresponding to cross-classified \code{x}
   and \code{y} if \code{x} is not a list.  Default is a vector of ones.
 }
 \item{aty}{
   vector of transformed values at which inverses are desired
 }
 \item{rule}{
   see \code{\link{approx}}.  \code{transcan} assumes \code{rule} is
   always 2.
 }
 \item{regcoef.only}{
   set to \code{TRUE} to make \code{vcov.default} delete positions in
   the covariance matrix for any non-regression coefficients (e.g., log
   scale parameter from \code{\link[rms]{psm}} or \code{\link{survreg}})
 }
 \item{intercepts}{this is primarily for \code{\link[rms]{orm}}
	 objects.  Set to \code{"none"} to discard all intercepts from the
	 covariance matrix, or to \code{"all"} or \code{"mid"} to keep all
	 elements generated by \code{orm} (\code{orm} only outputs the
	 covariance matrix for the intercept corresponding to the median).
	 You can also set \code{intercepts} to a vector of subscripts for
	 selecting particular intercepts in a multi-intercept model.}
}
\value{
  For \code{transcan}, a list of class \samp{transcan} with elements
  \item{call}{ (with the function call)}
  \item{iter}{ (number of  iterations done)}
  \item{rsq, rsq.adj}{
    containing the \eqn{R^2}{R-square}s and adjusted
    \eqn{R^2}{R-square}s achieved in predicting each variable from all
    the others
  }
  \item{categorical}{
    the values supplied for \code{categorical}
  }
  \item{asis}{
    the values supplied for \code{asis}
  }
  \item{coef}{
    the within-variable coefficients used to compute the first
    canonical variate
  }
  \item{xcoef}{
    the (possibly shrunk) across-variables coefficients of the first
    canonical variate that predicts each variable in-turn.
  }
  \item{parms}{
    the parameters of the transformation (knots for splines, contrast
    matrix for categorical variables)  
  }
  \item{fillin}{
    the initial estimates for missing values (\code{NA} if variable
    never missing)
  }
  \item{ranges}{
    the matrix of ranges of the transformed variables (min and max in
    first and secondrow)
  }
  \item{scale}{
    a vector of scales used to determine convergence for a
    transformation.
  }
  \item{formula}{
    the formula (if \code{x} was a formula)
  }
  , and optionally a vector of shrinkage factors used for predicting
  each variable from the others.  For \code{asis} variables, the scale
  is the average absolute difference about the median.  For other
  variables it is unity, since canonical variables are standardized.
  For \code{xcoef}, row \var{i} has the coefficients to predict
  transformed variable \var{i}, with the column for the coefficient of
  variable \var{i} set to \code{NA}.  If \code{imputed=TRUE} was given,
  an optional element \code{imputed} also appears.  This is a list with
  the vector of imputed values (on the original scale) for each variable
  containing \code{NA}s.  Matrices rather than vectors are returned if
  \code{n.impute} is given.  If \code{trantab=TRUE}, the \code{trantab}
  element also appears, as described above.  If \code{n.impute > 0},
  \code{transcan} also returns a list \code{residuals} that can be used
  for future multiple imputation.
  
  \code{impute} returns a vector (the same length as \code{var}) of
  class \samp{impute} with \code{NA} values imputed.  

  \code{predict} returns a matrix with the same number of columns or
  variables as were in \code{x}.
  
  \code{fit.mult.impute} returns a fit object that is a modification of
  the fit object created by fitting the completed dataset for the final
  imputation.  The \code{var} matrix in the fit object has the
  imputation-corrected variance-covariance matrix.  \code{coefficients}
  is the average (over imputations) of the coefficient vectors,
  \code{variance.inflation.impute} is a vector containing the ratios of
  the diagonals of the between-imputation variance matrix to the
  diagonals of the average apparent (within-imputation) variance
  matrix. \code{missingInfo} is
  \cite{Rubin's rate of missing information} and \code{dfmi} is
  \cite{Rubin's degrees of freedom for a t-statistic}
  for testing a single parameter.  The last two objects are vectors
  corresponding to the diagonal of the variance matrix.  The class
  \code{"fit.mult.impute"} is prepended to the other classes produced by
  the fitting function.

	\code{fit.mult.impute} stores \code{intercepts} attributes in the
	coefficient matrix and in \code{var} for \code{orm} fits.
}
\section{Side Effects}{
  prints, plots, and \code{impute.transcan} creates new variables.
}
\details{
  The starting approximation to the transformation for each variable is
  taken to be the original coding of the variable.  The initial
  approximation for each missing value is taken to be the median of the
  non-missing values for the variable (for continuous ones) or the most
  frequent category (for categorical ones).  Instead, if \code{imp.con}
  is a vector, its values are used for imputing \code{NA} values.  When
  using each variable as a dependent variable, \code{NA} values on that
  variable cause all observations to be temporarily deleted.  Once a new
  working transformation is found for the variable, along with a model
  to predict that transformation from all the other variables, that
  latter model is used to impute \code{NA} values in the selected
  dependent variable if \code{imp.con} is not specified.
  
  When that variable is used to predict a new dependent variable, the
  current working imputed values are inserted.  Transformations are
  updated after each variable becomes a dependent variable, so the order
  of variables on \code{x} could conceivably make a difference in the
  final estimates.  For obtaining out-of-sample
  predictions/transformations, \code{\link{predict}} uses the same
  iterative procedure as \code{transcan} for imputation, with the same
  starting values for fill-ins as were used by \code{transcan}.  It also
  (by default) uses a conservative approach of curtailing transformed
  variables to be within the range of the original ones. Even when
  \code{method = "pc"} is specified, canonical variables are used for
  imputing missing values.
  
  Note that fitted transformations, when evaluated at imputed variable
  values (on the original scale), will not precisely match the
  transformed imputed values returned in \code{xt}.  This is because
  \code{transcan} uses an approximate method based on linear
  interpolation to back-solve for imputed values on the original scale.
  
  Shrinkage uses the method of
  \cite{Van Houwelingen and Le Cessie (1990)} (similar to
  \cite{Copas, 1983}).  The shrinkage factor is
  \deqn{\frac{1-\frac{(1-\var{R2})(\var{n}-1)}{\var{n}-\var{k}-1}}{\var{R2}}}{%
    [1 - (1 - \var{R2})(\var{n} - 1)/(\var{n} - \var{k} - 1)]/\var{R2}}
  where \var{R2} is the apparent \eqn{R^2}{R-square}d for predicting the
  variable, \var{n} is the number of non-missing values, and \var{k} is
  the effective number of degrees of freedom (aside from intercepts).  A
  heuristic estimate is used for \var{k}:
  \code{\var{A} - 1 + sum(max(0,\var{Bi} - 1))/\var{m} + \var{m}}, where
  \var{A} is the number of d.f. required to represent the variable being
  predicted, the \var{Bi} are the number of columns required to
  represent all the other variables, and \var{m} is the number of all
  other variables.  Division by \var{m} is done because the
  transformations for the other variables are fixed at their current
  transformations the last time they were being predicted.  The
  \eqn{+ \var{m}} term comes from the number of coefficients estimated
  on the right hand side, whether by least squares or canonical
  variates.  If a shrinkage factor is negative, it is set to 0.  The
  shrinkage factor is the ratio of the adjusted \eqn{R^2}{R-square}d to
  the ordinary \eqn{R^2}{R-square}d. The adjusted \eqn{R^2}{R-square}d is
  \deqn{1-\frac{(1-\var{R2})(\var{n}-1)}{\var{n}-\var{k}-1}}{
    1 - (1 - R2)(n - 1)/(n - k - 1)}
  which is also set to zero if it is negative.  If \code{shrink=FALSE}
  and the adjusted \eqn{R^2}{R-square}s are much smaller than the
  ordinary \eqn{R^2}{R-square}s, you may want to run \code{transcan}
  with \code{shrink=TRUE}.
 
  Canonical variates are scaled to have variance of 1.0, by multiplying
  canonical coefficients from \code{\link{cancor}} by 
  \eqn{\sqrt{\var{n}-1}}{sqrt(\var{n} - 1)}.

  When specifying a non-\pkg{rms} library fitting function to
  \code{fit.mult.impute} (e.g., \code{\link{lm}}, \code{\link{glm}}),
  running the result of \code{fit.mult.impute} through that fit's
  \code{\link{summary}} method will not use the imputation-adjusted
  variances.  You may obtain the new variances using \code{fit$var} or
  \code{vcov(fit)}.
  
  When you specify a \pkg{rms} function to \code{fit.mult.impute} (e.g.
  \code{\link[rms]{lrm}}, \code{\link[rms]{ols}}, \code{\link[rms]{cph}},
  \code{\link[rms]{psm}}, \code{\link[rms]{bj}}, \code{\link[rms]{Rq}},
  \code{\link[rms]{Gls}}, \code{\link[rms]{Glm}}), automatically computed
  transformation  parameters (e.g., knot locations for
  \code{\link[rms]{rcs}}) that are estimated for the first imputation are
  used for all other imputations.  This ensures that knot locations will
  not vary, which would change the meaning of the regression
  coefficients.
  
  Warning: even though \code{fit.mult.impute} takes imputation into
  account when estimating variances of regression coefficient, it does
  not take into account the variation that results from estimation of
  the shapes and regression coefficients of the customized imputation
  equations. Specifying \code{shrink=TRUE} solves a small part of this
  problem.  To fully account for all sources of variation you should
  consider putting the \code{transcan} invocation inside a bootstrap or
  loop, if execution time allows.  Better still, use
  \code{\link{aregImpute}} or a package such as  as \pkg{mice} that uses
  real Bayesian posterior realizations to multiply impute missing values
  correctly.
  
  It is strongly recommended that you use the \pkg{Hmisc} \code{\link{naclus}}
  function to determine is there is a good basis for imputation.
  \code{\link{naclus}} will tell you, for example, if systolic blood
  pressure is missing whenever diastolic blood pressure is missing.  If
  the only variable that is well correlated with diastolic bp is
  systolic bp, there is no basis for imputing diastolic bp in this case.
  
  At present, \code{predict} does not work with multiple imputation.

  When calling \code{fit.mult.impute} with \code{\link{glm}} as the
  \code{fitter} argument, if you need to pass a \code{family} argument
  to \code{\link{glm}} do it by quoting the family, e.g.,
  \code{family="binomial"}.
  
  \code{fit.mult.impute} will not work with proportional odds models
  when regression imputation was used (as opposed to predictive mean
  matching).  That's because regression imputation will create values of
  the response variable that did not exist in the dataset, altering the
  intercept terms in the model.
  
  You should be able to use a variable in the formula given to
  \code{fit.mult.impute} as a numeric variable in the regression model
  even though it was a factor variable in the invocation of
  \code{transcan}.  Use for example \code{fit.mult.impute(y ~ codes(x),
    lrm, trans)} (thanks to Trevor Thompson
  \email{trevor@hp5.eushc.org}).

	Here is an outline of the steps necessary to impute baseline variables
	using the \code{dtrans} argument, when the analysis to be repeated by
	\code{fit.mult.impute} is a longitudinal analysis (using
	e.g. \code{Gls}).
	\enumerate{
		\item Create a one row per subject data frame containing baseline
	variables plus follow-up variables that are assigned to windows.  For
	example, you may have dozens of repeated measurements over years but
	you capture the measurements at the times measured closest to 1, 2,
	and 3 years after study entry
	\item Make sure the dataset contains the subject ID
	\item This dataset becomes the one passed to \code{aregImpute} as
	\code{data=}.  You will be imputing missing baseline variables from
	follow-up measurements defined at fixed times.
	\item Have another dataset with all the non-missing follow-up values
	on it, one record per measurement time per subject.  This dataset
	should not have the baseline variables on it, and the follow-up
	measurements should not be named the same as the baseline variable(s);
	the subject ID must also appear
	\item Add the dtrans argument to \code{fit.mult.impute} to define a
	function with one argument representing the one record per subject
	dataset with missing values filled it from the current imputation.
	This function merges the above 2 datasets; the returned value of this
	function is the merged data frame.
	\item This merged-on-the-fly dataset is the one handed by \code{fit.mult.impute} to your fitting function, so  variable names in the formula given to \code{fit.mult.impute} must matched the names created by the merge
		}
}
\author{
  Frank Harrell  \cr
  Department of Biostatistics  \cr
  Vanderbilt University  \cr
  \email{fh@fharrell.com}
}
\references{
  Kuhfeld, Warren F: The PRINQUAL Procedure.  SAS/STAT User's Guide, Fourth
  Edition, Volume 2, pp. 1265--1323, 1990.

  Van Houwelingen JC, Le Cessie S: Predictive value of statistical models.
  Statistics in Medicine 8:1303--1325, 1990.

  Copas JB: Regression, prediction and shrinkage. JRSS B 45:311--354, 1983.

  He X, Shen L: Linear regression after spline transformation.
  Biometrika 84:474--481, 1997.

  Little RJA, Rubin DB: Statistical Analysis with Missing Data.  New
  York: Wiley, 1987.

  Rubin DJ, Schenker N: Multiple imputation in health-care databases: An
  overview and some applications.  Stat in Med 10:585--598, 1991.

  Faris PD, Ghali WA, et al:Multiple imputation versus data enhancement
  for dealing with missing data in observational health care outcome
  analyses.  J Clin Epidem 55:184--191, 2002.
}
\seealso{
  \code{\link{aregImpute}}, \code{\link{impute}}, \code{\link{naclus}},
  \code{\link{naplot}}, \code{\link[acepack]{ace}},
  \code{\link[acepack]{avas}}, \code{\link{cancor}},
  \code{\link{prcomp}}, \code{\link{rcspline.eval}},
  \code{\link{lsfit}}, \code{\link{approx}}, \code{\link{datadensity}},
  \code{\link[mice]{mice}}, \code{\link[ggplot2]{ggplot}}
}
\examples{
\dontrun{
x <- cbind(age, disease, blood.pressure, pH)  
#cbind will convert factor object `disease' to integer
par(mfrow=c(2,2))
x.trans <- transcan(x, categorical="disease", asis="pH",
                    transformed=TRUE, imputed=TRUE)
summary(x.trans)  #Summary distribution of imputed values, and R-squares
f <- lm(y ~ x.trans$transformed)   #use transformed values in a regression
#Now replace NAs in original variables with imputed values, if not
#using transformations
age            <- impute(x.trans, age)
disease        <- impute(x.trans, disease)
blood.pressure <- impute(x.trans, blood.pressure)
pH             <- impute(x.trans, pH)
#Do impute(x.trans) to impute all variables, storing new variables under
#the old names
summary(pH)       #uses summary.impute to tell about imputations
                  #and summary.default to tell about pH overall
# Get transformed and imputed values on some new data frame xnew
newx.trans     <- predict(x.trans, xnew)
w              <- predict(x.trans, xnew, type="original")
age            <- w[,"age"]            #inserts imputed values
blood.pressure <- w[,"blood.pressure"]
Function(x.trans)  #creates .age, .disease, .blood.pressure, .pH()
#Repeat first fit using a formula
x.trans <- transcan(~ age + disease + blood.pressure + I(pH), 
                    imputed=TRUE)
age <- impute(x.trans, age)
predict(x.trans, expand.grid(age=50, disease="pneumonia",
        blood.pressure=60:260, pH=7.4))
z <- transcan(~ age + factor(disease.code),  # disease.code categorical
              transformed=TRUE, trantab=TRUE, imputed=TRUE, pl=FALSE)
ggplot(z, scale=TRUE)
plot(z$transformed)
}


# Multiple imputation and estimation of variances and covariances of
# regression coefficient estimates accounting for imputation
set.seed(1)
x1 <- factor(sample(c('a','b','c'),100,TRUE))
x2 <- (x1=='b') + 3*(x1=='c') + rnorm(100)
y  <- x2 + 1*(x1=='c') + rnorm(100)
x1[1:20] <- NA
x2[18:23] <- NA
d <- data.frame(x1,x2,y)
n <- naclus(d)
plot(n); naplot(n)  # Show patterns of NAs
f  <- transcan(~y + x1 + x2, n.impute=10, shrink=FALSE, data=d)
options(digits=3)
summary(f)


f  <- transcan(~y + x1 + x2, n.impute=10, shrink=TRUE, data=d)
summary(f)


h <- fit.mult.impute(y ~ x1 + x2, lm, f, data=d)
# Add ,fit.reps=TRUE to save all fit objects in h, then do something like:
# for(i in 1:length(h$fits)) print(summary(h$fits[[i]]))


diag(vcov(h))


h.complete <- lm(y ~ x1 + x2, na.action=na.omit)
h.complete
diag(vcov(h.complete))


# Note: had the rms ols function been used in place of lm, any
# function run on h (anova, summary, etc.) would have automatically
# used imputation-corrected variances and covariances


# Example demonstrating how using the multinomial logistic model
# to impute a categorical variable results in a frequency
# distribution of imputed values that matches the distribution
# of non-missing values of the categorical variable


\dontrun{
set.seed(11)
x1 <- factor(sample(letters[1:4], 1000,TRUE))
x1[1:200] <- NA
table(x1)/sum(table(x1))
x2 <- runif(1000)
z  <- transcan(~ x1 + I(x2), n.impute=20, impcat='multinom')
table(z$imputed$x1)/sum(table(z$imputed$x1))

# Here is how to create a completed dataset
d <- data.frame(x1, x2)
z <- transcan(~x1 + I(x2), n.impute=5, data=d)
imputed <- impute(z, imputation=1, data=d,
                  list.out=TRUE, pr=FALSE, check=FALSE)
sapply(imputed, function(x)sum(is.imputed(x)))
sapply(imputed, function(x)sum(is.na(x)))
}

# Example where multiple imputations are for basic variables and
# modeling is done on variables derived from these


set.seed(137)
n <- 400
x1 <- runif(n)
x2 <- runif(n)
y  <- x1*x2 + x1/(1+x2) + rnorm(n)/3
x1[1:5] <- NA
d <- data.frame(x1,x2,y)
w <- transcan(~ x1 + x2 + y, n.impute=5, data=d)
# Add ,show.imputed.actual for graphical diagnostics
\dontrun{
g <- fit.mult.impute(y ~ product + ratio, ols, w,
                     data=data.frame(x1,x2,y),
                     derived=expression({
                       product <- x1*x2
                       ratio   <- x1/(1+x2)
                       print(cbind(x1,x2,x1*x2,product)[1:6,])}))
}


# Here's a method for creating a permanent data frame containing
# one set of imputed values for each variable specified to transcan
# that had at least one NA, and also containing all the variables
# in an original data frame.  The following is based on the fact
# that the default output location for impute.transcan is
# given by the global environment


\dontrun{
xt <- transcan(~. , data=mine,
               imputed=TRUE, shrink=TRUE, n.impute=10, trantab=TRUE)
attach(mine, use.names=FALSE)
impute(xt, imputation=1) # use first imputation
# omit imputation= if using single imputation
detach(1, 'mine2')
}


# Example of using invertTabulated outside transcan
x    <- c(1,2,3,4,5,6,7,8,9,10)
y    <- c(1,2,3,4,5,5,5,5,9,10)
freq <- c(1,1,1,1,1,2,3,4,1,1)
# x=5,6,7,8 with prob. .1 .2 .3 .4 when y=5
# Within a tolerance of .05*(10-1) all y's match exactly
# so the distance measure does not play a role
set.seed(1)      # so can reproduce
for(inverse in c('linearInterp','sample'))
 print(table(invertTabulated(x, y, freq, rep(5,1000), inverse=inverse)))


# Test inverse='sample' when the estimated transformation is
# flat on the right.  First show default imputations
set.seed(3)
x <- rnorm(1000)
y <- pmin(x, 0)
x[1:500] <- NA
for(inverse in c('linearInterp','sample')) {
par(mfrow=c(2,2))
  w <- transcan(~ x + y, imputed.actual='hist',
                inverse=inverse, curtail=FALSE,
                data=data.frame(x,y))
  if(inverse=='sample') next
# cat('Click mouse on graph to proceed\n')
# locator(1)
}
}
\keyword{smooth}
\keyword{regression}
\keyword{multivariate}
\keyword{methods}
\keyword{models}
\concept{bootstrap}
% Converted by Sd2Rd version 1.21.

\name{pstamp}
\alias{pstamp}
\title{Date/Time/Directory Stamp the Current Plot}
\description{
Date-time stamp the current plot in the extreme lower right
corner. Optionally add the current working directory and arbitrary other
text to the stamp.
}
\usage{
pstamp(txt, pwd = FALSE, time. = TRUE)
}
\arguments{
  \item{txt}{an optional single text string}
  \item{pwd}{set to \code{TRUE} to add the current working directory
	name to the stamp}
  \item{time.}{set to \code{FALSE} to use the date without the time}
}
\details{
  Certain functions are not supported for S-Plus under Windows.  For \R,
  results may not be satisfactory if \code{par(mfrow=)} is in effect.
}
\author{Frank Harrell}
\examples{
plot(1:20)
pstamp(pwd=TRUE, time=FALSE)
}
\keyword{aplot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simMarkovOrd.r
\name{soprobMarkovOrd}
\alias{soprobMarkovOrd}
\title{soprobMarkovOrd}
\usage{
soprobMarkovOrd(y, times, initial, absorb = NULL, intercepts, g, ...)
}
\arguments{
\item{y}{a vector of possible y values in order (numeric, character, factor)}

\item{times}{vector of measurement times}

\item{initial}{initial value of \code{y} (baseline state; numeric, character, factr)}

\item{absorb}{vector of absorbing states, a subset of \code{y}.  The default is no absorbing states. (numeric, character, factor)}

\item{intercepts}{vector of intercepts in the proportional odds model, with length one less than the length of \code{y}}

\item{g}{a user-specified function of three or more arguments which in order are \code{yprev} - the value of \code{y} at the previous time, the current time \code{t}, the \code{gap} between the previous time and the current time, an optional (usually named) covariate vector \code{X}, and optional arguments such as a regression coefficient value to simulate from.  The function needs to allow \code{yprev} to be a vector and \code{yprev} must not include any absorbing states.  The \code{g} function returns the linear predictor for the proportional odds model aside from \code{intercepts}.  The returned value must be a matrix with row names taken from \code{yprev}.  If the model is a proportional odds model, the returned value must be one column.  If it is a partial proportional odds model, the value must have one column for each distinct value of the response variable Y after the first one, with the levels of Y used as optional column names.  So columns correspond to \code{intercepts}. The different columns are used for \code{y}-specific contributions to the linear predictor (aside from \code{intercepts}) for a partial or constrained partial proportional odds model.  Parameters for partial proportional odds effects may be included in the ... arguments.}

\item{...}{additional arguments to pass to \code{g} such as covariate settings}
}
\value{
matrix with rows corresponding to times and columns corresponding to states, with values equal to exact state occupancy probabilities
}
\description{
State Occupancy Probabilities for First-Order Markov Ordinal Model
}
\seealso{
\url{https://hbiostat.org/R/Hmisc/markov/}
}
\author{
Frank Harrell
}

\name{latexTherm}
\alias{latexTherm}
\alias{latexNeedle}
\alias{pngNeedle}
\title{Create LaTeX Thermometers and Colored Needles}
\description{
\code{latexTherm} creates a LaTeX picture environment for drawing a
series of thermometers 
whose heights depict the values of a variable \code{y} assumed to be
scaled from 0 to 1.  This is useful for showing fractions of sample
analyzed in any table or plot, intended for a legend.  For example, four
thermometers might be used to depict the fraction of enrolled patients
included in the current analysis, the fraction randomized, the fraction
of patients randomized to treatment A being analyzed, and the fraction
randomized to B being analyzed.  The picture is placed
inside a LaTeX macro definition for macro variable named \code{name}, to
be invoked by the user later in the LaTeX file using \code{name}
preceeded by a backslash.

If \code{y} has an attribute \code{"table"}, it is assumed to contain a
character string with LaTeX code.  This code is used as a tooltip popup
for PDF using the LaTeX \code{ocgtools} package or using style
\code{tooltips}.  Typically the code will contain a \code{tabular}
environment.  The user must define a LaTeX macro \code{tooltipn} that
takes two arguments (original object and pop-up object) that does
the pop-up.

\code{latexNeedle} is similar to \code{latexTherm} except that vertical
needles are produced and each may have its own color.  A grayscale box
is placed around the needles and provides the 0-1 \code{y}-axis
reference.  Horizontal grayscale grid lines may be drawn.

\code{pngNeedle} is similar to \code{latexNeedle} but is for generating
small png graphics.  The full graphics file name is returned invisibly.
}
\usage{
latexTherm(y, name, w = 0.075, h = 0.15, spacefactor = 1/2, extra = 0.07,
           file = "", append = TRUE)

latexNeedle(y, x=NULL, col='black', href=0.5, name, w=.05, h=.15,
            extra=0, file = "", append=TRUE)

pngNeedle(y, x=NULL, col='black', href=0.5, lwd=3.5, w=6, h=18,
          file=tempfile(fileext='.png'))
}
\arguments{
  \item{y}{a vector of 0-1 scaled values.  Boxes and their frames are
		omitted for \code{NA} elements}
	\item{x}{a vector corresponding to \code{y} giving x-coordinates.
          Scaled accordingly, or defaults to equally-spaced values.}
  \item{name}{name of LaTeX macro variable to be defined}
  \item{w}{width of a single box (thermometer) in inches.  For
    \code{latexNeedle} and \code{pngNeedle} is the spacing between
          needles, the latter being in pixels.}
  \item{h}{height of a single box in inches.  For \code{latexNeedle} and
          \code{pngNeedle} is the height of the frame, the latter in pixels.}
  \item{spacefactor}{fraction of \code{w} added for extra space between
    boxes for \code{latexTherm}}
  \item{extra}{extra space in inches to set aside to the right of and
		above the series of boxes or frame}
  \item{file}{name of file to which to write LaTeX code.  Default is the
    console.  Also used as base file name for png graphic.  Default for
          that is from \code{tempfile}.}
  \item{append}{set to \code{FALSE} to write over \code{file}}
	\item{col}{a vector of colors corresponding to positions in \code{y}.
    \code{col} is repeated if too short.}
	\item{href}{values of \code{y} (0-1) for which horizontal grayscale
    reference lines are drawn for \code{latexNeedle} and
          \code{pngNeedle}.  Set to 
					\code{NULL} to not draw any reference lines}
  \item{lwd}{line width of needles for \code{pngNeedle}}
}
\author{Frank Harrell}
\examples{
\dontrun{
# The following is in the Hmisc tests directory
# For a knitr example see latexTherm.Rnw in that directory
ct <- function(...) cat(..., sep='')
ct('\\documentclass{report}\\begin{document}\n')
latexTherm(c(1, 1, 1, 1), name='lta')
latexTherm(c(.5, .7, .4, .2), name='ltb')
latexTherm(c(.5, NA, .75, 0), w=.3, h=1, name='ltc', extra=0)
latexTherm(c(.5, NA, .75, 0), w=.3, h=1, name='ltcc')
latexTherm(c(0, 0, 0, 0), name='ltd')
ct('This is a the first:\\lta and the second:\\ltb\\\\ and the third
without extra:\\ltc END\\\\\nThird with extra:\\ltcc END\\\\ 
\\vspace{2in}\\\\ 
All data = zero, frame only:\\ltd\\\\
\\end{document}\n')
w <- pngNeedle(c(.2, .5, .7))
cat(tobase64image(w))  # can insert this directly into an html file
}}
\keyword{utilities}
\keyword{interface}
\keyword{file}
\keyword{character}
\keyword{manip}

\name{mgp.axis}
\alias{mgp.axis}
\alias{mgp.axis.labels}
\title{Draw Axes With Side-Specific mgp Parameters}
\description{
\code{mgp.axis} is a version of \code{axis} that uses the appropriate
side-specific \code{mgp} parameter (see \code{\link{par}}) to account
for different space requirements for axis labels vertical vs. horizontal
tick marks.  \code{mgp.axis} also fixes a bug in \code{axis(2,\dots)}
that causes it to assume \code{las=1}.

\code{mgp.axis.labels} is used so that different spacing between tick
marks and axis tick mark labels may be specified for x- and y-axes.  Use
\code{mgp.axis.labels('default')} to set defaults. Users can set values
manually using \code{mgp.axis.labels(x,y)} where \code{x} and \code{y}
are 2nd value of \code{par('mgp')} to use.  Use
\code{mgp.axis.labels(type=w)} to retrieve values, where \code{w='x'},
\code{'y'}, \code{'x and y'}, \code{'xy'}, to get 3 \code{mgp} values
(first 3 types) or 2 \code{mgp.axis.labels}.
}
\usage{
mgp.axis(side, at = NULL, \dots,
         mgp = mgp.axis.labels(type = if (side == 1 | side == 3) "x"
                               else "y"),
         axistitle = NULL, cex.axis=par('cex.axis'), cex.lab=par('cex.lab'))

mgp.axis.labels(value,type=c('xy','x','y','x and y'))
}

\arguments{
  \item{side,at}{see \code{\link{par}}}
  \item{\dots}{arguments passed through to \code{\link{axis}}}
  \item{mgp,cex.axis,cex.lab}{see \code{\link{par}}}
  \item{axistitle}{if specified will cause \code{axistitle} to be drawn
	on the appropriate axis as a title}
  \item{value}{vector of values to which to set system option
	\code{mgp.axis.labels}}
  \item{type}{see above}
}
\section{Side Effects}{\code{mgp.axis.labels} stores the value in the
  system option \code{mgp.axis.labels}}
\value{
  \code{mgp.axis.labels} returns the value of \code{mgp} (only the
  second element of \code{mgp} if \code{type="xy"} or a list with
  elements \code{x} and \code{y} if \code{type="x or y"}, each list
  element being a 3-vector) for the 
  appropriate axis if \code{value} is not specified, otherwise it
  returns nothing but the system option \code{mgp.axis.labels} is set.

  \code{mgp.axis} returns nothing.
}
\author{Frank Harrell}
\seealso{\code{\link{par}}}
\examples{
\dontrun{
mgp.axis.labels(type='x')  # get default value for x-axis
mgp.axis.labels(type='y')  # get value for y-axis
mgp.axis.labels(type='xy') # get 2nd element of both mgps
mgp.axis.labels(type='x and y')  # get a list with 2 elements
mgp.axis.labels(c(3,.5,0), type='x')  # set
options('mgp.axis.labels')            # retrieve

plot(..., axes=FALSE)
mgp.axis(1, "X Label")
mgp.axis(2, "Y Label")

}}
\keyword{iplot}
\keyword{dplot}
\keyword{environment}

\name{errbar}
\alias{errbar}
\title{Plot Error Bars}
\description{
  Add vertical error bars to an existing plot or makes a new
  plot with error bars.  
}
\usage{
errbar(x, y, yplus, yminus, cap=0.015, main = NULL,
       sub=NULL, xlab=as.character(substitute(x)),
       ylab=if(is.factor(x) || is.character(x)) ""
           else as.character(substitute(y)),
       add=FALSE, lty=1, type='p', ylim=NULL,
       lwd=1, pch=16, errbar.col, Type=rep(1, length(y)), 
       \dots)
}
\arguments{
  \item{x}{
    vector of numeric x-axis values (for vertical error bars) or a factor or
    character variable (for horizontal error bars, \code{x} representing the
    group labels)
  }
  \item{y}{
    vector of y-axis values.
  }
  \item{yplus}{
    vector of y-axis values: the tops of the error bars.
  }
  \item{yminus}{
    vector of y-axis values: the bottoms of the error bars.
  }
  \item{cap}{
    the width of the little lines at the tops and bottoms of the error bars
    in units of the width of the plot.  Defaults to \code{0.015}.
  }
  \item{main}{
    a main title for the plot, passed to \code{plot}, see also \code{\link{title}}.
  }
  \item{sub}{
    a sub title for the plot, passed to \code{plot}
  }
  \item{xlab}{
    optional x-axis labels if \code{add=FALSE}.
  }
  \item{ylab}{
    optional y-axis labels if \code{add=FALSE}.  Defaults to blank for horizontal charts.
  }
  \item{add}{
    set to \code{TRUE} to add bars to an existing plot (available only for vertical
    error bars)
  }
  \item{lty}{
    type of line for error bars
  }
  \item{type}{
    type of point.  Use \code{type="b"} to connect dots.
  }
  \item{ylim}{
    y-axis limits.  Default is to use range of \code{y}, \code{yminus}, and \code{yplus}.  For
    horizonal charts, \code{ylim} is really the \code{x}-axis range, excluding
    differences.
  }
  \item{lwd}{
    line width for line segments (not main line)
  }
  \item{pch}{
    character to use as the point.
  }
  \item{errbar.col}{
    color to use for drawing error bars.
  }
  \item{Type}{
    used for horizontal bars only.  Is an integer vector with values \code{1}
    if corresponding values represent simple estimates, \code{2} if they
    represent differences.
  }
  \item{...}{
    other parameters passed to all graphics functions.
  }
}
\details{
  \code{errbar} adds vertical error bars to an existing plot or makes a new
  plot with error bars.  It can also make a horizontal error bar plot
  that shows error bars for group differences as well as bars for
  groups.  For the latter type of plot, the lower x-axis scale
  corresponds to group estimates and the upper scale corresponds to
  differences.  The spacings of the two scales are identical but the
  scale for differences has its origin shifted so that zero may be
  included.  If at least one of the confidence intervals includes zero,
  a vertical dotted reference line at zero is drawn.
}
\author{
Charles Geyer, University of Chicago.  Modified by Frank Harrell,
Vanderbilt University, to handle missing data, to add the parameters
\code{add} and \code{lty}, and to implement horizontal charts with differences.
}
\examples{
set.seed(1)
x <- 1:10
y <- x + rnorm(10)
delta <- runif(10)
errbar( x, y, y + delta, y - delta )


# Show bootstrap nonparametric CLs for 3 group means and for
# pairwise differences on same graph
group <- sample(c('a','b','d'), 200, TRUE)
y     <- runif(200) + .25*(group=='b') + .5*(group=='d')
cla <- smean.cl.boot(y[group=='a'],B=100,reps=TRUE)  # usually B=1000
a   <- attr(cla,'reps')
clb <- smean.cl.boot(y[group=='b'],B=100,reps=TRUE)
b   <- attr(clb,'reps')
cld <- smean.cl.boot(y[group=='d'],B=100,reps=TRUE)
d   <- attr(cld,'reps')
a.b <- quantile(a-b,c(.025,.975))
a.d <- quantile(a-d,c(.025,.975))
b.d <- quantile(b-d,c(.025,.975))
errbar(c('a','b','d','a - b','a - d','b - d'),
       c(cla[1],clb[1],cld[1],cla[1]-clb[1],cla[1]-cld[1],clb[1]-cld[1]),
       c(cla[3],clb[3],cld[3],a.b[2],a.d[2],b.d[2]),
       c(cla[2],clb[2],cld[2],a.b[1],a.d[1],b.d[1]),
       Type=c(1,1,1,2,2,2), xlab='', ylab='')
       
}
\keyword{hplot}
% Converted by Sd2Rd version 1.21.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qrxcenter.r
\name{qrxcenter}
\alias{qrxcenter}
\title{qrxcenter}
\usage{
qrxcenter(x, ...)
}
\arguments{
\item{x}{a numeric matrix or vector with at least 2 rows}

\item{...}{passed to \code{\link[base:qr]{base::qr()}}}
}
\value{
a list with components \code{x} (transformed data matrix), \code{R} (the matrix that can be used to transform raw \code{x} and to transform regression coefficients computed on transformed \code{x} back to the original space), \code{Ri} (transforms transformed \code{x} back to original scale except for \code{xbar}), and \code{xbar} (vector of means of original \code{x} columns`)
}
\description{
Mean-center a data matrix and QR transform it
}
\details{
For a numeric matrix \code{x} (or a numeric vector that is automatically changed to a one-column matrix), computes column means and subtracts them from \code{x} columns, and passes this matrix to \code{\link[base:qr]{base::qr()}} to orthogonalize columns.  Columns of the transformed \code{x} are negated as needed so that original directions are preserved (which are arbitrary with QR decomposition).  Instead of the default \code{qr} operation for which sums of squares of column values are 1.0, \code{qrxcenter} makes all the transformed columns have standard deviation of 1.0.
}
\examples{
set.seed(1)
age <- 1:10
country <- sample(c('Slovenia', 'Italy', 'France'), 10, TRUE)
x <- model.matrix(~ age + country)[, -1]
x
w <- qrxcenter(x)
w
# Reproduce w$x
sweep(x, 2, w$xbar) \%*\% w$R
# Reproduce x from w$x
sweep(w$x \%*\% w$Ri, 2, w$xbar, FUN='+')
# See also https://hbiostat.org/r/examples/gtrans/gtrans#sec-splinebasis
}

\name{multLines}
\alias{multLines}
\title{Plot Multiple Lines}
\description{
	Plots multiple lines based on a vector \code{x} and a matrix \code{y},
	draws thin vertical lines connecting limits represented by columns of
	\code{y} beyond the first.  It is assumed that either (1) the second
	and third columns of \code{y} represent lower and upper confidence
	limits, or that (2) there is an even number of columns beyond the
	first and these represent ascending quantiles that are symmetrically
	arranged around 0.5.  If \code{options(grType='plotly')} is in effect,
	uses \code{plotly} graphics instead of \code{grid} or base graphics.
	For \code{plotly} you may want to set the list of possible colors,
	etc. using \code{pobj=plot_ly(colors=...)}.  \code{lwd,lty,lwd.vert}
	are ignored under \code{plotly}.
}
\usage{
multLines(x, y, pos = c('left', 'right'), col='gray',
          lwd=1, lty=1, lwd.vert = .85, lty.vert = 1,
          alpha = 0.4, grid = FALSE,
          pobj=plotly::plot_ly(), xlim, name=colnames(y)[1], legendgroup=name,
          showlegend=TRUE, ...)
}
\arguments{
  \item{x}{a numeric vector}
  \item{y}{a numeric matrix with number of rows equal to the number of
		\code{x} elements}
	\item{pos}{when \code{pos='left'} the vertical lines are drawn, right
		to left, to the left of the point \code{(x, y[,1)}.  Otherwise lines
		are drawn left to right to the right of the point.}
  \item{col}{a color used to connect \code{(x, y[,1])} pairs.  The same
		color but with transparency given by the \code{alpha} argument is
		used to draw the vertical lines}
  \item{lwd}{line width for main lines}
  \item{lty}{line types for main lines}
	\item{lwd.vert}{line width for vertical lines}
	\item{lty.vert}{line type for vertical lines}
  \item{alpha}{transparency}
  \item{grid}{set to \code{TRUE} when using \code{grid}/\code{lattice}}
	\item{pobj}{an already started \code{plotly} object to add to}
	\item{xlim}{global x-axis limits (required if using \code{plotly})}
	\item{name}{trace name if using \code{plotly}}
	\item{legendgroup}{legend group name if using \code{plotly}}
	\item{showlegend}{whether or not to show traces in legend, if using
		\code{plotly}} 
	\item{\dots}{passed to \code{add_lines} or \code{add_segments} if
		using \code{plotly}}
		
}
\author{Frank Harrell}
\examples{
if (requireNamespace("plotly")) {
  x <- 1:4
  y <- cbind(x, x-3, x-2, x-1, x+1, x+2, x+3)
  plot(NA, NA, xlim=c(1,4), ylim=c(-2, 7))
  multLines(x, y, col='blue')
  multLines(x, y, col='red', pos='right')
}
}
\keyword{hplot}

\name{rcspline.restate}
\alias{rcspline.restate}
\alias{rcsplineFunction}
\title{
  Re-state Restricted Cubic Spline Function
}
\description{
  This function re-states a restricted cubic spline function in
  the un-linearly-restricted form. Coefficients for that form are
  returned, along with an \R functional representation of this function
  and a LaTeX character representation of the function.
  \code{rcsplineFunction} is a fast function that creates a function to
  compute a restricted cubic spline function with given coefficients and
  knots, without reformatting the function to be pretty (i.e., into
  unrestricted form).
}
\usage{
rcspline.restate(knots, coef,
                 type=c("ordinary","integral"),
                 x="X", lx=nchar(x),
                 norm=2, columns=65, before="& &", after="\\\\",
                 begin="", nbegin=0, digits=max(8, .Options$digits))

rcsplineFunction(knots, coef, norm=2, type=c('ordinary', 'integral'))
}
\arguments{
  \item{knots}{
    vector of knots used in the regression fit
  }
  \item{coef}{
    vector of coefficients from the fit. If the length of \code{coef} is
    \eqn{\var{k}-1}, where \var{k} is equal to the \code{length(knots)}, the
    first coefficient must be for the linear term and remaining
    \eqn{k-2} coefficients must be for the constructed terms (e.g., from
    \code{rcspline.eval}). If the length of \code{coef} is \var{k}, an
    intercept is assumed to be in the first element (or a zero is
    prepended to \code{coef} for \code{rcsplineFunction}).
  }
  \item{type}{
    The default is to represent the cubic spline function corresponding
    to the coefficients and knots.  Set \code{type = "integral"} to
    instead represent its anti-derivative.
  }
  \item{x}{
    a character string to use as the variable name in the LaTeX expression
    for the formula.
  }
  \item{lx}{
    length of \code{x} to count with respect to \code{columns}. Default
    is length of character string contained by \code{x}. You may want to
    set \code{lx} smaller than this if it includes non-printable LaTeX
    commands.
  }
  \item{norm}{
    normalization that was used in deriving the original nonlinear terms
    used in the fit. See \code{rcspline.eval} for definitions.
  }
  \item{columns}{
    maximum number of symbols in the LaTeX expression to allow before
    inserting a newline (\samp{\\\\}) command. Set to a very large
    number to keep text all on one line.
  }
  \item{before}{
    text to place before each line of LaTeX output. Use \samp{"& &"}
    for an equation array environment in LaTeX where you want to have a
    left-hand prefix e.g. \samp{"f(X) & = &"} or using
    \samp{"\\lefteqn"}.
  }
  \item{after}{
    text to place at the end of each line of output.
  }
  \item{begin}{
    text with which to start the first line of output. Useful when
    adding LaTeX output to part of an existing formula
  }
  \item{nbegin}{
    number of columns of printable text in \code{begin}
  }
  \item{digits}{
    number of significant digits to write for coefficients and knots
  }
}
\value{
  \code{rcspline.restate} returns a vector of coefficients. The
  coefficients are un-normalized and two coefficients are added that are
  linearly dependent on the other coefficients and knots. The vector of
  coefficients has four attributes. \code{knots} is a vector of knots,
  \code{latex} is a vector of text strings with the LaTeX
  representation of the formula. \code{columns.used} is the number of
  columns used in the output string since the last newline command.
  \code{function} is an \R function, which is also return in character
  string format as the \code{text} attribute.  \code{rcsplineFunction}
  returns an \R function with arguments \code{x} (a user-supplied
  numeric vector at which to evaluate the function), and some
  automatically-supplied other arguments. 
}
\author{
  Frank Harrell
  \cr
  Department of Biostatistics, Vanderbilt University
  \cr
  \email{fh@fharrell.com}
}
\seealso{
  \code{\link{rcspline.eval}}, \code{\link{ns}}, \code{\link[rms]{rcs}},
  \code{\link{latex}}, \code{\link{Function.transcan}} 
}
\examples{
set.seed(1)
x <- 1:100
y <- (x - 50)^2 + rnorm(100, 0, 50)
plot(x, y)
xx <- rcspline.eval(x, inclx=TRUE, nk=4)
knots <- attr(xx, "knots")
coef <- lsfit(xx, y)$coef
options(digits=4)
# rcspline.restate must ignore intercept
w <- rcspline.restate(knots, coef[-1], x="{\\\\rm BP}")
# could also have used coef instead of coef[-1], to include intercept
cat(attr(w,"latex"), sep="\n")


xtrans <- eval(attr(w, "function"))
# This is an S function of a single argument
lines(x, coef[1] + xtrans(x), type="l")
# Plots fitted transformation

xtrans <- rcsplineFunction(knots, coef)
xtrans
lines(x, xtrans(x), col='blue')


#x <- blood.pressure
xx.simple <- cbind(x, pmax(x-knots[1],0)^3, pmax(x-knots[2],0)^3,
                       pmax(x-knots[3],0)^3, pmax(x-knots[4],0)^3)
pred.value <- coef[1] + xx.simple \%*\% w
plot(x, pred.value, type='l')   # same as above
}
\keyword{regression}
\keyword{interface}
\keyword{character}
% Converted by Sd2Rd version 1.21.

\name{panel.bpplot}
\alias{panel.bpplot}
\alias{bpplotM}
\alias{bpplt}
\alias{bppltp}
\title{
Box-Percentile Panel Function for Trellis
}
\description{
For all their good points, box plots have a high ink/information ratio
in that they mainly display 3 quartiles.  Many practitioners have
found that the "outer values" are difficult to explain to
non-statisticians and many feel that the notion of "outliers" is too
dependent on (false) expectations that data distributions should be Gaussian.

\code{panel.bpplot} is a \code{panel} function for use with
\code{trellis}, especially for \code{bwplot}.  It draws box plots
(without the whiskers) with any number of user-specified "corners"
(corresponding to different quantiles), but it also draws box-percentile
plots similar to those drawn by Jeffrey Banfield's
(\email{umsfjban@bill.oscs.montana.edu}) \code{bpplot} function. 
To quote from Banfield, "box-percentile plots supply more
information about the univariate distributions.  At any height the
width of the irregular 'box' is proportional to the percentile of that
height, up to the 50th percentile, and above the 50th percentile the
width is proportional to 100 minus the percentile.  Thus, the width at
any given height is proportional to the percent of observations that
are more extreme in that direction.  As in boxplots, the median, 25th
and 75th percentiles are marked with line segments across the box."

\code{panel.bpplot} can also be used with base graphics to add extended
box plots to an existing plot, by specifying \code{nogrid=TRUE, height=...}.

\code{panel.bpplot} is a generalization of \code{bpplot} and
\code{\link[lattice]{panel.bwplot}} in 
that it works with \code{trellis} (making the plots horizontal so that
category labels are more visable), it allows the user to specify the
quantiles to connect and those for which to draw reference lines, 
and it displays means (by default using dots).

\code{bpplt} draws horizontal box-percentile plot much like those drawn
by \code{panel.bpplot} but taking as the starting point a matrix
containing quantiles summarizing the data.  \code{bpplt} is primarily
intended to be used internally by \code{plot.summary.formula.reverse} or
\code{plot.summaryM} 
but when used with no arguments has a general purpose: to draw an
annotated example box-percentile plot with the default quantiles used
and with the mean drawn with a solid dot.  This schematic plot is
rendered nicely in postscript with an image height of 3.5 inches.

\code{bppltp} is like \code{bpplt} but for \code{plotly} graphics, and
it does not draw an annotated extended box plot example.

\code{bpplotM} uses the \code{lattice} \code{bwplot} function to depict
multiple numeric continuous variables with varying scales in a single
\code{lattice} graph, after reshaping the dataset into a tall and thin
format.
}
\usage{
panel.bpplot(x, y, box.ratio=1, means=TRUE, qref=c(.5,.25,.75),
             probs=c(.05,.125,.25,.375), nout=0,
             nloc=c('right lower', 'right', 'left', 'none'), cex.n=.7,
             datadensity=FALSE, scat1d.opts=NULL,
             violin=FALSE, violin.opts=NULL,
             font=box.dot$font, pch=box.dot$pch, 
             cex.means =box.dot$cex,  col=box.dot$col,
             nogrid=NULL, height=NULL, \dots)

# E.g. bwplot(formula, panel=panel.bpplot, panel.bpplot.parameters)

bpplt(stats, xlim, xlab='', box.ratio = 1, means=TRUE,
      qref=c(.5,.25,.75), qomit=c(.025,.975),
      pch=16, cex.labels=par('cex'), cex.points=if(prototype)1 else 0.5,
      grid=FALSE)

bppltp(p=plotly::plot_ly(),
       stats, xlim, xlab='', box.ratio = 1, means=TRUE,
       qref=c(.5,.25,.75), qomit=c(.025,.975),
       teststat=NULL, showlegend=TRUE)

bpplotM(formula=NULL, groups=NULL, data=NULL, subset=NULL, na.action=NULL,
        qlim=0.01, xlim=NULL,
        nloc=c('right lower','right','left','none'),
        vnames=c('labels', 'names'), cex.n=.7, cex.strip=1,
        outerlabels=TRUE, \dots)
}
\arguments{
\item{x}{
continuous variable whose distribution is to be examined
}
\item{y}{
grouping variable
}
\item{box.ratio}{
see \code{\link[lattice]{panel.bwplot}}
}
\item{means}{
set to \code{FALSE} to suppress drawing a character at the mean value
}
\item{qref}{
vector of quantiles for which to draw reference lines.  These do not
need to be included in \code{probs}.
}
\item{probs}{
vector of quantiles to display in the box plot.  These should all be
less than 0.5; the mirror-image quantiles are added automatically.  By
default, \code{probs} is set to \code{c(.05,.125,.25,.375)} so that intervals
contain 0.9, 0.75, 0.5, and 0.25 of the data.
To draw all 99 percentiles, i.e., to draw a box-percentile plot,
set \code{probs=seq(.01,.49,by=.01)}.
To make a more traditional box plot, use \code{probs=.25}.
}
\item{nout}{
tells the function to use \code{scat1d} to draw tick marks showing the
\code{nout} smallest and \code{nout} largest values if \code{nout >= 1}, or to
show all values less than the \code{nout} quantile or greater than the
\code{1-nout} quantile if \code{0 < nout <= 0.5}.  If \code{nout} is a whole number,
only the first \code{n/2} observations are shown on either side of the
median, where \code{n} is the total number of observations. 
}
\item{nloc}{location to plot number of non-\code{NA}
	observations next to each box.  Specify \code{nloc='none'} to
        suppress.  For \code{panel.bpplot}, the default \code{nloc} is
        \code{'none'} if \code{nogrid=TRUE}.}
\item{cex.n}{character size for \code{nloc}}
\item{datadensity}{
set to \code{TRUE} to invoke \code{scat1d} to draw a data density
(one-dimensional scatter diagram or rug plot) inside each box plot.
}
\item{scat1d.opts}{
a list containing named arguments (without abbreviations) to pass to
\code{scat1d} when \code{datadensity=TRUE} or \code{nout > 0}
}
\item{violin}{set to \code{TRUE} to invoke \code{panel.violin} in
  addition to drawing box-percentile plots}
\item{violin.opts}{a list of options to pass to \code{panel.violin}}
\item{cex.means}{character size for dots representing means}
\item{font,pch,col}{see \code{\link[lattice]{panel.bwplot}}}
\item{nogrid}{set to \code{TRUE} to use in base graphics}
\item{height}{if \code{nogrid=TRUE}, specifies the height of the box in
        user \code{y} units}
\item{\dots}{arguments passed to \code{points} or \code{panel.bpplot} or
        \code{bwplot}}
\item{stats,xlim,xlab,qomit,cex.labels,cex.points,grid}{
  undocumented arguments to \code{bpplt}.  For \code{bpplotM},
        \code{xlim} is a list with elements named as the \code{x}-axis
        variables, 
        to override the \code{qlim} calculations with user-specified
        \code{x}-axis limits for selected variables.  Example:
        \code{xlim=list(age=c(20,60))}.
			}
\item{p}{an already-started \code{plotly} object}
\item{teststat}{an html expression containing a test statistic}
\item{showlegend}{set to \code{TRUE} to have \code{plotly} include
        a legend.  Not recommended when plotting more than one variable.}
\item{formula}{a formula with continuous numeric analysis variables on
        the left hand side and stratification variables on the right.
        The first variable on the right is the one that will vary the
        fastest, forming the \code{y}-axis.  \code{formula} may be
        omitted, in which case all numeric variables with more than 5
        unique values in \code{data} will be analyzed.  Or
        \code{formula} may be a vector of variable names in \code{data}
        to analyze.  In the latter two cases (and only those cases),
        \code{groups} must be given, representing a character vector
        with names of stratification variables.}
\item{groups}{see above}
\item{data}{an optional data frame}
\item{subset}{an optional subsetting expression or logical vector}
\item{na.action}{specifies a function to possibly subset the data
        according to \code{NA}s (default is no such subsetting).}
\item{qlim}{the outer quantiles to use for scaling each panel in
  \code{bpplotM}}
\item{vnames}{default is to use variable \code{label} attributes when
        they exist, or use variable names otherwise.  Specify
        \code{vnames='names'} to always use variable names for panel
        labels in \code{bpplotM}}
\item{cex.strip}{character size for panel strip labels}
\item{outerlabels}{if \code{TRUE}, pass the \code{lattice} graphics
        through the \code{latticeExtra} package's \code{useOuterStrips}
        function if there are two conditioning (paneling) variables, to
        put panel labels in outer margins.}			
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University School of Medicine
\cr
\email{fh@fharrell.com}
}
\references{
  Esty WW, Banfield J: The box-percentile plot.  J Statistical
Software 8 No. 17, 2003.
}
\seealso{
\code{\link{bpplot}}, \code{\link[lattice]{panel.bwplot}},
        \code{\link{scat1d}}, \code{\link{quantile}},
        \code{\link{Ecdf}}, \code{\link{summaryP}},
        \code{\link[latticeExtra]{useOuterStrips}}
}
\examples{
set.seed(13)
x <- rnorm(1000)
g <- sample(1:6, 1000, replace=TRUE)
x[g==1][1:20] <- rnorm(20)+3   # contaminate 20 x's for group 1


# default trellis box plot
require(lattice)
bwplot(g ~ x)


# box-percentile plot with data density (rug plot)
bwplot(g ~ x, panel=panel.bpplot, probs=seq(.01,.49,by=.01), datadensity=TRUE)
# add ,scat1d.opts=list(tfrac=1) to make all tick marks the same size
# when a group has > 125 observations


# small dot for means, show only .05,.125,.25,.375,.625,.75,.875,.95 quantiles
bwplot(g ~ x, panel=panel.bpplot, cex.means=.3)


# suppress means and reference lines for lower and upper quartiles
bwplot(g ~ x, panel=panel.bpplot, probs=c(.025,.1,.25), means=FALSE, qref=FALSE)


# continuous plot up until quartiles ("Tootsie Roll plot")
bwplot(g ~ x, panel=panel.bpplot, probs=seq(.01,.25,by=.01))


# start at quartiles then make it continuous ("coffin plot")
bwplot(g ~ x, panel=panel.bpplot, probs=seq(.25,.49,by=.01))


# same as previous but add a spike to give 0.95 interval
bwplot(g ~ x, panel=panel.bpplot, probs=c(.025,seq(.25,.49,by=.01)))


# decile plot with reference lines at outer quintiles and median
bwplot(g ~ x, panel=panel.bpplot, probs=c(.1,.2,.3,.4), qref=c(.5,.2,.8))


# default plot with tick marks showing all observations outside the outer
# box (.05 and .95 quantiles), with very small ticks
bwplot(g ~ x, panel=panel.bpplot, nout=.05, scat1d.opts=list(frac=.01))


# show 5 smallest and 5 largest observations
bwplot(g ~ x, panel=panel.bpplot, nout=5)


# Use a scat1d option (preserve=TRUE) to ensure that the right peak extends 
# to the same position as the extreme scat1d
bwplot(~x , panel=panel.bpplot, probs=seq(.00,.5,by=.001), 
       datadensity=TRUE, scat1d.opt=list(preserve=TRUE))

# Add an extended box plot to an existing base graphics plot
plot(x, 1:length(x))
panel.bpplot(x, 1070, nogrid=TRUE, pch=19, height=15, cex.means=.5)

# Draw a prototype showing how to interpret the plots
bpplt()

# Example for bpplotM
set.seed(1)
n <- 800
d <- data.frame(treatment=sample(c('a','b'), n, TRUE),
                sex=sample(c('female','male'), n, TRUE),
                age=rnorm(n, 40, 10),
                bp =rnorm(n, 120, 12),
                wt =rnorm(n, 190, 30))
label(d$bp) <- 'Systolic Blood Pressure'
units(d$bp) <- 'mmHg'
bpplotM(age + bp + wt ~ treatment, data=d)
bpplotM(age + bp + wt ~ treatment * sex, data=d, cex.strip=.8)
bpplotM(age + bp + wt ~ treatment*sex, data=d,
        violin=TRUE,
        violin.opts=list(col=adjustcolor('blue', alpha.f=.15),
                         border=FALSE))


bpplotM(c('age', 'bp', 'wt'), groups='treatment', data=d)
# Can use Hmisc Cs function, e.g. Cs(age, bp, wt)
bpplotM(age + bp + wt ~ treatment, data=d, nloc='left')

# Without treatment: bpplotM(age + bp + wt ~ 1, data=d)

\dontrun{
# Automatically find all variables that appear to be continuous
getHdata(support)
bpplotM(data=support, group='dzgroup',
        cex.strip=.4, cex.means=.3, cex.n=.45)

# Separate displays for categorical vs. continuous baseline variables
getHdata(pbc)
pbc <- upData(pbc, moveUnits=TRUE)

s <- summaryM(stage + sex + spiders ~ drug, data=pbc)
plot(s)
Key(0, .5)
s <- summaryP(stage + sex + spiders ~ drug, data=pbc)
plot(s, val ~ freq | var, groups='drug', pch=1:3, col=1:3,
     key=list(x=.6, y=.8))

bpplotM(bili + albumin + protime + age ~ drug, data=pbc)
}
}
\keyword{nonparametric}
\keyword{hplot}
\keyword{distribution}
\concept{trellis}
\concept{lattice}

\name{Cs}
\alias{Cs}
\alias{.q}
\title{
Character strings from unquoted names
}
\description{
\code{Cs} makes a vector of character strings from a list of valid R
names.  \code{.q} is similar but also makes uses of names of arguments.
}
\usage{
Cs(\dots)
.q(\dots)
}
\arguments{
\item{...}{
any number of names separated by commas.  For \code{.q} any names of
arguments will be used.
}}
\value{
character string vector.  For \code{.q} there will be a \code{names}
attribute to the vector if any names appeared in \dots.
}
\seealso{
sys.frame, deparse
}
\examples{
Cs(a,cat,dog)
# subset.data.frame <- dataframe[,Cs(age,sex,race,bloodpressure,height)]
.q(a, b, c, 'this and that')
.q(dog=a, giraffe=b, cat=c)
}
\keyword{character}
\keyword{utilities}

\name{showPsfrag}
\alias{showPsfrag}
\title{
  Display image from psfrag LaTeX strings
}
\description{
  \code{showPsfrag} is used to display (using ghostview) a postscript
  image that contained psfrag LaTeX strings, by building a small LaTeX
  script and running \command{latex} and \command{dvips}.
}
\usage{
showPsfrag(filename)
}
\arguments{
  \item{filename}{
    name or character string or character vector specifying file
    prefix.
  }
}
\author{
  Frank Harrell\cr
  Department of Biostatistics\cr
  Vanderbilt University\cr
  \email{fh@fharrell.com}
}
\references{
  Grant MC, Carlisle (1998): The PSfrag System, Version 3.  Full
  documentation is obtained by searching www.ctan.org for \file{pfgguide.ps}.
}
\seealso{
  \code{\link{postscript}}, \code{\link{par}}, \code{\link{ps.options}},
  \code{\link{mgp.axis.labels}}, \code{\link{pdf}},
  \code{\link[lattice]{trellis.device}}, \code{\link{setTrellis}}
}
\keyword{hplot}
\keyword{device}
\concept{trellis}
\concept{lattice}

\name{translate}
\alias{translate}
\title{
Translate Vector or Matrix of Text Strings
}
\description{
Uses the UNIX tr command to translate any character in \code{old} in
\code{text} to the corresponding character in \code{new}.  If multichar=T
or \code{old} and \code{new} have more than one element, or each have one element
but they have different numbers of characters,
uses the UNIX \code{sed} command to translate the series of characters in
\code{old} to the series in \code{new} when these characters occur in \code{text}.
If \code{old} or \code{new} contain a backslash, you sometimes have to quadruple
it to make the UNIX command work. If they contain a forward slash,
preceed it by two backslashes.  Invokes the builtin chartr function if
\code{multichar=FALSE}. 
}
\usage{
translate(text, old, new, multichar=FALSE)
}
\arguments{
\item{text}{
scalar, vector, or matrix of character strings to translate.
}
\item{old}{
vector old characters
}
\item{new}{
corresponding vector of new characters
}
\item{multichar}{See above.}
}
\value{
an object like text but with characters translated
}
\seealso{grep}
\examples{
translate(c("ABC","DEF"),"ABCDEFG", "abcdefg")
translate("23.12","[.]","\\\\cdot ") # change . to \cdot
translate(c("dog","cat","tiger"),c("dog","cat"),c("DOG","CAT"))
# S-Plus gives  [1] "DOG"   "CAT"   "tiger" - check discrepency
translate(c("dog","cat2","snake"),c("dog","cat"),"animal")
# S-Plus gives  [1] "animal"  "animal2" "snake" 
}
\keyword{character}

\name{find.matches}
\alias{find.matches}
\alias{summary.find.matches}
\alias{print.find.matches}
\alias{matchCases}
\title{
Find Close Matches
}
\description{
Compares each row in \code{x} against all the rows in \code{y}, finding rows in
\code{y} with all columns within a tolerance of the values a given row of
\code{x}.  The default tolerance
\code{tol} is zero, i.e., an exact match is required on all columns.
For qualifying matches, a distance measure is computed.  This is
the sum of squares of differences between \code{x} and \code{y} after scaling
the columns.  The default scaling values are \code{tol}, and for columns
with \code{tol=1} the scale values are set to 1.0 (since they are ignored
anyway).  Matches (up to \code{maxmatch} of them) are stored and listed in order of 
increasing distance.
\cr
The \code{summary} method prints a frequency distribution of the
number of matches per observation in \code{x}, the median of the minimum
distances for all matches per \code{x}, as a function of the number of matches,
and the frequency of selection of duplicate observations as those having
the smallest distance.  The \code{print} method prints the entire \code{matches}
and \code{distance} components of the result from \code{find.matches}.
\cr
\code{matchCases} finds all controls that match cases on a single variable
\code{x} within a tolerance of \code{tol}.  This is intended for prospective
cohort studies that use matching for confounder adjustment (even
though regression models usually work better).
}
\usage{
find.matches(x, y, tol=rep(0, ncol(y)), scale=tol, maxmatch=10)
\method{summary}{find.matches}(object, \dots)
\method{print}{find.matches}(x, digits, \dots)

matchCases(xcase,    ycase,    idcase=names(ycase),
           xcontrol, ycontrol, idcontrol=names(ycontrol),
           tol=NULL,
           maxobs=max(length(ycase),length(ycontrol))*10,
           maxmatch=20, which=c('closest','random'))
}
\arguments{
\item{x}{
a numeric matrix or the result of \code{find.matches}
}
\item{y}{
a numeric matrix with same number of columns as \code{x}
}
\item{xcase}{
}
\item{xcontrol}{
vectors, not necessarily of the same length, specifying a numeric
variable used to match cases and control
}
\item{ycase}{
}
\item{ycontrol}{
vectors or matrices, not necessarily having the same number of rows,
specifying a variable to carry along from cases and matching
controls.  If you instead want to carry along rows from a data frame,
let \code{ycase} and \code{ycontrol} be non-overlapping integer subscripts of
the donor data frame.
}
\item{tol}{
a vector of tolerances with number of elements the same as the number
of columns of \code{y}, for \code{find.matches}.  For \code{matchCases}
is a scalar tolerance.
}
\item{scale}{
a vector of scaling constants with number of elements the same as the
number of columns of \code{y}.
}
\item{maxmatch}{
maximum number of matches to allow.  For \code{matchCases},
maximum number of controls to match with a case (default is 20).  If more than
\code{maxmatch} matching controls are available, a random sample without
replacement of \code{maxmatch} controls is used (if \code{which="random"}).
}
\item{object}{an object created by \code{find.matches}}
\item{digits}{
number of digits to use in printing distances
}
\item{idcase}{
}
\item{idcontrol}{
vectors the same length as \code{xcase} and \code{xcontrol} respectively,
specifying the id of cases and controls.  Defaults are integers
specifying original element positions within each of cases and
controls.
}
\item{maxobs}{
maximum number of cases and all matching controls combined (maximum
dimension of data frame resulting from \code{matchControls}).  Default is
ten times the maximum of the number of cases and number of controls.
\code{maxobs} is used to allocate space for the resulting data frame.
}
\item{which}{
set to \code{"closest"} (the default) to match cases with up to \code{maxmatch}
controls that most closely match on \code{x}.  Set \code{which="random"} to use
randomly chosen controls.  In either case, only those controls within
\code{tol} on \code{x} are allowed to be used.
}
\item{\dots}{unused}
}
\value{
\code{find.matches} returns a list of class \code{find.matches} with elements
\code{matches} and \code{distance}. 
Both elements are matrices with the number of rows equal to the number
of rows in \code{x}, and with \code{k} columns, where \code{k} is the maximum number of
matches (\code{<= maxmatch}) that occurred.  The elements of \code{matches}
are row identifiers of \code{y} that match, with zeros if fewer than
\code{maxmatch} matches are found (blanks if \code{y} had row names).
\code{matchCases} returns a data frame with variables \code{idcase} (id of case
currently being matched), \code{type} (factor variable with levels \code{"case"}
and \code{"control"}), \code{id} (id of case if case row, or id of matching
case), and \code{y}.
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\references{
Ming K, Rosenbaum PR (2001): A note on optimal matching with variable
controls using the assignment algorithm.  J Comp Graph Stat
10:455--463.

Cepeda MS, Boston R, Farrar JT, Strom BL (2003): Optimal matching with a
variable number of controls vs. a fixed number of controls for a cohort
study: trade-offs.  J Clin Epidemiology 56:230-237.
Note: These papers were not used for the functions here but
probably should have been.

}
\seealso{
\code{\link{scale}}, \code{\link{apply}}
}
\examples{
y <- rbind(c(.1, .2),c(.11, .22), c(.3, .4), c(.31, .41), c(.32, 5))
x <- rbind(c(.09,.21), c(.29,.39))
y
x
w <- find.matches(x, y, maxmatch=5, tol=c(.05,.05))


set.seed(111)       # so can replicate results
x <- matrix(runif(500), ncol=2)
y <- matrix(runif(2000), ncol=2)
w <- find.matches(x, y, maxmatch=5, tol=c(.02,.03))
w$matches[1:5,]
w$distance[1:5,]
# Find first x with 3 or more y-matches
num.match <- apply(w$matches, 1, function(x)sum(x > 0))
j <- ((1:length(num.match))[num.match > 2])[1]
x[j,]
y[w$matches[j,],]


summary(w)


# For many applications would do something like this:
# attach(df1)
# x <- cbind(age, sex) # Just do as.matrix(df1) if df1 has no factor objects
# attach(df2)
# y <- cbind(age, sex)
# mat <- find.matches(x, y, tol=c(5,0)) # exact match on sex, 5y on age


# Demonstrate matchCases
xcase     <- c(1,3,5,12)
xcontrol  <- 1:6
idcase    <- c('A','B','C','D')
idcontrol <- c('a','b','c','d','e','f')
ycase     <- c(11,33,55,122)
ycontrol  <- c(11,22,33,44,55,66)
matchCases(xcase, ycase, idcase,
           xcontrol, ycontrol, idcontrol, tol=1)


# If y is a binary response variable, the following code
# will produce a Mantel-Haenszel summary odds ratio that 
# utilizes the matching.
# Standard variance formula will not work here because
# a control will match more than one case
# WARNING: The M-H procedure exemplified here is suspect 
# because of the small strata and widely varying number
# of controls per case.


x    <- c(1, 2, 3, 3, 3, 6, 7, 12,  1, 1:7)
y    <- c(0, 0, 0, 1, 0, 1, 1,  1,  1, 0, 0, 0, 0, 1, 1, 1)
case <- c(rep(TRUE, 8), rep(FALSE, 8))
id   <- 1:length(x)


m <- matchCases(x[case],  y[case],  id[case],
                x[!case], y[!case], id[!case], tol=1)
iscase <- m$type=='case'
# Note: the first tapply on insures that event indicators are
# sorted by case id.  The second actually does something.
event.case    <- tapply(m$y[iscase],  m$idcase[iscase],  sum)
event.control <- tapply(m$y[!iscase], m$idcase[!iscase], sum)
n.control     <- tapply(!iscase,      m$idcase,          sum)
n             <- tapply(m$y,          m$idcase,          length)
or <- sum(event.case * (n.control - event.control) / n) /
      sum(event.control * (1 - event.case) / n)
or


# Bootstrap this estimator by sampling with replacement from
# subjects.  Assumes id is unique when combine cases+controls
# (id was constructed this way above).  The following algorithms
# puts all sampled controls back with the cases to whom they were
# originally matched.


ids <- unique(m$id)
idgroups <- split(1:nrow(m), m$id)
B   <- 50   # in practice use many more
ors <- numeric(B)
# Function to order w by ids, leaving unassigned elements zero
align <- function(ids, w) {
  z <- structure(rep(0, length(ids)), names=ids)
  z[names(w)] <- w
  z
}
for(i in 1:B) {
  j <- sample(ids, replace=TRUE)
  obs <- unlist(idgroups[j])
  u <- m[obs,]
  iscase <- u$type=='case'
  n.case <- align(ids, tapply(u$type, u$idcase, 
                              function(v)sum(v=='case')))
  n.control <- align(ids, tapply(u$type, u$idcase,
                                 function(v)sum(v=='control')))
  event.case <- align(ids, tapply(u$y[iscase],  u$idcase[iscase],  sum))
  event.control <- align(ids, tapply(u$y[!iscase], u$idcase[!iscase], sum))
  n <- n.case + n.control
  # Remove sets having 0 cases or 0 controls in resample
  s             <- n.case > 0 & n.control > 0
  denom <- sum(event.control[s] * (n.case[s] - event.case[s]) / n[s])
  or <- if(denom==0) NA else 
   sum(event.case[s] * (n.control[s] - event.control[s]) / n[s]) / denom
  ors[i] <- or
}
describe(ors)
}
\keyword{math}
\keyword{multivariate}
\keyword{htest}
\concept{bootstrap}
\concept{matching}
\concept{epidemiology}
\concept{case-control}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/r2describe.r
\name{r2describe}
\alias{r2describe}
\title{r2describe}
\usage{
r2describe(x, nvmax = 10)
}
\arguments{
\item{x}{numeric matrix with 2 or more columns}

\item{nvmax}{maxmum number of columns of x to use in predicting a given column}
}
\value{
nothing
}
\description{
Summarize Strength of Relationships Using R-Squared From Linear Regression
}
\details{
Function to use \code{leaps::regsubsets()} to briefly describe which variables more strongly predict another variable.  Variables are in a numeric matrix and are assumed to be transformed so that relationships are linear (e.g., using \code{redun()} or \code{transcan()}.)
}
\examples{
\dontrun{
r <- redun(...)
r2describe(r$scores)
}
}
\author{
Frank Harrell
}

\name{spower}
\alias{spower}
\alias{print.spower}
\alias{Quantile2}
\alias{print.Quantile2}
\alias{plot.Quantile2}
\alias{logrank}
\alias{Gompertz2}
\alias{Lognorm2}
\alias{Weibull2}
\title{
  Simulate Power of 2-Sample Test for Survival under Complex Conditions
}
\description{
  Given functions to generate random variables for survival times and
  censoring times, \code{spower} simulates the power of a user-given
  2-sample test for censored data.  By default, the logrank (Cox
  2-sample) test is used, and a \code{logrank} function for comparing 2
  groups is provided. Optionally a Cox model is fitted for each each
  simulated dataset and the log hazard ratios are saved (this requires
  the \code{survival} package). A \code{print} method prints various
  measures from these.  For composing \R functions to generate random
  survival times under complex conditions, the \code{Quantile2} function
  allows the user to specify the intervention:control hazard ratio as a
  function of time, the probability of a control subject actually
  receiving the intervention (dropin) as a function of time, and the
  probability that an intervention subject receives only the control
  agent as a function of time (non-compliance, dropout).
  \code{Quantile2} returns a function that generates either control or
  intervention uncensored survival times subject to non-constant
  treatment effect, dropin, and dropout.  There is a \code{plot} method
  for plotting the results of \code{Quantile2}, which will aid in
  understanding the effects of the two types of non-compliance and
  non-constant treatment effects.  \code{Quantile2} assumes that the
  hazard function for either treatment group is a mixture of the control
  and intervention hazard functions, with mixing proportions defined by
  the dropin and dropout probabilities.  It computes hazards and
  survival distributions by numerical differentiation and integration
  using a grid of (by default) 7500 equally-spaced time points.
  
  The \code{logrank} function is intended to be used with \code{spower}
  but it can be used by itself.  It returns the 1 degree of freedom
  chi-square statistic, with the hazard ratio estimate as an attribute.

  The \code{Weibull2} function accepts as input two vectors, one
  containing two times and one containing two survival probabilities, and
  it solves for the scale and shape parameters of the Weibull distribution
  (\eqn{S(t) = e^{-\alpha {t}^{\gamma}}}{S(t) = exp(-\alpha*t^\gamma)})
  which will yield
  those estimates.  It creates an \R function to evaluate survival
  probabilities from this Weibull distribution.  \code{Weibull2} is
  useful in creating functions to pass as the first argument to
  \code{Quantile2}.

  The \code{Lognorm2} and \code{Gompertz2} functions are similar to
  \code{Weibull2} except that they produce survival functions for the
  log-normal and Gompertz distributions.

  When \code{cox=TRUE} is specified to \code{spower}, the analyst may wish
  to extract the two margins of error by using the \code{print} method
  for \code{spower} objects (see example below) and take the maximum of
  the two.
}
\usage{
spower(rcontrol, rinterv, rcens, nc, ni, 
       test=logrank, cox=FALSE, nsim=500, alpha=0.05, pr=TRUE)

\method{print}{spower}(x, conf.int=.95, \dots)

Quantile2(scontrol, hratio, 
          dropin=function(times)0, dropout=function(times)0,
          m=7500, tmax, qtmax=.001, mplot=200, pr=TRUE, \dots)

\method{print}{Quantile2}(x, \dots)

\method{plot}{Quantile2}(x, 
     what=c("survival", "hazard", "both", "drop", "hratio", "all"),
     dropsep=FALSE, lty=1:4, col=1, xlim, ylim=NULL,
     label.curves=NULL, \dots)

logrank(S, group)

Gompertz2(times, surv)
Lognorm2(times, surv)
Weibull2(times, surv)
}
\arguments{
  \item{rcontrol}{
    a function of \var{n} which returns \var{n} random uncensored
    failure times for the control group.  \code{spower} assumes that
    non-compliance (dropin) has been taken into account by this
    function.
  }
  \item{rinterv}{
    similar to \code{rcontrol} but for the intervention group
  }
  \item{rcens}{
    a function of \var{n} which returns \var{n} random censoring times.
    It is assumed that both treatment groups have the same censoring
    distribution.
  }
  \item{nc}{
    number of subjects in the control group
  }
  \item{ni}{
    number in the intervention group
  }
  \item{scontrol}{
    a function of a time vector which returns the survival probabilities
    for the control group at those times assuming that all patients are
    compliant.
  }
  \item{hratio}{
    a function of time which specifies the intervention:control hazard
    ratio (treatment effect)
  }
  \item{x}{
    an object of class \dQuote{Quantile2} created by \code{Quantile2},
    or of class \dQuote{spower} created by \code{spower}
  }
  \item{conf.int}{
    confidence level for determining fold-change margins of error in
    estimating the hazard ratio
  }
  \item{S}{
    a \code{Surv} object or other two-column matrix for right-censored
    survival times 
  }
  \item{group}{
    group indicators have length equal to the number of rows in \code{S}
    argument.
  }
  \item{times}{
    a vector of two times
  }
  \item{surv}{
    a vector of two survival probabilities
  }
  \item{test}{
    any function of a \code{Surv} object and a grouping variable which
    computes a chi-square for a two-sample censored data test.  The
    default is \code{logrank}.
  }
  \item{cox}{
    If true \code{TRUE} the two margins of error are available by using
    the \code{print} method for \code{spower} objects (see example
    below) and taking the maximum of the two.
  }
  \item{nsim}{
    number of simulations to perform (default=500)
  }
  \item{alpha}{
    type I error (default=.05)
  }
  \item{pr}{
    If \code{FALSE} prevents \code{spower} from printing progress notes for
    simulations. 
    If \code{FALSE} prevents \code{Quantile2} from printing \code{tmax}
    when it calculates \code{tmax}.
  }
  \item{dropin}{
    a function of time specifying the probability that a control subject
    actually is treated with the new intervention at the corresponding
    time
  }
  \item{dropout}{
    a function of time specifying the probability of an intervention
    subject dropping out to control conditions.  As a function of time,
    \code{dropout} specifies the probability that a patient is treated
    with the control therapy at time \var{t}.  \code{dropin} and
    \code{dropout} form mixing proportions for control and intervention
    hazard functions.
  }
  \item{m}{
    number of time points used for approximating functions (default is
    7500)
  }
  \item{tmax}{
    maximum time point to use in the grid of \code{m} times.  Default is
    the time such that \code{scontrol(time)} is \code{qtmax}.
  }
  \item{qtmax}{
    survival probability corresponding to the last time point used for
    approximating survival and hazard functions.  Default is 0.001.  For
    \code{qtmax} of the time for which a simulated time is needed which
    corresponds to a survival probability of less than \code{qtmax}, the
    simulated value will be \code{tmax}.
  }
  \item{mplot}{
    number of points used for approximating functions for use in
    plotting (default is 200 equally spaced points)
  }
  \item{\dots}{
    optional arguments passed to the \code{scontrol} function when it's
    evaluated by \code{Quantile2}.  Unused for \code{print.spower}.
  }
  \item{what}{
    a single character constant (may be abbreviated) specifying which
    functions to plot.  The default is \samp{"both"} meaning both
    survival and hazard functions.  Specify \code{what="drop"} to just
    plot the dropin and dropout functions, \code{what="hratio"} to plot
    the hazard ratio functions, or \samp{"all"} to make 4 separate plots
    showing all functions (6 plots if \code{dropsep=TRUE}).
  }
  \item{dropsep}{
    If \code{TRUE} makes \code{plot.Quantile2} separate pure and
    contaminated functions onto separate plots
  }
  \item{lty}{
    vector of line types
  }
  \item{col}{
    vector of colors
  }
  \item{xlim}{
    optional x-axis limits
  }
  \item{ylim}{
    optional y-axis limits
  }
  \item{label.curves}{
    optional list which is passed as the \code{opts} argument to
    \code{\link{labcurve}}.
  }
}
\value{
  \code{spower} returns the power estimate (fraction of simulated
  chi-squares greater than the alpha-critical value).  If
  \code{cox=TRUE}, \code{spower} returns an object of class
  \dQuote{spower} containing the power and various other quantities.

  \code{Quantile2} returns an \R function of class \dQuote{Quantile2}
  with attributes that drive the \code{plot} method.  The major
  attribute is a list containing several lists.  Each of these sub-lists
  contains a \code{Time} vector along with one of the following:
  survival probabilities for either treatment group and with or without
  contamination caused by non-compliance, hazard rates in a similar way,
  intervention:control hazard ratio function with and without
  contamination, and dropin and dropout functions.

  \code{logrank} returns a single chi-square statistic.

  \code{Weibull2}, \code{Lognorm2} and \code{Gompertz2} return an \R
  function with three arguments, only the first of which (the vector of
  \code{times}) is intended to be specified by the user.
}
\section{Side Effects}{
  \code{spower} prints the interation number every 10 iterations if
  \code{pr=TRUE}.
}
\author{
  Frank Harrell
  \cr
  Department of Biostatistics
  \cr
  Vanderbilt University School of Medicine
  \cr
  \email{fh@fharrell.com}
}
\references{
  Lakatos E (1988): Sample sizes based on the log-rank statistic in complex
  clinical trials.  Biometrics 44:229--241 (Correction 44:923).

  Cuzick J, Edwards R, Segnan N (1997): Adjusting for non-compliance and 
  contamination in randomized clinical trials. Stat in Med 16:1017--1029.

  Cook, T (2003): Methods for mid-course corrections in clinical trials
  with survival outcomes.  Stat in Med 22:3431--3447.

  Barthel FMS, Babiker A et al (2006): Evaluation of sample size and power
  for multi-arm survival trials allowing for non-uniform accrual,
  non-proportional hazards, loss to follow-up and cross-over.  Stat in Med
  25:2521--2542.
}
\seealso{
  \code{\link{cpower}}, \code{\link{ciapower}}, \code{\link{bpower}},
  \code{\link[rms]{cph}}, \code{\link[survival]{coxph}},
  \code{\link{labcurve}}
}
\examples{
# Simulate a simple 2-arm clinical trial with exponential survival so
# we can compare power simulations of logrank-Cox test with cpower()
# Hazard ratio is constant and patients enter the study uniformly
# with follow-up ranging from 1 to 3 years
# Drop-in probability is constant at .1 and drop-out probability is
# constant at .175.  Two-year survival of control patients in absence
# of drop-in is .8 (mortality=.2).  Note that hazard rate is -log(.8)/2
# Total sample size (both groups combined) is 1000
# \% mortality reduction by intervention (if no dropin or dropout) is 25
# This corresponds to a hazard ratio of 0.7283 (computed by cpower)


cpower(2, 1000, .2, 25, accrual=2, tmin=1, 
       noncomp.c=10, noncomp.i=17.5)


ranfun <- Quantile2(function(x)exp(log(.8)/2*x),
                    hratio=function(x)0.7283156,
                    dropin=function(x).1,
                    dropout=function(x).175)


rcontrol <- function(n) ranfun(n, what='control')
rinterv  <- function(n) ranfun(n, what='int')
rcens    <- function(n) runif(n, 1, 3)


set.seed(11)   # So can reproduce results
spower(rcontrol, rinterv, rcens, nc=500, ni=500, 
       test=logrank, nsim=50)  # normally use nsim=500 or 1000

\dontrun{
# Run the same simulation but fit the Cox model for each one to
# get log hazard ratios for the purpose of assessing the tightness
# confidence intervals that are likely to result

set.seed(11)
u <- spower(rcontrol, rinterv, rcens, nc=500, ni=500, 
       test=logrank, nsim=50, cox=TRUE)
u
v <- print(u)
v[c('MOElower','MOEupper','SE')]
}

# Simulate a 2-arm 5-year follow-up study for which the control group's
# survival distribution is Weibull with 1-year survival of .95 and
# 3-year survival of .7.  All subjects are followed at least one year,
# and patients enter the study with linearly increasing probability  after that
# Assume there is no chance of dropin for the first 6 months, then the
# probability increases linearly up to .15 at 5 years
# Assume there is a linearly increasing chance of dropout up to .3 at 5 years
# Assume that the treatment has no effect for the first 9 months, then
# it has a constant effect (hazard ratio of .75)


# First find the right Weibull distribution for compliant control patients
sc <- Weibull2(c(1,3), c(.95,.7))
sc


# Inverse cumulative distribution for case where all subjects are followed
# at least a years and then between a and b years the density rises
# as (time - a) ^ d is a + (b-a) * u ^ (1/(d+1))


rcens <- function(n) 1 + (5-1) * (runif(n) ^ .5)
# To check this, type hist(rcens(10000), nclass=50)


# Put it all together


f <- Quantile2(sc, 
      hratio=function(x)ifelse(x<=.75, 1, .75),
      dropin=function(x)ifelse(x<=.5, 0, .15*(x-.5)/(5-.5)),
      dropout=function(x).3*x/5)


par(mfrow=c(2,2))
# par(mfrow=c(1,1)) to make legends fit
plot(f, 'all', label.curves=list(keys='lines'))


rcontrol <- function(n) f(n, 'control')
rinterv  <- function(n) f(n, 'intervention')


set.seed(211)
spower(rcontrol, rinterv, rcens, nc=350, ni=350, 
       test=logrank, nsim=50)  # normally nsim=500 or more
par(mfrow=c(1,1))

# Compose a censoring time generator function such that at 1 year
# 5\% of subjects are accrued, at 3 years 70\% are accured, and at 10
# years 100\% are accrued.  The trial proceeds two years past the last
# accrual for a total of 12 years of follow-up for the first subject.
# Use linear interporation between these 3 points

rcens <- function(n)
{
  times <- c(0,1,3,10)
  accrued <- c(0,.05,.7,1)
  # Compute inverse of accrued function at U(0,1) random variables
  accrual.times <- approx(accrued, times, xout=runif(n))$y
  censor.times <- 12 - accrual.times
  censor.times
}

censor.times <- rcens(500)
# hist(censor.times, nclass=20)
accrual.times <- 12 - censor.times
# Ecdf(accrual.times)
# lines(c(0,1,3,10), c(0,.05,.7,1), col='red')
# spower(..., rcens=rcens, ...)

\dontrun{
# To define a control survival curve from a fitted survival curve
# with coordinates (tt, surv) with tt[1]=0, surv[1]=1:

Scontrol <- function(times, tt, surv) approx(tt, surv, xout=times)$y
tt <- 0:6
surv <- c(1, .9, .8, .75, .7, .65, .64)
formals(Scontrol) <- list(times=NULL, tt=tt, surv=surv)

# To use a mixture of two survival curves, with e.g. mixing proportions
# of .2 and .8, use the following as a guide:
#
# Scontrol <- function(times, t1, s1, t2, s2)
#  .2*approx(t1, s1, xout=times)$y + .8*approx(t2, s2, xout=times)$y
# t1 <- ...; s1 <- ...; t2 <- ...; s2 <- ...;
# formals(Scontrol) <- list(times=NULL, t1=t1, s1=s1, t2=t2, s2=s2)

# Check that spower can detect a situation where generated censoring times
# are later than all failure times

rcens <- function(n) runif(n, 0, 7)
f <- Quantile2(scontrol=Scontrol, hratio=function(x).8, tmax=6)
cont <- function(n) f(n, what='control')
int  <- function(n) f(n, what='intervention')
spower(rcontrol=cont, rinterv=int, rcens=rcens, nc=300, ni=300, nsim=20)

# Do an unstratified logrank test
library(survival)
# From SAS/STAT PROC LIFETEST manual, p. 1801
days <- c(179,256,262,256,255,224,225,287,319,264,237,156,270,257,242,
          157,249,180,226,268,378,355,319,256,171,325,325,217,255,256,
          291,323,253,206,206,237,211,229,234,209)
status <- c(1,1,1,1,1,0,1,1,1,1,0,1,1,1,1,1,1,1,1,0,
            0,rep(1,19))
treatment <- c(rep(1,10), rep(2,10), rep(1,10), rep(2,10))
sex <- Cs(F,F,M,F,M,F,F,M,M,M,F,F,M,M,M,F,M,F,F,M,
          M,M,M,M,F,M,M,F,F,F,M,M,M,F,F,M,F,F,F,F)
data.frame(days, status, treatment, sex)
table(treatment, status)
logrank(Surv(days, status), treatment)  # agrees with p. 1807
# For stratified tests the picture is puzzling.
# survdiff(Surv(days,status) ~ treatment + strata(sex))$chisq
# is 7.246562, which does not agree with SAS (7.1609)
# But summary(coxph(Surv(days,status) ~ treatment + strata(sex)))
# yields 7.16 whereas summary(coxph(Surv(days,status) ~ treatment))
# yields 5.21 as the score test, not agreeing with SAS or logrank() (5.6485)
}
}
\keyword{htest}
\keyword{survival}
\concept{power}
\concept{study design}

\name{event.convert}
\alias{event.convert}
\title{
  Event Conversion for Time-to-Event Data
}
\description{
  Convert a two-column data matrix with event time and event code into
  multiple column event time with one event in each column
}
\usage{
event.convert(data2, event.time = 1, event.code = 2)
}
\arguments{
  \item{data2}{
    a matrix or dataframe with at least 2 columns; by default, the first
    column contains the event time and the second column contains the k
    event codes (e.g. 1=dead, 0=censord)
  }
  \item{event.time}{
    the column number in data contains the event time
  }
  \item{event.code}{
    the column number in data contains the event code
  }
}
\details{
  In the survival analysis, the data typically come  in  two
  columns: one column containing survival time and the other
  containing  censoring  indicator  or   event   code.   The
  \code{event.convert}  function  converts  this  type of data into
  multiple columns of event times, one column of each  event
  type, suitable for the \code{event.chart} function.
}
\author{
  J. Jack Lee and Kenneth R. Hess
  \cr
  Department of Biostatistics
  \cr
  University of Texas
  \cr
  M.D. Anderson Cancer Center
  \cr
  Houston, TX 77030
  \cr
  \email{jjlee@mdanderson.org}, \email{khess@mdanderson.org}


  Joel A. Dubin
  \cr
  Department of Statistics
  \cr
  University of Waterloo
  \cr
  \email{jdubin@uwaterloo.ca}
}
\seealso{
  \code{\link{event.history}}, \code{\link{Date}}, \code{\link{event.chart}}
}
\examples{
# To convert coded time-to-event data, then, draw an event chart:
surv.time <- c(5,6,3,1,2)
cens.ind   <- c(1,0,1,1,0)
surv.data  <- cbind(surv.time,cens.ind)
event.data <- event.convert(surv.data)
event.chart(cbind(rep(0,5),event.data),x.julian=TRUE,x.reference=1)
}
\keyword{hplot}
\keyword{survival}

\name{mdb.get}
\alias{mdb.get}
\title{Read Tables in a Microsoft Access Database}
\description{
  Assuming the \code{mdbtools} package has been installed on your
  system and is in the system path, \code{mdb.get} imports
  one or more tables in a Microsoft Access database.  Date-time
  variables are converted to dates or \code{chron} package date-time
  variables.  The \code{csv.get} function is used to import
  automatically exported csv files.  If \code{tables} 
  is unspecified all tables in the database are retrieved.  If more than
  one table is imported, the result is a list of data frames.
}
\usage{
mdb.get(file, tables=NULL, lowernames=FALSE, allow=NULL,
        dateformat='\%m/\%d/\%y', mdbexportArgs='-b strip', ...)
}
\arguments{
  \item{file}{the file name containing the Access database}
  \item{tables}{character vector specifying the names of tables to
	import.  Default is to import all tables.  Specify
	\code{tables=TRUE} to return the list of available tables.}
  \item{lowernames}{set this to \code{TRUE} to change variable names to
    lower case}
  \item{allow}{a vector of characters allowed by \R that should not be
    converted to periods in variable names.  By default, underscores in
    variable names are converted to periods as with \R before version
    1.9.}
  \item{dateformat}{see \code{\link{cleanup.import}}.  Default is the
		usual Access format used in the U.S.}
	\item{mdbexportArgs}{command line arguments to issue to mdb-export.
		Set to \code{''} to omit \code{'-b strip'}.}
  \item{\dots}{arguments to pass to \code{csv.get}}
}
\details{
  Uses the \code{mdbtools} package executables \code{mdb-tables},
  \code{mdb-schema}, and \code{mdb-export} (with by default option
	\code{-b strip} to drop any binary output).  In Debian/Ubuntu Linux run
  \code{apt get install mdbtools}.
  \code{cleanup.import} is invoked by \code{csv.get} to transform
  variables and store them as efficiently as possible.
}
\value{a new data frame or a list of data frames}
\author{Frank Harrell, Vanderbilt University}
\seealso{
  \code{\link{data.frame}},
  \code{\link{cleanup.import}}, \code{\link{csv.get}},
  \code{\link{Date}}, \code{\link[chron]{chron}}
}
\examples{
\dontrun{
# Read all tables in the Microsoft Access database Nwind.mdb
d <- mdb.get('Nwind.mdb')
contents(d)
for(z in d) print(contents(z))
# Just print the names of tables in the database
mdb.get('Nwind.mdb', tables=TRUE)
# Import one table
Orders <- mdb.get('Nwind.mdb', tables='Orders')
}
}
\keyword{manip}
\keyword{IO}
\keyword{file}

\name{legendfunctions}
\alias{legendfunctions}
\alias{Key}
\alias{sKey}
\alias{Key2}
\title{Legend Creation Functions}
\description{
  Wrapers to plot defined legend ploting functions
}
\usage{
Key(...)
Key2(...)
sKey(...)
}
\arguments{
  \item{\dots}{arguments to pass to wrapped functions}
}

\name{escapeRegex}
\alias{escapeRegex}
\alias{escapeBS}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Escapes any characters that would have special meaning in a reqular expression. }
\description{
  Escapes any characters that would have special meaning in a reqular expression.
}
\usage{
escapeRegex(string)
escapeBS(string)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{string}{ string being operated on. }
}
\details{
  \code{escapeRegex} will escape any characters that would have
  special meaning in a reqular expression. For any string
  \code{grep(regexpEscape(string), string)} will always be true.

  \code{escapeBS} will escape any backslash \samp{\\} in a string.
}
\value{
  The value of the string with any characters that would have
  special meaning in a reqular expression escaped.
}
\author{
  Charles Dupont\cr
  Department of Biostatistics\cr
  Vanderbilt University
}
\seealso{\code{\link[base]{grep}} }
\examples{
string <- "this\\\\(system) {is} [full]."
escapeRegex(string)

escapeBS(string)

\dontshow{
if(!any(grep(escapeRegex(string), string))) {
  stop("function escapeRegex failed test")
}

if(escapeBS(string) != "this\\\\\\\\(system) {is} [full].") {
  stop("function escapeBS failed test")
}
}
}
\keyword{ manip }% at least one, from doc/KEYWORDS
\keyword{ character }% __ONLY ONE__ keyword per line
\keyword{ programming }

\name{ggfreqScatter}
\alias{ggfreqScatter}
\title{Frequency Scatterplot}
\description{
Uses \code{ggplot2} to plot a scatterplot or dot-like chart for the case
where there is a very large number of overlapping values.  This works
for continuous and categorical \code{x} and \code{y}.  For continuous
variables it serves the same purpose as hexagonal binning.  Counts for
overlapping points are grouped into quantile groups and level of
transparency and rainbow colors are used to provide count information.

Instead, you can specify \code{stick=TRUE} not use color but to encode
	cell frequencies 
	with the height of a black line y-centered at the middle of the bins.
	Relative frequencies are not transformed, and the maximum cell
	frequency is shown in a caption.  Every point with at least a
	frequency of one is depicted with a full-height light gray vertical
	line, scaled to the above overall maximum frequency.  In this way to
	relative frequency is to proportion of these light gray lines that are
	black, and one can see points whose frequencies are too low to see the
	black lines.

The result can also be passed to \code{ggplotly}.  Actual cell
frequencies are added to the hover text in that case using the
\code{label} \code{ggplot2} aesthetic.
}
\usage{
ggfreqScatter(x, y, by=NULL, bins=50, g=10, cuts=NULL,
              xtrans = function(x) x,
              ytrans = function(y) y,
              xbreaks = pretty(x, 10),
              ybreaks = pretty(y, 10),
              xminor  = NULL, yminor = NULL,
              xlab = as.character(substitute(x)),
              ylab = as.character(substitute(y)),
              fcolors = viridisLite::viridis(10), nsize=FALSE,
              stick=FALSE, html=FALSE, prfreq=FALSE, \dots)
}
\arguments{
\item{x}{x-variable}
\item{y}{y-variable}
\item{by}{an optional vector used to make separate plots for each
	distinct value using \code{facet_wrap()}}
\item{bins}{for continuous \code{x} or \code{y} is the number of bins to
	create by rounding.  Ignored for categorical variables.  If a
	2-vector, the first element corresponds to \code{x} and the second to
	\code{y}.}
\item{g}{number of quantile groups to make for frequency counts.  Use
	\code{g=0} to use frequencies continuously for color 
	coding.  This is recommended only when using \code{plotly}.}
\item{cuts}{instead of using \code{g}, specify \code{cuts} to provide
	the vector of cuts for categorizing frequencies for assignment to colors}
\item{xtrans,ytrans}{functions specifying transformations to be made
	before binning and plotting}
\item{xbreaks,ybreaks}{vectors of values to label on axis, on original
	scale}
\item{xminor,yminor}{values at which to put minor tick marks, on
	original scale}
\item{xlab,ylab}{axis labels.  If not specified and variable has a
	\code{label}, thatu label will be used.}
\item{fcolors}{\code{colors} argument to pass to
	\code{scale_color_gradientn} to color code frequencies.  Use
	\code{fcolors=gray.colors(10, 0.75, 0)} to show gray
	scale, for example.  Another good choice is
	\code{fcolors=hcl.colors(10, 'Blue-Red')}.} 
\item{nsize}{set to \code{TRUE} to not vary color or transparency but
	instead to size the symbols in relation to the number of points.  Best
	with both \code{x} and \code{y} are discrete.  \code{ggplot2}
	\code{size} is taken as the fourth root of the frequency.  If there
	are 15 or unique frequencies all the unique frequencies are used,
	otherwise \code{g} quantile groups of frequencies are used.}
\item{stick}{set to \code{TRUE} to not use colors but instead use
	varying-height black vertical lines to depict cell frequencies.}
\item{html}{set to \code{TRUE} to use html in axis labels instead of
	plotmath}
\item{prfreq}{set to \code{TRUE} to print the frequency distributions of
	the binned coordinate frequencies}
\item{\dots}{arguments to pass to \code{geom_point} such as \code{shape}
	and \code{size}}
}
\value{a \code{ggplot} object}
\author{Frank Harrell}
\seealso{\code{\link[Hmisc]{cut2}}}
\examples{
require(ggplot2)
set.seed(1)
x <- rnorm(1000)
y <- rnorm(1000)
count <- sample(1:100, 1000, TRUE)
x <- rep(x, count)
y <- rep(y, count)
# color=alpha=NULL below makes loess smooth over all points
g <- ggfreqScatter(x, y) +   # might add g=0 if using plotly
      geom_smooth(aes(color=NULL, alpha=NULL), se=FALSE) +
      ggtitle("Using Deciles of Frequency Counts, 2500 Bins")
g
# plotly::ggplotly(g, tooltip='label')  # use plotly, hover text = freq. only
# Plotly makes it somewhat interactive, with hover text tooltips

# Instead use varying-height sticks to depict frequencies
ggfreqScatter(x, y, stick=TRUE) +
 labs(subtitle='Relative height of black lines to gray lines
is proportional to cell frequency.
Note that points with even tiny frequency are visable
(gray line with no visible black line).')


# Try with x categorical
x1 <- sample(c('cat', 'dog', 'giraffe'), length(x), TRUE)
ggfreqScatter(x1, y)

# Try with y categorical
y1 <- sample(LETTERS[1:10], length(x), TRUE)
ggfreqScatter(x, y1)

# Both categorical, larger point symbols, box instead of circle
ggfreqScatter(x1, y1, shape=15, size=7)
# Vary box size instead
ggfreqScatter(x1, y1, nsize=TRUE, shape=15)
}
\keyword{hplot}
\concept{grouping}
\concept{categorization}
\concept{discretization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gbayesSeqSim.r
\name{estSeqSim}
\alias{estSeqSim}
\title{estSeqSim}
\usage{
estSeqSim(parameter, looks, gendat, fitter, nsim = 1, progress = FALSE)
}
\arguments{
\item{parameter}{vector of true parameter (effects; group differences) values}

\item{looks}{integer vector of observation numbers at which posterior probabilities are computed}

\item{gendat}{a function of three arguments: true parameter value (scalar), sample size for first group, sample size for second group}

\item{fitter}{a function of two arguments: 0/1 group indicator vector and the dependent variable vector}

\item{nsim}{number of simulations (default is 1)}

\item{progress}{set to \code{TRUE} to send current iteration number to the console}
}
\value{
a data frame with number of rows equal to the product of \code{nsim}, the length of \code{looks}, and the length of \code{parameter}.
}
\description{
Simulate Comparisons For Use in Sequential Clinical Trial Simulations
}
\details{
Simulates sequential clinical trials.  Looks are done sequentially at observation numbers given in the vector \code{looks} with the earliest possible look being at observation 2.  For each true effect parameter value, simulation, and at each look, runs a function to compute the estimate of the parameter of interest along with its variance.  For each simulation, data are first simulated for the last look, and these data are sequentially revealed for earlier looks.  The user provides a function \code{gendat} that given a true effect of \code{parameter} and the two sample sizes (for treatment groups 1 and 2) returns a list with vectors \code{y1} and \code{y2} containing simulated data.  The user also provides a function \code{fitter} with arguments \code{x} (group indicator 0/1) and \code{y} (response variable) that returns a 2-vector containing the effect estimate and its variance.  \code{parameter} is usually on the scale of a regression coefficient, e.g., a log odds ratio.
}
\examples{
if (requireNamespace("rms", quietly = TRUE)) {
  # Run 50 simulations, 5 looks, 2 true parameter values
  # Total simulation time: 2s
  lfit <- function(x, y) {
  f <- rms::lrm.fit(x, y)
    k <- length(coef(f))
    c(coef(f)[k], vcov(f)[k, k])
  }
  gdat <- function(beta, n1, n2) {
    # Cell probabilities for a 7-category ordinal outcome for the control group
    p <- c(2, 1, 2, 7, 8, 38, 42) / 100

    # Compute cell probabilities for the treated group
    p2 <- pomodm(p=p, odds.ratio=exp(beta))
    y1 <- sample(1 : 7, n1, p,  replace=TRUE)
    y2 <- sample(1 : 7, n2, p2, replace=TRUE)
    list(y1=y1, y2=y2)
  }

  set.seed(1)
  est <- estSeqSim(c(0, log(0.7)), looks=c(50, 75, 95, 100, 200),
                    gendat=gdat,
                    fitter=lfit, nsim=50)
  head(est)
}
}
\seealso{
\code{gbayesSeqSim()}, \code{simMarkovOrd()}, \code{estSeqMarkovOrd()}
}
\author{
Frank Harrell
}

\name{trunc.POSIXt}
\alias{truncPOSIXt}
\alias{ceil.POSIXt}
\alias{ceil}
\alias{ceil.default}
\alias{roundPOSIXt}
\title{Return the floor, ceiling, or rounded value of date or time to
  specified unit.}
\description{
  \code{truncPOSIXt} returns the date truncated to the specified unit.
  \code{ceil.POSIXt} returns next ceiling of the date at the unit selected in
  \code{units}.
  \code{roundPOSIXt} returns the date or time value rounded to nearest
  specified unit selected in \code{digits}.

  \code{truncPOSIXt} and \code{roundPOSIXt} have been extended from
  the \code{base} package functions \code{trunc.POSIXt} and
  \code{round.POSIXt} which in the future will add the other time units
  we need.
}
\usage{
ceil(x, units,\dots)
\method{ceil}{default}(x, units, \dots)
truncPOSIXt(x, units = c("secs", "mins", "hours", "days",
"months", "years"), \dots)
\method{ceil}{POSIXt}(x, units = c("secs", "mins", "hours", "days",
"months", "years"), \dots)
roundPOSIXt(x, digits = c("secs", "mins", "hours", "days", "months", "years"))
}
\arguments{
  \item{x}{ date to be ceilinged, truncated, or rounded }
  \item{units}{ unit to that is is rounded up or down to. }
  \item{digits}{
    same as \code{units} but different name to be compatible
    with \code{\link{round}} generic.
  }
  \item{\dots}{further arguments to be passed to or from other methods.}
}
\value{
  An object of class \code{POSIXlt}.
}
\author{ Charles Dupont }
\seealso{ \code{\link{Date}} \code{\link{POSIXt}} \code{\link{POSIXlt}} \code{\link{DateTimeClasses}}}
\examples{
date <- ISOdate(1832, 7, 12)
ceil(date, units='months')  # '1832-8-1'
truncPOSIXt(date, units='years')     # '1832-1-1'
roundPOSIXt(date, digits='months')    # '1832-7-1'
}
\keyword{ manip }
\keyword{ utilities }
\keyword{ chron }

\name{list.tree}
\alias{list.tree}
\title{
Pretty-print the Structure of a Data Object
}
\description{
This is a function to pretty-print the structure of any data object
(usually a list).  It is similar to the R function \code{str}.
}
\usage{
list.tree(struct, depth=-1, numbers=FALSE, maxlen=22, maxcomp=12, 
          attr.print=TRUE, front="", fill=". ", name.of, size=TRUE)
}
\arguments{
\item{struct}{
The object to be displayed
}
\item{depth}{
Maximum depth of recursion (of lists within lists \dots) to be printed; negative
value means no limit on depth.
}
\item{numbers}{
If TRUE, use numbers in leader  instead  of  dots  to
represent position in structure.
}
\item{maxlen}{
Approximate maximum length (in characters) allowed on each line to give the
first few values of a vector.  maxlen=0 suppresses printing any values.
}
\item{maxcomp}{
Maximum number of components of any list that will be described.
}
\item{attr.print}{
Logical flag, determining whether a description of attributes will be printed.
}
\item{front}{
Front material of a line, for internal use.
}
\item{fill}{
Fill character used for each level of indentation.
}
\item{name.of}{
Name of object, for internal use (deparsed version  of  struct  by  default). 
}
\item{size}{
Logical flag, should the size of the object in bytes be printed?


A description of the structure of struct will be printed in outline
form, with indentation
for each level of recursion, showing the internal storage mode, length,
class(es) if any, attributes, and first few elements of each data vector.
By default each level of list recursion is indicated by a "." and 
attributes by "A".
}}
\seealso{
\code{\link{str}}
}
\examples{
X <- list(a=ordered(c(1:30,30:1)),b=c("Rick","John","Allan"),
          c=diag(300),e=cbind(p=1008:1019,q=4))
list.tree(X)
# In R you can say str(X)
}
\author{
Alan Zaslavsky, \email{zaslavsk@hcp.med.harvard.edu}
}
\keyword{documentation}
% Converted by Sd2Rd version 1.21.

\name{reShape}
\alias{reShape}
\title{Reshape Matrices and Serial Data}
\description{
  If the first argument is a matrix, \code{reShape} strings out its values
  and creates row and column vectors specifying the row and column each
  element came from.  This is useful for sending matrices to Trellis
  functions, for analyzing or plotting results of \code{table} or
  \code{crosstabs}, or for reformatting serial data stored in a matrix (with
  rows representing multiple time points) into vectors.  The number of
  observations in the new variables will be the product of the number of
  rows and number of columns in the input matrix.  If the first
  argument is a vector, the \code{id} and \code{colvar} variables are used to
  restructure it into a matrix, with \code{NA}s for elements that corresponded
  to combinations of \code{id} and \code{colvar} values that did not exist in the
  data.  When more than one vector is given, multiple matrices are
  created.  This is useful for restructuring irregular serial data into
  regular matrices.  It is also useful for converting data produced by
  \code{expand.grid} into a matrix (see the last example).  The number of
  rows of the new matrices equals the number of unique values of \code{id},
  and the number of columns equals the number of unique values of
  \code{colvar}.

  When the first argument is a vector and the \code{id} is a data frame
  (even with only one variable),
  \code{reShape} will produce a data frame, and the unique groups are
  identified by combinations of the values of all variables in \code{id}.
  If a data frame \code{constant} is specified, the variables in this data
  frame are assumed to be constant within combinations of \code{id}
  variables (if not, an arbitrary observation in \code{constant} will be
  selected for each group).  A row of \code{constant} corresponding to the
  target \code{id} combination is then carried along when creating the
  data frame result.

  A different behavior of \code{reShape} is achieved when \code{base} and \code{reps}
  are specified.  In that case \code{x} must be a list or data frame, and
  those data are assumed to contain one or more non-repeating
  measurements (e.g., baseline measurements) and one or more repeated
  measurements represented by variables named by pasting together the
  character strings in the vector \code{base} with the integers 1, 2, \dots,
  \code{reps}.  The input data are rearranged by repeating each value of the
  baseline variables \code{reps} times and by transposing each observation's
  values of one of the set of repeated measurements as \code{reps}
  observations under the variable whose name does not have an integer
  pasted to the end.  if \code{x} has a \code{row.names} attribute, those
  observation identifiers are each repeated \code{reps} times in the output
  object.  See the last example.
}
\usage{
reShape(x, \dots, id, colvar, base, reps, times=1:reps,
        timevar='seqno', constant=NULL)
}
\arguments{
  \item{x}{
    a matrix or vector, or, when \code{base} is specified, a list or data frame
  }
  \item{\dots}{
    other optional vectors, if \code{x} is a vector
  }
  \item{id}{
    A numeric, character, category, or factor variable containing subject
    identifiers, or a data frame of such variables that in combination form
    groups of interest.  Required if \code{x} is a vector, ignored otherwise.
  }
  \item{colvar}{
    A numeric, character, category, or factor variable containing column
    identifiers.  \code{colvar} is using a "time of data collection" variable.
    Required if \code{x} is a vector, ignored otherwise.
  }
  \item{base}{
    vector of character strings containing base names of repeated
    measurements
  }
  \item{reps}{
    number of times variables named in \code{base} are repeated.  This must be
    a constant.
  }
  \item{times}{
    when \code{base} is given, \code{times} is the vector of times to create
    if you do not want to use consecutive integers beginning with 1.
  }
  \item{timevar}{
    specifies the name of the time variable to create if \code{times} is
    given, if you do not want to use \code{seqno}
  }
  \item{constant}{
    a data frame with the same number of rows in \code{id} and \code{x},
    containing auxiliary information to be merged into the resulting data
    frame.  Logically, the rows of \code{constant} within each group
    should have the same value of all of its variables.
  }
}
\value{
  If \code{x} is a matrix, returns a list containing the row variable, the
  column variable, and the \code{as.vector(x)} vector, named the same as the
  calling argument was called for \code{x}.  If \code{x} is a vector and no other
  vectors were specified as \code{\dots}, the result is a matrix.  If at least
  one vector was given to \code{\dots}, the result is a list containing \code{k}
  matrices, where \code{k} one plus the number of vectors in \code{\dots}.  If \code{x}
  is a list or data frame, the same type of object is returned.  If
  \code{x} is a vector and \code{id} is a data frame, a data frame will be
  the result.
}
\details{
  In converting \code{dimnames} to vectors, the resulting variables are
  numeric if all elements of the matrix dimnames can be converted to
  numeric, otherwise the corresponding row or column variable remains
  character.  When the \code{dimnames} if \code{x} have a \code{names} attribute, those
  two names become the new variable names.  If \code{x} is a vector and
  another vector is also given (in \code{\dots}), the matrices in the resulting
  list are named the same as the input vector calling arguments.  You
  can specify customized names for these on-the-fly by using
  e.g. \code{reShape(X=x, Y=y, id= , colvar= )}.  The new names will then be
  \code{X} and \code{Y} instead of \code{x} and \code{y}.   A new variable named \code{seqnno} is
  also added to the resulting object.  \code{seqno} indicates the sequential
  repeated measurement number.  When \code{base} and \code{times} are
  specified, this new variable is named the character value of \code{timevar} and the values
  are given by a table lookup into the vector \code{times}.
}
\author{
Frank Harrell\cr
Department of Biostatistics\cr
Vanderbilt University School of Medicine\cr
\email{fh@fharrell.com}
}
\seealso{
  \code{\link[stats]{reshape}}, \code{\link[base:vector]{as.vector}},
  \code{\link[base]{matrix}}, \code{\link[base]{dimnames}},
  \code{\link[base]{outer}}, \code{\link[base]{table}}
}
\examples{
set.seed(1)
Solder  <- factor(sample(c('Thin','Thick'),200,TRUE),c('Thin','Thick'))
Opening <- factor(sample(c('S','M','L'),  200,TRUE),c('S','M','L'))

tab <- table(Opening, Solder)
tab
reShape(tab)
# attach(tab)  # do further processing

# An example where a matrix is created from irregular vectors
follow <- data.frame(id=c('a','a','b','b','b','d'),
                     month=c(1, 2,  1,  2,  3,  2),
                     cholesterol=c(225,226, 320,319,318, 270))
follow
attach(follow)
reShape(cholesterol, id=id, colvar=month)
detach('follow')
# Could have done :
# reShape(cholesterol, triglyceride=trig, id=id, colvar=month)

# Create a data frame, reshaping a long dataset in which groups are
# formed not just by subject id but by combinations of subject id and
# visit number.  Also carry forward a variable that is supposed to be
# constant within subject-visit number combinations.  In this example,
# it is not constant, so an arbitrary visit number will be selected.
w <- data.frame(id=c('a','a','a','a','b','b','b','d','d','d'),
             visit=c(  1,  1,  2,  2,  1,  1,  2,  2,  2,  2),
                 k=c('A','A','B','B','C','C','D','E','F','G'),
               var=c('x','y','x','y','x','y','y','x','y','z'),
               val=1:10)
with(w,
     reShape(val, id=data.frame(id,visit),
             constant=data.frame(k), colvar=var))

# Get predictions from a regression model for 2 systematically
# varying predictors.  Convert the predictions into a matrix, with
# rows corresponding to the predictor having the most values, and
# columns corresponding to the other predictor
# d <- expand.grid(x2=0:1, x1=1:100)
# pred <- predict(fit, d)
# reShape(pred, id=d$x1, colvar=d$x2)  # makes 100 x 2 matrix


# Reshape a wide data frame containing multiple variables representing
# repeated measurements (3 repeats on 2 variables; 4 subjects)
set.seed(33)
n <- 4
w <- data.frame(age=rnorm(n, 40, 10),
                sex=sample(c('female','male'), n,TRUE),
                sbp1=rnorm(n, 120, 15),
                sbp2=rnorm(n, 120, 15),
                sbp3=rnorm(n, 120, 15),
                dbp1=rnorm(n,  80, 15),
                dbp2=rnorm(n,  80, 15),
                dbp3=rnorm(n,  80, 15), row.names=letters[1:n])
options(digits=3)
w


u <- reShape(w, base=c('sbp','dbp'), reps=3)
u
reShape(w, base=c('sbp','dbp'), reps=3, timevar='week', times=c(0,3,12))
}
\keyword{manip}
\keyword{array}
\concept{trellis}
\concept{lattice}
\concept{repeated measures}
\concept{longitudinal data}

\name{csv.get}
\alias{csv.get}
\title{Read Comma-Separated Text Data Files}
\description{
  Read comma-separated text data files, allowing optional translation
  to lower case for variable names after making them valid S names.
  There is a facility for reading long variable labels as one of the
  rows.  If labels are not specified and a final variable name is not
  the same as that in the header, the original variable name is saved as
  a variable label.  Uses \code{read.csv} if the \code{data.table}
	package is not in effect, otherwise calls \code{fread}.
}
\usage{
csv.get(file, lowernames=FALSE, datevars=NULL, datetimevars=NULL,
        dateformat='\%F',
        fixdates=c('none','year'), comment.char="", autodate=TRUE,
        allow=NULL, charfactor=FALSE,
        sep=',', skip=0, vnames=NULL, labels=NULL, text=NULL, \dots)
}
\arguments{
  \item{file}{the file name for import.}
  \item{lowernames}{set this to \code{TRUE} to change variable names to
    lower case.}
  \item{datevars}{character vector of names (after \code{lowernames} is
    applied) of variables to consider as a factor or character vector
    containing dates in a format matching \code{dateformat}.  The
    default is \code{"\%F"} which uses the yyyy-mm-dd format.}
  \item{datetimevars}{character vector of names (after \code{lowernames}
	is applied) of variables to consider to be date-time variables, with
	date formats as described under \code{datevars} followed by a space
	followed by time in hh:mm:ss format.  \code{chron} is used to store
	such variables.  If all times in the variable
	are 00:00:00 the variable will be converted to an ordinary date variable.}
  \item{dateformat}{for \code{cleanup.import} is the input format (see
    \code{\link{strptime}})}
  \item{fixdates}{for any of the variables listed in \code{datevars}
    that have a \code{dateformat} that \code{cleanup.import} understands,
    specifying \code{fixdates} allows corrections of certain formatting
    inconsistencies before the fields are attempted to be converted to
    dates (the default is to assume that the \code{dateformat} is followed
    for all observation for \code{datevars}).  Currently
    \code{fixdates='year'} is implemented, which will cause 2-digit or
    4-digit years to be shifted to the alternate number of digits when
    \code{dateform} is the default \code{"\%F"} or is \code{"\%y-\%m-\%d"},
    \code{"\%m/\%d/\%y"}, or \code{"\%m/\%d/\%Y"}.  Two-digits years are
	padded with \code{20} on the left.  Set \code{dateformat} to the
	desired format, not the exceptional format.}
  \item{comment.char}{a character vector of length one containing a
    single character or an empty string.  Use '""' to turn off the
    interpretation of comments altogether.}
  \item{autodate}{Set to true to allow function to guess at which
    variables are dates}
  \item{allow}{a vector of characters allowed by \R that should not be
    converted to periods in variable names.  By default, underscores in
    variable names are converted to periods as with \R before version
    1.9.}
  \item{charfactor}{set to \code{TRUE} to change character variables to
	factors if they have fewer than n/2 unique values.  Blanks and null
	strings are converted to \code{NA}s.}
  \item{sep}{field separator, defaults to comma}
  \item{skip}{number of records to skip before data start.  Required if
	\code{vnames} or \code{labels} is given.}
  \item{vnames}{number of row containing variable names, default is one}
  \item{labels}{number of row containing variable labels, default is no
		labels}
	\item{text}{a character string containing the \code{.csv} file to use
		instead of \code{file=}.  Passed to \code{read.csv} as the
		\code{text=} argument.}
  \item{\dots}{arguments to pass to \code{read.csv} other than
	\code{skip} and \code{sep}.}
}
\details{
  \code{csv.get} reads comma-separated text data files, allowing optional
  translation to lower case for variable names after making them valid S
  names.  Original possibly non-legal names are taken to be variable
  labels if \code{labels} is not specified.  Character or factor
  variables containing dates can be converted to date variables.
  \code{cleanup.import} is invoked to finish the job.
}
\value{a new data frame.}
\author{Frank Harrell, Vanderbilt University}
\seealso{
  \code{\link{sas.get}}, \code{\link{data.frame}},
  \code{\link{cleanup.import}}, \code{\link{read.csv}},
  \code{\link{strptime}}, \code{\link{POSIXct}}, \code{\link{Date}},
	\code{\link[data.table]{fread}}
}
\examples{
\dontrun{
dat <- csv.get('myfile.csv')

# Read a csv file with junk in the first row, variable names in the
# second, long variable labels in the third, and junk in the 4th row
dat <- csv.get('myfile.csv', vnames=2, labels=3, skip=4)
}
}
\keyword{manip}
\keyword{IO}
\keyword{file}

\name{varclus}
\alias{varclus}
\alias{print.varclus}
\alias{plot.varclus}
\alias{naclus}
\alias{naplot}
\alias{combine.levels}
\alias{plotMultSim}
\alias{na.pattern}
\title{
Variable Clustering
}
\description{
Does a hierarchical cluster analysis on variables, using the Hoeffding
D statistic, squared Pearson or Spearman correlations, or proportion
of observations for which two variables are both positive as similarity
measures.  Variable clustering is used for assessing collinearity,
redundancy, and for separating variables into clusters that can be
scored as a single variable, thus resulting in data reduction.  For
computing any of the three similarity measures, pairwise deletion of
NAs is done.  The clustering is done by \code{hclust()}.  A small function
\code{naclus} is also provided which depicts similarities in which
observations are missing for variables in a data frame.  The
similarity measure is the fraction of \code{NAs} in common between any two
variables.  The diagonals of this \code{sim} matrix are the fraction of NAs
in each variable by itself.  \code{naclus} also computes \code{na.per.obs}, the
number of missing variables in each observation, and \code{mean.na}, a
vector whose ith element is the mean number of missing variables other
than variable i, for observations in which variable i is missing.  The
\code{naplot} function makes several plots (see the \code{which} argument).

So as to not generate too many dummy variables for multi-valued
character or categorical predictors, \code{varclus} will automatically
combine infrequent cells of such variables using an auxiliary
function \code{combine.levels} that is defined here.  If all values of
\code{x} are \code{NA}, \code{combine.levels} returns a numeric vector
is returned that is all \code{NA}. 

\code{plotMultSim} plots multiple similarity matrices, with the similarity
measure being on the x-axis of each subplot.

\code{na.pattern} prints a frequency table of all combinations of
missingness for multiple variables.  If there are 3 variables, a
frequency table entry labeled \code{110} corresponds to the number of
observations for which the first and second variables were missing but
the third variable was not missing.
}
\usage{
varclus(x, similarity=c("spearman","pearson","hoeffding","bothpos","ccbothpos"),
        type=c("data.matrix","similarity.matrix"), 
        method="complete",
        data=NULL, subset=NULL, na.action=na.retain,
        trans=c("square", "abs", "none"), ...)
\method{print}{varclus}(x, abbrev=FALSE, ...)
\method{plot}{varclus}(x, ylab, abbrev=FALSE, legend.=FALSE, loc, maxlen, labels, \dots)

naclus(df, method)
naplot(obj, which=c('all','na per var','na per obs','mean na',
                    'na per var vs mean na'), \dots)

combine.levels(x, minlev=.05)

plotMultSim(s, x=1:dim(s)[3],
            slim=range(pretty(c(0,max(s,na.rm=TRUE)))),
            slimds=FALSE,
            add=FALSE, lty=par('lty'), col=par('col'),
            lwd=par('lwd'), vname=NULL, h=.5, w=.75, u=.05,
            labelx=TRUE, xspace=.35)

na.pattern(x)
}
\arguments{
\item{x}{
a formula,
a numeric matrix of predictors, or a similarity matrix.  If \code{x} is
a formula, \code{model.matrix} is used to convert it to a design matrix.
If the formula excludes an intercept (e.g., \code{~ a + b -1}),
the first categorical (\code{factor}) variable in the formula will have
dummy variables generated for all levels instead of omitting one for
the first level. For \code{combine.levels}, \code{x} is a character, category,
or factor vector (or other vector that is converted to factor).  For
\code{plot} and \code{print}, \code{x} is an object created by
\code{varclus}.  For \code{na.pattern}, \code{x} is a list, data frame,
or numeric matrix.

For \code{plotMultSim}, is a numeric vector specifying the ordered
unique values on the x-axis, corresponding to the third dimension of
\code{s}.
}
\item{df}{a data frame}
\item{s}{
an array of similarity matrices.  The third dimension of this array
corresponds to different computations of similarities.  The first two
dimensions come from a single similarity matrix.  This is useful for
displaying similarity matrices computed by \code{varclus}, for example.  A
use for this might be to show pairwise similarities of variables
across time in a longitudinal study (see the example below).  If
\code{vname} is not given, \code{s} must have \code{dimnames}.
}
\item{similarity}{
the default is to use squared Spearman correlation coefficients, which
will detect monotonic but nonlinear relationships.  You can also
specify linear correlation or Hoeffding's (1948) D statistic, which
has the advantage of being sensitive to many types
of dependence, including highly non-monotonic relationships.  For
binary data, or data to be made binary, \code{similarity="bothpos"} uses as
a similarity measure the proportion of observations for which two
variables are both positive.  \code{similarity="ccbothpos"} uses a
chance-corrected measure which is the proportion of observations for
which both variables are positive minus the product of the two
marginal proportions.  This difference is expected to be zero under
independence.  For diagonals, \code{"ccbothpos"} still uses the proportion
of positives for the single variable.  So \code{"ccbothpos"} is not really
a similarity measure, and clustering is not done.  This measure is
useful for plotting with \code{plotMultSim} (see the last example).
}
\item{type}{
if \code{x} is not a formula, it may be a data matrix or a similarity matrix.
By default, it is assumed to be a data matrix.
}
\item{method}{
see \code{hclust}.  The default, for both \code{varclus} and \code{naclus}, is
\code{"compact"} (for \R it is \code{"complete"}).
}
\item{data}{
}
\item{subset}{
}
\item{na.action}{
These may be specified if \code{x} is a formula.  The default
\code{na.action} is \code{na.retain}, defined by \code{varclus}.  This
causes all observations to be kept in the model frame, with later
pairwise deletion of \code{NA}s.}
\item{trans}{By default, when the similarity measure is based on
	Pearson's or Spearman's correlation coefficients, the coefficients are
	squared.  Specify \code{trans="abs"} to take absolute values or
	\code{trans="none"} to use the coefficients as they stand.}
\item{...}{for \code{varclus} these are optional arguments to pass to
  the \code{\link{dataframeReduce}} function.  Otherwise,
passed to \code{plclust} (or to \code{dotchart} or \code{dotchart2} for
\code{naplot}).
}
\item{ylab}{
y-axis label.  Default is constructed on the basis of \code{similarity}.
}
\item{legend.}{
set to \code{TRUE} to plot a legend defining the abbreviations
}
\item{loc}{
a list with elements \code{x} and \code{y} defining coordinates of the
upper left corner of the legend.  Default is \code{locator(1)}.
}
\item{maxlen}{
if a legend is plotted describing abbreviations, original labels
longer than \code{maxlen} characters are truncated at \code{maxlen}.
}
\item{labels}{
a vector of character strings containing labels corresponding to
columns in the similar matrix, if the column names of that matrix are
not to be used
}
\item{obj}{an object created by \code{naclus}}
\item{which}{
defaults to \code{"all"} meaning to have \code{naplot} make 4 separate
plots.  To 
make only one of the plots, use \code{which="na per var"} (dot chart of
fraction of NAs for each variable), ,\code{"na per obs"} (dot chart showing
frequency distribution of number of variables having NAs in an
observation), \code{"mean na"} (dot chart showing mean number of other
variables missing when the indicated variable is missing), or 
\code{"na per var vs mean na"}, a scatterplot showing on the x-axis the
fraction of NAs in the variable and on the y-axis the mean number of
other variables that are NA when the indicated variable is NA.
}
\item{minlev}{
the minimum proportion of observations in a cell before that cell is
combined with one or more cells.  If more than one cell has fewer than
minlev*n observations, all such cells are combined into a new cell
labeled \code{"OTHER"}.  Otherwise, the lowest frequency cell is combined
with the next lowest frequency cell, and the level name is the
combination of the two old level levels.
}
\item{abbrev}{
set to \code{TRUE} to abbreviate variable names for plotting or
printing.  Is set to \code{TRUE} automatically if \code{legend=TRUE}.
}
\item{slim}{
2-vector specifying the range of similarity values for scaling the
y-axes.  By default this is the observed range over all of \code{s}.
}
\item{slimds}{set to \code{slimds} to \code{TRUE} to scale diagonals and
off-diagonals separately}
\item{add}{
set to \code{TRUE} to add similarities to an existing plot (usually
specifying \code{lty} or \code{col})
}
\item{lty}{
}
\item{col}{
}
\item{lwd}{
line type, color, or line thickness for \code{plotMultSim}
}
\item{vname}{
optional vector of variable names, in order, used in \code{s}
}
\item{h}{
relative height for subplot
}
\item{w}{
relative width for subplot
}
\item{u}{
relative extra height and width to leave unused inside the subplot.
Also used as the space between y-axis tick mark labels and graph border.
}
\item{labelx}{
  set to \code{FALSE} to suppress drawing of labels in the x direction
}
\item{xspace}{
  amount of space, on a scale of 1:\code{n} where \code{n} is the number
  of variables, to set aside for y-axis labels
}
}
\value{
for \code{varclus} or \code{naclus}, a list of class \code{varclus} with elements
\code{call} (containing the calling statement), \code{sim} (similarity matrix),
\code{n} (sample size used if \code{x} was not a correlation matrix already -
\code{n} is a matrix), \code{hclust}, the object created by \code{hclust},
\code{similarity}, and \code{method}.  \code{naclus} also returns the
two vectors listed under 
description, and \code{naplot} returns an invisible vector that is the
frequency table of the number of missing variables per observation.
\code{plotMultSim} invisibly returns the limits of similarities used in
constructing the y-axes of each subplot.  For \code{similarity="ccbothpos"}
the \code{hclust} object is \code{NULL}.

\code{na.pattern} creates an integer vector of frequencies.
}
\details{
\code{options(contrasts= c("contr.treatment", "contr.poly"))} is issued 
temporarily by \code{varclus} to make sure that ordinary dummy variables
are generated for \code{factor} variables.  Pass arguments to the
\code{\link{dataframeReduce}} function to remove problematic variables
(especially if analyzing all variables in a data frame).
}
\author{
Frank Harrell
\cr
Department of Biostatistics, Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\section{Side Effects}{
plots
}
\references{
Sarle, WS: The VARCLUS Procedure.  SAS/STAT User's Guide, 4th Edition,
1990.  Cary NC: SAS Institute, Inc.


Hoeffding W. (1948): A non-parametric test of independence.  Ann Math Stat
19:546--57.
}
\seealso{
\code{\link{hclust}}, \code{\link{plclust}}, \code{\link{hoeffd}}, \code{\link{rcorr}}, \code{\link{cor}}, \code{\link{model.matrix}},
\code{\link{locator}}, \code{\link{na.pattern}}
}
\examples{
set.seed(1)
x1 <- rnorm(200)
x2 <- rnorm(200)
x3 <- x1 + x2 + rnorm(200)
x4 <- x2 + rnorm(200)
x <- cbind(x1,x2,x3,x4)
v <- varclus(x, similarity="spear")  # spearman is the default anyway
v    # invokes print.varclus
print(round(v$sim,2))
plot(v)


# plot(varclus(~ age + sys.bp + dias.bp + country - 1), abbrev=TRUE)
# the -1 causes k dummies to be generated for k countries
# plot(varclus(~ age + factor(disease.code) - 1))
#
#
# use varclus(~., data= fracmiss= maxlevels= minprev=) to analyze all
# "useful" variables - see dataframeReduce for details about arguments


df <- data.frame(a=c(1,2,3),b=c(1,2,3),c=c(1,2,NA),d=c(1,NA,3),
                 e=c(1,NA,3),f=c(NA,NA,NA),g=c(NA,2,3),h=c(NA,NA,3))
par(mfrow=c(2,2))
for(m in c("ward","complete","median")) {
  plot(naclus(df, method=m))
  title(m)
}
naplot(naclus(df))
n <- naclus(df)
plot(n); naplot(n)
na.pattern(df)      # builtin function


x <- c(1, rep(2,11), rep(3,9))
combine.levels(x)
x <- c(1, 2, rep(3,20))
combine.levels(x)


# plotMultSim example: Plot proportion of observations
# for which two variables are both positive (diagonals
# show the proportion of observations for which the
# one variable is positive).  Chance-correct the
# off-diagonals by subtracting the product of the
# marginal proportions.  On each subplot the x-axis
# shows month (0, 4, 8, 12) and there is a separate
# curve for females and males
d <- data.frame(sex=sample(c('female','male'),1000,TRUE),
                month=sample(c(0,4,8,12),1000,TRUE),
                x1=sample(0:1,1000,TRUE),
                x2=sample(0:1,1000,TRUE),
                x3=sample(0:1,1000,TRUE))
s <- array(NA, c(3,3,4))
opar <- par(mar=c(0,0,4.1,0))  # waste less space
for(sx in c('female','male')) {
  for(i in 1:4) {
    mon <- (i-1)*4
    s[,,i] <- varclus(~x1 + x2 + x3, sim='ccbothpos', data=d,
                      subset=d$month==mon & d$sex==sx)$sim
    }
  plotMultSim(s, c(0,4,8,12), vname=c('x1','x2','x3'),
              add=sx=='male', slimds=TRUE,
              lty=1+(sx=='male'))
  # slimds=TRUE causes separate  scaling for diagonals and
  # off-diagonals
}
par(opar)
}
\keyword{cluster}
\keyword{multivariate}
\keyword{category}
\keyword{manip}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/latestFile.r
\name{latestFile}
\alias{latestFile}
\title{latestFile}
\usage{
latestFile(pattern, path = ".", verbose = TRUE)
}
\arguments{
\item{pattern}{a regular expression; see \code{\link[base:list.files]{base::list.files()}}}

\item{path}{full path, defaulting to current working directory}

\item{verbose}{set to \code{FALSE} to not report on total number of matching files}
}
\value{
the name of the last modified file
}
\description{
Find File With Latest Modification Time
}
\details{
Subject to matching on \code{pattern} finds the last modified file, and if \code{verbose} is \code{TRUE} reports on how many total files matched \code{pattern}.
}
\seealso{
\code{\link[base:list.files]{base::list.files()}}
}
\author{
Frank Harrell
}

\name{discrete}
\alias{as.discrete}
\alias{as.discrete.default}
\alias{discrete}
\alias{[<-.discrete}
\alias{[.discrete}
\alias{[[.discrete}
\alias{is.discrete}
\alias{is.na<-.discrete}
\alias{length<-.discrete}

\title{ Discrete Vector tools }
\description{
  \code{discrete} creates a discrete vector which is distinct from a
  continuous vector, or a factor/ordered vector.
  The other function are tools for manipulating descrete vectors.
}
\usage{
as.discrete(x, ...)
\method{as.discrete}{default}(x, ...)
discrete(x, levels = sort(unique.default(x), na.last = TRUE), exclude = NA)
\method{[}{discrete}(x, ...) <- value
\method{[}{discrete}(x, ..., drop = FALSE)
\method{[[}{discrete}(x, i)
is.discrete(x)
\method{is.na}{discrete}(x) <- value
\method{length}{discrete}(x) <- value
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ a vector }
  \item{drop}{ Should unused levels be dropped. }
  \item{exclude}{logical: should \code{NA} be excluded. }
  \item{i}{ indexing vector }
  \item{levels}{ charater: list of individual level values }
  \item{value}{ index of elements to set to \code{NA} }
  \item{\dots}{ arguments to be passed to other functions }
}
\details{
  \code{as.discrete} converts a vector into a discrete vector.

  \code{discrete} creates a discrete vector from provided values.

  \code{is.discrete} tests to see if the vector is a discrete vector.
}
\value{
  \code{as.discrete}, \code{discrete} returns a vector of
  \code{discrete} type.

  \code{is.discrete} returan logical \code{TRUE} if the vector is of
  class discrete other wise it returns \code{FALSE}.
}
\author{ Charles Dupont}
\seealso{ \code{\link{[[}}, \code{\link{[}}, \code{\link{factor}} }
\examples{
a <- discrete(1:25)
a

is.discrete(a)

b <- as.discrete(2:4)
b
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ manip }

\name{deff}
\alias{deff}
\title{
  Design Effect and Intra-cluster Correlation
}
\description{
  Computes the Kish design effect and corresponding intra-cluster correlation
  for a single cluster-sampled variable
}
\usage{
deff(y, cluster)
}
\arguments{
  \item{y}{
    variable to analyze
  }
  \item{cluster}{
    a variable whose unique values indicate cluster membership.  Any
    type of variable is allowed.
  }
}
\value{
  a vector with named elements \code{n} (total number of non-missing
  observations), \code{clusters} (number of clusters after deleting
  missing data), \code{rho}(intra-cluster correlation), and \code{deff}
  (design effect).
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\seealso{
\code{\link[rms]{bootcov}}, \code{\link[rms]{robcov}}
}
\examples{
set.seed(1)
blood.pressure <- rnorm(1000, 120, 15)
clinic <- sample(letters, 1000, replace=TRUE)
deff(blood.pressure, clinic)
}
\keyword{htest}
\concept{study design}
\concept{cluster sampling}

\name{Save}
\alias{Save}
\alias{Load}
\title{Faciliate Use of save and load to Remote Directories}
\description{
These functions are slightly enhanced versions of \code{save} and
\code{load} that allow a target directory to be specified using
\code{options(LoadPath="pathname")}.  If the \code{LoadPath} option is
not set, the current working directory is used.
}
\usage{
# options(LoadPath='mypath')
Save(object, name=deparse(substitute(object)), compress=TRUE)
Load(object)
}
\arguments{
  \item{object}{the name of an object, usually a data frame.  It must
	not be quoted.}
  \item{name}{an optional name to assign to the object and file name
		prefix, if the argument name is not used}
	\item{compress}{see \code{\link{save}}.  Default is \code{TRUE}
		which corresponds to \code{gzip}.}
}
\details{
\code{Save} creates a temporary version of the object under the name
given by the user, so that \code{save} will internalize this name.
Then subsequent \code{Load} or \code{load} will cause an object of the
original name to be created in the global environment.  The name of
the \R data file is assumed to be the name of the object (or the value
of \code{name}) appended with \code{".rda"}.
}
\author{Frank Harrell}
\seealso{\code{\link{save}}, \code{\link{load}}}
\examples{
\dontrun{
d <- data.frame(x=1:3, y=11:13)
options(LoadPath='../data/rda')
Save(d)   # creates ../data/rda/d.rda
Load(d)   # reads   ../data/rda/d.rda
Save(d, 'D')   # creates object D and saves it in .../D.rda
}
}
\keyword{data}
\keyword{file}
\keyword{utilities}

\name{dataRep}
\alias{dataRep}
\alias{print.dataRep}
\alias{predict.dataRep}
\alias{print.predict.dataRep}
\alias{roundN}
\alias{[.roundN}
\title{
Representativeness of Observations in a Data Set
}
\description{
These functions are intended to be used to describe how well a given
set of new observations (e.g., new subjects) were represented in a
dataset used to develop a predictive model.
The \code{dataRep} function forms a data frame that contains all the unique
combinations of variable values that existed in a given set of
variable values.  Cross--classifications of values are created using
exact values of variables, so for continuous numeric variables it is
often necessary to round them to the nearest \code{v} and to possibly
curtail the values to some lower and upper limit before rounding.
Here \code{v} denotes a numeric constant specifying the matching tolerance
that will be used.  \code{dataRep} also stores marginal distribution
summaries for all the variables.  For numeric variables, all 101
percentiles are stored, and for all variables, the frequency
distributions are also stored (frequencies are computed after any
rounding and curtailment of numeric variables).  For the purposes of
rounding and curtailing, the \code{roundN} function is provided.  A \code{print}
method will summarize the calculations made by \code{dataRep}, and if
\code{long=TRUE} all unique combinations of values and their frequencies in
the original dataset are printed.

The \code{predict} method for \code{dataRep} takes a new data frame having
variables named the same as the original ones (but whose factor levels
are not necessarily in the same order) and examines the collapsed
cross-classifications created by \code{dataRep} to find how many
observations were similar to each of the new observations after any
rounding or curtailment of limits is done.  \code{predict} also does some
calculations to describe how the variable values of the new
observations "stack up" against the marginal distributions of the
original data.  For categorical variables, the percent of observations
having a given variable with the value of the new observation (after
rounding for variables that were through \code{roundN} in the formula given
to \code{dataRep}) is computed.  For numeric variables, the percentile of
the original distribution in which the current value falls will be
computed.  For this purpose, the data are not rounded because the 101
original percentiles were retained; linear interpolation is used to
estimate percentiles for values between two tabulated percentiles.
The lowest marginal frequency of matching values across all variables
is also computed.  For example, if an age, sex combination matches 10
subjects in the original dataset but the age value matches 100 ages
(after rounding) and the sex value matches the sex code of 300
observations, the lowest marginal frequency is 100, which is a "best
case" upper limit for multivariable matching.  I.e., matching on all
variables has to result on a lower frequency than this amount.
A \code{print} method for the output of \code{predict.dataRep} prints all
calculations done by \code{predict} by default.  Calculations can be
selectively suppressed.
}
\usage{
dataRep(formula, data, subset, na.action)

roundN(x, tol=1, clip=NULL)

\method{print}{dataRep}(x, long=FALSE, \dots)

\method{predict}{dataRep}(object, newdata, \dots)

\method{print}{predict.dataRep}(x, prdata=TRUE, prpct=TRUE, \dots)
}
\arguments{
\item{formula}{
a formula with no left-hand-side.  Continuous numeric variables in
need of rounding should appear in the formula as e.g. \code{roundN(x,5)} to
have a tolerance of e.g. +/- 2.5 in matching.  Factor or character
variables as well as numeric ones not passed through \code{roundN} are
matched on exactly.
}
\item{x}{
a numeric vector or an object created by \code{dataRep}
}
\item{object}{
the object created by \code{dataRep} or \code{predict.dataRep}
}
\item{data, subset, na.action}{
standard modeling arguments.  Default \code{na.action} is \code{na.delete},
i.e., observations in the original dataset having any variables
missing are deleted up front.
}
\item{tol}{
rounding constant (tolerance is actually \code{tol/2} as values are rounded
to the nearest \code{tol})
}
\item{clip}{
a 2-vector specifying a lower and upper limit to curtail values of \code{x}
before rounding
}
\item{long}{
set to \code{TRUE} to see all unique combinations and frequency count
}
\item{newdata}{
a data frame containing all the variables given to \code{dataRep} but not
necessarily in the same order or having factor levels in the same order
}
\item{prdata}{
set to \code{FALSE} to suppress printing \code{newdata} and the count of matching
observations (plus the worst-case marginal frequency). 
}
\item{prpct}{set to \code{FALSE} to not print percentiles and percents}
\item{\dots}{unused}
}
\value{
\code{dataRep} returns a list of class \code{"dataRep"} containing the collapsed
data frame and frequency counts along with marginal distribution
information.  \code{predict} returns an object of class \code{"predict.dataRep"}
containing information determined by matching observations in
\code{newdata} with the original (collapsed) data.
}
\section{Side Effects}{
\code{print.dataRep} prints.
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University School of Medicine
\cr
\email{fh@fharrell.com}
}
\seealso{
\code{\link{round}}, \code{\link{table}}
}
\examples{
set.seed(13)
num.symptoms <- sample(1:4, 1000,TRUE)
sex <- factor(sample(c('female','male'), 1000,TRUE))
x    <- runif(1000)
x[1] <- NA
table(num.symptoms, sex, .25*round(x/.25))


d <- dataRep(~ num.symptoms + sex + roundN(x,.25))
print(d, long=TRUE)


predict(d, data.frame(num.symptoms=1:3, sex=c('male','male','female'),
                      x=c(.03,.5,1.5)))
}
\keyword{datasets}
\keyword{category}
\keyword{cluster}
\keyword{manip}
\keyword{models}
% Converted by Sd2Rd version 1.21.

\name{print.char.list}
\alias{print.char.list}
\title{ prints a list of lists in a visually readable format. }
\description{
  Takes a list that is composed of other lists and matrixes and prints
  it in a visually readable format.
}
\usage{
\method{print}{char.list}(x, \dots, hsep = c("|"), vsep = c("-"), csep = c("+"), print.it = TRUE,
                rowname.halign = c("left", "centre", "right"),
                rowname.valign = c("top", "centre", "bottom"),
                colname.halign = c("centre", "left", "right"),
                colname.valign = c("centre", "top", "bottom"),
                text.halign = c("right", "centre", "left"),
                text.valign = c("top", "centre", "bottom"),
                rowname.width, rowname.height,
                min.colwidth = .Options$digits, max.rowheight = NULL,
                abbreviate.dimnames = TRUE, page.width = .Options$width,
                colname.width, colname.height, prefix.width,
                superprefix.width = prefix.width)
}
\arguments{
  \item{x}{
    list object to be printed
  }
  \item{\dots}{
    place for extra arguments to reside.
  }
  \item{hsep}{
    character used to separate horizontal fields
  }
  \item{vsep}{
    character used to separate veritcal feilds
  }
  \item{csep}{
    character used where horizontal and veritcal separators meet.
  }
  \item{print.it}{
    should the value be printed to the console or returned as a string.
  }
  \item{rowname.halign}{
    horizontal justification of row names.
  }
  \item{rowname.valign}{
    verical justification of row names.
  }
  \item{colname.halign}{
    horizontal justification of column names.
  }
  \item{colname.valign}{
    verical justification of column names.
  }
  \item{text.halign}{
    horizontal justification of cell text.
  }
  \item{text.valign}{
    vertical justification of cell text.
  }
  \item{rowname.width}{
    minimum width of row name strings.
  }
  \item{rowname.height}{
    minimum height of row name strings.
  }
  \item{min.colwidth}{
    minimum column width.
  }
  \item{max.rowheight}{
    maximum row height.
  }
  \item{abbreviate.dimnames}{
    should the row and column names be abbreviated.
  }
  \item{page.width}{
    width of the page being printed on.
  }
  \item{colname.width}{
    minimum width of the column names.
  }
  \item{colname.height}{
    minimum height of the column names
  }
  \item{prefix.width}{
    maximum width of the rowname columns
  }
  \item{superprefix.width}{
    maximum width of the super rowname columns
  }
}
\value{
  String that formated table of the list object.
}
\author{ Charles Dupont }
\keyword{ print }
\keyword{ list }

\name{rcorr.cens}
\alias{rcorr.cens}
\alias{rcorrcens}
\alias{rcorrcens.formula}
\title{
  Rank Correlation for Censored Data
}
\description{
  Computes the \var{c} index and the corresponding
  generalization of Somers' \var{Dxy} rank correlation for a censored response
  variable. Also works for uncensored and binary responses, 
  although its use of all possible pairings
  makes it slow for this purpose.  \var{Dxy} and \var{c} are related by
  \eqn{\var{Dxy}=2(\var{c}-0.5)}{\var{Dxy} = 2*(\var{c} - 0.5)}.

  \code{rcorr.cens} handles one predictor variable.  \code{rcorrcens}
  computes rank correlation measures separately by a series of
  predictors.  In addition, \code{rcorrcens} has a rough way of handling
  categorical predictors.  If a categorical (factor) predictor has two
  levels, it is coverted to a numeric having values 1 and 2.  If it has
  more than 2 levels, an indicator variable is formed for the most
  frequently level vs. all others, and another indicator for the second
  most frequent level and all others.  The correlation is taken as the
  maximum of the two (in absolute value).
}
\usage{
rcorr.cens(x, S, outx=FALSE)

\method{rcorrcens}{formula}(formula, data=NULL, subset=NULL,
          na.action=na.retain, exclude.imputed=TRUE, outx=FALSE,
          \dots)
}
\arguments{
  \item{x}{
    a numeric predictor variable
  }
  \item{S}{
    an \code{Surv} object or a vector.  If a vector, assumes that every
    observation is uncensored.
  }
  \item{outx}{
    set to \code{TRUE} to not count pairs of observations tied on \code{x} as a
    relevant pair.  This results in a Goodman--Kruskal gamma type rank
    correlation.
  }
  \item{formula}{
    a formula with a \code{Surv} object or a numeric vector
    on the left-hand side
  }
  \item{data, subset, na.action}{
    the usual options for models.  Default for \code{na.action} is to retain
    all values, NA or not, so that NAs can be deleted in only a pairwise
    fashion.
  }
  \item{exclude.imputed}{
    set to \code{FALSE} to include imputed values (created by
    \code{impute}) in the calculations.
  }
  \item{\dots}{
    extra arguments passed to \code{\link{biVar}}.
  }
}
\value{
  \code{rcorr.cens} returns a vector with the following named elements:
  \code{C Index}, \code{Dxy}, \code{S.D.}, \code{n}, \code{missing},
  \code{uncensored}, \code{Relevant Pairs}, \code{Concordant}, and
  \code{Uncertain}

  \item{n}{number of observations not missing on any input variables}

  \item{missing}{number of observations missing on \code{x} or \code{S}}

  \item{relevant}{number of pairs of non-missing observations for which
  \code{S} could be ordered}

  \item{concordant}{number of relevant pairs for which \code{x} and \code{S}
  are concordant.}
  
  \item{uncertain}{number of pairs of non-missing observations for which
  censoring prevents classification of concordance of \code{x} and
  \code{S}.
  }

  \code{rcorrcens.formula} returns an object of class \code{biVar}
which is documented with the \code{\link{biVar}} function.
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\seealso{
\code{\link{somers2}}, \code{\link{biVar}}, \code{\link{rcorrp.cens}}
}
\references{
Newson R: Confidence intervals for rank statistics: Somers' D and extensions.  Stata Journal 6:309-334; 2006.
}
\examples{
set.seed(1)
x <- round(rnorm(200))
y <- rnorm(200)
rcorr.cens(x, y, outx=TRUE)   # can correlate non-censored variables
library(survival)
age <- rnorm(400, 50, 10)
bp  <- rnorm(400,120, 15)
bp[1]  <- NA
d.time <- rexp(400)
cens   <- runif(400,.5,2)
death  <- d.time <= cens
d.time <- pmin(d.time, cens)
rcorr.cens(age, Surv(d.time, death))
r <- rcorrcens(Surv(d.time, death) ~ age + bp)
r
plot(r)

# Show typical 0.95 confidence limits for ROC areas for a sample size
# with 24 events and 62 non-events, for varying population ROC areas
# Repeat for 138 events and 102 non-events
set.seed(8)
par(mfrow=c(2,1))
for(i in 1:2) {
 n1 <- c(24,138)[i]
 n0 <- c(62,102)[i]
 y <- c(rep(0,n0), rep(1,n1))
 deltas <- seq(-3, 3, by=.25)
 C <- se <- deltas
 j <- 0
 for(d in deltas) {
  j <- j + 1
  x <- c(rnorm(n0, 0), rnorm(n1, d))
  w <- rcorr.cens(x, y)
  C[j]  <- w['C Index']
  se[j] <- w['S.D.']/2
 }
 low <- C-1.96*se; hi <- C+1.96*se
 print(cbind(C, low, hi))
 errbar(deltas, C, C+1.96*se, C-1.96*se,
        xlab='True Difference in Mean X',
        ylab='ROC Area and Approx. 0.95 CI')
 title(paste('n1=',n1,'  n0=',n0,sep=''))
 abline(h=.5, v=0, col='gray')
 true <- 1 - pnorm(0, deltas, sqrt(2))
 lines(deltas, true, col='blue')
}
par(mfrow=c(1,1))
}
\keyword{survival}
\keyword{nonparametric}
\concept{predictive accuracy}
\concept{logistic regression model}
% Converted by Sd2Rd version 1.21.

\name{spss.get}
\alias{spss.get}
\title{Enhanced Importing of SPSS Files}
\description{
\code{spss.get} invokes the \code{read.spss} function in the
\pkg{foreign} package to read an SPSS file, with a default output
format of \code{"data.frame"}.  The \code{label} function is used to
attach labels to individual variables instead of to the data frame as
done by \code{read.spss}.  By default, integer-valued variables are
converted to a storage mode of integer unless
\code{force.single=FALSE}.  Date variables are converted to \R \code{Date}
variables.  By default, underscores in names are converted to periods.
}
\usage{
spss.get(file, lowernames=FALSE, datevars = NULL,
         use.value.labels = TRUE, to.data.frame = TRUE,
         max.value.labels = Inf, force.single=TRUE,
         allow=NULL, charfactor=FALSE, reencode = NA)
}
\arguments{
  \item{file}{input SPSS save file.  May be a file on the WWW, indicated
  by \code{file} starting with \code{'http://'} or \code{'https://'}.}
  \item{lowernames}{set to \code{TRUE} to convert variable names to
	lower case}
  \item{datevars}{vector of variable names containing dates to be
	converted to \R internal format}
  \item{use.value.labels}{see \code{\link[foreign]{read.spss}}}
  \item{to.data.frame}{see \code{\link[foreign]{read.spss}}; default is
	\code{TRUE} for \code{spss.get}}
  \item{max.value.labels}{see \code{\link[foreign]{read.spss}}}
  \item{force.single}{set to \code{FALSE} to prevent integer-valued
	variables from being converted from storage mode \code{double} to
	\code{integer}}
  \item{allow}{a vector of characters allowed by \R that should not be
	converted to periods in variable names.  By default, underscores in
	variable names are converted to periods as with \R before version 1.9.}
  \item{charfactor}{set to \code{TRUE} to change character variables to
	factors if they have fewer than n/2 unique values.  Blanks and null
	strings are converted to \code{NA}s.}
  \item{reencode}{see \code{\link[foreign]{read.spss}}}
}
\value{
  a data frame or list
}
\author{Frank Harrell}
\seealso{\code{\link[foreign]{read.spss}},\code{\link{cleanup.import}},\code{\link{sas.get}}}

\examples{
\dontrun{
w <- spss.get('/tmp/my.sav', datevars=c('birthdate','deathdate'))
  }
}
\keyword{interface}
\keyword{manip}
\keyword{file}
\concept{SPSS data file}

\name{solvet}
\alias{solvet}
\title{
solve Function with tol argument
}
\description{
A slightly modified version of \code{solve} that allows a tolerance argument
for singularity (\code{tol}) which is passed to \code{qr}.
}
\usage{
solvet(a, b, tol=1e-09)
}
\arguments{
  \item{a}{a square numeric matrix}
  \item{b}{a numeric vector or matrix}
  \item{tol}{tolerance for detecting linear dependencies in columns of
	\code{a}}
  }
\seealso{
\code{\link{solve}}
}
\keyword{array}
\keyword{algebra}

\name{pc1}
\alias{pc1}
\title{First Principal Component}
\description{
Given a numeric matrix which may or may not contain \code{NA}s,
\code{pc1} standardizes the columns to have mean 0 and variance 1 and
computes the first principal component using \code{\link{prcomp}}.  The
proportion of variance explained by this component is printed, and so
are the coefficients of the original (not scaled) variables.  These
coefficients may be applied to the raw data to obtain the first PC.
}
\usage{
pc1(x, hi)
}
\arguments{
  \item{x}{numeric matrix}
  \item{hi}{if specified, the first PC is scaled so that its maximum
	value is \code{hi} and its minimum value is zero}
}
\value{
  The vector of observations with the first PC.  An attribute
  \code{"coef"} is attached to this vector.  \code{"coef"} contains the
  raw-variable coefficients.
  }
\author{Frank Harrell}
\seealso{\code{\link{prcomp}}}
\examples{
set.seed(1)
x1 <- rnorm(100)
x2 <- x1 + rnorm(100)
w <- pc1(cbind(x1,x2))
attr(w,'coef')
}
\keyword{multivariate}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/testCharDateTime.r
\name{testCharDateTime}
\alias{testCharDateTime}
\title{testCharDateTime}
\usage{
testCharDateTime(x, p = 0.5, m = 0, convert = FALSE, existing = FALSE)
}
\arguments{
\item{x}{input vector of any type, but interesting cases are for character \code{x}}

\item{p}{minimum proportion of non-missing non-blank values of \code{x} for which the format is one of the formats described before considering \code{x} to be of that type}

\item{m}{if greater than 0, a test is applied: the number of distinct illegal values of \code{x} (values containing a letter or underscore) must not exceed \code{m}, or type \code{character} will be returned.  \code{p} is set to \code{1.0} when \code{m} > 0.}

\item{convert}{set to \code{TRUE} to convert the variable under the dominant format.  If all values are \code{NA}, \code{type} will be set to \code{'character'}.}

\item{existing}{set to \code{TRUE} to return a character string with the current type of variable without examining pattern matches}
}
\value{
if \code{convert=FALSE}, a single character string with the type of \code{x}: \verb{"character", "datetime", "date", "time"}.  If \code{convert=TRUE}, a list with components named \code{type}, \code{x} (converted to \code{POSIXct}, \code{Date}, or \code{chron} times format), and \code{numna}, the number of originally non-\code{NA} values of \code{x} that could not be converted to the predominant format.  If there were any non-covertible dates/times,
the returned vector is given an additional class \code{special.miss} and an
attribute \code{special.miss} which is a list with original character values
(\code{codes}) and observation numbers (\code{obs}).  These are summarized by
\code{describe()}.
}
\description{
Test Character Variables for Dates and Times
}
\details{
For a vector \code{x}, if it is already a date-time, date, or time variable, the type is returned if \code{convert=FALSE}, or a list with that type, the original vector, and \code{numna=0} is returned.  Otherwise if \code{x} is not a character vector, a type of \code{notcharacter} is returned, or a list that includes the original \code{x} and \code{type='notcharacter'}.  When \code{x} is character, the main logic is applied.  The default logic (when \code{m=0}) is to consider \code{x} a date-time variable when its format is YYYY-MM-DD HH:MM:SS (:SS is optional) in more than 1/2 of the non-missing observations.  It is considered to be a date if its format is YYYY-MM-DD or MM/DD/YYYY or DD-MMM-YYYY in more than 1/2 of the non-missing observations (MMM=3-letter month).  A time variable has the format HH:MM:SS or HH:MM.  Blank values of \code{x} (after trimming) are set to \code{NA} before proceeding.
}
\examples{
for(conv in c(FALSE, TRUE)) {
  print(testCharDateTime(c('2023-03-11', '2023-04-11', 'a', 'b', 'c'), convert=conv))
  print(testCharDateTime(c('2023-03-11', '2023-04-11', 'a', 'b'), convert=conv))
  print(testCharDateTime(c('2023-03-11 11:12:13', '2023-04-11 11:13:14', 'a', 'b'), convert=conv))
  print(testCharDateTime(c('2023-03-11 11:12', '2023-04-11 11:13', 'a', 'b'), convert=conv))
  print(testCharDateTime(c('3/11/2023', '4/11/2023', 'a', 'b'), convert=conv))
}
x <- c(paste0('2023-03-0', 1:9), 'a', 'a', 'a', 'b')
y <- testCharDateTime(x, convert=TRUE)$x
describe(y)  # note counts of special missing values a, b
}
\author{
Frank Harrell
}

\name{histbackback}
\alias{histbackback}
\title{
Back to Back Histograms
}
\description{
Takes two vectors or a list with \code{x} and \code{y} components, and produces 
back to back histograms of the two datasets.
}
\usage{
histbackback(x, y, brks=NULL, xlab=NULL, axes=TRUE, probability=FALSE,
             xlim=NULL, ylab='', \dots)
}
\arguments{
\item{x,y}{
either two vectors or a list given as \code{x} with two components.  If the
components have names, they will be used to label the axis
(modification FEH).
}
\item{brks}{
vector of the desired breakpoints for the histograms.
}
\item{xlab}{
a vector of two character strings naming the two datasets.
}
\item{axes}{
logical flag stating whether or not to label the axes.
}
\item{probability}{
logical flag: if \code{TRUE}, then the x-axis corresponds to the units for a
density.  If \code{FALSE}, then the units are counts.
}
\item{xlim}{
x-axis limits.  First value must be negative, as the left histogram is
placed at negative x-values.  Second value must be positive, for the
right histogram.  To make the limits symmetric, use e.g. \code{ylim=c(-20,20)}.
}
\item{ylab}{
label for y-axis.  Default is no label.
}
\item{...}{
additional graphics parameters may be given.
}}
\value{
a list is returned invisibly with the following components:

\item{left}{
the counts for the dataset plotted on the left.
}
\item{right}{
the counts for the dataset plotted on the right.
}
\item{breaks}{
the breakpoints used.
}}
\section{Side Effects}{
a plot is produced on the current graphics device.
}
\author{
Pat Burns
\cr
Salomon Smith Barney
\cr
London
\cr
\email{pburns@dorado.sbi.com}
}
\seealso{
\code{\link{hist}}, \code{\link[lattice]{histogram}}
}
\examples{
options(digits=3)
set.seed(1)
histbackback(rnorm(20), rnorm(30))


fool <- list(x=rnorm(40), y=rnorm(40))
histbackback(fool)
age <- rnorm(1000,50,10)
sex <- sample(c('female','male'),1000,TRUE)
histbackback(split(age, sex))
agef <- age[sex=='female']; agem <- age[sex=='male']
histbackback(list(Female=agef,Male=agem), probability=TRUE, xlim=c(-.06,.06))
}
\keyword{dplot}
\keyword{hplot}
\keyword{distribution}
% Converted by Sd2Rd version 1.21.

\name{Ecdf}
\alias{Ecdf}
\alias{Ecdf.default}
\alias{Ecdf.data.frame}
\alias{Ecdf.formula}
\alias{panel.Ecdf}
\alias{prepanel.Ecdf}
\title{Empirical Cumulative Distribution Plot}
\description{
Computes coordinates of cumulative distribution function of x, and by defaults
plots it as a step function.  A grouping variable may be specified so that
stratified estimates are computed and (by default) plotted.  If there is
more than one group, the \code{labcurve} function is used (by default) to label
the multiple step functions or to draw a legend defining line types, colors,
or symbols by linking them with group labels.  A \code{weights} vector may
be specified to get weighted estimates.  Specify \code{normwt} to make
\code{weights} sum to the length of \code{x} (after removing NAs).  Other wise
the total sample size is taken to be the sum of the weights.

\code{Ecdf} is actually a method, and \code{Ecdf.default} is what's
called for a vector argument.  \code{Ecdf.data.frame} is called when the
first argument is a data frame.  This function can automatically set up
a matrix of ECDFs and wait for a mouse click if the matrix requires more
than one page.  Categorical variables, character variables, and
variables having fewer than a set number of unique values are ignored.
If \code{par(mfrow=..)} is not set up before \code{Ecdf.data.frame} is
called, the function will try to figure the best layout depending on the
number of variables in the data frame.  Upon return the original
\code{mfrow} is left intact.

When the first argument to \code{Ecdf} is a formula, a Trellis/Lattice function
\code{Ecdf.formula} is called.  This allows for multi-panel
conditioning, superposition using a \code{groups} variable, and other
Trellis features, along with the ability to easily plot transformed
ECDFs using the \code{fun} argument.  For example, if \code{fun=qnorm},
the inverse normal transformation will be used for the y-axis.  If the
transformed curves are linear this indicates normality.  Like the
\code{xYplot} function, \code{Ecdf} will create a function \code{Key} if
the \code{groups} variable is used.  This function can be invoked by the
user to define the keys for the groups.
}

\usage{
Ecdf(x, \dots)

\method{Ecdf}{default}(x, what=c('F','1-F','f','1-f'),
     weights=rep(1, length(x)), normwt=FALSE,
     xlab, ylab, q, pl=TRUE, add=FALSE, lty=1, 
     col=1, group=rep(1,length(x)), label.curves=TRUE, xlim, 
     subtitles=TRUE, datadensity=c('none','rug','hist','density'),
     side=1, 
     frac=switch(datadensity,none=NA,rug=.03,hist=.1,density=.1),
     dens.opts=NULL, lwd=1, log='', \dots)


\method{Ecdf}{data.frame}(x, group=rep(1,nrows),
     weights=rep(1, nrows), normwt=FALSE,
     label.curves=TRUE, n.unique=10, na.big=FALSE, subtitles=TRUE, 
     vnames=c('labels','names'),\dots)

\method{Ecdf}{formula}(x, data=sys.frame(sys.parent()), groups=NULL,
     prepanel=prepanel.Ecdf, panel=panel.Ecdf, \dots, xlab,
     ylab, fun=function(x)x, what=c('F','1-F','f','1-f'), subset=TRUE)
}
\arguments{
\item{x}{a numeric vector, data frame, or Trellis/Lattice formula}
\item{what}{
The default is \code{"F"} which results in plotting the fraction of values
<= x.  Set to \code{"1-F"} to plot the fraction > x or \code{"f"} to plot the
cumulative frequency of values <= x.  Use \code{"1-f"} to plot the
cumulative frequency of values >= x.
}
\item{weights}{
numeric vector of weights.  Omit or specify a zero-length vector or
NULL to get unweighted estimates.
}
\item{normwt}{see above}
\item{xlab}{
x-axis label.  Default is label(x) or name of calling argument.  For
\code{Ecdf.formula}, \code{xlab} defaults to the \code{label} attribute
of the x-axis variable.
}
\item{ylab}{
y-axis label.  Default is \code{"Proportion <= x"}, \code{"Proportion > x"}, 
or "Frequency <= x" depending on value of \code{what}.
}
\item{q}{
a vector for quantiles for which to draw reference lines on the plot.
Default is not to draw any.
}
\item{pl}{set to F to omit the plot, to just return estimates}
\item{add}{
set to TRUE to add the cdf to an existing plot.  Does not apply if using
     lattice graphics (i.e., if a formula is given as the first argument).
}
\item{lty}{
integer line type for plot.  If \code{group} is specified, this can be a vector.
}
\item{lwd}{
  line width for plot.  Can be a vector corresponding to \code{group}s.
}
\item{log}{
	see \code{\link{plot}}.  Set \code{log='x'} to use log scale for
  \code{x}-axis.
	}
\item{col}{
color for step function.  Can be a vector.
}
\item{group}{
a numeric, character, or \code{factor} categorical variable used for stratifying
estimates.  If \code{group} is present, as many ECDFs are drawn as there are
non--missing group levels.
}
\item{label.curves}{
applies if more than one \code{group} exists.
Default is \code{TRUE} to use \code{labcurve} to label curves where they are farthest
apart.  Set \code{label.curves} to a \code{list} to specify options to
\code{labcurve}, e.g., \code{label.curves=list(method="arrow", cex=.8)}.
These option names may be abbreviated in the usual way arguments
are abbreviated.  Use for example \code{label.curves=list(keys=1:5)}
to draw symbols periodically (as in \code{pch=1:5} - see \code{points})
on the curves and automatically position a legend
in the most empty part of the plot.  Set \code{label.curves=FALSE} to
suppress drawing curve labels.  The \code{col}, \code{lty}, and \code{type}
parameters are automatically passed to \code{labcurve}, although you
can override them here.  You can set \code{label.curves=list(keys="lines")} to
have different line types defined in an automatically positioned key.
}
\item{xlim}{
x-axis limits.  Default is entire range of \code{x}.
}
\item{subtitles}{
set to \code{FALSE} to suppress putting a subtitle at the bottom left of each
plot.  The subtitle indicates the numbers of
non-missing and missing observations, which are labeled \code{n}, \code{m}.
}
\item{datadensity}{
If \code{datadensity} is not \code{"none"}, either \code{scat1d} or \code{histSpike} is called to
add a rug plot (\code{datadensity="rug"}), spike histogram
(\code{datadensity="hist"}), or smooth density estimate (\code{"density"}) to
the bottom or top of the ECDF.
}
\item{side}{
If \code{datadensity} is not \code{"none"}, the default is to place the additional
information on top of the x-axis (\code{side=1}).  Use \code{side=3} to place at
the top of the graph.
}
\item{frac}{
passed to \code{histSpike}
}
\item{dens.opts}{
a list of optional arguments for \code{histSpike}
}
\item{...}{
other parameters passed to plot if add=F.  For data frames, other
parameters to pass to \code{Ecdf.default}.
For \code{Ecdf.formula}, if \code{groups} is not used, you can also add
data density information to each panel's ECDF by specifying the
\code{datadensity} and optional \code{frac}, \code{side},
\code{dens.opts} arguments. 
}
\item{n.unique}{
minimum number of unique values before an ECDF is drawn for a variable
in a data frame.  Default is 10.
}
\item{na.big}{
set to \code{TRUE} to draw the number of NAs in larger letters in the middle of
the plot for \code{Ecdf.data.frame}
}
\item{vnames}{
By default, variable labels are used to label x-axes.  Set \code{vnames="names"}
to instead use variable names.
}
\item{method}{
method for computing the empirical cumulative distribution.  See
\code{wtd.Ecdf}.  The default is to use the standard \code{"i/n"} method as is
used by the non-Trellis versions of \code{Ecdf}.
}
\item{fun}{
a function to transform the cumulative proportions, for the
Trellis-type usage of \code{Ecdf}
}
\item{data, groups, subset,prepanel, panel}{the usual Trellis/Lattice parameters, with \code{groups}
  causing \code{Ecdf.formula} to overlay multiple ECDFs on one panel.}
}
\value{
for \code{Ecdf.default} an invisible list with elements x and y giving the
coordinates of the cdf.  If there is more than one \code{group}, a list of
such lists is returned.  An attribute, \code{N}, is in the returned
object.  It contains the elements \code{n} and \code{m}, the number of
non-missing and missing observations, respectively.
}
\author{
Frank Harrell
\cr
Department of Biostatistics, Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\section{Side Effects}{
plots
}
\seealso{
\code{\link{wtd.Ecdf}}, \code{\link{label}}, \code{\link{table}}, \code{\link{cumsum}}, \code{\link{labcurve}}, \code{\link{xYplot}}, \code{\link{histSpike}}
}
\examples{
set.seed(1)
ch <- rnorm(1000, 200, 40)
Ecdf(ch, xlab="Serum Cholesterol")
scat1d(ch)                       # add rug plot
histSpike(ch, add=TRUE, frac=.15)   # add spike histogram
# Better: add a data density display automatically:
Ecdf(ch, datadensity='density')


label(ch) <- "Serum Cholesterol"
Ecdf(ch)
other.ch <- rnorm(500, 220, 20)
Ecdf(other.ch,add=TRUE,lty=2)


sex <- factor(sample(c('female','male'), 1000, TRUE))
Ecdf(ch, q=c(.25,.5,.75))  # show quartiles
Ecdf(ch, group=sex,
     label.curves=list(method='arrow'))


# Example showing how to draw multiple ECDFs from paired data
pre.test <- rnorm(100,50,10)
post.test <- rnorm(100,55,10)
x <- c(pre.test, post.test)
g <- c(rep('Pre',length(pre.test)),rep('Post',length(post.test)))
Ecdf(x, group=g, xlab='Test Results', label.curves=list(keys=1:2))
# keys=1:2 causes symbols to be drawn periodically on top of curves


# Draw a matrix of ECDFs for a data frame
m <- data.frame(pre.test, post.test, 
                sex=sample(c('male','female'),100,TRUE))
Ecdf(m, group=m$sex, datadensity='rug')


freqs <- sample(1:10, 1000, TRUE)
Ecdf(ch, weights=freqs)  # weighted estimates


# Trellis/Lattice examples:


region <- factor(sample(c('Europe','USA','Australia'),100,TRUE))
year <- factor(sample(2001:2002,1000,TRUE))
Ecdf(~ch | region*year, groups=sex)
Key()           # draw a key for sex at the default location
# Key(locator(1)) # user-specified positioning of key
age <- rnorm(1000, 50, 10)
Ecdf(~ch | lattice::equal.count(age), groups=sex)  # use overlapping shingles
Ecdf(~ch | sex, datadensity='hist', side=3)  # add spike histogram at top
}
\keyword{nonparametric}
\keyword{hplot}
\keyword{methods}
\keyword{distribution}
\concept{trellis}
\concept{lattice}

\name{nstr}
\alias{nstr}

\title{ Creates a string of arbitry length }
\description{
  Creates a vector of strings which consists of the string segment given in
  each element of the \code{string} vector repeated \code{times}.
}
\usage{
nstr(string, times)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{string}{ character: vector of string segments to be
    repeated.  Will be recycled if argument \code{times} is longer.}
  \item{times}{ integer: vector of number of times to repeat the
    corisponding segment.  Will be recycled if argument \code{string} is
    longer.
  }
}
\value{
  returns a character vector the same length as the longest of the two arguments.
}
\author{ Charles Dupont }
\note{
  Will throw a warning if the length of the longer argment is not a even
  multiple of the shorter argument.
}
\seealso{ \code{\link{paste}}, \code{\link{rep}} }
\examples{
nstr(c("a"), c(0,3,4))

nstr(c("a", "b", "c"), c(1,2,3))

nstr(c("a", "b", "c"), 4)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{manip}
\keyword{character}% __ONLY ONE__ keyword per line
\keyword{utilities}

\name{prnz}
\alias{prn}
\title{
Print and Object with its Name
}
\description{
Prints an object with its name and with an optional descriptive
text string.  This is useful for annotating analysis output files and
for debugging.
}
\usage{
prn(x, txt, file)
}
\arguments{
\item{x}{any object}
\item{txt}{optional text string}
\item{file}{optional file name.  By default, writes to console.
	\code{append=TRUE} is assumed.}
}
\section{Side Effects}{
prints
}
\seealso{
\code{\link{print}}, \code{\link{cat}}
}
\examples{
x <- 1:5
prn(x)
# prn(fit, 'Full Model Fit')
}
\keyword{print}

\name{dotchart3}
\alias{dotchart3}
\alias{dotchartp}
\alias{summaryD}
\alias{summaryDp}
\title{Enhanced Version of dotchart Function}
\description{
These are adaptations of the R dotchart function that sorts categories
top to bottom, adds \code{auxdata} and \code{auxtitle} arguments to put
extra information in the right margin, and for \code{dotchart3} adds
arguments \code{cex.labels}, \code{cex.group.labels}, and
\code{groupfont}.  By default, group headings are in a larger, bold
font.  \code{dotchart3} also cuts a bit of white space from the top and
bottom of the chart.  The most significant change, however, is in how
\code{x} is interpreted.  Columns of \code{x} no longer provide an
alternate way to define groups.  Instead, they define superpositioned
values.  This is useful for showing three quartiles, for example.  Going
along with this change, for \code{dotchart3} \code{pch} can now be a
vector specifying symbols to use going across columns of \code{x}.
\code{x} was changed in this way because to put multiple points on a
line (e.g., quartiles) and keeping track of \code{par()} parameters when
\code{dotchart2} was called with \code{add=TRUE} was cumbersome.
\code{dotchart3} changes the margins to account for horizontal labels.

\code{dotchartp} is a version of \code{dotchart3} for making the chart
with the \code{plotly} package.

\code{summaryD} creates aggregate data using \code{\link{summarize}} and
calls \code{dotchart3} with suitable arguments to summarize data by
major and minor categories.  If \code{options(grType='plotly')} is in
effect and the \code{plotly} package is installed, \code{summaryD} uses
\code{dotchartp} instead of \code{dotchart3}.

\code{summaryDp} is a streamlined \code{summaryD}-like function that
uses the \code{dotchartpl} function to render a \code{plotly} graphic.
It is used to compute summary statistics stratified separately by a
series of variables.
}
\usage{
dotchart3(x, labels = NULL, groups = NULL, gdata = NULL,
          cex = par("cex"), pch = 21, gpch = pch, bg = par("bg"),
          color = par("fg"), gcolor = par("fg"), lcolor = "gray",
          xlim = range(c(x, gdata), na.rm=TRUE), main = NULL, xlab = NULL,
          ylab = NULL, auxdata = NULL, auxtitle = NULL, auxgdata=NULL,
          axisat=NULL, axislabels=NULL,
          cex.labels = cex, cex.group.labels = cex.labels * 1.25,
          cex.auxdata=cex, groupfont = 2,
          auxwhere=NULL, height=NULL, width=NULL, \dots)

dotchartp(x, labels = NULL, groups = NULL, gdata = NULL,
            xlim = range(c(x, gdata), na.rm=TRUE), main=NULL,
            xlab = NULL, ylab = '', auxdata=NULL, auxtitle=NULL,
            auxgdata=NULL, auxwhere=c('right', 'hover'),
            symbol='circle', col=colorspace::rainbow_hcl,
            legendgroup=NULL,
            axisat=NULL, axislabels=NULL, sort=TRUE, digits=4, dec=NULL,
            height=NULL, width=700, layoutattr=FALSE, showlegend=TRUE, \dots) 

summaryD(formula, data=NULL, fun=mean, funm=fun,
         groupsummary=TRUE, auxvar=NULL, auxtitle='',
         auxwhere=c('hover', 'right'),
         vals=length(auxvar) > 0, fmtvals=format,
         symbol=if(use.plotly) 'circle' else 21,
         col=if(use.plotly) colorspace::rainbow_hcl else 1:10,
         legendgroup=NULL,
         cex.auxdata=.7, xlab=v[1], ylab=NULL,
         gridevery=NULL, gridcol=gray(.95), sort=TRUE, \dots)

summaryDp(formula,
          fun=function(x) c(Mean=mean(x, na.rm=TRUE),
                            N=sum(! is.na(x))),
          overall=TRUE, xlim=NULL, xlab=NULL,
          data=NULL, subset=NULL, na.action=na.retain,
          ncharsmax=c(50, 30),
          digits=4, ...)
}
\arguments{
  \item{x}{a numeric vector or matrix}
  \item{labels}{labels for categories corresponding to rows of
	\code{x}.  If not specified these are taken from row names of \code{x}.}
  \item{groups,gdata,cex,pch,gpch,bg,color,gcolor,lcolor,xlim,main,xlab,ylab}{see \code{\link{dotchart}}}
  \item{auxdata}{a vector of information to be put in the right margin,
	in the same order as \code{x}.  May be numeric, character, or a
	vector of expressions containing \code{\link{plotmath}} markup.  For
         \code{dotchartp}, \code{auxdata} may be a matrix to go along
         with the numeric x-axis variable, to result in point-specific
         hover text.}
  \item{auxtitle}{a column heading for \code{auxdata}}
  \item{auxgdata}{similar to \code{auxdata} but corresponding to the
		\code{gdata} argument.  These usually represent overall sample sizes
		for each group of lines.}
 \item{axisat}{a vector of tick mark locations to pass to \code{axis}.
	Useful if transforming the data axis}
  \item{axislabels}{a vector of strings specifying axis tick mark
		labels.  Useful if transforming the data axis}
	\item{digits}{number of significant digits for formatting numeric data
    in hover text for \code{dotchartp} and \code{summaryDp}}
	\item{dec}{for \code{dotchartp} only, overrides \code{digits} to
         specify the argument to \code{round()} for rounding values for
         hover labels}
  \item{cex.labels}{\code{cex} for labels}
  \item{cex.group.labels}{\code{cex} for group labels}
	\item{cex.auxdata}{\code{cex} for \code{auxdata}}
  \item{groupfont}{font number for group headings}
	\item{auxwhere}{for \code{summaryD} and \code{dotchartp} specifies
         whether \code{auxdata} 
         and \code{auxgdata} are to be placed on the far right of the
         chart, or should appear as pop-up tooltips when hovering the
         mouse over the ordinary \code{x} data points on the chart.
         Ignored for \code{dotchart3}.}
  \item{\dots}{other arguments passed to some of the graphics functions,
    or to \code{dotchart3} or \code{dotchartp} from \code{summaryD}.
         The \code{auxwhere='hover'} option is a useful argument to pass
         from \code{summaryD} to \code{dotchartp}.  Also used to pass
    other arguments to \code{dotchartpl} from \code{summaryDp}.}
  \item{layoutattr}{set to \code{TRUE} to put \code{plotly::layout}
         information in a list as an attribute \code{layout} of the
         returned \code{plotly} object instead of running the
         \code{plotly} object through the \code{layout} function.  This
         is useful if running \code{dotchartp} multiple times to later
         put together using \code{plotly::subplot} and only then running
         the result through \code{plotly::layout}.}
  \item{showlegend}{set to \code{FALSE} to suppress the \code{plotly}
         legend with \code{dotchartp}}
	\item{formula}{a formula with one variable on the left hand side (the
         variable to compute summary statistics on), and one or two
         variables on the right hand side.  If there are two variables,
         the first is taken as the major grouping variable.  If the left
         hand side variable is a matrix it has to be a legal R variable
         name, not an expression, and \code{fun} needs to be able to
         process a matrix.  For \code{summaryDp} there may be more than
  two right-hand-side variables.}
  \item{data}{a data frame or list used to find the variables in
    \code{formula}.  If omitted, the parent environment is used.}
	\item{fun}{a summarization function creating a single number from a
    vector.  Default is the mean.  For \code{summaryDp}, \code{fun}
         produces a named vector of summary statistics, with the default
         computing the \code{Mean} and \code{N} (number of non-missing values).}
	\item{funm}{applies if there are two right hand variables and
         \code{groupsummary=TRUE} and the marginal summaries over just
         the first \code{x} variable need to be computed differently
         than the summaries that are cross-classified by both
         variables.  \code{funm} defaults to \code{fun} and should
         have the same structure as \code{fun}.}
	\item{groupsummary}{By default, when there are two right-hand
         variables, \code{summarize(..., fun)} is called a second time
         without the use of the second variable, to obtain marginal
         summaries for the major grouping variable and display the
         results as a dot (and optionally in the right margin).  Set
         \code{groupsummary=FALSE} to suppress this information.}
  \item{auxvar}{when \code{fun} returns more than one statistic and the
         user names the elements in the returned vector, you can specify
         \code{auxvar} as a single character string naming one of them.
         This will cause the named element to be written in the right
         margin, and that element to be deleted when plotting the statistics.}
	\item{vals}{set to \code{TRUE} to show data values (dot
    locations) in the right margin.  Defaults to \code{TRUE} if
         \code{auxvar} is specified.}
	\item{fmtvals}{an optional function to format values before putting
         them in the right margin.  Default is the \code{format}
         function.}
  \item{symbol}{a scalar or vector of \code{pch} values for ordinary
         graphics or a character vector or scalar of \code{plotly}
         symbols.   These correspond to columns of \code{x} or elements
         produced by \code{fun}.}
  \item{col}{a function or vector of colors to assign to multiple points
         plotted in one line. If a function it will be evaluated with an
         argument equal to the number of groups/columns.}
  \item{legendgroup}{see \code{plotly} documentation; corresponds to
         column names/\code{fun} output for \code{plotly} graphs only}
 	\item{gridevery}{specify a positive number to draw very faint vertical
    grid lines every \code{gridevery} \code{x}-axis units; for
    non-\code{plotly} charts}
	\item{gridcol}{color for grid lines; default is very faint gray scale}
	\item{sort}{specify \code{sort=FALSE} to plot data in the original
         order, from top to bottom on the dot chart.  For
         \code{dotchartp}, set \code{sort} to \code{'descending'} to
         sort in descending order of the first column of \code{x}, or
         \code{'ascending'} to do the reverse.  These do not make sense
         if \code{groups} is present.}
	\item{height,width}{height and width in pixels for \code{dotchartp} if
         not using \code{plotly} defaults.  Ignored for
         \code{dotchart3}.  If set to \code{"auto"} the height is
         computed using \code{Hmisc::plotlyHeightDotchart}.}
	\item{overall}{set to \code{FALSE} to suppress plotting of
		unstratified estimates}
	\item{subset}{an observation subsetting expression}
	\item{na.action}{an \code{NA} action function}
	\item{ncharsmax}{a 2-vector specifying the number of characters after
  which an html new line character should be placed, respectively for
  the x-axis label and the stratification variable levels}
}
\value{the function returns invisibly}
\author{Frank Harrell}
\seealso{\code{\link{dotchart}},\code{\link{dotchart2}},\code{\link{summarize}},
         \code{\link{rlegend}}}
\examples{
set.seed(135)
maj <- factor(c(rep('North',13),rep('South',13)))
g <- paste('Category',rep(letters[1:13],2))
n <- sample(1:15000, 26, replace=TRUE)
y1 <- runif(26)
y2 <- pmax(0, y1 - runif(26, 0, .1))
dotchart3(cbind(y1,y2), g, groups=maj, auxdata=n, auxtitle='n',
          xlab='Y', pch=c(1,17))
## Compare with dotchart function (no superpositioning or auxdata allowed):
## dotchart(y1, g, groups=maj, xlab='Y')

\dontrun{
dotchartp(cbind(y1, y2), g, groups=maj, auxdata=n, auxtitle='n',
          xlab='Y', gdata=cbind(c(0,.1), c(.23,.44)), auxgdata=c(-1,-2),
          symbol=c('circle', 'line-ns-open'))

summaryDp(sbp ~ region + sex + race + cut2(age, g=5), data=mydata)
}

## Put options(grType='plotly') to have the following use dotchartp
## (rlegend will not apply)
## Add argument auxwhere='hover' to summaryD or dotchartp to put
## aux info in hover text instead of right margin
summaryD(y1 ~ maj + g, xlab='Mean')
summaryD(y1 ~ maj + g, groupsummary=FALSE)
summaryD(y1 ~ g, fmtvals=function(x) sprintf('\%4.2f', x))
Y <- cbind(y1, y2)   # summaryD cannot handle cbind(...) ~ ...
summaryD(Y  ~ maj + g, fun=function(y) y[1,], symbol=c(1,17))
rlegend(.1, 26, c('y1','y2'), pch=c(1,17))

summaryD(y1 ~ maj, fun=function(y) c(Mean=mean(y), n=length(y)),
         auxvar='n', auxtitle='N')
}
\keyword{hplot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simMarkovOrd.r
\name{estSeqMarkovOrd}
\alias{estSeqMarkovOrd}
\title{estSeqMarkovOrd}
\usage{
estSeqMarkovOrd(
  y,
  times,
  initial,
  absorb = NULL,
  intercepts,
  parameter,
  looks,
  g,
  formula,
  ppo = NULL,
  yprevfactor = TRUE,
  groupContrast = NULL,
  cscov = FALSE,
  timecriterion = NULL,
  coxzph = FALSE,
  sstat = NULL,
  rdsample = NULL,
  nsim = 1,
  progress = FALSE,
  pfile = ""
)
}
\arguments{
\item{y}{vector of possible y values in order (numeric, character, factor)}

\item{times}{vector of measurement times}

\item{initial}{a vector of probabilities summing to 1.0 that specifies the frequency distribution of initial values to be sampled from.  The vector must have names that correspond to values of \code{y} representing non-absorbing states.}

\item{absorb}{vector of absorbing states, a subset of \code{y}.  The default is no absorbing states.  Observations are truncated when an absorbing state is simulated.  May be numeric, character, or factor.}

\item{intercepts}{vector of intercepts in the proportional odds model.  There must be one fewer of these than the length of \code{y}.}

\item{parameter}{vector of true parameter (effects; group differences) values.  These are group 2:1 log odds ratios in the transition model, conditioning on the previous \code{y}.}

\item{looks}{integer vector of ID numbers at which maximum likelihood estimates and their estimated variances are computed.  For a single look specify a scalar value for \code{loops} equal to the number of subjects in the sample.}

\item{g}{a user-specified function of three or more arguments which in order are \code{yprev} - the value of \code{y} at the previous time, the current time \code{t}, the \code{gap} between the previous time and the current time, an optional (usually named) covariate vector \code{X}, and optional arguments such as a regression coefficient value to simulate from.  The function needs to allow \code{yprev} to be a vector and \code{yprev} must not include any absorbing states.  The \code{g} function returns the linear predictor for the proportional odds model aside from \code{intercepts}.  The returned value must be a matrix with row names taken from \code{yprev}.  If the model is a proportional odds model, the returned value must be one column.  If it is a partial proportional odds model, the value must have one column for each distinct value of the response variable Y after the first one, with the levels of Y used as optional column names.  So columns correspond to \code{intercepts}. The different columns are used for \code{y}-specific contributions to the linear predictor (aside from \code{intercepts}) for a partial or constrained partial proportional odds model.  Parameters for partial proportional odds effects may be included in the ... arguments.}

\item{formula}{a formula object given to the \code{lrm()} function using variables with these name: \code{y}, \code{time}, \code{yprev}, and \code{group} (factor variable having values '1' and '2').  The \code{yprev} variable is converted to a factor before fitting the model unless \code{yprevfactor=FALSE}.}

\item{ppo}{a formula specifying the part of \code{formula} for which proportional odds is not to be assumed, i.e., that specifies a partial proportional odds model.  Specifying \code{ppo} triggers the use of \code{VGAM::vgam()} instead of \code{rms::lrm} and will make the simulations run slower.}

\item{yprevfactor}{see \code{formula}}

\item{groupContrast}{omit this argument if \code{group} has only one regression coefficient in \code{formula}.  Otherwise if \code{ppo} is omitted, provide \code{groupContrast} as a list of two lists that are passed to \code{rms::contrast.rms()} to compute the contrast of interest and its standard error.  The first list corresponds to group 1, the second to group 2, to get a 2:1 contrast.  If \code{ppo} is given and the group effect is not just a simple regression coefficient, specify as \code{groupContrast} a function of a \code{vgam} fit that computes the contrast of interest and its standard error and returns a list with elements named \code{Contrast} and \code{SE}.}

\item{cscov}{applies if \code{ppo} is not used.  Set to \code{TRUE} to use the cluster sandwich covariance estimator of the variance of the group comparison.}

\item{timecriterion}{a function of a time-ordered vector of simulated ordinal responses \code{y} that returns a vector \code{FALSE} or \code{TRUE} values denoting whether the current \code{y} level met the condition of interest.  For example \code{estSeqMarkovOrd} will compute the first time at which \code{y >= 5} if you specify \code{timecriterion=function(y) y >= 5}.  This function is only called at the last data look for each simulated study.}

\item{coxzph}{set to \code{TRUE} if \code{timecriterion} is specified and you want to compute a statistic for testing proportional hazards at the last look of each simulated data}

\item{sstat}{set to a function of the time vector and the corresponding vector of ordinal responses for a single group if you want to compute a Wilcoxon test on a derived quantity such as the number of days in a given state.}

\item{rdsample}{an optional function to do response-dependent sampling.  It is a function of these arguments, which are vectors that stop at any absorbing state: \code{times} (ascending measurement times for one subject), \code{y} (vector of ordinal outcomes at these times for one subject.  The function returns \code{NULL} if no observations are to be dropped, returns the vector of new times to sample.}

\item{nsim}{number of simulations (default is 1)}

\item{progress}{set to \code{TRUE} to send current iteration number to \code{pfile} every 10 iterations.  Each iteration will really involve multiple simulations, if \code{parameter} has length greater than 1.}

\item{pfile}{file to which to write progress information.  Defaults to \code{''} which is the console.  Ignored if \code{progress=FALSE}.}
}
\value{
a data frame with number of rows equal to the product of \code{nsim}, the length of \code{looks}, and the length of \code{parameter}, with variables \code{sim}, \code{parameter}, \code{look}, \code{est} (log odds ratio for group), and \code{vest} (the variance of the latter).  If \code{timecriterion} is specified the data frame also contains \code{loghr} (Cox log hazard ratio for group), \code{lrchisq} (chi-square from Cox test for group), and if \code{coxph=TRUE}, \code{phchisq}, the chi-square for testing proportional hazards.  The attribute \code{etimefreq} is also present if \code{timecriterion=TRUE} and it probvides the frequency distribution of derived event times by group and censoring/event indicator.  If \code{sstat} is given, the attribute \code{sstat} is also present, and it contains an array with dimensions corresponding to simulations, parameter values within simulations, \code{id}, and a two-column subarray with columns \code{group} and \code{y}, the latter being the summary measure computed by the \code{sstat} function.  The returned data frame also has attribute \code{lrmcoef} which is the average of all the last-look logistic regression coefficient estimates over the \code{nsim} simulations.
}
\description{
Simulate Comparisons For Use in Sequential Markov Longitudinal Clinical Trial Simulations
}
\details{
Simulates sequential clinical trials of longitudinal ordinal outcomes using a first-order Markov model.  Looks are done sequentially after subject ID numbers given in the vector \code{looks} with the earliest possible look being after subject 2.  At each look, a subject's repeated records are either all used or all ignored depending on the sequent ID number.  For each true effect parameter value, simulation, and at each look, runs a function to compute the estimate of the parameter of interest along with its variance.  For each simulation, data are first simulated for the last look, and these data are sequentially revealed for earlier looks.  The user provides a function \code{g} that has extra arguments specifying the true effect of \code{parameter} the treatment \code{group} expecting treatments to be coded 1 and 2.  \code{parameter} is usually on the scale of a regression coefficient, e.g., a log odds ratio.  Fitting is done using the \code{rms::lrm()} function, unless non-proportional odds is allowed in which case \code{VGAM::vgam()} is used.  If \code{timecriterion} is specified, the function also, for the last data look only, computes the first time at which the criterion is satisfied for the subject.  The Cox/logrank chi-square statistic for comparing groups on the derived time variable is saved.  If \code{coxzph=TRUE}, the \code{survival} package correlation coefficient \code{rho} from the scaled partial residuals is also saved so that the user can later determine to what extent the Markov model resulted in the proportional hazards assumption being violated when analyzing on the time scale.
}
\seealso{
\code{gbayesSeqSim()}, \code{simMarkovOrd()}, \url{https://hbiostat.org/R/Hmisc/markov/}
}
\author{
Frank Harrell
}

\name{abs.error.pred}
\alias{abs.error.pred}
\alias{print.abs.error.pred}
\title{
  Indexes of Absolute Prediction Error for Linear Models
}
\description{
  Computes the mean and median of various absolute errors related to
  ordinary multiple regression models.  The mean and median absolute
  errors correspond to the mean square due to regression, error, and
  total. The absolute errors computed are derived from \eqn{\hat{Y} -
    \mbox{median($\hat{Y}$)}}{Yhat - median(Yhat)},
  \eqn{\hat{Y} - Y}{Yhat - Y}, and \eqn{Y -
    \mbox{median($Y$)}}{Y - median(Y)}.  The function also
  computes ratios that correspond to \eqn{R^2} and \eqn{1 - R^2} (but
  these ratios do not add to 1.0); the \eqn{R^2} measure is the ratio of
  mean or median absolute \eqn{\hat{Y} - \mbox{median($\hat{Y}$)}}{Yhat
    - median(Yhat)} to the mean or median absolute \eqn{Y -
    \mbox{median($Y$)}}{Y - median(Y)}. The \eqn{1 - R^2} or SSE/SST
  measure is the mean or median absolute \eqn{\hat{Y} - Y}{Yhat - Y}
  divided by the mean or median absolute \eqn{\hat{Y} -
   \mbox{median($Y$)}}{Y - median(Y)}.
}
\usage{
abs.error.pred(fit, lp=NULL, y=NULL)

\method{print}{abs.error.pred}(x, \dots)
}
\arguments{
  \item{fit}{
    a fit object typically from \code{\link{lm}} or \code{\link[rms]{ols}}
    that contains a y vector (i.e., you should have specified
    \code{y=TRUE} to the fitting function) unless the \code{y} argument
    is given to \code{abs.error.pred}.  If you do not specify the
    \code{lp} argument, \code{fit} must contain \code{fitted.values} or
    \code{linear.predictors}.  You must specify \code{fit} or both of
    \code{lp} and \code{y}.
  }
  \item{lp}{
    a vector of predicted values (Y hat above) if \code{fit} is not given
  }
  \item{y}{
    a vector of response variable values if \code{fit} (with
    \code{y=TRUE} in effect) is not given
  }
  \item{x}{an object created by \code{abs.error.pred}}
  \item{\dots}{unused}
}
\value{
  a list of class \code{abs.error.pred} (used by
  \code{print.abs.error.pred}) containing two matrices:
  \code{differences} and \code{ratios}.
}
\author{
  Frank Harrell\cr
  Department of Biostatistics\cr
  Vanderbilt University School of Medicine\cr
  \email{fh@fharrell.com}
}
\seealso{
  \code{\link{lm}}, \code{\link[rms]{ols}}, \code{\link{cor}},
  \code{\link[rms]{validate.ols}}
}
\references{
  Schemper M (2003): Stat in Med 22:2299-2308.

  Tian L, Cai T, Goetghebeur E, Wei LJ (2007): Biometrika 94:297-311.
}
\examples{
set.seed(1)         # so can regenerate results
x1 <- rnorm(100)
x2 <- rnorm(100)
y  <- exp(x1+x2+rnorm(100))
f <- lm(log(y) ~ x1 + poly(x2,3), y=TRUE)
abs.error.pred(lp=exp(fitted(f)), y=y)
rm(x1,x2,y,f)
}
\keyword{robust}
\keyword{regression}
\keyword{models}
\concept{predictive accuracy}

\name{cut2}
\alias{cut2}
\alias{cutGn}
\title{Cut a Numeric Variable into Intervals}
\description{
\code{cut2} is a function like \code{cut} but left endpoints are inclusive and labels are of
the form \code{[lower, upper)}, except that last interval is \code{[lower,upper]}.  
If cuts are given, will by default make sure that cuts include entire
range of \code{x}.
Also, if cuts are not given, will cut \code{x} into quantile groups 
(\code{g} given) or groups
with a given minimum number of observations (\code{m}).  Whereas cut creates a
category object, \code{cut2} creates a factor object.  \code{m} is not guaranteed but is a target.

\code{cutGn} guarantees that the grouped variable will have a minimum of \code{m} observations in any group.  This is done by an exhaustive algorithm that runs fast due to being coded in Fortran.
}
\usage{
cut2(x, cuts, m=150, g, levels.mean=FALSE, digits, minmax=TRUE,
oneval=TRUE, onlycuts=FALSE, formatfun=format, \dots)

cutGn(x, m, what=c('mean', 'factor', 'summary', 'cuts', 'function'), rcode=FALSE) 
}
\arguments{
\item{x}{
numeric vector to classify into intervals
}
\item{cuts}{
cut points
}
\item{m}{
desired minimum number of observations in a group.  The algorithm does
not guarantee that all groups will have at least \code{m} observations.
}
\item{g}{
number of quantile groups
}
\item{levels.mean}{
set to \code{TRUE} to make the new categorical vector have levels attribute that is
the group means of \code{x} instead of interval endpoint labels
}
\item{digits}{
number of significant digits to use in constructing levels.  Default is 3
(5 if \code{levels.mean=TRUE})
}
\item{minmax}{
if cuts is specified but \code{min(x)<min(cuts)} or \code{max(x)>max(cuts)}, augments
cuts to include min and max \code{x}
}
\item{oneval}{
if an interval contains only one unique value, the interval will be
labeled with the formatted version of that value instead of the
interval endpoints, unless \code{oneval=FALSE}
}
\item{onlycuts}{
  set to \code{TRUE} to only return the vector of computed cuts.  This
  consists of the interior values plus outer ranges.
}
\item{formatfun}{
  formatting function, supports formula notation (if \code{rlang} is installed)
}
\item{\dots}{
  additional arguments passed to \code{formatfun}
}
\item{what}{specifies the kind of vector values to return from \code{cutGn}, the default being like \code{'levels.mean'} of \code{cut2}.  Specify \code{'summary'} to return a numeric 3-column matrix that summarizes the intervals satisfying the \code{m} requirement. Use \code{what='cuts'} to only return the vector of computed cutpoints. To create a function that will recode the variable in play using the same intervals as computed by \code{cutGn}, specify \code{what='function'}.  This function will have a \code{what} argument to allow the user to decide later whether to recode into interval means or into a \code{factor} variable.}
\item{rcode}{set to \code{TRUE} to run the \code{cutgn} algorithm in R.  This is useful for speed comparisons with the default compiled code.}
}
\value{
a factor variable with levels of the form \code{[a,b)} or formatted means
(character strings) unless \code{onlycuts} is \code{TRUE} in which case
a numeric vector is returned
}
\seealso{
\code{\link{cut}}, \code{\link{quantile}}, \code{\link{combine.levels}}
}
\examples{
set.seed(1)
x <- runif(1000, 0, 100)
z <- cut2(x, c(10,20,30))
table(z)
table(cut2(x, g=10))      # quantile groups
table(cut2(x, m=50))      # group x into intevals with at least 50 obs.

table(cutGn(x, m=50, what='factor'))
f <- cutGn(x, m=50, what='function')
f
f(c(-1, 2, 10), what='mean')
f(c(-1, 2, 10), what='factor')
\dontrun{
  x <- round(runif(200000), 3)
  system.time(a <- cutGn(x, m=20))              # 0.02s
  system.time(b <- cutGn(x, m=20, rcode=TRUE))  # 1.51s
  identical(a, b)
}
}
\keyword{category}
\keyword{nonparametric}
\concept{grouping}
\concept{categorization}
\concept{discretization}

\name{dotchartpl}
\alias{dotchartpl}
\title{Enhanced Version of dotchart Function for plotly}
\description{
	This function produces a \code{plotly} interactive graphic and accepts
	a different format of data input than the other \code{dotchart}
	functions.  It was written to handle a hierarchical data structure
	including strata that further subdivide the main classes.  Strata,
	indicated by the \code{mult} variable, are shown  on the same
	horizontal line, and if the variable \code{big} is \code{FALSE} will
	appear slightly below the main line, using smaller symbols, and having
	some transparency.  This is intended to handle output such as that
	from the \code{summaryP} function when there is a superpositioning
	variable \code{group} and a stratification variable \code{mult},
	especially when the data have been run through the \code{addMarginal}
	function to create \code{mult} categories labelled \code{"All"} for
	which the user will specify \code{big=TRUE} to indicate non-stratified
	estimates (stratified only on \code{group}) to emphasize.

	When viewing graphics that used \code{mult} and \code{big}, the user
	can click on the legends for the small points for \code{group}s to
	vanish the finely stratified estimates.

	When \code{group} is used by \code{mult} and \code{big} are not, and
	when the \code{group} variable has exactly two distinct values, you
	can specify \code{refgroup} to get the difference between two
	proportions in addition to the individual proportions.  The individual
	proportions are plotted, but confidence intervals for the difference
	are shown in hover text and half-width confidence intervals for the
	difference, centered at the midpoint of the proportions, are shown.
	These have the property of intersecting the two proportions if and
	only if there is no significant difference at the \code{1 - conf.int}
	level.

	Specify \code{fun=exp} and \code{ifun=log} if estimates and confidence
	limits are on the log scale.  Make sure that zeros were prevented in
	the original calculations.  For exponential hazard rates this can be
	accomplished by replacing event counts of 0 with 0.5.
	}
\usage{
dotchartpl(x, major=NULL, minor=NULL, group=NULL, mult=NULL,
           big=NULL, htext=NULL, num=NULL, denom=NULL,
           numlabel='', denomlabel='',
           fun=function(x) x, ifun=function(x) x, op='-',
           lower=NULL, upper=NULL,
           refgroup=NULL, sortdiff=TRUE, conf.int=0.95,
           minkeep=NULL, xlim=NULL, xlab='Proportion',
           tracename=NULL, limitstracename='Limits',
           nonbigtracename='Stratified Estimates',
           dec=3, width=800, height=NULL,
           col=colorspace::rainbow_hcl)
}
\arguments{
  \item{x}{a numeric vector used for values on the \code{x}-axis}
	\item{major}{major vertical category, e.g., variable labels}
	\item{minor}{minor vertical category, e.g. category levels within
		variables}
	\item{group}{superpositioning variable such as treatment}
	\item{mult}{strata names for further subdivisions without
		\code{group}s}
	\item{big}{omit if all levels of \code{mult} are equally important or
		if \code{mult} is omitted.  Otherwise denotes major (larger points,
		right on horizontal lines) vs. minor (smaller, transparent points
		slightly below the line).}
	\item{htext}{additional hover text per point}
	\item{num}{if \code{x} represents proportions, optionally specifies
		numerators to be used in fractions added to hover text.  When
		\code{num} is given, \code{x} is automatically added to hover text,
		rounded to 3 digits after the decimal point.}
	\item{denom}{like \code{num} but for denominators}
	\item{numlabel}{character string to put to the right of the numerator
		in hover text}
	\item{denomlabel}{character string to put to the right of the
	denominator in hover text}
	\item{fun}{a transformation to make when printing estimates.  For
	example, one may specify \code{fun=exp} to anti-log estimates and
	confidence limites that were computed on a log basis}
  \item{ifun}{inverse transformation of \code{fun}}
  \item{op}{set to for example \code{'/'} when \code{fun=exp} and
	effects are computed as ratios instead of differences.  This is used
	in hover text.}
	\item{lower}{lower limits for optional error bars}
	\item{upper}{upper limits for optional error bars}
	\item{refgroup}{if \code{group} is specified and there are exactly two
	groups, specify the character string for the reference group in
	computing difference in proportions.  For example if
	\code{refgroup='A'} and the \code{group} levels are \code{'A','B'},
	you will get B - A.}
  \item{sortdiff}{\code{minor} categories are sorted by descending
	values of the difference in proportions when \code{refgroup} is used,
	unless you specify \code{sortdiff=FALSE}}
  \item{conf.int}{confidence level for computing confidence intervals
	for the difference in two proportions.  Specify \code{conf.int=FALSE}
	to suppress confidence intervals.}
  \item{minkeep}{if \code{refgroup} and \code{minkeep} are both given,
		observations that are at or above \code{minkeep} for at least one of
		the groups are retained.  The defaults to to keep all observations.}
	\item{xlim}{\code{x}-axis limits}
	\item{xlab}{\code{x}-axis label}
	\item{tracename}{\code{plotly} trace name if \code{group} is not used}
	\item{limitstracename}{\code{plotly} trace name for \code{lower} and
		\code{upper} if \code{group} is not used}
	\item{nonbigtracename}{\code{plotly} trace name used for non-big
	elements, which usually represent stratified versions of the "big"
	observations}
	\item{col}{a function or vector of colors to assign to \code{group}.
	If a function it will be evaluated with an argument equal to the
	number of distinct groups.}
  \item{dec}{number of places to the right of the decimal place for
	formatting numeric quantities in hover text}
  \item{width}{width of plot in pixels}
  \item{height}{height of plot in pixels; computed from number of strata
	by default}
	}
\value{a \code{plotly} object.  An attribute \code{levelsRemoved} is
	added if \code{minkeep} is used and any categories were omitted from
	the plot as a result.  This is a character vector with categories
	removed.  If \code{major} is present, the strings are of the form
	\code{major:minor}}
\author{Frank Harrell}
\seealso{\code{\link{dotchartp}}}
\examples{
\dontrun{
set.seed(1)
d <- expand.grid(major=c('Alabama', 'Alaska', 'Arkansas'),
                 minor=c('East', 'West'),
                 group=c('Female', 'Male'),
                 city=0:2)
n <- nrow(d)
d$num   <- round(100*runif(n))
d$denom <- d$num + round(100*runif(n))
d$x     <- d$num / d$denom
d$lower <- d$x - runif(n)
d$upper <- d$x + runif(n)

with(d,
 dotchartpl(x, major, minor, group, city, lower=lower, upper=upper,
            big=city==0, num=num, denom=denom, xlab='x'))

# Show half-width confidence intervals for Female - Male differences
# after subsetting the data to have only one record per
# state/region/group
d <- subset(d, city == 0)
with(d,
 dotchartpl(x, major, minor, group, num=num, denom=denom,
            lower=lower, upper=upper, refgroup='Male')
)

n <- 500
set.seed(1)
d <- data.frame(
  race         = sample(c('Asian', 'Black/AA', 'White'), n, TRUE),
  sex          = sample(c('Female', 'Male'), n, TRUE),
  treat        = sample(c('A', 'B'), n, TRUE),
  smoking      = sample(c('Smoker', 'Non-smoker'), n, TRUE),
  hypertension = sample(c('Hypertensive', 'Non-Hypertensive'), n, TRUE),
  region       = sample(c('North America','Europe','South America',
                          'Europe', 'Asia', 'Central America'), n, TRUE))

d <- upData(d, labels=c(race='Race', sex='Sex'))

dm <- addMarginal(d, region)
s <- summaryP(race + sex + smoking + hypertension ~
                region + treat,  data=dm)

s$region <- ifelse(s$region == 'All', 'All Regions', as.character(s$region))

with(s, 
 dotchartpl(freq / denom, major=var, minor=val, group=treat, mult=region,
            big=region == 'All Regions', num=freq, denom=denom)
)

s2 <- s[- attr(s, 'rows.to.exclude1'), ]
with(s2, 
     dotchartpl(freq / denom, major=var, minor=val, group=treat, mult=region,
                big=region == 'All Regions', num=freq, denom=denom)
)
# Note these plots can be created by plot.summaryP when options(grType='plotly')

# Plot hazard rates and ratios with confidence limits, on log scale
d <- data.frame(tx=c('a', 'a', 'b', 'b'),
                event=c('MI', 'stroke', 'MI', 'stroke'),
                count=c(10, 5, 5, 2),
                exposure=c(1000, 1000, 900, 900))
# There were no zero event counts in this dataset.  In general we
# want to handle that, hence the 0.5 below
d <- upData(d, hazard = pmax(0.5, count) / exposure,
               selog  = sqrt(1. / pmax(0.5, count)),
               lower  = log(hazard) - 1.96 * selog,
               upper  = log(hazard) + 1.96 * selog)
with(d,
     dotchartpl(log(hazard), minor=event, group=tx, num=count, denom=exposure,
                lower=lower, upper=upper,
                fun=exp, ifun=log, op='/',
                numlabel='events', denomlabel='years',
                refgroup='a', xlab='Events Per Person-Year')
)
}
}
\keyword{hplot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stat-plsmo.r
\name{stat_plsmo}
\alias{stat_plsmo}
\title{Add a lowess smoother without counfidence bands.}
\usage{
stat_plsmo(
  mapping = NULL,
  data = NULL,
  geom = "smooth",
  position = "identity",
  n = 80,
  fullrange = FALSE,
  span = 2/3,
  fun = function(x) x,
  na.rm = FALSE,
  show.legend = NA,
  inherit.aes = TRUE,
  ...
)
}
\arguments{
\item{mapping, data, geom, position, show.legend, inherit.aes}{see ggplot2 documentation}

\item{n}{number of points to evaluate smoother at}

\item{fullrange}{should the fit span the full range of the plot, or just
the data}

\item{span}{see \code{f} argument to \code{lowess}}

\item{fun}{a function to transform smoothed \code{y}}

\item{na.rm}{If \code{FALSE} (the default), removes missing values with
a warning.  If \code{TRUE} silently removes missing values.}

\item{...}{other arguments are passed to smoothing function}
}
\value{
a data.frame with additional columns
  \item{y}{predicted value}
}
\description{
Automatically selects \code{iter=0} for \code{lowess} if \code{y} is binary, otherwise uses \code{iter=3}.
}
\examples{
\donttest{
c <- ggplot(mtcars, aes(qsec, wt))
c + stat_plsmo()
c + stat_plsmo() + geom_point()

c + stat_plsmo(span = 0.1) + geom_point()

# Smoothers for subsets
c <- ggplot(mtcars, aes(y=wt, x=mpg)) + facet_grid(. ~ cyl)
c + stat_plsmo() + geom_point()
c + stat_plsmo(fullrange = TRUE) + geom_point()

# Geoms and stats are automatically split by aesthetics that are factors
c <- ggplot(mtcars, aes(y=wt, x=mpg, colour=factor(cyl)))
c + stat_plsmo() + geom_point()
c + stat_plsmo(aes(fill = factor(cyl))) + geom_point()
c + stat_plsmo(fullrange=TRUE) + geom_point()

# Example with logistic regression
data("kyphosis", package="rpart")
qplot(Age, as.numeric(Kyphosis) - 1, data = kyphosis) + stat_plsmo()
}
}
\seealso{
\code{\link{lowess}} for \code{loess} smoother.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/meltData.r
\name{meltData}
\alias{meltData}
\title{meltData}
\usage{
meltData(
  formula,
  data,
  tall = c("right", "left"),
  vnames = c("labels", "names"),
  sepunits = FALSE,
  ...
)
}
\arguments{
\item{formula}{a formula}

\item{data}{data frame or table}

\item{tall}{see above}

\item{vnames}{set to \code{names} to always use variable names instead of labels for X}

\item{sepunits}{set to \code{TRUE} to create a separate variable \code{Units} to hold units of measurement.  The variable is not created if no original variables have a non-blank \code{units} attribute.}

\item{...}{passed to \code{label()}}
}
\value{
data table
}
\description{
Melt a Dataset To Examine All Xs vs Y
}
\details{
Uses a formula with one or more left hand side variables (Y) and one or more right hand side variables (X).  Uses \code{\link[data.table:melt]{data.table::melt()}} to melt \code{data} so that each X is played against the same Y if \code{tall='right'} (the default) or each Y is played against the same X combination if \code{tall='left'}.  The resulting data table has variables Y with their original names (if \code{tall='right'}) or variables X with their original names (if \code{tall='left'}), \code{variable}, and \code{value}.  By default \code{variable} is taken as \code{label()}s of the \code{tall} variables.
}
\examples{
d <- data.frame(y1=(1:10)/10, y2=(1:10)/100, x1=1:10, x2=101:110)
label(d$x1) <- 'X1'
units(d$x1) <- 'mmHg'
m=meltData(y1 + y2 ~ x1 + x2, data=d, units=TRUE) # consider also html=TRUE
print(m)
m=meltData(y1 + y2 ~ x1 + x2, data=d, tall='left')
print(m)
}
\seealso{
\code{\link[=label]{label()}}
}
\author{
Frank Harrell
}

\name{html}
\alias{html}
\alias{html.latex}
\alias{html.data.frame}
\alias{html.default}
\alias{htmlVerbatim}
\title{Convert an S object to HTML}
\description{
\code{html} is a generic function, for which only two methods are currently
implemented, \code{html.latex} and a rudimentary
\code{html.data.frame}.  The former uses the \code{HeVeA} LaTeX to HTML 
translator by Maranget to create an HTML file from a LaTeX file like
the one produced by \code{latex}.  \code{html.default} just runs
\code{html.data.frame}. 
\code{htmlVerbatim} prints all of its arguments to the console in an
html verbatim environment, using a specified percent of the prevailing
character size.  This is useful for R Markdown with \code{knitr}.

Most of the html-producing functions in the Hmisc and rms packages
return a character vector passed through \code{htmltools::HTML} so that
\code{kintr} will correctly format the result without the need for the
user putting \code{results='asis'} in the chunk header.
}
\usage{
html(object, \dots)
\method{html}{latex}(object, file, where=c('cwd', 'tmp'),
  method=c('hevea', 'htlatex'),
  rmarkdown=FALSE, cleanup=TRUE, \dots)
\method{html}{data.frame}(object,
  file=paste(first.word(deparse(substitute(object))),'html',sep='.'), header,
     caption=NULL, rownames=FALSE, align='r', align.header='c',
     bold.header=TRUE, col.header='Black',
     border=2, width=NULL, size=100, translate=FALSE,
     append=FALSE, link=NULL, linkCol=1,
     linkType=c('href','name'), disableq=FALSE, \dots) 
\method{html}{default}(object,
     file=paste(first.word(deparse(substitute(object))),'html',sep='.'),
     append=FALSE, link=NULL, linkCol=1, linkType=c('href','name'), \dots)
htmlVerbatim(\dots, size=75, width=85, scroll=FALSE, rows=10, cols=100,
             propts=NULL, omit1b=FALSE)
}
\arguments{
\item{object}{a data frame or an object created by \code{latex}.
  For the generic \code{html} is any object for which an \code{html}
	method exists.} 
\item{file}{
name of the file to create.  The default file
name is \code{object.html} where \code{object} is the first word in
the name of the argument for \code{object}.  For \code{html.latex}
specify \code{file=''} or \code{file=character(0)} to print html code to
the console, as when using \code{knitr}.  For the \code{data.frame}
method, \code{file} may be set to \code{FALSE} which causes a character
vector enclosed in \code{htmltools::HTML} to be returned instead of
writing to the console. 
}
\item{where}{for \code{html}.  Default is to put output files in current
	working directory.  Specify \code{where='tmp'} to put in a system
	temporary directory area.}
\item{method}{default is to use system command \code{hevea} to convert
	from LaTeX to html.  Specify\code{method='htlatex'} to use system
	command \code{htlatex}, assuming the 
	system package \code{TeX4ht} is installed.}
\item{rmarkdown}{set to \code{TRUE} if using RMarkdown (usually under
	\code{knitr} and RStudio).  This causes html to be packaged for
	RMarkdown and output to go into the console stream.  \code{file} is
	ignored when \code{rmarkdown=TRUE}.}
\item{cleanup}{if using \code{method='htlatex'} set to \code{FALSE} if
	\code{where='cwd'} to	prevent deletion of auxiliary files created by
	\code{htlatex} that are not needed when using the final \code{html}
	document (only the \code{.css} file is needed in addition to
	\code{.html}).  If using \code{method='hevea'}, \code{cleanup=TRUE}
	causes deletion of the generated \code{.haux} file.}
\item{header}{vector of column names.  Defaults to names in
	\code{object}.  Set to \code{NULL} to suppress column names.}
\item{caption}{a character string to be used as a caption before the
	table}
\item{rownames}{set to \code{FALSE} to ignore row names even if they are
	present}
\item{align}{alignment for table columns (all are assumed to have the
	same if is a scalar).  Specify \code{"c", "r", "l"} for center, right, or left
	alignment.}
\item{align.header}{same coding as for \code{align} but pertains to
	header}
\item{bold.header}{set to \code{FALSE} to not bold face column headers}
\item{col.header}{color for column headers}
\item{border}{set to 0 to not include table cell borders, 1 to include
	only outer borders, or 2 (the default) to put borders around cells too}
\item{translate}{set to \code{TRUE} to run header and table cell text
	through the \code{htmlTranslate} function}
\item{width}{optional table width for \code{html.data.frame}.  For full
	page width use \code{width="100\%"}, for use in \code{options()} for
	printing objects.}
\item{size}{a number between 0 and 100 representing the percent of the
	prevailing character size to be used by \code{htmlVerbatim} and the
	data frame method.}
\item{append}{set to \code{TRUE} to append to an existing file}
\item{link}{character vector specifying hyperlink names to attach to
  selected elements of the matrix or data frame.  No hyperlinks are used
  if \code{link} is omitted or for elements of \code{link} that are
  \code{""}.  To allow multiple links per link, \code{link} may also be
  a character matrix shaped as \code{object} in which case
  \code{linkCol} is ignored.}
\item{linkCol}{column number of \code{object} to which hyperlinks are
  attached.  Defaults to first column.}
\item{linkType}{defaults to \code{"href"}}
\item{disableq}{set to \code{TRUE} to add code to the html table tag
	that makes Quarto not use its usual table style}
\item{\dots}{ignored except for \code{htmlVerbatim} - is a list of
	objects to \code{print()}}
\item{scroll}{set to \code{TRUE} to put the html in a scrollable
	\code{textarea}}
\item{rows,cols}{the number of rows and columns to devote to the visable
	part of the scrollable box}
\item{propts}{options, besides \code{quote=FALSE} to pass to the
	\code{print} method, for \code{htmlVerbatim}}
\item{omit1b}{for \code{htmlVerbatim} if \code{TRUE} causes an initial
	and a final line of output that is all blank to be deleted}
}
\author{
Frank E. Harrell, Jr.
\cr
Department of Biostatistics,
\cr
Vanderbilt University,
\cr
\email{fh@fharrell.com}
}
\references{
Maranget, Luc.  HeVeA: a LaTeX to HTML translater.
URL: http://para.inria.fr/~maranget/hevea/
}
\seealso{
\code{\link{latex}}
}
\examples{
\dontrun{
x <- matrix(1:6, nrow=2, dimnames=list(c('a','b'),c('c','d','e')))
w <- latex(x)
h <- html(w) # run HeVeA to convert .tex to .html
h <- html(x) # convert x directly to html
w <- html(x, link=c('','B'))   # hyperlink first row first col to B

# Assuming system package tex4ht is installed, easily convert advanced
# LaTeX tables to html
getHdata(pbc)
s <- summaryM(bili + albumin + stage + protime + sex + age + spiders ~ drug,
              data=pbc, test=TRUE)
w <- latex(s, npct='slash', file='s.tex')
z <- html(w)
browseURL(z$file)

d <- describe(pbc)
w <- latex(d, file='d.tex')
z <- html(w)
browseURL(z$file)
}
}
\keyword{utilities}
\keyword{interface}
\keyword{methods}
\keyword{file}
\keyword{character}
\keyword{manip}

\name{knitrSet}
\alias{knitrSet}
\alias{plotlySave}
\title{knitr Setup and plotly Service Function}
\description{
	\code{knitrSet} sets up knitr to use better default parameters for base graphics,
	better code formatting, and to allow several arguments to be passed
	from code chunk headers, such as \code{bty}, \code{mfrow}, \code{ps},
	\code{bot} (extra bottom margin for base graphics), \code{top} (extra
	top margin), \code{left} (extra left margin), \code{rt} (extra right
	margin), \code{lwd}, \code{mgp}, \code{las}, \code{tcl}, \code{axes},
	\code{xpd}, \code{h} (usually \code{fig.height} in knitr),
	\code{w} (usually \code{fig.width} in knitr), \code{wo}
	(\code{out.width} in knitr), \code{ho} (\code{out.height} in knitr),
	\code{cap} (character
	string containing figure caption), \code{scap} (character string
	containing short figure caption for table of figures).  The
	\code{capfile} argument facilities auto-generating a table of figures
	for certain Rmarkdown report themes.  This is done by the addition of
	a hook function that appends data to the \code{capfile} file each time
	a chunk runs that has a long or short caption in the chunk header.

	\code{plotlySave} saves a plotly graphic with name \code{foo.png}
	where \code{foo} is the name of the current chunk.  You must have a
	free \code{plotly} account from \code{plot.ly} to use this function,
	and you must have run 
  \code{Sys.setenv(plotly_username="your_plotly_username")} and
  \code{Sys.setenv(plotly_api_key="your_api_key")}. The API key can be
	found in one's profile settings.
}
\usage{
knitrSet(basename=NULL, w=if(! bd) 4, h=if(! bd) 3, wo=NULL, ho=NULL,
         fig.path=if(length(basename)) basename else '',
         fig.align=if(! bd) 'center', fig.show='hold',
         fig.pos=if(! bd) 'htbp',
         fig.lp=if(! bd) paste('fig', basename, sep=':'),
         dev=switch(lang, latex='pdf', markdown='png', blogdown=NULL),
         tidy=FALSE, error=FALSE,
         messages=c('messages.txt', 'console'),
         width=61, decinline=5, size=NULL, cache=FALSE,
         echo=TRUE, results='markup', capfile=NULL,
         lang=c('latex','markdown','blogdown'))

plotlySave(x, \dots)
}
\arguments{
  \item{basename}{base name to be added in front of graphics file
		names. \code{basename} is followed by a minus sign.}
	\item{w,h}{default figure width and height in inches}
	\item{wo,ho}{default figure rendering width and height, in integer
		pixels or percent as a character string, e.g. \code{'40\%'}}
	\item{fig.path}{path for figures.  To put figures in a subdirectory
		specify e.g. \code{fig.path='folder/'}.  Ignored for blogdown.}
	\item{fig.align,fig.show,fig.pos,fig.lp,tidy,cache,echo,results,error,size}{see knitr documentation} 
	\item{dev}{graphics device, with default figured from \code{lang}}
	\item{messages}{By default warning and other messages such as those
		from loading packages are sent to file \code{'messages.txt'} in the
		current working directory.  You can specify
		\code{messages='console'} to send them directly to the console.}
	\item{width}{text output width for R code and output}
	\item{decinline}{number of digits to the right of the decimal point to
		round numeric values appearing inside Sexpr}
	\item{capfile}{the name of a file in the current working directory
		that is used to accumulate chunk labels, figure cross-reference
		tags, and figure short captions (long captions if no short caption
		is defined) for the purpose of using
		\code{markupSpecs$markdown$tof()} to insert a table of figures in a
		report.  The file as appended to, which is useful if
		\code{cache=TRUE} is used since this will keep some chunks from
		running.  The \code{tof} function will remove earlier duplicated
		figure tags if this is the case.  If not \code{cache}ing, the user
		should initialize the file to empty at the top of the script.}
	\item{lang}{Default is \code{'latex'} to use LaTeX.  Set to
		\code{'markdown'} when using R Markdown or \code{'blogdown'}.  For
		\code{'blogdown'} \code{par} and \code{knitr} graphics-related hooks
		are not called as this would prevent
		\code{blogdown} from putting graphics files in the correct directory
		for the blog system.}
	\item{x}{a \code{plotly} graphics object or a named list of such
		objects.  The resulting \code{png} file will go in the file path
		given by the \code{knitr} \code{fig.path} value, and have a base
		name equal to the current \code{knitr} chunk name.  If \code{x} is a
		list, a minus sign followed by the chunk name are inserted before
		\code{.png}.}
	\item{\dots}{additional arguments passed to \code{plotly::plotly_IMAGE}}
}
\author{Frank Harrell}
\seealso{\code{\link[knitr]{knit}}}
\examples{
\dontrun{
# Typical call (without # comment symbols):
# <<echo=FALSE>>=
# require(Hmisc)
# knitrSet()
# @

knitrSet()    # use all defaults and don't use a graphics file prefix
knitrSet('modeling')   # use modeling- prefix for a major section or chapter
knitrSet(cache=TRUE, echo=FALSE)  # global default to cache and not print code
knitrSet(w=5,h=3.75)   # override default figure width, height

# ```{r chunkname}
# p <- plotly::plot_ly(...)
# plotlySave(p)   # creates fig.path/chunkname.png
}
}
\keyword{interface}

\name{\%nin\%}
\alias{\%nin\%}
\title{
  Find Matching (or Non-Matching) Elements
}
\description{
  \code{\%nin\%} is a binary operator, which returns a logical vector indicating
  if there is a match or not for its left operand. A true vector element
  indicates no match in left operand, false indicates a match.
}
\usage{
x \%nin\% table
}
\arguments{
  \item{x}{
    a vector (numeric, character, factor)
  }
  \item{table}{
    a vector (numeric, character, factor), matching the mode of \code{x}
  }
}
\value{
  vector of logical values with length equal to length of \code{x}.
}
\seealso{
  \code{\link{match}} \code{\link{\%in\%}}
}
\examples{
c('a','b','c') \%nin\% c('a','b')
}
\keyword{manip}
\keyword{character}

\name{units}
\alias{units}
\alias{units.default}
\alias{units.Surv}
\alias{units<-.default}
\title{
Units Attribute of a Vector  
}
\description{
Sets or retrieves the \code{"units"} attribute of an object.
For \code{units.default} replaces the builtin
version, which only works for time series objects.  If the variable is
also given a \code{label}, subsetting (using \code{[.labelled}) will
retain the \code{"units"} attribute.  For a \code{Surv} object,
\code{units} first looks for an overall \code{"units"} attribute, then
it looks for \code{units} for the \code{time2} variable then for \code{time1}.
}
\usage{
units(x, \dots)
\method{units}{default}(x, none='', \dots)
\method{units}{Surv}(x, none='', \dots)
\method{units}{default}(x) <- value
}
\arguments{
\item{x}{any object}
\item{\dots}{ignored}
\item{value}{the units of the object, or ""}
\item{none}{value to which to set result if no appropriate attribute is
  found}
}
\value{
the units attribute of x, if any; otherwise, the \code{units} attribute of
the \code{tspar} attribute of \code{x} if any; otherwise the value
\code{none}.  Handling for \code{Surv} objects is different (see above).
}
\seealso{\code{\link{label}}}
\examples{
fail.time <- c(10,20)
units(fail.time) <- "Day"
describe(fail.time)
S <- Surv(fail.time)
units(S)

label(fail.time) <- 'Failure Time'
fail.time
}
\keyword{utilities}
\keyword{interface}

\name{rcorr}
\alias{rcorr}
\alias{print.rcorr}
\title{Matrix of Correlations and P-values}
\description{
  \code{rcorr} Computes a matrix of Pearson's \code{r} or Spearman's
  \code{rho} rank correlation coefficients for all possible pairs of
  columns of a matrix.  Missing values are deleted in pairs rather than
  deleting all rows of \code{x} having any missing variables.  Ranks are
  computed using efficient algorithms (see reference 2), using midranks
  for ties.
}
\usage{
rcorr(x, y, type=c("pearson","spearman"))

\method{print}{rcorr}(x, \dots)
}
\arguments{
\item{x}{
  a numeric matrix with at least 5 rows and at least 2 columns (if
  \code{y} is absent).  For \code{print}, \code{x} is an object
  produced by \code{rcorr}.
}
\item{y}{
  a numeric vector or matrix which will be concatenated to \code{x}.  If
  \code{y} is omitted for \code{rcorr}, \code{x} must be a matrix.
}
\item{type}{
  specifies the type of correlations to compute.  Spearman correlations
  are the Pearson linear correlations computed on the ranks of non-missing
  elements, using midranks for ties.
}
\item{\dots}{argument for method compatiblity.}
}
\value{
\code{rcorr} returns a list with elements \code{r}, the
matrix of correlations, \code{n} the
matrix of number of observations used in analyzing each pair of variables,
\code{P}, the asymptotic P-values, and \code{type}.
Pairs with fewer than 2 non-missing values have the r values set to NA.
The diagonals of \code{n} are the number of non-NAs for the single variable
corresponding to that row and column.
}
\details{
Uses midranks in case of ties, as described by Hollander and Wolfe.
P-values are approximated by using the \code{t} or \code{F} distributions.
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\references{
Hollander M. and Wolfe D.A. (1973).  Nonparametric Statistical Methods.
New York: Wiley.

Press WH, Flannery BP, Teukolsky SA, Vetterling, WT (1988): Numerical
Recipes in C.  Cambridge: Cambridge University Press.
}
\seealso{
\code{\link{hoeffd}}, \code{\link{cor}}, \code{\link{combine.levels}},
\code{\link{varclus}}, \code{\link{dotchart3}}, \code{\link{impute}},
\code{\link{chisq.test}}, \code{\link{cut2}}.
}
\examples{
x <- c(-2, -1, 0, 1, 2)
y <- c(4,   1, 0, 1, 4)
z <- c(1,   2, 3, 4, NA)
v <- c(1,   2, 3, 4, 5)
rcorr(cbind(x,y,z,v))
}
\keyword{nonparametric}
\keyword{htest}
\keyword{category}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/htmltabv.r
\name{htmltabv}
\alias{htmltabv}
\title{htmltabc}
\usage{
htmltabv(..., cols = 2, propts = list(quote = FALSE))
}
\arguments{
\item{...}{objects to \code{print()}.  The arguments must be named with the labels you want to print before the verbatim \code{print()}.}

\item{cols}{number of columns in the html table}

\item{propts}{an option list of arguments to pass to the \code{print()} methods; default is to not quote character strings}
}
\value{
character string of html
}
\description{
Simple HTML Table of Verbatim Output
}
\details{
Uses \code{capture.output} to capture as character strings the results of
running \code{print()} on each element of \code{...}.  If an element of \code{...} has
length of 1 and is a blank string, nothing is printed for that cell
other than its name (not in verbatim).
}
\author{
Frank Harrell
}

\name{rcorrp.cens}
\alias{rcorrp.cens}
\alias{improveProb}
\alias{print.improveProb}
\title{
  Rank Correlation for Paired Predictors with a Possibly Censored
  Response, and Integrated Discrimination Index
}
\description{
  Computes U-statistics to test for whether predictor \var{X1} is more
  concordant than predictor \var{X2}, extending \code{rcorr.cens}.  For
  \code{method=1}, estimates the fraction of pairs for which the
  \code{x1} difference is more impressive than the \code{x2}
  difference. For \code{method=2}, estimates the fraction of pairs for
  which \code{x1} is concordant with \code{S} but \code{x2} is not.

  For binary responses the function \code{improveProb} provides several
  assessments of whether one set of predicted probabilities is better
  than another, using the methods describe in 
  \cite{Pencina et al (2007)}. This involves NRI and IDI to test for
  whether predictions from model \code{x1} are significantly different
  from those obtained from predictions from model \code{x2}. This is a
  distinct improvement over comparing ROC areas, sensitivity, or
  specificity.
}
\usage{
rcorrp.cens(x1, x2, S, outx=FALSE, method=1)

improveProb(x1, x2, y)

\method{print}{improveProb}(x, digits=3, conf.int=.95, \dots)
}
\arguments{
  \item{x1}{
    first predictor (a probability, for \code{improveProb})
  } 
  \item{x2}{
    second predictor (a probability, for \code{improveProb})
  }
  \item{S}{
    a possibly right-censored \code{\link[survival]{Surv}} object.  If
    \code{S} is a vector instead, it is converted to a
    \code{\link[survival]{Surv}} object and it is assumed that no
    observations are censored.
  }
  \item{outx}{
    set to \code{TRUE} to exclude pairs tied on \code{x1} or \code{x2}
    from consideration
  }
  \item{method}{
    see above
  }
  \item{y}{
    a binary 0/1 outcome variable
  }
  \item{x}{
    the result from \code{improveProb}
  }
  \item{digits}{
    number of significant digits for use in printing the result of
    \code{improveProb}
  } 
  \item{conf.int}{
    level for confidence limits
  }
  \item{\dots}{
    unused
  }
}
\details{
  If \code{x1},\code{x2} represent predictions from models, these
  functions assume either that you are using a separate sample from the
  one used to build the model, or that the amount of overfitting in
  \code{x1} equals the amount of overfitting in \code{x2}.  An example
  of the latter is giving both models equal opportunity to be complex so
  that both models have the same number of effective degrees of freedom,
  whether a predictor was included in the model or was screened out by a
  variable selection scheme.
  
  Note that in the first part of their paper, \cite{Pencina et al.}
  presented measures that required binning the predicted probabilities.
  Those measures were then replaced with better continuous measures that
  are implementedhere.
}
\value{
  a vector of statistics for \code{rcorrp.cens}, or a list with class
  \code{improveProb} of statistics for \code{improveProb}:
   \cr
  \item{n}{number of cases}
  \item{na}{number of events}
  \item{nb}{number of non-events}
  \item{pup.ev}{
    mean of pairwise differences in probabilities for those with events
    and a pairwise difference of \eqn{\mbox{probabilities}>0}
  }
  \item{pup.ne}{
    mean of pairwise differences in probabilities for those without
    events and a pairwise difference of \eqn{\mbox{probabilities}>0}
  } 
  \item{pdown.ev}{
    mean of pairwise differences in probabilities for those with events
    and a pairwise difference of \eqn{\mbox{probabilities}>0}
  } 
  \item{pdown.ne}{
    mean of pairwise differences in probabilities for those without
    events and a pairwise difference of \eqn{\mbox{probabilities}>0}
  }
  \item{nri}{
    Net Reclassification Index =
    \eqn{(pup.ev-pdown.ev)-(pup.ne-pdown.ne)}
  }
  \item{se.nri}{standard error of NRI}
  \item{z.nri}{Z score for NRI}
  \item{nri.ev}{Net Reclassification Index = \eqn{pup.ev-pdown.ev}}
  \item{se.nri.ev}{SE of NRI of events}
  \item{z.nri.ev}{Z score for NRI of events}
  \item{nri.ne}{Net Reclassification Index = \eqn{pup.ne-pdown.ne}}
  \item{se.nri.ne}{SE of NRI of non-events}
  \item{z.nri.ne}{Z score for NRI of non-events}
  \item{improveSens}{improvement in sensitivity}
  \item{improveSpec}{improvement in specificity}
  \item{idi}{Integrated Discrimination Index}
  \item{se.idi}{SE of IDI}
  \item{z.idi}{Z score of IDI}
}
\author{
  Frank Harrell  \cr
  Department of Biostatistics, Vanderbilt University  \cr
  \email{fh@fharrell.com}

  Scott Williams  \cr
  Division of Radiation Oncology  \cr
  Peter MacCallum Cancer Centre, Melbourne, Australia  \cr
  \email{scott.williams@petermac.org}
}
\references{
  Pencina MJ, D'Agostino Sr RB, D'Agostino Jr RB, Vasan RS (2008):
  Evaluating the added predictive ability of a new marker: From area
  under the ROC curve to reclassification and beyond.  Stat in Med 27:157-172.
  DOI: 10.1002/sim.2929
  
  Pencina MJ, D'Agostino Sr RB, D'Agostino Jr RB, Vasan RS:
  Rejoinder: Comments on Integrated discrimination and net reclassification
  improvements-Practical advice. Stat in Med 2007; DOI: 10.1002/sim.3106  

  Pencina MJ, D'Agostino RB, Steyerberg EW (2011): Extensions of net
  reclassification improvement calculations to measure usefulness of new
  biomarkers.  Stat in Med 30:11-21; DOI: 10.1002/sim.4085
}
\seealso{
  \code{\link{rcorr.cens}}, \code{\link{somers2}},
  \code{\link[survival]{Surv}}, \code{\link[rms]{val.prob}}
}
\examples{
set.seed(1)
library(survival)

x1 <- rnorm(400)
x2 <- x1 + rnorm(400)
d.time <- rexp(400) + (x1 - min(x1))
cens   <- runif(400,.5,2)
death  <- d.time <= cens
d.time <- pmin(d.time, cens)
rcorrp.cens(x1, x2, Surv(d.time, death))
#rcorrp.cens(x1, x2, y) ## no censoring

set.seed(1)
x1 <- runif(1000)
x2 <- runif(1000)
y  <- sample(0:1, 1000, TRUE)
rcorrp.cens(x1, x2, y)
improveProb(x1, x2, y)
}
\keyword{survival}
\keyword{nonparametric}
\keyword{regression}
\concept{logistic regression model}
\concept{predictive accuracy}

\name{Hmisc-internal}
\title{Internal Hmisc functions}
\alias{dataDensityString}
\alias{aregTran}
\alias{as.double.Cbind}
\alias{as.numeric.Cbind}
\alias{formatSep}
\alias{as.data.frame.impute}
\alias{as.data.frame.roundN}
\alias{as.data.frame.special.miss}
\alias{as.data.frame.substi}
\alias{substi}
\alias{substi.source}
\alias{[.substi}
\alias{bpx}
\alias{convertPdate}
\alias{ddmmmyy}
\alias{expr.tree}
\alias{fillin}
\alias{formatCats}
\alias{formatCons}
\alias{formatDateTime}
\alias{formatTestStats}
\alias{format.timePOSIXt}
\alias{ftuss}
\alias{ftupwr}
\alias{get2rowHeads}
\alias{groupn}
\alias{htmlGreek}
\alias{htmlSpecial}
\alias{markupSpecs}
\alias{importConvertDateTime}
\alias{is.present}
\alias{lookupSASContents}
\alias{makeNames}
\alias{mask}
\alias{nafitted.delete}
\alias{na.include}
\alias{Names2names}
\alias{GetModelFrame}
\alias{naprint.keep}
\alias{naresid.keep}
\alias{naprint.delete}
\alias{naresid.delete}
\alias{napredict.delete}
\alias{oPar}
\alias{optionsCmds}
\alias{ordGridFun}
\alias{parGrid}
\alias{pasteFit}
\alias{plotpsummaryM}
\alias{print.substi}
\alias{print.timePOSIXt}
\alias{read.xportDataload}
\alias{readSAScsv}
\alias{rowsumFast}
\alias{sas.get.macro}
\alias{setParNro}
\alias{StatPlsmo}
\alias{stepfun.eval}
\alias{stripChart}
\alias{termsDrop}
\alias{testDateTime}
\alias{uncbind}
\alias{var.inner}
\alias{xInch}
\alias{xySortNoDupNoNA}
\alias{yInch}
\alias{zoom}
\alias{latex.responseSummary}
\alias{print.responseSummary}
\alias{responseSummary}
\alias{combine}
\alias{combine<-}
\alias{F_cidxcn}
\alias{F_cidxcp}
\alias{F_do_mchoice_match}
\alias{F_do_nstr}
\alias{F_hoeffd}
\alias{F_jacklins}
\alias{F_largrec}
\alias{F_maxempr}
\alias{F_rcorr}
\alias{F_wclosepw}
\alias{F_wclosest}

\description{Internal Hmisc functions.}
\details{These are not to be called by the user or are undocumented.}
\keyword{internal}

\name{format.pval}
\alias{format.pval}
\title{Format P Values}
\description{
  \code{format.pval} is intended for formatting p-values.
}
\usage{
format.pval(x, pv=x, digits = max(1, .Options$digits - 2),
            eps = .Machine$double.eps, na.form = "NA", \dots)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{pv}{a numeric vector.}
  \item{x}{argument for method compliance.}
  \item{digits}{how many significant digits are to be used.}
  \item{eps}{a numerical tolerance: see Details.}
  \item{na.form}{character representation of \code{NA}s.}
  \item{\dots}{
    arguments passed to \code{\link{format}} in the \code{format.pval}
    function body.
  }
}
\details{
  \code{format.pval} is mainly an auxiliary function for
  \code{\link{print.summary.lm}} etc., and does separate formatting for
  fixed, floating point and very small values; those less than
  \code{eps} are formatted as \dQuote{\samp{< [eps]}} (where
  \dQuote{\samp{[eps]}} stands for \code{format(eps, digits)}).
}
\value{
  A character vector.
}
\note{This is the base \code{\link[base]{format.pval}} function with the
  ablitiy to pass the \code{nsmall} argument to \code{\link{format}}
}
\examples{
format.pval(c(runif(5), pi^-100, NA))
format.pval(c(0.1, 0.0001, 1e-27))
format.pval(c(0.1, 1e-27), nsmall=3)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{print}

\name{scat1d}
\alias{scat1d}
\alias{jitter2}
\alias{jitter2.default}
\alias{jitter2.data.frame}
\alias{datadensity}
\alias{datadensity.data.frame}
\alias{histSpike}
\alias{histSpikeg}
\alias{ecdfpM}
\title{One-Dimensional Scatter Diagram, Spike Histogram, or Density}
\description{
  \code{scat1d} adds tick marks (bar codes. rug plot) on any of the four
  sides of an existing plot, corresponding with non-missing values of a
  vector \code{x}.  This is used to show the data density.  Can also
  place the tick marks along a curve by specifying y-coordinates to go
  along with the \code{x} values.
  
  If any two values of \code{x} are within \eqn{\code{eps}*w} of
  each other, where \code{eps} defaults to .001 and w is the span
  of the intended axis, values of \code{x} are jittered by adding a
  value uniformly distributed in \eqn{[-\code{jitfrac}*w,
  \code{jitfrac}*w]}, where \code{jitfrac} defaults to
  .008. Specifying \code{preserve=TRUE} invokes \code{jitter2} with a
  different logic of jittering. Allows plotting random sub-segments to
  handle very large \code{x} vectors (see\code{tfrac}).
  
  \code{jitter2} is a generic method for jittering, which does not add
  random noise. It retains unique values and ranks, and randomly spreads
  duplicate values at equidistant positions within limits of enclosing
  values. \code{jitter2} is especially useful for numeric variables with
  discrete values, like rating scales. Missing values are allowed and
  are returned. Currently implemented methods are \code{jitter2.default}
  for vectors and \code{jitter2.data.frame} which returns a data.frame
  with each numeric column jittered.
  
  \code{datadensity} is a generic method used to show data densities in
  more complex situations.  Here, another \code{datadensity} method is
  defined for data frames. Depending on the \code{which} argument, some
  or all of the variables in a data frame will be displayed, with
  \code{scat1d} used to display continuous variables and, by default,
  bars used to display frequencies of categorical, character, or
  discrete numeric variables.  For such variables, when the total length
  of value labels exceeds 200, only the first few characters from each
  level are used. By default, \code{datadensity.data.frame} will
  construct one axis (i.e., one strip) per variable in the data frame.
  Variable names appear to the left of the axes, and the number of
  missing values (if greater than zero) appear to the right of the axes.
  An optional \code{group} variable can be used for stratification,
  where the different strata are depicted using different colors.  If
  the \code{q} vector is specified, the desired quantiles (over all
  \code{group}s) are displayed with solid triangles below each axis.
  
  When the sample size exceeds 2000 (this value may be modified using
  the \code{nhistSpike} argument, \code{datadensity} calls
  \code{histSpike} instead of \code{scat1d} to show the data density for
  numeric variables.  This results in a histogram-like display that
  makes the resulting graphics file much smaller.  In this case,
  \code{datadensity} uses the \code{minf} argument (see below) so that
  very infrequent data values will not be lost on the variable's axis,
  although this will slightly distortthe histogram.
  
  \code{histSpike} is another method for showing a high-resolution data
  distribution that is particularly good for very large datasets (say
  \eqn{\code{n} > 1000}).  By default, \code{histSpike} bins the
  continuous \code{x} variable into 100 equal-width bins and then
  computes the frequency counts within bins (if \code{n} does not exceed
  10, no binning is done). If \code{add=FALSE} (the default), the
  function displays either proportions or frequencies as in a vertical
  histogram.  Instead of bars, spikes are used to depict the
  frequencies.  If \code{add=FALSE}, the function assumes you are adding
  small density displays that are intended to take up a small amount of
  space in the margins of the overall plot.  The \code{frac} argument is
  used as with \code{scat1d} to determine the relative length of the
  whole plot that is used to represent the maximum frequency.  No
  jittering is done by \code{histSpike}.
  
  \code{histSpike} can also graph a kernel density estimate for
  \code{x}, or add a small density curve to any of 4 sides of an
  existing plot.  When \code{y} or \code{curve} is specified, the
  density or spikes are drawn with respect to the curve rather than the
  x-axis.

	\code{histSpikeg} is similar to \code{histSpike} but is for adding layers
	to a \code{ggplot2} graphics object or traces to a \code{plotly}
	object.
	\code{histSpikeg} can also add \code{lowess} curves to the plot.

	\code{ecdfpM} makes a \code{plotly} graph or series of graphs showing
	possibly superposed empirical cumulative distribution functions.
}
\usage{
scat1d(x, side=3, frac=0.02, jitfrac=0.008, tfrac,
       eps=ifelse(preserve,0,.001),
       lwd=0.1, col=par("col"),
       y=NULL, curve=NULL,
       bottom.align=FALSE,
       preserve=FALSE, fill=1/3, limit=TRUE, nhistSpike=2000, nint=100,
       type=c('proportion','count','density'), grid=FALSE, \dots)

jitter2(x, \dots)

\method{jitter2}{default}(x, fill=1/3, limit=TRUE, eps=0,
        presorted=FALSE, \dots)

\method{jitter2}{data.frame}(x, \dots)

datadensity(object, \dots)

\method{datadensity}{data.frame}(object, group,
            which=c("all","continuous","categorical"),
            method.cat=c("bar","freq"),
            col.group=1:10,
            n.unique=10, show.na=TRUE, nint=1, naxes,
            q, bottom.align=nint>1,
            cex.axis=sc(.5,.3), cex.var=sc(.8,.3),
            lmgp=NULL, tck=sc(-.009,-.002),
            ranges=NULL, labels=NULL, \dots)
# sc(a,b) means default to a if number of axes <= 3, b if >=50, use
# linear interpolation within 3-50

histSpike(x, side=1, nint=100, bins=NULL, frac=.05, minf=NULL, mult.width=1,
          type=c('proportion','count','density'),
          xlim=range(x), ylim=c(0,max(f)), xlab=deparse(substitute(x)), 
          ylab=switch(type,proportion='Proportion',
                           count     ='Frequency',
                           density   ='Density'),
          y=NULL, curve=NULL, add=FALSE, minimal=FALSE,
          bottom.align=type=='density', col=par('col'), lwd=par('lwd'),
          grid=FALSE, \dots)

histSpikeg(formula=NULL, predictions=NULL, data, plotly=NULL,
           lowess=FALSE, xlim=NULL, ylim=NULL,
           side=1, nint=100,
           frac=function(f) 0.01 + 0.02*sqrt(f-1)/sqrt(max(f,2)-1),
           span=3/4, histcol='black', showlegend=TRUE)

ecdfpM(x, group=NULL, what=c('F','1-F','f','1-f'), q=NULL,
       extra=c(0.025, 0.025), xlab=NULL, ylab=NULL, height=NULL, width=NULL,
       colors=NULL, nrows=NULL, ncols=NULL, ...)
}
\arguments{
  \item{x}{
    a vector of numeric data, or a data frame (for \code{jitter2} or
       \code{ecdfpM}) 
  }
  \item{object}{
    a data frame or list (even with unequal number of observations per
    variable, as long as \code{group} is notspecified)
  }
  \item{side}{
    axis side to use (1=bottom (default for \code{histSpike}), 2=left,
    3=top (default for \code{scat1d}), 4=right)
  }
  \item{frac}{
    fraction of smaller of vertical and horizontal axes for tick mark
    lengths. Can be negative to move tick marks outside of plot. For
    \code{histSpike}, this is the relative y-direction length to be used for the
    largest frequency. When \code{scat1d} calls \code{histSpike}, it
    multiplies its \code{frac} argument by 2.5.  For \code{histSpikeg},
    \code{frac} is a function of \code{f}, the vector of all frequencies.  The
		default function scales tick marks so that they are between 0.01 and
    0.03 of the y range, linearly scaled in the square root of the
    frequency less one.
  }
  \item{jitfrac}{
    fraction of axis for jittering.  If
    \eqn{\code{jitfrac} \le 0}{\code{jitfrac} <= 0}, no
    jittering is done. If \code{preserve=TRUE}, the amount of
    jittering is independent of jitfrac.
  }
  \item{tfrac}{
    Fraction of tick mark to actually draw.  If \eqn{\code{tfrac}<1},
    will draw a random fraction \code{tfrac}  of the line segment at
    each point. This is useful for very large samples or ones with some
    very dense points. The default value is 1 if the number of
    non-missing observations \code{n}  is less than 125, and
    \eqn{\max{(.1, 125/n)}} otherwise.
  }
  \item{eps}{
    fraction of axis for determining overlapping points in \code{x}. For
    \code{preserve=TRUE} the default is 0 and original unique values are
    retained, bigger values of eps tends to bias observations from dense
    to sparse regions, but ranks are still preserved.
  }
  \item{lwd}{
    line width for tick marks, passed to \code{segments}
  }
  \item{col}{
    color for tick marks, passed to \code{segments}
  }
  \item{y}{
    specify a vector the same length as \code{x} to draw tick marks
    along a curve instead of by one of the axes.  The \code{y} values
    are often predicted values from a model.  The \code{side} argument
    is ignored when \code{y} is given.  If the curve is already
    represented as a table look-up, you may specify it using the
    \code{curve} argument instead.  \code{y} may be a scalar to use a
    constant verticalplacement.
  }
  \item{curve}{
    a list containing elements \code{x} and \code{y} for which linear
    interpolation is used to derive \code{y} values corresponding to
    values of \code{x}.  This results in tick marks being drawn along
    the curve.  For \code{histSpike}, interpolated \code{y} values are
    derived for binmidpoints.
  }
	\item{minimal}{for \code{histSpike} set \code{minimal=TRUE} to draw a
       minimalist spike histogram with no y-axis.  This works best when
       produce graphics images that are short, e.g., have a height of
       two inches.  \code{add} is forced to be \code{FALSE} in this case
       so that a standalone graph is produced.  Only base graphics are
       used.}
  \item{bottom.align}{
    set to \code{TRUE} to have the bottoms of tick marks (for
    \code{side=1} or \code{side=3}) aligned at the y-coordinate.  The
    default behavior is to center the tick marks.  For
    \code{datadensity.data.frame}, \code{bottom.align} defaults to
    \code{TRUE} if \code{nint>1}.  In other words, if you are only
    labeling the first and last axis tick mark, the \code{scat1d} tick
    marks are centered on the variable's axis.
  }
  \item{preserve}{
    set to \code{TRUE} to invoke \code{jitter2}
  }
  \item{fill}{
    maximum fraction of the axis filled by jittered values. If \code{d}
    are duplicated values between a lower value l and upper value
    u, then d will be spread within
    \eqn{\pm \code{fill}*\min{(u-d,d-l)}/2}{
      +/- \code{fill}*min(u-d,d-l)/2}.
  }
  \item{limit}{
    specifies a limit for maximum shift in jittered values. Duplicate
    values will be spread within
    \eqn{\pm\code{fill}*\min{(u-d,d-l)}/2}{
      +/- \code{fill}*min(u-d,d-l)/2}. The
    default \code{TRUE} restricts jittering to the smallest
    \eqn{\min{(u-d,d-l)}/2} observed and results
    in equal amount of jittering for all d. Setting to
    \code{FALSE} allows for locally different amount of jittering, using
    maximum space available.
  }
  \item{nhistSpike}{
    If the number of observations exceeds or equals \code{nhistSpike},
    \code{scat1d} will automatically call \code{histSpike} to draw the
    data density, to prevent the graphics file from being too large.
  }
  \item{type}{
    used by or passed to \code{histSpike}.  Set to \code{"count"} to
    display frequency counts rather than relative frequencies, or
    \code{"density"} to display a kernel density estimate computed using
    the \code{density} function.
  }
  \item{grid}{
    set to \code{TRUE} if the \R \code{grid} package is in effect for
    the current plot
  }
  \item{nint}{
    number of intervals to divide each continuous variable's axis for
    \code{datadensity}. For \code{histSpike}, is the number of
    equal-width intervals for which to bin \code{x}, and if instead
    \code{nint} is a character string (e.g.,\code{nint="all"}), the
    frequency tabulation is done with no binning.  In other words,
    frequencies for all unique values of \code{x} are derived and
    plotted.  For \code{histSpikeg}, if \code{x} has no more than
    \code{nint} unique values, all observed values are used, otherwise
    the data are rounded before tabulation so that there are no more
    than \code{nint} intervals.  For \code{histSpike}, \code{nint} is
       ignored if \code{bins} is given.
		 }
  \item{bins}{for \code{histSpike} specifies the actual cutpoints to use
       for binning \code{x}.  The default is to use \code{nint} in
       conjunction with \code{xlim}.}
  \item{\dots}{
    optional arguments passed to \code{scat1d} from \code{datadensity}
    or to \code{histSpike} from \code{scat1d}.  For \code{histSpikep}
           are passed to the \code{lines} list to \code{add_trace}.  For
					 \code{ecdfpM} these arguments are passed to \code{add_lines}.
  }
  \item{presorted}{
    set to \code{TRUE} to prevent from sorting for determining the order
    \eqn{l<d<u}. This is usefull if an existing
    meaningfull local order would be destroyed by sorting, as in
    \eqn{\sin{(\pi*\code{sort}(\code{round}(\code{runif}(1000,0,10),1)))}}.
  }
  \item{group}{
    an optional stratification variable, which is converted to a
    \code{factor} vector if it is not one already
  }
  \item{which}{
    set \code{which="continuous"} to only plot continuous variables, or
    \code{which="categorical"} to only plot categorical, character, or
    discrete numeric ones.  By default, all types of variables are
    depicted.
  }
  \item{method.cat}{
    set \code{method.cat="freq"} to depict frequencies of categorical
    variables with digits representing the cell frequencies, with size
    proportional to the square root of the frequency.  By default,
    vertical bars are used.
  }
  \item{col.group}{
    colors representing the \code{group} strata.  The vector of colors
    is recycled to be the same length as the levels of \code{group}.
  }
  \item{n.unique}{
    number of unique values a numeric variable must have before it is
    considered to be a continuous variable
  }
  \item{show.na}{
    set to \code{FALSE} to suppress drawing the number of \code{NA}s to
    the right of each axis
  }
  \item{naxes}{
    number of axes to draw on each page before starting a new plot.  You
    can set \code{naxes} larger than the number of variables in the data
    frame if you want to compress the plot vertically.
  }
  \item{q}{
    a vector of quantiles to display.  By default, quantiles are not
    shown.
  }
	\item{extra}{a two-vector specifying the fraction of the x
       range to add on the left and the fraction to add on the right}
  \item{cex.axis}{
    character size for draw labels for axis tick marks
  }
  \item{cex.var}{
    character size for variable names and frequence of \code{NA}s
  }
  \item{lmgp}{
    spacing between numeric axis labels and axis (see \code{par} for
    \code{mgp})
  }
  \item{tck}{
    see \code{tck} under \code{\link{par}}
  }
  \item{ranges}{
    a list containing ranges for some or all of the numeric variables.
    If \code{ranges} is not given or if a certain variable is not found
    in the list, the empirical range, modified by \code{pretty}, is
    used.  Example:
    \code{ranges=list(age=c(10,100), pressure=c(50,150))}.
  }
  \item{labels}{
    a vector of labels to use in labeling the axes for
    \code{datadensity.data.frame}.  Default is to use the names of the
    variable in the input data frame.  Note: margin widths computed for
    setting aside names of variables use the names, and not these
    labels.
  }
  \item{minf}{
    For \code{histSpike}, if \code{minf} is specified low bin
    frequencies are set to a minimum value of \code{minf} times the
    maximum bin frequency, so that rare data points will remain visible.
    A good choice of \code{minf} is 0.075.
    \code{datadensity.data.frame} passes \code{minf=0.075} to
    \code{scat1d} to pass to \code{histSpike}.  Note that specifying
    \code{minf} will cause the shape of the histogram to be distorted
    somewhat.
  }
  \item{mult.width}{
    multiplier for the smoothing window width computed by
    \code{histSpike} when \code{type="density"}
  }
  \item{xlim}{
    a 2-vector specifying the outer limits of \code{x} for binning (and
    plotting, if \code{add=FALSE} and \code{nint} is a number).  For
    \code{histSpikeg}, observations outside the \code{xlim} range are ignored.
  }
  \item{ylim}{
    y-axis range for plotting (if \code{add=FALSE}).  Often needed for
    \code{histSpikeg} to help scale the tick mark line segments.
  }
  \item{xlab}{
    x-axis label (\code{add=FALSE} or for \code{ecdfpM}); default is
       name of input argument, or for \code{ecdfpM} comes from
       \code{label} and \code{units} attributes of the analysis
       variable.  For \code{ecdfpM} \code{xlab} may be a vector if there
       is more than one analysis variable.
		 }
  \item{ylab}{
    y-axis label (\code{add=FALSE} or for \code{ecdfpM})
  }
  \item{add}{
    set to \code{TRUE} to add the spike-histogram to an existing plot,
    to show marginal data densities
  }
	\item{formula}{
		a formula of the form \code{y ~ x1} or \code{y ~ x1 + \dots} where
    \code{y} is the name of the \code{y}-axis variable being plotted
    with \code{ggplot}, \code{x1} is the name of the \code{x}-axis
    variable, and optional \dots are variables used by
    \code{ggplot} to produce multiple curves on a panel and/or facets.
	}
	\item{predictions}{
		the data frame being plotted by \code{ggplot}, containing \code{x}
    and \code{y} coordinates of curves.  If omitted, spike histograms
    are drawn at the bottom (default) or top of the plot according to
    \code{side}.
  }
	\item{data}{
		for \code{histSpikeg} is a mandatory data frame containing raw data whose
    frequency distribution is to be summarized, using variables in
    \code{formula}. 
	}
	\item{plotly}{
		an existing \code{plotly} object.  If not \code{NULL},
           \code{histSpikeg} uses \code{plotly} instead of \code{ggplot}.}
	\item{lowess}{
		set to \code{TRUE} to have \code{histSpikeg} add a \code{geom_line}
           layer to the \code{ggplot2} graphic, containing
           \code{lowess()} nonparametric smoothers.  This causes the
           returned value of \code{histSpikeg} to be a list with two
           components: \code{"hist"} and \code{"lowess"} each containing
           a layer.  Fortunately, \code{ggplot2} plots both layers
           automatically.  If the dependent variable is binary,
           \code{iter=0} is passed to \code{lowess} so that outlier
           detection is turned off; otherwise \code{iter=3} is passed.
				 }
\item{span}{passed to \code{lowess} as the \code{f} argument}
\item{histcol}{color of line segments (tick marks) for
 \code{histSpikeg}.  Default is black.  Set to any color or to
   \code{"default"} to use the prevailing colors for the
   graphic.}
\item{showlegend}{set to \code{FALSE} too have the added \code{plotly}
  traces not have entries in the plot legend}
\item{what}{set to \code{"1-F"} to plot 1 minus the ECDF instead of the
       ECDF, \code{"f"} to plot cumulative frequency, or \code{"1-f"} to
       plot the inverse cumulative frequency}
\item{height,width}{passed to \code{plot_ly}}
\item{colors}{a vector of colors to pas to \code{add_lines}}
\item{nrows,ncols}{passed to \code{plotly::subplot}}
}
\value{
  \code{histSpike} returns the actual range of \code{x} used in its binning. 
  \code{histSpikeg} returns a list of \code{ggplot2} layers that \code{ggplot2}
  will easily add with \code{+}.
}
\section{Side Effects}{
  \code{scat1d} adds line segments to plot.
  \code{datadensity.data.frame} draws a complete plot.  \code{histSpike}
  draws a complete plot or adds to an existing plot.
}
\details{
  For \code{scat1d} the length of line segments used is
  \code{frac*min(par()$pin)/par()$uin[opp]} data units, where
  opp is the index of the opposite axis and \code{frac} defaults
  to .02.  Assumes that \code{plot} has already been called.  Current
  \code{par("usr")} is used to determine the range of data for the axis
  of the current plot.  This range is used in jittering and in
  constructing line segments.
}
\author{
Frank Harrell\cr
Department of Biostatistics\cr
Vanderbilt University\cr
Nashville TN, USA\cr
\email{fh@fharrell.com}


Martin Maechler (improved \code{scat1d})\cr
Seminar fuer Statistik\cr
ETH Zurich SWITZERLAND\cr
\email{maechler@stat.math.ethz.ch}


Jens Oehlschlaegel-Akiyoshi (wrote \code{jitter2})\cr
Center for Psychotherapy Research\cr
Christian-Belser-Strasse 79a\cr
D-70597 Stuttgart Germany\cr
\email{oehl@psyres-stuttgart.de}
}
\seealso{
  \code{\link{segments}}, \code{\link{jitter}}, \code{\link{rug}},
  \code{\link{plsmo}}, \code{\link{lowess}}, \code{\link{stripplot}},
  \code{\link{hist.data.frame}},\code{\link{Ecdf}}, \code{\link{hist}},
  \code{\link[lattice]{histogram}}, \code{\link{table}},
  \code{\link{density}}, \code{\link{stat_plsmo}}, \code{\link{histboxp}}
}
\examples{
plot(x <- rnorm(50), y <- 3*x + rnorm(50)/2 )
scat1d(x)                 # density bars on top of graph
scat1d(y, 4)              # density bars at right
histSpike(x, add=TRUE)       # histogram instead, 100 bins
histSpike(y, 4, add=TRUE)
histSpike(x, type='density', add=TRUE)  # smooth density at bottom
histSpike(y, 4, type='density', add=TRUE)


smooth <- lowess(x, y)    # add nonparametric regression curve
lines(smooth)             # Note: plsmo() does this
scat1d(x, y=approx(smooth, xout=x)$y) # data density on curve
scat1d(x, curve=smooth)   # same effect as previous command
histSpike(x, curve=smooth, add=TRUE) # same as previous but with histogram
histSpike(x, curve=smooth, type='density', add=TRUE)  
# same but smooth density over curve


plot(x <- rnorm(250), y <- 3*x + rnorm(250)/2)
scat1d(x, tfrac=0)        # dots randomly spaced from axis
scat1d(y, 4, frac=-.03)   # bars outside axis
scat1d(y, 2, tfrac=.2)    # same bars with smaller random fraction


x <- c(0:3,rep(4,3),5,rep(7,10),9)
plot(x, jitter2(x))       # original versus jittered values
abline(0,1)               # unique values unjittered on abline
points(x+0.1, jitter2(x, limit=FALSE), col=2)
                          # allow locally maximum jittering
points(x+0.2, jitter2(x, fill=1), col=3); abline(h=seq(0.5,9,1), lty=2)
                          # fill 3/3 instead of 1/3
x <- rnorm(200,0,2)+1; y <- x^2
x2 <- round((x+rnorm(200))/2)*2
x3 <- round((x+rnorm(200))/4)*4
dfram <- data.frame(y,x,x2,x3)
plot(dfram$x2, dfram$y)   # jitter2 via scat1d
scat1d(dfram$x2, y=dfram$y, preserve=TRUE, col=2)
scat1d(dfram$x2, preserve=TRUE, frac=-0.02, col=2)
scat1d(dfram$y, 4, preserve=TRUE, frac=-0.02, col=2)


pairs(jitter2(dfram))     # pairs for jittered data.frame
# This gets reasonable pairwise scatter plots for all combinations of
# variables where
#
# - continuous variables (with unique values) are not jittered at all, thus
#   all relations between continuous variables are shown as they are,
#   extreme values have exact positions.
#
# - discrete variables get a reasonable amount of jittering, whether they
#   have 2, 3, 5, 10, 20 \dots levels
#
# - different from adding noise, jitter2() will use the available space
#   optimally and no value will randomly mask another
#
# If you want a scatterplot with lowess smooths on the *exact* values and
# the point clouds shown jittered, you just need
#
pairs( dfram ,panel=function(x,y) { points(jitter2(x),jitter2(y))
                                    lines(lowess(x,y)) } )




datadensity(dfram)     # graphical snapshot of entire data frame
datadensity(dfram, group=cut2(dfram$x2,g=3))
                          # stratify points and frequencies by
                          # x2 tertiles and use 3 colors


# datadensity.data.frame(split(x, grouping.variable))
# need to explicitly invoke datadensity.data.frame when the
# first argument is a list

\dontrun{
require(rms)
require(ggplot2)
f <- lrm(y ~ blood.pressure + sex * (age + rcs(cholesterol,4)),
         data=d)
p <- Predict(f, cholesterol, sex)
g <- ggplot(p, aes(x=cholesterol, y=yhat, color=sex)) + geom_line() +
  xlab(xl2) + ylim(-1, 1)
g <- g + geom_ribbon(data=p, aes(ymin=lower, ymax=upper), alpha=0.2,
                linetype=0, show_guide=FALSE)
g + histSpikeg(yhat ~ cholesterol + sex, p, d)

# colors <- c('red', 'blue')
# p <- plot_ly(x=x, y=y, color=g, colors=colors, mode='markers')
# histSpikep(p, x, y, z, color=g, colors=colors)

w <- data.frame(x1=rnorm(100), x2=exp(rnorm(100)))
g <- c(rep('a', 50), rep('b', 50))
ecdfpM(w, group=g, ncols=2)
}
}
\keyword{dplot}
\keyword{aplot}
\keyword{hplot}
\keyword{distribution}

\name{upFirst}
\alias{upFirst}
\title{Change First Letters to Upper Case}
\usage{
upFirst(txt, lower = FALSE, alllower = FALSE)
}
\arguments{
\item{txt}{a character vector}

\item{lower}{set to \code{TRUE} to make only the very first letter of the string upper case, and to keep words with at least 2 capital letters in their original form}

\item{alllower}{set to \code{TRUE} to make every word start with lower case unless it has at least 2 caps}
}
\description{
Changes the first letter of each word in a string to upper case, keeping selected words in lower case.  Words containing at least 2 capital letters are kept as-is.
}
\examples{
upFirst(c('this and that','that is Beyond question'))
}
\references{
\url{https://en.wikipedia.org/wiki/Letter_case#Headings_and_publication_titles}
}

\name{sasxport.get}
\alias{sasxport.get}
\alias{sasdsLabels}
\title{Enhanced Importing of SAS Transport Files using read.xport}
\description{
Uses the \code{read.xport} and \code{lookup.xport} functions in the
\code{foreign} library to import SAS datasets.  SAS date, time, and
date/time variables are converted respectively to \code{Date}, 
POSIX, or \code{POSIXct} objects in \R, 
variable names are converted to lower case, SAS labels are associated
with variables, and (by default) integer-valued variables are converted
from storage mode \code{double} to \code{integer}.  If the user ran
\code{PROC FORMAT CNTLOUT=} in SAS and included the resulting dataset in
the SAS version 5 transport file, variables having customized formats
that do not include any ranges (i.e., variables having standard
\code{PROC FORMAT; VALUE} label formats) will have their format labels looked
up, and these variables are converted to S \code{factor}s.

For those users having access to SAS, \code{method='csv'} is preferred
when importing several SAS datasets.
Run SAS macro \code{exportlib.sas} available from
\url{https://github.com/harrelfe/Hmisc/blob/master/src/sas/exportlib.sas}
to convert all SAS datasets in a SAS data library (from any engine
supported by your system) into \code{CSV} files.  If any customized
formats are used, it is assumed that the \code{PROC FORMAT CNTLOUT=}
dataset is in the data library as a regular SAS dataset, as above.

\code{SASdsLabels} reads a file containing \code{PROC CONTENTS}
printed output to parse dataset labels, assuming that \code{PROC
CONTENTS} was run on an entire library.
}
\usage{
sasxport.get(file, lowernames=TRUE, force.single = TRUE,
             method=c('read.xport','dataload','csv'), formats=NULL, allow=NULL,
             out=NULL, keep=NULL, drop=NULL, as.is=0.5, FUN=NULL)
sasdsLabels(file)
}
\arguments{
  \item{file}{name of a file containing the SAS transport file.
	\code{file} may be a URL beginning with \code{https://}.  For
\code{sasdsLabels}, \code{file} is the name of a file containing a
\code{PROC CONTENTS} output listing.  For \code{method='csv'},
\code{file} is the name of the directory containing all the \code{CSV}
files created by running the \code{exportlib} SAS macro.
}
  \item{lowernames}{set to \code{FALSE} to keep from converting SAS
		variable names to lower case}
  \item{force.single}{set to \code{FALSE} to keep integer-valued
	variables not exceeding \eqn{2^31-1} in value from being converted to
	\code{integer} storage mode}
  \item{method}{set to \code{"dataload"} if you have the \code{dataload}
	executable installed and want to use it instead of
	\code{read.xport}.  This seems to correct some errors in which
	rarely some factor variables are always missing when read by
	\code{read.xport} when in fact they have some non-missing values.}
  \item{formats}{a data frame or list (like that created by
	\code{read.xport}) containing \code{PROC FORMAT}
	output, if such output is not stored in the main transport file.}
  \item{allow}{a vector of characters allowed by \R that should not be
converted to periods in variable names.  By default, underscores in
variable names are converted to periods as with \R before version 1.9.}
  \item{out}{a character string specifying a directory in which to write
	separate \R \code{save} files (\code{.rda} files) for each regular
	dataset.  Each file and the data frame inside it is named with the
	SAS dataset name translated to lower case and with underscores
	changed to periods.  The default \code{NULL} value of \code{out}
	results in a data frame or a list of data frames being returned.
	When \code{out} is given, \code{sasxport.get} returns only metadata (see
	below), invisibly.
	\code{out} only works with \code{methods='csv'}.  \code{out} should
	not have a trailing slash.}
  \item{keep}{a vector of names of SAS datasets to process (original SAS
  upper case names).  Must include \code{PROC FORMAT} dataset if it
  exists, and if the kept datasets use any of its value label formats.}
  \item{drop}{a vector of names of SAS datasets to ignore (original SAS
	upper case names)}
  \item{as.is}{
	SAS character variables are converted to S factor
	objects if \code{as.is=FALSE} or if \code{as.is} is a number between
	0 and 1 inclusive and the number of unique values of the variable is
	less than the number of observations (\code{n}) times \code{as.is}.
	The default if \code{as.is} is .5, so character variables are
	converted to factors only if they have fewer than \code{n/2} unique
	values.  The primary purpose of this is to keep unique
	identification variables as character values in the data frame
	instead of using more space to store both the integer factor codes
	and the factor labels.
  }
  \item{FUN}{an optional function that will be run on each data frame
	created, when \code{method='csv'} and \code{out} are specified.  The
	result of all the \code{FUN} calls is made into a list corresponding
	to the SAS datasets that are read.  This list is the \code{FUN}
	attribute of the result returned by \code{sasxport.get}.
	}
}
\value{
  If there is more than one dataset in the transport file other than the
  \code{PROC FORMAT} file, the result is a list of data frames
  containing all the non-\code{PROC FORMAT} datasets.  Otherwise the
  result is the single data frame.  There is an exception if \code{out}
  is specified; that causes separate \R \code{save} files to be written
  and the returned value to be a list corresponding to the SAS datasets,
  with key \code{PROC CONTENTS} information in a data frame making up
  each part of the list.
  \code{sasdsLabels} returns a named
  vector of dataset labels, with names equal to the dataset names.
}
\details{See \code{\link{contents.list}} for a way to print the
directory of SAS datasets when more than one was imported.}
\author{Frank E Harrell Jr}
\seealso{\code{\link[foreign]{read.xport}},\code{\link{label}},\code{\link{sas.get}},
  \code{\link{Dates}},\code{\link{DateTimeClasses}},
  \code{\link[foreign]{lookup.xport}},\code{\link{contents}},\code{\link{describe}}}
\examples{
\dontrun{
# SAS code to generate test dataset:
# libname y SASV5XPT "test2.xpt";
#
# PROC FORMAT; VALUE race 1=green 2=blue 3=purple; RUN;
# PROC FORMAT CNTLOUT=format;RUN;  * Name, e.g. 'format', unimportant;
# data test;
# LENGTH race 3 age 4;
# age=30; label age="Age at Beginning of Study";
# race=2;
# d1='3mar2002'd ;
# dt1='3mar2002 9:31:02'dt;
# t1='11:13:45't;
# output;
#
# age=31;
# race=4;
# d1='3jun2002'd ;
# dt1='3jun2002 9:42:07'dt;
# t1='11:14:13't;
# output;
# format d1 mmddyy10. dt1 datetime. t1 time. race race.;
# run;
# data z; LENGTH x3 3 x4 4 x5 5 x6 6 x7 7 x8 8;
#    DO i=1 TO 100;
#        x3=ranuni(3);
#        x4=ranuni(5);
#        x5=ranuni(7);
#        x6=ranuni(9);
#        x7=ranuni(11);
#        x8=ranuni(13);
#        output;
#        END;
#    DROP i;
#    RUN;
# PROC MEANS; RUN;
# PROC COPY IN=work OUT=y;SELECT test format z;RUN; *Creates test2.xpt;
w <- sasxport.get('test2.xpt')
# To use an existing copy of test2.xpt available on the web:
w <- sasxport.get('https://github.com/harrelfe/Hmisc/raw/master/inst/tests/test2.xpt')

describe(w$test)   # see labels, format names for dataset test
# Note: if only one dataset (other than format) had been exported,
# just do describe(w) as sasxport.get would not create a list for that
lapply(w, describe)# see descriptive stats for both datasets
contents(w$test)   # another way to see variable attributes
lapply(w, contents)# show contents of both datasets
options(digits=7)  # compare the following matrix with PROC MEANS output
t(sapply(w$z, function(x)
 c(Mean=mean(x),SD=sqrt(var(x)),Min=min(x),Max=max(x))))
}
}
\keyword{interface}
\keyword{manip}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hlab.r
\name{extractlabs}
\alias{extractlabs}
\title{extractlabs}
\usage{
extractlabs(..., print = TRUE)
}
\arguments{
\item{...}{one ore more data frames or data tables}

\item{print}{set to \code{FALSE} to not print details about variables with conflicting attributes}
}
\value{
a data table
}
\description{
Extract Labels and Units From Multiple Datasets
}
\details{
For one or more data frames/tables extracts all labels and units and comb ines them over dataset, dropping any variables not having either labels or units defined.  The resulting data table is returned and is used by the \code{hlab} function if the user stores the result in an objectnamed \code{LabelsUnits}.  The result is \code{NULL} if no variable in any dataset has a non-blank \code{label} or \code{units}.  Variables found in more than one dataset with duplicate \code{label} and \code{units} are consolidated.  A warning message is issued when duplicate variables have conflicting labels or units, and by default, details are printed.  No attempt is made to resolve these conflicts.
}
\examples{
d <- data.frame(x=1:10, y=(1:10)/10)
d <- upData(d, labels=c(x='X', y='Y'), units=c(x='mmHg'), print=FALSE)
d2 <- d
units(d2$x) <- 'cm'
LabelsUnits <- extractlabs(d, d2)
LabelsUnits
}
\seealso{
\code{\link[=label]{label()}}, \code{\link[=contents]{contents()}}, \code{\link[=units]{units()}}, \code{\link[=hlab]{hlab()}}
}
\author{
Frank Harrell
}

\name{plsmo}
\alias{plsmo}
\alias{panel.plsmo}
\title{
Plot smoothed estimates
}
\description{

  Plot smoothed estimates of x vs. y, handling missing data for lowess
  or supsmu, and adding axis labels.  Optionally suppresses plotting
  extrapolated estimates.  An optional \code{group} variable can be
  specified to compute and plot the smooth curves by levels of
  \code{group}.  When \code{group} is present, the \code{datadensity}
  option will draw tick marks showing the location of the raw
  \code{x}-values, separately for each curve.  \code{plsmo} has an
  option to plot connected points for raw data, with no smoothing.  The
  non-panel version of \code{plsmo} allows \code{y} to be a matrix, for
  which smoothing is done separately over its columns.  If both
  \code{group} and multi-column \code{y} are used, the number of curves
  plotted is the product of the number of groups and the number of
  \code{y} columns.

	\code{method='intervals'} is often used when y is binary, as it may be
	tricky to specify a reasonable smoothing parameter to \code{lowess} or
	\code{supsmu} in this case.  The \code{'intervals'} method uses the
	\code{cut2} function to form intervals of x containing a target of
	\code{mobs} observations.  For each interval the \code{ifun} function
	summarizes y, with the default being the mean (proportions for binary
	y).  The results are plotted as step functions, with vertical
	discontinuities drawn with a saturation of 0.15 of the original color.
	A plus sign is drawn at the mean x within each interval.
	For this approach, the default x-range is the entire raw data range,
	and \code{trim} and \code{evaluate} are ignored.  For
	\code{panel.plsmo} it is best to specify \code{type='l'} when using
	\code{'intervals'}. 

\code{panel.plsmo} is a \code{panel} function for \code{trellis} for the
\code{xyplot} function that uses \code{plsmo} and its options to draw
one or more nonparametric function estimates on each panel.  This has
advantages over using \code{xyplot} with \code{panel.xyplot} and
\code{panel.loess}: (1) by default it will invoke \code{labcurve} to
label the curves where they are most separated, (2) the
\code{datadensity} option will put rug plots on each curve (instead of a
single rug plot at the bottom of the graph), and (3) when
\code{panel.plsmo} invokes \code{plsmo} it can use the "super smoother"
(\code{supsmu} function) instead of \code{lowess}, or pass
\code{method='intervals'}.  \code{panel.plsmo} 
senses when a \code{group} variable is specified to \code{xyplot} so
that it can invoke \code{\link[lattice]{panel.superpose}} instead of
\code{panel.xyplot}.  Using \code{panel.plsmo} through \code{trellis}
has some advantages over calling \code{plsmo} directly in that
conditioning variables are allowed and \code{trellis} uses nicer fonts
etc.

When a \code{group} variable was used, \code{panel.plsmo} creates a function
\code{Key} in the session frame that the user can invoke to draw a key for
individual data point symbols used for the \code{group}s.  
By default, the key is positioned at the upper right
corner of the graph.  If \code{Key(locator(1))} is specified, the key will
appear so that its upper left corner is at the coordinates of the
mouse click.

For \code{ggplot2} graphics the counterparts are
\code{\link{stat_plsmo}} and \code{\link{histSpikeg}}.
}
\usage{
plsmo(x, y, method=c("lowess","supsmu","raw","intervals"), xlab, ylab, 
      add=FALSE, lty=1 : lc, col=par("col"), lwd=par("lwd"),
      iter=if(length(unique(y))>2) 3 else 0, bass=0, f=2/3, mobs=30, trim, 
      fun, ifun=mean, group, prefix, xlim, ylim, 
      label.curves=TRUE, datadensity=FALSE, scat1d.opts=NULL,
      lines.=TRUE, subset=TRUE,
      grid=FALSE, evaluate=NULL, \dots)


#To use panel function:
#xyplot(formula=y ~ x | conditioningvars, groups,
#       panel=panel.plsmo, type='b', 
#       label.curves=TRUE,
#       lwd = superpose.line$lwd, 
#       lty = superpose.line$lty, 
#       pch = superpose.symbol$pch, 
#       cex = superpose.symbol$cex, 
#       font = superpose.symbol$font, 
#       col = NULL, scat1d.opts=NULL, \dots)
}
\arguments{
\item{x}{
vector of x-values, NAs allowed
}
\item{y}{
vector or matrix of y-values, NAs allowed
}
\item{method}{
\code{"lowess"} (the default), \code{"supsmu"}, \code{"raw"} to not
smooth at all, or \code{"intervals"} to use intervals (see above)
}
\item{xlab}{
x-axis label iff add=F.  Defaults of label(x) or argument name.
}
\item{ylab}{
y-axis label, like xlab.
}
\item{add}{
Set to T to call lines instead of plot.  Assumes axes already labeled.
}
\item{lty}{
line type, default=1,2,3,\dots, corresponding to columns of \code{y} and
\code{group} combinations
}
\item{col}{
color for each curve, corresponding to \code{group}.  Default is
current \code{par("col")}. 
}
\item{lwd}{
vector of line widths for the curves, corresponding to \code{group}.
Default is current \code{par("lwd")}. 
\code{lwd} can also be specified as an element of \code{label.curves} if
\code{label.curves} is a list.
}
\item{iter}{
iter parameter if \code{method="lowess"}, default=0 if \code{y} is binary, and 3 otherwise.
}
\item{bass}{
bass parameter if \code{method="supsmu"}, default=0.
}
\item{f}{passed to the \code{lowess} function, for \code{method="lowess"}}
\item{mobs}{for \code{method='intervals'}, the target number of
            observations per interval}
\item{trim}{
only plots smoothed estimates between trim and 1-trim quantiles
of x.  Default is to use 10th smallest to 10th largest x in the group if the number of observations in the group exceeds 200 (0 otherwise).
Specify trim=0 to plot over entire range.
}
\item{fun}{
after computing the smoothed estimates, if \code{fun} is given the y-values
are transformed by \code{fun()}
}
\item{ifun}{a summary statistic function to apply to the
            \code{y}-variable for \code{method='intervals'}.  Default is \code{mean}.}
\item{group}{
a variable, either a \code{factor} vector or one that will be converted to
\code{factor} by \code{plsmo}, that is used to stratify the data so that separate
smooths may be computed
}
\item{prefix}{
a character string to appear in group of group labels.  The presence of
\code{prefix} ensures that \code{labcurve} will be called even when \code{add=TRUE}.
}
\item{xlim}{
a vector of 2 x-axis limits.  Default is observed range.
}
\item{ylim}{
a vector of 2 y-axis limits.  Default is observed range.
}
\item{label.curves}{
set to \code{FALSE} to prevent \code{labcurve} from being called to label multiple
curves corresponding to \code{group}s.  Set to a list to pass options to
\code{labcurve}.  \code{lty} and \code{col} are passed to \code{labcurve} automatically.
}
\item{datadensity}{
set to \code{TRUE} to draw tick marks on each curve, using x-coordinates
of the raw data \code{x} values.  This is done using \code{scat1d}.
}
\item{scat1d.opts}{a list of options to hand to \code{scat1d}}
\item{lines.}{
set to \code{FALSE} to suppress smoothed curves from being drawn.  This can
make sense if \code{datadensity=TRUE}.
}
\item{subset}{
a logical or integer vector specifying a subset to use for processing,
with respect too all variables being analyzed
}
\item{grid}{
  set to \code{TRUE} if the \R \code{grid} package drew the current	plot}
\item{evaluate}{
	number of points to keep from smoother.  If specified, an
equally-spaced grid of \code{evaluate} \code{x} values will be obtained from the
smoother using linear interpolation.  This will keep from plotting an
enormous number of points if the dataset contains a very large number
of unique \code{x} values.}
\item{\dots}{
  optional arguments that are passed to \code{scat1d},
  or optional parameters to pass to \code{plsmo} from
  \code{panel.plsmo}.  See optional arguments for \code{plsmo} above.
}
\item{type}{
set to \code{p} to have \code{panel.plsmo} plot points (and not call \code{plsmo}), 
\code{l} to call \code{plsmo} and not plot points, or use the default \code{b} to plot both.
}
\item{pch,cex,font}{
vectors of graphical parameters corresponding to the \code{group}s (scalars
if \code{group} is absent).  By default, the parameters set up by
\code{trellis} will be used.
}
}
\value{
\code{plsmo} returns a list of curves (x and y coordinates) that was passed to \code{labcurve}
}
\section{Side Effects}{
plots, and \code{panel.plsmo} creates the \code{Key} function in the session frame.
}
\seealso{
	\code{\link{lowess}}, \code{\link{supsmu}}, \code{\link{label}},
	\code{\link{quantile}}, \code{\link{labcurve}}, \code{\link{scat1d}},
	\code{\link[lattice]{xyplot}}, \code{\link[lattice]{panel.superpose}},
	\code{\link[lattice]{panel.xyplot}}, \code{\link{stat_plsmo}},
	\code{\link{histSpikeg}}
}
\examples{
set.seed(1)
x <- 1:100
y <- x + runif(100, -10, 10)
plsmo(x, y, "supsmu", xlab="Time of Entry") 
#Use label(y) or "y" for ylab


plsmo(x, y, add=TRUE, lty=2)
#Add lowess smooth to existing plot, with different line type


age <- rnorm(500, 50, 15)
survival.time <- rexp(500)
sex <- sample(c('female','male'), 500, TRUE)
race <- sample(c('black','non-black'), 500, TRUE)
plsmo(age, survival.time < 1, fun=qlogis, group=sex) # plot logit by sex

#Bivariate Y
sbp <- 120 + (age - 50)/10 + rnorm(500, 0, 8) + 5 * (sex == 'male')
dbp <-  80 + (age - 50)/10 + rnorm(500, 0, 8) - 5 * (sex == 'male')
Y <- cbind(sbp, dbp)
plsmo(age, Y)
plsmo(age, Y, group=sex)


#Plot points and smooth trend line using trellis 
# (add type='l' to suppress points or type='p' to suppress trend lines)
require(lattice)
xyplot(survival.time ~ age, panel=panel.plsmo)


#Do this for multiple panels
xyplot(survival.time ~ age | sex, panel=panel.plsmo)

#Repeat this using equal sample size intervals (n=25 each) summarized by
#the median, then a proportion (mean of binary y)
xyplot(survival.time ~ age | sex, panel=panel.plsmo, type='l',
       method='intervals', mobs=25, ifun=median)
ybinary <- ifelse(runif(length(sex)) < 0.5, 1, 0)
xyplot(ybinary ~ age, groups=sex, panel=panel.plsmo, type='l',
       method='intervals', mobs=75, ifun=mean, xlim=c(0, 120))


#Do this for subgroups of points on each panel, show the data
#density on each curve, and draw a key at the default location
xyplot(survival.time ~ age | sex, groups=race, panel=panel.plsmo,
       datadensity=TRUE)
Key()


#Use wloess.noiter to do a fast weighted smooth
plot(x, y)
lines(wtd.loess.noiter(x, y))
lines(wtd.loess.noiter(x, y, weights=c(rep(1,50), 100, rep(1,49))), col=2)
points(51, y[51], pch=18)   # show overly weighted point
#Try to duplicate this smooth by replicating 51st observation 100 times
lines(wtd.loess.noiter(c(x,rep(x[51],99)),c(y,rep(y[51],99)),
      type='ordered all'), col=3)
#Note: These two don't agree exactly
}
\keyword{smooth}
\keyword{nonparametric}
\keyword{hplot}
\concept{trellis}
\concept{lattice}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ordGroupBoot.r
\name{ordGroupBoot}
\alias{ordGroupBoot}
\title{Minimally Group an Ordinal Variable So Bootstrap Samples Will Contain All Distinct Values}
\usage{
ordGroupBoot(
  y,
  B = 0,
  m = 7:min(15, floor(n/3)),
  what = c("mean", "factor", "m"),
  aprob = 0.9999,
  pr = TRUE
)
}
\arguments{
\item{y}{a numeric vector}

\item{B}{number of bootstrap samples to test, or zero to use a coverage probability approximation}

\item{m}{range of minimum group sizes to test; the default range is usually adequate}

\item{what}{specifies that either the mean \code{y} in each group should be returned, a \code{factor} version of this with interval endpoints in the levels, or the computed value of \code{m} should be returned}

\item{aprob}{minimum coverage probability sought}

\item{pr}{set to \code{FALSE} to not print the computed value of the minimum \code{m} satisfying the needed condition}
}
\value{
a numeric vector corresponding to \code{y} but grouped, containing eithr the mean of \code{y} in each group or a factor variable representing grouped \code{y}, either with the minimum \code{m} that satisfied the required sample covrage
}
\description{
When bootstrapping models for ordinal Y when Y is fairly continuous, it is frequently the case that one or more bootstrap samples will not include one or more of the distinct original Y values.  When fitting an ordinal model (including a Cox PH model), this means that an intercept cannot be estimated, and the parameter vectors will not align over bootstrap samples.  To prevent this from happening, some grouping of Y may be necessary.  The \code{ordGroupBoot} function uses \code{\link[=cutGn]{cutGn()}} to group Y so that the minimum number in any group is guaranteed to not exceed a certain integer \code{m}.  \code{ordGroupBoot} tries a range of \code{m} and stops at the lowest \code{m} such that either all \code{B} tested bootstrap samples contain all the original distinct values of Y (if \code{B}>0), or that the probability that a given sample of size \code{n} with replacement will contain all the distinct original values exceeds \code{aprob} (\code{B}=0).  This probability is computed approximately using an approximation to the probability of complete sample coverage from the \emph{coupon collector's problem} and is quite accurate for our purposes.
}
\examples{
set.seed(1)
x <- c(1:6, NA, 7:22)
ordGroupBoot(x, m=5:10)
ordGroupBoot(x, m=5:10, B=5000, what='factor')
}
\seealso{
\code{\link[=cutGn]{cutGn()}}
}
\author{
Frank Harrell
}

\name{format.df}
\alias{format.df}
\title{
  Format a Data Frame or Matrix for LaTeX or HTML
}
\description{
  \code{format.df} does appropriate rounding and decimal alignment, and outputs
  a character matrix containing the formatted data.  If \code{x} is a
  \code{data.frame}, then do each component separately.
  If \code{x} is a matrix, but not a data.frame, make it a data.frame
  with individual components for the columns.
  If a component \code{x$x} is a matrix, then do all columns the same.
}

\usage{
format.df(x, digits, dec=NULL, rdec=NULL, cdec=NULL,
          numeric.dollar=!dcolumn, na.blank=FALSE, na.dot=FALSE,
          blank.dot=FALSE, col.just=NULL, cdot=FALSE,
          dcolumn=FALSE, matrix.sep=' ', scientific=c(-4,4),
          math.row.names=FALSE, already.math.row.names=FALSE,
          math.col.names=FALSE, already.math.col.names=FALSE,
          double.slash=FALSE, format.Date="\%m/\%d/\%Y",
          format.POSIXt="\%m/\%d/\%Y \%H:\%M:\%OS", \dots)
}
\arguments{
  \item{x}{
    a matrix (usually numeric) or data frame
  }
  \item{digits}{
    causes all values in the table to be formatted to \code{digits} significant
    digits.  \code{dec} is usually preferred.
  }
  \item{dec}{
    If \code{dec} is a scalar, all elements of the matrix will be rounded
    to \code{dec} 
    decimal places to the right of the decimal. \code{dec} can also be a matrix 
    whose elements correspond to \code{x}, for customized rounding of each element.
    A matrix \code{dec} must have number of columns equal to number of columns
    of input \code{x}.
    A scalar \code{dec} is expanded to a vector \code{cdec} with number of
    items equal to number of columns of input \code{x}.
  }
  \item{rdec}{
    a vector specifying the number of decimal places to the right for each row 
    (\code{cdec} is more commonly used than \code{rdec})
    A vector \code{rdec} must have number of items equal to number of rows of input \code{x}.
    \code{rdec} is expanded to matrix \code{dec}.
  }
  \item{cdec}{
    a vector specifying the number of decimal places for each column.
    The vector must have number of items equal to number of columns or components
    of input x.
  }
  \item{cdot}{
    Set to \code{TRUE} to use centered dots rather than ordinary periods in numbers.
    The output uses a syntax appropriate for \code{latex}.
  }
  \item{na.blank}{
    Set to \code{TRUE} to use blanks rather than \code{NA} for missing values.
    This usually looks better in \code{latex}.
  }
  \item{dcolumn}{
    Set to \code{TRUE} to use David Carlisle's dcolumn style for
    decimal alignment in \code{latex}.
    Default is \code{FALSE}. You will probably want to
    use \code{dcolumn} if you use \code{rdec}, as a column may then contain varying
    number of places to the right of the decimal. \code{dcolumn} can line up
    all such numbers on the decimal point, with integer values right
    justified at the decimal point location of numbers that actually
    contain decimal places.  When you use \code{dcolumn = TRUE}, 
    \code{numeric.dollar} is set by default to \code{FALSE}.  When you
    use \code{dcolumn = TRUE}, the
    object attribute \code{"style"} set to \samp{dcolumn} as the
		\code{latex} \code{usepackage} must reference \code{[dcolumn]}.
    The three files \file{dcolumn.sty}, \file{newarray.sty}, and
    \file{array.sty} will 
    need to be in a directory in your \env{TEXINPUTS} path.
    When you use \code{dcolumn=TRUE}, \code{numeric.dollar} should be set to \code{FALSE}.
  }
  \item{numeric.dollar}{
    logical, default \code{!dcolumn}.  Set to \code{TRUE} to place dollar
    signs around numeric values when \code{dcolumn = FALSE}.  This 
    assures that \code{latex} will use minus signs rather than hyphens to indicate
    negative numbers.  Set to \code{FALSE} when \code{dcolumn = TRUE}, as
    \code{dcolumn.sty} automatically uses minus signs.
  }
  \item{math.row.names}{
    logical, set true to place dollar signs around the row names.
  }
	\item{already.math.row.names}{set to \code{TRUE} to prevent any math
		mode changes to row names}
  \item{math.col.names}{
    logical, set true to place dollar signs around the column names.
  }
	\item{already.math.col.names}{set to \code{TRUE} to prevent any math
		mode changes to column names}
  \item{na.dot}{
    Set to \code{TRUE} to use periods rather than \code{NA} for missing
    numeric values. 
    This works with the \acronym{SAS} convention that periods indicate missing values.
  }
  \item{blank.dot}{
    Set to \code{TRUE} to use periods rather than blanks for missing character values.
    This works with the \acronym{SAS} convention that periods indicate missing values.
  }
  \item{col.just}{
    Input vector \code{col.just} must have number of columns equal to
    number of columns of the output matrix.  When \code{NULL}, the
    default, the \code{col.just} attribute of the result is set to
    \samp{l} for character columns and to \samp{r} for numeric
    columns.  The user can override the default by an argument vector
    whose length is equal to the number of columns of the result matrix.
    When \code{format.df} is called by \code{latex.default}, the
    \code{col.just} is used as the \code{cols} argument to the
    \code{tabular} environment and the letters \samp{l}, \samp{r},
    and \samp{c} are valid values.  When \code{format.df} is called by
    \acronym{SAS}, the \code{col.just} is used to determine whether a
    \samp{\$} is needed on the \samp{input} line of the \file{sysin} file,
    and the letters \samp{l} and \samp{r} are valid values.  You can
		pass specifications other than \code{l,r,c} in \code{col.just},
		e.g., \code{"p{3in}"} to get paragraph-formatted columns from
		\code{latex()}. 
  }
  \item{matrix.sep}{
    When \code{x} is a data frame containing a matrix, so that new column names
    are constructed from the name of the matrix object and the names of
    the individual columns of the matrix, \code{matrix.sep} specifies the
    character to use to separate object names from individual column
    names.
  }
  \item{scientific}{
    specifies ranges of exponents (or a logical vector) specifying values
    not to convert to scientific notation.  See \code{format.default} for details.
  }
  \item{double.slash}{
    should escaping backslashes be themselves escaped.
  }
  \item{format.Date}{
    String used to format objects of the Date class.
  }
  \item{format.POSIXt}{
    String used to format objects of the POSIXt class.
  }
  \item{\dots}{
    other arguments are accepted and passed to \code{format.default}.
    For \code{latexVerbatim} these arguments are passed to the
    \code{print} function.
  }
}
\value{
  a character matrix with character images of properly rounded \code{x}.
  Matrix components of input \code{x} are now just sets of columns of
  character matrix.
  Object attribute\code{"col.just"} repeats the value of the argument \code{col.just} when provided,
  otherwise, it includes the recommended justification for columns of output.
  See the discussion of the argument \code{col.just}.
  The default justification is \samp{l} for characters and factors,
  \samp{r} for numeric.
  When \code{dcolumn==TRUE}, numerics will have \samp{.} as the justification character.
}

\author{
  Frank E. Harrell, Jr.,
  \cr
  Department of Biostatistics,
  \cr
  Vanderbilt University,
  \cr
  \email{fh@fharrell.com}


  Richard M. Heiberger,
  \cr
  Department of Statistics,
  \cr
  Temple University, Philadelphia, PA.
  \cr
  \email{rmh@temple.edu}


}
\seealso{
  \code{\link{latex}}
}
\examples{
\dontrun{
x <- data.frame(a=1:2, b=3:4)
x$m <- 10000*matrix(5:8,nrow=2)
names(x)
dim(x)
x
format.df(x, big.mark=",")
dim(format.df(x))
}
}
\keyword{utilities}
\keyword{interface}
\keyword{methods}
\keyword{file}
\keyword{character}
\keyword{manip}

\name{describe}
\alias{describe}
\alias{describe.default}
\alias{describe.vector}
\alias{describe.matrix}
\alias{describe.formula}
\alias{describe.data.frame}
\alias{plot.describe}
\alias{print.describe}
\alias{print.describe.single}
\alias{[.describe}
\alias{latex.describe}
\alias{latex.describe.single}
\alias{html.describe}
\alias{html.describe.single}
\alias{formatdescribeSingle}
\title{Concise Statistical Description of a Vector, Matrix, Data Frame,
	or Formula}
\description{
\code{describe} is a generic method that invokes \code{describe.data.frame},
\code{describe.matrix}, \code{describe.vector}, or
\code{describe.formula}. \code{describe.vector} is the basic 
function for handling a single variable.
This function determines whether the variable is character, factor,
category, binary, discrete numeric, and continuous numeric, and prints
a concise statistical summary according to each. A numeric variable is
deemed discrete if it has <= 10 distinct values. In this case,
quantiles are not printed. A frequency table is printed 
for any non-binary variable if it has no more than 20 distinct
values.  For any variable for which the frequency table is not printed,
the 5 lowest and highest values are printed.  This behavior can be
overriden for long character variables with many levels using the
\code{listunique} parameter, to get a complete tabulation.

\code{describe} is especially useful for
describing data frames created by \code{*.get}, as labels, formats,
value labels, and (in the case of \code{sas.get}) frequencies of special
missing values are printed.

For a binary variable, the sum (number of 1's) and mean (proportion of
1's) are printed. If the first argument is a formula, a model frame
is created and passed to describe.data.frame.  If a variable
is of class \code{"impute"}, a count of the number of imputed values is
printed.  If a date variable has an attribute \code{partial.date}
(this is set up by \code{sas.get}), counts of how many partial dates are
actually present (missing month, missing day, missing both) are also presented.
If a variable was created by the special-purpose function \code{substi} (which
substitutes values of a second variable if the first variable is NA),
the frequency table of substitutions is also printed.

For numeric variables, \code{describe} adds an item called \code{Info}
which is a relative information measure using the relative efficiency of
a proportional odds/Wilcoxon test on the variable relative to the same
test on a variable that has no ties.  \code{Info} is related to how
continuous the variable is, and ties are less harmful the more untied
values there are.  The formula for \code{Info} is one minus the sum of
the cubes of relative frequencies of values divided by one minus the
square of the reciprocal of the sample size.  The lowest information
comes from a variable having only one distinct value following by a
highly skewed binary variable.  \code{Info} is reported to
two decimal places.

A latex method exists for converting the \code{describe} object to a
LaTeX file.  For numeric variables having more than 20 distinct values,
\code{describe} saves in its returned object the frequencies of 100
evenly spaced bins running from minimum observed value to the maximum.
When there are less than or equal to 20 distinct values, the original
values are maintained.
\code{latex} and \code{html} insert a spike histogram displaying these
frequency counts in the tabular material using the LaTeX picture
environment.  For example output see
\url{https://hbiostat.org/doc/rms/book/chapter7edition1.pdf}.
Note that the latex method assumes you have the following styles
installed in your latex installation: setspace and relsize.

The \code{html} method mimics the LaTeX output.  This is useful in the
context of Rmarkdown html and html notebook output.

The \code{plot} method is for \code{describe} objects run on data
frames.  It produces spike histograms for a graphic of
continuous variables and a dot chart for categorical variables, showing
category proportions.  The graphic format is \code{ggplot2} if the user
has not set \code{options(grType='plotly')} or has set the \code{grType}
option to something other than \code{'plotly'}.  Otherwise \code{plotly}
graphics that are interactive are produced, and these can be placed into
an Rmarkdown html notebook.  The user must install the \code{plotly}
package for this to work.  When the use hovers the mouse over a bin for
a raw data value, the actual value will pop-up (formatted using
\code{digits}).  When the user hovers over the minimum data value, most
of the information calculated by \code{describe} will pop up.  For each
variable, the number of missing values is used to assign the color to
the histogram or dot chart, and a legend is drawn.  Color is not used if
there are no missing values in any variable. For categorical variables,
hovering over the leftmost point for a variable displays details, and
for all points proportions, numerators, and denominators are displayed
in the popup.  If both continuous and categorical variables are present
and \code{which='both'} is specified, the \code{plot} method returns an
unclassed \code{list} containing two objects, named \code{'Categorical'}
and \code{'Continuous'}, in that order.

Sample weights may be specified to any of the functions, resulting
in weighted means, quantiles, and frequency tables.

Note: As discussed in Cox and Longton (2008), Stata Technical Bulletin 8(4)
pp. 557, the term "unique" has been replaced with "distinct" in the
output (but not in parameter names).

When \code{weights} are not used, Gini's mean difference is computed for
numeric variables.  This is a robust measure of dispersion that is the
mean absolute difference between any pairs of observations.  In the
output Gini's difference is labeled \code{Gmd}.

\code{formatdescribeSingle} is a service function for \code{latex},
\code{html}, and \code{print} methods for single variables that is not
intended to be called by the user.
}
\usage{
\method{describe}{vector}(x, descript, exclude.missing=TRUE, digits=4,
         listunique=0, listnchar=12,
         weights=NULL, normwt=FALSE, minlength=NULL, \dots)
\method{describe}{matrix}(x, descript, exclude.missing=TRUE, digits=4, \dots)
\method{describe}{data.frame}(x, descript, exclude.missing=TRUE,
    digits=4, \dots)
\method{describe}{formula}(x, descript, data, subset, na.action,
    digits=4, weights, \dots)
\method{print}{describe}(x, \dots)
\method{latex}{describe}(object, title=NULL,
      file=paste('describe',first.word(expr=attr(object,'descript')),'tex',sep='.'),
      append=FALSE, size='small', tabular=TRUE, greek=TRUE,
      spacing=0.7, lspace=c(0,0), \dots)
\method{latex}{describe.single}(object, title=NULL, vname,
      file, append=FALSE, size='small', tabular=TRUE, greek=TRUE,
      lspace=c(0,0), \dots)
\method{html}{describe}(object, size=85, tabular=TRUE,
      greek=TRUE, scroll=FALSE, rows=25, cols=100, \dots)
\method{html}{describe.single}(object, size=85,
      tabular=TRUE, greek=TRUE, \dots)
formatdescribeSingle(x, condense=c('extremes', 'frequencies', 'both', 'none'),
           lang=c('plain', 'latex', 'html'), verb=0, lspace=c(0, 0),
           size=85, \dots)
\method{plot}{describe}(x, which=c('both', 'continuous', 'categorical'),
                          what=NULL,
                          sort=c('ascending', 'descending', 'none'),
                          n.unique=10, digits=5, \dots)
}
\arguments{
\item{x}{
  a data frame, matrix, vector, or formula.  For a data frame, the 
  \code{describe.data.frame}
  function is automatically invoked.  For a matrix, \code{describe.matrix} is
  called.  For a formula, describe.data.frame(model.frame(x))
  is invoked. The formula may or may not have a response variable.  For
  \code{print}, \code{latex}, \code{html}, or
	\code{formatdescribeSingle}, \code{x} is an object created by
  \code{describe}.
}
\item{descript}{
  optional title to print for x. The default is the name of the argument
  or the "label" attributes of individual variables. When the first argument
  is a formula, \code{descript} defaults to a character representation of
  the formula.
}
\item{exclude.missing}{
  set toTRUE to print the names of variables that contain only missing values.
  This list appears at the bottom of the printout, and no space is taken
  up for such variables in the main listing.
}
\item{digits}{
  number of significant digits to print.  For \code{plot.describe} is
	the number of significant digits to put in hover text for
	\code{plotly} when showing raw variable values.} 
\item{listunique}{
  For a character variable that is not an \code{mChoice} variable, that
  has its longest string length greater than \code{listnchar}, and that
  has no more than \code{listunique} distinct values, all values are
  listed in alphabetic order.  Any value having more than one occurrence
  has the frequency of occurrence included.  Specify
  \code{listunique} equal to some value at least as large as the number
  of observations to ensure that all character variables will have all
  their values listed.  For purposes of tabulating character strings,
  multiple white spaces of any kind are translated to a single space,
  leading and trailing white space are ignored, and case is ignored.
}
\item{listnchar}{see \code{listunique}}
\item{weights}{
  a numeric vector of frequencies or sample weights.  Each observation
  will be treated as if it were sampled \code{weights} times.
}
\item{minlength}{value passed to summary.mChoice.}
\item{normwt}{
  The default, \code{normwt=FALSE} results in the use of \code{weights} as
  weights in computing various statistics.  In this case the sample size
  is assumed to be equal to the sum of \code{weights}.  Specify
  \code{normwt=TRUE} to divide 
  \code{weights} by a constant so that \code{weights} sum to the number of
  observations (length of vectors specified to \code{describe}).  In this
  case the number of observations is taken to be the actual number of
  records given to \code{describe}.
}
\item{object}{a result of \code{describe}}
\item{title}{unused}
\item{data}{
}
\item{subset}{
}
\item{na.action}{
  These are used if a formula is specified.  \code{na.action} defaults to
  \code{na.retain} which does not delete any \code{NA}s from the data frame.
  Use \code{na.action=na.omit} or \code{na.delete} to drop any observation with
  any \code{NA} before processing.
}
\item{\dots}{
  arguments passed to \code{describe.default} which are passed to calls
  to \code{format} for numeric variables.  For example if using R
  \code{POSIXct} or \code{Date} date/time formats, specifying
  \code{describe(d,format='\%d\%b\%y')} will print date/time variables as
  \code{"01Jan2000"}.  This is useful for omitting the time
  component.  See the help file for \code{format.POSIXct} or
  \code{format.Date} for more
  information.  For \code{plot} methods, \dots is ignored.
  For \code{html} and \code{latex} methods, \dots is used to pass
	optional arguments to \code{formatdescribeSingle}, especially the
	\code{condense} argument.
	}
\item{file}{
name of output file (should have a suffix of .tex).  Default name is
formed from the first word of the \code{descript} element of the
\code{describe} object, prefixed by \code{"describe"}.  Set
\code{file=""} to send LaTeX code to standard output instead of a file.
}
\item{append}{
set to \code{TRUE} to have \code{latex} append text to an existing file
named \code{file}
}
\item{size}{
LaTeX text size (\code{"small"}, the default, or \code{"normalsize"},
\code{"tiny"}, \code{"scriptsize"}, etc.) for the \code{describe} output
in LaTeX. For html is the percent of the prevailing font size to use for
the output.
}
\item{tabular}{
  set to \code{FALSE} to use verbatim rather than tabular (or html
	table) environment for the summary statistics output.  By default,
	tabular is used if the output is not too wide.}
\item{greek}{By default, the \code{latex} and \code{html} methods
  will change names of greek letters that appear in variable
  labels to appropriate LaTeX symbols in math mode, or html symbols,  unless
  \code{greek=FALSE}.}
\item{spacing}{By default, the \code{latex} method for \code{describe} run
  on a matrix or data frame uses the \code{setspace} LaTeX package with a
  line spacing of 0.7 so as to no waste space.  Specify \code{spacing=0}
  to suppress the use of the \code{setspace}'s \code{spacing} environment,
  or specify another positive value to use this environment with a
  different spacing.}
\item{lspace}{extra vertical scape, in character size units (i.e., "ex"
  as appended to the space).  When using certain font sizes, there is
  too much space left around LaTeX verbatim environments.  This
  two-vector specifies space to remove (i.e., the values are negated in
  forming the \code{vspace} command) before (first element) and after
  (second element of \code{lspace}) verbatims}
\item{scroll}{set to \code{TRUE} to create an html scrollable box for
	the html output}
\item{rows, cols}{the number of rows or columns to allocate for the
	scrollable box}
\item{vname}{unused argument in \code{latex.describe.single}}
\item{which}{specifies whether to plot numeric continuous or
	binary/categorical variables, or both.  When \code{"both"} a list with 
two elements is created.  Each element is a \code{ggplot2} or
\code{plotly} object.  If 
there are no variables of a given type, a single \code{ggplot2} or
\code{plotly} object is returned, ready to print.} 
\item{what}{character or numeric vector specifying which variables to
	plot; default is to plot all}
\item{sort}{specifies how and whether variables are sorted in order of
	the proportion of positives when \code{which="categorical"}.  Specify
	\code{sort="none"} to leave variables in the order they appear in the
	original data.}
\item{n.unique}{the minimum number of distinct values a numeric variable
	must have before \code{plot.describe} uses it in a continuous variable
	plot}
\item{condense}{specifies whether to condense the output with regard to
  the 5 lowest and highest values (\code{"extremes"}) and the frequency table
}
\item{lang}{specifies the markup language}
\item{verb}{set to 1 if a verbatim environment is already in effect for LaTeX}
}
\value{
a list containing elements \code{descript}, \code{counts},
\code{values}.  The list  is of class \code{describe}.  If the input
object was a matrix or a data 
frame, the list is a list of lists, one list for each variable
analyzed. \code{latex} returns a standard \code{latex} object.  For numeric
variables having at least 20 distinct values, an additional component
\code{intervalFreq}.  This component is a list with two elements, \code{range}
(containing two values) and \code{count}, a vector of 100 integer frequency
counts.
}
\details{
If \code{options(na.detail.response=TRUE)}
has been set and \code{na.action} is \code{"na.delete"} or
\code{"na.keep"}, summary  statistics on
the response variable are printed separately for missing and non-missing
values of each predictor.  The default summary function returns
the number of non-missing response values and the mean of the last
column of the response values, with a \code{names} attribute of
\code{c("N","Mean")}. 
When the response is a \code{Surv} object and the mean is used, this will
result in the crude proportion of events being used to summarize
the response.  The actual summary function can be designated through
\code{options(na.fun.response = "function name")}.

If you are modifying LaTex \code{parskip} or certain other parameters,
you may need to shrink the area around \code{tabular} and
\code{verbatim} environments produced by \code{latex.describe}.  You can
do this using for example
\code{\\usepackage{etoolbox}\\makeatletter\\preto{\\@verbatim}{\\topsep=-1.4pt
	\\partopsep=0pt}\\preto{\\@tabular}{\\parskip=2pt
	\\parsep=0pt}\\makeatother} in the LaTeX preamble.
}
\author{
Frank Harrell
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\seealso{
\code{\link{sas.get}}, \code{\link{quantile}}, \code{\link{GiniMd}},
\code{\link{table}}, \code{\link{summary}},
\code{\link{model.frame.default}}, 
\code{\link{naprint}}, \code{\link{lapply}}, \code{\link{tapply}},
\code{\link[survival]{Surv}}, \code{\link{na.delete}},
\code{\link{na.keep}}, 
\code{\link{na.detail.response}}, \code{\link{latex}}
}
\examples{
set.seed(1)
describe(runif(200),dig=2)    #single variable, continuous
                              #get quantiles .05,.10,\dots

dfr <- data.frame(x=rnorm(400),y=sample(c('male','female'),400,TRUE))
describe(dfr)

\dontrun{
options(grType='plotly')
d <- describe(mydata)
p <- plot(d)   # create plots for both types of variables
p[[1]]; p[[2]] # or p$Categorical; p$Continuous
plotly::subplot(p[[1]], p[[2]], nrows=2)  # plot both in one
plot(d, which='categorical')    # categorical ones

d <- sas.get(".","mydata",special.miss=TRUE,recode=TRUE)
describe(d)      #describe entire data frame
attach(d, 1)
describe(relig)  #Has special missing values .D .F .M .R .T
                 #attr(relig,"label") is "Religious preference"

#relig : Religious preference  Format:relig
#    n missing  D  F M R T distinct 
# 4038     263 45 33 7 2 1        8
#
#0:none (251, 6\%), 1:Jewish (372, 9\%), 2:Catholic (1230, 30\%) 
#3:Jehovah's Witnes (25, 1\%), 4:Christ Scientist (7, 0\%) 
#5:Seventh Day Adv (17, 0\%), 6:Protestant (2025, 50\%), 7:other (111, 3\%) 


# Method for describing part of a data frame:
 describe(death.time ~ age*sex + rcs(blood.pressure))
 describe(~ age+sex)
 describe(~ age+sex, weights=freqs)  # weighted analysis

 fit <- lrm(y ~ age*sex + log(height))
 describe(formula(fit))
 describe(y ~ age*sex, na.action=na.delete)   
# report on number deleted for each variable
 options(na.detail.response=TRUE)  
# keep missings separately for each x, report on dist of y by x=NA
 describe(y ~ age*sex)
 options(na.fun.response="quantile")
 describe(y ~ age*sex)   # same but use quantiles of y by x=NA

 d <- describe(my.data.frame)
 d$age                   # print description for just age
 d[c('age','sex')]       # print description for two variables
 d[sort(names(d))]       # print in alphabetic order by var. names
 d2 <- d[20:30]          # keep variables 20-30
 page(d2)                # pop-up window for these variables

# Test date/time formats and suppression of times when they don't vary
 library(chron)
 d <- data.frame(a=chron((1:20)+.1),
                 b=chron((1:20)+(1:20)/100),
                 d=ISOdatetime(year=rep(2003,20),month=rep(4,20),day=1:20,
                               hour=rep(11,20),min=rep(17,20),sec=rep(11,20)),
                 f=ISOdatetime(year=rep(2003,20),month=rep(4,20),day=1:20,
                               hour=1:20,min=1:20,sec=1:20),
                 g=ISOdate(year=2001:2020,month=rep(3,20),day=1:20))
 describe(d)

# Make a function to run describe, latex.describe, and use the kdvi
# previewer in Linux to view the result and easily make a pdf file

 ldesc <- function(data) {
  options(xdvicmd='kdvi')
  d <- describe(data, desc=deparse(substitute(data)))
  dvi(latex(d, file='/tmp/z.tex'), nomargins=FALSE, width=8.5, height=11)
 }

 ldesc(d)
}
}
\keyword{interface}
\keyword{nonparametric}
\keyword{category}
\keyword{distribution}
\keyword{robust}
\keyword{models}
\keyword{hplot}

\name{subplot}
\alias{subplot}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Embed a new plot within an existing plot}
\description{
  Subplot will embed a new plot within an existing plot at the
  coordinates specified (in user units of the existing plot).
}
\usage{
subplot(fun, x, y, size=c(1,1), vadj=0.5, hadj=0.5, pars=NULL)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{fun}{an expression or function defining the new plot to be embedded.}
  \item{x}{\code{x}-coordinate(s) of the new plot (in user coordinates
    of the existing plot).}
  \item{y}{\code{y}-coordinate(s) of the new plot, \code{x} and \code{y}
    can be specified in any of the ways understood by \code{xy.coords}.}
  \item{size}{The size of the embedded plot in inches if \code{x} and
    \code{y} have length 1.}
  \item{vadj}{vertical adjustment of the plot when \code{y} is a scalar,
    the default is to center vertically, 0 means place the bottom of the
    plot at \code{y}, 1 places the top of the plot at \code{y}.}
  \item{hadj}{horizontal adjustment of the plot when \code{x} is a
    scalar, the default is to center horizontally, 0 means place the
    left edge of the plot at \code{x}, and 1 means place the right edge
    of the plot at \code{x}.}
  \item{pars}{a list of parameters to be passed to \code{par} before
    running \code{fun}.}
}
\details{
  The coordinates \code{x} and \code{y} can be scalars or vectors of
  length 2.  If vectors of length 2 then they determine the opposite
  corners of the rectangle for the embedded plot (and the parameters
  \code{size}, \code{vadj}, and \code{hadj} are all ignored.

  If \code{x} and \code{y} are given as scalars then the plot position
  relative to the point and the size of the plot will be determined by
  the arguments \code{size}, \code{vadj}, and \code{hadj}.  The default
  is to center a 1 inch by 1 inch plot at \code{x,y}.  Setting
  \code{vadj} and \code{hadj} to \code{(0,0)} will position the lower
  left corner of the plot at \code{(x,y)}.

  The rectangle defined by \code{x}, \code{y}, \code{size}, \code{vadj},
  and \code{hadj} will be used as the plotting area of the new plot.
  Any tick marks, axis labels, main and sub titles will be outside of
  this rectangle.
  
  Any graphical parameter settings that you would like to be in place
  before \code{fun} is evaluated can be specified in the \code{pars}
  argument (warning: specifying layout parameters here (\code{plt},
  \code{mfrow}, etc.) may cause unexpected results).

  After the function completes the graphical parameters will have been
  reset to what they were before calling the function (so you can
  continue to augment the original plot).
}
\value{
 An invisible list with the graphical parameters that were in effect
 when the subplot was created.  Passing this list to \code{par} will
 enable you to augment the embedded plot.
}
%\references{ ~put references to the literature/web site here ~ }
\author{Greg Snow \email{greg.snow@imail.org}}
%\note{ ~~further notes~~ }

% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{\code{\link{cnvrt.coords}}, \code{\link{par}}, \code{\link{symbols}}}
\examples{
# make an original plot
plot( 11:20, sample(51:60) )

# add some histograms

subplot( hist(rnorm(100)), 15, 55)
subplot( hist(runif(100),main='',xlab='',ylab=''), 11, 51, hadj=0, vadj=0)
subplot( hist(rexp(100, 1/3)), 20, 60, hadj=1, vadj=1, size=c(0.5,2) )
subplot( hist(rt(100,3)), c(12,16), c(57,59), pars=list(lwd=3,ask=FALSE) )

tmp <- rnorm(25)
qqnorm(tmp)
qqline(tmp)
tmp2 <- subplot( hist(tmp,xlab='',ylab='',main=''), 
		cnvrt.coords(0.1,0.9,'plt')$usr, vadj=1, hadj=0 )
abline(v=0, col='red') # wrong way to add a reference line to histogram

# right way to add a reference line to histogram
op <- par(no.readonly=TRUE)
par(tmp2)
abline(v=0, col='green')
par(op)


}
\keyword{aplot}% at least one, from doc/KEYWORDS
\keyword{dplot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotlyM.r
\name{plotlyM}
\alias{plotlyM}
\title{plotly Multiple}
\usage{
plotlyM(
  data,
  x = ~x,
  y = ~y,
  xhi = ~xhi,
  yhi = ~yhi,
  htext = NULL,
  multplot = NULL,
  strata = NULL,
  fitter = NULL,
  color = NULL,
  size = NULL,
  showpts = !length(fitter),
  rotate = FALSE,
  xlab = NULL,
  ylab = NULL,
  ylabpos = c("top", "y"),
  xlim = NULL,
  ylim = NULL,
  shareX = TRUE,
  shareY = FALSE,
  height = NULL,
  width = NULL,
  nrows = NULL,
  ncols = NULL,
  colors = NULL,
  alphaSegments = 1,
  alphaCline = 0.3,
  digits = 4,
  zeroline = TRUE
)
}
\arguments{
\item{data}{input data frame}

\item{x}{formula specifying the x-axis variable}

\item{y}{formula for y-axis variable}

\item{xhi}{formula for upper x variable limits (\code{x} taken to be lower value)}

\item{yhi}{formula for upper y variable limit (\code{y} taken to be lower value)}

\item{htext}{formula for hovertext variable}

\item{multplot}{formula specifying a variable in \code{data} that when stratified on produces a separate plot}

\item{strata}{formula specifying an optional stratification variable}

\item{fitter}{a fitting such as \code{loess} that comes with a \code{predict} method.  Alternatively specify \code{fitter='ecdf'} to use an internal function for computing and displaying ECDFs, which moves the analysis variable from the y-axis to the x-axis}

\item{color}{\code{plotly} formula specifying a color variable or e.g. \code{~ I('black')}.  To keep colors constant over multiple plots you will need to specify an AsIs color when you don't have a variable representing color groups.}

\item{size}{\code{plotly} formula specifying a symbol size variable or AsIs}

\item{showpts}{if \code{fitter} is given, set to \code{TRUE} to show raw data points in addition to smooth fits}

\item{rotate}{set to \code{TRUE} to reverse the roles of \code{x} and \code{y}, for example to get horizontal dot charts with error bars}

\item{xlab}{x-axis label.  May contain html.}

\item{ylab}{a named vector of y-axis labels, possibly containing html (see example below).  The names of the vector must correspond to levels of the \code{multplot} variable.  \code{ylab} can be unnamed if \code{multplot} is not used.}

\item{ylabpos}{position of y-axis labels.  Default is on top left of plot.  Specify \code{ylabpos='y'} for usual y-axis placement.}

\item{xlim}{2-vector of x-axis limits, optional}

\item{ylim}{2-vector of y-axis limits, optional}

\item{shareX}{specifies whether x-axes should be shared when they align vertically over multiple plots}

\item{shareY}{specifies whether y-axes should be shared when they align horizontally over multiple plots}

\item{height}{height of the combined image in pixels}

\item{width}{width of the combined image in pixels}

\item{nrows}{the number of rows to produce using \code{subplot}}

\item{ncols}{the number of columns to produce using \code{subplot} (specify at most one of \code{nrows,ncols})}

\item{colors}{the color palette.  Leave unspecified to use the default \code{plotly} palette}

\item{alphaSegments}{alpha transparency for line segments (when \code{xhi} or \code{yhi} is not \code{NA})}

\item{alphaCline}{alpha transparency for lines used to connect points}

\item{digits}{number of significant digits to use in constructing hovertext}

\item{zeroline}{set to \code{FALSE} to suppress vertical line at x=0}
}
\value{
\code{plotly} object produced by \code{subplot}
}
\description{
Generates multiple plotly graphics, driven by specs in a data frame
}
\details{
Generates multiple \code{plotly} traces and combines them with \code{plotly::subplot}.  The traces are controlled by specifications in data frame \code{data} plus various arguments.  \code{data} must contain these variables: \code{x}, \code{y}, and \code{tracename} (if \code{color} is not an "AsIs" color such as \code{~ I('black')}), and can contain these optional variables: \code{xhi}, \code{yhi} (rows containing \code{NA} for both \code{xhi} and \code{yhi} represent points, and those with non-\code{NA} \code{xhi} or \code{yhi} represent segments, \code{connect} (set to \code{TRUE} for rows for points, to connect the symbols), \code{legendgroup} (see \code{plotly} documentation), and \code{htext} (hovertext).  If the \code{color} argument is given and it is not an "AsIs" color, the variable named in the \code{color} formula must also be in \code{data}.  Likewise for \code{size}.  If the \code{multplot} is given, the variable given in the formula must be in \code{data}.  If \code{strata} is present, another level of separate plots is generated by levels of \code{strata}, within levels of \code{multplot}.

If \code{fitter} is specified, x,y coordinates for an individual plot are
run through \code{fitter}, and a line plot is made instead of showing data points.  Alternatively you can specify \code{fitter='ecdf'} to compute and plot emirical cumulative distribution functions.
}
\examples{
\dontrun{
set.seed(1)
pts     <- expand.grid(v=c('y1', 'y2', 'y3'), x=1:4, g=c('a', 'b'), yhi=NA,
                       tracename='mean', legendgroup='mean',
                       connect=TRUE, size=4)

pts$y   <- round(runif(nrow(pts)), 2)

segs     <- expand.grid(v=c('y1', 'y2', 'y3'), x=1:4, g=c('a', 'b'),
                        tracename='limits', legendgroup='limits',
                        connect=NA, size=6)
segs$y   <- runif(nrow(pts))
segs$yhi <- segs$y + runif(nrow(pts), .05, .15)

z <- rbind(pts, segs)

xlab <- labelPlotmath('X<sub>12</sub>', 'm/sec<sup>2</sup>', html=TRUE)
ylab <- c(y1=labelPlotmath('Y1', 'cm', html=TRUE),
          y2='Y2',
          y3=labelPlotmath('Y3', 'mm', html=TRUE))

W=plotlyM(z, multplot=~v, color=~g, xlab=xlab, ylab=ylab, ncols=2,
          colors=c('black', 'blue'))

W2=plotlyM(z, multplot=~v, color=~I('black'), xlab=xlab, ylab=ylab,
           colors=c('black', 'blue'))

}
}
\author{
Frank Harrell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seqFreq.r
\name{seqFreq}
\alias{seqFreq}
\title{seqFreq}
\usage{
seqFreq(..., labels = NULL, noneNA = FALSE)
}
\arguments{
\item{...}{any number of variables}

\item{labels}{if specified variable labels will be used in place of variable names}

\item{noneNA}{set to \code{TRUE} to not include 'none' as a level in the result}
}
\value{
\code{factor} variable with \code{obs.per.numcond} attribute
}
\description{
Find Sequential Exclusions Due to NAs
}
\details{
Finds the variable with the highest number of \code{NA}s.  From the non-\code{NA}s on that variable find the next variable from those remaining with the highest number of \code{NA}s.  Proceed in like fashion.  The resulting variable summarizes sequential exclusions in a hierarchical fashion.  See \href{https://hbiostat.org/rflow/doverview.html#sec-doverview-filter}{this} for more information.
}
\author{
Frank Harrell
}

\name{latexCheckOptions}
\alias{latexCheckOptions}
\title{Check whether the options for latex functions have been specified.}
\description{
Check whether the options for latex functions have been specified.
If any of\cr
\code{options()[c("latexcmd","dviExtension","xdvicmd")]}
are \code{NULL}, an error message is displayed.
}
\usage{
latexCheckOptions(...)
}
\arguments{
  \item{\dots}{
Any arguments are ignored.
}
}
\value{
If any \code{NULL} options are detected, the invisible text of the
error message.  If all three options have non-\code{NULL} values, NULL.
}
\author{ Richard M. Heiberger <rmh@temple.edu> }
\seealso{
\code{\link[Hmisc]{latex}}
}
\keyword{ utilities}

\name{hist.data.frame}
\alias{hist.data.frame}
\title{Histograms for Variables in a Data Frame}
\description{
This functions tries to compute the maximum number of histograms that
will fit on one page, then it draws a matrix of histograms.  If there
are more qualifying variables than will fit on a page, the function
waits for a mouse click before drawing the next page.
}
\usage{
\method{hist}{data.frame}(x, n.unique = 3, nclass = "compute",
                na.big = FALSE, rugs = FALSE, freq=TRUE, mtitl = FALSE, ...)
}
\arguments{
  \item{x}{a data frame}
  \item{n.unique}{minimum number of unique values a variable must have
	before a histogram is drawn}
  \item{nclass}{number of bins.  Default is
	max(2,trunc(min(n/10,25*log(n,10))/2)), where n is the number of
	non-missing values for a variable.}
  \item{na.big}{set to \code{TRUE} to draw the number of missing values
	on the top of the histogram in addition to in a subtitle.  In the
	subtitle, n is the number of non-missing values and m is the number
	of missing values}
  \item{rugs}{set to \code{TRUE} to add rug plots at the top of each
		histogram}
	\item{freq}{see \code{\link{hist}}.  Default is to show frequencies.}
  \item{mtitl}{set to a character string to set aside extra outside top
	margin and to use the string for an overall title}
  \item{\dots}{arguments passed to \code{scat1d}}
}
\value{the number of pages drawn}
\author{Frank E Harrell Jr}
\seealso{\code{\link{hist}}, \code{\link{scat1d}}}
\examples{
d <- data.frame(a=runif(200), b=rnorm(200),
                w=factor(sample(c('green','red','blue'), 200, TRUE)))
hist.data.frame(d)   # in R, just say hist(d)
}
\keyword{hplot}
\keyword{dplot}
\keyword{distribution}

\name{rMultinom}
\alias{rMultinom}
\title{Generate Multinomial Random Variables with Varying Probabilities}
\description{
Given a matrix of multinomial probabilities where rows correspond to
observations and columns to categories (and each row sums to 1),
generates a matrix with the same number of rows as has \code{probs} and
with \code{m} columns.  The columns represent multinomial cell numbers,
and within a row the columns are all samples from the same multinomial
distribution.  The code is a modification of that in the
\code{impute.polyreg} function in the \code{MICE} package.
}
\usage{
rMultinom(probs, m)
}
\arguments{
  \item{probs}{matrix of probabilities}
  \item{m}{number of samples for each row of \code{probs}}
}
\value{
  an integer matrix having \code{m} columns
}
\seealso{\code{\link{rbinom}}}
\examples{
set.seed(1)
w <- rMultinom(rbind(c(.1,.2,.3,.4),c(.4,.3,.2,.1)),200)
t(apply(w, 1, table)/200)
}
\keyword{distribution}

\name{score.binary}
\alias{score.binary}
\title{
Score a Series of Binary Variables
}
\description{
Creates a new variable from a series of logical conditions.  The new
variable can be a hierarchical category or score derived from considering
the rightmost \code{TRUE} value among the input variables, an additive point
score, a union, or any of several others by specifying a function using the
\code{fun} argument.
}
\usage{
score.binary(\dots, fun=max, points=1:p, 
             na.rm=funtext == "max", retfactor=TRUE)
}
\arguments{
\item{...}{
a list of variables or expressions which are considered to be binary
or logical
}
\item{fun}{
a function to compute on each row of the matrix represented by
a specific observation of all the variables in \code{\dots}
}
\item{points}{
points to assign to successive elements of \code{\dots} .  The default is
\code{1, 2, \dots, p}, where \code{p} is the number of elements.  If you specify
one number for \code{points}, that number will be duplicated (i.e., equal weights
are assumed).
}
\item{na.rm}{
set to \code{TRUE} to remove \code{NA}s from consideration when processing
each row of the matrix of variables in \code{\dots} .  For \code{fun=max},
\code{na.rm=TRUE} is the default since \code{score.binary} assumes that a
hierarchical scale is based on available information.  Otherwise,
\code{na.rm=FALSE} is assumed.  For \code{fun=mean} you may want to specify
\code{na.rm=TRUE}.
}
\item{retfactor}{
applies if \code{fun=max}, in which case \code{retfactor=TRUE} makes \code{score.binary}
return a \code{factor} object since a hierarchical scale implies
a unique choice.
}}
\value{
a \code{factor} object if \code{retfactor=TRUE} and \code{fun=max} or a numeric vector
otherwise.  Will not contain NAs if \code{na.rm=TRUE} unless every variable in
a row is \code{NA}.  If a \code{factor} object
is returned, it has levels \code{"none"} followed by character
string versions of the arguments given in \code{\dots} .
}
\seealso{
\code{\link{any}}, \code{\link{sum}}, \code{\link{max}}, \code{\link{factor}}
}
\examples{
set.seed(1)
age <- rnorm(25, 70, 15)
previous.disease <- sample(0:1, 25, TRUE)
#Hierarchical scale, highest of 1:age>70  2:previous.disease
score.binary(age>70, previous.disease, retfactor=FALSE)
#Same as above but return factor variable with levels "none" "age>70" 
# "previous.disease"
score.binary(age>70, previous.disease)


#Additive scale with weights 1:age>70  2:previous.disease
score.binary(age>70, previous.disease, fun=sum)
#Additive scale, equal weights
score.binary(age>70, previous.disease, fun=sum, points=c(1,1))
#Same as saying points=1


#Union of variables, to create a new binary variable
score.binary(age>70, previous.disease, fun=any)
}
\keyword{manip}
% Converted by Sd2Rd version 1.21.

\name{wtd.stats}
\alias{wtd.mean}
\alias{wtd.var}
\alias{wtd.quantile}
\alias{wtd.Ecdf}
\alias{wtd.table}
\alias{wtd.rank}
\alias{wtd.loess.noiter}
\alias{num.denom.setup}
\title{
Weighted Statistical Estimates
}
\description{
These functions compute various weighted versions of standard
estimators.  In most cases the \code{weights} vector is a vector the same
length of \code{x}, containing frequency counts that in effect expand \code{x}
by these counts.  \code{weights} can also be sampling weights, in which
setting \code{normwt} to \code{TRUE} will often be appropriate.  This results in
making \code{weights} sum to the length of the non-missing elements in
\code{x}.  \code{normwt=TRUE} thus reflects the fact that the true sample size is
the length of the \code{x} vector and not the sum of the original values of
\code{weights} (which would be appropriate had \code{normwt=FALSE}).  When \code{weights}
is all ones, the estimates are all identical to unweighted estimates
(unless one of the non-default quantile estimation options is
specified to \code{wtd.quantile}).  When missing data have already been
deleted for, \code{x}, \code{weights}, and (in the case of \code{wtd.loess.noiter}) \code{y},
specifying \code{na.rm=FALSE} will save computation time.  Omitting the
\code{weights} argument or specifying \code{NULL} or a zero-length vector will
result in the usual unweighted estimates.

\code{wtd.mean}, \code{wtd.var}, and \code{wtd.quantile} compute
weighted means, variances, and quantiles, respectively.  \code{wtd.Ecdf}
computes a weighted empirical distribution function.  \code{wtd.table}
computes a weighted frequency table (although only one stratification
variable is supported at present).  \code{wtd.rank} computes weighted
ranks, using mid--ranks for ties.  This can be used to obtain Wilcoxon
tests and rank correlation coefficients.  \code{wtd.loess.noiter} is a
weighted version of \code{loess.smooth} when no iterations for outlier
rejection are desired. This results in especially good smoothing when
\code{y} is binary.  \code{wtd.quantile} removes any observations with
zero weight at the beginning.  Previously, these were changing the
quantile estimates.

\code{num.denom.setup} is a utility function that allows one to deal with
observations containing numbers of events and numbers of trials, by
outputting two observations when the number of events and non-events
(trials - events) exceed zero.  A vector of subscripts is generated
that will do the proper duplications of observations, and a new binary
variable \code{y} is created along with usual cell frequencies (\code{weights})
for each of the \code{y=0}, \code{y=1} cells per observation.
}
\usage{
wtd.mean(x, weights=NULL, normwt="ignored", na.rm=TRUE)
wtd.var(x, weights=NULL, normwt=FALSE, na.rm=TRUE,
        method=c('unbiased', 'ML'))
wtd.quantile(x, weights=NULL, probs=c(0, .25, .5, .75, 1), 
             type=c('quantile','(i-1)/(n-1)','i/(n+1)','i/n'), 
             normwt=FALSE, na.rm=TRUE)
wtd.Ecdf(x, weights=NULL, 
         type=c('i/n','(i-1)/(n-1)','i/(n+1)'), 
         normwt=FALSE, na.rm=TRUE)
wtd.table(x, weights=NULL, type=c('list','table'), 
          normwt=FALSE, na.rm=TRUE)
wtd.rank(x, weights=NULL, normwt=FALSE, na.rm=TRUE)
wtd.loess.noiter(x, y, weights=rep(1,n),
                 span=2/3, degree=1, cell=.13333, 
                 type=c('all','ordered all','evaluate'), 
                 evaluation=100, na.rm=TRUE)
num.denom.setup(num, denom)
}
\arguments{
\item{x}{
a numeric vector (may be a character or \code{category} or \code{factor} vector
for \code{wtd.table})
}
\item{num}{
vector of numerator frequencies
}
\item{denom}{
vector of denominators (numbers of trials)
}
\item{weights}{
a numeric vector of weights
}
\item{normwt}{
specify \code{normwt=TRUE} to make \code{weights} sum to
\code{length(x)} after deletion of \code{NA}s.  If \code{weights} are
frequency weights, then \code{normwt} should be \code{FALSE}, and if
\code{weights} are normalization (aka reliability) weights, then
\code{normwt} should be \code{TRUE}. In the case of the former, no check
is made that \code{weights} are valid frequencies. 
}
\item{na.rm}{
set to \code{FALSE} to suppress checking for NAs
}
\item{method}{determines the estimator type; if \code{'unbiased'} (the
	default) then the usual unbiased estimate (using Bessel's correction)
	is returned, if \code{'ML'} then it is the maximum likelihood estimate
	for a Gaussian distribution. In the case of the latter, the
	\code{normwt} argument has no effect.  Uses \code{stats:cov.wt} for
	both methods.}
\item{probs}{
a vector of quantiles to compute.  Default is 0 (min), .25, .5, .75, 1
(max).
}
\item{type}{
For \code{wtd.quantile}, \code{type} defaults to \code{quantile} to use the same
interpolated order statistic method as \code{quantile}.  Set \code{type} to 
\code{"(i-1)/(n-1)"},\code{"i/(n+1)"}, or \code{"i/n"} to use the inverse of the
empirical distribution function, using, respectively, (wt - 1)/T,
wt/(T+1), or wt/T, where wt is the cumulative weight and T is the
total weight (usually total sample size).  These three values of
\code{type} are the possibilities for \code{wtd.Ecdf}.  For \code{wtd.table} the
default \code{type} is \code{"list"}, meaning that the function is to return a
list containing two vectors: \code{x} is the sorted unique values of \code{x}
and \code{sum.of.weights} is the sum of weights for that \code{x}.  This is the
default so that you don't have to convert the \code{names} attribute of the
result that can be obtained with \code{type="table"} to a numeric variable
when \code{x} was originally numeric.  \code{type="table"} for \code{wtd.table}
results in an object that is the same structure as those returned from
\code{table}.  For \code{wtd.loess.noiter} the default \code{type} is \code{"all"},
indicating that the function is to return a list containing all the
original values of \code{x} (including duplicates and without sorting) and
the smoothed \code{y} values corresponding to them.  Set \code{type="ordered
all"} to sort by \code{x}, and \code{type="evaluate"} to evaluate the smooth
only at \code{evaluation} equally spaced points between the observed limits
of \code{x}.
}
\item{y}{a numeric vector the same length as \code{x}}
\item{span, degree, cell, evaluation}{
see \code{loess.smooth}.  The default is linear (\code{degree}=1) and 100 points
to evaluation (if \code{type="evaluate"}).
}}
\value{
\code{wtd.mean} and \code{wtd.var} return scalars.  \code{wtd.quantile} returns a
vector the same length as \code{probs}.  \code{wtd.Ecdf} returns a list whose
elements \code{x} and \code{Ecdf} correspond to unique sorted values of \code{x}.
If the first CDF estimate is greater than zero, a point (min(x),0) is
placed at the beginning of the estimates.
See above for \code{wtd.table}.  \code{wtd.rank} returns a vector the same
length as \code{x} (after removal of NAs, depending on \code{na.rm}).  See above
for \code{wtd.loess.noiter}.
}
\details{
The functions correctly combine weights of observations having
duplicate values of \code{x} before computing estimates.

When \code{normwt=FALSE} the weighted variance will not equal the
unweighted variance even if the weights are identical.  That is because
of the subtraction of 1 from the sum of the weights in the denominator
of the variance formula.  If you want the weighted variance to equal the
unweighted variance when weights do not vary, use \code{normwt=TRUE}.
The articles by Gatz and Smith discuss alternative approaches, to arrive
at estimators of the standard error of a weighted mean.

\code{wtd.rank} does not handle NAs as elegantly as \code{rank} if
\code{weights} is specified.
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University School of Medicine
\cr
\email{fh@fharrell.com}
\cr
Benjamin Tyner
\cr
\email{btyner@gmail.com}
}
\references{
Research Triangle Institute (1995): SUDAAN User's Manual, Release
6.40, pp. 8-16 to 8-17.

Gatz DF, Smith L (1995): The standard error of a weighted mean
concentration--I.  Bootstrapping vs other methods.  Atmospheric Env
11:1185-1193.

Gatz DF, Smith L (1995): The standard error of a weighted mean
concentration--II.  Estimating confidence intervals.  Atmospheric Env
29:1195-1200.

https://en.wikipedia.org/wiki/Weighted_arithmetic_mean
}
\seealso{
\code{\link{mean}}, \code{\link{var}}, \code{\link{quantile}}, \code{\link{table}}, \code{\link{rank}}, \code{\link{loess.smooth}}, \code{\link{lowess}},
\code{\link{plsmo}}, \code{\link{Ecdf}}, \code{\link{somers2}}, \code{\link{describe}}
}
\examples{
set.seed(1)
x <- runif(500)
wts <- sample(1:6, 500, TRUE)
std.dev <- sqrt(wtd.var(x, wts))
wtd.quantile(x, wts)
death <- sample(0:1, 500, TRUE)
plot(wtd.loess.noiter(x, death, wts, type='evaluate'))
describe(~x, weights=wts)
# describe uses wtd.mean, wtd.quantile, wtd.table
xg <- cut2(x,g=4)
table(xg)
wtd.table(xg, wts, type='table')

# Here is a method for getting stratified weighted means
y <- runif(500)
g <- function(y) wtd.mean(y[,1],y[,2])
summarize(cbind(y, wts), llist(xg), g, stat.name='y')

# Empirically determine how methods used by wtd.quantile match with
# methods used by quantile, when all weights are unity
set.seed(1)
u <-  eval(formals(wtd.quantile)$type)
v <- as.character(1:9)
r <- matrix(0, nrow=length(u), ncol=9, dimnames=list(u,v))

for(n in c(8, 13, 22, 29))
  {
    x <- rnorm(n)
    for(i in 1:5) {
      probs <- sort( runif(9))
      for(wtype in u) {
        wq <- wtd.quantile(x, type=wtype, weights=rep(1,length(x)), probs=probs)
        for(qtype in 1:9) {
          rq <- quantile(x, type=qtype, probs=probs)
          r[wtype, qtype] <- max(r[wtype,qtype], max(abs(wq-rq)))
        }
      }
    }
  }

r

# Restructure data to generate a dichotomous response variable
# from records containing numbers of events and numbers of trials
num   <- c(10,NA,20,0,15)   # data are 10/12 NA/999 20/20 0/25 15/35
denom <- c(12,999,20,25,35)
w     <- num.denom.setup(num, denom)
w
# attach(my.data.frame[w$subs,])
}
\keyword{nonparametric}
\keyword{category}
\keyword{distribution}
\keyword{robust}
\keyword{loess}
\keyword{smooth}
\keyword{manip}
\concept{weighted sampling}
\concept{grouping}
\concept{weights}

\encoding{latin1}
\name{latex}
\alias{latex}
\alias{latex.default}
\alias{latex.function}
\alias{latex.list}
\alias{latexTranslate}
\alias{htmlTranslate}
\alias{latexSN}
\alias{htmlSN}
\alias{latexVerbatim}
\alias{dvi}
\alias{print.dvi}
\alias{dvi.latex}
\alias{dvips}
\alias{dvips.latex}
\alias{dvips.dvi}
\alias{dvigv}
\alias{dvigv.latex}
\alias{dvigv.dvi}
\alias{print.latex}
\alias{show.latex}
\alias{show.dvi}
\title{
  Convert an S object to LaTeX, and Related Utilities
}
\description{
\code{latex} converts its argument to a \file{.tex} file appropriate
for inclusion in a LaTeX2e document.  \code{latex} is a generic
function that calls one of \code{latex.default},
\code{latex.function}, \code{latex.list}. 

\code{latex.default}
does appropriate rounding and decimal alignment and produces a
file containing a LaTeX tabular environment to print the matrix or data.frame
\code{x} as a table.

\code{latex.function} prepares an S function for printing by issuing \code{sed}
commands that are similar to those in the
\code{S.to.latex} procedure in the \code{s.to.latex} package (Chambers
and Hastie, 1993).  \code{latex.function} can also produce
\code{verbatim} output or output that works with the \code{Sweavel}
LaTeX style.

\code{latex.list} calls \code{latex} recursively for each element in the argument.

\code{latexTranslate} translates particular items in character
strings to LaTeX format, e.g., makes \samp{a^2 = a\$^2\$} for superscript within
variable labels.   LaTeX names of greek letters (e.g., \code{"alpha"})
will have backslashes added if \code{greek==TRUE}.  Math mode is
inserted as needed. 
\code{latexTranslate} assumes that input text always has matches,
e.g. \code{[) [] (] ()}, and that surrounding  by \samp{\$\$} is OK.

\code{htmlTranslate} is similar to \code{latexTranslate} but for html
translation.  It doesn't need math mode and assumes dollar signs are
just that.

\code{latexSN} converts a vector floating point numbers to character
strings using LaTeX exponents.  Dollar signs to enter math mode are not
added.  Similarly, \code{htmlSN} converts to scientific notation in html.

\code{latexVerbatim} on an object executes the object's \code{print} method,
capturing the output for a file inside a LaTeX verbatim environment.

\code{dvi} uses the system \code{latex} command to compile LaTeX code produced
by \code{latex}, including any needed styles.  \code{dvi}
will put a \samp{\\documentclass\{report\}} and \samp{\\end\{document\}} wrapper
around a file produced by \code{latex}.  By default, the \samp{geometry} LaTeX package is
used to omit all margins and to set the paper size to a default of
5.5in wide by 7in tall.  The result of \code{dvi} is a .dvi file.  To both
format and screen display a non-default size, use for example
\code{print(dvi(latex(x), width=3, height=4),width=3,height=4)}.  Note that
you can use something like \samp{xdvi -geometry 460x650 -margins 2.25in
file} without changing LaTeX defaults to emulate this.

\code{dvips} will use the system \code{dvips} command to print the .dvi file to
the default system printer, or create a postscript file if \code{file}
is specified.

\code{dvigv} uses the system \code{dvips} command to convert the input object
to a .dvi file, and uses the system \code{dvips} command to convert it to
postscript.  Then the postscript file is displayed using Ghostview
(assumed to be the system command \command{gv}).

There are \code{show} methods for displaying typeset LaTeX
on the screen using the system \command{xdvi}
command.   If you \code{show} a LaTeX file created by
\code{latex} without running it through \code{dvi} using
\code{show.dvi(object)}, the 
\code{show} method will run it through \code{dvi} automatically.
These \code{show} 
methods are not S Version 4 methods so you have to use full names such
as \code{show.dvi} and \code{show.latex}.  Use the \code{print} methods for
more automatic display of typesetting, e.g. typing \code{latex(x)} will
invoke xdvi to view the typeset document.
}
\usage{
latex(object, \dots)

\method{latex}{default}(object,
    title=first.word(deparse(substitute(object))),
    file=paste(title, ".tex", sep=""),
    append=FALSE, label=title,
    rowlabel=title, rowlabel.just="l",
    cgroup=NULL, n.cgroup=NULL,
    rgroup=NULL, n.rgroup=NULL,
    cgroupTexCmd="bfseries",
    rgroupTexCmd="bfseries",
    rownamesTexCmd=NULL,
    colnamesTexCmd=NULL,
    cellTexCmds=NULL,
    rowname, cgroup.just=rep("c",length(n.cgroup)),
    colheads=NULL,
    extracolheads=NULL, extracolsize='scriptsize',
    dcolumn=FALSE, numeric.dollar=!dcolumn, cdot=FALSE,
    longtable=FALSE, draft.longtable=TRUE, ctable=FALSE, booktabs=FALSE,
    table.env=TRUE, here=FALSE, lines.page=40,
    caption=NULL, caption.lot=NULL, caption.loc=c('top','bottom'),
    star=FALSE,
    double.slash=FALSE,
    vbar=FALSE, collabel.just=rep("c",nc), na.blank=TRUE,
    insert.bottom=NULL, insert.bottom.width=NULL,
    insert.top=NULL,
    first.hline.double=!(booktabs | ctable),
    where='!tbp', size=NULL,
    center=c('center','centering','centerline','none'),
    landscape=FALSE,
    multicol=TRUE,
    math.row.names=FALSE, already.math.row.names=FALSE,
    math.col.names=FALSE, already.math.col.names=FALSE,
    hyperref=NULL, continued='continued',
    \dots) # x is a matrix or data.frame

\method{latex}{function}(
	object,
	title=first.word(deparse(substitute(object))),
	file=paste(title, ".tex", sep=""),
	append=FALSE,
	assignment=TRUE,  type=c('example','verbatim','Sinput'),
    width.cutoff=70, size='', \dots)

\method{latex}{list}(
           object,
           title=first.word(deparse(substitute(object))),
           file=paste(title, ".tex", sep=""),
           append=FALSE,
           label,
           caption,
           caption.lot,
           caption.loc=c('top','bottom'),
           \dots)

\method{print}{latex}(x, \dots)

latexTranslate(object, inn=NULL, out=NULL, pb=FALSE, greek=FALSE, na='',
               \dots)

htmlTranslate(object, inn=NULL, out=NULL, greek=FALSE, na='',
              code=htmlSpecialType(), \dots)

latexSN(x)

htmlSN(x, pretty=TRUE, \dots)

latexVerbatim(x, title=first.word(deparse(substitute(x))),
    file=paste(title, ".tex", sep=""),
    append=FALSE, size=NULL, hspace=NULL,
    width=.Options$width, length=.Options$length, \dots)

dvi(object, \dots)
\method{dvi}{latex}(object, prlog=FALSE, nomargins=TRUE, width=5.5, height=7, \dots)
\method{print}{dvi}(x, \dots)
dvips(object, \dots)
\method{dvips}{latex}(object, \dots)
\method{dvips}{dvi}(object, file, \dots)
\method{show}{latex}(object)  # or show.dvi(object) or just object
dvigv(object, \dots)
\method{dvigv}{latex}(object, \dots)       # or gvdvi(dvi(object))
\method{dvigv}{dvi}(object, \dots)
}
\arguments{
  \item{object}{
    For \code{latex}, any S object.  For \code{dvi} or \code{dvigv}, an object
    created by \code{latex}.  For \code{latexTranslate} is a vector of
    character strings to translate.  Any \code{NA}s are set to blank
		strings before conversion.
  }
  \item{x}{
    any object to be \code{print}ed verbatim for \code{latexVerbatim}.  For
    \code{latexSN} or \code{htmlSN}, \code{x} is a numeric vector.
  }
  \item{title}{
    name of file to create without the \samp{.tex} extension.  If this
    option is not set, value/string of \code{x} (see above) is printed
    in the top left corner of the table.  Set \code{title=''} to
    suppress this output.
  }
  \item{file}{
    name of the file to create.  The default file name is \file{x.tex} where
    \code{x} is the first word in the name of the argument for \code{x}.
    Set \code{file=""} to have the generated LaTeX code just printed to
    standard output.  This is especially useful when running under Sweave in
    R using its \samp{results=tex} tag, to save having to manage many
    small external files.  When \code{file=""}, \code{latex} keeps track of
    LaTeX styles that are called for by creating or modifying an object
    \code{latexStyles} (in \code{.GlobalTemp} in R or in frame 0 in
    S-Plus).  \code{latexStyles} is a vector containing the base names of
    all the unique LaTeX styles called for so far in the current session.
    See the end of the examples section for a way to use this object to good
    effect.  For \code{dvips}, \code{file} is the name of an output
    postscript file.
  }
  \item{append}{
   defaults to \code{FALSE}. Set to \code{TRUE} to append output to an existing file.
  }
  \item{label}{
    a text string representing a symbolic label for the table for referencing
    in the LaTeX \samp{\\label} and \samp{\\ref} commands.
    \code{label} is only used if \code{caption} is given.
  }
  \item{rowlabel}{
    If \code{x} has row dimnames, \code{rowlabel} is a character string containing the
    column heading for the row dimnames. The default is the name of the
    argument for \code{x}.
  }
  \item{rowlabel.just}{
    If \code{x} has row dimnames, specifies the justification for printing them.
    Possible values are \code{"l"}, \code{"r"}, \code{"c"}. The heading (\code{rowlabel}) itself
    is left justified if \code{rowlabel.just="l"}, otherwise it is centered.
  }
  \item{cgroup}{
    a vector of character strings defining major column headings. The default is
    to have none.
  }
  \item{n.cgroup}{
    a vector containing the number of columns for which each element in
    cgroup is a heading.  For example, specify \code{cgroup=c("Major 1","Major 2")},
    \code{n.cgroup=c(3,3)} if \code{"Major 1"} is to span columns 1-3 and \code{"Major 2"} is
    to span columns 4-6.  \code{rowlabel} does not count in the column numbers.
    You can omit \code{n.cgroup} if all groups have the same number of columns.
  }
  \item{rgroup}{
    a vector of character strings containing headings for row groups.
    \code{n.rgroup} must be present when \code{rgroup} is given. The first \code{n.rgroup[1]}
    rows are sectioned off and \code{rgroup[1]} is used as a bold heading for
    them. The usual row dimnames (which must be present if \code{rgroup} is) are 
    indented. The next \code{n.rgroup[2]} rows are treated likewise, etc.
  }
  \item{n.rgroup}{
    integer vector giving the number of rows in each grouping. If \code{rgroup}
    is not specified, \code{n.rgroup} is just used to divide off blocks of
    rows by horizontal lines. If \code{rgroup} is given but \code{n.rgroup} is omitted,
    \code{n.rgroup} will default so that each row group contains the same number
    of rows.
  }
  \item{cgroupTexCmd}{A character string specifying a LaTeX command to be
    used to format column group labels.  The default, \code{"bfseries"}, sets
    the current font to \sQuote{bold}.  It is possible to supply a vector of
    strings so that each column group label is formatted differently.
    Please note that the first item of the vector is used to format the
    title (even if a title is not used). Currently the user needs to handle
    these issue.  Multiple effects can be achieved by creating custom
    LaTeX commands; for example,
    \code{"\providecommand{\redscshape}{\color{red}\scshape}"} creates a
    LaTeX command called \samp{\\redscshape} that formats the text in red
    small-caps.
  }
  \item{rgroupTexCmd}{A character string specifying a LaTeX command to be
    used to format row group labels.  The default, \code{"bfseries"}, sets the
    current font to \sQuote{bold}.  A vector of strings can be supplied to
    format each row group label differently.  Normal recycling applies
    if the vector is shorter than \code{n.rgroups}.  See also
    \code{cgroupTexCmd} above regarding multiple effects.
  }
  \item{rownamesTexCmd}{A character string specifying a LaTeX
    command to be used to format rownames. The default, \code{NULL}, applies no
    command.  A vector of different commands can also be supplied.
    See also \code{cgroupTexCmd} above regarding multiple effects.
  }
  \item{colnamesTexCmd}{A character string specifying a LaTeX command to be
    used to format column labels. The default, \code{NULL}, applies no command.
    It is possible to supply a vector of strings to format each column
    label differently. If column groups are not used, the first item in
    the vector will be used to format the title. Please note that if
    column groups are used the first item of \code{cgroupTexCmd} and not
    \code{colnamesTexCmd} is used to format the title. The user needs to allow for
    these issues when supplying a vector of commands.  See also
    \code{cgroupTexCmd} above regarding multiple effects.
  }
  \item{cellTexCmds}{A matrix of character strings which are LaTeX
    commands to be
    used to format each element, or cell, of the object.  The matrix
    must have the same \code{NROW()} and \code{NCOL()} as the object.  The default,
    NULL, applies no formats.  Empty strings also apply no formats, and
    one way to start might be to create a matrix of empty strings with
    \code{matrix(rep("", NROW(x) * NCOL(x)), nrow=NROW(x))} and then
    selectively change appropriate elements of the matrix.  Note that
    you might need to set \code{numeric.dollar=FALSE} (to disable math
    mode) for some effects to work. See also \code{cgroupTexCmd} above
    regarding multiple effects.
  }
  \item{na.blank}{
    Set to \code{TRUE} to use blanks rather than \code{NA} for missing values.
    This usually looks better in \code{latex}.
  }
  \item{insert.bottom}{
    an optional character string to typeset at the bottom of the table.
    For \code{"ctable"} style tables, this is placed in an unmarked footnote.
  }
  \item{insert.bottom.width}{
    character string; a tex width controlling the width of the
    insert.bottom text.  Currently only does something with using
    \code{longtable=TRUE}.
  }
	\item{insert.top}{a character string to insert as a heading right
		before beginning \code{tabular} environment.  Useful for multiple
		sub-tables.}
  \item{first.hline.double}{
    set to \code{FALSE} to use single horizontal rules for styles other than
    \code{"bookmark"} or \code{"ctable"}
  }
  \item{rowname}{
    rownames for \code{tabular} environment.  Default is rownames of matrix or
    data.frame.  Specify \code{rowname=NULL} to suppress the use of row names.
  }
  \item{cgroup.just}{
    justification for labels for column groups.  Defaults to \code{"c"}.
  }
  \item{colheads}{a character vector of column headings if you don't want
    to use \code{dimnames(object)[[2]]}.  Specify \code{colheads=FALSE} to
    suppress column headings.}
  \item{extracolheads}{
    an optional vector of extra column headings that will appear under the
    main headings (e.g., sample sizes).  This character vector does not
    need to include an empty space for any \code{rowname} in effect, as
    this will be added automatically.  You can also form subheadings by
    splitting character strings defining the column headings using the
    usual backslash \code{n} newline character.}
  \item{extracolsize}{
    size for \code{extracolheads} or for any second lines in column names;
    default is \code{"scriptsize"} 
  }
  \item{dcolumn}{see \code{\link{format.df}}}
  \item{numeric.dollar}{
    logical, default \code{!dcolumn}.  Set to \code{TRUE} to place dollar
    signs around numeric values when \code{dcolumn=FALSE}.  This 
    assures that \code{latex} will use minus signs rather than hyphens to indicate
    negative numbers.  Set to \code{FALSE} when \code{dcolumn=TRUE}, as
    \code{dcolumn.sty} automatically uses minus signs.
  }
  \item{math.row.names}{
    logical, set true to place dollar signs around the row names.
  }
	\item{already.math.row.names}{set to \code{TRUE} to prevent any math
		mode changes to row names}
  \item{math.col.names}{
    logical, set true to place dollar signs around the column names.
  }
	\item{already.math.col.names}{set to \code{TRUE} to prevent any math
		mode changes to column names}
	\item{hyperref}{if \code{table.env=TRUE} is a character string used to
  	generate a LaTeX \code{hyperref} enclosure}
	\item{continued}{a character string used to indicate pages after the
		first when making a long table}
  \item{cdot}{see \code{\link{format.df}}}
  \item{longtable}{
    Set to \code{TRUE} to use David Carlisle's LaTeX \code{longtable} style, allowing
    long tables to be split over multiple pages with headers repeated on
    each page.
    The \code{"style"} element is set to \code{"longtable"}. The \code{latex} \samp{\\usepackage}
    must reference \samp{[longtable]}.
    The file \file{longtable.sty} will
    need to be in a directory in your \env{TEXINPUTS} path.
  }
  \item{draft.longtable}{
    I forgot what this does.
  }
  \item{ctable}{
    set to \code{TRUE} to use Wybo Dekker's \samp{ctable} style from
    \acronym{CTAN}.  Even though for historical reasons it is not the
    default, it is generally the preferred method.  Thicker but not
    doubled \samp{\\hline}s are used to start a table when \code{ctable} is
    in effect.
  }
  \item{booktabs}{
    set \code{booktabs=TRUE} to use the \samp{booktabs} style of horizontal
    rules for better tables.  In this case, double \samp{\\hline}s are not
    used to start a table.
  }
  \item{table.env}{
    Set \code{table.env=FALSE} to suppress enclosing the table in a LaTeX
    \samp{table} environment.  \code{table.env} only applies when
    \code{longtable=FALSE}.  You may not specify a \code{caption} if
    \code{table.env=FALSE}.
  }
  \item{here}{
    Set to \code{TRUE} if you are using \code{table.env=TRUE} with \code{longtable=FALSE} and you
    have installed David Carlisle's \file{here.sty} LaTeX style. This will cause
    the LaTeX \samp{table} environment to be set up with option \samp{H} to guarantee
    that the table will appear exactly where you think it will in the text.
    The \code{"style"} element is set to \code{"here"}. The \code{latex} \samp{\\usepackage}
    must reference \samp{[here]}.  The file \file{here.sty} will
    need to be in a directory in your \env{TEXINPUTS} path.  \samp{here} is
    largely obsolete with LaTeX2e.
  }
  \item{lines.page}{
    Applies if \code{longtable=TRUE}. No more than \code{lines.page} lines in the body
    of a table will be placed on a single page. Page breaks will only
    occur at \code{rgroup} boundaries.
  }
  \item{caption}{
    a text string to use as a caption to print at the top of the first
    page of the table. Default is no caption.
  }
  \item{caption.lot}{
    a text string representing a short caption to be used in the \dQuote{List of Tables}.
    By default, LaTeX will use \code{caption}.  If you get inexplicable \samp{latex} errors,
    you may need to supply \code{caption.lot} to make the errors go away.
  }
  \item{caption.loc}{
    set to \code{"bottom"} to position a caption below
    the table instead of the default of \code{"top"}.
  }
  \item{star}{
    apply the star option for ctables to allow a table to spread over
    two columns when in twocolumn mode.
  }
  \item{double.slash}{
    set to \code{TRUE} to output \samp{"\\"} as \samp{"\\\\"} in LaTeX commands. Useful when you
    are reading the output file back into an S vector for later output.
  }
  \item{vbar}{
    logical. When \code{vbar==TRUE}, columns in the tabular environment are separated with
    vertical bar characters.  When \code{vbar==FALSE}, columns are separated with white
    space.  The default, \code{vbar==FALSE}, produces tables consistent with the style sheet
    for the Journal of the American Statistical Association.
  }
  \item{collabel.just}{
    justification for column labels.
  }
  \item{assignment}{
    logical.  When \code{TRUE}, the default, the name of the function
	and the assignment arrow are printed to the file.
  }
  \item{where}{
    specifies placement of floats if a table environment is used.  Default
    is \code{"!tbp"}.  To allow tables to appear in the middle of a page of
    text you might specify \code{where="!htbp"} to \code{latex.default}.
  }
  \item{size}{
    size of table text if a size change is needed (default is no change).
    For example you might specify \code{size="small"} to use LaTeX font size
    \dQuote{small}.  For \code{latex.function} is a character string
	that will be appended to \code{"Sinput"} such as \code{"small"}.
  }
  \item{center}{
    default is \code{"center"} to enclose the table in a \samp{center}
    environment.  Use \code{center="centering"} or \code{"centerline"}
		to instead use LaTeX 
    \samp{centering} or \code{centerline} directives, or
		\code{center="none"} to use no 
    centering.  \code{centerline} can be useful when objects besides a
		\code{tabular} are enclosed in a single \code{table} environment.
		This option was implemented by Markus J�ntti
    \email{markus.jantti@iki.fi} of Abo Akademi University.
  }
  \item{landscape}{
    set to \code{TRUE} to enclose the table in a \samp{landscape}
    environment.  When \code{ctable} is \code{TRUE}, will use the
    \code{rotate} argument to \code{ctable}.
  }
  \item{type}{
    The default uses the S \code{alltt} environment for \code{latex.function},
    Set \code{type="verbatim"} to instead use the LaTeX \samp{verbatim}
	environment.  Use \code{type="Sinput"} if using \code{Sweave},
	especially if you have customized the \code{Sinput} environment, for
	example using the \code{Sweavel} style which uses the
	\code{listings} LaTeX package.
  }
  \item{width.cutoff}{width of function text output in columns; see
	\code{deparse}}
  \item{\dots}{
    other arguments are accepted and ignored except that \code{latex}
    passes arguments to \code{format.df} (e.g., \code{col.just} and other
    formatting options like \code{dec}, \code{rdec}, and \code{cdec}).  For
    \code{latexVerbatim} these arguments are passed to the \code{print}
    function.  Ignored for \code{latexTranslate} and
		\code{htmlTranslate}.  For \code{htmlSN}, these arguments are passed
		to \code{prettyNum} or \code{format}.
  }
  \item{inn, out}{
    specify additional input and translated strings over the usual
    defaults
  }
  \item{pb}{
    If \code{pb=TRUE}, \code{latexTranslate} also translates \samp{[()]}
		to math mode using \samp{\\left, \\right}.
  }
  \item{greek}{set to \code{TRUE} to have \code{latexTranslate} put names
    for greek letters in math mode and add backslashes. For
		\code{htmlTranslate}, translates greek letters to corresponding html
	characters, ignoring "modes".}
	\item{na}{single character string to translate \code{NA} values to for
		\code{latexTranslate} and \code{htmlTranslate}}
	\item{code}{set to \code{'unicode'} to use HTML unicode characters
		or \code{'&'} to use the ampersand pound number format}
	\item{pretty}{set to \code{FALSE} to have \code{htmlSN} use
		\code{format} instead of \code{prettyNum}}
  \item{hspace}{
    horizontal space, e.g., extra left margin for verbatim text.  Default
    is none.  Use e.g. \code{hspace="10ex"} to add 10 extra spaces to the left
    of the text.
  }
  \item{length}{for S-Plus only; is the length of the output page for
    printing and capturing verbatim text}
  \item{width,height}{
    are the \code{options( )} to have in effect only for when \code{print} is
    executed.  Defaults are current \code{options}.  For \code{dvi} these specify
    the paper width and height in inches if \code{nomargins=TRUE}, with
    defaults of 5.5 and 7, respectively.
  }
  \item{prlog}{
    set to \code{TRUE} to have \code{dvi} print, to the S-Plus session, the LaTeX .log
    file.
  }
  \item{multicol}{
    set  to \code{FALSE} to not use \samp{\\multicolumn} in header
    of table
  }

  \item{nomargins}{
    set to \code{FALSE} to use default LaTeX margins when making the .dvi file
  }
}
\value{
  \code{latex} and \code{dvi} return a
  list of class \code{latex} or \code{dvi} containing character string
  elements \code{file} and \code{style}.  \code{file} contains the name of the
  generated file, and \code{style} is a vector (possibly empty) of styles to
  be included using the LaTeX2e \samp{\\usepackage} command.

  \code{latexTranslate} returns a vector of character strings
}

\section{Side Effects}{
  creates various system files and runs various Linux/UNIX system
  commands which are assumed to be in the system path.
}
\details{
	\command{latex.default} optionally outputs a LaTeX comment containing the calling
  statement.  To output this comment, run
  \command{options(omitlatexcom=FALSE)} before running.  The default behavior or suppressing the comment is helpful
  when running RMarkdown to produce pdf output using LaTeX, as this uses
  \command{pandoc} which is fooled into try to escape the percent
  comment symbol.
	
  If running under Windows and using MikTeX, \command{latex} and \command{yap}
  must be in your system path, and \command{yap} is used to browse
  \file{.dvi} files created by \command{latex}.  You should install the
  \file{geometry.sty} and \file{ctable.sty} styles in MikTeX to make optimum use
  of \code{latex()}.

  On Mac OS X, you may have to append the \file{/usr/texbin} directory to the
  system path.  Thanks to Kevin Thorpe
  (\email{kevin.thorpe@utoronto.ca}) one way to set up Mac OS X is
  to install \samp{X11} and \samp{X11SDK} if not already installed,
  start \samp{X11} within the R GUI, and issue the command
  \code{Sys.setenv( PATH=paste(Sys.getenv("PATH"),"/usr/texbin",sep=":")
  )}.  To avoid any complications of using \samp{X11} under MacOS, users
  can install the \samp{TeXShop} package, which will associate
  \file{.dvi} files with a viewer that displays a \file{pdf} version of
  the file after a hidden conversion from \file{dvi} to \file{pdf}.

  System options can be used to specify external commands to be used.
  Defaults are given by \code{options(xdvicmd='xdvi')} or
  \code{options(xdvicmd='yap')}, \code{options(dvipscmd='dvips')},
  \code{options(latexcmd='latex')}.  For MacOS specify
  \code{options(xdvicmd='MacdviX')} or if TeXShop is installed,
  \code{options(xdvicmd='open')}.
  
  To use \samp{pdflatex} rather than \samp{latex}, set
  \code{options(latexcmd='pdflatex')},
  \code{options(dviExtension='pdf')}, and set
  \code{options('xdvicmd')} to your chosen PDF previewer.

  If running S-Plus and your directory for temporary files is not
  \file{/tmp} (Unix/Linux) or \file{\\windows\\temp} (Windows), add your
  own \code{tempdir} function such as \code{
	tempdir <- function() "/yourmaindirectory/yoursubdirectory"}

  To prevent the latex file from being displayed store the result of
  \code{latex} in an object, e.g. \code{w <- latex(object, file='foo.tex')}.
}
\author{
  Frank E. Harrell, Jr.,\cr
  Department of Biostatistics,\cr
  Vanderbilt University,\cr
  \email{fh@fharrell.com}


  Richard M. Heiberger,\cr
  Department of Statistics,\cr
  Temple University, Philadelphia, PA.\cr
  \email{rmh@temple.edu}

  David R. Whiting,\cr
  School of Clinical Medical Sciences (Diabetes),\cr
  University of Newcastle upon Tyne, UK.\cr
  \email{david.whiting@ncl.ac.uk}

}
\seealso{
\code{\link{html}}, \code{\link{format.df}}, \code{\link[tools]{texi2dvi}}
}
\examples{
x <- matrix(1:6, nrow=2, dimnames=list(c('a','b'),c('c','d','this that')))
\dontrun{
latex(x)   # creates x.tex in working directory
# The result of the above command is an object of class "latex"
# which here is automatically printed by the latex print method.
# The latex print method prepends and appends latex headers and
# calls the latex program in the PATH.  If the latex program is
# not in the PATH, you will get error messages from the operating
# system.

w <- latex(x, file='/tmp/my.tex')
# Does not call the latex program as the print method was not invoked
print.default(w)
# Shows the contents of the w variable without attempting to latex it.

d <- dvi(w)  # compile LaTeX document, make .dvi
             # latex assumed to be in path
d            # or show(d) : run xdvi (assumed in path) to display
w            # or show(w) : run dvi then xdvi
dvips(d)     # run dvips to print document
dvips(w)     # run dvi then dvips
library(tools)
texi2dvi('/tmp/my.tex')   # compile and produce pdf file in working dir.
}
latex(x, file="")   # just write out LaTeX code to screen

\dontrun{
# Use paragraph formatting to wrap text to 3 in. wide in a column
d <- data.frame(x=1:2,
                y=c(paste("a",
                    paste(rep("very",30),collapse=" "),"long string"),
                "a short string"))
latex(d, file="", col.just=c("l", "p{3in}"), table.env=FALSE)
}

\dontrun{
# After running latex( ) multiple times with different special styles in
# effect, make a file that will call for the needed LaTeX packages when
# latex is run (especially when using Sweave with R)
if(exists(latexStyles))
  cat(paste('\\usepackage{',latexStyles,'}',sep=''),
      file='stylesused.tex', sep='\n')
# Then in the latex job have something like:
# \documentclass{article}
# \input{stylesused}
# \begin{document}
# ...
}
}
\keyword{utilities}
\keyword{interface}
\keyword{methods}
\keyword{file}
\keyword{character}
\keyword{manip}

\name{mChoice}
\alias{mChoice}
\alias{format.mChoice}
\alias{print.mChoice}
\alias{summary.mChoice}
\alias{as.character.mChoice}
\alias{as.double.mChoice}
\alias{inmChoice}
\alias{match.mChoice}
\alias{[.mChoice}
\alias{print.summary.mChoice}
\alias{is.mChoice}
\alias{Math.mChoice}
\alias{Ops.mChoice}
\alias{Summary.mChoice}
\title{Methods for Storing and Analyzing Multiple Choice Variables}
\description{
  \code{mChoice} is a function that is useful for grouping 
  variables that represent
  individual choices on a multiple choice question.  These choices are
  typically factor or character values but may be of any type.  Levels
  of component factor variables need not be the same; all unique levels
  (or unique character values) are collected over all of the multiple
  variables.  Then a new character vector is formed with integer choice
  numbers separated by semicolons.  Optimally, a database system would
  have exported the semicolon-separated character strings with a
  \code{levels} attribute containing strings defining value labels
  corresponding to the integer choice numbers.  \code{mChoice} is a
  function for creating a multiple-choice variable after the fact.
  \code{mChoice} variables are explicitly handed by the \code{describe}
  and \code{summary.formula} functions. \code{NA}s or blanks in input
  variables are ignored. 

  \code{format.mChoice} will convert the multiple choice representation
  to text form by substituting \code{levels} for integer codes.
  \code{as.double.mChoice} converts the \code{mChoice} object to a
  binary numeric matrix, one column per used level (or all levels of
  \code{drop=FALSE}.  This is called by
  the user by invoking \code{as.numeric}.  There is a
  \code{print} method and a \code{summary} method, and a \code{print}
  method for the \code{summary.mChoice} object.  The \code{summary}
  method computes frequencies of all two-way choice combinations, the
  frequencies of the top 5 combinations, information about which other
  choices are present when each given choice is present, and the
  frequency distribution of the number of choices per observation.  This
  \code{summary} output is used in the \code{describe} function.

  \code{in.mChoice} creates a logical vector the same length as \code{x}
  whose elements are \code{TRUE} when the observation in \code{x}
  contains at least one of the codes or value labels in the second
  argument.

  \code{match.mChoice} creats an integer vector of the indexes of all
  elements in \code{table} which contain any of the speicified levels

  \code{is.mChoice} returns \code{TRUE} is the argument is a multiple
  choice variable.
}
\usage{
mChoice(\dots, label='',
        sort.levels=c('original','alphabetic'), 
        add.none=FALSE, drop=TRUE)

\method{format}{mChoice}(x, minlength=NULL, sep=";", \dots)

\method{as.double}{mChoice}(x, drop=FALSE, ...)

\method{print}{mChoice}(x, quote=FALSE, max.levels=NULL,
       width=getOption("width"), ...)

\method{as.character}{mChoice}(x, ...)

\method{summary}{mChoice}(object, ncombos=5, minlength=NULL, drop=TRUE, ...)

\method{print}{summary.mChoice}(x, prlabel=TRUE, ...)

\method{[}{mChoice}(x, ..., drop=FALSE)

match.mChoice(x, table, nomatch=NA, incomparables=FALSE)

inmChoice(x, values)

is.mChoice(x)

\method{Summary}{mChoice}(..., na.rm)
}
\arguments{
  \item{na.rm}{
    Logical: remove \code{NA}'s from data
  }
  \item{table}{
    a vector (mChoice) of values to be matched against.
  }
  \item{nomatch}{
    value to return if a value for \code{x} does not exist in
    \code{table}.
  }
  \item{incomparables}{
    logical whether incomparable values should be compaired.
  }
  \item{...}{
    a series of vectors
  }
  \item{label}{
    a character string \code{label} attribute to attach to the matrix created
    by \code{mChoice}
  }
  \item{sort.levels}{
    set \code{sort.levels="alphabetic"} to sort the columns of the matrix
    created by \code{mChoice} alphabetically by category rather than by the
    original order of levels in component factor variables (if there were
    any input variables that were factors)
  }
  \item{add.none}{
    Set \code{add.none} to \code{TRUE} to make a new category
    \code{'none'} if it doesn't already exist and if there is an
    observations with no choices selected.
  }
  \item{drop}{
    set \code{drop=FALSE} to keep unused factor levels as columns of the matrix
    produced by \code{mChoice}
  }
  \item{x}{
    an object of class \code{"mchoice"} such as that created by
    \code{mChoice}.  For \code{is.mChoice} is any object.
  }
  \item{object}{
    an object of class \code{"mchoice"} such as that created by
    \code{mChoice}
  }
  \item{ncombos}{
    maximum number of combos.
  }
  \item{width}{
    With of a line of text to be formated
  }
  \item{quote}{
    quote the output
  }
  \item{max.levels}{max levels to be displayed}
  \item{minlength}{
    By default no abbreviation of levels is done in
    \code{format} and \code{summary}.  Specify a positive integer to use
    abbreviation in those functions.  See \code{\link{abbreviate}}.
  }
  \item{sep}{
    character to use to separate levels when formatting
  }
  \item{prlabel}{
    set to \code{FALSE} to keep
    \code{print.summary.mChoice} from printing the variable label and
    number of unique values
  }
  \item{values}{
    a scalar or vector.  If \code{values} is integer, it is
    the choice codes, and if it is a character vector, it is assumed to
    be value labels.
  }
}
\value{
  \code{mChoice} returns a character vector of class \code{"mChoice"}
  plus attributes \code{"levels"} and \code{"label"}.
  \code{summary.mChoice} returns an object of class
  \code{"summary.mChoice"}.  \code{inmChoice} returns a logical vector.
  \code{format.mChoice} returns a character vector, and
  \code{as.double.mChoice} returns a binary numeric matrix.
}
\author{
  Frank Harrell
  \cr
  Department of Biostatistics
  \cr
  Vanderbilt University
  \cr
  \email{fh@fharrell.com}
}
\seealso{
  \code{\link{label}}, \code{\link{combplotp}}
}
\examples{
options(digits=3)
set.seed(3)
n <- 20
sex <- factor(sample(c("m","f"), n, rep=TRUE))
age <- rnorm(n, 50, 5)
treatment <- factor(sample(c("Drug","Placebo"), n, rep=TRUE))


# Generate a 3-choice variable; each of 3 variables has 5 possible levels
symp <- c('Headache','Stomach Ache','Hangnail',
          'Muscle Ache','Depressed')
symptom1 <- sample(symp, n, TRUE)
symptom2 <- sample(symp, n, TRUE)
symptom3 <- sample(symp, n, TRUE)
cbind(symptom1, symptom2, symptom3)[1:5,]
Symptoms <- mChoice(symptom1, symptom2, symptom3, label='Primary Symptoms')
Symptoms
print(Symptoms, long=TRUE)
format(Symptoms[1:5])
inmChoice(Symptoms,'Headache')
levels(Symptoms)
inmChoice(Symptoms, 3)
inmChoice(Symptoms, c('Headache','Hangnail'))
# Note: In this example, some subjects have the same symptom checked
# multiple times; in practice these redundant selections would be NAs
# mChoice will ignore these redundant selections

meanage <- N <- numeric(5)
for(j in 1:5) {
 meanage[j] <- mean(age[inmChoice(Symptoms,j)])
 N[j] <- sum(inmChoice(Symptoms,j))
}
names(meanage) <- names(N) <- levels(Symptoms)
meanage
N

# Manually compute mean age for 2 symptoms
mean(age[symptom1=='Headache' | symptom2=='Headache' | symptom3=='Headache'])
mean(age[symptom1=='Hangnail' | symptom2=='Hangnail' | symptom3=='Hangnail'])

summary(Symptoms)

#Frequency table sex*treatment, sex*Symptoms
summary(sex ~ treatment + Symptoms, fun=table)
# Check:
ma <- inmChoice(Symptoms, 'Muscle Ache')
table(sex[ma])

# could also do:
# summary(sex ~ treatment + mChoice(symptom1,symptom2,symptom3), fun=table)

#Compute mean age, separately by 3 variables
summary(age ~ sex + treatment + Symptoms)


summary(age ~ sex + treatment + Symptoms, method="cross")

f <- summary(treatment ~ age + sex + Symptoms, method="reverse", test=TRUE)
f
# trio of numbers represent 25th, 50th, 75th percentile
print(f, long=TRUE)
}
\keyword{category}
\keyword{manip}
\concept{multiple choice}

\name{rcspline.plot}
\alias{rcspline.plot}
\title{
  Plot Restricted Cubic Spline Function
}
\description{
  Provides plots of the estimated restricted cubic spline function
  relating a single predictor to the response for a logistic or Cox
  model. The \code{rcspline.plot} function does not allow for
  interactions as do \code{\link[rms]{lrm}} and \code{\link[rms]{cph}}, but it can
  provide detailed output for checking spline fits. This function uses
  the \code{\link{rcspline.eval}}, \code{\link[rms]{lrm.fit}}, and Therneau's
  \code{\link[survival:survival-internal]{coxph.fit}} functions and plots the estimated spline
  regression and confidence limits, placing summary statistics on the
  graph. If there are no adjustment variables, \code{rcspline.plot} can
  also plot two alternative estimates of the regression function when
  \code{model="logistic"}: proportions or logit proportions on grouped
  data, and a nonparametric estimate. The nonparametric regression
  estimate is based on smoothing the binary responses and taking the
  logit transformation of the smoothed estimates, if desired. The
  smoothing uses \code{\link{supsmu}}.
}
\usage{
rcspline.plot(x,y,model=c("logistic", "cox", "ols"), xrange, event, nk=5,
              knots=NULL, show=c("xbeta","prob"), adj=NULL, xlab, ylab,
              ylim, plim=c(0,1), plotcl=TRUE, showknots=TRUE, add=FALSE,
              subset, lty=1, noprint=FALSE, m, smooth=FALSE, bass=1,
              main="auto", statloc)
}
\arguments{
  \item{x}{
    a numeric predictor
  }
  \item{y}{
    a numeric response. For binary logistic regression, \code{y} should
    be either 0 or 1.
  }
  \item{model}{
    \code{"logistic"} or \code{"cox"}. For \code{"cox"}, uses the
    \code{coxph.fit} function with \code{method="efron"} arguement set.
  }
  \item{xrange}{
    range for evaluating \code{x}, default is f and
    \eqn{1 - f} quantiles of \code{x}, where
    \eqn{f = \frac{10}{\max{(n, 200)}}}{f = 10/max(n, 200)}
  }
  \item{event}{
    event/censoring indicator if \code{model="cox"}. If \code{event} is
    present, \code{model} is assumed to be \code{"cox"}
  }
  \item{nk}{
    number of knots
  }
  \item{knots}{
    knot locations, default based on quantiles of \code{x} (by
    \code{\link{rcspline.eval}}) 
  }
  \item{show}{
    \code{"xbeta"} or \code{"prob"} - what is plotted on \verb{y}-axis
  }
  \item{adj}{
    optional matrix of adjustment variables
  }
  \item{xlab}{
    \verb{x}-axis label, default is the \dQuote{label} attribute of
    \code{x} 
  }
  \item{ylab}{
    \verb{y}-axis label, default is the \dQuote{label} attribute of
    \code{y}
  }
  \item{ylim}{
    \verb{y}-axis limits for logit or log hazard
  }
  \item{plim}{
    \verb{y}-axis limits for probability scale
  }
  \item{plotcl}{
    plot confidence limits
  }
  \item{showknots}{
    show knot locations with arrows
  }
  \item{add}{
    add this plot to an already existing plot
  }
  \item{subset}{
    subset of observations to process, e.g. \code{sex == "male"}
  }
  \item{lty}{
    line type for plotting estimated spline function
  }
  \item{noprint}{
    suppress printing regression coefficients and standard errors
  }
  \item{m}{
    for \code{model="logistic"}, plot grouped estimates with
    triangles. Each group contains \code{m} ordered observations on
    \code{x}.
  }
  \item{smooth}{
    plot nonparametric estimate if \code{model="logistic"} and
    \code{adj} is not specified
  }
  \item{bass}{
    smoothing parameter (see \code{supsmu})
  }
  \item{main}{
    main title, default is \code{"Estimated Spline Transformation"}
  }
  \item{statloc}{
    location of summary statistics. Default positioning by clicking left
    mouse button where upper left corner of statistics should
    appear. Alternative is \code{"ll"} to place below the graph on the
    lower left, or the actual \code{x} and \code{y} coordinates. Use
    \code{"none"} to suppress statistics.
  }
}
\value{
  list with components (\samp{knots}, \samp{x}, \samp{xbeta},
  \samp{lower}, \samp{upper}) which are respectively the knot locations,
  design matrix, linear predictor, and lower and upper confidence limits
}
\author{
  Frank Harrell  \cr
  Department of Biostatistics, Vanderbilt University  \cr
  \email{fh@fharrell.com}
}
\seealso{
  \code{\link[rms]{lrm}}, \code{\link[rms]{cph}}, \code{\link{rcspline.eval}},
  \code{\link[graphics]{plot}}, \code{\link{supsmu}},
  \code{\link[survival:survival-internal]{coxph.fit}},
  \code{\link[rms]{lrm.fit}}
}
\examples{
#rcspline.plot(cad.dur, tvdlm, m=150)
#rcspline.plot(log10(cad.dur+1), tvdlm, m=150)
}
\keyword{regression}
\keyword{models}

\name{latexTabular}
\alias{latexTabular}
\title{Convert a Data Frame or Matrix to a LaTeX Tabular}
\description{
\code{latexTabular} creates a character vector representing a matrix or
data frame in a simple \samp{tabular} environment.
}
\usage{
latexTabular(x, headings=colnames(x),
             align =paste(rep('c',ncol(x)),collapse=''),
             halign=paste(rep('c',ncol(x)),collapse=''),
             helvetica=TRUE, translate=TRUE, hline=0, center=FALSE, \dots)
}
\arguments{
  \item{x}{a matrix or data frame, or a vector that is automatically
		converted to a matrix}
  \item{headings}{a vector of character strings specifying column
		headings for \samp{latexTabular}, defaulting to \code{x}'s
	\code{colnames}.  To make multi-line headers use the newline character
	inside elements of \code{headings}.}
  \item{align}{a character strings specifying column
		alignments for \samp{latexTabular}, defaulting to
		\code{paste(rep('c',ncol(x)),collapse='')} to center.  You may
		specify \code{align='c|c'} and other LaTeX tabular formatting.}
  \item{halign}{a character strings specifying alignment for
		column headings, defaulting to centered.}
  \item{helvetica}{set to \code{FALSE} to use default LaTeX font in
		\samp{latexTabular} instead of helvetica.}
	\item{translate}{set to \code{FALSE} if column headings and table
		entries are already in
		LaTeX format, otherwise \code{latexTabular} will run them through
		\code{latexTranslate}}
	\item{hline}{set to 1 to put \code{hline} after heading, 2 to also put
		\code{hline}s before and after heading and at table end}
	\item{center}{set to \code{TRUE} to enclose the tabular in a LaTeX
		\code{center} environment}
	\item{\dots}{if present, \code{x} is run through \code{format.df} with
		those extra arguments}
  }
\value{a character string containing LaTeX markup}
\author{
  Frank E. Harrell, Jr.,\cr
  Department of Biostatistics,\cr
  Vanderbilt University,\cr
  \email{fh@fharrell.com}
}
\seealso{
\code{\link{latex.default}}, \code{\link{format.df}}
}
\examples{
x <- matrix(1:6, nrow=2, dimnames=list(c('a','b'),c('c','d','this that')))
latexTabular(x)   # a character string with LaTeX markup
}
\keyword{utilities}
\keyword{interface}
\keyword{methods}
\keyword{file}
\keyword{character}
\keyword{manip}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ebpcomp.r
\name{spikecomp}
\alias{spikecomp}
\title{spikecomp}
\usage{
spikecomp(
  x,
  method = c("tryactual", "simple", "grid"),
  lumptails = 0.01,
  normalize = TRUE,
  y,
  trans = NULL,
  tresult = c("list", "segments", "roundeddata")
)
}
\arguments{
\item{x}{a numeric variable}

\item{method}{specifies the binning and output method.  The default is \code{'tryactual'} and is intended to be used for spike histograms plotted in a way that allows for random x-coordinates and data gaps.  No binning is done if there are less than 100 distinct values and the closest distinct \code{x} values are distinguishable (not with 1/500th of the data range of each other).  Binning uses \code{pretty}.  When \code{trans} is specified to transform \code{x} to reduce long tails due to outliers, \code{pretty} rounding is not done, and \code{lumptails} is ignored.  \code{method='grid'} is intended for sparkline spike histograms drawn with bar charts, where plotting is done in a way that x-coordinates must be equally spaced.  For this method, extensive binning information is returned.  For either \code{'tryactual'} or \code{'grid'}, the default if \code{trans} is omitted is to put all values beyond the 0.01 or 0.99 quantiles into a single bin so that outliers will not create long nearly empty tails.  When \code{y} is specified, \code{method} is ignored.}

\item{lumptails}{the quantile to use for lumping values into a single left and a single right bin for two of the methods.  When outer quantiles using \code{lumptails} equal outer quantiles using \code{2*lumptails}, \code{lumptails} is ignored as this indicates a large number of ties in the tails of the distribution.}

\item{normalize}{set to \code{FALSE} to not divide frequencies by maximum frequency}

\item{y}{a vector of frequencies corresponding to \code{x} if you want the (\code{x}, \code{y}) pairs to be taken as a possibly irregular-spaced frequency tabulation for which you want to convert to a regularly-spaced tabulation like \code{count='tabulate'} produces.  If there is a constant gap between \code{x} values, the original pairs are return, with possible removal of \code{NA}s.}

\item{trans}{a list with three elements: the name of a transformation to make on \code{x}, the transformation function, and the inverse transformation function.  The latter is used for \code{method='grid'}.  When \code{trans} is given \code{lumptails} is ignored.  \code{trans} applies only to \code{method='tryactual'}.}

\item{tresult}{applies only to \code{method='tryactual'}.  The default \code{'list'} returns a list with elements \code{x}, \code{y}, and \code{roundedTo}.  \code{method='segments'} returns a list suitable for drawing line segments, with elements \verb{x, y1, y2}.  \code{method='roundeddata'} returns a list with elements \code{x} (non-tabulated rounded data vector after excluding \code{NA}s) and vector \code{roundedTo}.}
}
\value{
when \code{y} is specified, a list with elements \code{x} and \code{y}.  When \code{method='tryactual'} the returned value depends on \code{tresult}.  For \code{method='grid'}, a list with elements \code{x} and \code{y} and scalar element \code{roundedTo} containing the typical bin width.  Here \code{x} is a character string.
}
\description{
Compute Elements of a Spike Histogram
}
\details{
Derives the line segment coordinates need to draw a spike histogram.  This is useful for adding elements to \code{ggplot2} plots and for the \code{describe} function to construct spike histograms.  Date/time variables are handled by doing calculations on the underlying numeric scale then converting back to the original class.  For them the left endpoint of the first bin is taken as the minimal data value instead of rounded using \code{pretty()}.
}
\examples{
spikecomp(1:1000)
spikecomp(1:1000, method='grid')
\dontrun{
On a data.table d use ggplot2 to make spike histograms by country and sex groups
s <- d[, spikecomp(x, tresult='segments'), by=.(country, sex)]
ggplot(s) + geom_segment(aes(x=x, y=y1, xend=x, yend=y2, alpha=I(0.3))) +
   scale_y_continuous(breaks=NULL, labels=NULL) + ylab('') +
   facet_grid(country ~ sex)
}
}
\author{
Frank Harrell
}

\name{makeNstr}
\alias{makeNstr}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ creates a string that is a repeat of a substring }
\description{
Takes a character and creates a string that is the character repeated \code{len} times.
}
\usage{
makeNstr(char, len)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{char}{ character to be repeated }
  \item{len}{ number of times to repeat \code{char}. }
}
\value{
  A string that is \code{char} repeated \code{len} times.
}
\author{ Charles Dupont }
\seealso{ \code{\link[base]{paste}}, \code{\link[base]{rep}} }
\examples{
makeNstr(" ", 5)

\dontshow{
if(makeNstr(" ", 5) != "     ") stop("makeNstr failed test")
}
}
\keyword{ manip }% at least one, from doc/KEYWORDS
\keyword{ character }% __ONLY ONE__ keyword per line
\concept{string}
\concept{concat}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runParallel.r
\name{runParallel}
\alias{runParallel}
\title{runParallel}
\usage{
runParallel(
  onecore,
  reps,
  seed = round(runif(1, 0, 10000)),
  cores = max(1, parallel::detectCores() - 1),
  simplify = TRUE,
  along
)
}
\arguments{
\item{onecore}{function to run the analysis on one core}

\item{reps}{total number of repetitions}

\item{seed}{species the base random number seed.  The seed used for core i will be \code{seed} + \code{i}.}

\item{cores}{number of cores to use, defaulting to one less than the number available}

\item{simplify}{set to FALSE to not create an outer list if a \code{onecore} result has only one element}

\item{along}{see Details}
}
\value{
result from combining all the parallel runs, formatting as similar to the result produced from one run as possible
}
\description{
parallel Package Easy Front-End
}
\details{
Given a function \code{onecore} that runs the needed set of simulations on
one CPU core, and given a total number of repetitions \code{reps}, determines
the number of available cores and by default uses one less than that.
By default the number of cores is one less than the number available
on your machine.
reps is divided as evenly as possible over these cores, and batches
are run on the cores using the \code{parallel} package \code{mclapply} function.
The current per-core repetition number is continually updated in
your system's temporary directory (/tmp for Linux and Mac, TEMP for Windows)
in a file name progressX.log where X is the core number.
The random number seed is set for each core and is equal to
the scalar \code{seed} - core number + 1.  The default seed is a random
number between 0 and 10000 but it's best if the user provides the
seed so the simulation is reproducible.
The total run time is computed and printed
onefile must create a named list of all the results created during
that one simulation batch.  Elements of this list must be data frames,
vectors, matrices, or arrays.   Upon completion of all batches,
all the results are rbind'd and saved in a single list.

onecore must have an argument \code{reps} that will tell the function
how many simulations to run for one batch, another argument \code{showprogress}
which is a function to be called inside onecore to write to the
progress file for the current core and repetition, and an argument \code{core}
which informs \code{onecore} which sequential core number (batch number) it is
processing.
When calling \code{showprogress} inside \code{onecore}, the arguments, in order,
must be the integer value of the repetition to be noted, the number of reps,
\code{core}, an optional 4th argument \code{other} that can contain a single
character string to add to the output, and an optional 5th argument \code{pr}.
You can set \code{pr=FALSE} to suppress printing and have \code{showprogress}
return the file name for holding progress information if you want to
customize printing.

If any of the objects appearing as list elements produced by onecore
are multi-dimensional arrays, you must specify an integer value for
\code{along}.  This specifies to the \code{abind} package \code{abind} function
the dimension along which to bind the arrays.  For example, if the
first dimension of the array corresponding to repetitions, you would
specify along=1.   All arrays present must use the same \code{along} unless
\code{along} is a named vector and the names match elements of the
simulation result object.
Set \code{simplify=FALSE} if you don't want the result simplified if
onecore produces only one list element.  The default returns the
first (and only) list element rather than the list if there is only one
element.

When \code{onecore} returns a \code{data.table}, \code{runParallel} simplifies all this and merely
rbinds all the per-core data tables into one large data table.  In that case when you
have \code{onecore} include a column containing a simulation number, it is wise to prepend
that number with the core number so that you will have unique simulation IDs when
all the cores' results are combined.

See \href{https://hbiostat.org/rflow/parallel.html}{here} for examples.
}
\author{
Frank Harrell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qcrypt.r
\name{qcrypt}
\alias{qcrypt}
\title{qcrypt}
\usage{
qcrypt(obj, base, service = "R-keyring-service", file, pw)
}
\arguments{
\item{obj}{an R object to write to disk and encrypt (if \code{base} is specified) or the base file name to read and uncrypted (if \code{base} is not specified).  Not used when \code{file} is given.}

\item{base}{base file name when creating a file.  Not used when \code{file} is given.}

\item{service}{a fairly arbitrary \code{keyring} service name.  The default is almost always OK unless you need to use different passwords for different files.  \code{service} is ignored if \code{pw} is specified as an argument.}

\item{file}{full name of file to encrypt or decrypt}

\item{pw}{a single character string containing an actual password}
}
\value{
(invisibly) the full encrypted file name if writing the file, or the restored R object if reading the file.  When decrypting a general file with \verb{file=}, the returned value is the full path to a temporary file containing the decrypted data.
}
\description{
Store and Encrypt R Objects or Files or Read and Decrypt Them
}
\details{
\code{qcrypt} is used to protect sensitive information on a user's computer or when transmitting a copy of the file to another R user.  Unencrypted information only exists for a moment, and the encryption password does not appear in the user's script but instead is managed by the \code{keyring} package to remember the password across R sessions, and the \code{getPass} package, which pops up a password entry window and does not allow the password to be visible.  The password is requested only once, except perhaps when the user logs out of their operating system session or reboots.

The keyring can be bypassed and the password entered in a popup window by specifying \code{service=NA}.  This is the preferred approach when sending an encrypted file to a user on a different computer.

\code{qcrypt} writes R objects to disk in a temporary file using the \code{qs} package \code{qsave} function.  The file is quickly encrypted using the \code{safer} package, and the temporary unencrypted \code{qs} file is deleted.  When reading an encrypted file the process is reversed.

To save an object in an encrypted file, specify the object as the first argument \code{obj} and specify a base file name as a character string in the second argument \code{base}.  The full \code{qs} file name will be of the form \code{base.qs.encrypted} in the user's current working directory.  To unencrypt the file into a short-lived temporary file and use \code{qs::qread} to read it, specify the base file name as a character string with the first argument, and do not specify the \code{base} argument.

Alternatively, \code{qcrypt} can be used to encrypt or decrypt existing files of any type using the same password and keyring mechanism.  The former is done by specifying \code{file} that does not end in \code{'.encrypted'} and the latter is done by ending \code{file} with \code{'.encrypted'}.  When \code{file} does not contain a path it is assumed to be in the current working directory.  When a file is encrypted the original file is removed.  Files are decrypted into a temporary directory created by \code{tempdir()}, with the name of the file being the value of \code{file} with \code{'.encrypted'} removed.

Interactive password provision works when running \code{R}, \code{Rscript}, \code{RStudio}, or \code{Quarto} but does not work when running \verb{R CMD BATCH}.  \code{getPass} fails under \code{RStudio} on Macs.

It is also possible to pass the password as the \code{pw} argument.  This is only safe if running interactively and the password is defined by typing e.g. \code{pw <- 'whateverpassword'} in the console, then running the script interactively with \code{pw=pw} added to the \code{qcrypt} call.

See \href{https://hbiostat.org/rflow/fcreate.html#sec-fcreate-secure}{R Workflow} for more information.
}
\examples{
\dontrun{
# Suppose x is a data.table or data.frame
# The first time qcrypt is run with a service a password will
# be requested.  It will be remembered across sessions thanks to
# the keyring package
qcrypt(x, 'x')   # creates x.qs.encrypted in current working directory
x <- qcrypt('x') # unencrypts x.qs.encrypted into a temporary
                 # directory, uses qs::qread to read it, and
                 # stores the result in x
# Encrypt a general file using a different password
qcrypt(file='report.pdf', service='pdfkey')
# Decrypt that file
fi <- qcrypt(file='report.pdf.encrypted', service='pdfkey')
fi contains the full unencrypted file name which is in a temporary directory
# Encrypt without using a keyring
qcrypt(x, 'x', service=NA)
x <- qcrypt('x', service=NA)

pw <- 'somepassword'     # run this in the console
x <- qcrypt('x', pw=pw)  # interactively run this in a script
}
}
\author{
Frank Harrell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simMarkovOrd.r
\name{intMarkovOrd}
\alias{intMarkovOrd}
\title{Compute Parameters for Proportional Odds Markov Model}
\usage{
intMarkovOrd(
  y,
  times,
  initial,
  absorb = NULL,
  intercepts,
  extra = NULL,
  g,
  target,
  t,
  ftarget = NULL,
  onlycrit = FALSE,
  constraints = NULL,
  printsop = FALSE,
  ...
)
}
\arguments{
\item{y}{vector of possible y values in order (numeric, character, factor)}

\item{times}{vector of measurement times}

\item{initial}{initial value of \code{y} (baseline state; numeric, character, or factor matching \code{y}).  If length 1 this value is used for all subjects, otherwise it is a vector of length \code{n}.}

\item{absorb}{vector of absorbing states, a subset of \code{y} (numeric, character, or factor matching \code{y}).  The default is no absorbing states.  Observations are truncated when an absorbing state is simulated.}

\item{intercepts}{vector of initial guesses for the intercepts}

\item{extra}{an optional vector of intial guesses for other parameters passed to \code{g} such as regression coefficients for previous states and for general time trends.  Name the elements of \code{extra} for more informative output.}

\item{g}{a user-specified function of three or more arguments which in order are \code{yprev} - the value of \code{y} at the previous time, the current time \code{t}, the \code{gap} between the previous time and the current time, an optional (usually named) covariate vector \code{X}, and optional arguments such as a regression coefficient value to simulate from.  The function needs to allow \code{yprev} to be a vector and \code{yprev} must not include any absorbing states.  The \code{g} function returns the linear predictor for the proportional odds model aside from \code{intercepts}.  The returned value must be a matrix with row names taken from \code{yprev}.  If the model is a proportional odds model, the returned value must be one column.  If it is a partial proportional odds model, the value must have one column for each distinct value of the response variable Y after the first one, with the levels of Y used as optional column names.  So columns correspond to \code{intercepts}. The different columns are used for \code{y}-specific contributions to the linear predictor (aside from \code{intercepts}) for a partial or constrained partial proportional odds model.  Parameters for partial proportional odds effects may be included in the ... arguments.}

\item{target}{vector of target state occupancy probabilities at time \code{t}.  If \code{extra} is specified, \code{target} must be a matrix where row names are character versions of \code{t} and columns represent occupancy probabilities corresponding to values of \code{y} at the time given in the row.}

\item{t}{target times.  Can have more than one element only if \code{extra} is given.}

\item{ftarget}{an optional function defining constraints that relate to transition probabilities.  The function returns a penalty which is a sum of absolute differences in probabilities from target probabilities over possibly multiple targets.  The \code{ftarget} function must have two arguments: \code{intercepts} and \code{extra}.}

\item{onlycrit}{set to \code{TRUE} to only return the achieved objective criterion and not print anything}

\item{constraints}{a function of two arguments: the vector of current intercept values and the vector of \code{extra} parameters, returning \code{TRUE} if that vector meets the constrains and \code{FALSE} otherwise}

\item{printsop}{set to \code{TRUE} to print solved-for state occupancy probabilities for groups 1 and 2}

\item{...}{optional arguments to pass to \code{\link[stats:nlm]{stats::nlm()}}.  If this is specified, the arguments that \code{intMarkovOrd} normally sends to \code{nlm} are not used.}
}
\value{
list containing two vectors named \code{intercepts} and \code{extra} unless \code{oncrit=TRUE} in which case the best achieved sum of absolute errors is returned
}
\description{
Given a vector \code{intercepts} of initial guesses at the intercepts in a Markov proportional odds model, and a vector \code{extra} if there are other parameters, solves for the \code{intercepts} and \code{extra} vectors that yields a set of occupancy probabilities at time \code{t} that equal, as closely as possible, a vector of target values.
}
\seealso{
\url{https://hbiostat.org/R/Hmisc/markov/}
}
\author{
Frank Harrell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hashCheck.r
\name{hashCheck}
\alias{hashCheck}
\title{hashCheck}
\usage{
hashCheck(..., file, .print. = TRUE, .names. = NULL)
}
\arguments{
\item{...}{a list of objects including data frames, vectors, functions, and all other types of R objects that represent dependencies of a certain calculation}

\item{file}{name of file in which results are stored}

\item{.print.}{set to \code{FALSE} to suppress printing information messages about what has changed}

\item{.names.}{vector of names of original arguments if not calling \code{hashCheck} directly}
}
\value{
a \code{list} with elements \code{result} (the computations), \code{hash} (the new hash), and \code{changed} which details what changed to make computations need to be run
}
\description{
Check for Changes in List of Objects
}
\details{
Given an RDS file name and a list of objects, does the following:
\itemize{
\item makes a vector of hashes, one for each object.  Function objects are run through \code{deparse} so that the environment of the function will not be considered.
\item see if the file exists; if not, return a list with result=NULL, \code{hash} = new vector of hashes, \code{changed='All'}
\item if the file exists, read the file and its hash attribute as \code{prevhash}
\item if \code{prevhash} is not identical to hash:
if \code{.print.=TRUE} (default), print to console a summary of what's changed
return a list with result=NULL, \code{hash} = new hash vector, changed
\item if \code{prevhash = hash}, return a list with result=file object, \code{hash}=new hash,  changed=''
}

Set \code{options(debughash=TRUE)} to trace results in \verb{/tmp/debughash.txt}
}
\author{
Frank Harrell
}

\name{summaryP}
\alias{summaryP}
\alias{plot.summaryP}
\alias{ggplot.summaryP}
\alias{latex.summaryP}
\title{Multi-way Summary of Proportions}
\description{
	\code{summaryP} produces a tall and thin data frame containing
	numerators (\code{freq}) and denominators (\code{denom}) after
	stratifying the data by a series of variables.  A special capability
	to group a series of related yes/no variables is included through the
	use of the \code{\link{ynbind}} function, for which the user specials a final
	argument \code{label} used to label the panel created for that group
	of related variables.
	
	If \code{options(grType='plotly')} is not in effect,
	the \code{plot} method for \code{summaryP}	displays proportions as a
	multi-panel dot chart using the \code{lattice} package's \code{dotplot}
	function with a special \code{panel} function.  Numerators and
	denominators of proportions are also included as text, in the same
	colors as used by an optional \code{groups} variable.  The
	\code{formula} argument used in the \code{dotplot} call is constructed,
	but the user can easily reorder the variables by specifying
	\code{formula}, with elements named \code{val} (category levels),
	\code{var} (classification variable name), \code{freq} (calculated
	result) plus the overall cross-classification variables excluding
	\code{groups}.  If \code{options(grType='plotly')} is in effect, the
	\code{plot} method makes an entirely different display using
	\code{Hmisc::dotchartpl} with code{plotly} if \code{marginVal} is
	specified, whereby a stratification
	variable causes more finely stratified estimates to be shown slightly
	below the lines, with smaller and translucent symbols if \code{data}
	has been run through \code{addMarginal}.  The marginal summaries are
	shown as the main estimates and the user can turn off display of the
	stratified estimates, or view their details with hover text.

	The \code{ggplot} method for \code{summaryP} does not draw numerators
	and denominators but the chart is more compact than using the
	\code{plot} method with base graphics because \code{ggplot2}
	does not repeat category names the same way as \code{lattice} does.
	Variable names that are too long to fit in panel strips are renamed
	(1), (2), etc. and an attribute \code{"fnvar"} is added to the result;
	this attribute is a character string defining the abbreviations,
	useful in a figure caption.  The \code{ggplot2} object has
	\code{label}s for points plotted, used by \code{plotly::ggplotly} as
	hover text (see example).

	The \code{latex} method produces one or more LaTeX \code{tabular}s
	containing a table representation of the result, with optional
	side-by-side display if \code{groups} is specified.  Multiple
	\code{tabular}s result from the presence of non-group stratification
	factors.
}
\usage{
summaryP(formula, data = NULL, subset = NULL,
         na.action = na.retain, sort=TRUE,
         asna = c("unknown", "unspecified"), \dots)
\method{plot}{summaryP}(x, formula=NULL, groups=NULL,
         marginVal=NULL, marginLabel=marginVal,
         refgroup=NULL, exclude1=TRUE,  xlim = c(-.05, 1.05),
         text.at=NULL, cex.values = 0.5,
         key = list(columns = length(groupslevels), x = 0.75,
                    y = -0.04, cex = 0.9,
                    col = trellis.par.get('superpose.symbol')$col,
                    corner=c(0,1)),
         outerlabels=TRUE, autoarrange=TRUE,
         col=colorspace::rainbow_hcl, \dots)
\method{ggplot}{summaryP}(data, mapping, groups=NULL, exclude1=TRUE,
           xlim=c(0, 1), col=NULL, shape=NULL, size=function(n) n ^ (1/4),
           sizerange=NULL, abblen=5, autoarrange=TRUE, addlayer=NULL,
           \dots, environment)
\method{latex}{summaryP}(object, groups=NULL, exclude1=TRUE, file='', round=3,
                           size=NULL, append=TRUE, \dots)
}
\arguments{
  \item{formula}{a formula with the variables for whose levels
		proportions are computed on the left hand side, and major
		classification variables on the right.  The formula need to include
		any variable later used as \code{groups}, as the data summarization
		does not distinguish between superpositioning and paneling.  For the
	plot method, \code{formula} can provide an overall to the default
	formula for \code{dotplot()}.}
  \item{data}{an optional data frame.  For \code{ggplot.summaryP}
	  \code{data} is the result of \code{summaryP}.}
  \item{subset}{an optional subsetting expression or vector}
  \item{na.action}{function specifying how to handle \code{NA}s.  The
		default is to keep all \code{NA}s in the analysis frame.}
  \item{sort}{set to \code{FALSE} to not sort category levels in
		descending order of global proportions}
  \item{asna}{character vector specifying level names to consider the
		same as \code{NA}.  Set \code{asna=NULL} to not consider any.}
	\item{x}{an object produced by \code{summaryP}}
  \item{groups}{a character string containing the name of a
   	superpositioning variable for obtaining 
		further stratification within a horizontal line in the dot chart.}
	\item{marginVal}{if \code{options(grType='plotly')} is in effect and
	the data given to \code{summaryP} were run through \code{addMarginal},
	specifies the category name that represents marginal summaries
	(usually \code{"All"}).}
  \item{marginLabel}{specifies a different character string to use than
	the value of \code{marginVal}.  For example, if marginal proportions
	were computed over all \code{region}s, one may specify
	\code{marginVal="All", marginLabel="All Regions"}.  \code{marginLabel}
	is only used for formatting graphical output.}
  \item{refgroup}{used when doing a \code{plotly} chart and a two-level
	 group variable was used, resulting in the half-width confidence
  	interval for the difference in two proportions to be shown, and the
		actual confidence limits and the difference added to hover text.  See
	\code{dotchartpl} for more details.}
  \item{exclude1}{By default, \code{ggplot}, \code{plot}, and
	\code{latex} methods for \code{summaryP} remove redundant entries 
		from tables for variables with only two levels.  For example, if you
		print the proportion of females, you don't need to print the
		proportion of males.  To override this, set \code{exclude1=FALSE}.}
  \item{xlim}{\code{x}-axis limits.  Default is \code{c(0,1)}.}
	\item{text.at}{specify to leave unused space to the right of each
	panel to prevent numerators and denominators from touching data
	points.  \code{text.at} is the upper limit for scaling panels'
	\code{x}-axes but tick marks are only labeled up to \code{max(xlim)}.}
  \item{cex.values}{character size to use for plotting numerators and
		denominators}
  \item{key}{a list to pass to the \code{auto.key} argument of
		\code{dotplot}.  To place a key above the entire chart use
		\code{auto.key=list(columns=2)} for example.}
	\item{outerlabels}{by default if there are two conditioning variables
		besides \code{groups}, the \code{latticeExtra} package's
		\code{useOuterStrips} function is used to put strip labels in the
		margins, usually resulting in a much prettier chart.  Set to
		\code{FALSE} to prevent usage of \code{useOuterStrips}.}
	\item{autoarrange}{If \code{TRUE}, the formula is re-arranged so that
 	 if there are two conditioning (paneling) variables, the variable with
	 the most levels is taken as the vertical condition.}
 \item{col}{a vector of colors to use to override defaults in
	 \code{ggplot}.  When \code{options(grType='plotly')}, see \code{dotchartpl}.}
 \item{shape}{a vector of plotting symbols to override \code{ggplot}
	 defaults}
 \item{mapping, environment}{not used; needed because of rules for generics}
 \item{size}{for \code{ggplot}, a function that transforms denominators
	into metrics used for the \code{size} aesthetic.  Default is the
	fourth root function so that the area of symbols is proportional to
	the square root of sample size.  Specify \code{NULL} to not vary point
	sizes. 	\code{size=sqrt} is a reasonable 	alternative.  Set
	\code{size} to an integer to categorize the denominators into
	\code{size} quantile groups using \code{cut2}. Unless \code{size} is
	an integer, the legend for sizes uses the minimum and maximum
	denominators and 6-tiles using \code{quantile(..., type=1)} so that
	actually occurring sample sizes are used as labels.  \code{size} is
	overridden to \code{NULL} if the range in denominators is less than 10
	or the ratio of the maximum to the minimum is less than 1.2.
	For	\code{latex}, \code{size} is an optional font size such as
	\code{"small"}}  
 \item{sizerange}{a 2-vector specifying the \code{range} argument to the
	\code{ggplot2} \code{scale_size_...} function, which is the
	range of sizes allowed for the points according to the denominator.
	The default is \code{sizerange=c(.7, 3.25)} but the lower limit is
	increased according to the ratio of maximum to minimum sample sizes.}
 \item{abblen}{labels of variables having only one level and having
	their name longer than \code{abblen} characters are 
	abbreviated and documented in \code{fnvar} (described elsewhere
	here).  The default \code{abblen=5} is good for labels plotted
	vertically.  If labels are rotated using \code{theme} a better value
	would be 12.}
 \item{\dots}{used only for \code{plotly} graphics and these arguments
	are passed to \code{dotchartpl}}
 \item{object}{an object produced by \code{summaryP}}
 \item{file}{file name, defaults to writing to console}
 \item{round}{number of digits to the right of the decimal place for
	 proportions}
 \item{append}{set to \code{FALSE} to start output over}
 \item{addlayer}{a \code{ggplot} layer to add to the plot object}
}
\value{\code{summaryP} produces a data frame of class
	\code{"summaryP"}.  The \code{plot} method produces a \code{lattice}
	object of class \code{"trellis"}.  The \code{latex} method produces an
	object of class \code{"latex"} with an additional attribute
	\code{ngrouplevels} specifying the number of levels of any
	\code{groups} variable and an attribute \code{nstrata} specifying the
	number of strata.
	}
\author{Frank Harrell
  \cr
  Department of Biostatistics
  \cr
  Vanderbilt University
  \cr
  \email{fh@fharrell.com}}
\seealso{\code{\link{bpplotM}}, \code{\link{summaryM}},
	\code{\link{ynbind}}, \code{\link{pBlock}},
	\code{\link[ggplot2]{ggplot}}, \code{\link{colorFacet}}
}
\examples{
n <- 100
f <- function(na=FALSE) {
  x <- sample(c('N', 'Y'), n, TRUE)
  if(na) x[runif(100) < .1] <- NA
  x
}
set.seed(1)
d <- data.frame(x1=f(), x2=f(), x3=f(), x4=f(), x5=f(), x6=f(), x7=f(TRUE),
                age=rnorm(n, 50, 10),
                race=sample(c('Asian', 'Black/AA', 'White'), n, TRUE),
                sex=sample(c('Female', 'Male'), n, TRUE),
                treat=sample(c('A', 'B'), n, TRUE),
                region=sample(c('North America','Europe'), n, TRUE))
d <- upData(d, labels=c(x1='MI', x2='Stroke', x3='AKI', x4='Migraines',
                 x5='Pregnant', x6='Other event', x7='MD withdrawal',
                 race='Race', sex='Sex'))
dasna <- subset(d, region=='North America')
with(dasna, table(race, treat))
s <- summaryP(race + sex + ynbind(x1, x2, x3, x4, x5, x6, x7, label='Exclusions') ~
              region + treat, data=d)
# add exclude1=FALSE below to include female category
plot(s, groups='treat')
ggplot(s, groups='treat')

plot(s, val ~ freq | region * var, groups='treat', outerlabels=FALSE)
# Much better looking if omit outerlabels=FALSE; see output at
# https://hbiostat.org/R/Hmisc/summaryFuns.pdf
# See more examples under bpplotM

## For plotly interactive graphic that does not handle variable size
## panels well:
## require(plotly)
## g <- ggplot(s, groups='treat')
## ggplotly(g, tooltip='text')

## For nice plotly interactive graphic:
## options(grType='plotly')
## s <- summaryP(race + sex + ynbind(x1, x2, x3, x4, x5, x6, x7,
##                                   label='Exclusions') ~
##               treat, data=subset(d, region='Europe'))
##
## plot(s, groups='treat', refgroup='A')  # refgroup='A' does B-A differences


# Make a chart where there is a block of variables that
# are only analyzed for males.  Keep redundant sex in block for demo.
# Leave extra space for numerators, denominators
sb <- summaryP(race + sex +
               pBlock(race, sex, label='Race: Males', subset=sex=='Male') ~
               region, data=d)
plot(sb, text.at=1.3)
plot(sb, groups='region', layout=c(1,3), key=list(space='top'),
     text.at=1.15)
ggplot(sb, groups='region')
\dontrun{
plot(s, groups='treat')
# plot(s, groups='treat', outerlabels=FALSE) for standard lattice output
plot(s, groups='region', key=list(columns=2, space='bottom'))
colorFacet(ggplot(s))

plot(summaryP(race + sex ~ region, data=d), exclude1=FALSE, col='green')

# Make your own plot using data frame created by summaryP
useOuterStrips(dotplot(val ~ freq | region * var, groups=treat, data=s,
        xlim=c(0,1), scales=list(y='free', rot=0), xlab='Fraction',
        panel=function(x, y, subscripts, ...) {
          denom <- s$denom[subscripts]
          x <- x / denom
          panel.dotplot(x=x, y=y, subscripts=subscripts, ...) }))

# Show marginal summary for all regions combined
s <- summaryP(race + sex ~ region, data=addMarginal(d, region))
plot(s, groups='region', key=list(space='top'), layout=c(1,2))

# Show marginal summaries for both race and sex
s <- summaryP(ynbind(x1, x2, x3, x4, label='Exclusions', sort=FALSE) ~
              race + sex, data=addMarginal(d, race, sex))
plot(s, val ~ freq | sex*race)
}
}
\keyword{hplot}
\keyword{category}
\keyword{manip}
\concept{grouping}
\concept{stratification}
\concept{aggregation}
\concept{cross-classification}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hidingTOC.r
\name{hidingTOC}
\alias{hidingTOC}
\title{Moving and Hiding Table of Contents}
\usage{
hidingTOC(
  buttonLabel = "Contents",
  levels = 3,
  tocSide = c("right", "left"),
  buttonSide = c("right", "left"),
  posCollapse = c("margin", "top", "bottom"),
  hidden = FALSE
)
}
\arguments{
\item{buttonLabel}{the text on the button that hides and unhides the
table of contents. Defaults to \code{Contents}.}

\item{levels}{the max depth of the table of contents that it is desired to
have control over the display of.  (defaults to 3)}

\item{tocSide}{which side of the page should the table of contents be placed
on. Can be either \code{'right'} or \code{'left'}. Defaults to
\code{'right'}}

\item{buttonSide}{which side of the page should the button that hides the TOC
be placed on. Can be either \code{'right'} or \code{'left'}. Defaults to
\code{'right'}}

\item{posCollapse}{if \code{'margin'} then display the depth select buttons
vertically along the side of the page choosen by \code{buttonSide}. If
\code{'top'} then display the depth select buttons horizontally under the
button that hides the TOC. Defaults to \code{'margin'}. \code{'bottom'} is
currently unimplemented.}

\item{hidden}{Logical should the table of contents be hidden at page load
Defaults to \code{FALSE}}
}
\value{
a HTML formated text string to be inserted into an markdown document
}
\description{
Moving and hiding table of contents for Rmd HTML documents
}
\details{
\code{hidingTOC} creates a table of contents in a Rmd document that
can be hidden at the press of a button. It also generate buttons that allow
the hiding or unhiding of the diffrent level depths of the table of contents.
}
\examples{
\dontrun{
hidingTOC()
}
}
\author{
Thomas Dupont
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dualSD.r
\name{dualSD}
\alias{dualSD}
\title{Dual Standard Deviations}
\usage{
dualSD(x, na.rm = FALSE, nmin = 10, center = xbar)
}
\arguments{
\item{x}{a numeric vector}

\item{na.rm}{set to \code{TRUE} to find any \code{NA} values and remove them before computing SDs.}

\item{nmin}{the minimum number of non-\code{NA} obesrvations that must be present for two SDs to be computed.  If the mumber of non-missing values falls below \code{nmin}, the regular SD is duplicated in the result.}

\item{center}{center point for making the two subsets.  The sample mean is used to compute the two SDs no matter what is specified for \code{center}.}
}
\value{
a 2-vector of SDs with names \code{bottom} and \code{top}
}
\description{
Computes one standard deviation for the lower half of the distribution of a numeric vector and another SD for the upper half.  By default the center of the distribution for purposes of splitting into "halves" is the mean.  The user may override this with \code{center}.  When splitting into halves, observations equal to the \code{center} value are included in both subsets.
}
\details{
The purpose of dual SDs is to describe variability for asymmetric distributions.  Symmetric distributions are also handled, though slightly less efficiently than a single SD does.
}
\examples{
set.seed(1)
x <- rnorm(20000)
sd(x)
dualSD(x)
y <- exp(x)
s1 <- sd(y)
s2 <- dualSD(y)
s1
s2
quantile(y, c(0.025, 0.975))
mean(y) + 1.96 * c(-1, 1) * s1
mean(y) + 1.96 * c(- s2['bottom'], s2['top'])
c(mean=mean(y), pseudomedian=pMedian(y), median=median(y))
}
\seealso{
\code{\link[=pMedian]{pMedian()}}
}
\author{
Frank Harrell
}

\name{approxExtrap}
\alias{approxExtrap}
\title{Linear Extrapolation}
\description{
  Works in conjunction with the \code{\link{approx}} function to do linear
  extrapolation.  \code{\link{approx}} in R does not support extrapolation at
  all, and it is buggy in S-Plus 6. 
}
\usage{
approxExtrap(x, y, xout, method = "linear", n = 50, rule = 2, f = 0,
             ties = "ordered", na.rm = FALSE)
}
\arguments{
  \item{x,y,xout,method,n,rule,f}{
    see \code{\link{approx}}
  }
  \item{ties}{
    applies only to R.  See \code{\link{approx}}
  }
  \item{na.rm}{
    set to \code{TRUE} to remove \code{NA}s in \code{x} and
    \code{y} before proceeding
  }
}
\details{
  Duplicates in \code{x} (and corresponding \code{y} elements) are removed
  before using \code{approx}.
}
\value{
  a vector the same length as \code{xout}
}
\author{Frank Harrell}
\seealso{\code{\link{approx}}}
\examples{
approxExtrap(1:3,1:3,xout=c(0,4))
}
\keyword{arith}
\keyword{dplot}

\name{na.detail.response}
\alias{na.detail.response}
\title{
Detailed Response Variable Information
}
\description{
This function is called by certain \code{na.action} functions if
\code{options(na.detail.response=TRUE)} is set.  By default, this function
returns a matrix of counts of non-NAs and the mean of the response variable
computed separately by whether or not each predictor is NA.  The default
action uses the last column of a \code{Surv} object, in effect computing the
proportion of events.  Other summary functions may be specified by
using \code{options(na.fun.response="name of function")}.
}
\usage{
na.detail.response(mf)
}
\arguments{
\item{mf}{
a model frame
}}
\value{
a matrix, with rows representing the different statistics that are
computed for the response, and columns representing the different
subsets for each predictor (NA and non-NA value subsets).
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\seealso{
\code{\link{na.omit}}, \code{\link{na.delete}}, \code{\link{model.frame.default}}, 
\code{\link{naresid}}, \code{\link{naprint}}, \code{\link{describe}}
}
\examples{
# sex
# [1] m f f m f f m m m m m m m m f f f m f m
# age
# [1] NA 41 23 30 44 22 NA 32 37 34 38 36 36 50 40 43 34 22 42 30
# y
# [1] 0 1 0 0 1 0 1 0 0 1 1 1 0 0 1 1 0 1 0 0
# options(na.detail.response=TRUE, na.action="na.delete", digits=3)
# lrm(y ~ age*sex)
#
# Logistic Regression Model
# 
# lrm(formula = y ~ age * sex)
#
#
# Frequencies of Responses
#   0 1 
#  10 8
#
# Frequencies of Missing Values Due to Each Variable
#  y age sex 
#  0   2   0
#
#
# Statistics on Response by Missing/Non-Missing Status of Predictors
#
#     age=NA age!=NA sex!=NA Any NA  No NA 
#   N    2.0  18.000   20.00    2.0 18.000
# Mean    0.5   0.444    0.45    0.5  0.444
#
# \dots\dots
# options(na.action="na.keep")
# describe(y ~ age*sex)
# Statistics on Response by Missing/Non-Missing Status of Predictors
#
#      age=NA age!=NA sex!=NA Any NA  No NA 
#    N    2.0  18.000   20.00    2.0 18.000
# Mean    0.5   0.444    0.45    0.5  0.444
#
# \dots
# options(na.fun.response="table")  #built-in function table()
# describe(y ~ age*sex)
#
# Statistics on Response by Missing/Non-Missing Status of Predictors
#
#   age=NA age!=NA sex!=NA Any NA No NA 
# 0      1      10      11      1    10
# 1      1       8       9      1     8
#
# \dots
}
\keyword{models}
\keyword{regression}
% Converted by Sd2Rd version 1.21.

\name{Misc}
\alias{clowess}
\alias{confbar}
\alias{getLatestSource}
\alias{grType}
\alias{prType}
\alias{htmlSpecialType}
\alias{inverseFunction}
\alias{james.stein}
\alias{keepHattrib}
\alias{km.quick}
\alias{latexBuild}
\alias{lm.fit.qr.bare}
\alias{matxv}
\alias{makeSteps}
\alias{nomiss}
\alias{outerText}
\alias{plotlyParm}
\alias{plotp}
\alias{rendHTML}
\alias{restoreHattrib}
\alias{sepUnitsTrans}
\alias{strgraphwrap}
\alias{tobase64image}
\alias{trap.rule}
\alias{trellis.strip.blank}
\alias{unPaste}
\alias{whichClosest}
\alias{whichClosePW}
\alias{whichClosek}
\alias{xless}
\title{Miscellaneous Functions}
\description{
  This documents miscellaneous small functions in Hmisc that may be of
  interest to users.

  \code{clowess} runs \code{lowess} but if the \code{iter} argument
  exceeds zero, sometimes wild values can result, in which case
  \code{lowess} is re-run with \code{iter=0}.
  
  \code{confbar} draws multi-level confidence bars using small rectangles
  that may be of different colors.

  \code{getLatestSource} fetches and \code{source}s the most recent
  source code for functions in GitHub.

  \code{grType} retrieves the system option \code{grType}, which is
  forced to be \code{"base"} if the \code{plotly} package is not
  installed.

	\code{prType} retrieves the system option \code{prType}, which is
	set to \code{"plain"} if the option is not set.  \code{print} methods
	that allow for markdown/html/latex can be automatically invoked by
	setting \code{options(prType="html")} or
	\code{options(prType='latex')}.

	\code{htmlSpecialType} retrieves the system option
	\code{htmlSpecialType}, which is set to \code{"unicode"} if the option
	is not set.  \code{htmlSpecialType='unicode'} cause html-generating
	functions in \code{Hmisc} and \code{rms} to use unicode for special
	characters, and \code{htmlSpecialType='&'} uses the older ampersand
	3-digit format. 

  \code{inverseFunction} generates a function to find all inverses of a
  monotonic or nonmonotonic function that is tabulated at vectors (x,y),
  typically 1000 points.  If the original function is monotonic, simple linear
  interpolation is used and the result is a vector, otherwise linear
  interpolation is used within each interval in which the function is
  monotonic and the result is a matrix with number of columns equal to the
  number of monotonic intervals.  If a requested y is not within any
  interval, the extreme x that pertains to the nearest extreme y is
  returned. Specifying what='sample' to the returned function will cause a
  vector to be returned instead of a matrix, with elements taken as a
  random choice of the possible inverses.

  \code{james.stein} computes James-Stein shrunken estimates of cell
  means given a response variable (which may be binary) and a grouping
  indicator.

	\code{keepHattrib} for an input variable or a data frame, creates a
	list object saving special Hmisc attributes such as \code{label} and
	\code{units} that might be lost during certain operations such as
	running \code{data.table}.  \code{restoreHattrib} restores these attributes.

  \code{km.quick} provides a fast way to invoke \code{survfitKM} in the
  \code{survival} package to efficiently get Kaplan-Meier or Fleming-Harrington estimates for a
  single stratum for a vector of time points (if \code{times} is given) or to
  get a vector of survival time quantiles (if \code{q} is given).  If neither is given,
  the whole curve is returned in a list with objects \code{time} and \code{surv}, and
  there is an option to consider an interval as pertaining to greater than or equal
  to a specific time instead of the traditional greater than.  If the censoring is not 
  right censoring, the more general \code{survfit} is called by \code{km.quick}.

	\code{latexBuild} takes pairs of character strings and produces a
	single character string containing concatenation of all of them, plus
	an attribute \code{"close"} which is a character string containing the
	LaTeX closure that will balance LaTeX code with respect to
	parentheses, braces, brackets, or \code{begin} vs. \code{end}.  When
	an even-numbered element of the vector is not a left parenthesis,
	brace, or bracket, the element is taken as a word that was surrounded
	by \code{begin} and braces, for which the corresponding \code{end} is
	constructed in the returned attribute.

  \code{lm.fit.qr.bare} is a fast stripped-down function for computing
  regression coefficients, residuals, \eqn{R^2}, and fitted values.  It
  uses \code{lm.fit}. 

  \code{matxv} multiplies a matrix by a vector, handling automatic
  addition of intercepts if the matrix does not have a column of ones.
  If the first argument is not a matrix, it will be converted to one.
  An optional argument allows the second argument to be treated as a
  matrix, useful when its rows represent bootstrap reps of
  coefficients.  Then ab' is computed.  \code{matxv} respects the
  \code{"intercepts"} attribute if it is stored on \code{b} by the
  \code{rms} package.  This is used by \code{\link[rms]{orm}}
  fits that are bootstrap-repeated by \code{\link[rms]{bootcov}} where
  only the intercept corresponding to the median is retained.  If
  \code{kint} has nonzero length, it is checked for consistency with the
  attribute.

  \code{makeSteps} is a copy of the dostep function inside the
  \code{survival} package's \code{plot.survfit} function.  It expands a
  series of points to include all the segments needed to plot step
  functions.  This is useful for drawing polygons to shade confidence
  bands for step functions.

  \code{nomiss} returns a data frame (if its argument is one) with rows
  corresponding to \code{NA}s removed, or it returns a matrix with rows
  with any element missing removed.

  \code{outerText} uses \code{axis()} to put right-justified text
  strings in the right margin.  Placement depends on
  \code{par('mar')[4]}

	\code{plotlyParm} is a list of functions useful for specifying
	parameters to \code{plotly} graphics.

	\code{plotp} is a generic to handle \code{plotp} methods to make
	\code{plotly} graphics.

	\code{rendHTML} renders HTML in a character vector, first converting
	to one character string with newline delimeters.  If \code{knitr} is
	currently running, runs this string through \code{knitr::asis_output}
	so that the user need not include \code{results='asis'} in the chunk
	header for R Markdown or Quarto.  If \code{knitr} is not running, uses
	\code{htmltools::browsable} and \code{htmltools::HTML} and prints the
	result so that an RStudio viewer (if running inside RStudio) or
	separate browser window displays the rendered HTML.  The HTML code is
	surrounded by yaml markup to make Pandoc not fiddle with the HTML.
	Set the argument \code{html=FALSE} to not add this, in case you are
	really rendering markdown.  \code{html=FALSE} also invokes
	\code{rmarkdown::render} to convert the character vector to HTML
	before using \code{htmltools} to view, assuming the characters
	represent RMarkdown/Quarto text other than the YAML header.  If
	\code{options(rawmarkup=TRUE)} is in effect, \code{rendHTML} will just
	\code{cat()} its first argument.  This is useful when rendering is
	happening inside a Quarto margin, for example.
	
  \code{sepUnitsTrans} converts character vectors containing values such
  as \code{c("3 days","3day","4month","2 years","2weeks","7")} to
  numeric vectors 
  (here \code{c(3,3,122,730,14,7)}) in a flexible fashion.  The user can
  specify a 
  vector of units of measurements and conversion factors.  The units
  with a conversion factor of \code{1} are taken as the target units,
  and if those units are present in the character strings they are
  ignored.  The target units are added to the resulting vector as the
  \code{"units"} attribute.

  \code{strgraphwrap} is like \code{strwrap} but is for the current
  graphics environment.

	\code{tobase64image} is a function written by Dirk Eddelbuettel that
  uses the \code{base64enc} package to convert a png graphic file to
  base64 encoding to include as an inline image in an html file.
	
  \code{trap.rule} computes the area under a curve using the trapezoidal
  rule, assuming \code{x} is sorted.

  \code{trellis.strip.blank} sets up Trellis or Lattice graphs to have a
  clear background on the strips for panel labels.
  
  \code{unPaste} provides a version of the S-Plus \code{unpaste} that
  works for \R and S-Plus.

  \code{whichClosePW} is a very fast function using weighted multinomial
  sampling to determine which element of a vector is "closest" to each
  element of another vector.  \code{whichClosest} quickly finds the closest
  element without any randomness.

  \code{whichClosek} is a slow function that finds, after jittering the
  lookup table, the \code{k} closest matchest to each element of the
  other vector, and chooses from among these one at random.

  \code{xless} is a function for Linux/Unix users to invoke the system
  \code{xless} command to pop up a window to display the result of
  \code{print}ing an object.  For MacOS \code{xless} uses the system \code{open} command to pop up a \code{TextEdit} window.
}
\usage{
confbar(at, est, se, width, q = c(0.7, 0.8, 0.9, 0.95, 0.99), 
        col = gray(c(0, 0.25, 0.5, 0.75, 1)),
        type = c("v", "h"), labels = TRUE, ticks = FALSE,
        cex = 0.5, side = "l", lwd = 5, clip = c(-1e+30, 1e+30),
        fun = function(x) x,
        qfun = function(x) ifelse(x == 0.5, qnorm(x),
                            ifelse(x < 0.5, qnorm(x/2),
                            qnorm((1 +  x)/2))))
getLatestSource(x=NULL, package='Hmisc', recent=NULL, avail=FALSE)
grType()
prType()
htmlSpecialType()
inverseFunction(x, y)
james.stein(y, group)
keepHattrib(obj)
km.quick(S, times, q,
        type = c("kaplan-meier", "fleming-harrington", "fh2"),
        interval = c(">", ">="), method=c('constant', 'linear'), fapprox=0, n.risk=FALSE)
latexBuild(\dots, insert, sep='')
lm.fit.qr.bare(x, y, tolerance, intercept=TRUE, xpxi=FALSE, singzero=FALSE)
matxv(a, b, kint=1, bmat=FALSE)
nomiss(x)
outerText(string, y, cex=par('cex'), \dots)
plotlyParm
plotp(data, ...)
rendHTML(x, html=TRUE)
restoreHattrib(obj, attribs)
sepUnitsTrans(x, conversion=c(day=1, month=365.25/12, year=365.25, week=7),
              round=FALSE, digits=0)
strgraphwrap(x, width = 0.9 * getOption("width"),
             indent = 0, exdent = 0,
             prefix = "", simplify = TRUE, units='user', cex=NULL)
tobase64image(file, Rd = FALSE, alt = "image")
trap.rule(x, y)
trellis.strip.blank()
unPaste(str, sep="/")
whichClosest(x, w)
whichClosePW(x, w, f=0.2)
whichClosek(x, w, k)
xless(x, \dots, title)
}
\arguments{
  \item{a}{a numeric matrix or vector}
	\item{alt,Rd}{see \code{base64::img}}
  \item{at}{x-coordinate for vertical confidence intervals, y-coordinate
		for horizontal}
	\item{attribs}{an object returned by \code{keepHattrib}}
  \item{avail}{set to \code{TRUE} to have \code{getLatestSource} return
	a data frame of available files and latest versions instead of
	fetching any}
  \item{b}{a numeric vector}
  \item{cex}{character expansion factor}
  \item{clip}{interval to truncate limits}
  \item{col}{vector of colors}
  \item{conversion}{a named numeric vector}
	\item{data}{an object having a \code{plotp} method}
  \item{digits}{number of digits used for \code{round}}
  \item{est}{vector of point estimates for confidence limits}
  \item{f}{a scaling constant}
	\item{file}{a file name}
  \item{fun}{function to transform scale}
  \item{group}{a categorical grouping variable}
	\item{html}{set to \code{FALSE} to tell \code{rendHTML} to not
  surround HTML code with yaml}
	\item{insert}{a list of 3-element lists for \code{latexBuild}.
		The first of each 3-element
		list is a character string with an environment name.  The second
		specifies the order: \code{"before"} or \code{"after"}, the former
		indicating that when the environment is found, the third element of
		the list is inserted before or after it, according to the second
		element.}
  \item{intercept}{set to \code{FALSE} to not automatically add a column
	of ones to the \code{x} matrix}
  \item{k}{get the \code{k} closest matches}
  \item{kint}{which element of \code{b} to add to the result if \code{a}
		does not contain a column for intercepts}
	\item{bmat}{set to \code{TRUE} to consider \code{b} a matrix of
		repeated coefficients, usually resampled estimates with rows
		corresponding to resamples}
  \item{labels}{set to \code{FALSE} to omit drawing confidence
	coefficients}
  \item{lwd}{line widths}
  \item{package}{name of package for \code{getLatestSource}, default is
		\code{'Hmisc'}}
	\item{obj}{a variable, data frame, or data table}
  \item{q}{vector of confidence coefficients or quantiles}
  \item{qfun}{quantiles on transformed scale}
  \item{recent}{an integer telling \code{getLatestSource} to get the
	\code{recent} most recently modified files from the package}
  \item{round}{set to \code{TRUE} to round converted values}
  \item{S}{a \code{\link[survival]{Surv}} object}
  \item{se}{vector of standard errors}
  \item{sep}{a single character string specifying the delimiter.  For
		\code{latexBuild} the default is \code{""}.}
  \item{side}{for \code{confbar} is \code{"b","l","t","r"} for bottom,
	left, top, right.}
  \item{str}{a character string vector}
  \item{string}{a character string vector}
  \item{ticks}{set to \code{TRUE} to draw lines between rectangles}
  \item{times}{a numeric vector of times}
  \item{title}{a character string to title a window or plot.  Ignored for \code{xless} under MacOs.}
  \item{tolerance}{tolerance for judging singularity in matrix}
  \item{type}{\code{"v"} for vertical, \code{"h"} for horizontal. 
  For \code{km.quick} specifies the type of survival estimator.}
  \item{w}{a numeric vector}
  \item{width}{width of confidence rectanges in user units, or see
	\code{\link{strwrap}}} 
  \item{x}{a numeric vector (matrix for \code{lm.fit.qr.bare}) or data
	frame.  For \code{xless} may be any object that is sensible to
	\code{print}.  For \code{sepUnitsTrans} is a character or factor
	variable.  For \code{getLatestSource} is a character string or
	vector of character strings containing base file names to retrieve
	from CVS.  Set \code{x='all'} to retrieve all source files.  For
	\code{clowess}, \code{x} may also be a list with x and y
	components.  For \code{inverseFunction}, \code{x} and \code{y}
	contain evaluations of the function whose inverse is needed.
	\code{x} is typically an equally-spaced grid of 1000 points.  For
	\code{strgraphwrap} is a character vector.  For \code{rendHTML}
  \code{x} is a character vector.}
  \item{xpxi}{set to \code{TRUE} to add an element to the result
		containing the inverse of \eqn{X'X}}
	\item{singzero}{set to \code{TRUE} to set coefficients corresponding
		to singular variables to zero instead of \code{NA}.}
  \item{y}{a numeric vector.  For \code{inverseFunction} \code{y} is the
	evaluated function values at \code{x}.}
  \item{indent, exdent, prefix}{see \code{\link{strwrap}}}
  \item{simplify}{see \code{\link{sapply}}}
  \item{units}{see \code{\link{par}}}
  \item{interval}{specifies whether to deal with probabilities of exceeding a value
  (the default) or of exceeding or equalling the value}
  \item{method,fapprox}{see \code{approx}}
  \item{n.risk}{set to \code{TRUE} to include the number at risk in the result}
  \item{\dots}{arguments passed through to another function.  For
		\code{latexBuild} represents pairs, with odd numbered elements being
		character strings containing LaTeX code or a zero-length object to
		ignore, and even-numbered elements representing LaTeX left
		parenthesis, left brace, or left bracket, or environment name.}
}
\author{Frank Harrell and Charles Dupont}
\examples{


trap.rule(1:100,1:100)

unPaste(c('a;b or c','ab;d','qr;s'), ';')

sepUnitsTrans(c('3 days','4 months','2 years','7'))

set.seed(1)
whichClosest(1:100, 3:5)
whichClosest(1:100, rep(3,20))

whichClosePW(1:100, rep(3,20))
whichClosePW(1:100, rep(3,20), f=.05)
whichClosePW(1:100, rep(3,20), f=1e-10)

x <- seq(-1, 1, by=.01)
y <- x^2
h <- inverseFunction(x,y)
formals(h)$turns   # vertex
a <- seq(0, 1, by=.01)
plot(0, 0, type='n', xlim=c(-.5,1.5))
lines(a, h(a)[,1])            ## first inverse
lines(a, h(a)[,2], col='red') ## second inverse
a <- c(-.1, 1.01, 1.1, 1.2)
points(a, h(a)[,1])

d <- data.frame(x=1:2, y=3:4, z=5:6)
d <- upData(d, labels=c(x='X', z='Z lab'), units=c(z='mm'))
a <- keepHattrib(d)

d <- data.frame(x=1:2, y=3:4, z=5:6)
d2 <- restoreHattrib(d, a)
sapply(d2, attributes)

\dontrun{
getLatestSource(recent=5)  # source() most recent 5 revised files in Hmisc
getLatestSource('cut2')    # fetch and source latest cut2.s
getLatestSource('all')     # get everything
getLatestSource(avail=TRUE) # list available files and latest versions
}
}
\keyword{programming}
\keyword{utilities}
\keyword{iplot}

\name{all.is.numeric}
\alias{all.is.numeric}
\title{Check if All Elements in Character Vector are Numeric}
\description{
Tests, without issuing warnings, whether all elements of a character
vector are legal numeric values, or optionally converts the vector to a
numeric vector.  Leading and trailing blanks in \code{x} are ignored.
}
\usage{
all.is.numeric(x, what = c("test", "vector"), extras=c('.','NA'))
}
\arguments{
  \item{x}{a character vector}
  \item{what}{specify \code{what="vector"} to return a numeric vector if
	it passes the test, or the original character vector otherwise}
  \item{extras}{a vector of character strings to count as numeric
	values, other than \code{""}.}
}
\value{a logical value if \code{what="test"} or a vector otherwise}
\author{Frank Harrell}
\seealso{\code{\link{as.numeric}}}
\examples{
all.is.numeric(c('1','1.2','3'))
all.is.numeric(c('1','1.2','3a'))
all.is.numeric(c('1','1.2','3'),'vector')
all.is.numeric(c('1','1.2','3a'),'vector')
all.is.numeric(c('1','',' .'),'vector')
}
\keyword{character}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/completer.r
\name{completer}
\alias{completer}
\title{completer}
\usage{
completer(a, nimpute, oneimpute = FALSE, mydata)
}
\arguments{
\item{a}{An object of class \code{transcan} or \code{aregImpute}}

\item{nimpute}{A numeric vector between 1 and \code{a$n.impute}. For \code{transcan} object, this is set to 1. For \code{aregImpute} object, returns a list of \code{nimpute} datasets when \code{oneimpute} is set to \code{FALSE} (default).}

\item{oneimpute}{A logical vector. When set to \code{TRUE}, returns a single completed dataset for the imputation number specified by \code{nimpute}}

\item{mydata}{A data frame in which its missing values will be imputed.}
}
\value{
\if{html}{\out{<div class="sourceCode">}}\preformatted{      A single or a list of completed dataset(s).
}\if{html}{\out{</div>}}
}
\description{
Create imputed dataset(s) using \code{transcan} and \code{aregImpute} objects
}
\details{
Similar in function to \code{mice::complete}, this function uses \code{transcan} and \code{aregImpute} objects to impute missing data
and returns the completed dataset(s) as a dataframe or a list.
It assumes that \code{transcan} is used for single regression imputation.
}
\examples{
\dontrun{
mtcars$hp[1:5]    <- NA
mtcars$wt[1:10]   <- NA
myrform <- ~ wt + hp + I(carb)
mytranscan  <- transcan( myrform,  data = mtcars, imputed = TRUE,
  pl = FALSE, pr = FALSE, trantab = TRUE, long = TRUE)
myareg      <- aregImpute(myrform, data = mtcars, x=TRUE, n.impute = 5)
completer(mytranscan)                    # single completed dataset
completer(myareg, 3, oneimpute = TRUE)
# single completed dataset based on the `n.impute`th set of multiple imputation
completer(myareg, 3)
# list of completed datasets based on first `nimpute` sets of multiple imputation
completer(myareg)
# list of completed datasets based on all available sets of multiple imputation
# To get a stacked data frame of all completed datasets use
# do.call(rbind, completer(myareg, data=mydata))
# or use rbindlist in data.table
}
}
\author{
\if{html}{\out{<div class="sourceCode">}}\preformatted{      Yong-Hao Pua, Singapore General Hospital
}\if{html}{\out{</div>}}
}

\name{stringDims}
\alias{stringDims}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{String Dimentions}
\description{
  Finds the height and width of all the string in a character vector.
}
\usage{
stringDims(string)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{string}{vector of strings}
}
\details{
  \code{stringDims} finds the number of characters in width and number of
  lines in height for each string in the \code{string} argument.
}
\value{
  \item{height}{a vector of the number of lines in each string.}
  \item{width}{a vector with the number of character columns in the
    longest line.}
}
\author{Charles Dupont}
\seealso{\code{\link{string.bounding.box}}, \code{\link{nchar}}}
\examples{
a <- c("this is a single line string", "This is a\nmulty line string")
stringDims(a)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{print}

\name{summarize}
\alias{summarize}
\alias{asNumericMatrix}
\alias{matrix2dataFrame}
\title{Summarize Scalars or Matrices by Cross-Classification}
\description{
\code{summarize} is a fast version of \code{summary.formula(formula,
method="cross",overall=FALSE)} for producing stratified summary statistics
and storing them in a data frame for plotting (especially with trellis
\code{xyplot} and \code{dotplot} and Hmisc \code{xYplot}).  Unlike
\code{aggregate}, \code{summarize} accepts a matrix as its first
argument and a multi-valued \code{FUN}
argument and \code{summarize} also labels the variables in the new data
frame using their original names.  Unlike methods based on
\code{tapply}, \code{summarize} stores the values of the stratification
variables using their original types, e.g., a numeric \code{by} variable
will remain a numeric variable in the collapsed data frame.
\code{summarize} also retains \code{"label"} attributes for variables.
\code{summarize} works especially well with the Hmisc \code{xYplot}
function for displaying multiple summaries of a single variable on each
panel, such as means and upper and lower confidence limits.


\code{asNumericMatrix} converts a data frame into a numeric matrix,
saving attributes to reverse the process by \code{matrix2dataframe}.
It saves attributes that are commonly preserved across row
subsetting (i.e., it does not save \code{dim}, \code{dimnames}, or
\code{names} attributes).

\code{matrix2dataFrame} converts a numeric matrix back into a data
frame if it was created by \code{asNumericMatrix}.
}
\usage{
summarize(X, by, FUN, \dots, 
          stat.name=deparse(substitute(X)),
          type=c('variables','matrix'), subset=TRUE,
          keepcolnames=FALSE)

asNumericMatrix(x)

matrix2dataFrame(x, at=attr(x, 'origAttributes'), restoreAll=TRUE)
}
\arguments{
\item{X}{
a vector or matrix capable of being operated on by the
function specified as the \code{FUN} argument
}
\item{by}{
one or more stratification variables.  If a single
variable, \code{by} may be a vector, otherwise it should be a list.
Using the Hmisc \code{llist} function instead of \code{list} will result
in individual variable names being accessible to \code{summarize}.  For
example, you can specify \code{llist(age.group,sex)} or
\code{llist(Age=age.group,sex)}.  The latter gives \code{age.group} a
new temporary name, \code{Age}. 
}
\item{FUN}{
a function of a single vector argument, used to create the statistical
summaries for \code{summarize}.  \code{FUN} may compute any number of
statistics. 
}
\item{...}{extra arguments are passed to \code{FUN}}
\item{stat.name}{
the name to use when creating the main summary variable.  By default,
the name of the \code{X} argument is used.  Set \code{stat.name} to
\code{NULL} to suppress this name replacement.
}
\item{type}{
Specify \code{type="matrix"} to store the summary variables (if there are
more than one) in a matrix.
}
\item{subset}{
a logical vector or integer vector of subscripts used to specify the
subset of data to use in the analysis.  The default is to use all
observations in the data frame.
}
\item{keepcolnames}{by default when \code{type="matrix"}, the first
	column of the computed matrix is the name of the first argument to
	\code{summarize}.  Set \code{keepcolnames=TRUE} to retain the name of
	the first column created by \code{FUN}}
\item{x}{
  a data frame (for \code{asNumericMatrix}) or a numeric matrix (for
  \code{matrix2dataFrame}).
}
\item{at}{List containing attributes of original data frame that survive
  subsetting. Defaults to attribute \code{"origAttributes"} of the
  object \code{x}, created by the call to \code{asNumericMatrix}}
\item{restoreAll}{
  set to \code{FALSE} to only restore attributes \code{label},
  \code{units}, and \code{levels} instead of all attributes
}
}
\value{
For \code{summarize}, a data frame containing the \code{by} variables and the
statistical summaries (the first of which is named the same as the \code{X}
variable unless \code{stat.name} is given).  If \code{type="matrix"}, the
summaries are stored in a single variable in the data frame, and this
variable is a matrix.

\code{asNumericMatrix} returns a numeric matrix and stores an object
\code{origAttributes} as an attribute of the returned object, with original
attributes of component variables, the \code{storage.mode}. 

\code{matrix2dataFrame} returns a data frame.

}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\seealso{
\code{\link{label}}, \code{\link{cut2}}, \code{\link{llist}}, \code{\link{by}}
}
\examples{
\dontrun{
s <- summarize(ap>1, llist(size=cut2(sz, g=4), bone), mean,
               stat.name='Proportion')
dotplot(Proportion ~ size | bone, data=s7)
}

set.seed(1)
temperature <- rnorm(300, 70, 10)
month <- sample(1:12, 300, TRUE)
year  <- sample(2000:2001, 300, TRUE)
g <- function(x)c(Mean=mean(x,na.rm=TRUE),Median=median(x,na.rm=TRUE))
summarize(temperature, month, g)
mApply(temperature, month, g)

mApply(temperature, month, mean, na.rm=TRUE)
w <- summarize(temperature, month, mean, na.rm=TRUE)
library(lattice)
xyplot(temperature ~ month, data=w) # plot mean temperature by month

w <- summarize(temperature, llist(year,month), 
               quantile, probs=c(.5,.25,.75), na.rm=TRUE, type='matrix')
xYplot(Cbind(temperature[,1],temperature[,-1]) ~ month | year, data=w)
mApply(temperature, llist(year,month),
       quantile, probs=c(.5,.25,.75), na.rm=TRUE)

# Compute the median and outer quartiles.  The outer quartiles are
# displayed using "error bars"
set.seed(111)
dfr <- expand.grid(month=1:12, year=c(1997,1998), reps=1:100)
attach(dfr)
y <- abs(month-6.5) + 2*runif(length(month)) + year-1997
s <- summarize(y, llist(month,year), smedian.hilow, conf.int=.5)
s
mApply(y, llist(month,year), smedian.hilow, conf.int=.5)

xYplot(Cbind(y,Lower,Upper) ~ month, groups=year, data=s, 
       keys='lines', method='alt')
# Can also do:
s <- summarize(y, llist(month,year), quantile, probs=c(.5,.25,.75),
               stat.name=c('y','Q1','Q3'))
xYplot(Cbind(y, Q1, Q3) ~ month, groups=year, data=s, keys='lines')
# To display means and bootstrapped nonparametric confidence intervals
# use for example:
s <- summarize(y, llist(month,year), smean.cl.boot)
xYplot(Cbind(y, Lower, Upper) ~ month | year, data=s)

# For each subject use the trapezoidal rule to compute the area under
# the (time,response) curve using the Hmisc trap.rule function
x <- cbind(time=c(1,2,4,7, 1,3,5,10),response=c(1,3,2,4, 1,3,2,4))
subject <- c(rep(1,4),rep(2,4))
trap.rule(x[1:4,1],x[1:4,2])
summarize(x, subject, function(y) trap.rule(y[,1],y[,2]))

\dontrun{
# Another approach would be to properly re-shape the mm array below
# This assumes no missing cells.  There are many other approaches.
# mApply will do this well while allowing for missing cells.
m <- tapply(y, list(year,month), quantile, probs=c(.25,.5,.75))
mm <- array(unlist(m), dim=c(3,2,12), 
            dimnames=list(c('lower','median','upper'),c('1997','1998'),
                          as.character(1:12)))
# aggregate will help but it only allows you to compute one quantile
# at a time; see also the Hmisc mApply function
dframe <- aggregate(y, list(Year=year,Month=month), quantile, probs=.5)

# Compute expected life length by race assuming an exponential
# distribution - can also use summarize
g <- function(y) { # computations for one race group
  futime <- y[,1]; event <- y[,2]
  sum(futime)/sum(event)  # assume event=1 for death, 0=alive
}
mApply(cbind(followup.time, death), race, g)

# To run mApply on a data frame:
xn <- asNumericMatrix(x)
m <- mApply(xn, race, h)
# Here assume h is a function that returns a matrix similar to x
matrix2dataFrame(m)


# Get stratified weighted means
g <- function(y) wtd.mean(y[,1],y[,2])
summarize(cbind(y, wts), llist(sex,race), g, stat.name='y')
mApply(cbind(y,wts), llist(sex,race), g)

# Compare speed of mApply vs. by for computing 
d <- data.frame(sex=sample(c('female','male'),100000,TRUE),
                country=sample(letters,100000,TRUE),
                y1=runif(100000), y2=runif(100000))
g <- function(x) {
  y <- c(median(x[,'y1']-x[,'y2']),
         med.sum =median(x[,'y1']+x[,'y2']))
  names(y) <- c('med.diff','med.sum')
  y
}

system.time(by(d, llist(sex=d$sex,country=d$country), g))
system.time({
             x <- asNumericMatrix(d)
             a <- subsAttr(d)
             m <- mApply(x, llist(sex=d$sex,country=d$country), g)
            })
system.time({
             x <- asNumericMatrix(d)
             summarize(x, llist(sex=d$sex, country=d$country), g)
            })

# An example where each subject has one record per diagnosis but sex of
# subject is duplicated for all the rows a subject has.  Get the cross-
# classified frequencies of diagnosis (dx) by sex and plot the results
# with a dot plot

count <- rep(1,length(dx))
d <- summarize(count, llist(dx,sex), sum)
Dotplot(dx ~ count | sex, data=d)
}
d <- list(x=1:10, a=factor(rep(c('a','b'), 5)),
          b=structure(letters[1:10], label='label for b'),
          d=c(rep(TRUE,9), FALSE), f=pi*(1 : 10))
x <- asNumericMatrix(d)
attr(x, 'origAttributes')
matrix2dataFrame(x)

detach('dfr')

# Run summarize on a matrix to get column means
x <- c(1:19,NA)
y <- 101:120
z <- cbind(x, y)
g <- c(rep(1, 10), rep(2, 10))
summarize(z, g, colMeans, na.rm=TRUE, stat.name='x')
# Also works on an all numeric data frame
summarize(as.data.frame(z), g, colMeans, na.rm=TRUE, stat.name='x')
}
\keyword{category}
\keyword{manip}
\keyword{multivariate}
\concept{grouping}
\concept{stratification}
\concept{aggregation}
\concept{cross-classification}

\name{consolidate}
\alias{consolidate}
\alias{consolidate<-}
\alias{consolidate.default}
\title{ Element Merging }
\description{
  Merges an object by the names of its elements.  Inserting elements in
  \code{value} into \code{x} that do not exists in \code{x} and
  replacing elements in \code{x} that exists in \code{value} with
  \code{value} elements if \code{protect} is false.
}
\usage{
consolidate(x, value, protect, \dots)
\method{consolidate}{default}(x, value, protect=FALSE, \dots)

consolidate(x, protect, \dots) <- value
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ named list or vector }
  \item{value}{ named list or vector }
  \item{protect}{
    logical; should elements in \code{x} be kept instead
    of elements in \code{value}?
  }
  \item{\dots}{ currently does nothing; included if ever want to make generic. }
}
\author{ Charles Dupont }
\seealso{ \code{\link{names}} }
\examples{
x <- 1:5
names(x) <- LETTERS[x]

y <- 6:10
names(y) <- LETTERS[y-2]

x                  # c(A=1,B=2,C=3,D=4,E=5)
y                  # c(D=6,E=7,F=8,G=9,H=10)

consolidate(x, y)      # c(A=1,B=2,C=3,D=6,E=7,F=8,G=9,H=10)
consolidate(x, y, protect=TRUE)      # c(A=1,B=2,C=3,D=4,E=5,F=8,G=9,H=10)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ utilities }

\name{xy.group}
\alias{xy.group}
\title{
Mean x vs. function of y in groups of x
}
\description{
Compute mean x vs. a function of y (e.g. median) by quantile
groups of x or by x grouped to have a given minimum number of
observations.  Deletes NAs in x and y before doing computations.
}
\usage{
xy.group(x, y, m=150, g, fun=mean, result="list")
}
\arguments{
\item{x}{
a vector, may contain NAs
}
\item{y}{
a vector of same length as x, may contain NAs
}
\item{m}{
number of observations per group
}
\item{g}{
number of quantile groups
}
\item{fun}{
function of y such as median or mean (the default)
}
\item{result}{
"list" (the default), or "matrix"
}}
\value{
if result="list", a list with components x and y suitable for plotting.
if result="matrix", matrix with rows corresponding to x-groups and columns named
n, x, and y.
}
\seealso{
\code{\link{cut2}}, \code{\link{cutGn}}, \code{\link{tapply}}
}
\examples{
  \dontrun{
plot(xy.group(x, y, g=10))	#Plot mean y by deciles of x
xy.group(x, y, m=100, result="matrix")	#Print table, 100 obs/group
  }
}
\keyword{category}
\keyword{nonparametric}
\concept{grouping}
\concept{stratification}
\concept{aggregation}
\concept{discretization}

\name{xYplot}
\alias{xYplot}
\alias{panel.xYplot}
\alias{prepanel.xYplot}
\alias{Dotplot}
\alias{panel.Dotplot}
\alias{prepanel.Dotplot}
\alias{Cbind}
\alias{[.Cbind}
\alias{setTrellis}
\alias{numericScale}
\title{xyplot and dotplot with Matrix Variables to Plot Error Bars and Bands}
\description{
A utility function \code{Cbind} returns the first argument as a vector and
combines all other arguments into a matrix stored as an attribute called
\code{"other"}.  The arguments can be named (e.g.,
\code{Cbind(pressure=y,ylow,yhigh)}) or a \code{label} attribute may be pre-attached
to the first argument. In either case, the name or label of the first
argument is stored as an attribute \code{"label"} of the object returned by
\code{Cbind}.  Storing other vectors as a matrix attribute facilitates plotting
error bars, etc., as \code{trellis} really wants the x- and y-variables to be
vectors, not matrices. If a single argument is given to \code{Cbind} and that
argument is a matrix with column dimnames, the first column is taken as the
main vector and remaining columns are taken as \code{"other"}. A subscript
method for \code{Cbind} objects subscripts the \code{other} matrix along
with the main \code{y} vector.

The \code{xYplot} function is a substitute for \code{xyplot} that allows for
simulated multi-column \code{y}. It uses by default the \code{panel.xYplot} and
\code{prepanel.xYplot} functions to do the actual work. The \code{method} argument
passed to \code{panel.xYplot} from \code{xYplot} allows you to make error bars, the
upper-only or lower-only portions of error bars, alternating lower-only and
upper-only bars, bands, or filled bands.  \code{panel.xYplot} decides how to
alternate upper and lower bars according to whether the median \code{y} value of
the current main data line is above the median \code{y} for all \code{groups} of
lines or not.  If the median is above the overall median, only the upper
bar is drawn. For \code{bands} (but not 'filled bands'), any number of other
columns of \code{y} will be drawn as lines having the same thickness, color, and
type as the main data line.  If plotting bars, bands, or filled bands and
only one additional column is specified for the response variable, that
column is taken as the half width of a precision interval for \code{y}, and the
lower and upper values are computed automatically as \code{y} plus or minus the
value of the additional column variable.


When a \code{groups} variable is present, \code{panel.xYplot} will create a function
in frame 0 (\code{.GlobalEnv} in \R) called \code{Key} that when
invoked will draw a key describing the 
\code{groups} labels, point symbols, and colors. By default, the key is outside
the graph.  For S-Plus, if \code{Key(locator(1))} is specified, the key will appear so that
its upper left corner is at the coordinates of the mouse click.  For
R/Lattice the first two arguments of \code{Key} (\code{x} and \code{y}) are fractions
of the page, measured from the lower left corner, and the default
placement is at \code{x=0.05, y=0.95}.  For \R, an optional argument
to \code{sKey}, \code{other}, may contain a list of arguments to pass to \code{draw.key} (see
\code{\link[lattice]{xyplot}} for a list of possible arguments, under
the \code{key} option).  


When \code{method="quantile"} is specified, \code{xYplot} automatically groups the
\code{x} variable into intervals containing a target of \code{nx} observations each,
and within each \code{x} group computes three quantiles of \code{y} and plots these
as three lines. The mean \code{x} within each \code{x} group is taken as the
\code{x}-coordinate. This will make a useful empirical display for large
datasets in which scatterdiagrams are too busy to see patterns of central
tendency and variability.  You can also specify a general function of a
data vector that returns a matrix of statistics for the \code{method} argument.
Arguments can be passed to that function via a list \code{methodArgs}.  The
statistic in the first column should be the measure of central tendency.
Examples of useful \code{method} functions are those listed under the help file
for \code{summary.formula} such as \code{smean.cl.normal}.

\code{xYplot} can also produce bubble plots.  This is done when
\code{size} is specified to \code{xYplot}.  When \code{size} is used, a
function \code{sKey} is generated for drawing a key to the character
sizes.  See the bubble plot example.  \code{size} can also specify a
vector where the first character of each observation is used as the
plotting symbol, if \code{rangeCex} is set to a single \code{cex}
value.  An optional argument to \code{sKey}, \code{other}, may contain
a list of arguments to pass to \code{draw.key} (see
\code{\link[lattice]{xyplot}} for a list of possible arguments, under
the \code{key} option).  See the bubble plot example.

\code{Dotplot} is a substitute for \code{dotplot} allowing for a matrix x-variable,
automatic superpositioning when \code{groups} is present, and creation of a
\code{Key} function.  When the x-variable (created by \code{Cbind} to simulate a
matrix) contains a total of 3 columns, the first column specifies where the
dot is positioned, and the last 2 columns specify starting and ending
points for intervals.  The intervals are shown using line type, width, and
color from the trellis \code{plot.line} list. By default, you will usually see a
darker line segment for the low and high values, with the dotted reference
line elsewhere. A good choice of the \code{pch} argument for such plots is \code{3}
(plus sign) if you want to emphasize the interval more than the point
estimate.  When the x-variable contains a total of 5 columns, the 2nd and
5th columns are treated as the 2nd and 3rd are treated above, and the 3rd
and 4th columns define an inner line segment that will have twice the
thickness of the outer segments. In addition, tick marks separate the outer
and inner segments.  This type of display (an example of which appeared in
\emph{The Elements of Graphing Data} by Cleveland) is very suitable for
displaying two confidence levels (e.g., 0.9 and 0.99) or the 0.05, 0.25,
0.75, 0.95 sample quantiles, for example.  For this display, the central
point displays well with a default circle symbol.


\code{setTrellis} sets nice defaults for Trellis graphics, assuming that the
graphics device has already been opened if using postscript, etc. By
default, it sets panel strips to blank and reference dot lines to thickness
1 instead of the Trellis default of 2.


\code{numericScale} is a utility function that facilitates using
\code{xYplot} to 
plot variables that are not considered to be numeric but which can readily
be converted to numeric using \code{as.numeric()}.  \code{numericScale}
by default will keep the name of the input variable as a \code{label}
attribute for the new numeric variable.
}
\usage{
Cbind(\dots)

xYplot(formula, data = sys.frame(sys.parent()), groups,
       subset, xlab=NULL, ylab=NULL, ylim=NULL,
       panel=panel.xYplot, prepanel=prepanel.xYplot, scales=NULL,
       minor.ticks=NULL, sub=NULL, \dots)

panel.xYplot(x, y, subscripts, groups=NULL, 
             type=if(is.function(method) || method=='quantiles') 
               'b' else 'p',
             method=c("bars", "bands", "upper bars", "lower bars", 
                      "alt bars", "quantiles", "filled bands"), 
             methodArgs=NULL, label.curves=TRUE, abline,
             probs=c(.5,.25,.75), nx=NULL,
             cap=0.015, lty.bar=1, 
             lwd=plot.line$lwd, lty=plot.line$lty, pch=plot.symbol$pch, 
             cex=plot.symbol$cex, font=plot.symbol$font, col=NULL, 
             lwd.bands=NULL, lty.bands=NULL, col.bands=NULL, 
             minor.ticks=NULL, col.fill=NULL,
             size=NULL, rangeCex=c(.5,3), \dots)

prepanel.xYplot(x, y, \dots)

Dotplot(formula, data = sys.frame(sys.parent()), groups, subset, 
        xlab = NULL, ylab = NULL, ylim = NULL,
        panel=panel.Dotplot, prepanel=prepanel.Dotplot,
        scales=NULL, xscale=NULL, \dots)

prepanel.Dotplot(x, y, \dots)

panel.Dotplot(x, y, groups = NULL,
              pch  = dot.symbol$pch, 
              col  = dot.symbol$col, cex = dot.symbol$cex, 
              font = dot.symbol$font, abline, \dots)

setTrellis(strip.blank=TRUE, lty.dot.line=2, lwd.dot.line=1)

numericScale(x, label=NULL, \dots)
}
\arguments{
\item{\dots}{
for \code{Cbind} \code{\dots} is any number of additional numeric
vectors. Unless you are using \code{Dotplot} (which allows for either 2
or 4 "other" variables) or \code{xYplot} with \code{method="bands"},
vectors after the first two are ignored.  If drawing bars and only one
extra variable is given in \code{\dots}, upper and lower values are
computed as described above. If the second argument to \code{Cbind} is a
matrix, that matrix is stored in the \code{"other"} attribute and
arguments after the second are ignored.  For bubble plots, name an
argument \code{cex}.

Also can be other arguments to pass to \code{labcurve}.
}
\item{formula}{
a \code{trellis} formula consistent with \code{xyplot} or \code{dotplot} 
}
\item{x}{
\code{x}-axis variable.  For \code{numericScale} \code{x} is any vector
such as \code{as.numeric(x)} returns a numeric vector suitable for x- or
y-coordinates.
}
\item{y}{
  a vector, or an object created by \code{Cbind} for \code{xYplot}.
\code{y} represents the main variable to plot, i.e., the variable used to
draw the main lines. For \code{Dotplot} the first argument to
\code{Cbind} will be the main \code{x}-axis variable.  
}
\item{data,subset,ylim,subscripts,groups,type,scales,panel,prepanel,xlab,ylab}{
  see \code{trellis.args}.  \code{xlab} and \code{ylab} get default values from
  \code{"label"} attributes.
}
\item{xscale}{allows one to use the default \code{scales} but specify
  only the \code{x} component of it for \code{Dotplot}}
\item{method}{
defaults to \code{"bars"} to draw error-bar type plots.  See meaning of other
values above.  \code{method} can be a function.  Specifying \code{method=quantile},
\code{methodArgs=list(probs=c(.5,.25,.75))} is the same as specifying
\code{method="quantile"} without specifying \code{probs}.
}
\item{methodArgs}{
a list containing optional arguments to be passed to the function specified
in \code{method}
}
\item{label.curves}{
set to \code{FALSE} to suppress invocation of \code{labcurve} to label primary curves
where they are most separated or to draw a legend in an empty spot on the
panel.  You can also set \code{label.curves} to a list of options to pass to
\code{labcurve}.  These options can also be passed as \code{\dots} to \code{xYplot}. See the
examples below.
}
\item{abline}{
a list of arguments to pass to \code{panel.abline} for each panel, e.g.
\code{list(a=0, b=1, col=3)} to draw the line of identity using color
3.  To make multiple calls to \code{panel.abline}, pass a list of
unnamed lists as \code{abline}, e.g., \code{abline=list(list(h=0),list(v=1))}.
}
\item{probs}{
a vector of three quantiles with the quantile corresponding to the central
line listed first. By default \code{probs=c(.5, .25, .75)}. You can also specify
\code{probs} through \code{methodArgs=list(probs=\dots)}.
}
\item{nx}{
number of target observations for each \code{x} group (see \code{cut2} \code{m} argument).
\code{nx} defaults to the minimum of 40 and the number of points in the current
stratum divided by 4. Set \code{nx=FALSE} or \code{nx=0} if \code{x} is already discrete and
requires no grouping.
}
\item{cap}{
the half-width of horizontal end pieces for error bars, as a fraction of
the length of the \code{x}-axis
}
\item{lty.bar}{
line type for bars
}
\item{lwd, lty, pch, cex, font, col}{
see \code{trellis.args}.  These are vectors when \code{groups} is present, and the
order of their elements corresponds to the different \code{groups}, regardless
of how many bands or bars are drawn. If you don't specify \code{lty.bands}, for
example, all band lines within each group will have the same \code{lty}.
}
\item{lty.bands, lwd.bands, col.bands}{
used to allow \code{lty}, \code{lwd}, \code{col} to vary across the different band lines
for different \code{groups}. These parameters are vectors or lists whose
elements correspond to the added band lines (i.e., they ignore the central
line, whose line characteristics are defined by \code{lty}, \code{lwd}, \code{col}). For
example, suppose that 4 lines are drawn in addition to the central line.
Specifying \code{lwd.bands=1:4} will cause line widths of 1:4 to be used for
every group, regardless of the value of \code{lwd}.  To vary characteristics
over the \code{groups} use e.g. \code{lwd.bands=list(rep(1,4), rep(2,4))} or
\code{list(c(1,2,1,2), c(3,4,3,4))}.
}
\item{minor.ticks}{
a list with elements \code{at} and \code{labels} specifying positions
and labels for minor tick marks to be used on the x-axis of each panel,
if any.
}
\item{sub}{an optional subtitle}
\item{col.fill}{
used to override default colors used for the bands in method='filled
bands'. This is a vector when \code{groups} is present, and the order of the
elements corresponds to the different \code{groups}, regardless of how many
bands are drawn.  The default colors for 'filled bands' are pastel colors
matching the default colors superpose.line$col (plot.line$col)
}
\item{size}{
  a vector the same length as \code{x} giving a variable whose values
  are a linear function of the size of the symbol drawn.  This is used
  for example for bubble plots.
}
\item{rangeCex}{
  a vector of two values specifying the range in character sizes to use
  for the \code{size} variable (lowest first, highest second).
  \code{size} values are linearly translated to this range, based on the
  observed range of \code{size} when \code{x} and \code{y} coordinates
  are not missing.  Specify a single numeric \code{cex} value for
  \code{rangeCex} to use the first character of each observations's
  \code{size} as the plotting symbol.
  }
\item{strip.blank}{
set to \code{FALSE} to not make the panel strip backgrounds blank 
}
\item{lty.dot.line}{
line type for dot plot reference lines (default = 1 for dotted; use 2 for
dotted)
}
\item{lwd.dot.line}{
line thickness for reference lines for dot plots (default = 1) 
}
\item{label}{
a scalar character string to be used as a variable label after
\code{numericScale} converts the 
variable to numeric form 
}
}
\value{
\code{Cbind} returns a matrix with attributes.  Other functions return standard
\code{trellis} results.
}
\section{Side Effects}{
plots, and \code{panel.xYplot} may create temporary \code{Key} and
\code{sKey} functions in the session frame. 
}
\details{
Unlike \code{xyplot}, \code{xYplot} senses the presence of a \code{groups} variable and
automatically invokes \code{panel.superpose} instead of \code{panel.xyplot}. The same
is true for \code{Dotplot} vs. \code{dotplot}.
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
\cr
Madeline Bauer
\cr
Department of Infectious Diseases
\cr
University of Southern California School of Medicine
\cr
\email{mbauer@usc.edu}
}
\seealso{
\code{\link[lattice]{xyplot}}, \code{\link[lattice]{panel.xyplot}}, \code{\link{summarize}}, \code{\link{label}}, \code{\link{labcurve}},
\code{\link{errbar}}, \code{\link[lattice:xyplot]{dotplot}}, 
\code{\link{reShape}}, \code{\link{cut2}}, \code{\link[lattice:panel.functions]{panel.abline}}
}
\examples{
# Plot 6 smooth functions.  Superpose 3, panel 2.
# Label curves with p=1,2,3 where most separated 
d <- expand.grid(x=seq(0,2*pi,length=150), p=1:3, shift=c(0,pi)) 
xYplot(sin(x+shift)^p ~ x | shift, groups=p, data=d, type='l') 
# Use a key instead, use 3 line widths instead of 3 colors 
# Put key in most empty portion of each panel
xYplot(sin(x+shift)^p ~ x | shift, groups=p, data=d, 
       type='l', keys='lines', lwd=1:3, col=1) 
# Instead of implicitly using labcurve(), put a 
# single key outside of panels at lower left corner
xYplot(sin(x+shift)^p ~ x | shift, groups=p, data=d, 
       type='l', label.curves=FALSE, lwd=1:3, col=1, lty=1:3) 
Key()

# Bubble plots
x <- y <- 1:8
x[2] <- NA
units(x) <- 'cm^2'
z <- 101:108
p <- factor(rep(c('a','b'),4))
g <- c(rep(1,7),2)
data.frame(p, x, y, z, g)
xYplot(y ~ x | p, groups=g, size=z)
 Key(other=list(title='g', cex.title=1.2))  # draw key for colors
sKey(.2,.85,other=list(title='Z Values', cex.title=1.2))
# draw key for character sizes

# Show the median and quartiles of height given age, stratified 
# by sex and race.  Draws 2 sets (male, female) of 3 lines per panel.
# xYplot(height ~ age | race, groups=sex, method='quantiles')


# Examples of plotting raw data
dfr <- expand.grid(month=1:12, continent=c('Europe','USA'), 
                   sex=c('female','male'))
set.seed(1)
dfr <- upData(dfr,
              y=month/10 + 1*(sex=='female') + 2*(continent=='Europe') + 
                runif(48,-.15,.15),
              lower=y - runif(48,.05,.15),
              upper=y + runif(48,.05,.15))


xYplot(Cbind(y,lower,upper) ~ month,subset=sex=='male' & continent=='USA',
       data=dfr)
xYplot(Cbind(y,lower,upper) ~ month|continent, subset=sex=='male',data=dfr)
xYplot(Cbind(y,lower,upper) ~ month|continent, groups=sex, data=dfr); Key() 
# add ,label.curves=FALSE to suppress use of labcurve to label curves where
# farthest apart


xYplot(Cbind(y,lower,upper) ~ month,groups=sex,
                              subset=continent=='Europe', data=dfr) 
xYplot(Cbind(y,lower,upper) ~ month,groups=sex, type='b',
                              subset=continent=='Europe', keys='lines',
                              data=dfr)
# keys='lines' causes labcurve to draw a legend where the panel is most empty


xYplot(Cbind(y,lower,upper) ~ month,groups=sex, type='b', data=dfr,
                              subset=continent=='Europe',method='bands') 
xYplot(Cbind(y,lower,upper) ~ month,groups=sex, type='b', data=dfr,
                              subset=continent=='Europe',method='upper')


label(dfr$y) <- 'Quality of Life Score'   
# label is in Hmisc library = attr(y,'label') <- 'Quality\dots'; will be
# y-axis label 
# can also specify Cbind('Quality of Life Score'=y,lower,upper) 
xYplot(Cbind(y,lower,upper) ~ month, groups=sex,
       subset=continent=='Europe', method='alt bars',
        offset=grid::unit(.1,'inches'), type='b', data=dfr)   
# offset passed to labcurve to label .4 y units away from curve
# for R (using grid/lattice), offset is specified using the grid
# unit function, e.g., offset=grid::unit(.4,'native') or
# offset=grid::unit(.1,'inches') or grid::unit(.05,'npc')


# The following example uses the summarize function in Hmisc to 
# compute the median and outer quartiles.  The outer quartiles are 
# displayed using "error bars"
set.seed(111)
dfr <- expand.grid(month=1:12, year=c(1997,1998), reps=1:100)
month <- dfr$month; year <- dfr$year
y <- abs(month-6.5) + 2*runif(length(month)) + year-1997
s <- summarize(y, llist(month,year), smedian.hilow, conf.int=.5) 
xYplot(Cbind(y,Lower,Upper) ~ month, groups=year, data=s, 
       keys='lines', method='alt', type='b')
# Can also do:
s <- summarize(y, llist(month,year), quantile, probs=c(.5,.25,.75),
               stat.name=c('y','Q1','Q3')) 
xYplot(Cbind(y, Q1, Q3) ~ month, groups=year, data=s, 
       type='b', keys='lines') 
# Or:
xYplot(y ~ month, groups=year, keys='lines', nx=FALSE, method='quantile',
       type='b') 
# nx=FALSE means to treat month as a discrete variable


# To display means and bootstrapped nonparametric confidence intervals 
# use:
s <- summarize(y, llist(month,year), smean.cl.boot) 
s
xYplot(Cbind(y, Lower, Upper) ~ month | year, data=s, type='b')
# Can also use Y <- cbind(y, Lower, Upper); xYplot(Cbind(Y) ~ ...) 
# Or:
xYplot(y ~ month | year, nx=FALSE, method=smean.cl.boot, type='b')


# This example uses the summarize function in Hmisc to 
# compute the median and outer quartiles.  The outer quartiles are 
# displayed using "filled bands"


s <- summarize(y, llist(month,year), smedian.hilow, conf.int=.5) 


# filled bands: default fill = pastel colors matching solid colors
# in superpose.line (this works differently in R)
xYplot ( Cbind ( y, Lower, Upper ) ~ month, groups=year, 
     method="filled bands" , data=s, type="l")


# note colors based on levels of selected subgroups, not first two colors
xYplot ( Cbind ( y, Lower, Upper ) ~ month, groups=year, 
     method="filled bands" , data=s, type="l",
     subset=(year == 1998 | year == 2000), label.curves=FALSE )


# filled bands using black lines with selected solid colors for fill
xYplot ( Cbind ( y, Lower, Upper ) ~ month, groups=year, 
     method="filled bands" , data=s, label.curves=FALSE,
     type="l", col=1, col.fill = 2:3)
Key(.5,.8,col = 2:3) #use fill colors in key


# A good way to check for stable variance of residuals from ols 
# xYplot(resid(fit) ~ fitted(fit), method=smean.sdl) 
# smean.sdl is defined with summary.formula in Hmisc


# Plot y vs. a special variable x
# xYplot(y ~ numericScale(x, label='Label for X') | country) 
# For this example could omit label= and specify 
#    y ~ numericScale(x) | country, xlab='Label for X'


# Here is an example of using xYplot with several options
# to change various Trellis parameters,
# xYplot(y ~ x | z, groups=v, pch=c('1','2','3'),
#        layout=c(3,1),     # 3 panels side by side
#        ylab='Y Label', xlab='X Label',
#        main=list('Main Title', cex=1.5),
#        par.strip.text=list(cex=1.2),
#        strip=function(\dots) strip.default(\dots, style=1),
#        scales=list(alternating=FALSE))


#
# Dotplot examples
#


s <- summarize(y, llist(month,year), smedian.hilow, conf.int=.5) 


setTrellis()            # blank conditioning panel backgrounds 
Dotplot(month ~ Cbind(y, Lower, Upper) | year, data=s) 
# or Cbind(\dots), groups=year, data=s


# Display a 5-number (5-quantile) summary (2 intervals, dot=median) 
# Note that summarize produces a matrix for y, and Cbind(y) trusts the 
# first column to be the point estimate (here the median) 
s <- summarize(y, llist(month,year), quantile,
               probs=c(.5,.05,.25,.75,.95), type='matrix') 
Dotplot(month ~ Cbind(y) | year, data=s) 
# Use factor(year) to make actual years appear in conditioning title strips

# Plot proportions and their Wilson confidence limits
set.seed(3)
d <- expand.grid(continent=c('USA','Europe'), year=1999:2001,
                 reps=1:100)
# Generate binary events from a population probability of 0.2
# of the event, same for all years and continents
d$y <- ifelse(runif(6*100) <= .2, 1, 0)
s <- with(d,
          summarize(y, llist(continent,year),
                    function(y) {
                     n <- sum(!is.na(y))
                     s <- sum(y, na.rm=TRUE)
                     binconf(s, n)
                    }, type='matrix')
)

Dotplot(year ~ Cbind(y) | continent,  data=s, ylab='Year',
        xlab='Probability')


# Dotplot(z ~ x | g1*g2)                 
# 2-way conditioning 
# Dotplot(z ~ x | g1, groups=g2); Key()  
# Key defines symbols for g2


# If the data are organized so that the mean, lower, and upper 
# confidence limits are in separate records, the Hmisc reShape 
# function is useful for assembling these 3 values as 3 variables 
# a single observation, e.g., assuming type has values such as 
# c('Mean','Lower','Upper'):
# a <- reShape(y, id=month, colvar=type) 
# This will make a matrix with 3 columns named Mean Lower Upper 
# and with 1/3 as many rows as the original data 
}
\keyword{hplot}
\concept{trellis}
\concept{lattice}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggplotlyr.r
\name{ggplotlyr}
\alias{ggplotlyr}
\title{ggplotlyr}
\usage{
ggplotlyr(ggobject, tooltip = "label", remove = "txt: ", ...)
}
\arguments{
\item{ggobject}{an object produced by \code{ggplot}}

\item{tooltip}{attribute specified to \code{ggplot} to hold hover text}

\item{remove}{extraneous text to remove from hover text.  Default is set to assume \code{tooltip='label'} and assumed the user specified \code{aes(..., label=txt)}.  If you instead specified \code{aes(..., label=myvar)} use \code{remove='myvar: '}.}

\item{...}{other arguments passed to \code{ggplotly}}
}
\value{
a \code{plotly} object
}
\description{
Render \code{plotly} Graphic from a \code{ggplot2} Object
}
\details{
Uses \code{plotly::ggplotly()} to render a \code{plotly} graphic with a specified tooltip attribute, removing extraneous text that \code{ggplotly} puts in hover text when \code{tooltip='label'}
}
\author{
Frank Harrell
}

\name{biVar}
\alias{biVar}
\alias{print.biVar}
\alias{plot.biVar}
\alias{spearman2}
\alias{spearman2.default}
\alias{spearman2.formula}
\alias{spearman}
\alias{spearman.test}
\alias{chiSquare}
\title{Bivariate Summaries Computed Separately by a Series of Predictors}
\description{
  \code{biVar} is a generic function that accepts a formula and usual
  \code{data}, \code{subset}, and \code{na.action} parameters plus a
  list \code{statinfo} that specifies a function of two variables to
  compute along with information about labeling results for printing and
  plotting.  The function is called separately with each right hand side
  variable and the same left hand variable.  The result is a matrix of
  bivariate statistics and the \code{statinfo} list that drives printing
  and plotting.  The plot method draws a dot plot with x-axis values by
  default sorted in order of one of the statistics computed by the function.

  \code{spearman2} computes the square of Spearman's rho rank correlation
  and a generalization of it in which \code{x} can relate
  non-monotonically to \code{y}.  This is done by computing the Spearman
  multiple rho-squared between \code{(rank(x), rank(x)^2)} and \code{y}.
  When \code{x} is categorical, a different kind of Spearman correlation
  used in the Kruskal-Wallis test is computed (and \code{spearman2} can do
  the Kruskal-Wallis test).  This is done by computing the ordinary
  multiple \code{R^2} between \code{k-1} dummy variables and
  \code{rank(y)}, where \code{x} has \code{k} categories.  \code{x} can
  also be a formula, in which case each predictor is correlated separately
  with \code{y}, using non-missing observations for that predictor.
  \code{biVar} is used to do the looping and bookkeeping.  By default the
  plot shows the adjusted \code{rho^2}, using the same formula used for
  the ordinary adjusted \code{R^2}.  The \code{F} test uses the unadjusted
  R2.

  \code{spearman} computes Spearman's rho on non-missing values of two
  variables.  \code{spearman.test} is a simple version of
  \code{spearman2.default}.

  \code{chiSquare} is set up like \code{spearman2} except it is intended
  for a categorical response variable.  Separate Pearson chi-square tests
  are done for each predictor, with optional collapsing of infrequent
  categories.  Numeric predictors having more than \code{g} levels are
  categorized into \code{g} quantile groups.  \code{chiSquare} uses
  \code{biVar}.
}
\usage{
biVar(formula, statinfo, data=NULL, subset=NULL,
      na.action=na.retain, exclude.imputed=TRUE, ...)

\method{print}{biVar}(x, ...)

\method{plot}{biVar}(x, what=info$defaultwhat,
                       sort.=TRUE, main, xlab,
                       vnames=c('names','labels'), ...)

spearman2(x, ...)

\method{spearman2}{default}(x, y, p=1, minlev=0, na.rm=TRUE, exclude.imputed=na.rm, ...)

\method{spearman2}{formula}(formula, data=NULL,
          subset, na.action=na.retain, exclude.imputed=TRUE, ...)

spearman(x, y)

spearman.test(x, y, p=1)

chiSquare(formula, data=NULL, subset=NULL, na.action=na.retain,
          exclude.imputed=TRUE, ...)
}
\arguments{
  \item{formula}{a formula with a single left side variable}
  \item{statinfo}{see \code{spearman2.formula} or \code{chiSquare} code}
  \item{data, subset, na.action}{
    the usual options for models.  Default for \code{na.action} is to retain
    all values, NA or not, so that NAs can be deleted in only a pairwise
    fashion.
  }
  \item{exclude.imputed}{
    set to \code{FALSE} to include imputed values (created by
    \code{impute}) in the calculations.
  }
  \item{...}{other arguments that are passed to the function used to
    compute the bivariate statistics or to \code{dotchart3} for
    \code{plot}.
  }
  \item{na.rm}{logical; delete NA values?}
  \item{x}{
	a numeric matrix with at least 5 rows and at least 2 columns (if
	\code{y} is absent).  For \code{spearman2}, the first argument may
	be a vector of any type, including character or factor.  The first
	argument may also be a formula, in which case all predictors are
	correlated individually with 
	the response variable.  \code{x} may be a formula for \code{spearman2}
	in which case \code{spearman2.formula} is invoked.  Each
	predictor in the right hand side of the formula is separately correlated
	with the response variable.  For \code{print} or \code{plot}, \code{x}
	is an object produced by \code{biVar}.  For \code{spearman} and
	\code{spearman.test} \code{x} is a numeric vector, as is \code{y}.  For
	\code{chiSquare}, \code{x} is a formula.
  }
%  \item{type}{
%	specifies the type of correlations to compute.  Spearman correlations
%	are the Pearson linear correlations computed on the ranks of non-missing
%	elements, using midranks for ties.
%  }
  \item{y}{
	a numeric vector
  }
  \item{p}{
	for numeric variables, specifies the order of the Spearman \code{rho^2} to
	use.  The default is \code{p=1} to compute the ordinary
	\code{rho^2}.  Use \code{p=2} to compute the quadratic rank
	generalization to allow non-monotonicity.  \code{p} is ignored for
	categorical predictors.
  }
  \item{minlev}{
	minimum relative frequency that a level of a categorical predictor
	should have before it is pooled with other categories (see
	\code{combine.levels}) in \code{spearman2} and \code{chiSquare} (in
	which case it also applies to the response).  The default,
	\code{minlev=0} causes no pooling.
  }
  \item{what}{
	specifies which statistic to plot.  Possibilities include the
	column names that appear with the print method is used.
  }
  \item{sort.}{
	set \code{sort.=FALSE} to suppress sorting variables by the
	statistic being plotted
  }
  \item{main}{
	main title for plot.  Default title shows the name of the response
	variable.
  }
  \item{xlab}{
	x-axis label.  Default constructed from \code{what}.
  }
  \item{vnames}{
	set to \code{"labels"} to use variable labels in place of names for
	plotting.  If a variable does not have a label the name is always
	used.}
%  \item{g}{number of quantile groups into which to categorize continuous
%	predictors having more than \code{g} unique values, for \code{chiSquare}}
}
\value{
  \code{spearman2.default} (the
  function that is called for a single \code{x}, i.e., when there is no
  formula) returns a vector of statistics for the variable.
  \code{biVar}, \code{spearman2.formula}, and \code{chiSquare} return a
  matrix with rows corresponding to predictors.
}
\details{
  Uses midranks in case of ties, as described by Hollander and Wolfe.
  P-values for Spearman, Wilcoxon, or Kruskal-Wallis tests are
  approximated by using the \code{t} or \code{F} distributions.
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\references{
Hollander M. and Wolfe D.A. (1973).  Nonparametric Statistical Methods.
New York: Wiley.

Press WH, Flannery BP, Teukolsky SA, Vetterling, WT (1988): Numerical
Recipes in C.  Cambridge: Cambridge University Press.
}
\seealso{
\code{\link{combine.levels}},
\code{\link{varclus}}, \code{\link{dotchart3}}, \code{\link{impute}},
\code{\link{chisq.test}}, \code{\link{cut2}}.
}
\examples{
x <- c(-2, -1, 0, 1, 2)
y <- c(4,   1, 0, 1, 4)
z <- c(1,   2, 3, 4, NA)
v <- c(1,   2, 3, 4, 5)

spearman2(x, y)
plot(spearman2(z ~ x + y + v, p=2))

f <- chiSquare(z ~ x + y + v)
f
}
\keyword{nonparametric}
\keyword{htest}
\keyword{category}

\name{popower}
\alias{multEventChart}
\alias{popower}
\alias{posamsize}
\alias{print.popower}
\alias{print.posamsize}
\alias{pomodm}
\alias{propsPO}
\alias{propsTrans}
\title{Power and Sample Size for Ordinal Response}
\description{
\code{popower} computes the power for a two-tailed two sample comparison
of ordinal outcomes under the proportional odds ordinal logistic
model.  The power is the same as that of the Wilcoxon test but with
ties handled properly.  \code{posamsize} computes the total sample size
needed to achieve a given power.  Both functions compute the efficiency
of the design compared with a design in which the response variable
is continuous.  \code{print} methods exist for both functions.  Any of the
input arguments may be vectors, in which case a vector of powers or
sample sizes is returned.  These functions use the methods of
Whitehead (1993).

\code{pomodm} is a function that assists in translating odds ratios to
differences in mean or median on the original scale.

\code{propsPO} uses \code{\link{ggplot2}} to plot a stacked bar chart of
proportions stratified by a grouping variable (and optionally a stratification variable), with an optional
additional graph showing what the proportions would be had proportional
odds held and an odds ratio was applied to the proportions in a
reference group.  If the result is passed to \code{ggplotly}, customized
tooltip hover text will appear.

\code{propsTrans} uses \code{\link{ggplot2}} to plot all successive
transition proportions.  \code{formula} has the state variable on the
left hand side, the first right-hand variable is time, and the second
right-hand variable is a subject ID variable.\

\code{multEventChart} uses \code{\link{ggplot2}} to plot event charts
showing state transitions, account for absorbing states/events.  It is
based on code written by Lucy D'Agostino McGowan posted at \url{https://livefreeordichotomize.com/2020/05/21/survival-model-detective-1}.

}
\usage{
popower(p, odds.ratio, n, n1, n2, alpha=0.05)
\method{print}{popower}(x, \dots)
posamsize(p, odds.ratio, fraction=.5, alpha=0.05, power=0.8)
\method{print}{posamsize}(x, \dots)
pomodm(x=NULL, p, odds.ratio=1)
propsPO(formula, odds.ratio=NULL, ref=NULL, data=NULL, ncol=NULL, nrow=NULL )
propsTrans(formula, data=NULL, labels=NULL, arrow='\u2794',
           maxsize=12, ncol=NULL, nrow=NULL)
multEventChart(formula, data=NULL, absorb=NULL, sortbylast=FALSE,
   colorTitle=label(y), eventTitle='Event',
   palette='OrRd',
   eventSymbols=c(15, 5, 1:4, 6:10),
   timeInc=min(diff(unique(x))/2))
}
\arguments{
\item{p}{
a vector of marginal cell probabilities which must add up to one.
For \code{popower} and \code{posamsize}, The \code{i}th element specifies the probability that a patient will be
in response level \code{i}, averaged over the two treatment groups.  For
\code{pomodm}, \code{p} is the vector of cell probabilities to be
translated under a given odds ratio.
}
\item{odds.ratio}{
the odds ratio to be able to detect.  It doesn't
matter which group is in the numerator.  For \code{propsPO},
\code{odds.ratio} is a function of the grouping (right hand side)
variable value.  The value of the function specifies the odds ratio to
apply to the refernce group to get all other group's expected proportions
were proportional odds to hold against the first group.  Normally the
function should return 1.0 when its \code{x} argument corresponds to the
\code{ref} group.  For \code{pomodm} is the odds ratio to apply to
convert the given cell probabilities.}
\item{n}{
total sample size for \code{popower}.  You must specify either \code{n} or
\code{n1} and \code{n2}.  If you specify \code{n}, \code{n1} and
\code{n2} are set to \code{n/2}. 
}
\item{n1}{
for \code{popower}, the number of subjects in treatment group 1
}
\item{n2}{
for \code{popower}, the number of subjects in group 2
}
\item{alpha}{
type I error
}
\item{x}{an object created by \code{popower} or \code{posamsize}, or a
	vector of data values given to \code{pomodm} that corresponds to the
	vector \code{p} of probabilities.  If \code{x} is omitted for
	\code{pomodm}, the \code{odds.ratio} will be applied and the new
	vector of individual probabilities will be returned.  Otherwise if
	\code{x} is given to \code{pomodm}, a 2-vector with the mean and
	median \code{x} after applying the odds ratio is returned.}
\item{fraction}{
for \code{posamsize}, the fraction of subjects that will be allocated to group 1
}
\item{power}{
for \code{posamsize}, the desired power (default is 0.8)
}
\item{formula}{an R formula expressure for \code{proposPO} where the
	outcome categorical variable is on the left hand side and the grouping
	variable is on the right.  It is assume that the left hand variable is
	either already a factor or will have its levels in the right order for
	an ordinal model when it is converted to factor.  For
	\code{multEventChart} the left hand variable is a categorial status
	variable, the first right hand side variable represents time, and the
	second right side variable is a unique subject ID.  One line is
	produced per subject.}
\item{ref}{for \code{propsPO} specifies the reference group (value of
	the right hand side \code{formula} variable) to use in computing
	proportions on which too translate proportions in other groups, under
	the proportional odds assumption.}
\item{data}{a data frame or \code{data.table}}
\item{labels}{for \code{propsTrans} is an optional character vector
	corresponding to y=1,2,3,... that is used to construct \code{plotly}
	hovertext as a \code{label} attribute in the \code{ggplot2}
	aesthetic.  Used with y is integer on axes but you want long labels in
	hovertext.}
\item{arrow}{character to use as the arrow symbol for transitions in
	\code{propsTrans.  The default is the dingbats heavy wide-headed
		rightwards arror.}}
\item{nrow,ncol}{see \code{\link[ggplot2]{facet_wrap}}}
\item{maxsize}{maximum symbol size}
\item{\dots}{unused}
\item{absorb}{character vector specifying the subset of levels of the
	left hand side variable that are absorbing states such as death or
	hospital discharge}
\item{sortbylast}{set to \code{TRUE} to sort the subjects by the
	severity of the status at the last time point}
\item{colorTitle}{label for legend for status}
\item{eventTitle}{label for legend for \code{absorb}}
\item{palette}{a single character string specifying the
	\code{\link[ggplot2]{scale_fill_brewer}} color palette}
\item{eventSymbols}{vector of symbol codes.  Default for first two
	symbols is a solid square and an open diamond.}
\item{timeInc}{time increment for the x-axis.  Default is 1/2 the
	shortest gap between any two distincttimes in the data.}
}
\value{
a list containing \code{power}, \code{eff} (relative efficiency), and
\code{approx.se} (approximate standard error of log odds ratio) for
\code{popower}, or containing \code{n} and \code{eff} for \code{posamsize}.
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University School of Medicine
\cr
\email{fh@fharrell.com}
}
\references{
Whitehead J (1993): Sample size calculations for ordered categorical
data.  Stat in Med 12:2257--2271.


Julious SA, Campbell MJ (1996): Letter to the Editor.  Stat in Med 15:
1065--1066.  Shows accuracy of formula for binary response case.
}
\seealso{
\code{\link{simRegOrd}}, \code{\link{bpower}}, \code{\link{cpower}}
}
\examples{
# For a study of back pain (none, mild, moderate, severe) here are the
# expected proportions (averaged over 2 treatments) that will be in
# each of the 4 categories:


p <- c(.1,.2,.4,.3)
popower(p, 1.2, 1000)   # OR=1.2, total n=1000
posamsize(p, 1.2)
popower(p, 1.2, 3148)
# If p was the vector of probabilities for group 1, here's how to
# compute the average over the two groups:
# p2   <- pomodm(p=p, odds.ratio=1.2)
# pavg <- (p + p2) / 2

# Compare power to test for proportions for binary case,
# proportion of events in control group of 0.1
p <- 0.1; or <- 0.85; n <- 4000
popower(c(1 - p, p), or, n)    # 0.338
bpower(p, odds.ratio=or, n=n)  # 0.320
# Add more categories, starting with 0.1 in middle
p <- c(.8, .1, .1)
popower(p, or, n)   # 0.543
p <- c(.7, .1, .1, .1)
popower(p, or, n)   # 0.67
# Continuous scale with final level have prob. 0.1
p <- c(rep(1 / n, 0.9 * n), 0.1)
popower(p, or, n)   # 0.843

# Compute the mean and median x after shifting the probability
# distribution by an odds ratio under the proportional odds model
x <- 1 : 5
p <- c(.05, .2, .2, .3, .25)
# For comparison make up a sample that looks like this
X <- rep(1 : 5, 20 * p)
c(mean=mean(X), median=median(X))
pomodm(x, p, odds.ratio=1)  # still have to figure out the right median
pomodm(x, p, odds.ratio=0.5)

# An ordinal outcome with levels a, b, c, d, e is measured at 3 times
# Show the proportion of values in each outcome category stratified by
# time.  Then compute what the proportions would be had the proportions
# at times 2 and 3 been the proportions at time 1 modified by two odds ratios 

set.seed(1)
d   <- expand.grid(time=1:3, reps=1:30)
d$y <- sample(letters[1:5], nrow(d), replace=TRUE)
propsPO(y ~ time, data=d, odds.ratio=function(time) c(1, 2, 4)[time])
# To show with plotly, save previous result as object p and then:
# plotly::ggplotly(p, tooltip='label')

# Add a stratification variable and don't consider an odds ratio
d   <- expand.grid(time=1:5, sex=c('female', 'male'), reps=1:30)
d$y <- sample(letters[1:5], nrow(d), replace=TRUE)
propsPO(y ~ time + sex, data=d)  # may add nrow= or ncol=

# Show all successive transition proportion matrices
d   <- expand.grid(id=1:30, time=1:10)
d$state <- sample(LETTERS[1:4], nrow(d), replace=TRUE)
propsTrans(state ~ time + id, data=d)

pt1 <- data.frame(pt=1, day=0:3,
   status=c('well', 'well', 'sick', 'very sick'))
pt2 <- data.frame(pt=2, day=c(1,2,4,6),
   status=c('sick', 'very sick', 'coma', 'death'))
pt3 <- data.frame(pt=3, day=1:5,
   status=c('sick', 'very sick', 'sick', 'very sick', 'discharged'))
pt4 <- data.frame(pt=4, day=c(1:4, 10),
   status=c('well', 'sick', 'very sick', 'well', 'discharged'))
d <- rbind(pt1, pt2, pt3, pt4)
d$status <- factor(d$status, c('discharged', 'well', 'sick',
                               'very sick', 'coma', 'death'))
label(d$day) <- 'Day'
multEventChart(status ~ day + pt, data=d,
               absorb=c('death', 'discharged'),
               colorTitle='Status', sortbylast=TRUE) +
theme_classic() +
theme(legend.position='bottom')
}
\keyword{htest}
\keyword{category}
\concept{power}
\concept{study design}
\concept{ordinal logistic model}
\concept{ordinal response}
\concept{proportional odds model}

\name{na.keep}
\alias{na.keep}
\title{
Do-nothing na.action
}
\description{
Does not delete rows containing NAs, but does add details concerning
the distribution of the response variable if \code{options(na.detail.response=TRUE)}.
This \code{na.action} is primarily for use with \code{describe.formula}. 
}
\usage{
na.keep(mf)
}
\arguments{
\item{mf}{
a model frame
}}
\value{
the same model frame with the \code{"na.action"} attribute


}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\seealso{
\code{\link{na.omit}}, \code{\link{na.delete}}, \code{\link{model.frame.default}}, \code{\link{na.detail.response}},
\code{\link{naresid}}, \code{\link{naprint}}, \code{\link{describe}}
}
\examples{
options(na.action="na.keep", na.detail.response=TRUE)
x1 <- runif(20)
x2 <- runif(20)
x2[1:4] <- NA
y <- rnorm(20)
describe(y ~ x1*x2)
}
\keyword{models}
% Converted by Sd2Rd version 1.21.

\name{partition}
\alias{partition}
\alias{partition.vector}
\alias{partition.matrix}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Patitions an object into different sets}
\description{
  Partitions an object into subsets of length defined in the \code{sep}
  argument.
}
\usage{
partition.vector(x, sep, ...)
partition.matrix(x, rowsep, colsep, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{object to be partitioned. }
  \item{sep}{determines how many elements should go into each set.  The
    sum of \code{sep} should be equal to the length of \code{x}.}
  \item{rowsep}{determins how many rows should go into each set.  The
    sum of \code{rowsep} must equal the number of rows in \code{x}.}
  \item{colsep}{determins how many columns should go into each set.  The
    sum of \code{colsep} must equal the number of columns in \code{x}.}
  \item{\dots}{arguments used in other methods of \code{partition}.}
}
\value{
  A list of equal length as \code{sep} containing the partitioned objects.
}
\author{Charles Dupont}
\seealso{ \code{\link{split}}}
\examples{
a <- 1:7
partition.vector(a, sep=c(1,3,2,1))
}
% R documentation directory.
\keyword{manip}

\name{hdquantile}
\alias{hdquantile}
\title{Harrell-Davis Distribution-Free Quantile Estimator}
\description{
Computes the Harrell-Davis (1982) quantile estimator and jacknife
standard errors of quantiles.  The quantile estimator is a weighted
linear combination or order statistics in which the order statistics
used in traditional nonparametric quantile estimators are given the
greatest weight.  In small samples the H-D estimator is more efficient
than traditional ones, and the two methods are asymptotically
equivalent.  The H-D estimator is the limit of a bootstrap average as
the number of bootstrap resamples becomes infinitely large.
}
\usage{
hdquantile(x, probs = seq(0, 1, 0.25),
           se = FALSE, na.rm = FALSE, names = TRUE, weights=FALSE)
}
\arguments{
  \item{x}{a numeric vector}
  \item{probs}{vector of quantiles to compute}
  \item{se}{set to \code{TRUE} to also compute standard errors}
  \item{na.rm}{set to \code{TRUE} to remove \code{NA}s from \code{x}
	before computing quantiles}
  \item{names}{set to \code{FALSE} to prevent names attributions from
	being added to quantiles and standard errors}
  \item{weights}{set to \code{TRUE} to return a \code{"weights"}
	attribution with the matrix of weights used in the H-D estimator
	corresponding to order statistics, with columns corresponding to
	quantiles.}
}
\details{
A Fortran routine is used to compute the jackknife leave-out-one
quantile estimates.  Standard errors are not computed for quantiles 0 or
1 (\code{NA}s are returned).
}
\value{
  A vector of quantiles.  If \code{se=TRUE} this vector will have an
  attribute \code{se} added to it, containing the standard errors.  If
  \code{weights=TRUE}, also has a \code{"weights"} attribute which is a matrix.
}
\references{
  Harrell FE, Davis CE (1982): A new distribution-free quantile
  estimator.  Biometrika 69:635-640.

  Hutson AD, Ernst MD (2000): The exact bootstrap mean and variance of
  an L-estimator.  J Roy Statist Soc B 62:89-94.
}
\author{Frank Harrell}
\seealso{\code{\link{quantile}}}
\examples{
set.seed(1)
x <- runif(100)
hdquantile(x, (1:3)/4, se=TRUE)

\dontrun{
# Compare jackknife standard errors with those from the bootstrap
library(boot)
boot(x, function(x,i) hdquantile(x[i], probs=(1:3)/4), R=400)
}
}
\keyword{univar}

\name{simRegOrd}
\alias{simRegOrd}
\title{Simulate Power for Adjusted Ordinal Regression Two-Sample Test}
\description{
	This function simulates the power of a two-sample test from a
	proportional odds ordinal logistic model for a continuous response
	variable- a generalization of the Wilcoxon test.  The continuous data
	model is normal with equal variance.  Nonlinear covariate
	adjustment is allowed, and the user can optionally specify discrete
	ordinal level overrides to the continuous response.  For example, if
	the main response is systolic blood pressure, one can add two ordinal
	categories higher than the highest observed blood pressure to capture
	heart attack or death.
}
\usage{
simRegOrd(n, nsim=1000, delta=0, odds.ratio=1, sigma,
          p=NULL, x=NULL, X=x, Eyx, alpha=0.05, pr=FALSE)
}
\arguments{
	\item{n}{combined sample size (both groups combined)}
	\item{nsim}{number of simulations to run}
	\item{delta}{difference in means to detect, for continuous portion of
		response variable}
	\item{odds.ratio}{odds ratio to detect for ordinal overrides of
		continuous portion}
	\item{sigma}{standard deviation for continuous portion of response}
	\item{p}{a vector of marginal cell probabilities which must add up to one.
		The \code{i}th element specifies the probability that a patient will be
		in response level \code{i} for the control arm for the discrete
		ordinal overrides.}
	\item{x}{optional covariate to adjust for - a vector of length
		\code{n}}
	\item{X}{a design matrix for the adjustment covariate \code{x} if
		present.  This could represent for example \code{x} and \code{x^2}
		or cubic spline components.}
	\item{Eyx}{a function of \code{x} that provides the mean response for
		the control arm treatment}
	\item{alpha}{type I error}
	\item{pr}{set to \code{TRUE} to see iteration progress}
	}
\value{
a list containing \code{n, delta, sigma, power, betas, se, pvals} where
\code{power} is the estimated power (scalar), and \code{betas, se,
	pvals} are \code{nsim}-vectors containing, respectively, the ordinal
model treatment effect estimate, standard errors, and 2-tailed
p-values.  When a model fit failed, the corresponding entries in
\code{betas, se, pvals} are \code{NA} and \code{power} is the proportion
of non-failed iterations for which the treatment p-value is significant
at the \code{alpha} level.
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University School of Medicine
\cr
\email{fh@fharrell.com}
}
\seealso{\code{\link{popower}}}
\examples{
\dontrun{
## First use no ordinal high-end category overrides, and compare power
## to t-test when there is no covariate

n <- 100
delta <- .5
sd <- 1
require(pwr)
power.t.test(n = n / 2, delta=delta, sd=sd, type='two.sample')  # 0.70
set.seed(1)
w <- simRegOrd(n, delta=delta, sigma=sd, pr=TRUE)     # 0.686

## Now do ANCOVA with a quadratic effect of a covariate
n <- 100
x <- rnorm(n)
w <- simRegOrd(n, nsim=400, delta=delta, sigma=sd, x=x,
               X=cbind(x, x^2),
               Eyx=function(x) x + x^2, pr=TRUE)
w$power  # 0.68

## Fit a cubic spline to some simulated pilot data and use the fitted
## function as the true equation in the power simulation
require(rms)
N <- 1000
set.seed(2)
x <- rnorm(N)
y <- x + x^2 + rnorm(N, 0, sd=sd)
f <- ols(y ~ rcs(x, 4), x=TRUE)

n <- 100
j <- sample(1 : N, n, replace=n > N)
x <-   x[j]
X <- f$x[j,]
w <- simRegOrd(n, nsim=400, delta=delta, sigma=sd, x=x,
               X=X,
               Eyx=Function(f), pr=TRUE)
w$power  ## 0.70

## Finally, add discrete ordinal category overrides and high end of y
## Start with no effect of treatment on these ordinal event levels (OR=1.0)

w <- simRegOrd(n, nsim=400, delta=delta, odds.ratio=1, sigma=sd,
               x=x, X=X, Eyx=Function(f),
               p=c(.98, .01, .01),
               pr=TRUE)
w$power  ## 0.61   (0.3 if p=.8 .1 .1, 0.37 for .9 .05 .05, 0.50 for .95 .025 .025)

## Now assume that odds ratio for treatment is 2.5
## First compute power for clinical endpoint portion of Y alone
or <- 2.5
p <- c(.9, .05, .05)
popower(p, odds.ratio=or, n=100)   # 0.275
## Compute power of t-test on continuous part of Y alone
power.t.test(n = 100 / 2, delta=delta, sd=sd, type='two.sample')  # 0.70
## Note this is the same as the p.o. model power from simulation above
## Solve for OR that gives the same power estimate from popower
popower(rep(.01, 100), odds.ratio=2.4, n=100)   # 0.706
## Compute power for continuous Y with ordinal override
w <- simRegOrd(n, nsim=400, delta=delta, odds.ratio=or, sigma=sd,
               x=x, X=X, Eyx=Function(f),
               p=c(.9, .05, .05),
               pr=TRUE)
w$power  ## 0.72
}
}
\keyword{htest}
\keyword{category}
\concept{power}
\concept{study design}
\concept{ordinal logistic model}
\concept{ordinal response}
\concept{proportional odds model}

\name{stata.get}
\alias{stata.get}
\title{Enhanced Importing of STATA Files}
\description{
  Reads a file in Stata version 5-11 binary format format into a
  data frame.
}
\usage{
stata.get(file, lowernames = FALSE, convert.dates = TRUE,
          convert.factors = TRUE, missing.type = FALSE,
          convert.underscore = TRUE, warn.missing.labels = TRUE,
          force.single = TRUE, allow=NULL, charfactor=FALSE, \dots)
}
\arguments{
  \item{file}{input \acronym{SPSS} save file.  May be a file on the \acronym{WWW}, indicated
    by \code{file} starting with \samp{'https://'}.}
  \item{lowernames}{set to \code{TRUE} to convert variable names to
    lower case}
  \item{convert.dates}{see \code{\link[foreign]{read.dta}}}
  \item{convert.factors}{see \code{\link[foreign]{read.dta}}}
  \item{missing.type}{see \code{\link[foreign]{read.dta}}}
  \item{convert.underscore}{see \code{\link[foreign]{read.dta}}}
  \item{warn.missing.labels}{see \code{\link[foreign]{read.dta}}}
  \item{force.single}{set to \code{FALSE} to prevent integer-valued
    variables from being converted from storage mode \code{double} to
    \code{integer}}
  \item{allow}{a vector of characters allowed by \R that should not be
	converted to periods in variable names.  By default, underscores in
	variable names are converted to periods as with \R before version 1.9.}
  \item{charfactor}{set to \code{TRUE} to change character variables to
	factors if they have fewer than n/2 unique values.  Blanks and null
	strings are converted to \code{NA}s.}
  \item{\dots}{arguments passed to \code{\link[foreign]{read.dta}}.}
}
\details{
  \code{stata.get} invokes the \code{\link[foreign]{read.dta}} function in the
  \pkg{foreign} package to read an STATA file, with a default output
  format of \code{\link{data.frame}}.  The \code{\link{label}} function is used to
  attach labels to individual variables instead of to the data frame as
  done by \code{\link[foreign]{read.dta}}.  By default, integer-valued variables are
  converted to a storage mode of integer unless
  \code{force.single=FALSE}.  Date variables are converted to \R
  \code{\link{Date}} variables.  By default, underscores in names are converted to periods.
}
\value{A data frame}
\author{Charles Dupont}
\seealso{\code{\link[foreign]{read.dta}},\code{\link{cleanup.import}},\code{\link{label}},\code{\link{data.frame}},\code{\link{Date}}}
\examples{
\dontrun{
w <- stata.get('/tmp/my.dta')
}
}
\keyword{interface}
\keyword{manip}
\keyword{file}
\concept{STATA data file}

\name{rlegend}
\alias{rlegend}
\alias{rlegendg}
\title{Special Version of legend for R}
\description{
  \code{rlegend} is a version of \code{\link{legend}} for \R that implements
  \code{plot=FALSE}, adds \code{grid=TRUE}, and defaults \code{lty},
  \code{lwd}, \code{pch} to \code{NULL} and checks for \code{length>0}
  rather than \code{missing()}, so it's easier to deal with
  non-applicable parameters.  But when \pkg{grid} is in effect, the
  preferred function to use is \code{rlegendg}, which calls the
  \pkg{lattice} \code{\link[lattice]{draw.key}} function.
}
\usage{
rlegend(x, y, legend, fill, col = "black", lty = NULL, lwd = NULL,
        pch = NULL, angle = NULL, density = NULL, bty = "o",
        bg = par("bg"), pt.bg = NA, cex = 1, xjust = 0, yjust = 1,
        x.intersp = 1, y.intersp = 1, adj = 0, text.width = NULL,
        merge = do.lines && has.pch, trace = FALSE, ncol = 1,
        horiz = FALSE, plot = TRUE, grid = FALSE, \dots)

rlegendg(x, y, legend, col=pr$col[1], lty=NULL,
         lwd=NULL, pch=NULL, cex=pr$cex[1], other=NULL) 
}
\arguments{
  \item{x,y,legend,fill,col,lty,lwd,pch,angle,density,bty,bg,pt.bg,cex,xjust,
    yjust,x.intersp,y.intersp,adj,text.width,merge,trace,ncol,horiz}{
    see \code{\link{legend}}
  }
  \item{plot}{set to \code{FALSE} to suppress drawing the legend.  This
    is used the compute the size needed for when the legend is drawn
    with a later call to \code{rlegend}.
  }
  \item{grid}{set to \code{TRUE} if the \pkg{grid} package is in effect}
  \item{\dots}{see \code{\link{legend}}}
  \item{other}{
    a list containing other arguments to pass to
    \code{draw.key}.  See the help file for \code{\link[lattice]{xyplot}}.
  }
}
\value{
  a list with elements \code{rect} and \code{text}.  \code{rect} has
  elements \code{w, h, left, top} with size/position information.
}
\author{Frank Harrell and R-Core}
\seealso{
  \code{\link{legend}}, \code{\link[lattice]{draw.key}}, \code{\link[lattice]{xyplot}}
}
\keyword{aplot}

\name{ffCompress}
\alias{ffCompress}
\alias{as.data.frame.ffdflabel}
\alias{[.ffdflabel}
\title{Transform Data Frame Into a Compact \code{ff} Object}
\description{
	The \code{ff} package implements a wide variety of atomic data types
	down to 2 bits, allowing for compact storage of large datasets and
	requiring memory usage in R for only those rows and columns of the
	dataset that are needed at one time.  It is best to create a compact
	\code{ffdf} data frame object while initially reading the external
	data file, using for example an input \code{.csv} file and specifying
	the \code{ff} \code{vmode}s for all the columns.  If you can get
	enough memory to read the entire dataset into an R \code{data.frame}
	you can use \code{ffCompress} after the fact to analyze the data frame
	and use the most compact data representation possible.  This entails
	using single precision for floating point numbers (which can be easily
	overridden to use R's usual double precision) and a variety of integer
	types depend on the number of bits used by the maximum absolute value
	of the variable, whether or not \code{NA}s exist in the data, and
	whether or not negative values are possible.

	Since \code{ff} does not allow variable labels and units, any such
	attributes are stripped off of variables and stored as attributes on the
	entire \code{ffdf} object.  An \code{as.data.frame} and subscripting
	method retrieves these attributes and restores them to individual
	variables when needed.
}
\usage{
ffCompress(obj, float=c('single', 'double'), print=FALSE)

\method{as.data.frame}{ffdflabel}(x, \dots)
}
\arguments{
  \item{obj}{a data frame}
	\item{float}{representation to use for floating point vectors.  The
		default is single precision (4 bytes, 7 significant digits).
		Specify \code{float='double'} to use double precision (8 bytes, 15
		significant digits)}
	\item{print}{set to \code{TRUE} to get progress output and passed as
		the \code{VERBOSE} argument to \code{ff} functions}
	\item{x}{an \code{ffdf} object}
	\item{\dots}{ignored}
}
\value{
	an \code{ffdf} object for \code{ffCompress}, a \code{data.frame} for
	\code{as.data.frame}, and either one of these for subscripting.  If
	subscripting results in a single variable and \code{drop=FALSE} is not
	specified, the result is of \code{ff} type.
}
\author{Frank Harrell, Vanderbilt University}
\seealso{\code{\link[Hmisc]{cleanup.import}}}
\examples{
\dontrun{
require(ff)
require(survival)
n <- 1e6
d <- data.frame(x=rnorm(n), y=sample(0:1, n, TRUE),
                i=as.Date('2013-01-02'), S=Surv(runif(n)),
                z=factor(sample(1:3, n, TRUE), 1:3,
                  c('elephant','giraffe','dog')))
## Cannot have labels for variables; ff will reject as non-atomic vectors
storage.mode(d$y)
object.size(d)
n * (8 + 4 + 4 + 4)
f <- as.ffdf(d, vmode=c('single', 'quad', 'integer', 'single', 'quad'))
vmode(f)
n * (4 + 0.25 + 4 + 0.25)
object.size(as.data.frame(f))
f[1:10,]
hist(d[,'x'] - f[,'x'], nclass=100)
table(d[,'z'], f[,'z'])

system.time(subset(f, z == 'dog'))
system.time({i <- ffwhich(f, z == 'dog'); f[i,]})
table(subset(f, z == 'dog')[,'z'])
class(subset(f, z == 'dog'))

ffsave(f, file='/tmp/f')  # creates /tmp/f.ffData /tmp/f.RData
## To load: ffload('/tmp/f')

d <- upData(d, labels=c(y='Y'), units=c(z='units z'))
f <- ffCompress(d)
vmode(f)

load('ras.rda')   # dataset is not available
r <- ffCompress(ras)
vmode(r)
attr(r, 'label')
attr(r, 'units')
all.equal(ras, as.data.frame(r))
dr <- as.data.frame(r)
g <- function(x) names(attributes(x))
nam <- names(dr)
for(i in 1 : ncol(dr)) {
  a <- ras[[i]]
  b <- dr[[i]]
  cat(nam[i], '\n')
  cat(g(a), '\n', g(b), '\n')
  cat(max(w <- abs(unclass(a) - unclass(b)), na.rm=TRUE), '\n')
  if(nam[i] == 'ldl') {
    j <- which.max(abs(w))
    cat(a[j], b[j], '\n')
  }
}

dr <- as.data.frame(r)
xless(contents(dr))
xless(contents(r[1:10,]))
xless(contents(r[,1:10]))

table(r[, 'gender'])
## subset invokes [] so uses method from ffdflabel
m <- subset(r, gender == 'Male')
class(m)
dim(m)
attr(m, 'label')
attributes(m[,'age'])
df <- as.data.frame(m)
class(df$age)
label(df$age)
## But if subset again things are not OK
k <- subset(m, age < 3)
class(k)
contents(k[, 'age', drop=FALSE])
invisible(ffsave(r, file='/tmp/r'))

## w <- read.csv.ffdf(file='/tmp/data.csv', first.rows=10000)
## table(vmode(w))

## From ff manual:  vmode definitions
# boolean 1 bit logical without NA
# logical 2 bit logical with NA
# quad 2 bit unsigned integer without NA
# nibble 4 bit unsigned integer without NA
# byte 8 bit signed integer with NA
# ubyte 8 bit unsigned integer without NA
# short 16 bit signed integer with NA
# ushort 16 bit unsigned integer without NA
# integer 32 bit signed integer with NA
# single 32 bit float
# double 64 bit float
# complex 2x64 bit float
# raw 8 bit unsigned char
# character character
}
}
\keyword{attribute}
\keyword{misc}
\keyword{utilities}

\name{xtfrm.labelled}
\alias{xtfrm.labelled}
\title{
  Auxiliary Function Method for Sorting and Ranking
}
\description{
  An auxiliary function method that is a workaround for bug in the
  implementation of xtfrm handles inheritance.
}
\usage{
\method{xtfrm}{labelled}(x)
}
\arguments{
  \item{x}{
    any object of class labelled.
  }
}
\seealso{
  \code{\link{xtfrm}}
}

\name{mApply}
\concept{apply for matrix}
\concept{apply for vector}
\alias{mApply}

\title{Apply a Function to Rows of a Matrix or Vector}

\description{
\code{mApply} is like \code{tapply} except that the first argument can
be a matrix or a vector, and the output is cleaned up if \code{simplify=TRUE}.
It uses code adapted from Tony Plate (\email{tplate@blackmesacapital.com}) to
operate on grouped submatrices.

As \code{mApply} can be much faster than using \code{by}, it is often
worth the trouble of converting a data frame to a numeric matrix for
processing by \code{mApply}.  \code{asNumericMatrix} will do this, and
\code{matrix2dataFrame} will convert a numeric matrix back into a data
frame.
}

\usage{
mApply(X, INDEX, FUN, \dots, simplify=TRUE, keepmatrix=FALSE)
}

\arguments{
\item{X}{
a vector or matrix capable of being operated on by the
function specified as the \code{FUN} argument
}
\item{INDEX}{
list of factors, each of same number of rows as 'X' has.
}
\item{FUN}{
the function to be applied.  In the case of functions like
'+', '%*%', etc., the function name must be quoted.
}
\item{\dots}{
optional arguments to 'FUN'.
}
\item{simplify}{
set to 'FALSE' to suppress simplification of the result in to
an array, matrix, etc.
}
\item{keepmatrix}{set to \code{TRUE} to keep result as a matrix even if
  \code{simplify} is \code{TRUE}, in the case of only one stratum
  }
}
\value{
For \code{mApply}, the returned value is a vector, matrix, or list.
If \code{FUN} returns more than one number, the result is an array if
\code{simplify=TRUE} and is a list otherwise.  If a matrix is returned,
its rows correspond to unique combinations of \code{INDEX}.  If
\code{INDEX} is a list with more than one vector, \code{FUN} returns
more than one number, and \code{simplify=FALSE}, the returned value is a
list that is an array with the first dimension corresponding to the last
vector in \code{INDEX}, the second dimension corresponding to the next
to last vector in \code{INDEX}, etc., and the elements of the list-array
correspond to the values computed by \code{FUN}.  In this situation the
returned value is a regular array if \code{simplify=TRUE}.   The order
of dimensions is as previously but the additional (last) dimension
corresponds to values computed by \code{FUN}.
}

\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}

\seealso{
\code{\link{asNumericMatrix}}, \code{\link{matrix2dataFrame}}, \code{\link{tapply}},
\code{\link{sapply}}, \code{\link{lapply}}, \code{\link{mapply}}, \code{\link{by}}.
}

\examples{
require(datasets, TRUE)
a <- mApply(iris[,-5], iris$Species, mean)
}

\keyword{iteration}
\keyword{category}

\name{bootkm}
\alias{bootkm}
\title{
  Bootstrap Kaplan-Meier Estimates
}
\description{
  Bootstraps Kaplan-Meier estimate of the probability of survival to at
  least a fixed time (\code{times} variable) or the estimate of the \code{q}
  quantile of the survival distribution (e.g., median survival time, the
  default).
}
\usage{
bootkm(S, q=0.5, B=500, times, pr=TRUE)
}
\arguments{
  \item{S}{
    a \code{Surv} object for possibly right-censored survival time
  }
  \item{q}{
    quantile of survival time, default is 0.5 for median
  }
  \item{B}{
    number of bootstrap repetitions (default=500)
  }
  \item{times}{
    time vector (currently only a scalar is allowed) at which to compute
    survival estimates.  You may specify only one of \code{q} and
    \code{times}, and if \code{times} is specified \code{q} is ignored. 
  }
  \item{pr}{
    set to \code{FALSE} to suppress printing the iteration number every
    10 iterations
  }
}
\value{
  a vector containing \code{B} bootstrap estimates
}
\section{Side Effects}{
  updates \code{.Random.seed}, and, if \code{pr=TRUE}, prints progress
  of simulations
}
\details{
  \code{bootkm} uses Therneau's \code{survfitKM} function to efficiently
  compute Kaplan-Meier estimates.
}
\author{
  Frank Harrell
  \cr
  Department of Biostatistics
  \cr
  Vanderbilt University School of Medicine
  \cr
  \email{fh@fharrell.com}
}
\references{
  Akritas MG (1986): Bootstrapping the Kaplan-Meier estimator.  JASA
  81:1032--1038.
}
\seealso{
  \code{\link[survival]{survfit}}, \code{\link[survival]{Surv}},
  \code{\link[rms]{Survival.cph}}, \code{\link[rms]{Quantile.cph}}
}
\examples{
# Compute 0.95 nonparametric confidence interval for the difference in
# median survival time between females and males (two-sample problem)
set.seed(1)
library(survival)
S <- Surv(runif(200))      # no censoring
sex <- c(rep('female',100),rep('male',100))
med.female <- bootkm(S[sex=='female',], B=100) # normally B=500
med.male   <- bootkm(S[sex=='male',],   B=100)
describe(med.female-med.male)
quantile(med.female-med.male, c(.025,.975), na.rm=TRUE)
# na.rm needed because some bootstrap estimates of median survival
# time may be missing when a bootstrap sample did not include the
# longer survival times
}
\keyword{survival}
\keyword{nonparametric}
\concept{bootstrap}

\name{redun}
\alias{redun}
\alias{print.redun}
\title{Redundancy Analysis}
\description{
Uses flexible parametric additive models (see \code{\link{areg}} and its
use of regression splines), or alternatively to run a regular regression
after replacing continuous variables with ranks, to
determine how well each variable can be predicted from the remaining
variables.  Variables are dropped in a stepwise fashion, removing the
most predictable variable at each step. The remaining variables are used
to predict.  The process continues until no variable still in the list
of predictors can be predicted with an \eqn{R^2} or adjusted \eqn{R^2}
of at least \code{r2} or until dropping the variable with the highest
\eqn{R^2} (adjusted or ordinary) would cause a variable that was dropped
earlier to no longer be predicted at least at the \code{r2} level from
the now smaller list of predictors.

There is also an option \code{qrank} to expand each variable into two
columns containing the rank and square of the rank.  Whenever ranks are
used, they are computed as fractional ranks for numerical reasons.
}
\usage{
redun(formula, data=NULL, subset=NULL, r2 = 0.9,
      type = c("ordinary", "adjusted"), nk = 3, tlinear = TRUE,
      rank=qrank, qrank=FALSE,
      allcat=FALSE, minfreq=0, iterms=FALSE, pc=FALSE, pr = FALSE, ...)
\method{print}{redun}(x, digits=3, long=TRUE, ...)
}
\arguments{
  \item{formula}{a formula.  Enclose a variable in \code{I()} to force
	linearity.  Alternately, can be a numeric matrix, in which case the
	data are not run through \code{dataframeReduce}.  This is useful when
	running the data through \code{transcan} first for nonlinearly
	transforming the data.}
  \item{data}{a data frame, which must be omitted if \code{formula} is a
	matrix}
  \item{subset}{usual subsetting expression}
  \item{r2}{ordinary or adjusted \eqn{R^2} cutoff for redundancy}
  \item{type}{specify \code{"adjusted"} to use adjusted \eqn{R^2}}
  \item{nk}{number of knots to use for continuous variables.  Use
	\code{nk=0} to force linearity for all variables.}
  \item{tlinear}{set to \code{FALSE} to allow a variable to be automatically
	nonlinearly transformed (see \code{areg}) while being predicted.  By
  default, only continuous variables on the right hand side (i.e., while
  they are being predictors) are automatically transformed, using
  regression splines.  Estimating transformations for target (dependent)
  variables causes more overfitting than doing so for predictors.}
  \item{rank}{set to \code{TRUE} to replace non-categorical varibles
		with ranks before running the analysis.  This causes \code{nk} to be
		set to zero.}
	\item{qrank}{set to \code{TRUE} to also include squares of ranks to
		allow for non-monotonic transformations}
  \item{allcat}{set to \code{TRUE} to ensure that all categories of
	categorical variables having more than two categories are redundant
	(see details below)}
  \item{minfreq}{For a binary or categorical variable, there must be at
	least two categories with at least \code{minfreq} observations or
	the variable will be dropped and not checked for redundancy against
	other variables.  \code{minfreq} also specifies the minimum
	frequency of a category or its complement 
	before that category is considered when \code{allcat=TRUE}.}
  \item{iterms}{set to \code{TRUE} to consider derived terms (dummy
	variables and nonlinear spline components) as separate variables.
	This will perform a redundancy analysis on pieces of the variables.}
  \item{pc}{if \code{iterms=TRUE} you can set \code{pc} to \code{TRUE}
	to replace the submatrix of terms corresponding to each variable
	with the orthogonal principal components before doing the redundancy
	analysis.  The components are based on the correlation matrix.}
  \item{pr}{set to \code{TRUE} to monitor progress of the stepwise algorithm}
  \item{\dots}{arguments to pass to \code{dataframeReduce} to remove
	"difficult" variables from \code{data} if \code{formula} is
	\code{~.} to use all variables in \code{data} (\code{data} must be
	specified when these arguments are used).  Ignored for \code{print}.}
  \item{x}{an object created by \code{redun}}
  \item{digits}{number of digits to which to round \eqn{R^2} values when
	printing}
  \item{long}{set to \code{FALSE} to prevent the \code{print} method
	from printing the \eqn{R^2} history and the original \eqn{R^2} with
	which each variable can be predicted from ALL other variables.}
}
\value{an object of class \code{"redun"} including an element \code{"scores"}, a numeric matrix with all transformed values when each variable was the dependent variable and the first canonical variate was computed }
\details{
A categorical variable is deemed
redundant if a linear combination of dummy variables representing it can
be predicted from a linear combination of other variables.  For example,
if there were 4 cities in the data and each city's rainfall was also
present as a variable, with virtually the same rainfall reported for all
observations for a city, city would be redundant given rainfall (or
vice-versa; the one declared redundant would be the first one in the
formula). If two cities had the same rainfall, \code{city} might be
declared redundant even though tied cities might be deemed non-redundant
in another setting.  To ensure that all categories may be predicted well
from other variables, use the \code{allcat} option.  To ignore
categories that are too infrequent or too frequent, set \code{minfreq}
to a nonzero integer.  When the number of observations in the category
is below this number or the number of observations not in the category
is below this number, no attempt is made to predict observations being
in that category individually for the purpose of redundancy detection.}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\seealso{\code{\link{areg}}, \code{\link{dataframeReduce}},
  \code{\link{transcan}}, \code{\link{varclus}}, \code{\link{r2describe}},
  \code{subselect::genetic}}
\examples{
set.seed(1)
n <- 100
x1 <- runif(n)
x2 <- runif(n)
x3 <- x1 + x2 + runif(n)/10
x4 <- x1 + x2 + x3 + runif(n)/10
x5 <- factor(sample(c('a','b','c'),n,replace=TRUE))
x6 <- 1*(x5=='a' | x5=='c')
redun(~x1+x2+x3+x4+x5+x6, r2=.8)
redun(~x1+x2+x3+x4+x5+x6, r2=.8, minfreq=40)
redun(~x1+x2+x3+x4+x5+x6, r2=.8, allcat=TRUE)
# x5 is no longer redundant but x6 is
redun(~x1+x2+x3+x4+x5+x6, r2=.8, rank=TRUE)
redun(~x1+x2+x3+x4+x5+x6, r2=.8, qrank=TRUE)

# To help decode which variables made a particular variable redundant:
# r <- redun(...)
# r2describe(r$scores)
}
\keyword{smooth}
\keyword{regression}
\keyword{multivariate}
\keyword{methods}
\keyword{models}
\concept{data reduction}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/princmp.r
\name{plot.princmp}
\alias{plot.princmp}
\title{plot.princmp}
\usage{
\method{plot}{princmp}(
  x,
  which = c("scree", "loadings"),
  k = x$k,
  offset = 0.8,
  col = 1,
  adj = 0,
  ylim = NULL,
  add = FALSE,
  abbrev = 25,
  nrow = NULL,
  ...
)
}
\arguments{
\item{x}{results of `princmp`}

\item{which}{'`scree`' or '`loadings'`}

\item{k}{number of components to show, default is `k` specified to `princmp`}

\item{offset}{controls positioning of text labels for cumulative fraction of variance explained}

\item{col}{color of plotted text in scree plot}

\item{adj}{angle for plotting text in scree plot}

\item{ylim}{y-axis scree plotting limits, a 2-vector}

\item{add}{set to `TRUE` to add a line to an existing scree plot without drawing axes}

\item{abbrev}{an integer specifying the variable name length above which names are passed through [abbreviate(..., minlength=abbrev)]}

\item{nrow}{number of rows to use in plotting loadings.  Defaults to the `ggplot2` `facet_wrap` default.}

\item{...}{unused}
}
\value{
`ggplot2` object if `which='loadings'`
}
\description{
Plot Method for princmp
}
\details{
Uses base graphics to by default plot the scree plot from a [princmp()] result, showing cumultive proportion of variance explained.  Alternatively the standardized PC loadings are shown in a `ggplot2` bar chart.
}
\author{
Frank Harrell
}

\name{sys}
\alias{sys}
\title{
Run Unix or Dos Depending on System
}
\description{
Runs \code{unix} or \code{dos} depending on the current operating system.  For
\R, just runs \code{system} with optional concatenation of first two
arguments which are assumed named \code{command} and \code{text}.
}
\usage{
sys(command, text=NULL, output=TRUE)
# S-Plus: sys(\dots, minimized=FALSE)
}
\arguments{
\item{command}{
system command to execute
}
\item{text}{
text to concatenate to system command, if any (typically options or file
names or both)
}
\item{output}{
  set to \code{FALSE} to not return output of command as a character
  vector
}
}
\value{
see \code{unix} or \code{dos}
}
\section{Side Effects}{
executes system commands
}
\seealso{
\code{\link{unix}}, \code{\link{system}}
}
\keyword{interface}

\name{areg}
\alias{areg}
\alias{print.areg}
\alias{predict.areg}
\alias{plot.areg}
\title{Additive Regression with Optimal Transformations on Both Sides using
Canonical Variates}
\description{
Expands continuous variables into restricted cubic spline bases and
categorical variables into dummy variables and fits a multivariate
equation using canonical variates.  This finds optimum transformations
that maximize \eqn{R^2}.  Optionally, the bootstrap is used to estimate
the covariance matrix of both left- and right-hand-side transformation
parameters, and to estimate the bias in the \eqn{R^2} due to overfitting
and compute the bootstrap optimism-corrected \eqn{R^2}.
Cross-validation can also be used to get an unbiased estimate of
\eqn{R^2} but this is not as precise as the bootstrap estimate.  The
bootstrap and cross-validation may also used to get estimates of mean
and median absolute error in predicted values on the original \code{y}
scale.  These two estimates are perhaps the best ones for gauging the
accuracy of a flexible model, because it is difficult to compare
\eqn{R^2} under different y-transformations, and because \eqn{R^2}
allows for an out-of-sample recalibration (i.e., it only measures
relative errors).

Note that uncertainty about the proper transformation of \code{y} causes
an enormous amount of model uncertainty.  When the transformation for
\code{y} is estimated from the data a high variance in predicted values
on the original \code{y} scale may result, especially if the true
transformation is linear.  Comparing bootstrap or cross-validated mean
absolute errors with and without restricted the \code{y} transform to be
linear (\code{ytype='l'}) may help the analyst choose the proper model
complexity.
}
\usage{
areg(x, y, xtype = NULL, ytype = NULL, nk = 4,
     B = 0, na.rm = TRUE, tolerance = NULL, crossval = NULL)

\method{print}{areg}(x, digits=4, \dots)

\method{plot}{areg}(x, whichx = 1:ncol(x$x), \dots)

\method{predict}{areg}(object, x, type=c('lp','fitted','x'),
                       what=c('all','sample'), \dots)
}
\arguments{
  \item{x}{
	A single predictor or a matrix of predictors.  Categorical
	predictors are required to be coded as integers (as \code{factor}
	does internally).
	For \code{predict}, \code{x} is a data matrix with the same integer
	codes that were originally used for categorical variables.
	}
  \item{y}{a \code{factor}, categorical, character, or numeric response
	variable}
  \item{xtype}{
	a vector of one-letter character codes specifying how each predictor
	is to be modeled, in order of columns of \code{x}.  The codes are
	\code{"s"} for smooth function (using restricted cubic splines),
	\code{"l"} for no transformation (linear), or \code{"c"} for
	categorical (to cause expansion into dummy variables).  Default is
	\code{"s"} if \code{nk > 0} and \code{"l"} if \code{nk=0}.
  }
  \item{ytype}{same coding as for \code{xtype}.  Default is \code{"s"}
	for a numeric variable with more than two unique values, \code{"l"}
	for a binary numeric variable, and \code{"c"} for a factor,
	categorical, or character variable.}
  \item{nk}{number of knots, 0 for linear, or 3 or more.  Default is 4
	which will fit 3 parameters to continuous variables (one linear term
  and two nonlinear terms)}
  \item{B}{number of bootstrap resamples used to estimate covariance
	matrices of transformation parameters.  Default is no bootstrapping.}
  \item{na.rm}{set to \code{FALSE} if you are sure that observations
	with \code{NA}s have already been removed}
  \item{tolerance}{singularity tolerance.  List source code for
	\code{lm.fit.qr.bare} for details.}
  \item{crossval}{set to a positive integer k to compute k-fold
	cross-validated R-squared (square of first canonical correlation)
	and mean and median absolute error of predictions on the original scale}
  \item{digits}{number of digits to use in formatting for printing}
  \item{object}{an object created by \code{areg}}
  \item{whichx}{integer or character vector specifying which predictors
	are to have their transformations plotted (default is all).  The
	\code{y} transformation is always plotted.}
  \item{type}{tells \code{predict} whether to obtain predicted
	untransformed \code{y} (\code{type='lp'}, the default) or predicted
	\code{y} on the original scale (\code{type='fitted'}), or the design
    matrix for the right-hand side (\code{type='x'}).}
  \item{what}{When the \code{y}-transform is non-monotonic you may
	specify \code{what='sample'} to \code{predict} to obtain a random
	sample of \code{y} values on the original scale instead of a matrix
	of all \code{y}-inverses.  See \code{\link{inverseFunction}}.}
  \item{\dots}{arguments passed to the plot function.}
}
\details{
\code{areg} is a competitor of \code{ace} in the \code{acepack}
package.  Transformations from \code{ace} are seldom smooth enough and
are often overfitted.  With \code{areg} the complexity can be controlled
with the \code{nk} parameter, and predicted values are easy to obtain
because parametric functions are fitted.

If one side of the equation has a categorical variable with more than
two categories and the other side has a continuous variable not assumed
to act linearly, larger sample sizes are needed to reliably estimate
transformations, as it is difficult to optimally score categorical
variables to maximize \eqn{R^2} against a simultaneously optimally
transformed continuous variable.
}
\value{
  a list of class \code{"areg"} containing many objects
}
\references{Breiman and Friedman, Journal of the American Statistical
     Association (September, 1985).} 
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\seealso{\code{\link{cancor}},\code{\link[acepack]{ace}}, \code{\link{transcan}}}
\examples{
set.seed(1)

ns <- c(30,300,3000)
for(n in ns) {
  y <- sample(1:5, n, TRUE)
  x <- abs(y-3) + runif(n)
  par(mfrow=c(3,4))
  for(k in c(0,3:5)) {
    z <- areg(x, y, ytype='c', nk=k)
    plot(x, z$tx)
	title(paste('R2=',format(z$rsquared)))
    tapply(z$ty, y, range)
    a <- tapply(x,y,mean)
    b <- tapply(z$ty,y,mean)
    plot(a,b)
	abline(lsfit(a,b))
    # Should get same result to within linear transformation if reverse x and y
    w <- areg(y, x, xtype='c', nk=k)
    plot(z$ty, w$tx)
    title(paste('R2=',format(w$rsquared)))
    abline(lsfit(z$ty, w$tx))
 }
}

par(mfrow=c(2,2))
# Example where one category in y differs from others but only in variance of x
n <- 50
y <- sample(1:5,n,TRUE)
x <- rnorm(n)
x[y==1] <- rnorm(sum(y==1), 0, 5)
z <- areg(x,y,xtype='l',ytype='c')
z
plot(z)
z <- areg(x,y,ytype='c')
z
plot(z)

\dontrun{		
# Examine overfitting when true transformations are linear
par(mfrow=c(4,3))
for(n in c(200,2000)) {
  x <- rnorm(n); y <- rnorm(n) + x
    for(nk in c(0,3,5)) {
    z <- areg(x, y, nk=nk, crossval=10, B=100)
    print(z)
    plot(z)
    title(paste('n=',n))
  }
}
par(mfrow=c(1,1))

# Underfitting when true transformation is quadratic but overfitting
# when y is allowed to be transformed
set.seed(49)
n <- 200
x <- rnorm(n); y <- rnorm(n) + .5*x^2
#areg(x, y, nk=0, crossval=10, B=100)
#areg(x, y, nk=4, ytype='l', crossval=10, B=100)
z <- areg(x, y, nk=4) #, crossval=10, B=100)
z
# Plot x vs. predicted value on original scale.  Since y-transform is
# not monotonic, there are multiple y-inverses
xx <- seq(-3.5,3.5,length=1000)
yhat <- predict(z, xx, type='fitted')
plot(x, y, xlim=c(-3.5,3.5))
for(j in 1:ncol(yhat)) lines(xx, yhat[,j], col=j)
# Plot a random sample of possible y inverses
yhats <- predict(z, xx, type='fitted', what='sample')
points(xx, yhats, pch=2)
}

# True transformation of x1 is quadratic, y is linear
n <- 200
x1 <- rnorm(n); x2 <- rnorm(n); y <- rnorm(n) + x1^2
z <- areg(cbind(x1,x2),y,xtype=c('s','l'),nk=3)
par(mfrow=c(2,2))
plot(z)

# y transformation is inverse quadratic but areg gets the same answer by
# making x1 quadratic
n <- 5000
x1 <- rnorm(n); x2 <- rnorm(n); y <- (x1 + rnorm(n))^2
z <- areg(cbind(x1,x2),y,nk=5)
par(mfrow=c(2,2))
plot(z)

# Overfit 20 predictors when no true relationships exist
n <- 1000
x <- matrix(runif(n*20),n,20)
y <- rnorm(n)
z <- areg(x, y, nk=5)  # add crossval=4 to expose the problem

# Test predict function
n <- 50
x <- rnorm(n)
y <- rnorm(n) + x
g <- sample(1:3, n, TRUE)
z <- areg(cbind(x,g),y,xtype=c('s','c'))
range(predict(z, cbind(x,g)) - z$linear.predictors)
}
\keyword{smooth}
\keyword{regression}
\keyword{multivariate}
\keyword{models}
\concept{bootstrap}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/movStats.r
\name{movStats}
\alias{movStats}
\title{movStats}
\usage{
movStats(
  formula,
  stat = NULL,
  discrete = FALSE,
  space = c("n", "x"),
  eps = if (space == "n") 15,
  varyeps = FALSE,
  nignore = 10,
  xinc = NULL,
  xlim = NULL,
  times = NULL,
  tunits = "year",
  msmooth = c("smoothed", "raw", "both"),
  tsmooth = c("supsmu", "lowess"),
  bass = 8,
  span = 1/4,
  maxdim = 6,
  penalty = NULL,
  trans = function(x) x,
  itrans = function(x) x,
  loess = FALSE,
  ols = FALSE,
  qreg = FALSE,
  lrm = FALSE,
  orm = FALSE,
  hare = FALSE,
  ordsurv = FALSE,
  lrm_args = NULL,
  family = "logistic",
  k = 5,
  tau = (1:3)/4,
  melt = FALSE,
  data = environment(formula),
  pr = c("none", "kable", "plain", "margin")
)
}
\arguments{
\item{formula}{a formula with the analysis variable on the left and the x-variable on the right, following by optional stratification variables}

\item{stat}{function of one argument that returns a named list of computed values.  Defaults to computing mean and quartiles + N except when y is binary in which case it computes moving proportions.  If y has two columns the default statistics are Kaplan-Meier estimates of cumulative incidence at a vector of \code{times}.}

\item{discrete}{set to \code{TRUE} if x-axis variable is discrete and no intervals should be created for windows}

\item{space}{defines whether intervals used fixed width or fixed sample size}

\item{eps}{tolerance for window (half width of window).  For \code{space='x'} is in data units, otherwise is the sample size for half the window, not counting the middle target point.}

\item{varyeps}{applies to \code{space='n'} and causes a smaller \code{eps} to be used in strata with fewer than `` observations so as to arrive at three x points}

\item{nignore}{see description, default is to exclude \code{nignore=10} points on the left and right tails from estimation and plotting}

\item{xinc}{increment in x to evaluate stats, default is xlim range/100 for \code{space='x'}.  For \code{space='n'} \code{xinc} defaults to m observations, where m = max(n/200, 1).}

\item{xlim}{2-vector of limits to evaluate if \code{space='x'} (default is \code{nignore} smallest to \code{nignore} largest)}

\item{times}{vector of times for evaluating one minus Kaplan-Meier estimates}

\item{tunits}{time units when \code{times} is given}

\item{msmooth}{set to \code{'smoothed'} or \code{'both'} to compute \code{lowess}-smooth moving estimates. \code{msmooth='both'} will display both.  \code{'raw'} will display only the moving statistics.  \code{msmooth='smoothed'} (the default) will display only he smoothed moving estimates.}

\item{tsmooth}{defaults to the super-smoother \code{'supsmu'} for after-moving smoothing.  Use \code{tsmooth='lowess'} to instead use \code{lowess}.}

\item{bass}{the \code{supsmu} \code{bass} parameter used to smooth the moving statistics if \code{tsmooth='supsmu'}.  The default of 8 represents quite heavy smoothing.}

\item{span}{the \code{lowess} \code{span} used to smooth the moving statistics}

\item{maxdim}{passed to \code{hare}, default is 6}

\item{penalty}{passed to \code{hare}, default is to use BIC.  Specify 2 to use AIC.}

\item{trans}{transformation to apply to x}

\item{itrans}{inverse transformation}

\item{loess}{set to TRUE to also compute loess estimates}

\item{ols}{set to TRUE to include rcspline estimate of mean using ols}

\item{qreg}{set to TRUE to include quantile regression estimates w rcspline}

\item{lrm}{set to TRUE to include logistic regression estimates w rcspline}

\item{orm}{set to TRUE to include ordinal logistic regression estimates w rcspline (mean + quantiles in \code{tau})}

\item{hare}{set to TRUE to include hazard regression estimtes of incidence at \code{times}, using the \code{polspline} package}

\item{ordsurv}{set to TRUE to include ordinal regression estimates of incidence at \code{times}, using the \code{rms} package \code{adapt_orm} and \code{survest.orm} functions}

\item{lrm_args}{a \code{list} of optional arguments to pass to \code{lrm} when \code{lrm=TRUE}, e.g., \code{list(maxit=20)}}

\item{family}{link function for ordinal regression (see \code{rms::orm})}

\item{k}{number of knots to use for ols, lrm,  qreg restricted cubic splines.  Linearity is forced for binary \code{y} when the minimum of the number of events and number of non-events is below 10 for a by-group.  For \code{ordsurv=TRUE} is the maximum number of knots tried and is passed as argument \code{maxk} to the \code{rms} \code{adapt_orm} function.}

\item{tau}{quantile numbers to estimate with quantile regression}

\item{melt}{set to TRUE to melt data table and derive Type and Statistic}

\item{data}{data.table or data.frame, default is calling frame}

\item{pr}{defaults to no printing of window information.  Use \code{pr='plain'} to print in the ordinary way, \verb{pr='kable} to convert the object to \code{knitr::kable} and print, or \code{pr='margin'} to convert to \code{kable} and place in the \code{Quarto} right margin.  For the latter two \code{results='asis'} must be in the chunk header.}
}
\value{
a data table, with attribute \code{infon} which is a data frame with rows corresponding to strata and columns \code{N}, \code{Wmean}, \code{Wmin}, \code{Wmax} if \code{stat} computed \code{N}.  These summarize the number of observations used in the windows.  If \code{varyeps=TRUE} there is an additional column \code{eps} with the computed per-stratum \code{eps}.  When \code{space='n'} and \code{xinc} is not given, the computed \code{xinc} also appears as a column.  An additional attribute \code{info} is a \code{kable} object ready for printing to describe the window characteristics.
}
\description{
Moving Estimates Using Overlapping Windows
}
\details{
Function to compute moving averages and other statistics as a function
of a continuous variable, possibly stratified by other variables.
Estimates are made by creating overlapping moving windows and
computing the statistics defined in the stat function for each window.
The default method, \code{space='n'} creates varying-width intervals each having a sample size of \code{2*eps +1}, and the smooth estimates are made every \code{xinc} observations.  Outer intervals are not symmetric in sample size (but the mean x in those intervals will reflect that) unless \code{eps=nignore}, as outer intervals are centered at observations \code{nignore} and \code{n - nignore + 1} where the default for \code{nignore} is 10.  The mean x-variable within each windows is taken to represent that window.  If \code{trans} and \code{itrans} are given, x means are computed on the \code{trans(x)} scale and then \code{itrans}'d.  For \code{space='x'}, by default estimates are made on to the \code{nignore} smallest to the \code{nignore} largest
observed values of the x variable to avoid extrapolation and to
help getting the moving statistics off on an adequate start for
the left tail.  Also by default the moving estimates are smoothed using \code{supsmu}.
When \code{melt=TRUE} you can feed the result into \code{ggplot} like this:
\verb{ggplot(w, aes(x=age, y=crea, col=Type)) + geom_line() +}
\code{facet_wrap(~ Statistic)}

See \href{https://hbiostat.org/rflow/analysis.html#sec-analysis-assoc}{here} for several examples.
}
\author{
Frank Harrell
}

\name{getHdata}
\alias{getHdata}
\title{
  Download and Install Datasets for \pkg{Hmisc}, \pkg{rms}, and Statistical
  Modeling
}
\description{
  This function downloads and makes ready to use datasets from the main
  web site for the \pkg{Hmisc} and \pkg{rms} libraries.  For \R, the
  datasets were stored in compressed \code{\link{save}} format and
  \code{getHdata} makes them available by running \code{\link{load}}
  after download.  For S-Plus, the datasets were stored in
  \code{data.dump} format and are made available by running
  \code{data.restore} after import.  The dataset is run through the
  \code{\link{cleanup.import}} function.  Calling \code{getHdata} with no
  \code{file} argument provides a character vector of names of available
  datasets that are currently on the web site.  For \R, \R's default
  browser can optionally be launched to view \verb{html} files that were
  already prepared using the \pkg{Hmisc} command
  \code{html(contents())} or to view \file{.txt} or \file{.html} data
  description files when available.
}
\usage{
getHdata(file, what = c("data", "contents", "description", "all"),
         where="https://hbiostat.org/data/repo")
}
\arguments{
  \item{file}{
    an unquoted name of a dataset on the web site, e.g. \samp{prostate}.
    Omit \code{file} to obtain a list of available datasets.
  }
  \item{what}{
    specify \code{what="contents"} to browse the contents (metadata) for
    the dataset rather than fetching the data themselves.  Specify
    \code{what="description"} to browse a data description file if
    available.  Specify \code{what="all"} to retrieve the data and see
    the metadata and description.
  }
  \item{where}{
    \acronym{URL} containing the data and metadata files
  }
}
\value{
  \code{getHdata()} without a \code{file} argument returns a character
  vector of dataset base names.  When a dataset is downloaded, the data
  frame is placed in search position one and is not returned as value of
  \code{getHdata}.
}
\author{Frank Harrell}
\seealso{
  \code{\link{download.file}}, \code{\link{cleanup.import}},
  \code{\link[foreign:read.S]{data.restore}}, \code{\link{load}}
}
\examples{
\dontrun{
getHdata()          # download list of available datasets
getHdata(prostate)  # downloads, load( ) or data.restore( )
                    # runs cleanup.import for S-Plus 6
getHdata(valung, "contents")   # open browser (options(browser="whatever"))
                    # after downloading valung.html
                    # (result of html(contents()))
getHdata(support, "all")  # download and open one browser window
datadensity(support)
attach(support)     # make individual variables available
getHdata(plasma,  "all")  # download and open two browser windows
                          # (description file is available for plasma)
}
}
\keyword{interface}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rmClose.r
\name{rmClose}
\alias{rmClose}
\title{rmClose}
\usage{
rmClose(x, minfrac = 0.05)
}
\arguments{
\item{x}{a numeric vector with no \code{NA}s}

\item{minfrac}{minimum allowed spacing between consecutive ordered \code{x}, as a fraction of the range of \code{x}}
}
\value{
a sorted numeric vector of non-close values of \code{x}
}
\description{
Remove close values from a numeric vector that are not at the outer limtis.  This is useful for removing axis breaks that overlap when plotting.
}
\examples{
rmClose(c(1, 2, 4, 47, 48, 49, 50), minfrac=0.07)
}
\author{
Frank Harrell
}

\name{valueTags}
\alias{valueTags}
\alias{valueTags<-}
\alias{valueLabel}
\alias{valueLabel<-}
\alias{valueUnit}
\alias{valueUnit<-}
\alias{valueName}
\alias{valueName<-}
\title{Store Discriptive Information About an Object}
\description{
  Functions get or set useful information about the contents of the
  object for later use.
}
\usage{
valueTags(x)
valueTags(x) <- value

valueLabel(x)
valueLabel(x) <- value

valueName(x)
valueName(x) <- value

valueUnit(x)
valueUnit(x) <- value
}
\arguments{
  \item{x}{
    an object
  }
  \item{value}{
    for \code{valueTags<-} a named list of value tags.
    a character vector of length 1, or \code{NULL}.
  }
}
\value{
  \code{valueTag} returns \code{NULL} or a named list with each of the
  named values \code{name}, \code{label}, \code{unit} set if they exists
  in the object.

  For \code{valueTag<-} returns \code{list}

  For \code{valueName}, \code{valueLable}, and \code{valueUnit}  returns
  \code{NULL} or character vector of length 1.
  
  For \code{valueName<-}, \code{valueLabel<-}, and \code{valueUnit} returns \code{value}
}
\details{
  These functions store the a short name of for the contents, a longer
  label that is useful for display, and the units of the contents that
  is useful for display.

  \code{valueTag} is an accessor, and \code{valueTag<-} is a replacement
  function for all of the value's information.

  \code{valueName} is an accessor, and \code{valueName<-} is a
  replacement function for the value's name.  This name is used when a
  plot or a latex table needs a short name and the variable name is not
  useful.
  
  \code{valueLabel} is an accessor, and \code{valueLabel<-} is a
  replacement function for the value's label.  The label is used in a
  plots or latex tables when they need a descriptive name.

  \code{valueUnit} is an accessor, and \code{valueUnit<-} is a
  replacement function for the value's unit.  The unit is used to add
  unit information to the R output.
}
\seealso{
  \code{\link{names}}, \code{\link{attributes}}
}
\examples{
age <- c(21,65,43)
y   <- 1:3
valueLabel(age) <- "Age in Years"
plot(age, y, xlab=valueLabel(age))


x1 <- 1:10
x2 <- 10:1
valueLabel(x2) <- 'Label for x2'
valueUnit(x2) <- 'mmHg'
x2
x2[1:5]
dframe <- data.frame(x1, x2)
Label(dframe)


##In these examples of llist, note that labels are printed after
##variable names, because of print.labelled
a <- 1:3
b <- 4:6
valueLabel(b) <- 'B Label'
}
\author{Charles Dupont}
\keyword{attribute}
\keyword{misc}
\keyword{utilities}

\name{bystats}
\alias{bystats}
\alias{print.bystats}
\alias{latex.bystats}
\alias{bystats2}
\alias{print.bystats2}
\alias{latex.bystats2}
\title{
Statistics by Categories
}
\description{

  For any number of cross-classification variables, \code{bystats}
  returns a matrix with the sample size, number missing \code{y}, and
  \code{fun(non-missing y)}, with the cross-classifications designated
  by rows. Uses Harrell's modification of the \code{interaction}
  function to produce cross-classifications.  The default \code{fun} is
  \code{mean}, and if \code{y} is binary, the mean is labeled as
  \code{Fraction}.  There is a \code{print} method as well as a
  \code{latex} method for objects created by \code{bystats}.
  \code{bystats2} handles the special case in which there are 2
  classifcation variables, and places the first one in rows and the
  second in columns.  The \code{print} method for \code{bystats2} uses
  the \code{print.char.matrix} function to organize statistics
  for cells into boxes. }

\usage{
bystats(y, \dots, fun, nmiss, subset)
\method{print}{bystats}(x, \dots)
\method{latex}{bystats}(object, title, caption, rowlabel, \dots)
bystats2(y, v, h, fun, nmiss, subset)
\method{print}{bystats2}(x, abbreviate.dimnames=FALSE,
   prefix.width=max(nchar(dimnames(x)[[1]])), \dots)
\method{latex}{bystats2}(object, title, caption, rowlabel, \dots)
}
\arguments{
\item{y}{
a binary, logical, or continuous variable or a matrix or data frame of
such variables.  If \code{y} is a data frame it is converted to a matrix.
If \code{y} is a data frame or matrix, computations are done on subsets of
the rows of \code{y}, and you should specify \code{fun} so as to be able to operate
on the matrix.  For matrix \code{y}, any column with a missing value causes
the entire row to be considered missing, and the row is not passed to
\code{fun}.
}
\item{...}{
For \code{bystats}, one or more classifcation variables separated by commas.
For \code{print.bystats}, options passed to \code{print.default} such as \code{digits}.
For \code{latex.bystats}, and \code{latex.bystats2},
options passed to \code{latex.default} such as \code{digits}.
If you pass \code{cdec} to \code{latex.default}, keep in mind that the first one or
two positions (depending on \code{nmiss}) should have zeros since these
correspond with frequency counts. 
}
\item{v}{
vertical variable for \code{bystats2}.  Will be converted to \code{factor}.
}
\item{h}{
horizontal variable for \code{bystats2}.  Will be converted to \code{factor}.
}
\item{fun}{
a function to compute on the non-missing \code{y} for a given subset.
You must specify \code{fun=} in front of the function name or definition.
\code{fun} may return a single number or a vector or matrix of any length.
Matrix results are rolled out into a vector, with names preserved.
When \code{y} is a matrix, a common \code{fun} is \code{function(y) apply(y, 2, ff)}
where \code{ff} is the name of a function which operates on one column of
\code{y}.
}
\item{nmiss}{
A column containing a count of missing values is included if \code{nmiss=TRUE}
or if there is at least one missing value.
}
\item{subset}{
a vector of subscripts or logical values indicating the subset of
data to analyze
}
\item{abbreviate.dimnames}{set to \code{TRUE} to abbreviate
  \code{dimnames} in output}
\item{prefix.width}{see \code{\link{print.char.matrix}}}
\item{title}{
\code{title} to pass to \code{latex.default}.  Default is the first word of
the character string version of the first calling argument.
}
\item{caption}{
caption to pass to \code{latex.default}.  Default is the \code{heading}
attribute from the object produced by \code{bystats}.
}
\item{rowlabel}{
\code{rowlabel} to pass to \code{latex.default}.  Default is the \code{byvarnames}
attribute from the object produced by \code{bystats}.  For \code{bystats2} the
default is \code{""}.
}
\item{x}{an object created by \code{bystats} or \code{bystats2}}
\item{object}{an object created by \code{bystats} or \code{bystats2}}
}
\value{
for \code{bystats}, a matrix with row names equal to the classification labels and column
names \code{N, Missing, funlab}, where \code{funlab} is determined from \code{fun}.
A row is added to the end with the summary statistics computed 
on all observations combined.  The class of this matrix is \code{bystats}.
For \code{bystats}, returns a 3-dimensional array with the last dimension
corresponding to statistics being computed.  The class of the array is
\code{bystats2}.
}
\section{Side Effects}{
\code{latex} produces a \code{.tex} file.
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\seealso{
\code{\link{interaction}}, \code{\link{cut}}, \code{\link{cut2}}, \code{\link{latex}}, \code{\link{print.char.matrix}},
\code{\link{translate}}
}
\examples{
\dontrun{
bystats(sex==2, county, city)
bystats(death, race)
bystats(death, cut2(age,g=5), race)
bystats(cholesterol, cut2(age,g=4), sex, fun=median)
bystats(cholesterol, sex, fun=quantile)
bystats(cholesterol, sex, fun=function(x)c(Mean=mean(x),Median=median(x)))
latex(bystats(death,race,nmiss=FALSE,subset=sex=="female"), digits=2)
f <- function(y) c(Hazard=sum(y[,2])/sum(y[,1]))
# f() gets the hazard estimate for right-censored data from exponential dist.
bystats(cbind(d.time, death), race, sex, fun=f)
bystats(cbind(pressure, cholesterol), age.decile, 
        fun=function(y) c(Median.pressure   =median(y[,1]),
                          Median.cholesterol=median(y[,2])))
y <- cbind(pressure, cholesterol)
bystats(y, age.decile, 
        fun=function(y) apply(y, 2, median))   # same result as last one
bystats(y, age.decile, fun=function(y) apply(y, 2, quantile, c(.25,.75)))
# The last one computes separately the 0.25 and 0.75 quantiles of 2 vars.
latex(bystats2(death, race, sex, fun=table))
}
}
\keyword{category}
\concept{grouping}

\name{rm.boot}
\alias{rm.boot}
\alias{plot.rm.boot}
\title{
  Bootstrap Repeated Measurements Model
}
\description{
  For a dataset containing a time variable, a scalar response variable,
  and an optional subject identification variable, obtains least squares
  estimates of the coefficients of a restricted cubic spline function or
  a linear regression in time after adjusting for subject effects
  through the use of subject dummy variables.  Then the fit is
  bootstrapped \code{B} times, either by treating time and subject ID as
  fixed (i.e., conditioning the analysis on them) or as random
  variables.  For the former, the residuals from the original model fit
  are used as the basis of the bootstrap distribution.  For the latter,
  samples are taken jointly from the time, subject ID, and response
  vectors to obtain unconditional distributions.
  
  If a subject \code{id} variable is given, the bootstrap sampling will
  be based on samples with replacement from subjects rather than from
  individual data points.  In other words, either none or all of a given
  subject's data will appear in a bootstrap sample.  This cluster
  sampling takes into account any correlation structure that might exist
  within subjects, so that confidence limits are corrected for
  within-subject correlation.  Assuming that ordinary least squares
  estimates, which ignore the correlation structure, are consistent
  (which is almost always true) and efficient (which would not be true
  for certain correlation structures or for datasets in which the number
  of observation times vary greatly from subject to subject), the
  resulting analysis will be a robust, efficient repeated measures
  analysis for the one-sample problem.
  
  Predicted values of the fitted models are evaluated by default at a
  grid of 100 equally spaced time points ranging from the minimum to
  maximum observed time points.  Predictions are for the average subject
  effect.  Pointwise confidence intervals are optionally computed
  separately for each of the points on the time grid.  However,
  simultaneous confidence regions that control the level of confidence
  for the entire regression curve lying within a band are often more
  appropriate, as they allow the analyst to draw conclusions about
  nuances in the mean time response profile that were not stated
  apriori.  The method of \cite{Tibshirani (1997)} is used to easily
  obtain simultaneous confidence sets for the set of coefficients of the
  spline or linear regression function as well as the average  intercept
  parameter (over subjects).  Here one computes the objective criterion
  (here both the -2 log likelihood evaluated at the bootstrap estimate
  of beta but with respect to the original design matrix and response
  vector, and the sum of squared errors in predicting the original
  response vector) for the original fit as well as for all of the
  bootstrap fits.  The confidence set of the regression coefficients is
  the set of all coefficients that are associated with objective
  function values that are less than or equal to say the 0.95 quantile
  of the vector of \eqn{\code{B} + 1} objective function values.  For
  the coefficients satisfying this condition, predicted curves are
  computed at the time grid, and minima and maxima of these curves are
  computed separately at each time point toderive the final
  simultaneous confidence band.
  
  By default, the log likelihoods that are computed for obtaining the
  simultaneous confidence band assume independence within subject.  This
  will cause problems unless such log likelihoods have very high rank
  correlation with the log likelihood allowing for dependence.  To allow
  for correlation or to estimate the correlation function, see the
  \code{cor.pattern} argument below.
}
\usage{
rm.boot(time, y, id=seq(along=time), subset,
        plot.individual=FALSE,
        bootstrap.type=c('x fixed','x random'),
        nk=6, knots, B=500, smoother=supsmu, 
        xlab, xlim, ylim=range(y), 
        times=seq(min(time), max(time), length=100),
        absorb.subject.effects=FALSE, 
        rho=0, cor.pattern=c('independent','estimate'), ncor=10000,
        \dots)


\method{plot}{rm.boot}(x, obj2, conf.int=.95,
     xlab=x$xlab, ylab=x$ylab, 
     xlim, ylim=x$ylim,
     individual.boot=FALSE,
     pointwise.band=FALSE,
     curves.in.simultaneous.band=FALSE,
     col.pointwise.band=2,
     objective=c('-2 log L','sse','dep -2 log L'), add=FALSE, ncurves,
     multi=FALSE, multi.method=c('color','density'),
     multi.conf   =c(.05,.1,.2,.3,.4,.5,.6,.7,.8,.9,.95,.99),
     multi.density=c( -1,90,80,70,60,50,40,30,20,10,  7,  4),
     multi.col    =c(  1, 8,20, 5, 2, 7,15,13,10,11,  9, 14),
     subtitles=TRUE, \dots)
}
\arguments{
  \item{time}{
    numeric time vector
  }
  \item{y}{
    continuous numeric response vector of length the same as \code{time}.
    Subjects having multiple measurements have the measurements strung out.
  }
  \item{x}{
    an object returned from \code{rm.boot}
  }
  \item{id}{
    subject ID variable.  If omitted, it is assumed that each
    time-response pair is measured on a different subject.
  }
  \item{subset}{
    subset of observations to process if not all the data
  }
  \item{plot.individual}{
    set to \code{TRUE} to plot nonparametrically smoothed time-response
    curves for each subject
  }  
  \item{bootstrap.type}{
    specifies whether to treat the time and subject ID variables as
    fixed or random
  }
  \item{nk}{
    number of knots in the restricted cubic spline function fit.  The
    number of knots may be 0 (denoting linear regression) or an integer
    greater than 2 in which k knots results in \eqn{k - 1}
    regression coefficients excluding the intercept.  The default is 6
    knots.
  }
  \item{knots}{
    vector of knot locations.  May be specified if \code{nk} is
    omitted. 
  }
  \item{B}{
    number of bootstrap repetitions.  Default is 500.
  }
  \item{smoother}{
    a smoothing function that is used if \code{plot.individual=TRUE}.
    Default is \code{\link{supsmu}}.
  }
  \item{xlab}{
    label for x-axis.  Default is \code{"units"} attribute of the
    original \code{time} variable, or \code{"Time"} if no such
    attribute was defined using the \code{units} function.
  }
  \item{xlim}{
    specifies x-axis plotting limits.  Default is to use range of times
    specified to \code{rm.boot}.
  }
  \item{ylim}{
    for \code{rm.boot} this is a vector of y-axis limits used if
    \code{plot.individual=TRUE}.  It is also passed along for later use
    by \code{plot.rm.boot}.  For \code{plot.rm.boot}, \code{ylim} can
    be specified, to override the value stored in the object stored by
    \code{rm.boot}.  The default is the actual range of \code{y} in the
    input data.
  }
  \item{times}{
    a sequence of times at which to evaluated fitted values and
    confidence limits.  Default is 100 equally spaced points in the
    observed range of \code{time}.
  }
  \item{absorb.subject.effects}{
    If \code{TRUE}, adjusts the response vector \code{y} before
    re-sampling so that the subject-specific effects in the initial
    model fit are all zero.  Then in re-sampling, subject effects are
    not used in the models.  This will downplay one of the sources of
    variation.  This option is used mainly for checking for consistency
    of results, as the re-sampling analyses are simpler when
    \code{absort.subject.effects=TRUE}.
  }
  \item{rho}{
    The log-likelihood function that is used as the basis of
    simultaneous confidence bands assumes normality with independence
    within subject. To check the robustness of this assumption, if
    \code{rho} is not zero, the log-likelihood under multivariate
    normality within subject, with constant correlation \code{rho}
    between any two time points, is also computed.  If the two
    log-likelihoods have the same ranks across re-samples, alllowing
    the correlation structure does not matter.  The agreement in ranks
    is quantified using the Spearman rank correlation coefficient.  The
    \code{\link{plot}} method allows the non-zero intra-subject
    correlation log-likelihood to be used in deriving the simultaneous
    confidence band.  Note that this approach does assume
    homoscedasticity.
  }
  \item{cor.pattern}{
    More generally than using an equal-correlation structure, you can
    specify a function of two time vectors that generates as many
    correlations as the length of these vectors.  For example,
    \code{cor.pattern=function(time1,time2) 0.2^(abs(time1-time2)/10)}
    would specify a dampening serial correlation pattern.
    \code{cor.pattern} can also be a list containing vectors \code{x}
    (a vector of absolute time differences) and \code{y} (a
    corresponding vector of correlations).  To estimate the correlation
    function as a function of absolute time differences within
    subjects, specify \code{cor.pattern="estimate"}.  The products of
    all possible pairs of residuals (or at least up to \code{ncor} of
    them) within subjects will be related to the absolute time
    difference.  The correlation function is estimated by computing the
    sample mean of the products of standardized residuals, stratified
    by absolute time difference.  The correlation for a zero time
    difference is set to 1 regardless of the \code{\link{lowess}}
    estimate.  NOTE: This approach fails in the presence of large
    subject effects; correcting for such effects removes too much of
    the correlation structure in the residuals.
  }
  \item{ncor}{
    the maximum number of pairs of time values used in estimating the
    correlation function if \code{cor.pattern="estimate"}
  }
  \item{\dots}{
    other arguments to pass to \code{smoother} if \code{plot.individual=TRUE}
  }
  \item{obj2}{
    a second object created by \code{rm.boot} that can also be passed
    to \code{plot.rm.boot}.  This is used for two-sample problems for
    which the time profiles are allowed to differ between the two
    groups.  The bootstrapped predicted y values for the second fit are
    subtracted from the fitted values for the first fit so that the
    predicted mean response for group 1 minus the predicted mean
    response for group 2 is what is plotted. The confidence bands that
    are plotted are also for this difference.  For the simultaneous
    confidence band, the objective criterion is taken to be the sum of
    the objective criteria (-2 log L or sum of squared errors) for the
    separate fits for the two groups. The \code{times} vectors must
    have been identical for both calls to \code{rm.boot}, although
    \code{NA}s can be inserted by the user of one or both of the time
    vectors in the \code{rm.boot} objects so as to suppress certain
    sections of the difference curve from being plotted.
  }
  \item{conf.int}{
    the confidence level to use in constructing simultaneous, and
    optionally pointwise, bands.  Default is 0.95.
  }
  \item{ylab}{
    label for y-axis.  Default is the \code{"label"} attribute of the
    original \code{y} variable, or \code{"y"} if no label was assigned
    to \code{y} (using the \code{label} function, for example).
  }
  \item{individual.boot}{
    set to \code{TRUE} to plot the first 100 bootstrap regression fits
  }
  \item{pointwise.band}{
    set to \code{TRUE} to draw a pointwise confidence band in addition
    to the simultaneous band
  }
  \item{curves.in.simultaneous.band}{
    set to \code{TRUE} to draw all bootstrap regression fits that had a
    sum of squared errors (obtained by predicting the original \code{y}
    vector from the original \code{time} vector and \code{id} vector)
    that was less that or equal to the \code{conf.int} quantile of all
    bootstrapped models (plus the original model). This will show how
    the point by point max and min were computed to form the
    simultaneous confidence band.
  }
  \item{col.pointwise.band}{
    color for the pointwise confidence band.  Default is \samp{2},
    which defaults to red for default Windows S-PLUS setups.
  }
  \item{objective}{
    the default is to use the -2 times log of the Gaussian likelihood
    for computing the simultaneous confidence region.  If neither
    \code{cor.pattern} nor \code{rho} was specified to \code{rm.boot},
    the independent homoscedastic Gaussian likelihood is
    used. Otherwise the dependent homoscedastic likelihood is used
    according to the specified or estimated correlation
    pattern. Specify \code{objective="sse"} to instead use the sum of
    squared errors.
  }
  \item{add}{
    set to \code{TRUE} to add curves to an existing plot.  If you do
    this, titles and subtitles are omitted.
  }
  \item{ncurves}{
    when using \code{individual.boot=TRUE} or
    \code{curves.in.simultaneous.band=TRUE}, you can plot a random
    sample of \code{ncurves} of the fitted curves instead of plotting
    up to \code{B} of them.
  }
  \item{multi}{
    set to \code{TRUE} to draw multiple simultaneous confidence bands
    shaded with different colors.  Confidence levels vary over the
    values in the \code{multi.conf} vector.
  }
  \item{multi.method}{
    specifies the method of shading when \code{multi=TRUE}.  Default is
    to use colors, with the default colors chosen so that when the
    graph is printed under S-Plus for Windows 4.0 to an HP LaserJet
    printer, the confidence regions are naturally ordered by darkness
    of gray-scale. Regions closer to the point estimates (i.e., the
    center) are darker. Specify \code{multi.method="density"} to
    instead use densities of lines drawn per inch in the confidence
    regions, with all regions drawn with the default color. The
    \code{\link{polygon}} function is used to shade the regions.
  }
  \item{multi.conf}{
    vector of confidence levels, in ascending order.  Default is to use
    12 confidence levels ranging from 0.05 to 0.99.
  }
  \item{multi.density}{
    vector of densities in lines per inch corresponding to
    \code{multi.conf}. As is the convention in the
    \code{\link{polygon}} function, a density of -1 indicates a solid
    region.
  }
  \item{multi.col}{
    vector of colors corresponding to \code{multi.conf}.  See
    \code{multi.method} for rationale.
  }
  \item{subtitles}{
    set to \code{FALSE} to suppress drawing subtitles for the plot
  }
}
\value{
  an object of class \code{rm.boot} is returned by \code{rm.boot}. The
  principal object stored in the returned object is a matrix of
  regression coefficients for the original fit and all of the bootstrap
  repetitions (object \code{Coef}), along with vectors of the
  corresponding -2 log likelihoods are sums of squared errors. The
  original fit object from \code{lm.fit.qr} is stored in
  \code{fit}. For this fit, a cell means model is used for the
  \code{id} effects.

  \code{plot.rm.boot} returns a list containing the vector of times used
  for plotting along with the overall fitted values, lower and upper
  simultaneous confidence limits, and optionally the pointwise
  confidence limits.
}
\details{
  Observations having missing \code{time} or \code{y} are excluded from
  the analysis.


  As most repeated measurement studies consider the times as design
  points, the fixed covariable case is the default. Bootstrapping the
  residuals from the initial fit assumes that the model is correctly
  specified.  Even if the covariables are fixed, doing an unconditional
  bootstrap is still appropriate, and for large sample sizes
  unconditional confidence intervals are only slightly wider than
  conditional ones.  For moderate to small sample sizes, the
  \code{bootstrap.type="x random"} method can be fairly conservative.
    

  If not all subjects have the same number of observations (after
  deleting observations containing missing values) and if
  \code{bootstrap.type="x fixed"}, bootstrapped residual vectors may
  have a length m that is different from the number of original
  observations n.  If \eqn{m > n} for a bootstrap
  repetition, the first n elements of the randomly drawn residuals
  are used. If \eqn{m < n}, the residual vector is appended
  with a random sample with replacement of length \eqn{n - m} from itself.  A warning message is issued if this happens.
  If the number of time points per subject varies, the bootstrap results
  for \code{bootstrap.type="x fixed"} can still be invalid, as this
  method assumes that a vector (over subjects) of all residuals can be
  added to the original yhats, and varying number of points will cause
  mis-alignment.

  For \code{bootstrap.type="x random"} in the presence of significant
  subject effects, the analysis is approximate as the subjects used in
  any one bootstrap fit will not be the entire list of subjects.  The
  average (over subjects used in the bootstrap sample) intercept is used
  from that bootstrap sample as a predictor of average subject effects
  in the overall sample.

  Once the bootstrap coefficient matrix is stored by \code{rm.boot},
  \code{plot.rm.boot} can be run multiple times with different options
  (e.g, different confidence levels).

  See \code{\link[rms]{bootcov}} in the \pkg{rms} library for a general
  approach to handling repeated measurement data for ordinary linear
  models, binary and ordinal models, and survival models, using the
  unconditional bootstrap.  \code{\link[rms]{bootcov}} does not handle bootstrapping
  residuals.
}
\author{
  Frank Harrell  \cr
  Department of Biostatistics  \cr
  Vanderbilt University School of Medicine  \cr
  \email{fh@fharrell.com}
}
\references{
  Feng Z, McLerran D, Grizzle J (1996): A comparison of statistical methods for
  clustered data analysis with Gaussian error.  Stat in Med 15:1793--1806.

  Tibshirani R, Knight K (1997):Model search and inference by bootstrap 
  "bumping".  Technical Report, Department of Statistics, University of Toronto.
  \cr
  \url{https://www.jstor.org/stable/1390820}. Presented at the Joint Statistical
  Meetings, Chicago, August 1996.


  Efron B, Tibshirani R (1993): An Introduction to the Bootstrap.
  New York: Chapman and Hall.


  Diggle PJ, Verbyla AP (1998): Nonparametric estimation of covariance
  structure in logitudinal data.  Biometrics 54:401--415.


  Chapman IM, Hartman ML, et al (1997): Effect of aging on the
  sensitivity of growth hormone secretion to insulin-like growth
  factor-I negative feedback.  J Clin Endocrinol Metab 82:2996--3004.

  Li Y, Wang YG (2008): Smooth bootstrap methods for analysis of
  longitudinal data.  Stat in Med 27:937-953. (potential improvements to
  cluster bootstrap; not implemented here)
}
\seealso{
  \code{\link{rcspline.eval}}, \code{\link{lm}}, \code{\link{lowess}},
  \code{\link{supsmu}}, \code{\link[rms]{bootcov}},
  \code{\link{units}}, \code{\link{label}}, \code{\link{polygon}},
  \code{\link{reShape}}
}
\examples{
# Generate multivariate normal responses with equal correlations (.7)
# within subjects and no correlation between subjects
# Simulate realizations from a piecewise linear population time-response
# profile with large subject effects, and fit using a 6-knot spline
# Estimate the correlation structure from the residuals, as a function
# of the absolute time difference


# Function to generate n p-variate normal variates with mean vector u and
# covariance matrix S
# Slight modification of function written by Bill Venables
# See also the built-in function rmvnorm
mvrnorm <- function(n, p = 1, u = rep(0, p), S = diag(p)) {
  Z <- matrix(rnorm(n * p), p, n)
  t(u + t(chol(S)) \%*\% Z)
}


n     <- 20         # Number of subjects
sub   <- .5*(1:n)   # Subject effects


# Specify functional form for time trend and compute non-stochastic component
times <- seq(0, 1, by=.1)
g     <- function(times) 5*pmax(abs(times-.5),.3)
ey    <- g(times)


# Generate multivariate normal errors for 20 subjects at 11 times
# Assume equal correlations of rho=.7, independent subjects


nt    <- length(times)
rho   <- .7


        
set.seed(19)        
errors <- mvrnorm(n, p=nt, S=diag(rep(1-rho,nt))+rho)
# Note:  first random number seed used gave rise to mean(errors)=0.24!


# Add E[Y], error components, and subject effects
y      <- matrix(rep(ey,n), ncol=nt, byrow=TRUE) + errors + 
          matrix(rep(sub,nt), ncol=nt)


# String out data into long vectors for times, responses, and subject ID
y      <- as.vector(t(y))
times  <- rep(times, n)
id     <- sort(rep(1:n, nt))


# Show lowess estimates of time profiles for individual subjects
f <- rm.boot(times, y, id, plot.individual=TRUE, B=25, cor.pattern='estimate',
             smoother=lowess, bootstrap.type='x fixed', nk=6)
# In practice use B=400 or 500
# This will compute a dependent-structure log-likelihood in addition
# to one assuming independence.  By default, the dep. structure
# objective will be used by the plot method  (could have specified rho=.7)
# NOTE: Estimating the correlation pattern from the residual does not
# work in cases such as this one where there are large subject effects


# Plot fits for a random sample of 10 of the 25 bootstrap fits
plot(f, individual.boot=TRUE, ncurves=10, ylim=c(6,8.5))


# Plot pointwise and simultaneous confidence regions
plot(f, pointwise.band=TRUE, col.pointwise=1, ylim=c(6,8.5))


# Plot population response curve at average subject effect
ts <- seq(0, 1, length=100)
lines(ts, g(ts)+mean(sub), lwd=3)


\dontrun{
#
# Handle a 2-sample problem in which curves are fitted 
# separately for males and females and we wish to estimate the
# difference in the time-response curves for the two sexes.  
# The objective criterion will be taken by plot.rm.boot as the 
# total of the two sums of squared errors for the two models
#
knots <- rcspline.eval(c(time.f,time.m), nk=6, knots.only=TRUE)
# Use same knots for both sexes, and use a times vector that 
# uses a range of times that is included in the measurement 
# times for both sexes
#
tm <- seq(max(min(time.f),min(time.m)),
          min(max(time.f),max(time.m)),length=100)


f.female <- rm.boot(time.f, bp.f, id.f, knots=knots, times=tm)
f.male   <- rm.boot(time.m, bp.m, id.m, knots=knots, times=tm)
plot(f.female)
plot(f.male)
# The following plots female minus male response, with 
# a sequence of shaded confidence band for the difference
plot(f.female,f.male,multi=TRUE)


# Do 1000 simulated analyses to check simultaneous coverage 
# probability.  Use a null regression model with Gaussian errors


n.per.pt <- 30
n.pt     <- 10


null.in.region <- 0


for(i in 1:1000) {
  y    <- rnorm(n.pt*n.per.pt)
  time <- rep(1:n.per.pt, n.pt)
#  Add the following line and add ,id=id to rm.boot to use clustering
#  id   <- sort(rep(1:n.pt, n.per.pt))
#  Because we are ignoring patient id, this simulation is effectively
#  using 1 point from each of 300 patients, with times 1,2,3,,,30 


  f <- rm.boot(time, y, B=500, nk=5, bootstrap.type='x fixed')
  g <- plot(f, ylim=c(-1,1), pointwise=FALSE)
  null.in.region <- null.in.region + all(g$lower<=0 & g$upper>=0)
  prn(c(i=i,null.in.region=null.in.region))
}


# Simulation Results: 905/1000 simultaneous confidence bands 
# fully contained the horizontal line at zero
}
}
\keyword{regression}
\keyword{multivariate}
\keyword{htest}
\keyword{hplot}
\concept{bootstrap}
\concept{repeated measures}
\concept{longitudinal data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom_stepconfint.r
\name{geom_stepconfint}
\alias{geom_stepconfint}
\title{Step function confidence intervals for ggplot2}
\usage{
geom_stepconfint(
  mapping = NULL,
  data = NULL,
  stat = "identity",
  position = "identity",
  na.rm = FALSE,
  ...
)
}
\arguments{
\item{mapping}{Aesthetic mappings with aes() function. Like geom_ribbon(), you must provide
columns for x, ymin (lower limit), ymax (upper limit).}

\item{data}{The data to be displayed in this layer. Can inherit from ggplot parent.}

\item{stat}{The statistical transformation to use on the data for this layer, as a string.
Defaults to 'identity'.}

\item{position}{Position adjustment, either as a string, or the result of a call to a
position adjustment function.}

\item{na.rm}{If FALSE, the default, missing values are removed with a warning. If TRUE,
missing values are silently removed.}

\item{...}{Optional. Any other ggplot geom_ribbon() arguments.}
}
\description{
Produces a step function confidence interval for survival curves.  This function is taken from
the \code{utile.visuals} package by Eric Finnesgard.  That package is not used because of its
strong dependencies.
}
\note{
Originally adapted from the survminer package <https://github.com/kassambara/survminer>.
}
\examples{
require(survival)
require(ggplot2)

f <- survfit(Surv(time, status) ~ trt, data = diabetic)
d <- with(f, data.frame(time, surv, lower, upper, trt=rep(names(f$strata), f$strata)))
ggplot(d, aes(x = time, y=surv)) +
  geom_step(aes(color = trt)) +
  geom_stepconfint(aes(ymin = lower, ymax = upper, fill = trt), alpha = 0.3) +
  coord_cartesian(c(0, 50)) +
  scale_x_continuous(expand = c(0.02,0)) +
  labs(x = 'Time', y = 'Freedom From Event') +
  scale_color_manual(
    values = c('#d83641', '#1A45A7'),
    name = 'Treatment',
    labels = c('None', 'Laser'),
    aesthetics = c('colour', 'fill'))
}
\author{
Eric Finnesgard
}

\name{Lag}
\alias{Lag}
\title{Lag a Numeric, Character, or Factor Vector}
\description{
Shifts a vector \code{shift} elements later.  Character or factor
variables are padded with \code{""}, numerics with \code{NA}.  The shift
may be negative.
}
\usage{
Lag(x, shift = 1)
}
\arguments{
  \item{x}{a vector}
  \item{shift}{integer specifying the number of observations to
	be shifted to the right.  Negative values imply shifts to the left.}
}
\details{
A.ttributes of the original object are carried along to the new lagged
one.
}
\value{
a vector like \code{x}
}
\author{Frank Harrell}
\seealso{\code{\link{lag}}}
\examples{
Lag(1:5,2)
Lag(letters[1:4],2)
Lag(factor(letters[1:4]),-2)
# Find which observations are the first for a given subject
id <- c('a','a','b','b','b','c')
id != Lag(id)
!duplicated(id)
}
\keyword{manip}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gbayesSeqSim.r
\name{gbayesSeqSim}
\alias{gbayesSeqSim}
\title{gbayesSeqSim}
\usage{
gbayesSeqSim(est, asserts)
}
\arguments{
\item{est}{data frame created by \code{estSeqSim()}}

\item{asserts}{list of lists.  The first element of each list is the user-specified name for each assertion/prior combination, e.g., \code{"efficacy"}.  The other elements are, in order, a character string equal to "<", ">", or "in", a parameter value \code{cutoff} (for "<" and ">") or a 2-vector specifying an interval for "in", and either a prior distribution mean and standard deviation named \code{mu} and \code{sigma} respectively, or a parameter value (\code{"cutprior"}) and tail area \code{"tailprob"}.  If the latter is used, \code{mu} is assumed to be zero and \code{sigma} is solved for such that P(parameter > 'cutprior') = P(parameter < - 'cutprior') = \code{tailprob}.}
}
\value{
a data frame with number of rows equal to that of \code{est} with a number of new columns equal to the number of assertions added.  The new columns are named \code{p1}, \code{p2}, \code{p3}, ... (posterior probabilities), \code{mean1}, \code{mean2}, ... (posterior means), and \code{sd1}, \code{sd2}, ... (posterior standard deviations).  The returned data frame also has an attribute \code{asserts} added which is the original \code{asserts} augmented with any derived \code{mu} and \code{sigma} and converted to a data frame, and another attribute \code{alabels} which is a named vector used to map \code{p1}, \code{p2}, ... to the user-provided labels in \code{asserts}.
}
\description{
Simulate Bayesian Sequential Treatment Comparisons Using a Gaussian Model
}
\details{
Simulate a sequential trial under a Gaussian model for parameter estimates, and Gaussian priors using simulated estimates and variances returned by \code{estSeqSim}.  For each row of the data frame \code{est} and for each prior/assertion combination, computes the posterior probability of the assertion.
}
\examples{
\dontrun{
# Simulate Bayesian operating characteristics for an unadjusted
# proportional odds comparison (Wilcoxon test)
# For 100 simulations, 5 looks, 2 true parameter values, and
# 2 assertion/prior combinations, compute the posterior probability
# Use a low-level logistic regression call to speed up simuluations
# Use data.table to compute various summary measures
# Total simulation time: 2s
lfit <- function(x, y) {
f <- rms::lrm.fit(x, y)
  k <- length(coef(f))
  c(coef(f)[k], vcov(f)[k, k])
}
gdat <- function(beta, n1, n2) {
  # Cell probabilities for a 7-category ordinal outcome for the control group
  p <- c(2, 1, 2, 7, 8, 38, 42) / 100

  # Compute cell probabilities for the treated group
  p2 <- pomodm(p=p, odds.ratio=exp(beta))
  y1 <- sample(1 : 7, n1, p,  replace=TRUE)
  y2 <- sample(1 : 7, n2, p2, replace=TRUE)
  list(y1=y1, y2=y2)
}

# Assertion 1: log(OR) < 0 under prior with prior mean 0.1 and sigma 1 on log OR scale
# Assertion 2: OR between 0.9 and 1/0.9 with prior mean 0 and sigma computed so that
# P(OR > 2) = 0.05
asserts <- list(list('Efficacy', '<', 0, mu=0.1, sigma=1),
                list('Similarity', 'in', log(c(0.9, 1/0.9)),
                     cutprior=log(2), tailprob=0.05))

set.seed(1)
est <- estSeqSim(c(0, log(0.7)), looks=c(50, 75, 95, 100, 200),
                   gendat=gdat,
                   fitter=lfit, nsim=100)
z <- gbayesSeqSim(est, asserts)
head(z)
attr(z, 'asserts')

# Compute the proportion of simulations that hit targets (different target posterior
# probabilities for efficacy vs. similarity)

# For the efficacy assessment compute the first look at which the target
# was hit (set to infinity if never hit)
require(data.table)
z <- data.table(z)
u <- z[, .(first=min(p1 > 0.95])), by=.(parameter, sim)]
# Compute the proportion of simulations that ever hit the target and
# that hit it by the 100th subject
u[, .(ever=mean(first < Inf)),  by=.(parameter)]
u[, .(by75=mean(first <= 100)), by=.(parameter)]
}
}
\seealso{
\code{gbayes()}, \code{estSeqSim()}, \code{simMarkovOrd()}, \code{estSeqMarkovOrd()}
}
\author{
Frank Harrell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simMarkovOrd.r
\name{simMarkovOrd}
\alias{simMarkovOrd}
\title{simMarkovOrd}
\usage{
simMarkovOrd(
  n = 1,
  y,
  times,
  initial,
  X = NULL,
  absorb = NULL,
  intercepts,
  g,
  carry = FALSE,
  rdsample = NULL,
  ...
)
}
\arguments{
\item{n}{number of subjects to simulate}

\item{y}{vector of possible y values in order (numeric, character, factor)}

\item{times}{vector of measurement times}

\item{initial}{initial value of \code{y} (baseline state; numeric, character, or factor matching \code{y}).  If length 1 this value is used for all subjects, otherwise it is a vector of length \code{n}.}

\item{X}{an optional vector of matrix of baseline covariate values passed to \code{g}.  If a vector, \code{X} represents a set of single values for all the covariates and those values are used for every subject.  Otherwise \code{X} is a matrix with rows corresponding to subjects and columns corresponding to covariates which \code{g} must know how to handle.  \code{g} only sees one row of \code{X} at a time.}

\item{absorb}{vector of absorbing states, a subset of \code{y} (numeric, character, or factor matching \code{y}).  The default is no absorbing states.  Observations are truncated when an absorbing state is simulated.}

\item{intercepts}{vector of intercepts in the proportional odds model.  There must be one fewer of these than the length of \code{y}.}

\item{g}{a user-specified function of three or more arguments which in order are \code{yprev} - the value of \code{y} at the previous time, the current time \code{t}, the \code{gap} between the previous time and the current time, an optional (usually named) covariate vector \code{X}, and optional arguments such as a regression coefficient value to simulate from.  The function needs to allow \code{yprev} to be a vector and \code{yprev} must not include any absorbing states.  The \code{g} function returns the linear predictor for the proportional odds model aside from \code{intercepts}.  The returned value must be a matrix with row names taken from \code{yprev}.  If the model is a proportional odds model, the returned value must be one column.  If it is a partial proportional odds model, the value must have one column for each distinct value of the response variable Y after the first one, with the levels of Y used as optional column names.  So columns correspond to \code{intercepts}. The different columns are used for \code{y}-specific contributions to the linear predictor (aside from \code{intercepts}) for a partial or constrained partial proportional odds model.  Parameters for partial proportional odds effects may be included in the ... arguments.}

\item{carry}{set to \code{TRUE} to carry absorbing state forward after it is first hit; the default is to end records for the subject once the absorbing state is hit}

\item{rdsample}{an optional function to do response-dependent sampling.  It is a function of these arguments, which are vectors that stop at any absorbing state: \code{times} (ascending measurement times for one subject), \code{y} (vector of ordinal outcomes at these times for one subject.  The function returns \code{NULL} if no observations are to be dropped, returns the vector of new times to sample.}

\item{...}{additional arguments to pass to \code{g} such as a regresson coefficient}
}
\value{
data frame with one row per subject per time, and columns id, time, gap, yprev, y
}
\description{
Simulate Ordinal Markov Process
}
\details{
Simulates longitudinal data for subjects following a first-order Markov process under a proportional odds model.  Optionally, response-dependent sampling can be done, e.g., if a subject hits a specified state at time t, measurements are removed for times t+1, t+3, t+5, ...  This is applicable when for example a study of hospitalized patients samples every day, Y=1 denotes patient discharge to home, and sampling is less frequent outside the hospital.  This example assumes that arriving home is not an absorbing state, i.e., a patient could return to the hospital.
}
\seealso{
\url{https://hbiostat.org/R/Hmisc/markov/}
}
\author{
Frank Harrell
}

\name{rcspline.eval}
\alias{rcspline.eval}
\title{
  Restricted Cubic Spline Design Matrix
}
\description{
  Computes matrix that expands a single variable into the terms needed
  to fit a restricted cubic spline (natural spline) function using the
  truncated power basis. Two normalization options are given for
  somewhat reducing problems of ill-conditioning.  The antiderivative
  function can be optionally created. If knot locations are not given,
  they will be estimated from the marginal distribution of \code{x}.
}
\usage{
rcspline.eval(x, knots, nk=5, inclx=FALSE, knots.only=FALSE, 
              type="ordinary", norm=2, rpm=NULL, pc=FALSE,
              fractied=0.05)
}
\arguments{
  \item{x}{
    a vector representing a predictor variable
  }
  \item{knots}{
    knot locations. If not given, knots will be estimated using default
    quantiles of \code{x}. For 3 knots, the outer quantiles used are 0.10
    and 0.90. For 4-6 knots, the outer quantiles used are 0.05 and
    0.95. For \eqn{\code{nk}>6}, the outer quantiles are 0.025 and 0.975. The
    knots are equally spaced between these on the quantile scale. For
    fewer than 100 non-missing values of \code{x}, the outer knots are
    the 5th smallest and largest \code{x}.
  }
  \item{nk}{
    number of knots. Default is 5. The minimum value is 3.
  }
  \item{inclx}{
    set to \code{TRUE} to add \code{x} as the first column of the
    returned matrix
  }
  \item{knots.only}{
    return the estimated knot locations but not the expanded matrix
  }
  \item{type}{
    \samp{"ordinary"} to fit the function, \samp{"integral"} to fit its
    anti-derivative.
  }
  \item{norm}{
    \samp{0} to use the terms as originally given by \cite{Devlin and
      Weeks (1986)}, \samp{1} to normalize non-linear terms by the cube
    of the spacing between the last two knots, \samp{2} to normalize by
    the square of the spacing between the first and last knots (the
    default). \code{norm=2} has the advantage of making all nonlinear
    terms beon the x-scale.
  }
  \item{rpm}{
    If given, any \code{NA}s in \code{x} will be replaced with the value
    \code{rpm} after estimating any knot locations.
  }
  \item{pc}{
    Set to \code{TRUE} to replace the design matrix with orthogonal
    (uncorrelated) principal components computed on the scaled, centered
    design matrix
  }
	\item{fractied}{
		If the fraction of observations tied at the lowest and/or highest
		values of \code{x} is greater than or equal to \code{fractied}, the
		algorithm attempts to use a different algorithm for knot finding
		based on quantiles of \code{x} after excluding the one or two values
		with excessive ties.  And if the number of unique \code{x} values
		excluding these values is small, the unique values will be used as
		the knots.  If the number of knots to use other than these exterior
		values is only one, that knot will be at the median of the
		non-extreme \code{x}.  This algorithm is not used if any interior
		values of \code{x} also have a proportion of ties equal to or
		exceeding \code{fractied}.}
}
\value{
  If \code{knots.only=TRUE}, returns a vector of knot
  locations. Otherwise returns a matrix with \code{x} (if
  \code{inclx=TRUE}) followed by \eqn{\code{nk}-2} nonlinear terms. The
  matrix has an attribute \code{knots} which is the vector of knots
  used.  When \code{pc} is \code{TRUE}, an additional attribute is
  stored: \code{pcparms}, which contains the \code{center} and
  \code{scale} vectors and the \code{rotation} matrix.
}
\references{
  Devlin TF and Weeks BJ (1986): Spline functions for logistic regression
  modeling. Proc 11th Annual SAS Users Group Intnl Conf, p. 646--651.
  Cary NC: SAS Institute, Inc.
}
\seealso{
  \code{\link[splines]{ns}}, \code{\link{rcspline.restate}},
  \code{\link[rms]{rcs}}
}
\examples{
x <- 1:100
rcspline.eval(x, nk=4, inclx=TRUE)
#lrm.fit(rcspline.eval(age,nk=4,inclx=TRUE), death)
x <- 1:1000
attributes(rcspline.eval(x))
x <- c(rep(0, 744),rep(1,6), rep(2,4), rep(3,10),rep(4,2),rep(6,6),
  rep(7,3),rep(8,2),rep(9,4),rep(10,2),rep(11,9),rep(12,10),rep(13,13),
  rep(14,5),rep(15,5),rep(16,10),rep(17,6),rep(18,3),rep(19,11),rep(20,16),
  rep(21,6),rep(22,16),rep(23,17), 24, rep(25,8), rep(26,6),rep(27,3),
  rep(28,7),rep(29,9),rep(30,10),rep(31,4),rep(32,4),rep(33,6),rep(34,6),
  rep(35,4), rep(36,5), rep(38,6), 39, 39, 40, 40, 40, 41, 43, 44, 45)
attributes(rcspline.eval(x, nk=3))
attributes(rcspline.eval(x, nk=5))
u <- c(rep(0,30), 1:4, rep(5,30))
attributes(rcspline.eval(u))
}
\keyword{regression}
\keyword{smooth}

\name{ciapower}
\alias{ciapower}
\title{
Power of Interaction Test for Exponential Survival
}
\description{
Uses the method of Peterson and George to compute the power of an
interaction test in a 2 x 2 setup in which all 4 distributions are
exponential.  This will be the same as the power of the Cox model
test if assumptions hold.  The test is 2-tailed.  
The duration of accrual is specified
(constant accrual is assumed), as is the minimum follow-up time.
The maximum follow-up time is then \code{accrual + tmin}.  Treatment
allocation is assumed to be 1:1.
}
\usage{
ciapower(tref, n1, n2, m1c, m2c, r1, r2, accrual, tmin, 
         alpha=0.05, pr=TRUE)
}
\arguments{
\item{tref}{
time at which mortalities estimated
}
\item{n1}{
total sample size, stratum 1
}
\item{n2}{
total sample size, stratum 2
}
\item{m1c}{
tref-year mortality, stratum 1 control
}
\item{m2c}{
tref-year mortality, stratum 2 control
}
\item{r1}{
\% reduction in \code{m1c} by intervention, stratum 1
}
\item{r2}{
\% reduction in \code{m2c} by intervention, stratum 2
}
\item{accrual}{
duration of accrual period
}
\item{tmin}{
minimum follow-up time
}
\item{alpha}{
type I error probability
}
\item{pr}{
set to \code{FALSE} to suppress printing of details
}}
\value{
power
}
\section{Side Effects}{
prints
}
\section{AUTHOR}{
Frank Harrell


Department of Biostatistics


Vanderbilt University


\email{fh@fharrell.com}
}
\references{
Peterson B, George SL: Controlled Clinical Trials 14:511--522; 1993.
}
\seealso{
\code{\link{cpower}}, \code{\link{spower}}
}
\examples{
# Find the power of a race x treatment test.  25\% of patients will
# be non-white and the total sample size is 14000.  
# Accrual is for 1.5 years and minimum follow-up is 5y.
# Reduction in 5-year mortality is 15\% for whites, 0\% or -5\% for
# non-whites.  5-year mortality for control subjects if assumed to
# be 0.18 for whites, 0.23 for non-whites.
n <- 14000
for(nonwhite.reduction in c(0,-5)) {
  cat("\n\n\n\% Reduction in 5-year mortality for non-whites:",
      nonwhite.reduction, "\n\n")
  pow <- ciapower(5,  .75*n, .25*n,  .18, .23,  15, nonwhite.reduction,  
                  1.5, 5)
  cat("\n\nPower:",format(pow),"\n")
}
}
\keyword{survival}
\keyword{htest}
\concept{power}
\concept{study design}

\name{HmiscOverview}
\alias{HmiscOverview}
\alias{Hmisc.Overview}
\title{
  Overview of Hmisc Library
}
\description{
  The Hmisc library contains many functions useful for data analysis,
  high-level graphics, utility operations, functions for computing
  sample size and power, translating SAS datasets into \R, imputing
  missing values, advanced table making, variable clustering, character
  string manipulation, conversion of \R objects to LaTeX code, recoding
  variables, and bootstrap repeated measures analysis.  Most of these
  functions were written by F Harrell, but a few were collected from
  statlib and from s-news; other authors are indicated below.  This
  collection of functions includes all of  Harrell's submissions to
  statlib other than  the functions in the \pkg{rms} and display
  libraries.  A few of the functions do not  have \dQuote{Help}
  documentation.
  
  To make \pkg{Hmisc} load silently, issue
  \code{options(Hverbose=FALSE)} before \code{library(Hmisc)}.
}
\section{Functions}{
\tabular{ll}{
\bold{Function Name} \tab  \bold{Purpose} \cr
abs.error.pred  \tab Computes various indexes of predictive accuracy based\cr
\tab    on absolute errors, for linear models\cr
addMarginal     \tab Add marginal observations over selected variables\cr
all.is.numeric  \tab Check if character strings are legal numerics\cr
approxExtrap    \tab Linear extrapolation\cr
aregImpute      \tab Multiple imputation based on additive regression,\cr
                \tab     bootstrapping, and predictive mean matching\cr
areg.boot       \tab Nonparametrically estimate transformations for both\cr
                \tab     sides of a multiple additive regression, and\cr
                \tab     bootstrap these estimates and \eqn{R^2}\cr
ballocation     \tab Optimum sample allocations in 2-sample proportion test\cr
binconf         \tab Exact confidence limits for a proportion and more accurate\cr
                \tab     (narrower!) score stat.-based Wilson interval\cr
                \tab     (Rollin Brant, mod. FEH)\cr
bootkm          \tab Bootstrap Kaplan-Meier survival or quantile estimates\cr
bpower          \tab Approximate power of 2-sided test for 2 proportions\cr
                \tab     Includes bpower.sim for exact power by simulation\cr
bpplot          \tab Box-Percentile plot \cr
                \tab     (Jeffrey Banfield, \email{umsfjban@bill.oscs.montana.edu})\cr
bpplotM         \tab Chart extended box plots for multiple variables\cr
bsamsize        \tab Sample size requirements for test of 2 proportions\cr
bystats         \tab Statistics on a single variable by levels of >=1 factors\cr
bystats2        \tab 2-way statistics\cr
character.table \tab Shows numeric equivalents of all latin characters\cr
                \tab     Useful for putting many special chars. in graph titles\cr
                \tab     (Pierre Joyet, \email{pierre.joyet@bluewin.ch})\cr
ciapower        \tab Power of Cox interaction test\cr
cleanup.import  \tab More compactly store variables in a data frame, and clean up\cr
                \tab     problem data when e.g. Excel spreadsheet had a non-\cr
                \tab     numeric value in a numeric column\cr
combine.levels  \tab Combine infrequent levels of a categorical variable\cr
confbar         \tab Draws confidence bars on an existing plot using multiple\cr
                \tab     confidence levels distinguished using color or gray scale\cr
contents        \tab Print the contents (variables, labels, etc.) of a data frame\cr
cpower          \tab Power of Cox 2-sample test allowing for noncompliance\cr
Cs              \tab Vector of character strings from list of unquoted names\cr
csv.get         \tab Enhanced importing of comma separated files labels\cr
cut2            \tab Like cut with better endpoint label construction and allows\cr
                \tab     construction of quantile groups or groups with given n\cr
datadensity     \tab Snapshot graph of distributions of all variables in\cr
                \tab     a data frame.  For continuous variables uses scat1d.\cr
dataRep         \tab Quantify representation of new observations in a database\cr
ddmmmyy         \tab SAS \dQuote{date7} output format for a chron object\cr
deff            \tab Kish design effect and intra-cluster correlation\cr
describe        \tab Function to describe different classes of objects.\cr
                \tab     Invoke by saying describe(object). It calls one of the\cr
                \tab     following:\cr
describe.data.frame
                \tab Describe all variables in a data frame (generalization\cr
                \tab     of SAS UNIVARIATE)\cr
describe.default
                \tab Describe a variable (generalization of SAS UNIVARIATE)\cr
dotplot3        \tab A more flexible version of dotplot\cr
Dotplot         \tab Enhancement of Trellis dotplot allowing for matrix\cr
                \tab     x-var., auto generation of Key function, superposition\cr
drawPlot        \tab Simple mouse-driven drawing program, including a function\cr
                \tab     for fitting Bezier curves\cr
Ecdf            \tab Empirical cumulative distribution function plot\cr
errbar          \tab Plot with error bars (Charles Geyer, U. Chi., mod FEH)\cr
event.chart     \tab Plot general event charts (Jack Lee, \email{jjlee@mdanderson.org}, \cr
                \tab     Ken Hess, Joel Dubin; Am Statistician 54:63-70,2000)\cr
event.history	\tab Event history chart with time-dependent cov. status\cr
                \tab     (Joel Dubin, \email{jdubin@uwaterloo.ca})\cr
find.matches    \tab Find matches (with tolerances) between columns of 2 matrices\cr
first.word      \tab Find the first word in an \R expression (R Heiberger)\cr
fit.mult.impute \tab Fit most regression models over multiple transcan imputations,\cr
                \tab     compute imputation-adjusted variances and avg. betas\cr
format.df       \tab Format a matrix or data frame with much user control\cr
                \tab     (R Heiberger and FE Harrell)\cr
ftupwr          \tab Power of 2-sample binomial test using Fleiss, Tytun, Ury\cr
ftuss           \tab Sample size for 2-sample binomial test using  "  "  "  "\cr
                \tab     (Both by Dan Heitjan, \email{dheitjan@biostats.hmc.psu.edu})\cr
gbayes          \tab Bayesian posterior and predictive distributions when both\cr
                \tab the prior and the likelihood are Gaussian\cr
getHdata        \tab Fetch and list datasets on our web site\cr
hdquantile      \tab Harrell-Davis nonparametric quantile estimator with s.e.\cr
histbackback    \tab Back-to-back histograms (Pat Burns, Salomon Smith\cr
                \tab     Barney, London, \email{pburns@dorado.sbi.com})\cr
hist.data.frame \tab Matrix of histograms for all numeric vars. in data frame\cr
                \tab     Use hist.data.frame(data.frame.name)\cr
histSpike       \tab Add high-resolution spike histograms or density estimates\cr
                \tab     to an existing plot\cr
hoeffd          \tab Hoeffding's D test (omnibus test of independence of X and Y)\cr
impute          \tab Impute missing data (generic method)\cr
interaction     \tab More flexible version of builtin function\cr
is.present      \tab Tests for non-blank character values or non-NA numeric values\cr
james.stein     \tab James-Stein shrinkage estimates of cell means from raw data\cr
labcurve        \tab Optimally label a set of curves that have been drawn on\cr
                \tab     an existing plot, on the basis of gaps between curves.\cr
                \tab     Also position legends automatically at emptiest rectangle.\cr
label           \tab Set or fetch a label for an \R-object\cr
Lag             \tab Lag a vector, padding on the left with NA or ''\cr
latex           \tab Convert an \R object to LaTeX (R Heiberger & FE Harrell)\cr
list.tree       \tab Pretty-print the structure of any data object\cr
                \tab     (Alan Zaslavsky, \email{zaslavsk@hcp.med.harvard.edu})\cr
Load            \tab Enhancement of \code{load}\cr
mask            \tab 8-bit logical representation of a short integer value\cr
                \tab     (Rick Becker)\cr
matchCases      \tab Match each case on one continuous variable\cr
matxv           \tab Fast matrix * vector, handling intercept(s) and NAs\cr
mgp.axis        \tab Version of axis() that uses appropriate mgp from \cr
                \tab     mgp.axis.labels and gets around bug in axis(2, ...)\cr
                \tab     that causes it to assume las=1\cr
mgp.axis.labels
                \tab Used by survplot and plot in \pkg{rms} library (and other\cr
                \tab     functions in the future) so that different spacing\cr
                \tab     between tick marks and axis tick mark labels may be\cr
                \tab     specified for x- and y-axes.  \cr
                \tab     Use mgp.axis.labels('default') to set defaults.\cr
                \tab     Users can set values manually using \cr
                \tab     mgp.axis.labels(x,y) where x and y are 2nd value of\cr
                \tab     par('mgp') to use.  Use mgp.axis.labels(type=w) to\cr
                \tab     retrieve values, where w='x', 'y', 'x and y', 'xy',\cr
                \tab     to get 3 mgp values (first 3 types) or 2 mgp.axis.labels.\cr
minor.tick      \tab Add minor tick marks to an existing plot\cr
mtitle          \tab Add outer titles and subtitles to a multiple plot layout\cr
multLines       \tab Draw multiple vertical lines at each x\cr
                \tab in a line plot\cr
\%nin\%         \tab Opposite of \%in\%\cr
nobsY           \tab Compute no. non-NA observations for left hand formula side\cr
nomiss          \tab Return a matrix after excluding any row with an NA\cr
panel.bpplot    \tab Panel function for trellis bwplot - box-percentile plots\cr
panel.plsmo     \tab Panel function for trellis xyplot - uses plsmo\cr
pBlock          \tab Block variables for certain lattice charts\cr
pc1             \tab Compute first prin. component and get coefficients on\cr\tab     original scale of variables\cr
plotCorrPrecision  \tab Plot precision of estimate of correlation coefficient\cr
plsmo           \tab Plot smoothed x vs. y with labeling and exclusion of NAs\cr
                \tab     Also allows a grouping variable and plots unsmoothed data\cr
popower         \tab Power and sample size calculations for ordinal responses\cr
                \tab     (two treatments, proportional odds model)\cr
prn             \tab prn(expression) does print(expression) but titles the\cr
                \tab     output with 'expression'.  Do prn(expression,txt) to add\cr
                \tab     a heading (\sQuote{txt}) before the \sQuote{expression} title\cr
pstamp          \tab Stamp a plot with date in lower right corner (pstamp())\cr
                \tab     Add ,pwd=T and/or ,time=T to add current directory \cr
                \tab      name or time\cr
                \tab     Put additional text for label as first argument, e.g.\cr
                \tab     pstamp('Figure 1')  will draw 'Figure 1  date'\cr
putKey          \tab Different way to use key()\cr
putKeyEmpty     \tab Put key at most empty part of existing plot\cr
rcorr           \tab Pearson or Spearman correlation matrix with pairwise deletion\cr
                \tab     of missing data\cr
rcorr.cens      \tab Somers' Dxy rank correlation with censored data\cr
rcorrp.cens     \tab Assess difference in concordance for paired predictors\cr
rcspline.eval   \tab Evaluate restricted cubic spline design matrix\cr
rcspline.plot   \tab Plot spline fit with nonparametric smooth and grouped estimates\cr
rcspline.restate
                \tab Restate restricted cubic spline in unrestricted form, and\cr
                \tab     create TeX expression to print the fitted function\cr
reShape         \tab Reshape a matrix into 3 vectors, reshape serial data\cr
rm.boot         \tab Bootstrap spline fit to repeated measurements model,\cr
                \tab     with simultaneous confidence region - least\cr
                \tab     squares using spline function in time\cr
rMultinom       \tab Generate multinomial random variables with varying prob.\cr
samplesize.bin  \tab Sample size for 2-sample binomial problem\cr
                \tab     (Rick Chappell, \email{chappell@stat.wisc.edu})\cr
sas.get         \tab Convert SAS dataset to S data frame\cr
sasxport.get    \tab Enhanced importing of SAS transport dataset in R\cr
Save            \tab Enhancement of \code{save}\cr
scat1d          \tab Add 1-dimensional scatterplot to an axis of an existing plot\cr
                \tab     (like bar-codes, FEH/Martin Maechler, \cr
                \tab     \email{maechler@stat.math.ethz.ch}/Jens Oehlschlaegel-Akiyoshi,\cr
                \tab     \email{oehl@psyres-stuttgart.de})\cr
score.binary    \tab Construct a score from a series of binary variables or\cr
                \tab     expressions\cr
sedit           \tab A set of character handling functions written entirely\cr
                \tab     in \R.  sedit() does much of what the UNIX sed\cr
                \tab     program does.  Other functions included are\cr
                \tab     substring.location, substring<-, replace.string.wild,\cr
                \tab     and functions to check if a string is numeric or\cr
                \tab     contains only the digits 0-9\cr
setTrellis      \tab Set Trellis graphics to use blank conditioning panel strips,\cr
                \tab     line thickness 1 for dot plot reference lines: \cr
                \tab     setTrellis(); 3 optional arguments\cr
show.col        \tab Show colors corresponding to col=0,1,...,99\cr
show.pch        \tab Show all plotting characters specified by pch=.\cr
                \tab     Just type show.pch() to draw the table on the \cr
                \tab     current device.  \cr
showPsfrag      \tab Use LaTeX to compile, and dvips and ghostview to\cr
                \tab    display a postscript graphic containing psfrag strings\cr
solvet          \tab Version of solve with argument tol passed to qr\cr
somers2         \tab Somers' rank correlation and c-index for binary y\cr
spearman        \tab Spearman rank correlation coefficient  spearman(x,y)\cr
spearman.test   \tab Spearman 1 d.f. and 2 d.f. rank correlation test\cr
spearman2       \tab Spearman multiple d.f. \eqn{\rho^2}{rho^2}, adjusted \eqn{\rho^2}{rho^2}, Wilcoxon-Kruskal-\cr
                \tab     Wallis test, for multiple predictors\cr
spower          \tab Simulate power of 2-sample test for survival under\cr
                \tab     complex conditions\cr
                \tab     Also contains the Gompertz2,Weibull2,Lognorm2
functions.\cr
spss.get        \tab Enhanced importing of SPSS files using read.spss
function \cr
src             \tab src(name) = source("name.s") with memory\cr
store           \tab store an object permanently (easy interface to assign function)\cr
strmatch        \tab Shortest unique identifier match \cr
                \tab     (Terry Therneau, \email{therneau@mayo.edu})\cr
subset          \tab More easily subset a data frame\cr
substi          \tab Substitute one var for another when observations NA\cr
summarize       \tab Generate a data frame containing stratified summary\cr
                \tab     statistics.  Useful for passing to trellis.\cr
summary.formula \tab General table making and plotting functions for summarizing\cr
                \tab data\cr
summaryD        \tab Summarizing using user-provided formula and dotchart3\cr
summaryM        \tab Replacement for summary.formula(..., method='reverse')\cr
summaryP        \tab Multi-panel dot chart for summarizing proportions\cr
summaryS        \tab Summarize multiple response variables for multi-panel\cr
                \tab dot chart or scatterplot\cr
summaryRc       \tab Summary for continuous variables using lowess\cr
symbol.freq     \tab X-Y Frequency plot with circles' area prop. to frequency\cr
sys             \tab Execute unix() or dos() depending on what's running\cr
tabulr          \tab Front-end to tabular function in the tables package\cr
tex             \tab Enclose a string with the correct syntax for using\cr
                \tab    with the LaTeX psfrag package, for postscript graphics\cr
transace        \tab ace() packaged for easily automatically transforming all\cr
                \tab     variables in a matrix\cr
transcan        \tab automatic transformation and imputation of NAs for a\cr
                \tab     series of predictor variables\cr
trap.rule       \tab Area under curve defined by arbitrary x and y vectors,\cr
                \tab using trapezoidal rule\cr
trellis.strip.blank
                \tab To make the strip titles in trellis more visible, you can \cr
                \tab     make the backgrounds blank by saying trellis.strip.blank().\cr
                \tab     Use before opening the graphics device.\cr
t.test.cluster  \tab 2-sample t-test for cluster-randomized observations\cr
uncbind         \tab Form individual variables from a matrix\cr
upData          \tab Update a data frame (change names, labels, remove vars, etc.)\cr
units           \tab Set or fetch "units" attribute - units of measurement for var.\cr
varclus         \tab Graph hierarchical clustering of variables using squared\cr
                \tab Pearson or Spearman correlations or Hoeffding D as similarities\cr
                \tab Also includes the naclus function for examining similarities in\cr
                \tab patterns of missing values across variables.\cr
wtd.mean \tab \cr wtd.var \tab \cr  wtd.quantile \tab \cr  wtd.Ecdf \tab
\cr wtd.table \tab \cr  wtd.rank \tab \cr wtd.loess.noiter \tab \cr
num.denom.setup \tab Set of function for obtaining weighted estimates\cr
xy.group        \tab Compute mean x vs. function of y by groups of x\cr
xYplot          \tab Like trellis xyplot but supports error bars and multiple\cr
                \tab     response variables that are connected as separate lines\cr
ynbind          \tab Combine a series of yes/no true/false present/absent variables into a matrix\cr
zoom            \tab Zoom in on any graphical display\cr \tab     (Bill Dunlap, \email{bill@statsci.com})
}}

\references{
See Alzola CF, Harrell FE (2004): An Introduction to S and the
Hmisc and Design Libraries at
\url{https://hbiostat.org/R/doc/sintro.pdf}
for extensive documentation and examples for the Hmisc package.
}

\section{Copyright Notice}{
\bold{GENERAL DISCLAIMER}\cr
This program is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public
License as published by the Free Software Foundation; either
version 2, or (at your option) any later version.\cr

This program is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU General Public License for more
details.\cr

In short: You may use it any way you like, as long as you
don't charge money for it, remove this notice, or hold anyone liable
for its results.  Also, please acknowledge the source and communicate
changes to the author.\cr

If this software is used is work presented for publication, kindly
reference it using for example:\cr
 Harrell FE (2014): Hmisc: A package of miscellaneous R functions.
  Programs available from \url{https://hbiostat.org/R/Hmisc/}.\cr
  Be sure to reference \R itself and other libraries used.
}
\author{
Frank E Harrell Jr\cr
Professor of Biostatistics\cr
Vanderbilt University School of Medicine\cr
Nashville, Tennessee\cr
\email{fh@fharrell.com}
}
\keyword{misc}
\concept{overview}

\name{smean.sd}
\alias{smean.cl.normal}
\alias{smean.sd}
\alias{smean.sdl}
\alias{smean.cl.boot}
\alias{smedian.hilow}
\title{
Compute Summary Statistics on a Vector
}
\description{
A number of statistical summary functions is provided for use
with \code{summary.formula} and \code{summarize} (as well as
\code{tapply} and by themselves).
\code{smean.cl.normal} computes 3 summary variables: the sample mean and
lower and upper Gaussian confidence limits based on the t-distribution.
\code{smean.sd} computes the mean and standard deviation.
\code{smean.sdl} computes the mean plus or minus a constant times the
standard deviation.
\code{smean.cl.boot} is a very fast implementation of the basic
nonparametric bootstrap for obtaining confidence limits for the
population mean without assuming normality.
These functions all delete NAs automatically.
\code{smedian.hilow} computes the sample median and a selected pair of
outer quantiles having equal tail areas.
}
\usage{
smean.cl.normal(x, mult=qt((1+conf.int)/2,n-1), conf.int=.95, na.rm=TRUE)

smean.sd(x, na.rm=TRUE)

smean.sdl(x, mult=2, na.rm=TRUE)

smean.cl.boot(x, conf.int=.95, B=1000, na.rm=TRUE, reps=FALSE)

smedian.hilow(x, conf.int=.95, na.rm=TRUE)
}
\arguments{
\item{x}{
for summary functions \code{smean.*}, \code{smedian.hilow}, a numeric vector
from which NAs will be removed automatically
}
\item{na.rm}{
defaults to \code{TRUE} unlike built-in functions, so that by
default \code{NA}s are automatically removed
}
\item{mult}{
for \code{smean.cl.normal} is the multiplier of the standard error of the
mean to use in obtaining confidence limits of the population mean
(default is appropriate quantile of the t distribution).  For
\code{smean.sdl}, \code{mult} is the multiplier of the standard deviation used
in obtaining a coverage interval about the sample mean.  The default
is \code{mult=2} to use plus or minus 2 standard deviations.
}
\item{conf.int}{
for \code{smean.cl.normal} and \code{smean.cl.boot} specifies the confidence
level (0-1) for interval estimation of the population mean.  For
\code{smedian.hilow}, \code{conf.int} is the coverage probability the outer
quantiles should target.  When the default, 0.95, is used, the lower
and upper quantiles computed are 0.025 and 0.975.
}
\item{B}{
number of bootstrap resamples for \code{smean.cl.boot}
}
\item{reps}{
set to \code{TRUE} to have \code{smean.cl.boot} return the vector of bootstrapped
means as the \code{reps} attribute of the returned object
}
}
\value{
a vector of summary statistics
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\seealso{
  \code{\link{summarize}}, \code{\link{summary.formula}}
}
\examples{
set.seed(1)
x <- rnorm(100)
smean.sd(x)
smean.sdl(x)
smean.cl.normal(x)
smean.cl.boot(x)
smedian.hilow(x, conf.int=.5)  # 25th and 75th percentiles

# Function to compute 0.95 confidence interval for the difference in two means
# g is grouping variable
bootdif <- function(y, g) {
 g <- as.factor(g)
 a <- attr(smean.cl.boot(y[g==levels(g)[1]], B=2000, reps=TRUE),'reps')
 b <- attr(smean.cl.boot(y[g==levels(g)[2]], B=2000, reps=TRUE),'reps')
 meandif <- diff(tapply(y, g, mean, na.rm=TRUE))
 a.b <- quantile(b-a, c(.025,.975))
 res <- c(meandif, a.b)
 names(res) <- c('Mean Difference','.025','.975')
 res
}

}
\keyword{nonparametric}
\keyword{htest}
\concept{bootstrap}

\name{transace}
\alias{transace}
\alias{areg.boot}
\alias{print.areg.boot}
\alias{plot.areg.boot}
\alias{predict.areg.boot}
\alias{summary.areg.boot}
\alias{print.summary.areg.boot}
\alias{Function.areg.boot}
\alias{Mean}
\alias{Mean.areg.boot}
\alias{Quantile}
\alias{Quantile.areg.boot}
\alias{monotone}
\alias{smearingEst}
\title{
  Additive Regression and Transformations using ace or avas
}
\description{
  \code{transace} is \code{\link[acepack]{ace}} packaged for easily automatically
  transforming all variables in a matrix.  \code{transace} is a fast
  one-iteration version of \code{\link{transcan}} without imputation of
  \code{NA}s.

  \code{areg.boot} uses \code{\link{areg}} or
  \code{\link[acepack]{avas}} to fit additive regression models allowing
  all variables in the model (including the left-hand-side) to be
  transformed, with transformations chosen so as to optimize certain
  criteria.  The default method uses \code{\link{areg}} whose goal it is
  to maximize \eqn{R^2}. \code{method="avas"} explicity tries to
  transform the response variable so as to stabilize the variance of the
  residuals. All-variables-transformed models tend to inflate \code{R^2}
  and it can be difficult to get confidence limits for each
  transformation. \code{areg.boot} solves both of these problems using
  the bootstrap.  As with the \code{\link[rms]{validate}} function in the
  \pkg{rms} library, the Efron bootstrap is used to estimate the
  optimism in the apparent \eqn{R^2}, and this optimism is subtracted
  from the apparent \eqn{R^2} to optain a bias-corrected \eqn{R^2}.
  This is done however on the transformed response variable scale.

  Tests with 3 predictors show that the \code{\link[acepack]{avas}} and
  \code{\link[acepack]{ace}} estimates are unstable unless the sample size
  exceeds 350.  Apparent \eqn{R^2} with low sample sizes can be very
  inflated, and bootstrap estimates of \eqn{R^2} can be even more
  unstable in such cases, resulting in optimism-corrected \eqn{R^2} that
  are much lower even than the actual \eqn{R^2}.  The situation can be
  improved a little by restricting predictor transformations to be
  monotonic.  On the other hand, the \code{areg} approach allows one to
  control overfitting by specifying the number of knots to use for each
  continuous variable in a restricted cubic spline function.

  For \code{method="avas"} the response transformation is restricted to
  be monotonic.  You can specify restrictions for transformations of
  predictors (and linearity for the response).  When the first argument
  is a formula, the function automatically determines which variables
  are categorical (i.e., \code{factor}, \code{category}, or character
  vectors).  Specify linear transformations by enclosing variables by
  the identify function (\code{I()}), and specify monotonicity by using
  \code{monotone(\var{variable})}.  Monotonicity restrictions are not
  allowed with \code{method="areg"}.
  
  The \code{\link{summary}} method for \code{areg.boot} computes
  bootstrap estimates of standard errors of differences in predicted
  responses (usually on the original scale) for selected levels of each
  predictor against the lowest level of the predictor.  The smearing
  estimator (see below) can be used here to estimate differences in
  predicted means, medians, or many other statistics.  By default,
  quartiles are used for continuous predictors and all levels are used
  for categorical ones.  See \cite{Details} below.  There is also a
  \code{\link{plot}} method for plotting transformation estimates,
  transformations for individual bootstrap re-samples, and pointwise
  confidence limits for transformations. Unless you already have a
  \code{par(mfrow=)} in effect with more than one row or column,
  \code{plot} will try to fit the plots on one page.  A
  \code{\link{predict}} method computes predicted values on the original
  or transformed response scale, or a matrix of transformed
  predictors. There is a \code{\link{Function}} method for producing a
  list of \R functions that perform the final fitted transformations.
  There is also a \code{\link{print}} method for \code{areg.boot}
  objects.

  When estimated means (or medians or other statistical parameters) are
  requested for models fitted with \code{areg.boot} (by
  \code{summary.areg.boot} or \code{predict.areg.boot}), the
  \dQuote{smearing} estimator of \cite{Duan (1983)} is used.  Here we
  estimate the mean of the untransformed response by computing the
  arithmetic mean of \eqn{\var{ginverse}(\var{lp} + \var{residuals})},
  where \var{ginverse} is the inverse of the nonparametric
  transformation of the response (obtained by reverse linear
  interpolation), \var{lp} is the linear predictor for an individual
  observation on the transformed scale, and \var{residuals} is the
  entire vector of residuals estimated from the fitted model, on the
  transformed scales (\var{n} residuals for \var{n} original observations).  The
  \code{smearingEst} function computes the general smearing estimate.
  For efficiency \code{smearingEst} recognizes that quantiles are
  transformation-preserving, i.e., when one wishes to estimate a
  quantile of the untransformed distribution one just needs to compute
  the inverse transformation of the transformed estimate after the
  chosen quantile of the vector of residuals is added to it. When the
  median is desired, the estimate is
  \eqn{\var{ginverse}(\var{lp} + \mbox{median}(\var{residuals}))}{
    \var{ginverse}(\var{lp} + median(\var{residuals}))}.
  See the last example for how \code{smearingEst} can be used outside of
  \code{areg.boot}.

  \code{Mean} is a generic function that returns an \R function to
  compute the estimate of the mean of a variable.  Its input is
  typically some kind of model fit object.  Likewise, \code{Quantile} is
  a generic quantile function-producing function.  \code{Mean.areg.boot}
  and \code{Quantile.areg.boot} create functions of a vector of linear
  predictors that transform them into the smearing estimates of the mean
  or quantile of the response variable,
  respectively. \code{Quantile.areg.boot} produces exactly the same
  value as \code{predict.areg.boot} or \code{smearingEst}.  \code{Mean}
  approximates the mapping of linear predictors to means over an evenly
  spaced grid of by default 200 points.  Linear interpolation is used
  between these points.  This approximate method is much faster than the
  full smearing estimator once \code{Mean} creates the function.  These
  functions are especially useful in \code{\link[rms]{nomogram}} (see the
  example on hypothetical data).
}
\usage{
transace(x, monotonic=NULL, categorical=NULL, binary=NULL, pl=TRUE)

areg.boot(x, data, weights, subset, na.action=na.delete, 
          B=100, method=c("areg","avas"), nk=4, evaluation=100, valrsq=TRUE, 
          probs=c(.25,.5,.75), tolerance=NULL)

\method{print}{areg.boot}(x, \dots)

\method{plot}{areg.boot}(x, ylim, boot=TRUE, col.boot=2, lwd.boot=.15,
     conf.int=.95, \dots)

smearingEst(transEst, inverseTrans, res,
            statistic=c('median','quantile','mean','fitted','lp'),
            q)

\method{summary}{areg.boot}(object, conf.int=.95, values, adj.to,
        statistic='median', q, \dots)

\method{print}{summary.areg.boot}(x, \dots)

\method{predict}{areg.boot}(object, newdata,
        statistic=c("lp", "median",
                    "quantile", "mean", "fitted", "terms"),
        q=NULL, \dots) 

\method{Function}{areg.boot}(object, type=c('list','individual'),
         ytype=c('transformed','inverse'),
         prefix='.', suffix='', pos=-1, \dots)

Mean(object, \dots)

Quantile(object, \dots)

\method{Mean}{areg.boot}(object, evaluation=200, \dots)

\method{Quantile}{areg.boot}(object, q=.5, \dots)
}
\arguments{
  \item{x}{
    for \code{transace} a numeric matrix.  For \code{areg.boot} \code{x}
    is a formula.  For \code{print} or \code{plot}, an object created by
    \code{areg.boot}.  For \code{print.summary.areg.boot}, and object
    created by \code{summary.areg.boot}.
  }
  \item{object}{
    an object created by \code{areg.boot}, or a model fit object
    suitable for \code{Mean} or \code{Quantile}.
  }
  \item{transEst}{
    a vector of transformed values.  In log-normal regression these
    could be predicted log(Y) for example.
  }
  \item{inverseTrans}{
    a function specifying the inverse transformation needed to change
    \code{transEst} to the original untransformed scale.
    \code{inverseTrans} may also be a 2-element list defining a mapping
    from the transformed values to untransformed values.  Linear
    interpolation is used in this case to obtain untransform values.
  }
  \item{binary, categorical, monotonic}{
    These are vectors of variable names specifying what to assume about
    each column of \code{x} for \code{transace}.  Binary variables are not
    transformed, of course.
  }
  \item{pl}{
    set \code{pl=FALSE} to prevent \code{transace} from plotting each
    fitted transformation
  }
  \item{data}{
    data frame to use if \code{x} is a formula and variables are not
    already in the search list
  }
  \item{weights}{
    a numeric vector of observation weights.  By default, all
    observations are weighted equally.
  }
  \item{subset}{
    an expression to subset data if \code{x} is a formula
  }
  \item{na.action}{
    a function specifying how to handle \code{NA}s.  Default is \code{\link{na.delete}}.
  }
  \item{B}{
    number of bootstrap samples (default=100)
  }
  \item{method}{
    \code{"areg"} (the default) or \code{"avas"}
  }
  \item{nk}{
    number of knots for continuous variables not restricted to be
    linear.  Default is 4.  One or two is not allowed.  \code{nk=0}
    forces linearity for all continuous variables.
  }
  \item{evaluation}{
    number of equally-spaced points at which to evaluate (and save) the
    nonparametric transformations derived by \code{\link[acepack]{avas}} or
    \code{\link[acepack]{ace}}.  Default is 100.  For \code{Mean.areg.boot},
    \code{evaluation} is the number of points at which to evaluate exact
    smearing estimates, to approximate them using linear interpolation
    (default is 200).
  }
  \item{valrsq}{
    set to \code{TRUE} to more quickly do bootstrapping without
    validating \eqn{R^2}
  }
  \item{probs}{
    vector probabilities denoting the quantiles of continuous predictors
    to use in estimating effects of those predictors
  }
  \item{tolerance}{
    singularity criterion; list source code for the
    \code{\link{lm.fit.qr.bare}} function.
  }
  \item{res}{
    a vector of residuals from the transformed model.  Not required when
    \code{statistic="lp"} or \code{statistic="fitted"}.
  }
  \item{statistic}{
    statistic to estimate with the smearing estimator.  For
    \code{smearingEst}, the default results in computation of the sample
    median of the model residuals, then \code{smearingEst} adds the
    median residual and back-transforms to get estimated median
    responses on the original scale.  \code{statistic="lp"} causes
    predicted transformed responses to be computed.  For
    \code{smearingEst}, the result (for \code{statistic="lp"}) is the
    input argument \code{transEst}.  \code{statistic="fitted"} gives
    predicted untransformed responses, i.e.,
    \eqn{\var{ginverse}(\var{lp})}, where \var{ginverse} is the inverse
    of the estimated response transformation, estimated by reverse
    linear interpolation on the tabulated nonparametric response
    transformation or by using an explicit analytic
    function. \code{statistic="quantile"} generalizes \code{"median"} to
    any single quantile \code{q} which must be specified.  \code{"mean"}
    causes the population mean response to be estimated.  For
    \code{predict.areg.boot}, \code{statistic="terms"} returns a matrix
    of transformed predictors. \code{statistic} can also be any \R
    function that computes a single value on a vector of values, such as
    \code{statistic=var}.  Note that in this case the function name is
    not quoted.
  }
  \item{q}{
    a single quantile of the original response scale to estimate, when
    \code{statistic="quantile"}, or for \code{Quantile.areg.boot}.
  }
  \item{ylim}{
    2-vector of y-axis limits
  }
  \item{boot}{
    set to \code{FALSE} to not plot any bootstrapped transformations.
    Set it to an integer \var{k} to plot the first \var{k} bootstrap
    estimates.
  }
  \item{col.boot}{
    color for bootstrapped transformations
  }
  \item{lwd.boot}{
    line width for bootstrapped transformations
  }
  \item{conf.int}{
    confidence level (0-1) for pointwise bootstrap confidence limits and
    for estimated effects of predictors in \code{summary.areg.boot}. The
    latter assumes normality of the estimated effects.
  }
  \item{values}{
    a list of vectors of settings of the predictors, for predictors for
    which you want to overide settings determined from \code{probs}.
    The list must have named components, with names corresponding to the
    predictors.  Example:
    \code{values=list(x1=c(2,4,6,8), x2=c(-1,0,1))} specifies that
    \code{summary} is to estimate the effect on \code{y} of changing
    \code{x1} from 2 to 4, 2 to 6, 2 to 8, and separately, of changing
    \code{x2} from -1 to 0 and -1 to 1.  
  }
  \item{adj.to}{
    a named vector of adjustment constants, for setting all other
    predictors when examining the effect of a single predictor in
    \code{summary}.  The more nonlinear is the transformation of
    \code{y} the more the adjustment settings will matter.  Default
    values are the medians of the values defined by \code{values} or
    \code{probs}.  You only need to name the predictors for which you
    are overriding the default settings. Example:
    \code{adj.to=c(x2=0,x5=10)} will set \code{x2} to 0 and \code{x5} to
    10 when assessing the impact of variation in the other predictors.
  }
  \item{newdata}{
    a data frame or list containing the same number of values of all of
    the predictors used in the fit.  For \code{\link{factor}} predictors
    the \samp{levels} attribute do not need to be in the same order as
    those used in the original fit, and not all levels need to be
    represented.  If \code{newdata} is omitted, you can still obtain
    linear predictors (on the transformed response scale) and fitted
    values (on the original response scale), but not \code{"terms"}.
  }
  \item{type}{
    specifies how \code{\link{Function}} is to return the series of
    functions that define the transformations of all variables.  By
    default a list is created, with the names of the list elements being
    the names of the variables.  Specify \code{type="individual"} to
    have separate functions created in the current environment
    (\code{pos=-1}, the default) or in location defined by \code{pos}
    if \code{where} is specified.  For the latter method, the names of
    the objects created are the names of the corresponding variables,
    prefixed by \code{prefix} and with \code{suffix} appended to the
    end. If any of \code{pos}, \code{prefix}, or
    \code{suffix} is specified, \code{type} is automatically set to
    \code{"individual"}.
  }
  \item{ytype}{
    By default the first function created by \code{Function} is the
    y-transformation.  Specify \code{ytype="inverse"} to instead create
    the inverse of the transformation, to be able to obtain originally
    scaled y-values.
  }
  \item{prefix}{
    character string defining the prefix for function names created when
    \code{type="individual"}.  By default, the function specifying the
    transformation for variable \code{x} will be named \code{.x}.
  }
  \item{suffix}{
    character string defining the suffix for the function names
  }
  \item{pos}{
	See \code{\link{assign}}.
  }
  \item{\dots}{
    arguments passed to other functions
  }
}
\value{
  \code{transace} returns a matrix like \code{x} but containing
  transformed values.  This matrix has attributes \code{rsq} (vector of
  \eqn{R^2} with which each variable can be predicted from the others)
  and \code{omitted} (row numbers of \code{x} that were deleted due to
  \code{NA}s).
  
  \code{areg.boot} returns a list of class \samp{areg.boot} containing
  many elements, including (if \code{valrsq} is \code{TRUE})
  \code{rsquare.app} and \code{rsquare.val}.  \code{summary.areg.boot}
  returns a list of class \samp{summary.areg.boot} containing a matrix
  of results for each predictor and a vector of adjust-to settings.  It
  also contains the call and a \samp{label} for the statistic that was
  computed.  A \code{print} method for these objects handles the
  printing.  \code{predict.areg.boot} returns a vector unless
  \code{statistic="terms"}, in which case it returns a
  matrix. \code{Function.areg.boot} returns by default a list of
  functions whose argument is one of the variables (on the original
  scale) and whose returned values are the corresponding transformed
  values.  The names of the list of functions correspond to the names of
  the original variables.  When \code{type="individual"},
  \code{Function.areg.boot} invisibly returns the vector of names of the
  created function objects. \code{Mean.areg.boot} and
  \code{Quantile.areg.boot} also return functions.
  
  \code{smearingEst} returns a vector of estimates of distribution
  parameters of class \samp{labelled} so that \code{print.labelled} wil
  print a label documenting the estimate that was used (see
  \code{\link{label}}).  This label can be retrieved for other purposes
  by using e.g. \code{label(\var{obj})}, where \var{obj} was the vector
  returned by \code{smearingEst}.
}
\details{
  As \code{transace} only does one iteration over the predictors, it may
  not find optimal transformations and it will be dependent on the order
  of the predictors in \code{x}.

  \code{\link[acepack]{ace}} and \code{\link[acepack]{avas}} standardize transformed variables to have
  mean zero and variance one for each bootstrap sample, so if a
  predictor is not important it will still consistently have a positive
  regression coefficient.  Therefore using the bootstrap to estimate
  standard errors of the additive least squares regression coefficients
  would not help in drawing inferences about the importance of the
  predictors.  To do this, \code{summary.areg.boot} computes estimates
  of, e.g., the inter-quartile range effects of predictors in predicting
  the response variable (after untransforming it).  As an example, at
  each bootstrap repetition the estimated transformed value of one of
  the predictors is computed at the lower quartile, median, and upper
  quartile of the raw value of the predictor.  These transformed x
  values are then multipled by the least squares estimate of the partial
  regression coefficient for that transformed predictor in predicting
  transformed y.  Then these weighted transformed x values have the
  weighted transformed x value corresponding to the lower quartile
  subtracted from them, to estimate an x effect accounting for
  nonlinearity.  The last difference computed is then the standardized
  effect of raising x from its lowest to its highest quartile.  Before
  computing differences, predicted values are back-transformed to be on
  the original y scale in a way depending on \code{statistic} and
  \code{q}. The sample standard deviation of these effects (differences)
  is taken over the bootstrap samples, and this is used to compute
  approximate confidence intervals for effects andapproximate P-values,
  both assuming normality.
  
  \code{predict} does not re-insert \code{NA}s corresponding to
  observations that were dropped before the fit, when \code{newdata} is
  omitted.
  
  \code{statistic="fitted"} estimates the same quantity as
  \code{statistic="median"} if the residuals on the transformed response
  have a symmetric distribution. The two provide identical estimates
  when the sample median of the residuals is exactly zero. The sample
  mean of the residuals is constrained to be exactly zero although this
  does not simplify anything.
}
\author{
  Frank Harrell
  \cr
  Department of Biostatistics
  \cr
  Vanderbilt University School of Medicine
  \cr
  \email{fh@fharrell.com}
}
\seealso{
  \code{\link[acepack]{avas}}, \code{\link[acepack]{ace}},
  \code{\link[rms]{ols}}, \code{\link[rms]{validate}},
  \code{\link[rms]{predab.resample}}, \code{\link{label}},
  \code{\link[rms]{nomogram}}
}
\references{
Harrell FE, Lee KL, Mark DB (1996): Stat in Med 15:361--387.


Duan N (1983): Smearing estimate: A nonparametric retransformation
method.  JASA 78:605--610.


Wang N, Ruppert D (1995): Nonparametric estimation of the
transformation in the transform-both-sides regression model.  JASA
90:522--534. 


See \code{\link[acepack]{avas}}, \code{\link[acepack]{ace}} for primary references.
}
\examples{
# xtrans <- transace(cbind(age,sex,blood.pressure,race.code),
#                    binary='sex', monotonic='age',
#                    categorical='race.code')


# Generate random data from the model y = exp(x1 + epsilon/3) where
# x1 and epsilon are Gaussian(0,1)
set.seed(171)  # to be able to reproduce example
x1 <- rnorm(200)
x2 <- runif(200)  # a variable that is really unrelated to y]
x3 <- factor(sample(c('cat','dog','cow'), 200,TRUE))  # also unrelated to y
y  <- exp(x1 + rnorm(200)/3)
f  <- areg.boot(y ~ x1 + x2 + x3, B=40)
f
plot(f)
# Note that the fitted transformation of y is very nearly log(y)
# (the appropriate one), the transformation of x1 is nearly linear,
# and the transformations of x2 and x3 are essentially flat 
# (specifying monotone(x2) if method='avas' would have resulted
# in a smaller confidence band for x2)


summary(f)


# use summary(f, values=list(x2=c(.2,.5,.8))) for example if you
# want to use nice round values for judging effects


# Plot Y hat vs. Y (this doesn't work if there were NAs)
plot(fitted(f), y)  # or: plot(predict(f,statistic='fitted'), y)


# Show fit of model by varying x1 on the x-axis and creating separate
# panels for x2 and x3.  For x2 using only a few discrete values
newdat <- expand.grid(x1=seq(-2,2,length=100),x2=c(.25,.75),
                      x3=c('cat','dog','cow'))
yhat <- predict(f, newdat, statistic='fitted')  
# statistic='mean' to get estimated mean rather than simple inverse trans.
xYplot(yhat ~ x1 | x2, groups=x3, type='l', data=newdat)


\dontrun{
# Another example, on hypothetical data
f <- areg.boot(response ~ I(age) + monotone(blood.pressure) + race)
# use I(response) to not transform the response variable
plot(f, conf.int=.9)
# Check distribution of residuals
plot(fitted(f), resid(f))
qqnorm(resid(f))
# Refit this model using ols so that we can draw a nomogram of it.
# The nomogram will show the linear predictor, median, mean.
# The last two are smearing estimators.
Function(f, type='individual')  # create transformation functions
f.ols <- ols(.response(response) ~ age + 
             .blood.pressure(blood.pressure) + .race(race))
# Note: This model is almost exactly the same as f but there
# will be very small differences due to interpolation of
# transformations
meanr <- Mean(f)      # create function of lp computing mean response
medr  <- Quantile(f)  # default quantile is .5
nomogram(f.ols, fun=list(Mean=meanr,Median=medr))


# Create S functions that will do the transformations
# This is a table look-up with linear interpolation
g <- Function(f)
plot(blood.pressure, g$blood.pressure(blood.pressure))
# produces the central curve in the last plot done by plot(f)
}


# Another simulated example, where y has a log-normal distribution
# with mean x and variance 1.  Untransformed y thus has median
# exp(x) and mean exp(x + .5sigma^2) = exp(x + .5)
# First generate data from the model y = exp(x + epsilon),
# epsilon ~ Gaussian(0, 1)


set.seed(139)
n <- 1000
x <- rnorm(n)
y <- exp(x + rnorm(n))
f <- areg.boot(y ~ x, B=20)
plot(f)       # note log shape for y, linear for x.  Good!
xs <- c(-2, 0, 2)
d <- data.frame(x=xs)
predict(f, d, 'fitted')
predict(f, d, 'median')   # almost same; median residual=-.001
exp(xs)                   # population medians
predict(f, d, 'mean')
exp(xs + .5)              # population means


# Show how smearingEst works
res <- c(-1,0,1)          # define residuals
y <- 1:5
ytrans <- log(y)
ys <- seq(.1,15,length=50)
trans.approx <- list(x=log(ys), y=ys)
options(digits=4)
smearingEst(ytrans, exp, res, 'fitted')          # ignores res
smearingEst(ytrans, trans.approx, res, 'fitted') # ignores res 
smearingEst(ytrans, exp, res, 'median')          # median res=0
smearingEst(ytrans, exp, res+.1, 'median')       # median res=.1
smearingEst(ytrans, trans.approx, res, 'median')
smearingEst(ytrans, exp, res, 'mean')
mean(exp(ytrans[2] + res))                       # should equal 2nd # above
smearingEst(ytrans, trans.approx, res, 'mean')
smearingEst(ytrans, trans.approx, res, mean)
# Last argument can be any statistical function operating
# on a vector that returns a single value
}
\keyword{nonparametric}
\keyword{smooth}
\keyword{multivariate}
\keyword{nonlinear}
\keyword{regression}
\concept{bootstrap}
\concept{model validation}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combine.levels.r
\name{combine.levels}
\alias{combine.levels}
\title{combine.levels}
\usage{
combine.levels(
  x,
  minlev = 0.05,
  m,
  ord = is.ordered(x),
  plevels = FALSE,
  sep = ","
)
}
\arguments{
\item{x}{a factor, `ordered` factor, or numeric or character variable that will be turned into a `factor`}

\item{minlev}{the minimum proportion of observations in a cell before that cell is combined with one or more cells.  If more than one cell has fewer than minlev*n observations, all such cells are combined into a new cell labeled `"OTHER"`.  Otherwise, the lowest frequency cell is combined with the next lowest frequency cell, and the level name is the combination of the two old level levels. When `ord=TRUE` combinations happen only for consecutive levels.}

\item{m}{alternative to `minlev`, is the minimum number of observations in a cell before it will be combined with others}

\item{ord}{set to `TRUE` to treat `x` as if it were an ordered factor, which allows only consecutive levels to be combined}

\item{plevels}{by default `combine.levels` pools low-frequency levels into a category named `OTHER` when `x` is not ordered and `ord=FALSE`.  To instead name this category the concatenation of all the pooled level names, separated by a comma, set `plevels=TRUE`.}

\item{sep}{the separator for concatenating levels when `plevels=TRUE`}
}
\value{
a factor variable, or if `ord=TRUE` an ordered factor variable
}
\description{
Combine Infrequent Levels of a Categorical Variable
}
\details{
After turning `x` into a `factor` if it is not one already, combines
levels of `x` whose frequency falls below a specified relative frequency `minlev` or absolute count `m`.  When `x` is not treated as ordered, all of the
small frequency levels are combined into `"OTHER"`, unless `plevels=TRUE`.
When `ord=TRUE` or `x` is an ordered factor, only consecutive levels
are combined.  New levels are constructed by concatenating the levels with
`sep` as a separator.  This is useful when comparing ordinal regression
with polytomous (multinomial) regression and there are too many
categories for polytomous regression.  `combine.levels` is also useful
when assumptions of ordinal models are being checked empirically by
computing exceedance probabilities for various cutoffs of the
dependent variable.
}
\examples{
x <- c(rep('A', 1), rep('B', 3), rep('C', 4), rep('D',1), rep('E',1))
combine.levels(x, m=3)
combine.levels(x, m=3, plevels=TRUE)
combine.levels(x, ord=TRUE, m=3)
x <- c(rep('A', 1), rep('B', 3), rep('C', 4), rep('D',1), rep('E',1),
       rep('F',1))
combine.levels(x, ord=TRUE, m=3)
}
\author{
Frank Harrell
}

\name{ynbind}
\alias{ynbind}
\alias{[.ynbind}
\alias{pBlock}
\alias{[.pBlock}
\title{Combine Variables in a Matrix}
\description{
\code{ynbind} column binds a series of related yes/no variables,
allowing for a final argument \code{label} used to label the panel
created for the group.  \code{label}s for individual variables are
collected into a vector attribute \code{"labels"} for the result;
original variable names are used in place of labels for those variables
without labels.  A positive response is taken to be \code{y, yes,
present} (ignoring case) or a \code{logical} \code{TRUE} value.  By
default, the columns are sorted be ascending order or the overall
proportion of positives.  A subsetting method is provided for objects of
class \code{"ynbind"}.

\code{pBlock} creates a matrix similarly labeled, from a general set of
variables (without special handling of binaries), and sets to \code{NA}
any observation not in \code{subset} so that when that block of
variables is analyzed it will be only for that subset.
}

\usage{
ynbind(..., label = deparse(substitute(...)),
       asna = c("unknown", "unspecified"), sort = TRUE)

pBlock(..., subset=NULL, label = deparse(substitute(...)))
}
\arguments{
  \item{\dots}{a series of vectors}
  \item{label}{a label for the group, to be attached to the resulting
		matrix as a \code{"label"} attribute, used by \code{\link{summaryP}}.}
  \item{asna}{a vector of character strings specifying levels that are
		to be treated the same as \code{NA} if present}
  \item{sort}{set to \code{FALSE} to not sort the columns by their
		proportions}
	\item{subset}{subset criteria - either a vector of logicals or subscripts}
}
\value{a matrix of class \code{"ynbind"} or
	\code{"pBlock"} with \code{"label"} and \code{"labels"} attributes.
	For \code{"pBlock"}, factor input vectors will have values converted
	to \code{character}. 
}		
\author{Frank Harrell}
\seealso{\code{\link{summaryP}}}
\examples{
x1 <- c('yEs', 'no', 'UNKNOWN', NA)
x2 <- c('y', 'n', 'no', 'present')
label(x2) <- 'X2'
X <- ynbind(x1, x2, label='x1-2')
X[1:3,]

pBlock(x1, x2, subset=2:3, label='x1-2')
}
\keyword{misc}
\keyword{utilities}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Fdebug.r
\name{Fdebug}
\alias{Fdebug}
\title{Debug Printing Function Generator}
\usage{
Fdebug(opt)
}
\arguments{
\item{opt}{character string containing an option name}
}
\value{
a function
}
\description{
Takes the name of a system \code{options(opt=)} and checks to see if option \code{opt} is
set to \code{TRUE}, taking its default value to be \code{FALSE}.  If \code{TRUE}, a function is
created that calls \code{\link[=prn]{prn()}} to print an object with the object's name in the
description along with the option name and the name of the function within which
the generated function was called, if any.  If option \code{opt} is not set, a dummy function
is generated instead.  If \code{options(debug_file=)} is set when the generated function
is called, \code{\link[=prn]{prn()}} output will be appended to that file name instead of the console.
At any time, set \code{options(debug_file='')} to resume printing to the console.
}
\examples{
dfun <- Fdebug('my_option_name')   # my_option_name not currently set
dfun
dfun(sqrt(2))
options(my_option_name=TRUE)
dfun <- Fdebug('my_option_name')
dfun
dfun(sqrt(2))
# options(debug_file='/tmp/z') to append output to /tmp/z
options(my_option_name=NULL)
}
\author{
Fran Harrell
}

\name{hoeffd}
\alias{hoeffd}
\alias{print.hoeffd}
\title{
Matrix of Hoeffding's D Statistics
}
\description{
Computes a matrix of Hoeffding's (1948) \code{D} statistics for all
possible pairs of columns of a matrix.  \code{D} is a measure of the
distance between \code{F(x,y)} and \code{G(x)H(y)}, where \code{F(x,y)}
is the joint CDF of \code{X} and \code{Y}, and \code{G} and \code{H} are
marginal CDFs. Missing values are deleted in pairs rather than deleting
all rows of \code{x} having any missing variables.  The \code{D}
statistic is robust against a wide variety of alternatives to
independence, such as non-monotonic relationships.  The larger the value
of \code{D}, the more dependent are \code{X} and \code{Y} (for many
types of dependencies).  \code{D} used here is 30 times Hoeffding's
original \code{D}, and ranges from -0.5 to 1.0 if there are no ties in
the data.  \code{print.hoeffd} prints the information derived by
\code{hoeffd}.  The higher the value of \code{D}, the more dependent are
\code{x} and \code{y}.  \code{hoeffd} also computes the mean and maximum
absolute values of the difference between the joint empirical CDF and
the product of the marginal empirical CDFs.
}
\usage{
hoeffd(x, y)
\method{print}{hoeffd}(x, \dots)
}
\arguments{
\item{x}{
a numeric matrix with at least 5 rows and at least 2 columns (if
\code{y} is absent), or an object created by \code{hoeffd}
}
\item{y}{
a numeric vector or matrix which will be concatenated to \code{x}
}
\item{\dots}{ignored}
}
\value{
a list with elements \code{D}, the
matrix of D statistics, \code{n} the
matrix of number of observations used in analyzing each pair of variables,
and \code{P}, the asymptotic P-values.
Pairs with fewer than 5 non-missing values have the D statistic set to NA.
The diagonals of \code{n} are the number of non-NAs for the single variable
corresponding to that row and column.
}
\details{
Uses midranks in case of ties, as described by Hollander and Wolfe.
P-values are approximated by linear interpolation on the table
in Hollander and Wolfe, which uses the asymptotically equivalent
Blum-Kiefer-Rosenblatt statistic.  For \code{P<.0001} or \code{>0.5}, \code{P} values are
computed using a well-fitting linear regression function in \code{log P} vs.
the test statistic.
Ranks (but not bivariate ranks) are computed using efficient
algorithms (see reference 3).
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\references{
Hoeffding W. (1948): A non-parametric test of independence.  Ann Math Stat
19:546--57.


Hollander M. and Wolfe D.A. (1973).  Nonparametric Statistical Methods,
pp. 228--235, 423. New York: Wiley.


Press WH, Flannery BP, Teukolsky SA, Vetterling, WT (1988): Numerical
Recipes in C.  Cambridge: Cambridge University Press.
}
\seealso{
\code{\link{rcorr}}, \code{\link{varclus}}
}
\examples{
x <- c(-2, -1, 0, 1, 2)
y <- c(4,   1, 0, 1, 4)
z <- c(1,   2, 3, 4, NA)
q <- c(1,   2, 3, 4, 5)
hoeffd(cbind(x,y,z,q))


# Hoeffding's test can detect even one-to-many dependency
set.seed(1)
x <- seq(-10,10,length=200)
y <- x*sign(runif(200,-1,1))
plot(x,y)
hoeffd(x,y)
}
\keyword{nonparametric}
\keyword{htest}

\name{tex}
\alias{tex}
\title{
  function for use in graphs that are used with the psfrag package in LaTeX
}
\description{
  \code{tex} is a little function to save typing when including TeX
  commands in graphs that are used with the psfrag package in LaTeX to
  typeset any LaTeX text inside a postscript graphic.  \code{tex}
  surrounds the input character string with \samp{\tex[options]\{\}}.
  This is especially useful for getting Greek letters and math symbols
  in postscript graphs.  By default \code{tex} returns a string with
  \code{psfrag} commands specifying that the string be centered, not
  rotated, and not specially enlarged or shrunk.
}
\usage{
tex(string, lref='c', psref='c', scale=1, srt=0)
}
\arguments{
  \item{string}{
    a character string to be processed by \code{psfrag} in LaTeX.
  }
  \item{lref}{
    LaTeX reference point for \code{string}.  See the \code{psfrag}
    documentation referenced below.  Default is \code{"c"} for centered
    (this is also the default for \code{psref}).
  }
  \item{psref}{
    PostScript reference point.
  }
  \item{scale}{
    scall factor, default is 1
  }
  \item{srt}{
    rotation for \code{string} in degrees (default is zero)
  }
}
\value{
  \code{tex} returns a modified character string.
}
\author{
  Frank Harrell\cr
  Department of Biostatistics\cr
  Vanderbilt University\cr
  \email{fh@fharrell.com}
}
\references{
  Grant MC, Carlisle (1998): The PSfrag System, Version 3.  Full
  documentation is obtained by searching www.ctan.org for \file{pfgguide.ps}.
}
\seealso{
  \code{\link{postscript}}, \code{\link{par}}, \code{\link{ps.options}},
  \code{\link{mgp.axis.labels}}, \code{\link{pdf}},
  \code{\link[lattice]{trellis.device}}, \code{\link{setTrellis}}
}
\examples{
\dontrun{
pdf('test.pdf')
x <- seq(0,15,length=100)
plot(x, dchisq(x, 5), xlab=tex('$x$'),
        ylab=tex('$f(x)$'), type='l')
title(tex('Density Function of the $\\chi_{5}^{2}$ Distribution'))
dev.off()
# To process this file in LaTeX do something like
#\documentclass{article}
#\usepackage[scanall]{psfrag}
#\begin{document}
#\begin{figure}
#\includegraphics{test.ps}
#\caption{This is an example}
#\end{figure}
#\end{document}
}
}
\keyword{hplot}
\keyword{device}
\concept{trellis}
\concept{lattice}

\name{sas.get}
\alias{sas.get}
\alias{is.special.miss}
\alias{[.special.miss}
\alias{print.special.miss}
\alias{format.special.miss}
\alias{sas.codes}
\alias{code.levels}
\alias{timePOSIXt}
\title{Convert a SAS Dataset to an S Data Frame}
\description{
  Converts a \acronym{SAS} dataset into an S data frame.  
  You may choose to extract only a subset of variables 
  or a subset of observations in the \acronym{SAS} dataset.
  The function will automatically convert \preformatted{PROC FORMAT}-coded
  variables to factor objects.  The original \acronym{SAS} codes are stored in an
  attribute called \code{sas.codes} and these may be added back to the
  \code{levels} of a \code{factor} variable using the \code{code.levels}
  function. 
  Information about special missing values may be captured in an attribute
  of each variable having special missing values.  This attribute is
  called \code{special.miss}, and such variables are given class \code{special.miss}.
  There are \code{print}, \code{[]}, \code{format}, and \code{is.special.miss}
  methods for such variables.
  date, time, and date-time variables use respectively
  \code{\link{Dates}}, \code{\link{DateTimeClasses}}, and
  \code{\link[chron]{chron}} variables.
  If using S-Plus 5 or 6 or later, the \code{timeDate} function is used instead.
  If a date variable represents a partial date (0.5 added if
  month missing, 0.25 added if day missing, 0.75 if both), an attribute
  \code{partial.date} is added to the variable, and the variable also becomes
  a class \code{imputed} variable.
  The \code{describe} function uses information about partial dates and
  special missing values.
  There is an option to automatically \command{PKUNZIP} compressed
  \acronym{SAS} datasets.

  \code{sas.get} works by composing and running a \acronym{SAS} job that
  creates various \acronym{ASCII} files that are read and analyzed
  by \code{sas.get}.  You can also run the \acronym{SAS} \code{sas_get} macro,
  which writes the \acronym{ASCII} files for downloading, in a separate
  step or on another computer, and then tell \code{sas.get} (through the
  \code{sasout} argument) to access these files instead of running \acronym{SAS}.
}
\usage{
sas.get(libraryName, member, variables=character(0), ifs=character(0),
     format.library=libraryName, id,
     dates.=c("sas","yymmdd","yearfrac","yearfrac2"),
     keep.log=TRUE, log.file="_temp_.log", macro=sas.get.macro,
     data.frame.out=existsFunction("data.frame"), clean.up=FALSE, quiet=FALSE,
     temp=tempfile("SaS"), formats=TRUE, 
     recode=formats, special.miss=FALSE, sasprog="sas",
     as.is=.5, check.unique.id=TRUE, force.single=FALSE, pos,
     uncompress=FALSE, defaultencoding="latin1", var.case="lower")

is.special.miss(x, code)

\method{[}{special.miss}(x, \dots, drop=FALSE)

\method{print}{special.miss}(x, \dots)

\method{format}{special.miss}(x, \dots)

sas.codes(object)

code.levels(object)
}
\arguments{
  \item{libraryName}{
    character string naming the directory in which the dataset is kept.
    The default is \code{libraryName = "."}, indicating that the current
    directory is to be used.
  }
  \item{member}{
    character string giving the second part of the two part \acronym{SAS} dataset name.  
    (The first part is irrelevant here - it is mapped to the directory name.)
  }
  \item{x}{
    a variable that may have been created by \code{sas.get} with \code{special.miss=TRUE}
    or with \code{recode} in effect.
  }
  \item{variables}{
    vector of character strings naming the variables in the \acronym{SAS} dataset.  
    The resulting data frame will contain only those variables from the
    \acronym{SAS} dataset.  
    To get all of the variables (the default), an empty string may be given.
    It is a fatal error if any one of the variables is not
    in the \acronym{SAS} dataset.  If you have retrieved a subset of the variables
    in the \acronym{SAS} dataset and which to retrieve the same list of variables
    from another dataset, you can program the value of \code{variables} - see
    one of the last examples.
  }
  \item{ifs}{
    a vector of character strings, each containing one \acronym{SAS} \dQuote{subsetting if}
    statement.  
    These will be used to extract a subset of the observations in the \acronym{SAS} dataset.
  }
  \item{format.library}{
    The directory containing the file \file{formats.sc2}, which contains
    the definitions of the user defined formats used in this dataset.
    By default, we look for the formats in the same directory as the data.
    The user defined formats must be available (so \acronym{SAS} can read the data).
  }
  \item{formats}{
    Set \code{formats} to \code{FALSE} to keep \code{sas.get} from telling the \acronym{SAS} macro to 
    retrieve value label formats from \code{format.library}.  When you do not
    specify \code{formats} or \code{recode}, \code{sas.get} will set \code{format} to \code{TRUE} if a
    \acronym{SAS} format catalog (\file{.sct} or \file{.sc2}) file exists in \code{format.library}.
    \code{sas.get} stores \acronym{SAS} \preformatted{PROC FORMAT VALUE} definitions
    as the \code{formats} attribute of the returned
    object (see below). A format is used if it is referred to by one or more 
    variables
    in the dataset, if it contains no ranges of values (i.e., it identifies
    value labels for single values), and if it is a character format
    or a numeric format that is not used just to label missing values.
    To fetch the values and labels for variable \code{x} in the dataset \code{d} you
    could type:
    \cr
    \code{f <- attr(d\$x, "format")}
    \cr
    \code{formats <- attr(d, "formats")}
    \cr
    \code{formats\$f\$values; formats\$f\$labels}
  }
  \item{recode}{
    This parameter defaults to \code{TRUE} if \code{formats} is \code{TRUE}.  If it is
    \code{TRUE}, variables that have an appropriate format (see above) are
    recoded as \code{factor} objects, which map the values
    to the value labels for the format.  Alternatively, set \code{recode} to
    1 to use labels of the form value:label, e.g. 1:good 2:better 3:best.
    Set \code{recode} to 2 to use labels such as good(1) better(2) best(3).
    Since \code{sas.codes} and \code{code.levels} add flexibility, the usual choice
    for \code{recode} is \code{TRUE}.
  }
  \item{drop}{
    logical. If \code{TRUE} the result is coerced to the
    lowest possible dimension.
  }
  \item{special.miss}{
    For numeric variables, any missing values are stored as NA in S.
    You can recover special missing values by setting \code{special.miss} to
    \code{TRUE}.  This will cause the \code{special.miss} attribute and the
    \code{special.miss} class to be added
    to each variable that has at least one special missing value.  
    Suppose that variable  \code{y} was .E in observation 3 and .G
    in observation 544.  The \code{special.miss} attribute for \code{y} then has the
    value
    \cr
    \code{list(codes=c("E","G"),obs=c(3,544))}
    \cr
    To fetch this information for variable \code{y} you would say for example
    \cr
    \code{s <- attr(y, "special.miss")}
    \cr
    \code{s\$codes; s\$obs}
    \cr
    or use \code{is.special.miss(x)} or the \code{print.special.miss} method, which
    will replace \code{NA} values for the variable with \samp{E} or \samp{G} if they
    correspond to special missing values.
    The describe
    function uses this information in printing a data summary.  
  }
  \item{id}{
    The name of the variable to be used as the row names of the S dataset.
    The id variable becomes the \code{row.names} attribute of a data frame, but
    the id variable is still retained as a variable in the data frame.
    You can also specify a vector of variable names as the \code{id}
    parameter.  After fetching the data from \acronym{SAS}, all these variables will be
    converted to character format and concatenated (with a space as a separator)
    to form a (hopefully) unique identification variable.
  }
  \item{dates.}{
    specifies the format for storing \acronym{SAS} dates in the
    resulting data frame.
  }
  \item{as.is}{
    \acronym{SAS} character variables are converted to S factor
    objects if \code{as.is=FALSE} or if \code{as.is} is a number between 0 and 1 inclusive and
    the number of unique values of the variable is less than
    the number of observations (\code{n}) times \code{as.is}.  The default if \code{as.is} is 0.5,
    so character variables are converted to factors only if they have fewer
    than \code{n/2} unique values.  The primary purpose of this is to keep unique
    identification variables as character values in the data frame instead
    of using more space to store both the integer factor codes and the
    factor labels.
  }
  \item{check.unique.id}{
    If \code{id} is specified, the row names are checked for
    uniqueness if \code{check.unique.id = TRUE}.  If any are duplicated, a warning
    is printed.  Note that if a data frame is being created with duplicate
    row names, statements such as \code{my.data.frame["B23",]} will retrieve
    only the first row with a row name of \samp{B23}.
  }
  \item{force.single}{
    By default, \acronym{SAS} numeric variables having \eqn{LENGTH > 4} are stored as
    S double precision numerics, which allow for the same precision as
    a \acronym{SAS} \preformatted{LENGTH} 8 variable.  Set \code{force.single = TRUE} to store every
    numeric variable in single precision (7 digits of precision).
    This option is useful when the creator of the \acronym{SAS} dataset has
    failed to use a \preformatted{LENGTH} statement.
    R does not have single precision,
    so no attempt is made to convert to single if running \R.
  }
  \item{keep.log}{
    logical: if \code{FALSE}, delete the \acronym{SAS} log file upon completion.
  }
  \item{log.file}{
    the name of the \acronym{SAS} log file.
  }
  \item{macro}{
    the name of an S object in the current search path that contains the text of
    the \acronym{SAS} macro called by S. The S object is a character vector that
    can be edited using, for example, \code{sas.get.macro <- editor(sas.get.macro)}.
  }
  \item{data.frame.out}{
    set to \code{FALSE} to make the result a list instead of a data
    frame
  }
  \item{clean.up}{
    logical flag: if \code{TRUE}, remove all temporary files when finished.  You
    may want to keep these while debugging the \acronym{SAS} macro.  Not needed for \R.
  }
  \item{quiet}{
    logical flag: if \code{FALSE}, print the contents of the
    \acronym{SAS} log file if there has been an error.
  }
  \item{temp}{
    the prefix to use for the temporary files.  Two characters
    will be added to this, the resulting name
    must fit on your file system.
  }
  \item{sasprog}{
    the name of the system command to invoke \acronym{SAS}
  }
  \item{uncompress}{
    set to \code{FALSE} by default.  Set it
    to \code{TRUE} to automatically invoke the DOS \command{PKUNZIP} command
    if \file{\var{member}.zip} exists,
    to uncompress the \acronym{SAS} dataset before
    proceeding.  This assumes you have the file permissions to allow
    uncompressing in place.  If the file is already uncompressed, this
    option is ignored.
  }
  \item{pos}{
    by default, a list or data frame which contains all the variables
    is returned.  If you specify \code{pos}, each individual variable
    is placed into a separate object (whose name is the name
    of the variable) using the \code{assign} function with the
    \code{pos} argument.  For example, you can put each variable
    in its own file in a directory, which in some cases may
    save memory over attaching a data frame.
  }
  \item{code}{
    a special missing value code (\samp{A} through \samp{Z} or
\samp{\_}) to check against. If \code{code} is omitted,
\code{is.special.miss} will return a \code{TRUE} for each 
    observation that has any special missing value.
  }
\item{defaultencoding}{
    encoding to assume if the SAS dataset does not specify one. Defaults to "latin1".
  }
\item{var.case}{
    specify the case that you want variable names to be in.  "lower" for lower case, 
    "upper" for upper case, and "preserve" to retain the case from SAS.
  }
  \item{object}{
    a variable in a data frame created by \code{sas.get}
  }
  \item{\dots}{ignored}
}
\value{
  A data frame resembling the \acronym{SAS} dataset.  If \code{id}
  was specified, that column of the data frame will be used
  as the row names of the data frame.  Each variable in the data frame
  or vector in the list will have the attributes \code{label} and \code{format}
  containing \acronym{SAS} labels and formats.  Underscores in formats are
  converted to periods.  Formats for character variables have \samp{\$} placed
  in front of their names.
  If \code{formats} is \code{TRUE} and there are any 
  appropriate format definitions in \code{format.library}, the returned
  object will have attribute \code{formats} containing lists named the
  same as the format names (with periods substituted for underscores and
  character formats prefixed by \samp{\$}).
  Each of these lists has a vector called \code{values} and one called
  \code{labels} with the \preformatted{PROC FORMAT; VALUE} \code{\dots} definitions.
}
\section{Side Effects}{
  if a \acronym{SAS} error occurs the \acronym{SAS} log file will be
  printed under the control of the \code{pager} function.
}
\details{
  If you specify \code{special.miss = TRUE} and there are no special missing
  values in the data \acronym{SAS} dataset, the \acronym{SAS} step will bomb.

  For variables having a \preformatted{PROC FORMAT VALUE}
  format with some of the levels undefined, \code{sas.get} will interpret those
  values as \code{NA} if you are using \code{recode}.


  If you leave the \code{sasprog} argument at its default value of
  \samp{sas}, be sure that the \acronym{SAS} executable is in the \file{PATH}
  specified in your \file{autoexec.bat} file.  Also make sure that
  you invoke S so that your current project directory is known
  to be the current working directory.  This is best done by creating
  a shortcut in Windows95, for which the command to execute will be
  something like \command{drive:\\spluswin\\cmd\\splus.exe HOME=.} and the
  program is flagged to start in \file{drive:\\myproject} for example.
  In this way, you will be able to examine the \acronym{SAS} log file easily
  since it will be placed in \file{drive:\\myproject} by default.

  \acronym{SAS} will create \samp{SASWORK} and \samp{SASUSER} directories in what it thinks
  are the current working directories.  To specify where \acronym{SAS} should
  put these instead, edit the \file{config.sas} file or specify a
  \code{sasprog} argument of the following form:
  \code{sasprog="\\sas\\sas.exe -saswork c:\\saswork -sasuser c:\\sasuser"}.

  When \code{sas.get} needs to run \acronym{SAS} it is run in iconized form.

  The \acronym{SAS} macro \file{sas_get} uses record lengths of up to 4096 in two
  places.  If you are exporting records that are very long (because of
  a large number of variables and/or long character variables), you
  may want to edit these \samp{LRECL}s to quadruple them, for example.
}
\note{
  If \code{sasout} is not given, you
  must be able to run \acronym{SAS} on your system.  


  If you are reading time or
  date-time variables, you will need to execute the command \code{library(chron)}
  to print those variables or the data frame.
}
\section{BACKGROUND}{
  The references cited below explain the structure of \acronym{SAS} datasets and how
  they are stored.
  See \emph{\acronym{SAS} Language} 
  for a discussion of the \preformatted{subsetting if} statement.
}
\author{
  Terry Therneau, Mayo Clinic
  \cr
  Frank Harrell, Vanderbilt University
  \cr
  Bill Dunlap, University of Washington and Insightful Corp.
  \cr
  Michael W. Kattan, Cleveland Clinic Foundation
  \cr
  Reinhold Koch (encoding)
}
\references{
  \acronym{SAS} Institute Inc. (1990).
  \emph{\acronym{SAS} Language: Reference, Version 6.}
  First Edition.
  \acronym{SAS} Institute Inc., Cary, North Carolina.


  \acronym{SAS} Institute Inc. (1988).
  \acronym{SAS} Technical Report P-176,
  \emph{Using the \acronym{SAS} System, Release 6.03, under UNIX Operating Systems and Derivatives.  }
  \acronym{SAS} Institute Inc., Cary, North Carolina.


  \acronym{SAS} Institute Inc. (1985).
  \emph{\acronym{SAS} Introductory Guide.}
  Third Edition.
  \acronym{SAS} Institute Inc., Cary, North Carolina.
}
\seealso{
  \code{\link{data.frame}}, \code{\link[Hmisc]{describe}},
  \code{\link[Hmisc]{label}}, \code{\link[Hmisc]{upData}}
}
\examples{
\dontrun{
mice <- sas.get("saslib", mem="mice", var=c("dose", "strain", "ld50"))
plot(mice$dose, mice$ld50)

nude.mice <- sas.get(lib=unix("echo $HOME/saslib"), mem="mice",
	ifs="if strain='nude'")

nude.mice.dl <- sas.get(lib=unix("echo $HOME/saslib"), mem="mice",
	var=c("dose", "ld50"), ifs="if strain='nude'")

# Get a dataset from current directory, recode PROC FORMAT; VALUE \dots 
# variables into factors with labels of the form "good(1)" "better(2)",
# get special missing values, recode missing codes .D and .R into new
# factor levels "Don't know" and "Refused to answer" for variable q1
d <- sas.get(mem="mydata", recode=2, special.miss=TRUE)
attach(d)
nl <- length(levels(q1))
lev <- c(levels(q1), "Don't know", "Refused")
q1.new <- as.integer(q1)
q1.new[is.special.miss(q1,"D")] <- nl+1
q1.new[is.special.miss(q1,"R")] <- nl+2
q1.new <- factor(q1.new, 1:(nl+2), lev)
# Note: would like to use factor() in place of as.integer ... but
# factor in this case adds "NA" as a category level

d <- sas.get(mem="mydata")
sas.codes(d$x)    # for PROC FORMATted variables returns original data codes
d$x <- code.levels(d$x)   # or attach(d); x <- code.levels(x)
# This makes levels such as "good" "better" "best" into e.g.
# "1:good" "2:better" "3:best", if the original SAS values were 1,2,3

# For the following example, suppose that SAS is run on a
# different machine from the one on which S is run.
# The sas_get macro is used to create files needed by
# sas.get.  To make a text file containing the sas_get macro
# run the following S command, for example:
#   cat(sas.get.macro, file='/sasmacro/sas_get.sas', sep='\n')

# Here is the SAS job.  This job assumes that you put
# sas_get.sas in an autocall macro library.


#  libname db '/my/sasdata/area';
#  \%sas_get(db.mydata, dict, data, formats, specmiss,
#           formats=1, specmiss=1)


# Substitute whatever file names you may want.
# Next the 4 files are moved to the S machine (using
# ASCII file transfer mode) and the following S
# program is run:


mydata <- sas.get(sasout=c('dict','data','formats','specmiss'),
                  id='idvar')


# If PKZIP is run after \%sas_get, e.g. "PKZIP port dict data formats"
# (assuming that specmiss was not used here), use


mydata <- sas.get(sasout='a:port', id='idvar')


# which will run PKUNZIP port to unzip a:port.zip, creating the
# dict, data, and formats files which are generated (and later
# deleted) by sas.get


# Retrieve the same variables from another dataset (or an update of
# the original dataset)
mydata2 <- sas.get('mydata2', var=names(mydata))
# This only works if none of the original SAS variable names contained _

# Code from Don MacQueen to generate SAS dataset to test import of
# date, time, date-time variables
# data ssd.test;
#     d1='3mar2002'd ;
#     dt1='3mar2002 9:31:02'dt;
#     t1='11:13:45't;
#     output;
#
#     d1='3jun2002'd ;
#     dt1='3jun2002 9:42:07'dt;
#     t1='11:14:13't;
#     output;
#     format d1 mmddyy10. dt1 datetime. t1 time.;
# run;
}
}
\keyword{interface}
\keyword{manip}

\name{equalBins}
\alias{equalBins}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Multicolumn Formating}
\description{
  Expands the width either supercolumns or the subcolumns so that the
  the sum of the supercolumn widths is the same as the sum of the
  subcolumn widths.
}
\usage{
equalBins(widths, subwidths)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{widths}{widths of the supercolumns.}
  \item{subwidths}{list of widths of the subcolumns for each supercolumn.}
}
\details{
  This determins the correct subwidths of each of various columns in a table
  for printing.  The correct width of the multicolumns is deterimed by
  summing the widths of it subcolumns.
}
\value{
  widths of the the columns for a table.
}
\author{Charles Dupont}
\seealso{\code{\link{nchar}}, \code{\link{stringDims}}}
\examples{
mcols <- c("Group 1", "Group 2")
mwidth <- nchar(mcols, type="width")
spancols <- c(3,3)
ccols <- c("a", "deer", "ad", "cat", "help", "bob")
cwidth <- nchar(ccols, type="width")

subwidths <- partition.vector(cwidth, spancols)

equalBins(mwidth, subwidths)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{print}

\name{getZip}
\alias{getZip}
\title{Open a Zip File From a URL}
\description{
  Allows downloading and reading of a zip file containing one file
}
\usage{
getZip(url, password=NULL)
}
\arguments{
  \item{url}{either a path to a local file or a valid URL.}
  \item{password}{required to decode password-protected zip files}
}
\value{
  Returns a file O/I pipe.
}
\details{
  Allows downloading and reading of zip file containing one file.
  The file may be password protected.  If a password is needed then one will be requested unless given.

  Note: to make password-protected zip file z.zip, do zip -e z myfile
}
\seealso{
  \code{\link{pipe}}
}
\examples{
\dontrun{
read.csv(getZip('http://test.com/z.zip'))
}
}
\author{Frank E. Harrell}
\keyword{file}
\keyword{IO}
\concept{compressed file}

\name{mtitle}
\alias{mtitle}
\title{
Margin Titles
}
\description{
Writes overall titles and subtitles after a multiple image plot is drawn.
If \code{par()$oma==c(0,0,0,0)}, \code{title} is used instead of \code{mtext}, to draw
titles or subtitles that are inside the plotting region for a single plot.
}
\usage{
mtitle(main, ll, lc,  
       lr=format(Sys.time(),'\%d\%b\%y'),
       cex.m=1.75, cex.l=.5, \dots)
}
\arguments{
\item{main}{
main title to be centered over entire figure, default is none
}
\item{ll}{
subtitle for lower left of figure, default is none
}
\item{lc}{
subtitle for lower center of figure, default is none
}
\item{lr}{
subtitle for lower right of figure, default is today's date in format
23Jan91 for UNIX or R (Thu May 30 09:08:13 1996 format for Windows). 
Set to \code{""} to suppress lower right title.
}
\item{cex.m}{
character size for main, default is 1.75
}
\item{cex.l}{
character size for subtitles
}
\item{...}{
other arguments passed to \code{mtext}
}}
\value{
nothing
}
\author{
Frank Harrell
\cr
Department of Biostatistics, Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\section{Side Effects}{
plots
}
\seealso{
\code{\link{par}}, \code{\link{mtext}}, \code{\link{title}}, \code{\link{unix}}, \code{\link{pstamp}}
}
\examples{
#Set up for 1 plot on figure, give a main title,
#use date for lr
plot(runif(20),runif(20))
mtitle("Main Title")


#Set up for 2 x 2 matrix of plots with a lower left subtitle and overall title
par(mfrow=c(2,2), oma=c(3,0,3,0))
plot(runif(20),runif(20))
plot(rnorm(20),rnorm(20))
plot(exp(rnorm(20)),exp(rnorm(20)))
mtitle("Main Title",ll="n=20")
}
\keyword{hplot}
% Converted by Sd2Rd version 1.21.

\name{labcurve}
\alias{labcurve}
\alias{putKey}
\alias{putKeyEmpty}
\alias{largest.empty}
\alias{drawPlot}
\alias{plot.drawPlot}
\alias{bezier}
\title{Label Curves, Make Keys, and Interactively Draw Points and Curves}
\description{
\code{labcurve} optionally draws a set of curves then labels the curves.
A variety of methods for drawing labels are implemented, ranging from
positioning using the mouse to automatic labeling to automatic placement
of key symbols with manual placement of key legends to automatic
placement of legends.  For automatic positioning of labels or keys, a
curve is labeled at a point that is maximally separated from all of the
other curves.  Gaps occurring when curves do not start or end at the
same x-coordinates are given preference for positioning labels. If
labels are offset from the curves (the default behaviour), if the
closest curve to curve i is above curve i, curve i is labeled below its
line.  If the closest curve is below curve i, curve i is labeled above
its line.  These directions are reversed if the resulting labels would
appear outside the plot region.

Both ordinary lines and step functions are handled, and there is an
option to draw the labels at the same angle as the curve within a
local window.

Unless the mouse is used to position labels or plotting symbols are
placed along the curves to distinguish them, curves are examined at 100
(by default) equally spaced points over the range of x-coordinates in
the current plot area.  Linear interpolation is used to get
y-coordinates to line up (step function or constant interpolation is
used for step functions).  There is an option to instead examine all
curves at the set of unique x-coordinates found by unioning the
x-coordinates of all the curves.  This option is especially useful when
plotting step functions.  By setting \code{adj="auto"} you can have
\code{labcurve} try to optimally left- or right-justify labels depending
on the slope of the curves at the points at which labels would be
centered (plus a vertical offset).  This is especially useful when
labels must be placed on steep curve sections.

You can use the \code{on top} method to write (short) curve names
directly on the curves (centered on the y-coordinate).  This is
especially useful when there are many curves whose full labels would run
into each other.  You can plot letters or numbers on the curves, for
example (using the \code{keys} option), and have \code{labcurve} use the
\code{key} function to provide long labels for these short ones (see the
end of the example).  There is another option for connecting labels to
curves using arrows.  When \code{keys} is a vector of integers, it is
taken to represent plotting symbols (\code{pch}s), and these symbols are
plotted at equally-spaced x-coordinates on each curve (by default, using
5 points per curve).  The points are offset in the x-direction between
curves so as to minimize the chance of collisions.

To add a legend defining line types, colors, or line widths with no
symbols, specify \code{keys="lines"}, e.g., \code{labcurve(curves,
keys="lines", lty=1:2)}.

\code{putKey} provides a different way to use \code{key()} by allowing
the user to specify vectors for labels, line types, plotting characters,
etc.  Elements that do not apply (e.g., \code{pch} for lines
(\code{type="l"})) may be \code{NA}.  When a series of points is
represented by both a symbol and a line, the corresponding elements of
both \code{pch} and \code{lty}, \code{col.}, or \code{lwd} will be
non-missing.

\code{putKeyEmpty}, given vectors of all the x-y coordinates that have been
plotted, uses \code{largest.empty} to find the largest empty rectangle large
enough to hold the key, and draws the key using \code{putKey}.

\code{drawPlot} is a simple mouse-driven function for drawing series of
lines, step functions, polynomials, Bezier curves, and points, and
automatically labeling the point groups using \code{labcurve} or
\code{putKeyEmpty}.  When \code{drawPlot} is invoked it creates
temporary functions \code{Points}, \code{Curve}, and \code{Abline}.
The user calls these functions inside
the call to \code{drawPlot} to define groups of points in the order they
are defined with the mouse.  \code{Abline} is used to call \code{abline}
and not actually great a group of points. For some curve types, the
curve generated to represent the corresponding series of points is drawn
after all points are entered for that series, and this curve may be
different than the simple curve obtained by connecting points at the
mouse clicks.  For example, to draw a general smooth Bezier curve the
user need only click on a few points, and she must overshoot the final
curve coordinates to define the curve.  The originally entered points
are not erased once the curve is drawn.  The same goes for step
functions and polynomials.  If you \code{plot()} the object returned by
\code{drawPlot}, however, only final curves will be shown.  The last
examples show how to use \code{drawPlot}.

The \code{largest.empty} function finds the largest rectangle that is large
enough to hold a rectangle of a given height and width, such that the
rectangle does not contain any of a given set of points.  This is
used by \code{labcurve} and \code{putKeyEmpty} to position keys at the most
empty part of an existing plot.  The default method was created by Hans
Borchers.
}
\usage{
labcurve(curves, labels=names(curves),
         method=NULL, keys=NULL, keyloc=c("auto","none"),
         type="l", step.type=c("left", "right"), 
         xmethod=if(any(type=="s")) "unique" else "grid", 
         offset=NULL, xlim=NULL,
         tilt=FALSE, window=NULL, npts=100, cex=NULL, 
         adj="auto", angle.adj.auto=30,
         lty=pr$lty, lwd=pr$lwd, col.=pr$col, transparent=TRUE,
         arrow.factor=1, point.inc=NULL, opts=NULL, key.opts=NULL,
         empty.method=c('area','maxdim'), numbins=25, 
         pl=!missing(add), add=FALSE, 
         ylim=NULL, xlab="", ylab="",
         whichLabel=1:length(curves),
         grid=FALSE, xrestrict=NULL, \dots)

putKey(z, labels, type, pch, lty, lwd,
       cex=par('cex'), col=rep(par('col'),nc),
       transparent=TRUE, plot=TRUE, key.opts=NULL, grid=FALSE)

putKeyEmpty(x, y, labels, type=NULL,
            pch=NULL, lty=NULL, lwd=NULL,
            cex=par('cex'), col=rep(par('col'),nc),
            transparent=TRUE, plot=TRUE, key.opts=NULL,
            empty.method=c('area','maxdim'), 
            numbins=25, 
            xlim=pr$usr[1:2], ylim=pr$usr[3:4], grid=FALSE)

drawPlot(\dots, xlim=c(0,1), ylim=c(0,1), xlab='', ylab='',
         ticks=c('none','x','y','xy'),
         key=FALSE, opts=NULL)

# Points(label=' ', type=c('p','r'),
#        n, pch=pch.to.use[1], cex=par('cex'), col=par('col'),
#        rug = c('none','x','y','xy'), ymean)

# Curve(label=' ',
#       type=c('bezier','polygon','linear','pol','loess','step','gauss'),
#       n=NULL, lty=1, lwd=par('lwd'), col=par('col'), degree=2,
#      evaluation=100, ask=FALSE)

# Abline(\dots)

\method{plot}{drawPlot}(x, xlab, ylab, ticks,
     key=x$key, keyloc=x$keyloc, \dots)

largest.empty(x, y, width=0, height=0, 
              numbins=25, method=c('exhaustive','rexhaustive','area','maxdim'),
              xlim=pr$usr[1:2], ylim=pr$usr[3:4],
              pl=FALSE, grid=FALSE)
}
\arguments{
\item{curves}{
a list of lists, each of which have at least two components: a vector of
\code{x} values and a vector of corresponding \code{y} values.  \code{curves} is
mandatory except when \code{method="mouse"} or \code{"locator"}, in which 
case \code{labels} is mandatory.  Each list in \code{curves} may optionally have
any of the parameters \code{type}, \code{lty}, \code{lwd}, or \code{col}
for that curve, as defined below (see one of the last examples).
}
\item{z}{
a two-element list specifying the coordinate of the center of the key,
e.g. \code{locator(1)} to use the mouse for positioning
}
\item{labels}{
For \code{labcurve}, a vector of character strings used to label curves 
(which may contain newline characters to stack labels vertically).  The
default labels are taken from the names of the \code{curves} list.
Setting \code{labels=FALSE} will suppress drawing any labels (for
\code{labcurve} only). 
For \code{putKey} and \code{putKeyEmpty} is a vector of character strings
specifying group labels
}
\item{x}{see below}
\item{y}{
for \code{putKeyEmpty} and \code{largest.empty}, \code{x} and \code{y}
are same-length vectors specifying points that have been plotted.
\code{x} can also be an object created by \code{drawPlot}.
}
\item{\dots}{
For \code{drawPlot} is a series of invocations of \code{Points} and
\code{Curve} (see example).  Any number of point groups can be defined
in this way.  For \code{Abline} these may be any arguments to
\code{abline}. 
For \code{labcurve}, other parameters to pass to \code{text}.
}
\item{width}{see below}
\item{height}{
for \code{largest.empty}, specifies the minimum allowable width in
\code{x} units and the minimum allowable height in \code{y} units
}
\item{method}{
\code{"offset"} (the default) offsets labels at largest gaps between
curves, and draws labels beside curves.  
\code{"on top"} draws labels on top of the curves (especially
good when using keys).  
\code{"arrow"} draws arrows connecting labels to the curves.
\code{"mouse"} or \code{"locator"} positions labels according to mouse clicks.
If \code{keys} is specified and is an integer vector or is \code{"lines"}, 
\code{method} defaults to \code{"on top"}.  If \code{keys} is character,
\code{method} defaults to \code{"offset"}.  Set \code{method="none"} to
suppress all curve labeling and key drawing, which is useful when
\code{pl=TRUE} and you only need \code{labcurve} to draw the curves and the
rest of the basic graph.

For \code{largest.empty} specifies the method a rectangle that does not
collide with any of the (\code{x}, \code{y}) points.  The default
method, \code{'exhaustive'}, uses a Fortran translation of an R function
and algorithm developed by Hans Borchers.  The same result, more slowly,
may be obtained by using pure R code by specifying
\code{method='rexhaustive'}.  The original algorithms using binning (and
the only methods supported for S-Plus) are
still available.  For all methods, screening of candidate rectangles
having at least a given width in \code{x}-units of \code{width} or
having at least a given height in \code{y}-units of \code{height} is possible.
Use \code{method="area"} to use the binning method to find the rectangle
having the largest area, or \code{method="maxdim"} to use the binning
method to return with last rectangle searched that had both
the largest width and largest height over all previous rectangles.
}
\item{keys}{
This causes keys (symbols or short text) to be drawn on or beside
curves, and if \code{keyloc} is not equal to \code{"none"}, a legend to be
automatically drawn.  The legend links keys with full curve labels
and optionally with colors and line types.
Set \code{keys} to a vector of character strings, or a
vector of integers specifying plotting character (\code{pch} values -
see \code{points}).  For the latter case, the default behavior is to
plot the symbols periodically, at equally spaced x-coordinates.
}
\item{keyloc}{
When \code{keys} is specified, \code{keyloc} specifies how the legend
is to be positioned for drawing using the \code{key} function in
\code{trellis}.  The default is \code{"auto"}, for which the
\code{largest.empty} function to used to find the most empty part of the
plot.  If no empty rectangle large enough to hold the key is found, no
key will be drawn. Specify \code{keyloc="none"} to suppress drawing a
legend, or set \code{keyloc} to a 2-element list containing the x and y
coordinates for the center of the legend.  For example, use
\code{keyloc=locator(1)} to click the mouse at the center.
\code{keyloc} specifies the coordinates of the center of the
key to be drawn with \code{plot.drawPlot} when \code{key=TRUE}.
}
\item{type}{
for \code{labcurve}, a scalar or vector of character strings specifying the
method that the points in the curves were connected. \code{"l"} means
ordinary connections between points and \code{"s"} means step functions.
For \code{putKey} and \code{putKeyEmpty} is a vector of plotting types, \code{"l"}
for regular line, \code{"p"} for point, \code{"b"} for both point and line, and
\code{"n"} for none.  For \code{Points} is either \code{"p"} (the default) for
regular points, or \code{"r"} for rugplot (one-dimensional scatter diagram
to be drawn using the \code{scat1d} function).  For \code{Curve}, \code{type} is
\code{"bezier"} (the default) for drawing a smooth Bezier curves (which can
represent a non-1-to-1 function such as a circle), \code{"polygon"} for
orginary line segments, \code{"linear"} for a straight line defined by two
endpoints, \code{"pol"} for a \code{degree}-degree polynomial to be fitted to
the mouse-clicked points, \code{"step"} for a left-step-function, \code{"gauss"}
to plot a Gaussian density fitted to 3 clicked points, \code{"loess"} to
use the \code{lowess} function to smooth the clicked points, or a function
to draw a user-specified function, evaluated at \code{evaluation} points
spanning the whole x-axis.  For the density the user must click in the
left tail, at the highest value (at the mean), and in the right tail,
with the two tail values being approximately equidistant from the
mean.  The density is scaled to fit in the highest value regardless of
its area.
}
\item{step.type}{
type of step functions used (default is \code{"left"})
}
\item{xmethod}{
method for generating the unique set of x-coordinates to examine (see above).  Default is \code{"grid"} for \code{type="l"} or \code{"unique"} for 
\code{type="s"}.
}
\item{offset}{
distance in y-units between the center of the label and the line being
labeled.  Default is 0.75 times the height of an "m" that would be
drawn in a label.  For R grid/lattice you must specify offset using
the \code{grid} \code{unit} function, e.g., \code{offset=unit(2,"native")} or
\code{offset=unit(.25,"cm")} (\code{"native"} means data units)
}
\item{xlim}{
limits for searching for label positions, and is also used to set up
plots when \code{pl=TRUE} and \code{add=FALSE}.  Default is total x-axis
range for current plot (\code{par("usr")[1:2]}).  For
\code{largest.empty}, \code{xlim} limits the search for largest
rectanges, but it has the same default as above. For
\code{pl=TRUE,add=FALSE} you may want to extend \code{xlim} somewhat to
allow large keys to fit, when using \code{keyloc="auto"}.  For
\code{drawPlot} default is \code{c(0,1)}.  When using
\code{largest.empty} with \code{ggplot2}, \code{xlim} and \code{ylim}
are mandatory.
}
\item{tilt}{
set to \code{TRUE} to tilt labels to follow the curves, for \code{method="offset"}
when \code{keys} is not given.
}
\item{window}{
width of a window, in x-units, to use in determining the local slope
for tilting labels.  Default is 0.5 times number of characters in the
label times the x-width of an "m" in the current character size and font.
}
\item{npts}{
number of points to use if \code{xmethod="grid"}
}
\item{cex}{
character size to pass to \code{text} and \code{key}.  Default is current
\code{par("cex")}.  For \code{putKey}, \code{putKeyEmpty}, and \code{Points} is the size of the
plotting symbol.
}
\item{adj}{
Default is \code{"auto"} which has \code{labcurve} figure justification
automatically when \code{method="offset"}.  This will cause centering to be used when the local angle
of the curve is less than \code{angle.adj.auto} in absolute value, left
justification if the angle is larger and either the label is under a
curve of positive slope or over a curve of negative slope, and right
justification otherwise.  For step functions, left justification is used
when the label is above the curve and right justifcation otherwise.
Set \code{adj=.5} to center labels at computed coordinates.  Set to 0 for
left-justification, 1 for right.  Set \code{adj} to a vector to vary adjustments
over the curves.
}
\item{angle.adj.auto}{
see \code{adj}.  Does not apply to step functions.
}
\item{lty}{
vector of line types which were used to draw the curves.
This is only used when keys are drawn. If all of the
line types, line widths, and line colors are the same, 
lines are not drawn in the key.
}
\item{lwd}{
vector of line widths which were used to draw the curves.
This is only used when keys are drawn.  See \code{lty} also.
}
\item{col.}{vector of integer color numbers}
\item{col}{
vector of integer color numbers for use in curve labels, symbols,
lines, and legends.  Default is \code{par("col")} for all curves.
See \code{lty} also.
}
\item{transparent}{
Default is \code{TRUE} to make \code{key} draw transparent legends, i.e., to
suppress drawing a solid rectangle background for the legend.
Set to \code{FALSE} otherwise.
}
\item{arrow.factor}{
factor by which to multiply default arrow lengths
}
\item{point.inc}{
When \code{keys} is a vector of integers, \code{point.inc} specifies the x-increment
between the point symbols that are overlaid periodically on the curves.  
By default, \code{point.inc} is equal
to the range for the x-axis divided by 5.
}
\item{opts}{
an optional list which can be used to specify any of the options
to \code{labcurve}, with the usual element name abbreviations allowed.
This is useful when \code{labcurve} is being called from another
function.  Example: \code{opts=list(method="arrow", cex=.8, np=200)}.
For \code{drawPlot} a list of \code{labcurve} options to pass as
\code{labcurve(\dots, opts=)}.
}
\item{key.opts}{
a list of extra arguments you wish to pass to \code{key()}, e.g.,
\code{key.opts=list(background=1, between=3)}.  
The argument names must be spelled out in full.
}
\item{empty.method}{see below}
\item{numbins}{
These two arguments are passed to the \code{largest.empty} function's
\code{method} and \code{numbins} arguments (see below).
For \code{largest.empty} specifies the number of bins in which to
discretize both the \code{x} and \code{y} directions for searching for
rectangles.  Default is 25.
}
\item{pl}{
set to \code{TRUE} (or specify \code{add}) to cause the curves in \code{curves} to be
drawn, under the control of \code{type},\code{lty},\code{lwd},\code{col} parameters defined
either in the \code{curves} lists or in the separate arguments given to
\code{labcurve} or through \code{opts}.
For \code{largest.empty}, set \code{pl=TRUE} to show the rectangle the function 
found by drawing it with a solid color.  May not be used under \code{ggplot2}.
}
\item{add}{
By default, when curves are actually drawn by \code{labcurve} a new plot is
started.  To add to an existing plot, set \code{add=TRUE}.
}
\item{ylim}{
When a plot has already been started, \code{ylim} defaults to \code{par("usr")[3:4]}.
When \code{pl=TRUE}, \code{ylim} and \code{xlim} are determined from the ranges of the data.
Specify \code{ylim} yourself to take control of the plot construction.  
In some cases it is advisable to
make \code{ylim} larger than usual to allow for automatically-positioned keys.
For \code{largest.empty}, \code{ylim} specifies the limits on the y-axis to limit
the search for rectangle.  
Here \code{ylim} defaults to the same as above, i.e., the range
of the y-axis of an open plot from \code{par}.  For \code{drawPlot} the default
is \code{c(0,1)}.
}
\item{xlab}{see below}
\item{ylab}{
x-axis and y-axis labels when \code{pl=TRUE} and \code{add=FALSE} or for
\code{drawPlot}.
Defaults to \code{""} unless the first curve has names for its first two
elements, in which case the names of these elements are taken as
\code{xlab} and \code{ylab}.
}
\item{whichLabel}{
  integer vector corresponding to \code{curves} specifying which curves
  are to be labelled or have a legend
  }
\item{grid}{
set to \code{TRUE} if the R \code{grid} package was used to draw the
current plot.  This prevents \code{labcurve} from using
\code{par("usr")} etc.  If using R \code{grid} you can pass coordinates
and lengths having arbitrary units, as documented in the \code{unit}
function.  This is especially useful for \code{offset}.
}
\item{xrestrict}{
  When having \code{labcurve} label curves where they are most
  separated, you can restrict the search for this separation point to a
  range of the x-axis, specified as a 2-vector \code{xrestrict}.  This
  is useful when one part of the curve is very steep.  Even though
  steep regions may have maximum separation, the labels will collide
  when curves are steep.
  }
\item{pch}{
vector of plotting characters for \code{putKey} and \code{putKeyEmpty}.  Can be
any value including \code{NA} when only a line is used to indentify the
group.  Is a single plotting character for \code{Points}, with the default
being the next unused value from among 1, 2, 3, 4, 16, 17, 5, 6, 15,
18, 19.
}
\item{plot}{
set to \code{FALSE} to keep \code{putKey} or \code{putKeyEmpty} from actually drawing the
key.  Instead, the size of the key will be return by \code{putKey}, or the
coordinates of the key by \code{putKeyEmpty}.
}
\item{ticks}{
tells \code{drawPlot} which axes to draw tick marks and tick labels.
Default is \code{"none"}.
}
\item{key}{
for \code{drawPlot} and \code{plot.drawPlot}.  Default is \code{FALSE} so that \code{labcurve}
is used to label points or curves.  Set to \code{TRUE} to use
\code{putKeyEmpty}.}
}
\value{
\code{labcurve} returns an invisible list with components \code{x, y, offset, adj, cex, col}, and if \code{tilt=TRUE}, 
\code{angle}. \code{offset} is the amount to add to \code{y} to draw a label.
\code{offset} is negative if the label is drawn below the line.
\code{adj} is a vector containing the values 0, .5, 1.


\code{largest.empty} returns a list with elements \code{x} and \code{y}
specifying the coordinates of the center of the rectangle which was
found, and element \code{rect} containing the 4 \code{x} and \code{y}
coordinates of the corners of the found empty rectangle.  The
\code{area} of the rectangle is also returned.
}
\details{
  The internal functions \code{Points}, \code{Curve}, \code{Abline} have
  unique arguments as follows.
  \describe{
	\item{\code{label}:}{for \code{Points} and \code{Curve} is a single
	  character string to label that group of points}
	\item{\code{n}:}{number of points to accept from the mouse.  Default
	  is to input points until a right mouse click.}
	\item{\code{rug}:}{for \code{Points}.  Default is \code{"none"} to
	  not show the  marginal x or y distributions as rug plots, for the
	  points entered. Other possibilities are used to execute
	  \code{scat1d} to show the marginal distribution of x, y, or both
	  as rug plots.} 
	\item{\code{ymean}:}{for \code{Points}, subtracts a constant from
	  each y-coordinate entered to make the overall mean \code{ymean}}
	\item{\code{degree}:}{degree of polynomial to fit to points by
	  \code{Curve}} 
	\item{\code{evaluation}:}{number of points at which to evaluate
	  Bezier curves, polynomials, and other functions in \code{Curve}}
	\item{\code{ask}:}{set \code{ask=TRUE} to give the user the
	  opportunity to try again at specifying points for Bezier curves,
	  step functions, and polynomials}
  }
  
The \code{labcurve} function used some code from the function \code{plot.multicurve} written
by Rod Tjoelker of The Boeing Company (\email{tjoelker@espresso.rt.cs.boeing.com}).

If there is only one curve, a label is placed at the middle x-value,
and no fancy features such as \code{angle} or positive/negative offsets are
used.

\code{key} is called once (with the argument \code{plot=FALSE}) to find the key
dimensions.  Then an empty rectangle with at least these dimensions is
searched for using \code{largest.empty}.  Then \code{key} is called again to draw
the key there, using the argument \code{corner=c(.5,.5)} so that the center
of the rectangle can be specified to \code{key}.

If you want to plot the data, an easier way to use \code{labcurve} is
through \code{xYplot} as shown in some of its examples.
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\seealso{
	\code{\link{approx}}, \code{\link{text}}, \code{\link{legend}},
	\code{\link{scat1d}}, \code{\link{xYplot}}, \code{\link{abline}}
}
\examples{
n <- 2:8
m <-  length(n)
type <- c('l','l','l','l','s','l','l')
# s=step function l=ordinary line (polygon)
curves <- vector('list', m)


plot(0,1,xlim=c(0,1),ylim=c(-2.5,4),type='n')


set.seed(39)


for(i in 1:m) {
  x <- sort(runif(n[i]))
  y <- rnorm(n[i])
  lines(x, y, lty=i, type=type[i], col=i)
  curves[[i]] <- list(x=x,y=y)
}


labels <- paste('Label for',letters[1:m])
labcurve(curves, labels, tilt=TRUE, type=type, col=1:m)


# Put only single letters on curves at points of 
# maximum space, and use key() to define the letters,
# with automatic positioning of the key in the most empty
# part of the plot
# Have labcurve do the plotting, leaving extra space for key


names(curves) <- labels
labcurve(curves, keys=letters[1:m], type=type, col=1:m,
         pl=TRUE, ylim=c(-2.5,4))


# Put plotting symbols at equally-spaced points,
# with a key for the symbols, ignoring line types


labcurve(curves, keys=1:m, lty=1, type=type, col=1:m,
         pl=TRUE, ylim=c(-2.5,4))




# Plot and label two curves, with line parameters specified with data
set.seed(191)
ages.f <- sort(rnorm(50,20,7))
ages.m <- sort(rnorm(40,19,7))
height.f <- pmin(ages.f,21)*.2+60
height.m <- pmin(ages.m,21)*.16+63


labcurve(list(Female=list(ages.f,height.f,col=2),
              Male  =list(ages.m,height.m,col=3,lty='dashed')),
         xlab='Age', ylab='Height', pl=TRUE)
# add ,keys=c('f','m') to label curves with single letters
# For S-Plus use lty=2


# Plot power for testing two proportions vs. n for various odds ratios, 
# using 0.1 as the probability of the event in the control group.  
# A separate curve is plotted for each odds ratio, and the curves are
# labeled at points of maximum separation


n  <- seq(10, 1000, by=10)
OR <- seq(.2,.9,by=.1)
pow <- lapply(OR, function(or,n)list(x=n,y=bpower(p1=.1,odds.ratio=or,n=n)),
              n=n)
names(pow) <- format(OR)
labcurve(pow, pl=TRUE, xlab='n', ylab='Power')


# Plot some random data and find the largest empty rectangle
# that is at least .1 wide and .1 tall


x <- runif(50)
y <- runif(50)
plot(x, y)
z <- largest.empty(x, y, .1, .1)
z
points(z,pch=3)  # mark center of rectangle, or
polygon(z$rect, col='blue')  # to draw the rectangle, or
#key(z$x, z$y, \dots stuff for legend)




# Use the mouse to draw a series of points using one symbol, and
# two smooth curves or straight lines (if two points are clicked), 
# none of these being labeled


# d <- drawPlot(Points(), Curve(), Curve())
# plot(d)


\dontrun{
# Use the mouse to draw a Gaussian density, two series of points
# using 2 symbols, one Bezier curve, a step function, and raw data
# along the x-axis as a 1-d scatter plot (rug plot).  Draw a key.
# The density function is fit to 3 mouse clicks
# Abline draws a dotted horizontal reference line
d <- drawPlot(Curve('Normal',type='gauss'),
              Points('female'), Points('male'), 
              Curve('smooth',ask=TRUE,lty=2), Curve('step',type='s',lty=3), 
              Points(type='r'), Abline(h=.5, lty=2),
              xlab='X', ylab='y', xlim=c(0,100), key=TRUE)
plot(d, ylab='Y')
plot(d, key=FALSE)  # label groups using labcurve
}
}
\keyword{hplot}
\keyword{aplot}
\keyword{dplot}
\keyword{iplot}

\name{tabulr}
\alias{tabulr}
\alias{table_trio}
\alias{table_N}
\alias{table_freq}
\alias{table_pc}
\alias{table_latexdefs}
\alias{table_formatpct}
\alias{nFm}
\title{Interface to Tabular Function}
\description{
\code{\link{tabulr}} is a front-end to the \code{tables} package's
\code{\link[tables]{tabular}} function so that the user can take
advantage of variable annotations used by the \code{Hmisc} package,
particular those created by the \code{\link{label}}, \code{\link{units}}, and
\code{\link{upData}} functions.  When a variable appears in a
\code{\link[tables]{tabular}} function, the 
variable \code{x} is found in the \code{data} argument or in the parent
environment, and the \code{\link{labelLatex}} function is used to create
a LaTeX label.  By default any units of measurement are right justified
in the current LaTeX tabular field using \code{hfill}; use \code{nofill}
to list variables for which \code{units} are not right-justified with
\code{hfill}.  Once the label is constructed, the variable name is
preceeded by \code{Heading("LaTeX label")*x} in the formula before it is
passed to \code{\link[tables]{tabular}}.  \code{nolabel} can be used to
specify variables for which labels are ignored.

\code{tabulr} also replaces \code{trio} with \code{table_trio}, \code{N}
with \code{table_N},  and \code{freq} with \code{table_freq} in the
formula.  

\code{table_trio} is a function that takes a numeric vector and computes
the three quartiles and optionally the mean and standard deviation, and
outputs a LaTeX-formatted character string representing the results.  By
default, calculated statistics are formatted with 3 digits to the left
and 1 digit to the right of the decimal point.  Running
\code{\link[tables]{table_options}(left=l, right=r)} will use \code{l}
and \code{r} digits instead.  Other options that can be given to
\code{table_options} are \code{prmsd=TRUE} to add mean +/- standard
deviation to the result, \code{pn=TRUE} to add the sample size,
\code{bold=TRUE} to set the median in bold face, \code{showfreq='all',
	'low', 'high'} used by the \code{table_freq} function, \code{pctdec},
specifying the number of places to the right of the decimal point for
percentages (default is zero), and
\code{npct='both','numerator','denominator','none'} used by
\code{table_formatpct} to control what appears after the percent.
Option \code{pnformat} may be specified to control the formatting for
\code{pn}.  The default is \code{"(n=..)"}.  Specify
\code{pnformat="non"} to suppress \code{"n="}.  \code{pnwhen} specifies
when to print the number of observations.  The default is
\code{"always"}.  Specify \code{pnwhen="ifna"} to include \code{n} only
if there are missing values in the vector being processed.

\code{tabulr} substitutes \code{table_N} for \code{N} in the formula.
This is used to create column headings for the number of observations,
without a row label.

\code{table_freq} analyzes a character variable to compute, for a single
output cell, the percents, numerator, and denominator for each category,
or optimally just the maximum or minimum, as specified by
\code{table_options(showfreq)}. 

\code{table_formatpct} is a function that formats percents depending on
settings of options in \code{table_options}.

\code{nFm} is a function that calls \code{\link{sprintf}} to format
numeric values to have a specific number of digits to the \code{left}
and to the \code{right} of the point.

\code{table_latexdefs} writes (by default) to the console a set of LaTeX
definitions that can be invoked at any point thereafter in a \code{knitr} or
\code{sweave} document by naming the macro, preceeded by a single
slash.  The \code{blfootnote} macro is called with a single LaTeX
argument which will appear as a footnote without a number.
\code{keytrio} invokes \code{blfootnote} to define the output of
\code{table_trio} if mean and SD are not included.  If mean and SD are
included, use \code{keytriomsd}.
}
\usage{
tabulr(formula, data = NULL, nolabel=NULL, nofill=NULL, \dots)
table_trio(x)
table_freq(x)
table_formatpct(num, den)
nFm(x, left, right, neg=FALSE, pad=FALSE, html=FALSE)
table_latexdefs(file='')
}
\arguments{
  \item{formula}{a formula suitable for \code{\link[tables]{tabular}}
		except for the addition of \code{.(variable name)},
		\code{.n()}, \code{trio}.}
  \item{data}{a data frame or list.  If omitted, the parent environment
		is assumed to contain the variables.}
	\item{nolabel}{a formula such as \code{~ x1 + x2} containing the list
		of variables for which labels are to be ignored, forcing use of the
		variable name}
	\item{nofill}{a formula such as \code{~ x1 + x2} contaning the list of
		variables for which units of measurement are not to be
		right-justified in the field using the LaTeX \code{hfill} directive}
  \item{\dots}{other arguments to \code{tabular}}
  \item{x}{a numeric vector}
	\item{num}{a single numerator or vector of numerators}
	\item{den}{a single denominator}
	\item{left, right}{number of places to the left and right of the
		decimal point, respectively}
	\item{neg}{set to \code{TRUE} if negative \code{x} values are allowed,
		to add one more space to the left of the decimal place}
	\item{pad}{set to \code{TRUE} to replace blanks with the LaTeX tilde
		placeholder}
	\item{html}{set to \code{TRUE} to make \code{pad} use an HTML space
		character instead of a LaTeX tilde space}
	\item{file}{location of output of \code{table_latexdefs}}
}
\value{\code{tabulr} returns an object of class \code{"tabular"}}
\author{Frank Harrell}
\seealso{\code{\link[tables]{tabular}}, \code{\link{label}},
	\code{\link{latex}}, \code{\link{summaryM}}}
\examples{
\dontrun{
n <- 400
set.seed(1)
d <- data.frame(country=factor(sample(c('US','Canada','Mexico'), n, TRUE)),
                sex=factor(sample(c('Female','Male'), n, TRUE)),
                age=rnorm(n, 50, 10),
                sbp=rnorm(n, 120, 8))
d <- upData(d,
            preghx=ifelse(sex=='Female', sample(c('No','Yes'), n, TRUE), NA),
            labels=c(sbp='Systolic BP', age='Age', preghx='Pregnancy History'),
            units=c(sbp='mmHg', age='years'))
contents(d)
require(tables)
invisible(booktabs())  # use booktabs LaTeX style for tabular
g <- function(x) {
  x <- x[!is.na(x)]
  if(length(x) == 0) return('')
  paste(latexNumeric(nFm(mean(x), 3, 1)),
        ' \\hfill{\\smaller[2](', length(x), ')}', sep='')
}
tab <- tabulr((age + Heading('Females')*(sex == 'Female')*sbp)*
              Heading()*g + (age + sbp)*Heading()*trio ~ 
              Heading()*country*Heading()*sex, data=d)
# Formula after interpretation by tabulr:
# (Heading('Age\\hfill {\\smaller[2] years}') * age + Heading("Females")
# * (sex == "Female") * Heading('Systolic BP {\\smaller[2] mmHg}') * sbp)
# * Heading() * g + (age + sbp) * Heading() * table_trio ~ Heading()
# * country * Heading() * sex
cat('\\begin{landscape}\n')
cat('\\begin{minipage}{\\textwidth}\n')
cat('\\keytrio\n')
latex(tab)
cat('\\end{minipage}\\end{landscape}\n')

getHdata(pbc)
pbc <- upData(pbc, moveUnits=TRUE)
# Convert to character to prevent tabular from stratifying
for(x in c('sex', 'stage', 'spiders')) {
  pbc[[x]] <- as.character(pbc[[x]])
  label(pbc[[x]]) <- paste(toupper(substring(x, 1, 1)), substring(x, 2), sep='')
}
table_options(pn=TRUE, showfreq='all')
tab <- tabulr((bili + albumin + protime + age) *
              Heading()*trio +
              (sex + stage + spiders)*Heading()*freq ~ drug, data=pbc)
latex(tab)
}
}
\keyword{utilities}
\keyword{interface}

\name{plotCorrPrecision}
\alias{plotCorrPrecision}
\title{Plot Precision of Estimate of Pearson Correlation Coefficient}
\description{
This function plots the precision (margin of error) of the
product-moment linear 
correlation coefficient r vs. sample size, for a given vector of
correlation coefficients \code{rho}.  Precision is defined as the larger
of the upper confidence limit minus rho and rho minus the lower confidence
limit.  \code{labcurve} is used to automatically label the curves.
}
\usage{
plotCorrPrecision(rho = c(0, 0.5), n = seq(10, 400, length.out = 100),
                  conf.int = 0.95, offset=0.025, \dots)
}
\arguments{
  \item{rho}{single or vector of true correlations.  A worst-case
	precision graph results from rho=0}
  \item{n}{vector of sample sizes to use on the x-axis}
  \item{conf.int}{confidence coefficient; default uses 0.95 confidence
	limits}
  \item{offset}{see \code{\link{labcurve}}}
  \item{\dots}{other arguments to \code{\link{labcurve}}}
}
\author{Xing Wang and Frank Harrell}
\seealso{\code{\link{rcorr}},\code{\link{cor}},\code{\link{cor.test}}}
\examples{
plotCorrPrecision()
plotCorrPrecision(rho=0)
}
\keyword{htest}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ebpcomp.r
\name{ebpcomp}
\alias{ebpcomp}
\title{ebpcomp}
\usage{
ebpcomp(x, qref = c(0.5, 0.25, 0.75), probs = c(0.05, 0.125, 0.25, 0.375))
}
\arguments{
\item{x}{a numeric variable}

\item{qref}{quantiles for major corners}

\item{probs}{quantiles for minor corners}
}
\value{
list with elements \code{segments}, \code{lines}, \code{points}, \code{points2}
}
\description{
Computation of Coordinates of Extended Box Plots Elements
}
\details{
For an extended box plots computes all the elements needed for plotting it.  This is typically used when adding to a \code{ggplot2} plot.
}
\examples{
ebpcomp(1:1000)
}
\author{
Frank Harrell
}

\name{bpower}
\alias{bpower}
\alias{bsamsize}
\alias{ballocation}
\alias{bpower.sim}
\title{
Power and Sample Size for Two-Sample Binomial Test
}
\description{
Uses method of Fleiss, Tytun, and Ury (but without the continuity
correction) to estimate the power (or the sample size to achieve a given
power) of a two-sided test for the difference in two proportions.  The two
sample sizes are allowed to be unequal, but for \code{bsamsize} you must specify
the fraction of observations in group 1.  For power calculations, one
probability (\code{p1}) must be given, and either the other probability (\code{p2}),
an \code{odds.ratio}, or a \code{percent.reduction} must be given.  For \code{bpower} or
\code{bsamsize}, any or all of the arguments may be vectors, in which case they
return a vector of powers or sample sizes.  All vector arguments must have
the same length.


Given \code{p1, p2}, \code{ballocation} uses the method of Brittain and Schlesselman
to compute the optimal fraction of observations to be placed in group 1
that either (1) minimize the variance of the difference in two proportions,
(2) minimize the variance of the ratio of the two proportions, 
(3) minimize the variance of the log odds ratio, or
(4) maximize the power of the 2-tailed test for differences.  For (4)
the total sample size must be given, or the fraction optimizing
the power is not returned.  The fraction for (3) is one minus the fraction
for (1).


\code{bpower.sim} estimates power by simulations, in minimal time.  By using
\code{bpower.sim} you can see that the formulas without any continuity correction
are quite accurate, and that the power of a continuity-corrected test
is significantly lower.  That's why no continuity corrections are implemented
here.
}
\usage{
bpower(p1, p2, odds.ratio, percent.reduction, 
       n, n1, n2, alpha=0.05)


bsamsize(p1, p2, fraction=.5, alpha=.05, power=.8)


ballocation(p1, p2, n, alpha=.05)


bpower.sim(p1, p2, odds.ratio, percent.reduction, 
           n, n1, n2, 
           alpha=0.05, nsim=10000)
}
\arguments{
\item{p1}{
population probability in the group 1
}
\item{p2}{
probability for group 2
}
\item{odds.ratio}{odds ratio to detect}
\item{percent.reduction}{percent reduction in risk to detect}
\item{n}{
total sample size over the two groups.  If you omit this for
\code{ballocation}, the \code{fraction} which optimizes power will not be
returned.
}
\item{n1}{sample size in group 1}
\item{n2}{sample size in group 2.  \code{bpower}, if \code{n} is given,
\code{n1} and \code{n2} are set to \code{n/2}.}
\item{alpha}{type I assertion probability}
\item{fraction}{fraction of observations in group 1}
\item{power}{the desired probability of detecting a difference}
\item{nsim}{number of simulations of binomial responses}
}
\value{
for \code{bpower}, the power estimate; for \code{bsamsize}, a vector containing
the sample sizes in the two groups; for \code{ballocation}, a vector with
4 fractions of observations allocated to group 1, optimizing the four
criteria mentioned above.  For \code{bpower.sim}, a vector with three
elements is returned, corresponding to the simulated power and its
lower and upper 0.95 confidence limits.
}
\details{
For \code{bpower.sim}, all arguments must be of length one.
}
\section{AUTHOR}{
Frank Harrell


Department of Biostatistics


Vanderbilt University


\email{fh@fharrell.com}
}
\references{
Fleiss JL, Tytun A, Ury HK (1980): A simple approximation for calculating
sample sizes for comparing independent proportions.  Biometrics 36:343--6.


Brittain E, Schlesselman JJ (1982): Optimal allocation for the comparison
of proportions.  Biometrics 38:1003--9.


Gordon I, Watson R (1996): The myth of continuity-corrected sample size
formulae.  Biometrics 52:71--6.
}
\seealso{
\code{\link{samplesize.bin}}, \code{\link{chisq.test}}, \code{\link{binconf}}
}
\examples{
bpower(.1, odds.ratio=.9, n=1000, alpha=c(.01,.05))
bpower.sim(.1, odds.ratio=.9, n=1000)
bsamsize(.1, .05, power=.95)
ballocation(.1, .5, n=100)


# Plot power vs. n for various odds ratios  (base prob.=.1)
n  <- seq(10, 1000, by=10)
OR <- seq(.2,.9,by=.1)
plot(0, 0, xlim=range(n), ylim=c(0,1), xlab="n", ylab="Power", type="n")
for(or in OR) {
  lines(n, bpower(.1, odds.ratio=or, n=n))
  text(350, bpower(.1, odds.ratio=or, n=350)-.02, format(or))
}


# Another way to plot the same curves, but letting labcurve do the
# work, including labeling each curve at points of maximum separation
pow <- lapply(OR, function(or,n)list(x=n,y=bpower(p1=.1,odds.ratio=or,n=n)),
              n=n)
names(pow) <- format(OR)
labcurve(pow, pl=TRUE, xlab='n', ylab='Power')


# Contour graph for various probabilities of outcome in the control
# group, fixing the odds ratio at .8 ([p2/(1-p2) / p1/(1-p1)] = .8)
# n is varied also
p1 <- seq(.01,.99,by=.01)
n  <- seq(100,5000,by=250)
pow <- outer(p1, n, function(p1,n) bpower(p1, n=n, odds.ratio=.8))
# This forms a length(p1)*length(n) matrix of power estimates
contour(p1, n, pow)
}
\keyword{htest}
\keyword{category}
\concept{power}
\concept{study design}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hlab.r
\name{hlabs}
\alias{hlabs}
\title{hlabs}
\usage{
hlabs(x, y, html = FALSE)
}
\arguments{
\item{x}{a single variable name, unquoted}

\item{y}{a single variable name, unquoted}

\item{html}{set to \code{TRUE} to render in html (for \code{plotly}), otherwise the result is \code{plotmath} expressions}
}
\value{
result of \code{\link[ggplot2:labs]{ggplot2::labs()}}
}
\description{
Front-end to ggplot2 labs Function
}
\details{
Runs \code{x}, \code{y}, or both through \code{\link[=hlab]{hlab()}} and passes the constructed labels to the \link[ggplot2:labs]{ggplot2::labs} function to specify x- and y-axis labels specially formatted for units of measurement
}
\examples{
# Name the current dataset d, or specify a name with
# options(curr_ds='...') or run `extractlabs`, then
# ggplot(d, aes(x,y)) + geom_point() + hlabs(x,y)
# to specify only the x-axis label use hlabs(x), or to
# specify only the y-axis label use hlabs(y=...)
}
\author{
Frank Harrell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hlab.r
\name{hlab}
\alias{hlab}
\title{hlab}
\usage{
hlab(x, name = NULL, html = FALSE, plotmath = TRUE)
}
\arguments{
\item{x}{a single variable name, unquoted}

\item{name}{a single character string providing an alternate way to name \code{x} that is useful when \code{hlab} is called from another function such as \code{hlabs}}

\item{html}{set to \code{TRUE} to return HTML strings instead of \code{plotmath} expressions}

\item{plotmath}{set to \code{FALSE} to use plain text instead of plotmath}
}
\value{
an expression created by \code{labelPlotmath} with \code{plotmath=TRUE}
}
\description{
Easy Extraction of Labels/Units Expressions for Plotting
}
\details{
Given a single unquoted variable, first looks to see if a non-\code{NULL} \code{LabelsUnits} object exists (produced by \code{extractlabs()}).  When \code{LabelsUnits} does not exist or is \code{NULL}, looks up the attributes in the current dataset, which defaults to \code{d} or may be specified by \code{options(current_ds='name of the data frame/table')}.  Finally the existence of a variable of the given name in the global environment is checked. When a variable is not found in any of these three sources or has a blank \code{label} and \code{units}, an \code{expression()} with the variable name alone is returned.  If \code{html=TRUE}, HTML strings are constructed instead, suitable for \code{plotly} graphics.

The result is useful for \code{xlab} and \code{ylab} in base plotting functions or in \code{ggplot2}, along with being useful for \code{labs} in \code{ggplot2}.  See example.
}
\examples{
d <- data.frame(x=1:10, y=(1:10)/10)
d <- upData(d, labels=c(x='X', y='Y'), units=c(x='mmHg'), print=FALSE)
hlab(x)
hlab(x, html=TRUE)
hlab(z)
require(ggplot2)
ggplot(d, aes(x, y)) + geom_point() + labs(x=hlab(x), y=hlab(y))
# Can use xlab(hlab(x)) + ylab(hlab(y)) also
# Store names, labels, units for all variables in d in object
LabelsUnits <- extractlabs(d)
# Remove d; labels/units still found
rm(d)
hlab(x)
# Remove LabelsUnits and use a current dataset named
# d2 instead of the default d
rm(LabelsUnits)
options(current_ds='d2')
}
\seealso{
\code{\link[=label]{label()}}, \code{\link[=units]{units()}}, \code{\link[=contents]{contents()}}, \code{\link[=hlabs]{hlabs()}}, \code{\link[=extractlabs]{extractlabs()}}, \link{plotmath}
}
\author{
Frank Harrell
}

\name{binconf}
\alias{binconf}
\title{
Confidence Intervals for Binomial Probabilities
}
\description{
Produces 1-alpha confidence intervals for binomial probabilities.
}
\usage{
binconf(x, n, alpha=0.05,
        method=c("wilson","exact","asymptotic","all"),
        include.x=FALSE, include.n=FALSE, return.df=FALSE)
}
\arguments{
\item{x}{
vector containing the number of "successes" for binomial variates
}
\item{n}{
vector containing the numbers of corresponding observations 
}
\item{alpha}{
probability of a type I error, so confidence coefficient = 1-alpha
}
\item{method}{
character string specifing which method to use.  The "all" method only
works when 
x and n are length 1.  The "exact" method uses the F distribution
to compute exact (based on the binomial cdf) intervals; the
"wilson" interval is score-test-based; and the "asymptotic" is the
text-book, asymptotic normal interval.  Following Agresti and
Coull, the Wilson interval is to be preferred and so is the
default.
}
\item{include.x}{
logical flag to indicate whether \code{x} should be included in the
returned matrix or data frame 
}
\item{include.n}{
logical flag to indicate whether \code{n} should be included in the
returned matrix or data frame 
}
\item{return.df}{
logical flag to indicate that a data frame rather than a matrix be
returned
}}
\value{
a matrix or data.frame containing the computed intervals and,
optionally, \code{x} and \code{n}.  
}
\author{
Rollin Brant, Modified by Frank Harrell and
\cr
Brad Biggerstaff
\cr
Centers for Disease Control and Prevention
\cr
National Center for Infectious Diseases
\cr
Division of Vector-Borne Infectious Diseases
\cr
P.O. Box 2087, Fort Collins, CO, 80522-2087, USA
\cr
\email{bkb5@cdc.gov}
}
\references{
A. Agresti and B.A. Coull, Approximate is better than "exact" for
interval estimation of binomial proportions,  
\emph{American Statistician,}
\bold{52}:119--126, 1998.


R.G. Newcombe, Logit confidence intervals and the inverse sinh
transformation,
\emph{American Statistician,}
\bold{55}:200--202, 2001.


L.D. Brown, T.T. Cai and A. DasGupta, Interval estimation for
a binomial proportion (with discussion),
\emph{Statistical Science,}
\bold{16}:101--133, 2001.
}
\examples{
binconf(0:10,10,include.x=TRUE,include.n=TRUE)
binconf(46,50,method="all")
}
\keyword{category}
\keyword{htest}
% Converted by Sd2Rd version 1.21.

\name{curveRep}
\alias{curveRep}
\alias{print.curveRep}
\alias{plot.curveRep}
\alias{curveSmooth}
\title{Representative Curves}
\description{\code{curveRep} finds representative curves from a
  relatively large collection of curves.  The curves usually represent
  time-response profiles as in serial (longitudinal or repeated) data
  with possibly unequal time points and greatly varying sample sizes per
  subject.  After excluding records containing missing \code{x} or
  \code{y}, records are first stratified into \code{kn} groups having similar
  sample sizes per curve (subject).  Within these strata, curves are
  next stratified according to the distribution of \code{x} points per
  curve (typically measurement times per subject).  The
  \code{\link[cluster]{clara}} clustering/partitioning function is used
  to do this, clustering on one, two, or three \code{x} characteristics
  depending on the minimum sample size in the current interval of sample
  size.  If the interval has a minimum number of unique \code{values} of
  one, clustering is done on the single \code{x} values.  If the minimum
  number of unique \code{x} values is two, clustering is done to create
  groups that are similar on both \code{min(x)} and \code{max(x)}.  For
  groups containing no fewer than three unique \code{x} values,
  clustering is done on the trio of values \code{min(x)}, \code{max(x)},
  and the longest gap between any successive \code{x}.  Then within
  sample size and \code{x} distribution strata, clustering of
  time-response profiles is based on \code{p} values of \code{y} all
  evaluated at the same \code{p} equally-spaced \code{x}'s within the
  stratum.  An option allows per-curve data to be smoothed with
  \code{\link{lowess}} before proceeding.  Outer \code{x} values are
  taken as extremes of \code{x} across all curves within the stratum.
  Linear interpolation within curves is used to estimate \code{y} at the
  grid of \code{x}'s.  For curves within the stratum that do not extend
  to the most extreme \code{x} values in that stratum, extrapolation
  uses flat lines from the observed extremes in the curve unless
  \code{extrap=TRUE}. The \code{p} \code{y} values are clustered using
  \code{\link[cluster]{clara}}.

  \code{print} and \code{plot} methods show results.  By specifying an
  auxiliary \code{idcol} variable to \code{plot}, other variables such
  as treatment may be depicted to allow the analyst to determine for
  example whether subjects on different treatments are assigned to
  different time-response profiles.  To write the frequencies of a
  variable such as treatment in the upper left corner of each panel
  (instead of the grand total number of clusters in that panel), specify
  \code{freq}.

  \code{curveSmooth} takes a set of curves and smooths them using
  \code{\link{lowess}}.  If the number of unique \code{x} points in a curve is
  less than \code{p}, the smooth is evaluated at the unique \code{x}
  values.  Otherwise it is evaluated at an equally spaced set of
  \code{x} points over the observed range.  If fewer than 3 unique
  \code{x} values are in a curve, those points are used and smoothing is not done.
}
\usage{
curveRep(x, y, id, kn = 5, kxdist = 5, k = 5, p = 5,
         force1 = TRUE, metric = c("euclidean", "manhattan"),
         smooth=FALSE, extrap=FALSE, pr=FALSE)

\method{print}{curveRep}(x, \dots)

\method{plot}{curveRep}(x, which=1:length(res),
                        method=c('all','lattice','data'),
                        m=NULL, probs=c(.5, .25, .75), nx=NULL, fill=TRUE,
                        idcol=NULL, freq=NULL, plotfreq=FALSE,
                        xlim=range(x), ylim=range(y),
                        xlab='x', ylab='y', colorfreq=FALSE, \dots)
curveSmooth(x, y, id, p=NULL, pr=TRUE)

}
\arguments{
  \item{x}{a numeric vector, typically measurement times.
	For \code{plot.curveRep} is an object created by \code{curveRep}.}
  \item{y}{a numeric vector of response values}
  \item{id}{a vector of curve (subject) identifiers, the same length as
	\code{x} and \code{y}}
  \item{kn}{number of curve sample size groups to construct.
	\code{curveRep} tries to divide the data into equal numbers of
	curves across sample size intervals.}
  \item{kxdist}{maximum number of x-distribution clusters to derive
	using \code{clara}}
  \item{k}{maximum number of x-y profile clusters to derive using \code{clara}}
  \item{p}{number of \code{x} points at which to interpolate \code{y}
	for profile clustering.  For \code{curveSmooth} is the number of
	equally spaced points at which to evaluate the lowess smooth, and if
  \code{p} is omitted the smooth is evaluated at the original \code{x}
  values (which will allow \code{curveRep} to still know the \code{x}
  distribution}
  \item{force1}{By default if any curves have only one point, all curves
	consisting of one point will be placed in a separate stratum.  To
	prevent this separation, set \code{force1 = FALSE}.}
  \item{metric}{see \code{\link[cluster]{clara}}}
  \item{smooth}{By default, linear interpolation is used on raw data to
	obtain \code{y} values to cluster to determine x-y profiles.
	Specify \code{smooth = TRUE} to replace observed points with
	\code{\link{lowess}} before computing \code{y} points on the grid.
	Also, when \code{smooth} is used, it may be desirable to use
	\code{extrap=TRUE}.}
  \item{extrap}{set to \code{TRUE} to use linear extrapolation to
	evaluate \code{y} points for x-y clustering.  Not recommended unless
	smoothing has been or is being done.}
  \item{pr}{set to \code{TRUE} to print progress notes}
  \item{which}{an integer vector specifying which sample size intervals
	to plot.  Must be specified if \code{method='lattice'} and must be a
	single number in that case.}
  \item{method}{The default makes individual plots of possibly all
	x-distribution by sample size by cluster combinations.  Fewer may be
	plotted by specifying \code{which}.  Specify \code{method='lattice'}
	to show a lattice \code{xyplot} of a single sample size interval,
	with x distributions going across and clusters going down.  To not
	plot but instead return a data frame for a single sample size
	interval, specify \code{method='data'}}
  \item{m}{the number of curves in a cluster to randomly sample if there
	are more than \code{m} in a cluster.  Default is to draw all curves
	in a cluster.  For \code{method = "lattice"} you can specify
	\code{m = "quantiles"} to use the \code{xYplot} function to show
	quantiles of \code{y} as a function of \code{x}, with the quantiles
	specified by the \code{probs} argument.  This cannot be used to draw
	a group containing \code{n = 1}.}
  \item{nx}{applies if \code{m = "quantiles"}.  See \code{\link{xYplot}}.}
  \item{probs}{3-vector of probabilities with the central quantile
	first.  Default uses quartiles.}
  \item{fill}{for \code{method = "all"}, by default if a sample size
	x-distribution stratum did not have enough curves to stratify into
	\code{k} x-y profiles, empty graphs are drawn so that a matrix of
	graphs will have the next row starting with a different sample size
	range or x-distribution.  See the example below.}
  \item{idcol}{a named vector to be used as a table lookup for color
	assignments (does not apply when \code{m = "quantile"}).  The names of
	this vector are curve \code{id}s and the values are color names or
	numbers.}
  \item{freq}{a named vector to be used as a table lookup for a grouping
	variable such as treatment.  The names are curve \code{id}s and
	values are any values useful for grouping in a frequency tabulation.}
  \item{plotfreq}{set to \code{TRUE} to plot the frequencies from the
	\code{freq} variable as horizontal bars instead of printing them.
	Applies only to \code{method = "lattice"}.  By default the largest bar
	is 0.1 times the length of a panel's x-axis.  Specify
	\code{plotfreq = 0.5} for example to make the longest bar half this long.}
  \item{colorfreq}{set to \code{TRUE} to color the frequencies printed by 
	\code{plotfreq} using the colors provided by \code{idcol}.}
  \item{xlim, ylim, xlab, ylab}{plotting parameters.  Default ranges are
	the ranges in the entire set of raw data given to \code{curveRep}.}
  \item{\dots}{arguments passed to other functions.}
}
\value{a list of class \code{"curveRep"} with the following elements
  \item{res}{a hierarchical list first split by sample size intervals,
	then by x distribution clusters, then containing a vector of cluster
  numbers with \code{id} values as a names attribute}
  \item{ns}{a table of frequencies of sample sizes per curve after
	removing \code{NA}s}
  \item{nomit}{total number of records excluded due to \code{NA}s}
  \item{missfreq}{a table of frequencies of number of \code{NA}s
	excluded per curve}
  \item{ncuts}{cut points for sample size intervals}
  \item{kn}{number of sample size intervals}
  \item{kxdist}{number of clusters on x distribution}
  \item{k}{number of clusters of curves within sample size and
	distribution groups}
  \item{p}{number of points at which to evaluate each curve for clustering}
  \item{x}{}
  \item{y}{}
  \item{id}{input data after removing \code{NA}s}
  \code{curveSmooth} returns a list with elements \code{x,y,id}.
}
\details{
  In the graph titles for the default graphic output, \code{n} refers to the
  minimum sample size, \code{x} refers to the sequential x-distribution
  cluster, and \code{c} refers to the sequential x-y profile cluster.  Graphs
  from \code{method = "lattice"} are produced by
  \code{\link[lattice]{xyplot}} and in the panel titles
  \code{distribution} refers to the x-distribution stratum and
  \code{cluster} refers to the x-y profile cluster.
}
\references{
  Segal M. (1994): Representative curves for longitudinal data via
  regression trees.  J Comp Graph Stat 3:214-233.

  
  Jones MC, Rice JA (1992): Displaying the important features of large
  collections of similar curves.  Am Statistician 46:140-145.

  
  Zheng X, Simpson JA, et al (2005): Data from a study of effectiveness
  suggested potential prognostic factors related to the patterns of
  shoulder pain.  J Clin Epi 58:823-830.
  }
\author{
  Frank Harrell\cr
  Department of Biostatistics\cr
  Vanderbilt University\cr
  \email{fh@fharrell.com}
}
\note{The references describe other methods for deriving
  representative curves, but those methods were not used here.  The last
  reference which used a cluster analysis on principal components
  motivated \code{curveRep} however.  The \code{kml} package does k-means clustering of longitudinal data with imputation.}
\seealso{\code{\link[cluster]{clara}},\code{\link[Hmisc]{dataRep}}}
\examples{
\dontrun{
# Simulate 200 curves with per-curve sample sizes ranging from 1 to 10
# Make curves with odd-numbered IDs have an x-distribution that is random
# uniform [0,1] and those with even-numbered IDs have an x-dist. that is
# half as wide but still centered at 0.5.  Shift y values higher with
# increasing IDs
set.seed(1)
N <- 200
nc <- sample(1:10, N, TRUE)
id <- rep(1:N, nc)
x <- y <- id
for(i in 1:N) {
  x[id==i] <- if(i \%\% 2) runif(nc[i]) else runif(nc[i], c(.25, .75))
  y[id==i] <- i + 10*(x[id==i] - .5) + runif(nc[i], -10, 10)
}

w <- curveRep(x, y, id, kxdist=2, p=10)
w
par(ask=TRUE, mfrow=c(4,5))
plot(w)                # show everything, profiles going across
par(mfrow=c(2,5))
plot(w,1)              # show n=1 results
# Use a color assignment table, assigning low curves to green and
# high to red.  Unique curve (subject) IDs are the names of the vector.
cols <- c(rep('green', N/2), rep('red', N/2))
names(cols) <- as.character(1:N)
plot(w, 3, idcol=cols)
par(ask=FALSE, mfrow=c(1,1))

plot(w, 1, 'lattice')  # show n=1 results
plot(w, 3, 'lattice')  # show n=4-5 results
plot(w, 3, 'lattice', idcol=cols)  # same but different color mapping
plot(w, 3, 'lattice', m=1)  # show a single "representative" curve
# Show median, 10th, and 90th percentiles of supposedly representative curves
plot(w, 3, 'lattice', m='quantiles', probs=c(.5,.1,.9))
# Same plot but with much less grouping of x variable
plot(w, 3, 'lattice', m='quantiles', probs=c(.5,.1,.9), nx=2)

# Use ggplot2 for one sample size interval
z <- plot(w, 2, 'data')
require(ggplot2)
ggplot(z, aes(x, y, color=curve)) + geom_line() +
       facet_grid(distribution ~ cluster) +
       theme(legend.position='none') +
       labs(caption=z$ninterval[1])


# Smooth data before profiling.  This allows later plotting to plot
# smoothed representative curves rather than raw curves (which
# specifying smooth=TRUE to curveRep would do, if curveSmooth was not used)
d <- curveSmooth(x, y, id)
w <- with(d, curveRep(x, y, id))

# Example to show that curveRep can cluster profiles correctly when
# there is no noise.  In the data there are four profiles - flat, flat
# at a higher mean y, linearly increasing then flat, and flat at the
# first height except for a sharp triangular peak

set.seed(1)
x <- 0:100
m <- length(x)
profile <- matrix(NA, nrow=m, ncol=4)
profile[,1] <- rep(0, m)
profile[,2] <- rep(3, m)
profile[,3] <- c(0:3, rep(3, m-4))
profile[,4] <- c(0,1,3,1,rep(0,m-4))
col <- c('black','blue','green','red')
matplot(x, profile, type='l', col=col)
xeval <- seq(0, 100, length.out=5)
s <- x %in% xeval
matplot(x[s], profile[s,], type='l', col=col)

id <- rep(1:100, each=m)
X <- Y <- id
cols <- character(100)
names(cols) <- as.character(1:100)
for(i in 1:100) {
  s <- id==i
  X[s] <- x
  j <- sample(1:4,1)
  Y[s] <- profile[,j]
  cols[i] <- col[j]
}
table(cols)
yl <- c(-1,4)
w <- curveRep(X, Y, id, kn=1, kxdist=1, k=4)
plot(w, 1, 'lattice', idcol=cols, ylim=yl)
# Found 4 clusters but two have same profile
w <- curveRep(X, Y, id, kn=1, kxdist=1, k=3)
plot(w, 1, 'lattice', idcol=cols, freq=cols, plotfreq=TRUE, ylim=yl)
# Incorrectly combined black and red because default value p=5 did
# not result in different profiles at x=xeval
w <- curveRep(X, Y, id, kn=1, kxdist=1, k=4, p=40)
plot(w, 1, 'lattice', idcol=cols, ylim=yl)
# Found correct clusters because evaluated curves at 40 equally
# spaced points and could find the sharp triangular peak in profile 4
}
}
\keyword{multivariate}
\keyword{hplot}
\concept{repeated measures}
\concept{longitudinal data}
\concept{serial data}
\concept{representative curves}
\concept{descriptive statistics}
\concept{exploratory data analysis}

\name{string.break.line}
\alias{string.break.line}
\title{Break a String into Many Lines at Newlines}
\description{
  Takes a string and breaks it into seperate substrings where there are
  newline characters.
}
\usage{
string.break.line(string)
}
\arguments{
  \item{string}{character vector to be separated into many lines.}
}
\value{
  Returns a list that is the same length of as the \code{string}
  argument.

  Each list element is a character vector.

  Each character vectors elements are the
  split lines of the corresponding element in the \code{string} argument vector.
}
\author{Charles Dupont}
\seealso{\code{\link{strsplit}}}
\examples{
a <- c('', 'this is a single line string',
       'This is a\nmulti-line string.')

b <- string.break.line(a)
}
\keyword{print}
\keyword{character}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hashCheck.r
\name{runifChanged}
\alias{runifChanged}
\title{runifChanged}
\usage{
runifChanged(fun, ..., file = NULL, .print. = TRUE, .inclfun. = TRUE)
}
\arguments{
\item{fun}{the (usually slow) function to run}

\item{...}{input objects the result of running the function is dependent on}

\item{file}{file in which to store the result of \code{fun} augmented by attributes containing hash digests}

\item{.print.}{set to \code{TRUE} to list which objects changed that neessitated re-running \code{f}}

\item{.inclfun.}{set to \code{FALSE} to not include \code{fun} in the hash digest, i.e., to not require re-running \code{fun} if only \code{fun} itself has changed}
}
\value{
the result of running \code{fun}
}
\description{
Re-run Code if an Input Changed
}
\details{
Uses \code{hashCheck} to run a function and save the results if specified inputs have changed, otherwise to retrieve results from a file.  This makes it easy to see if any objects changed that require re-running a long simulation, and reports on any changes.  The file name is taken as the chunk name appended with \code{.rds} unless it is given as \verb{file=}.  \code{fun} has no arguments.  Set \code{.inclfun.=FALSE} to not include \code{fun} in the hash check (for legacy uses).  The typical workflow is as follows.

\if{html}{\out{<div class="sourceCode">}}\preformatted{f <- function(       ) \{
# . . . do the real work with multiple function calls ...
\}
seed <- 3
set.seed(seed)
w <- runifChanged(f, seed, obj1, obj2, ....)
}\if{html}{\out{</div>}}

\verb{seed, obj1, obj2}, ... are all the objects that \code{f()} uses that if changed
would give a different result of \code{f()}.  This can include functions such as
those in a package, and \code{f} will be re-run if any of the function's code
changes.  \code{f} is also re-run if the code inside \code{f} changes.
The result of \code{f} is stored with \code{saveRDS} by default in file named \code{xxx.rds}
where \code{xxx} is the label for the current chunk.  To control this use instead
\code{file=xxx.rds} add the file argument to \code{runifChanged(...)}.  If nothing has
changed and the file already exists, the file is read to create the result
object (e.g., \code{w} above).  If \code{f()} needs to be run, the hashed input objects
are stored as attributes for the result then the enhanced result is written to the file.

See \href{https://hbiostat.org/rflow/caching.html}{here} for examples.
}
\author{
Frank Harrell
}

\name{print.char.matrix}
\alias{print.char.matrix}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{ Function to print a matrix with stacked cells }
\description{
   Prints a dataframe or matrix in stacked cells.  Line break charcters
   in a matrix element will result in a line break in that cell, but tab
   characters are not supported.
}
\usage{
\method{print}{char.matrix}(x, file = "", col.name.align = "cen", col.txt.align = "right", 
    cell.align = "cen", hsep = "|", vsep = "-", csep = "+", row.names = TRUE, 
    col.names = FALSE, append = FALSE,
    top.border = TRUE, left.border = TRUE, \dots)
}

\arguments{
  \item{x}{a matrix or dataframe}
  \item{file}{name of file if file output is desired.  If left empty,
    output will be to the screen}
  \item{col.name.align}{if column names are used, they can be aligned
    right, left or centre. Default \code{"cen"} results in names centred
    between the sides of the columns they name. If the width of the text
    in the columns is less than the width of the name, \code{col.name.align}
    will have no effect. Other options are \code{"right"} and \code{"left"}.}
  \item{col.txt.align}{how character columns are aligned.  Options
    are the same as for \code{col.name.align} with no effect when the width of
    the column is greater than its name.}
  \item{cell.align}{how numbers are displayed in columns}
  \item{hsep}{character string to use as horizontal separator,
    i.e. what separates columns}
  \item{vsep}{character string to use as vertical separator,
    i.e. what separates rows.  Length cannot be more than one.}

  \item{csep}{character string to use where vertical and horizontal
    separators cross.  If \code{hsep} is more than one character,
    \code{csep} will need to be the same length.  There is no provision
    for multiple vertical separators}

  \item{row.names}{logical: are we printing the names of the rows?}
  \item{col.names}{logical: are we printing the names of the columns?}
  \item{append}{logical: if \code{file} is not \code{""}, are we appending to
    the file or overwriting?}
  \item{top.border}{logical: do we want a border along the top above the
    columns?}
  \item{left.border}{logical: do we want a border along the left of the
    first column?}
  \item{\dots}{unused}
  }

\details{
  If any column of \code{x} is a mixture of character and numeric, the
  distinction between character and numeric columns will be lost. This
  is especially so if the matrix is of a form where you would not want
  to print the column names, the column information being in the rows at
  the beginning of the matrix.

  Row names, if not specified in the making of the matrix will simply be
  numbers. To prevent printing them, set \code{row.names = FALSE}.}

\value{
  No value is returned.  The matrix or dataframe will be printed to file
  or to the screen.
}
\author{Patrick Connolly \email{p.connolly@hortresearch.co.nz}}

\seealso{\code{write},  \code{write.table}}

\examples{
data(HairEyeColor)
print.char.matrix(HairEyeColor[ , , "Male"], col.names = TRUE)
print.char.matrix(HairEyeColor[ , , "Female"], col.txt.align = "left", col.names = TRUE)


z <- rbind(c("", "N", "y"),
           c("[ 1.34,40.3)\n[40.30,48.5)\n[48.49,58.4)\n[58.44,87.8]",
             " 50\n 50\n 50\n 50",
             "0.530\n0.489\n0.514\n0.507"),
           c("female\nmale", " 94\n106", "0.552\n0.473"  ),
           c("", "200", "0.510"))
dimnames(z) <- list(c("", "age", "sex", "Overall"),NULL)

print.char.matrix(z)
}
\keyword{print}
\keyword{array}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simMarkovOrd.r
\name{soprobMarkovOrdm}
\alias{soprobMarkovOrdm}
\title{soprobMarkovOrdm}
\usage{
soprobMarkovOrdm(
  object,
  data,
  times,
  ylevels,
  absorb = NULL,
  tvarname = "time",
  pvarname = "yprev",
  gap = NULL
)
}
\arguments{
\item{object}{a fit object created by \code{blrm}, \code{lrm}, \code{orm}, \code{VGAM::vglm()}, or \code{VGAM::vgam()}}

\item{data}{a single observation list or data frame with covariate settings, including the initial state for Y}

\item{times}{vector of measurement times}

\item{ylevels}{a vector of ordered levels of the outcome variable (numeric or character)}

\item{absorb}{vector of absorbing states, a subset of \code{ylevels}.  The default is no absorbing states. (numeric, character, factor)}

\item{tvarname}{name of time variable, defaulting to \code{time}}

\item{pvarname}{name of previous state variable, defaulting to \code{yprev}}

\item{gap}{name of time gap variable, defaults assuming that gap time is not in the model}
}
\value{
if \code{object} was not a Bayesian model, a matrix with rows corresponding to times and columns corresponding to states, with values equal to exact state occupancy probabilities.  If \code{object} was created by \code{blrm}, the result is a 3-dimensional array with the posterior draws as the first dimension.
}
\description{
State Occupancy Probabilities for First-Order Markov Ordinal Model from a Model Fit
}
\details{
Computes state occupancy probabilities for a single setting of baseline covariates.  If the model fit was from \code{rms::blrm()}, these probabilities are from all the posterior draws of the basic model parameters.  Otherwise they are maximum likelihood point estimates.
}
\seealso{
\url{https://hbiostat.org/R/Hmisc/markov/}
}
\author{
Frank Harrell
}

\name{getRs}
\alias{getRs}
\title{Interact with github rscripts Project}
\description{
	The github rscripts project at
	\url{https://github.com/harrelfe/rscripts} contains R scripts that are
	primarily analysis templates for teaching with RStudio.  This function
	allows the user to print an organized list of available scripts, to
	download a script and \code{source()} it into the current session (the
	default), to
	download a script and load it into an RStudio script editor window, to
	list scripts whose major category contains a given string (ignoring
	case), or to list all major and minor categories.  If
	\code{options(localHfiles=TRUE)} the scripts are read from local directory
	\code{~/R/rscripts} instead of from github.
}
\usage{
getRs(file=NULL, guser='harrelfe', grepo='rscripts', gdir='raw/master',
      dir=NULL, browse=c('local', 'browser'), cats=FALSE,
      put=c('source', 'rstudio'))
}
\arguments{
  \item{file}{a character string containing a script file name.
    Omit \code{file} to obtain a list of available scripts with major
    and minor categories.}
	\item{guser}{GitHub user name, default is \code{'harrelfe'}}
	\item{grepo}{Github repository name, default is \code{'rscripts'}}
	\item{gdir}{Github directory under which to find retrievable files}
	\item{dir}{directory under \code{grepo} in which to find files}
  \item{browse}{When showing the rscripts contents directory, the
      default is to list in tabular form in the console.  Specify
      \code{browse='browser'} to open the online contents in a web
      browser.}
	\item{cats}{Leave at the default (\code{FALSE}) to list whole contents
      or download a script.  Specify \code{cats=TRUE} to list major and
      minor categories available.  Specify a character string to list
      all scripts whose major category contains the string (ignoring
			case).}
	\item{put}{Leave at the default (\code{'source'}) to \code{source()} the file.  This is useful when the file just defines a function you want to use in the session. Use load \code{put='rstudio'} to load the file into the RStudio script editor window using the \code{rstudioapi} \code{navigateToFile} function.  If RStudio is not running, \code{file.edit()} is used instead.}
}
\value{a data frame or list, depending on arguments}
\author{Frank Harrell and Cole Beck}
\seealso{\code{\link{download.file}}}
\examples{
\dontrun{
getRs()             # list available scripts
scripts <- getRs()  # likewise, but store in an object that can easily
                    # be viewed on demand in RStudio
getRs('introda.r')  # download introda.r and put in script editor
getRs(cats=TRUE)    # list available major and minor categories
categories <- getRs(cats=TRUE)
# likewise but store results in a list for later viewing
getRs(cats='reg')   # list all scripts in a major category containing 'reg'
getRs('importREDCap.r')   # source() to define a function
# source() a new version of the Hmisc package's cut2 function:
getRs('cut2.s', grepo='Hmisc', dir='R')
}
}
\keyword{interface}

\name{sedit}
\alias{sedit}
\alias{substring.location}
\alias{substring2}
\alias{substring2<-}
\alias{replace.substring.wild}
\alias{numeric.string}
\alias{all.digits}
\title{
  Character String Editing and Miscellaneous Character Handling Functions
}
\description{
  This suite of functions was written to implement many of the features
  of the UNIX \code{sed} program entirely within S (function \code{sedit}).
  The \code{substring.location} function returns the first and last position
  numbers that a sub-string occupies in a larger string.  The \code{substring2<-}
  function does the opposite of the builtin function \code{substring}.
  It is named \code{substring2} because for S-Plus there is a built-in
  function \code{substring}, but it does not handle multiple replacements in
  a single string.
  \code{replace.substring.wild} edits character strings in the fashion of
  "change xxxxANYTHINGyyyy to aaaaANYTHINGbbbb", if the "ANYTHING"
  passes an optional user-specified \code{test} function.  Here, the
  "yyyy" string is searched for from right to left to handle
  balancing parentheses, etc.  \code{numeric.string}
  and \code{all.digits} are two examples of \code{test} functions, to check,
  respectively if each of a vector of strings is a legal numeric or if it contains only
  the digits 0-9.  For the case where \code{old="*$" or "^*"}, or for
  \code{replace.substring.wild} with the same values of \code{old} or with
  \code{front=TRUE} or \code{back=TRUE}, \code{sedit} (if \code{wild.literal=FALSE}) and
  \code{replace.substring.wild} will edit the largest substring
  satisfying \code{test}.

  \code{substring2} is just a copy of \code{substring} so that
  \code{substring2<-} will work.
}
\usage{
sedit(text, from, to, test, wild.literal=FALSE)
substring.location(text, string, restrict)
# substring(text, first, last) <- setto   # S-Plus only
replace.substring.wild(text, old, new, test, front=FALSE, back=FALSE)
numeric.string(string)
all.digits(string)
substring2(text, first, last)
substring2(text, first, last) <- value
}
\arguments{
  \item{text}{
    a vector of character strings for \code{sedit, substring2, substring2<-}
    or a single character string for \code{substring.location,
      replace.substring.wild}.
  }
  \item{from}{
    a vector of character strings to translate from, for \code{sedit}.
    A single asterisk wild card, meaning allow any sequence of characters
    (subject to the \code{test} function, if any) in place of the \code{"*"}.
    An element of \code{from} may begin with \code{"^"} to force the match to
    begin at the beginning of \code{text}, and an element of \code{from} can end with
    \code{"$"} to force the match to end at the end of \code{text}.
  }
  \item{to}{
    a vector of character strings to translate to, for \code{sedit}.
    If a corresponding element in \code{from} had an \code{"*"}, the element
    in \code{to} may also have an \code{"*"}.  Only single asterisks are allowed.
    If \code{to} is not the same length as \code{from}, the \code{rep} function
    is used to make it the same length.
  }
  \item{string}{
    a single character string, for \code{substring.location}, \code{numeric.string},
    \code{all.digits}
  }
  \item{first}{
    a vector of integers specifying the first position to replace for
    \code{substring2<-}.  \code{first} may also be a vector of character strings
    that are passed to \code{sedit} to use as patterns for replacing
    substrings with \code{setto}.  See one of the last examples below.
  }
  \item{last}{
    a vector of integers specifying the ending positions of the character
    substrings to be replaced.  The default is to go to the end of
    the string.  When \code{first} is character, \code{last} must be
    omitted.
  }
  \item{setto}{
    a character string or vector of character strings used as replacements,
    in \code{substring2<-}
  }
  \item{old}{
    a character string to translate from for \code{replace.substring.wild}.
    May be \code{"*$"} or \code{"^*"} or any string containing a single \code{"*"} but
    not beginning with \code{"^"} or ending with \code{"$"}.
  }
  \item{new}{
    a character string to translate to for \code{replace.substring.wild}
  }
  \item{test}{
    a function of a vector of character strings returning a logical vector
    whose elements are \code{TRUE} or \code{FALSE} according
    to whether that string element qualifies as the wild card string for
    \code{sedit, replace.substring.wild}
  }
  \item{wild.literal}{
    set to \code{TRUE} to not treat asterisks as wild cards and to not look for
    \code{"^"} or \code{"$"} in \code{old}
  }
  \item{restrict}{
    a vector of two integers for \code{substring.location} which specifies a
    range to which the search for matches should be restricted
  }
  \item{front}{
    specifying \code{front = TRUE} and \code{old = "*"} is the same as
    specifying \code{old = "^*"}
  }
  \item{back}{
    specifying \code{back = TRUE} and \code{old = "*"} is the same as
    specifying \code{old = "*$"}
  }
  \item{value}{a character vector}
}
\value{
  \code{sedit} returns a vector of character strings the same length as \code{text}.
  \code{substring.location} returns a list with components named \code{first}
  and \code{last}, each specifying a vector of character positions corresponding
  to matches.  \code{replace.substring.wild} returns a single character string.
  \code{numeric.string} and \code{all.digits} return a single logical value.
}
\section{Side Effects}{
  \code{substring2<-} modifies its first argument
}
\author{
  Frank Harrell
  \cr
  Department of Biostatistics
  \cr
  Vanderbilt University School of Medicine
  \cr
  \email{fh@fharrell.com}
}
\seealso{
  \code{\link{grep}}, \code{\link{substring}}
}
\examples{
x <- 'this string'
substring2(x, 3, 4) <- 'IS'
x
substring2(x, 7) <- ''
x


substring.location('abcdefgabc', 'ab')
substring.location('abcdefgabc', 'ab', restrict=c(3,999))


replace.substring.wild('this is a cat','this*cat','that*dog')
replace.substring.wild('there is a cat','is a*', 'is not a*')
replace.substring.wild('this is a cat','is a*', 'Z')


qualify <- function(x) x==' 1.5 ' | x==' 2.5 '
replace.substring.wild('He won 1.5 million $','won*million',
                       'lost*million', test=qualify)
replace.substring.wild('He won 1 million $','won*million',
                       'lost*million', test=qualify)
replace.substring.wild('He won 1.2 million $','won*million',
                       'lost*million', test=numeric.string)


x <- c('a = b','c < d','hello')
sedit(x, c('=','he*o'),c('==','he*'))


sedit('x23', '*$', '[*]', test=numeric.string)
sedit('23xx', '^*', 'Y_{*} ', test=all.digits)


replace.substring.wild("abcdefabcdef", "d*f", "xy")


x <- "abcd"
substring2(x, "bc") <- "BCX"
x
substring2(x, "B*d") <- "B*D"
x
}
\keyword{manip}
\keyword{character}
% Converted by Sd2Rd version 1.21.

\name{label}
\alias{label}
\alias{label<-}
\alias{label.default}
\alias{label.Surv}
\alias{label<-.default}
\alias{labelPlotmath}
\alias{labelLatex}
\alias{[.labelled}
\alias{print.labelled}
\alias{Label}
\alias{Label.data.frame}
\alias{llist}
\alias{prList}
\alias{putHcap}
\alias{putHfig}
\alias{plotmathTranslate}
\alias{as.data.frame.labelled}
\alias{data.frame.labelled}
\alias{reLabelled}
\alias{label.data.frame}
\alias{label<-.data.frame}
\alias{relevel.labelled}
\alias{combineLabels}
\title{
  Label Attribute of an Object
}
\description{
  \code{label(x)} retrieves the \code{label} attribute of \code{x}.
  \code{label(x) <- "a label"} stores the label attribute, and also puts
  the class \code{labelled} as the first class of \code{x} (for S-Plus
  this class is not used and methods for handling this class are
  not defined so the \code{"label"} and \code{"units"} attributes are lost
  upon subsetting).  The reason for having this class is so that the
  subscripting method for \code{labelled}, \code{[.labelled}, can preserve
  the \code{label} attribute in S.  Also, the \code{print}
  method for \code{labelled} objects prefaces the print with the object's
  \code{label} (and \code{units} if there).  If the variable is also given
  a \code{"units"} attribute using the \code{units} function, subsetting
  the variable (using \code{[.labelled}) will also retain the
  \code{"units"} attribute.

  \code{label} can optionally append a \code{"units"} attribute to the
  string, and it can optionally return a string or expression (for \R's
  \code{plotmath} facility) suitable for plotting.  \code{labelPlotmath}
  is a function that also has this function, when the input arguments are
  the \code{'label'} and \code{'units'} rather than a vector having those
  attributes.  When \code{plotmath} mode is used to construct labels, the
  \code{'label'} or \code{'units'} may contain math expressions but they
  are typed verbatim if they contain percent signs, blanks, or
  underscores.  \code{labelPlotmath} can optionally create the
  expression as a character string, which is useful in building
  \code{ggplot} commands.

	For \code{Surv} objects, \code{label} first looks to see if there is
	an overall \code{"label"} attribute for the object, then it looks for
	saved attributes that \code{Surv} put in the \code{"inputAttributes"}
	object, looking first at the \code{event} variable, then \code{time2},
	and finally \code{time}.  You can restrict the looking by specifying
	\code{type}.

	\code{labelLatex} constructs suitable LaTeX labels a variable or from the
	\code{label} and \code{units} arguments, optionally right-justifying
	\code{units} if \code{hfill=TRUE}.  This is useful when making tables
	when the variable in question is not a column heading.  If \code{x}
	is specified, \code{label} and \code{units} values are extracted from
	its attributes instead of from the other arguments.

  \code{Label} (actually \code{Label.data.frame}) is a function which generates
  S source code that makes the labels in all the variables in a data
  frame easy to edit.

  \code{llist} is like \code{list} except that it preserves the names or
  labels of the component variables in the variables \code{label}
  attribute.  This can be useful when looping over variables or using
  \code{sapply} or \code{lapply}. By using \code{llist} instead of
  \code{list} one can annotate the output with the current variable's name
  or label.  \code{llist} also defines a \code{names} attribute for the
  list and pulls the \code{names} from the arguments' expressions for
  non-named arguments.

	\code{prList} prints a list with element names (without the dollar
	sign as in default list printing) and if an element of the list is an
	unclassed list with a name, all of those elements are printed, with
	titles of the form "primary list name : inner list name".  This is
	especially useful for Rmarkdown html notebooks when a user-written
	function creates multiple html and graphical outputs to all be printed
	in a code chunk.  Optionally the names can be printed after the
	object, and the \code{htmlfig} option provides more capabilities when
	making html reports.  \code{prList} does not work for regular html
	documents. 

	\code{putHfig} is similar to \code{prList} but for a single graphical
	object that is rendered with a \code{print} method, making it easy to
	specify long captions, and short captions for the table of contents in
	HTML documents.
	Table of contents entries are generated with the short caption, which
	is taken as the long caption if there is none.  One can optionally not
	make a table of contents entry.  If argument \code{table=TRUE} table
	captions will be produced instead.  Using \code{expcoll},
	\code{markupSpecs} \code{html} function \code{expcoll} will be used to
	make tables expand upon clicking an arrow rather than always appear.

	\code{putHcap} is like \code{putHfig} except that it
	assumes that users render the graphics or table outside of the
	\code{putHcap} call.  This allows things to work in ordinary html
	documents.  \code{putHcap} does not handle collapsed text.

  \code{plotmathTranslate} is a simple function that translates certain
  character strings to character strings that can be used as part of \R
  \code{plotmath} expressions.  If the input string has a space or percent
  inside, the string is surrounded by a call to \code{plotmath}'s
  \code{paste} function.

  \code{as.data.frame.labelled} is a utility function that is called by
  \code{[.data.frame}.  It is just a copy of \code{as.data.frame.vector}.
  \code{data.frame.labelled} is another utility function, that adds a
  class \code{"labelled"} to every variable in a data frame that has a
  \code{"label"} attribute but not a \code{"labelled"} class.

  \code{relevel.labelled} is a method for preserving \code{label}s with the \code{relevel} function.

  \code{reLabelled} is used to add a \code{'labelled'} class back to
  variables in data frame that have a 'label' attribute but no 'labelled'
  class.  Useful for changing \code{cleanup.import()}'d S-Plus data
  frames back to general form for \R and old versions of S-Plus.
}
\usage{
label(x, default=NULL, ...)

\method{label}{default}(x, default=NULL, units=plot, plot=FALSE,
      grid=FALSE, html=FALSE, \dots)

\method{label}{Surv}(x, default=NULL, units=plot, plot=FALSE,
      grid=FALSE, html=FALSE, type=c('any', 'time', 'event'), \dots)

\method{label}{data.frame}(x, default=NULL, self=FALSE, \dots)

label(x, ...) <- value

\method{label}{default}(x, ...) <- value

\method{label}{data.frame}(x, self=TRUE, ...) <- value

labelPlotmath(label, units=NULL, plotmath=TRUE, html=FALSE, grid=FALSE,
              chexpr=FALSE)

labelLatex(x=NULL, label='', units='', size='smaller[2]',
           hfill=FALSE, bold=FALSE, default='', double=FALSE)

\method{print}{labelled}(x, \dots)   ## or x - calls print.labelled

Label(object, \dots)

\method{Label}{data.frame}(object, file='', append=FALSE, \dots)

llist(\dots, labels=TRUE)

prList(x, lcap=NULL, htmlfig=0, after=FALSE)

putHfig(x, \dots, scap=NULL, extra=NULL, subsub=TRUE, hr=TRUE,
        table=FALSE, file='', append=FALSE, expcoll=NULL)

putHcap(\dots, scap=NULL, extra=NULL, subsub=TRUE, hr=TRUE,
        table=FALSE, file='', append=FALSE)

plotmathTranslate(x)

data.frame.labelled(object)

\method{relevel}{labelled}(x, \dots)

reLabelled(object)

combineLabels(\dots)
}
\arguments{
  \item{x}{
    any object (for \code{plotmathTranslate} is a character string). For
		\code{relevel} is a \code{factor} variable.  For \code{prList} is a
		named list.  For \code{putHfig} is a graphical object for which a
		\code{print} method will render the graphic (e.g., a \code{ggplot2}
		or \code{plotly} object).
  }
  \item{self}{lgoical, where to interact with the object or its components}
  \item{units}{
    set to \code{TRUE} to append the \code{'units'} attribute (if present)
    to the returned label.  The \code{'units'} are surrounded
    by brackets.  For \code{labelPlotmath} and \code{labelLatex} is a
		character string containing the units of measurement.  When
		\code{plot} is \code{TRUE}, \code{units} defaults to \code{TRUE}.
  }
  \item{plot}{
    set to \code{TRUE} to return a label suitable for \R's \code{plotmath}
    facility (returns an expression instead of a character string) if R is
    in effect.  If \code{units} is also \code{TRUE}, and if both
    \code{'label'} and \code{'units'} attributes are present, the
    \code{'units'} will appear after the label but in smaller type and
    will not be surrounded by brackets.
  }
  \item{default}{
    if \code{x} does not have a \code{'label'} attribute and
    \code{default} (a character string) is specified, the label will be
    taken as \code{default}.  For \code{labelLatex} the \code{default}
		is the name of the first argument if it is a variable and not a label.
  }
  \item{grid}{
    Currently \R's \code{lattice} and \code{grid} functions do not support
    \code{plotmath} expressions for \code{xlab} and \code{ylab}
    arguments.  When using \code{lattice} functions in \R, set the
    argument \code{grid} to \code{TRUE} so that \code{labelPlotmath} can
    return an ordinary character string instead of an expression.
  }
	\item{html}{set to \code{TRUE} to use HTML formatting instead of
		plotmath expressions for constructing labels with units}
	\item{type}{for \code{Surv} objects specifies the type of element for
		which to restrict the search for a label}
  \item{label}{a character string containing a variable's label}
  \item{plotmath}{
    set to \code{TRUE} to have \code{labelMathplot} return an expression
    for plotting using \R's \code{plotmath} facility.  If \R is not in
    effect, an ordinary character string is returned.
  }
	\item{chexpr}{set to \code{TRUE} to have \code{labelPlotmath} return a
		character string of the form \code{"expression(...)"}}
	\item{size}{LaTeX size for \code{units}.  Default is two sizes smaller
		than \code{label}, which assumes that the LaTeX \code{relsize}
		package is in use.}
	\item{hfill}{set to \code{TRUE} to right-justify \code{units} in the
		field.  This is useful when multiple labels are being put into rows
		in a LaTeX \code{tabular} environment, and will cause a problem if
		the label is used in an environment where \code{hfill} is not
		appropriate.}
	\item{bold}{set to \code{TRUE} to have \code{labelLatex} put the
		\code{label} in bold face.}
	\item{double}{set to \code{TRUE} to represent backslash in LaTeX as
		four backslashes in place of two.  This is needed if, for example,
		you need to convert the result using \code{as.formula}}
  \item{value}{
    the label of the object, or "".
  }
  \item{object}{
    a data frame
  }
  \item{\dots}{
    a list of variables or expressions to be formed into a \code{list}.
    Ignored for \code{print.labelled}.  For \code{relevel} is the
		\code{level} (a single character string) to become the new reference
		(first) category.  For \code{putHfig} and \code{putHcap} represents
		one or more character strings that are pasted together, separated by
		a blank. 
  }
  \item{file}{
    the name of a file to which to write S source code.  Default is
    \code{""}, meaning standard output.  For \code{putHcap}, set
		\code{file} to \code{FALSE} to return a character vector instead of
		writing to \code{file}.}
  \item{append}{
    set to \code{TRUE} to append code generated by \code{Label} to file
		\code{file}.  Also used for \code{putHfig, putHcap}.
  }
  \item{labels}{
    set to \code{FALSE} to make \code{llist} ignore the variables'
		\code{label} attribute and  use the variables' names.
  }
	\item{lcap}{an optional vector of character strings corresponding to
		elements in \code{x} for \code{prList}.  These contain long captions
		that do not appear in the table of contents but which are printed
		right after the short caption in the body, in the same font.}
	\item{htmlfig}{for \code{prList} set to \code{1} to use HTML markup by
		running the object names through \code{markupSpecs$html$cap} for
			figure captions.  Set \code{htmlfig=2} to also preface the figure
			caption with \code{"### "} so that it will appear in the table of
			contents.}
	\item{after}{set to \code{TRUE} to have \code{prList} put names after
		the printed object instead of before}
	\item{scap}{a character string specifying the short (or possibly only)
		caption.}
	\item{extra}{an optional vector of character strings.  When present
		the long caption will be put in the first column of an HTML table
		and the elements of \code{extra} in subsequent columns.  This allows
		extra information to appear in the long caption in a way that is
		right-justified to the right of the flowing caption text.}
	\item{subsub}{set to \code{FALSE} to suppress \code{"### "} from being
		placed in front of the short caption.  Set it to different character
		string to use that instead.  Set it to \code{""} to ignore short
		captions entirely.  For example to use second-level headings for the
	table of contents specify \code{subsub="## "}.}
	\item{hr}{applies if a caption is present.  Specify \code{FALSE} to
		not put a horizontal line before the caption and figure.}
	\item{table}{set to \code{TRUE} to produce table captions instead of
		figure captions}
	\item{expcoll}{character string to be visible, with a clickable arrow
		following to allow initial hiding of a table and its captions.
		Cannot be used with \code{table=FALSE}.}
}
\value{
  \code{label} returns the label attribute of x, if any; otherwise, "".
  \code{label} is used
  most often for the individual variables in data frames.  The function
  \code{sas.get} copies labels over from SAS if they exist.
}
\seealso{
  \code{\link{sas.get}}, \code{\link{describe}},
	\code{\link{extractlabs}}, \code{\link{hlab}} 
}
\examples{
age <- c(21,65,43)
y   <- 1:3
label(age) <- "Age in Years"
plot(age, y, xlab=label(age))

data <- data.frame(age=age, y=y)
label(data)

label(data, self=TRUE) <- "A data frame"
label(data, self=TRUE)

x1 <- 1:10
x2 <- 10:1
label(x2) <- 'Label for x2'
units(x2) <- 'mmHg'
x2
x2[1:5]
dframe <- data.frame(x1, x2)
Label(dframe)

labelLatex(x2, hfill=TRUE, bold=TRUE)
labelLatex(label='Velocity', units='m/s')

##In these examples of llist, note that labels are printed after
##variable names, because of print.labelled
a <- 1:3
b <- 4:6
label(b) <- 'B Label'
llist(a,b)
llist(a,b,d=0)
llist(a,b,0)


w <- llist(a, b>5, d=101:103)
sapply(w, function(x){
  hist(as.numeric(x), xlab=label(x))
  # locator(1)   ## wait for mouse click
})

# Or: for(u in w) {hist(u); title(label(u))}
}
\keyword{attribute}
\keyword{misc}
\keyword{utilities}
% Converted by Sd2Rd version 1.21.

\name{colorFacet}
\alias{colorFacet}
\alias{arrGrob}
\alias{print.arrGrob}
\title{Miscellaneous ggplot2 and grid Helper Functions}
\description{
These functions are used on \code{ggplot2} objects or as layers when
building a \code{ggplot2} object, and to facilitate use of
\code{gridExtra}.  \code{colorFacet} colors the thin 
rectangles used to separate panels created by \code{facet_grid} (and
probably by \code{facet_wrap}). 
A better approach may be found at \url{https://stackoverflow.com/questions/28652284/}.
\code{arrGrob} is a front-end to \code{gridExtra::arrangeGrob} that
allows for proper printing.  See
\url{https://stackoverflow.com/questions/29062766/store-output-from-gridextragrid-arrange-into-an-object/}.  The \code{arrGrob} \code{print} method calls \code{grid::grid.draw}.
}
\usage{
colorFacet(g, col = adjustcolor("blue", alpha.f = 0.3))

arrGrob(\dots)

\method{print}{arrGrob}(x, \dots)
}
\arguments{
  \item{g}{a \code{ggplot2} object that used faceting}
	\item{col}{color for facet separator rectanges}
	\item{\dots}{passed to \code{arrangeGrob}}
	\item{x}{an object created by \code{arrGrob}}
}
\author{Sandy Muspratt}
\examples{
\dontrun{
require(ggplot2)
s <- summaryP(age + sex ~ region + treatment)
colorFacet(ggplot(s))   # prints directly
# arrGrob is called by rms::ggplot.Predict and others
}
}
\keyword{hplot}

\name{aregImpute}
\alias{aregImpute}
\alias{print.aregImpute}
\alias{plot.aregImpute}
\alias{reformM}
\title{
Multiple Imputation using Additive Regression, Bootstrapping, and
Predictive Mean Matching
}
\description{
The \code{transcan} function creates flexible additive imputation models
but provides only an approximation to true multiple imputation as the
imputation models are fixed before all multiple imputations are
drawn.  This ignores variability caused by having to fit the
imputation models.  \code{aregImpute} takes all aspects of uncertainty in
the imputations into account by using the bootstrap to approximate the
process of drawing predicted values from a full Bayesian predictive
distribution.  Different bootstrap resamples are used for each of the
multiple imputations, i.e., for the \code{i}th imputation of a sometimes
missing variable, \code{i=1,2,\dots n.impute}, a flexible additive
model is fitted on a sample with replacement from the original data and
this model is used to predict all of the original missing and
non-missing values for the target variable.

\code{areg} is used to fit the imputation models.  By default, linearity
is assumed for target variables (variables being imputed) and
\code{nk=3} knots are assumed for continuous predictors transformed
using restricted cubic splines.  If \code{nk} is three or greater and
\code{tlinear} is set to \code{FALSE}, \code{areg}
simultaneously finds transformations of the target variable and of all of
the predictors, to get a good fit assuming additivity, maximizing
\eqn{R^2}, using the same canonical correlation method as
\code{transcan}.  Flexible transformations may be overridden for
specific variables by specifying the identity transformation for them.
When a categorical variable is being predicted, the flexible
transformation is Fisher's optimum scoring method.  Nonlinear transformations for continuous variables may be nonmonotonic.  If
\code{nk} is a vector, \code{areg}'s bootstrap and \code{crossval=10}
options will be used to help find the optimum validating value of
\code{nk} over values of that vector, at the last imputation iteration.
For the imputations, the minimum value of \code{nk} is used.

Instead of defaulting to taking random draws from fitted imputation
models using random residuals as is done by \code{transcan},
\code{aregImpute} by default uses predictive mean matching with optional
weighted probability sampling of donors rather than using only the
closest match.  Predictive mean matching works for binary, categorical,
and continuous variables without the need for iterative maximum
likelihood fitting for binary and categorical variables, and without the
need for computing residuals or for curtailing imputed values to be in
the range of actual data.  Predictive mean matching is especially
attractive when the variable being imputed is also being transformed
automatically.  Constraints may be placed on variables being imputed
with predictive mean matching, e.g., a missing hospital discharge date
may be required to be imputed from a donor observation whose discharge
date is before the recipient subject's first post-discharge visit date.
See Details below for more information about the
algorithm.  A \code{"regression"} method is also available that is
similar to that used in \code{transcan}.  This option should be used
when mechanistic missingness requires the use of extrapolation during
imputation.

A \code{print} method summarizes the results, and a \code{plot} method plots
distributions of imputed values.  Typically, \code{fit.mult.impute} will
be called after \code{aregImpute}.

If a target variable is transformed nonlinearly (i.e., if \code{nk} is
greater than zero and \code{tlinear} is set to \code{FALSE}) and the
estimated target variable transformation is non-monotonic, imputed
values are not unique.  When \code{type='regression'}, a random choice
of possible inverse values is made.

The \code{reformM} function provides two ways of recreating a formula to
give to \code{aregImpute} by reordering the variables in the formula.
This is a modified version of a function written by Yong Hao Pua.  One
can specify \code{nperm} to obtain a list of \code{nperm} randomly
permuted variables.  The list is converted to a single ordinary formula
if \code{nperm=1}.  If \code{nperm} is omitted, variables are sorted in
descending order of the number of \code{NA}s.  \code{reformM} also
prints a recommended number of multiple imputations to use, which is a
minimum of 5 and the percent of incomplete observations.
}
\usage{
aregImpute(formula, data, subset, n.impute=5, group=NULL,
           nk=3, tlinear=TRUE, type=c('pmm','regression','normpmm'),
           pmmtype=1, match=c('weighted','closest','kclosest'),
           kclosest=3, fweighted=0.2,
           curtail=TRUE, constraint=NULL,
           boot.method=c('simple', 'approximate bayesian'),
           burnin=3, x=FALSE, pr=TRUE, plotTrans=FALSE, tolerance=NULL, B=75)
\method{print}{aregImpute}(x, digits=3, \dots)
\method{plot}{aregImpute}(x, nclass=NULL, type=c('ecdf','hist'),
     datadensity=c("hist", "none", "rug", "density"),
     diagnostics=FALSE, maxn=10, \dots)
reformM(formula, data, nperm)
}
\arguments{
\item{formula}{
an S model formula.  You can specify restrictions for transformations
of variables.  The function automatically determines which variables
are categorical (i.e., \code{factor}, \code{category}, or character vectors).
Binary variables are automatically restricted to be linear.  Force
linear transformations of continuous variables by enclosing variables
by the identify function (\code{I()}).  It is recommended that
\code{factor()} or \code{as.factor()} do not appear in the formula but
instead variables be converted to factors as needed and stored in the
data frame.  That way imputations for factor variables (done using
\code{\link{impute.transcan}} for example) will be correct.  Currently
\code{reformM} does not handle variables that are enclosed in functions
such as \code{I()}.
}
\item{x}{
  an object created by \code{aregImpute}.  For \code{aregImpute}, set
  \code{x} to \code{TRUE} to save the data matrix containing the final (number
  \code{n.impute}) imputations in the result.  This
  is needed if you want to later do out-of-sample imputation.
  Categorical variables are coded as integers in this matrix.
}
\item{data}{input raw data}
\item{subset}{
These may be also be specified.  You may not specify \code{na.action} as
\code{na.retain} is always used.
}
\item{n.impute}{
number of multiple imputations.  \code{n.impute=5} is frequently
recommended but 10 or more doesn't hurt.
}
\item{group}{a character or factor variable the same length as the
  number of observations in \code{data} and containing no \code{NA}s.
  When \code{group} is present, causes a bootstrap sample of the
  observations corresponding to non-\code{NA}s of a target variable to
  have the same frequency distribution of \code{group} as the
  that in the non-\code{NA}s of the original sample.  This can handle
  k-sample problems as well as lower the chance that a bootstrap sample
  will have a missing cell when the original cell frequency was low.
}
\item{nk}{number of knots to use for continuous variables.  When both
  the target variable and the predictors are having optimum
  transformations estimated, there is more instability than with normal
  regression so the complexity of the model should decrease more sharply
  as the sample size decreases.  Hence set \code{nk} to 0 (to force
  linearity for non-categorical variables) or 3 (minimum number of knots
  possible with a linear tail-restricted cubic spline) for small sample
  sizes.  Simulated problems as in the examples section can assist in
  choosing \code{nk}.  Set \code{nk} to a vector to get bootstrap-validated
  and 10-fold cross-validated \eqn{R^2} and mean and median absolute
  prediction errors for imputing each sometimes-missing variable, with
  \code{nk} ranging over the given vector.  The errors are on the
  original untransformed scale.  The mean absolute error is the
  recommended basis for choosing the number of knots (or linearity).
}
\item{tlinear}{set to \code{FALSE} to allow a target variable (variable
  being imputed) to have a nonlinear left-hand-side transformation when
  \code{nk} is 3 or greater}
\item{type}{
  The default is \code{"pmm"} for predictive mean matching,
  which is a more nonparametric approach that will work for categorical
  as well as continuous predictors.  Alternatively, use
  \code{"regression"} when all variables that are sometimes missing are
  continuous and the missingness mechanism is such that entire intervals
  of population values are unobserved.  See the Details section for more
  information.  Another method, \code{type="normpmm"}, only works
  when variables containing \code{NA}s are continuous and \code{tlinear}
  is \code{TRUE} (the default), meaning that the variable being imputed
  is not transformed when it is on the left hand model side.
  \code{normpmm} assumes that the imputation regression parameter
  estimates are multivariately normally distributed and that the
  residual variance has a scaled chi-squared distribution.  For each
  imputation a random draw of the estimates is taken and a random draw
  from sigma is combined with those to get a random draw from the
  posterior predicted value distribution.  Predictive mean matching is
  then done matching these predicted values from incomplete observations
  with predicted values from complete potential donor observations,
  where the latter predictions are based on the imputation model least
  squares parameter estimates and not on random draws from the posterior.
  For the \code{plot} method, specify \code{type="hist"}
  to draw histograms of imputed values with rug plots at the top, or
  \code{type="ecdf"} (the default) to draw empirical CDFs with spike
  histograms at the bottom.
}
\item{pmmtype}{type of matching to be used for predictive mean
  matching when \code{type="pmm"}.  \code{pmmtype=2} means that predicted 
  values for both target incomplete and complete observations come from
  a fit from the same bootstrap sample.  \code{pmmtype=1}, the default,
  means that predicted values for complete observations are based
  on additive regression fits on original complete observations (using last
  imputations for non-target variables as with the other methds), and using
  fits on a bootstrap sample to get predicted values for missing target variables.
  See van Buuren (2012) section 3.4.2 where \code{pmmtype=1} is said to
  work much better when the number of variables is small.
  \code{pmmtype=3} means that complete observation predicted values come
  from a bootstrap sample fit whereas target incomplete observation
  predicted values come from a sample with replacement from the bootstrap
  fit (approximate Bayesian bootstrap).}
\item{match}{
  Defaults to \code{match="weighted"} to do weighted multinomial
  probability sampling using the tricube function (similar to lowess)
  as the weights.  The argument of the tricube function is the absolute
  difference in transformed predicted values of all the donors and of
  the target predicted value, divided by a scaling factor.
  The scaling factor in the tricube function is \code{fweighted} times
  the mean absolute difference between the target predicted value and
  all the possible donor predicted values.  Set \code{match="closest"}
  to find as the donor the observation having the closest predicted
  transformed value, even if that same donor is found repeatedly.  Set
  \code{match="kclosest"} to use a slower implementation that finds,
  after jittering the complete case predicted values, the
  \code{kclosest} complete cases on the target variable being imputed,
  then takes a random sample of one of these \code{kclosest} cases.}
\item{kclosest}{see \code{match}}
\item{fweighted}{
  Smoothing parameter (multiple of mean absolute difference) used when
  \code{match="weighted"}, with a default value of 0.2.  Set
  \code{fweighted} to a number between 0.02 and 0.2 to force the donor
  to have a predicted value closer to the target, and set
  \code{fweighted} to larger values (but seldom larger than 1.0) to allow
  donor values to be less tightly matched.  See the examples below to
  learn how to study the relationship between \code{fweighted} and the
  standard deviation of multiple imputations within individuals.}
\item{curtail}{applies if \code{type='regression'}, causing imputed
  values to be curtailed at the observed range of the target variable.
  Set to \code{FALSE} to allow extrapolation outside the data range.}
\item{constraint}{for predictive mean matching \code{constraint} is a
	named list specifying R \code{expression()}s encoding constaints on
	which donor observations are allowed to be used, based on variables
	that are not missing, i.e., based on donor observations and/or
	recipient observations as long as the target variable being imputed is
	not used for the recipients.  The expressions must evaluate to a
	logical vector with no \code{NA}s and whose length is the number of
	rows in the donor observations.  The expressions refer to donor
	observations by prefixing variable names by \code{d$}, and to a single
	recipient observation by prefixing variables names by \code{r$}.}
\item{boot.method}{By default, simple boostrapping is used in which the
  target variable is predicted using a sample with replacement from the
  observations with non-missing target variable.  Specify
  \code{boot.method='approximate bayesian'} to build the imputation
  models from a sample with replacement from a sample with replacement
  of the observations with non-missing targets.  Preliminary simulations
  have shown this results in good confidence coverage of the final model
  parameters when \code{type='regression'} is used.  Not implemented
  when \code{group} is used.}
\item{burnin}{
  \code{aregImpute} does \code{burnin + n.impute} iterations of the
  entire modeling process.  The first \code{burnin} imputations are
  discarded.  More burn-in iteractions may be requied when multiple
  variables are missing on the same observations.  When only one
  variable is missing, no burn-ins are needed and \code{burnin} is set
  to zero if unspecified.}
\item{pr}{
set to \code{FALSE} to suppress printing of iteration messages
}
\item{plotTrans}{
  set to \code{TRUE} to plot \code{ace} or \code{avas} transformations
  for each variable for each of the multiple imputations.  This is
  useful for determining whether transformations are reasonable.  If
  transformations are too noisy or have long flat sections (resulting in
  "lumps" in the distribution of imputed values), it may be advisable to
  place restrictions on the transformations (monotonicity or linearity).
}
\item{tolerance}{singularity criterion; list the source code in the
  \code{lm.fit.qr.bare} function for details}
\item{B}{number of bootstrap resamples to use if \code{nk} is a vector}
\item{digits}{number of digits for printing}
\item{nclass}{number of bins to use in drawing histogram}
\item{datadensity}{see \code{\link{Ecdf}}}
\item{diagnostics}{
Specify \code{diagnostics=TRUE} to draw plots of imputed values against
sequential imputation numbers, separately for each missing
observations and variable. 
}
\item{maxn}{
Maximum number of observations shown for diagnostics.  Default is
\code{maxn=10}, which limits the number of observations plotted to at most
the first 10.
}
\item{nperm}{number of random formula permutations for \code{reformM};
	omit to sort variables by descending missing count.}
\item{...}{other arguments that are ignored}
}
\value{
a list of class \code{"aregImpute"} containing the following elements:

\item{call}{
the function call expression
}
\item{formula}{
the formula specified to \code{aregImpute}
}
\item{match}{
the \code{match} argument
}
\item{fweighted}{
  the \code{fweighted} argument
  }
\item{n}{
total number of observations in input dataset
}
\item{p}{
number of variables
}
\item{na}{
list of subscripts of observations for which values were originally missing
}
\item{nna}{
named vector containing the numbers of missing values in the data
}
\item{type}{
vector of types of transformations used for each variable
(\code{"s","l","c"} for smooth spline, linear, or categorical with dummy
variables)
}
\item{tlinear}{value of \code{tlinear} parameter}
\item{nk}{number of knots used for smooth transformations}
\item{cat.levels}{
list containing character vectors specifying the \code{levels} of
categorical variables
}
\item{df}{degrees of freedom (number of parameters estimated) for each
  variable}
\item{n.impute}{
number of multiple imputations per missing value
}
\item{imputed}{
a list containing matrices of imputed values in the same format as
those created by \code{transcan}.  Categorical variables are coded using
their integer codes.  Variables having no missing values will have
\code{NULL} matrices in the list.
}
\item{x}{if \code{x} is \code{TRUE}, the original data matrix with
  integer codes for categorical variables}
\item{rsq}{
for the last round of imputations, a vector containing the R-squares
with which each sometimes-missing variable could be predicted from the
others by \code{ace} or \code{avas}.}
}
\details{
The sequence of steps used by the \code{aregImpute} algorithm is the
following.
\cr
(1) For each variable containing m \code{NA}s where m > 0, initialize the
\code{NA}s to values from a random sample (without replacement if
a sufficient number of non-missing values exist) of size m from the
non-missing values.
\cr
(2) For \code{burnin+n.impute} iterations do the following steps.  The
first \code{burnin} iterations provide a burn-in, and imputations are
saved only from the last \code{n.impute} iterations.
\cr
(3) For each variable containing any \code{NA}s, draw a sample with
replacement from the observations in the entire dataset in which the
current variable being imputed is non-missing.  Fit a flexible
additive model to predict this target variable while finding the
optimum transformation of it (unless the identity
transformation is forced).  Use this fitted flexible model to
predict the target variable in all of the original observations.
Impute each missing value of the target variable with the observed
value whose predicted transformed value is closest to the predicted
transformed value of the missing value (if \code{match="closest"} and
\code{type="pmm"}), 
or use a draw from a multinomial distribution with probabilities derived
from distance weights, if \code{match="weighted"} (the default).
\cr
(4) After these imputations are computed, use these random draw
imputations the next time the curent target variable is used as a
predictor of other sometimes-missing variables.

When \code{match="closest"}, predictive mean matching does not work well
when fewer than 3 variables are used to predict the target variable,
because many of the multiple imputations for an observation will be
identical.  In the extreme case of one right-hand-side variable and
assuming that only monotonic transformations of left and right-side
variables are allowed, every bootstrap resample will give predicted
values of the target variable that are monotonically related to
predicted values from every other bootstrap resample.  The same is true
for Bayesian predicted values.  This causes predictive mean matching to
always match on the same donor observation.

When the missingness mechanism for a variable is so systematic that the
distribution of observed values is truncated, predictive mean matching
does not work.  It will only yield imputed values that are near observed
values, so intervals in which no values are observed will not be
populated by imputed values.  For this case, the only hope is to make
regression assumptions and use extrapolation.  With
\code{type="regression"}, \code{aregImpute} will use linear
extrapolation to obtain a (hopefully) reasonable distribution of imputed
values.  The \code{"regression"} option causes \code{aregImpute} to
impute missing values by adding a random sample of residuals (with
replacement if there are more \code{NA}s than measured values) on the
transformed scale of the target variable.  After random residuals are
added, predicted random draws are obtained on the original untransformed
scale using reverse linear interpolation on the table of original and
transformed target values (linear extrapolation when a random residual
is large enough to put the random draw prediction outside the range of
observed values).  The bootstrap is used as with \code{type="pmm"} to
factor in the uncertainty of the imputation model.

As model uncertainty is high when the transformation of a target
variable is unknown, \code{tlinear} defaults to \code{TRUE} to limit the
variance in predicted values when \code{nk} is positive.
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\references{
  van Buuren, Stef.  Flexible Imputation of Missing Data.  Chapman &
  Hall/CRC, Boca Raton FL, 2012.
  
  Little R, An H.  Robust likelihood-based analysis of multivariate data
  with missing values. Statistica Sinica 14:949-968, 2004.

  van Buuren S, Brand JPL, Groothuis-Oudshoorn CGM, Rubin DB.  Fully
  conditional specifications in multivariate imputation.  J Stat Comp
  Sim 72:1049-1064, 2006.

  de Groot JAH, Janssen KJM, Zwinderman AH, Moons KGM, Reitsma JB.
  Multiple imputation to correct for partial verification bias
  revisited.  Stat Med 27:5880-5889, 2008.

  Siddique J. Multiple imputation using an iterative hot-deck with
  distance-based donor selection.  Stat Med 27:83-102, 2008.

  White IR, Royston P, Wood AM.  Multiple imputation using chained
  equations: Issues and guidance for practice.  Stat Med 30:377-399,
  2011.

	Curnow E, Carpenter JR, Heron JE, et al: Multiple imputation of
  missing data under missing at random: compatible imputation models are
  not sufficient to avoid bias if they are mis-specified. J Clin Epi
  June 9, 2023.  DOI:10.1016/j.jclinepi.2023.06.011. 
  }
\seealso{
\code{\link{fit.mult.impute}}, \code{\link{transcan}}, \code{\link{areg}}, \code{\link{naclus}}, \code{\link{naplot}}, \code{\link[mice]{mice}},
\code{\link{dotchart3}}, \code{\link{Ecdf}}, \code{\link{completer}}
}
\examples{
# Check that aregImpute can almost exactly estimate missing values when
# there is a perfect nonlinear relationship between two variables
# Fit restricted cubic splines with 4 knots for x1 and x2, linear for x3
set.seed(3)
x1 <- rnorm(200)
x2 <- x1^2
x3 <- runif(200)
m <- 30
x2[1:m] <- NA
a <- aregImpute(~x1+x2+I(x3), n.impute=5, nk=4, match='closest')
a
matplot(x1[1:m]^2, a$imputed$x2)
abline(a=0, b=1, lty=2)

x1[1:m]^2
a$imputed$x2


# Multiple imputation and estimation of variances and covariances of
# regression coefficient estimates accounting for imputation
# Example 1: large sample size, much missing data, no overlap in
# NAs across variables
x1 <- factor(sample(c('a','b','c'),1000,TRUE))
x2 <- (x1=='b') + 3*(x1=='c') + rnorm(1000,0,2)
x3 <- rnorm(1000)
y  <- x2 + 1*(x1=='c') + .2*x3 + rnorm(1000,0,2)
orig.x1 <- x1[1:250]
orig.x2 <- x2[251:350]
x1[1:250] <- NA
x2[251:350] <- NA
d <- data.frame(x1,x2,x3,y, stringsAsFactors=TRUE)
# Find value of nk that yields best validating imputation models
# tlinear=FALSE means to not force the target variable to be linear
f <- aregImpute(~y + x1 + x2 + x3, nk=c(0,3:5), tlinear=FALSE,
                data=d, B=10) # normally B=75
f
# Try forcing target variable (x1, then x2) to be linear while allowing
# predictors to be nonlinear (could also say tlinear=TRUE)
f <- aregImpute(~y + x1 + x2 + x3, nk=c(0,3:5), data=d, B=10)
f

\dontrun{
# Use 100 imputations to better check against individual true values
f <- aregImpute(~y + x1 + x2 + x3, n.impute=100, data=d)
f
par(mfrow=c(2,1))
plot(f)
modecat <- function(u) {
 tab <- table(u)
 as.numeric(names(tab)[tab==max(tab)][1])
}
table(orig.x1,apply(f$imputed$x1, 1, modecat))
par(mfrow=c(1,1))
plot(orig.x2, apply(f$imputed$x2, 1, mean))
fmi <- fit.mult.impute(y ~ x1 + x2 + x3, lm, f, 
                       data=d)
sqrt(diag(vcov(fmi)))
fcc <- lm(y ~ x1 + x2 + x3)
summary(fcc)   # SEs are larger than from mult. imputation
}
\dontrun{
# Example 2: Very discriminating imputation models,
# x1 and x2 have some NAs on the same rows, smaller n
set.seed(5)
x1 <- factor(sample(c('a','b','c'),100,TRUE))
x2 <- (x1=='b') + 3*(x1=='c') + rnorm(100,0,.4)
x3 <- rnorm(100)
y  <- x2 + 1*(x1=='c') + .2*x3 + rnorm(100,0,.4)
orig.x1 <- x1[1:20]
orig.x2 <- x2[18:23]
x1[1:20] <- NA
x2[18:23] <- NA
#x2[21:25] <- NA
d <- data.frame(x1,x2,x3,y, stringsAsFactors=TRUE)
n <- naclus(d)
plot(n); naplot(n)  # Show patterns of NAs
# 100 imputations to study them; normally use 5 or 10
f  <- aregImpute(~y + x1 + x2 + x3, n.impute=100, nk=0, data=d)
par(mfrow=c(2,3))
plot(f, diagnostics=TRUE, maxn=2)
# Note: diagnostics=TRUE makes graphs similar to those made by:
# r <- range(f$imputed$x2, orig.x2)
# for(i in 1:6) {  # use 1:2 to mimic maxn=2
#   plot(1:100, f$imputed$x2[i,], ylim=r,
#        ylab=paste("Imputations for Obs.",i))
#   abline(h=orig.x2[i],lty=2)
# }

table(orig.x1,apply(f$imputed$x1, 1, modecat))
par(mfrow=c(1,1))
plot(orig.x2, apply(f$imputed$x2, 1, mean))


fmi <- fit.mult.impute(y ~ x1 + x2, lm, f, 
                       data=d)
sqrt(diag(vcov(fmi)))
fcc <- lm(y ~ x1 + x2)
summary(fcc)   # SEs are larger than from mult. imputation
}

\dontrun{
# Study relationship between smoothing parameter for weighting function
# (multiplier of mean absolute distance of transformed predicted
# values, used in tricube weighting function) and standard deviation
# of multiple imputations.  SDs are computed from average variances
# across subjects.  match="closest" same as match="weighted" with
# small value of fweighted.
# This example also shows problems with predicted mean
# matching almost always giving the same imputed values when there is
# only one predictor (regression coefficients change over multiple
# imputations but predicted values are virtually 1-1 functions of each
# other)

set.seed(23)
x <- runif(200)
y <- x + runif(200, -.05, .05)
r <- resid(lsfit(x,y))
rmse <- sqrt(sum(r^2)/(200-2))   # sqrt of residual MSE

y[1:20] <- NA
d <- data.frame(x,y)
f <- aregImpute(~ x + y, n.impute=10, match='closest', data=d)
# As an aside here is how to create a completed dataset for imputation
# number 3 as fit.mult.impute would do automatically.  In this degenerate
# case changing 3 to 1-2,4-10 will not alter the results.
imputed <- impute.transcan(f, imputation=3, data=d, list.out=TRUE,
                           pr=FALSE, check=FALSE)
sd <- sqrt(mean(apply(f$imputed$y, 1, var)))

ss <- c(0, .01, .02, seq(.05, 1, length=20))
sds <- ss; sds[1] <- sd

for(i in 2:length(ss)) {
  f <- aregImpute(~ x + y, n.impute=10, fweighted=ss[i])
  sds[i] <- sqrt(mean(apply(f$imputed$y, 1, var)))
}

plot(ss, sds, xlab='Smoothing Parameter', ylab='SD of Imputed Values',
     type='b')
abline(v=.2,  lty=2)  # default value of fweighted
abline(h=rmse, lty=2)  # root MSE of residuals from linear regression
}

\dontrun{
# Do a similar experiment for the Titanic dataset
getHdata(titanic3)
h <- lm(age ~ sex + pclass + survived, data=titanic3)
rmse <- summary(h)$sigma
set.seed(21)
f <- aregImpute(~ age + sex + pclass + survived, n.impute=10,
                data=titanic3, match='closest')
sd <- sqrt(mean(apply(f$imputed$age, 1, var)))

ss <- c(0, .01, .02, seq(.05, 1, length=20))
sds <- ss; sds[1] <- sd

for(i in 2:length(ss)) {
  f <- aregImpute(~ age + sex + pclass + survived, data=titanic3,
                  n.impute=10, fweighted=ss[i])
  sds[i] <- sqrt(mean(apply(f$imputed$age, 1, var)))
}

plot(ss, sds, xlab='Smoothing Parameter', ylab='SD of Imputed Values',
     type='b')
abline(v=.2,   lty=2)  # default value of fweighted
abline(h=rmse, lty=2)  # root MSE of residuals from linear regression
}


set.seed(2)
d <- data.frame(x1=runif(50), x2=c(rep(NA, 10), runif(40)),
                x3=c(runif(4), rep(NA, 11), runif(35)))
reformM(~ x1 + x2 + x3, data=d)
reformM(~ x1 + x2 + x3, data=d, nperm=2)
# Give result or one of the results as the first argument to aregImpute

# Constrain imputed values for two variables
# Require imputed values for x2 to be above 0.2
# Assume x1 is never missing and require imputed values for
# x3 to be less than the recipient's value of x1
a <- aregImpute(~ x1 + x2 + x3, data=d,
                constraint=list(x2 = expression(d$x2 > 0.2),
                                x3 = expression(d$x3 < r$x1)))
a
}
\keyword{smooth}
\keyword{regression}
\keyword{multivariate}
\keyword{methods}
\keyword{models}
\concept{bootstrap}
\concept{predictive mean matching}
\concept{imputation}
\concept{NA}
\concept{missing data}

\name{impute}
\alias{impute}
\alias{impute.default}
\alias{print.impute}
\alias{summary.impute}
\alias{[.impute}
\alias{is.imputed}
\title{
Generic Functions and Methods for Imputation
}
\description{
These functions do simple and \code{transcan} 
imputation and print, summarize, and subscript
variables that have NAs filled-in with imputed values.  The simple
imputation method involves filling in NAs with constants,
with a specified single-valued function of the non-NAs, or from
a sample (with replacement) from the non-NA values (this is useful
in multiple imputation).
More complex imputations can be done
with the \code{transcan} function, which also works with the generic methods
shown here, i.e., \code{impute} can take a \code{transcan} object and use  the
imputed values created by \code{transcan} (with \code{imputed=TRUE})  to fill-in NAs.
The \code{print} method places * after variable values that were imputed.
The \code{summary} method summarizes all imputed values and then uses
the next \code{summary} method available for the variable.
The subscript method preserves attributes of the variable and subsets
the list of imputed values corresponding with how the variable was
subsetted.  The \code{is.imputed} function is for checking if observations
are imputed.
}
\usage{
impute(x, ...)

\method{impute}{default}(x, fun=median, ...)

\method{print}{impute}(x, ...)

\method{summary}{impute}(object, ...)

is.imputed(x)
}
\arguments{
\item{x}{
a vector or an object created by \code{transcan}, or a vector needing
basic unconditional imputation.  If there are no \code{NA}s and \code{x}
is a vector, it is returned unchanged.
}
\item{fun}{
the name of a function to use in computing the (single) 
imputed value from the non-NAs.  The default is \code{median}.
If instead of specifying a function as \code{fun}, a single value or vector
(numeric, or character if \code{object} is a factor) is specified,
those values are used for insertion.  \code{fun} can also be the character
string \code{"random"} to draw random values for imputation, with the random
values not forced to be the same if there are multiple NAs.
For a vector of constants, the vector must be of length one
(indicating the same value replaces all NAs) or must be as long as
the number of NAs, in which case the values correspond to consecutive NAs
to replace.  For a factor \code{object}, constants for imputation may include
character values not in the current levels of \code{object}.  In that
case new levels are added.
If \code{object} is of class \code{"factor"}, \code{fun} is ignored and the
most frequent category is used for imputation.
}
\item{object}{an object of class \code{"impute"}}
\item{...}{ignored}
}
\value{
a vector with class \code{"impute"} placed in front of existing classes.
For \code{is.imputed}, a vector of logical values is returned (all
\code{TRUE} if \code{object} is not of class \code{impute}).
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\seealso{
\code{\link{transcan}}, \code{\link{impute.transcan}}, \code{\link{describe}}, \code{\link{na.include}}, \code{\link{sample}}
}
\examples{
age <- c(1,2,NA,4)
age.i <- impute(age)
# Could have used impute(age,2.5), impute(age,mean), impute(age,"random")
age.i
summary(age.i)
is.imputed(age.i)
}
\keyword{methods}
\keyword{math}
\keyword{htest}
\keyword{models}

\name{upData}
\alias{cleanup.import}
\alias{upData}
\alias{dataframeReduce}
\title{
  Update a Data Frame or Cleanup a Data Frame after Importing
}
\description{
  \code{cleanup.import} will correct errors and shrink
  the size of data frames.  By default, double precision numeric
  variables are changed to integer when they contain no fractional components. 
  Infinite values or values greater than 1e20 in absolute value are set
  to NA.  This solves problems of importing Excel spreadsheets that
  contain occasional character values for numeric columns, as S
  converts these to \code{Inf} without warning.  There is also an option to
  convert variable names to lower case and to add labels to variables.
  The latter can be made easier by importing a CNTLOUT dataset created
  by SAS PROC FORMAT and using the \code{sasdict} option as shown in the
  example below.  \code{cleanup.import} can also transform character or
  factor variables to dates.

  \code{upData} is a function facilitating the updating of a data frame
  without attaching it in search position one.  New variables can be
  added, old variables can be modified, variables can be removed or renamed, and
  \code{"labels"} and \code{"units"} attributes can be provided.
  Observations can be subsetted.  Various checks
  are made for errors and inconsistencies, with warnings issued to help
  the user.  Levels of factor variables can be replaced, especially
  using the \code{list} notation of the standard \code{merge.levels}
  function.  Unless \code{force.single} is set to \code{FALSE}, 
  \code{upData} also converts double precision vectors to integer if no
  fractional values are present in 
  a vector.  \code{upData} is also used to process R workspace objects
  created by StatTransfer, which puts variable and value labels as attributes on
  the data frame rather than on each variable. If such attributes are
  present, they are used to define all the labels and value labels
  (through conversion to factor variables) before any label changes
  take place, and \code{force.single} is set to a default of
  \code{FALSE}, as StatTransfer already does conversion to integer.

	Variables having labels but not classed \code{"labelled"} (e.g., data
	imported using the \code{haven} package) have that class added to them
	by \code{upData}.

  The \code{dataframeReduce} function removes variables from a data frame
  that are problematic for certain analyses.  Variables can be removed
  because the fraction of missing values exceeds a threshold, because they
  are character or categorical variables having too many levels, or
  because they are binary and have too small a prevalence in one of the
  two values.  Categorical variables can also have their levels combined
  when a level is of low prevalence.  A data frame listing actions take
  is return as attribute \code{"info"} to the main returned data frame.
}
\usage{
cleanup.import(obj, labels, lowernames=FALSE, 
               force.single=TRUE, force.numeric=TRUE, rmnames=TRUE,
               big=1e20, sasdict, print, datevars=NULL, datetimevars=NULL,
               dateformat='\%F',
               fixdates=c('none','year'),
               autodate=FALSE, autonum=FALSE, fracnn=0.3,
               considerNA=NULL, charfactor=FALSE)

upData(object, \dots, 
       subset, rename, drop, keep, labels, units, levels, force.single=TRUE,
       lowernames=FALSE, caplabels=FALSE, classlab=FALSE, moveUnits=FALSE,
       charfactor=FALSE, print=TRUE, html=FALSE)

dataframeReduce(data, fracmiss=1, maxlevels=NULL,  minprev=0, print=TRUE)
}
\arguments{
  \item{obj}{a data frame or list}
  \item{object}{a data frame or list}
  \item{data}{a data frame}
  \item{force.single}{
    By default, double precision variables are converted to single precision
    (in S-Plus only) unless \code{force.single=FALSE}.
    \code{force.single=TRUE} will also convert vectors having only integer
    values to have a storage mode of integer, in R or S-Plus.
  }
  \item{force.numeric}{
    Sometimes importing will cause a numeric variable to be
    changed to a factor vector.  By default, \code{cleanup.import} will check
    each factor variable to see if the levels contain only numeric values
    and \code{""}.  In that case, the variable will be converted to numeric,
    with \code{""} converted to NA.  Set \code{force.numeric=FALSE} to prevent
    this behavior. 
  }
  \item{rmnames}{
    set to `F' to not have `cleanup.import' remove `names' or `.Names'
    attributes from variables
  }
  \item{labels}{
    a character vector the same length as the number of variables in
    \code{obj}.  These character values are taken to be variable labels in the
    same order of variables in \code{obj}.
    For \code{upData}, \code{labels} is a named list or named vector
		with variables in no specific order.
  }
  \item{lowernames}{
    set this to \code{TRUE} to change variable names to lower case.
    \code{upData} does this before applying any other changes, so variable
    names given inside arguments to \code{upData} need to be lower case if
    \code{lowernames==TRUE}. 
  }
  \item{big}{
    a value such that values larger than this in absolute value are set to
    missing by \code{cleanup.import}
  }
  \item{sasdict}{
    the name of a data frame containing a raw imported SAS PROC CONTENTS
    CNTLOUT= dataset.  This is used to define variable names and to add
    attributes to the new data frame specifying the original SAS dataset
    name and label.
  }
  \item{print}{
    set to \code{TRUE} or \code{FALSE} to force or prevent printing of the current
    variable number being processed.  By default, such messages are printed if the
    product of the number of variables and number of observations in \code{obj}
    exceeds 500,000.  For \code{dataframeReduce} set \code{print} to
    \code{FALSE} to suppress printing information about dropped or
	modified variables.  Similar for \code{upData}.}
  \item{datevars}{character vector of names (after \code{lowernames} is
    applied) of variables to consider as a factor or character vector
    containing dates in a format matching \code{dateformat}.  The
    default is \code{"\%F"} which uses the yyyy-mm-dd format.}
  \item{datetimevars}{character vector of names (after \code{lowernames}
    is applied) of variables to consider to be date-time variables, with
    date formats as described under \code{datevars} followed by a space
    followed by time in hh:mm:ss format.  \code{chron} is used to store
    date-time variables.  If all times in the variable
    are 00:00:00 the variable will be converted to an ordinary date variable.}
  \item{dateformat}{for \code{cleanup.import} is the input format (see
    \code{\link{strptime}})}
  \item{fixdates}{for any of the variables listed in \code{datevars}
    that have a \code{dateformat} that \code{cleanup.import} understands,
    specifying \code{fixdates} allows corrections of certain formatting
    inconsistencies before the fields are attempted to be converted to
    dates (the default is to assume that the \code{dateformat} is followed
    for all observation for \code{datevars}).  Currently
    \code{fixdates='year'} is implemented, which will cause 2-digit or
    4-digit years to be shifted to the alternate number of digits when
    \code{dateform} is the default \code{"\%F"} or is \code{"\%y-\%m-\%d"},
    \code{"\%m/\%d/\%y"}, or \code{"\%m/\%d/\%Y"}.  Two-digits years are padded with \code{20}
    on the left.  Set \code{dateformat} to the desired format, not the
    exceptional format.
  }
	\item{autodate}{set to \code{TRUE} to have \code{cleanup.import}
		determine and automatically handle factor or character 
		vectors that mainly contain dates of the form YYYY-mm-dd,
		mm/dd/YYYY, YYYY, or mm/YYYY, where the later two are imputed to,
		respectively, July 3 and the 15th of the month.  Takes effect when
		the fraction of non-dates (of non-missing values) is less than
		\code{fracnn} to allow for some free text such as \code{"unknown"}.
		Attributes 
		\code{special.miss} and \code{imputed} are created for the vector so
		that \code{describe()} will inform the user.  Illegal values are
		converted to \code{NA}s and stored in the \code{special.miss} attribute.}
	\item{autonum}{set to \code{TRUE} to have \code{cleanup.import}
		examine (after \code{autodate}) character and factor variables to
		see if they are legal numerics exact for at most a fraction of
		\code{fracnn} of non-missing non-numeric values.  Qualifying variables are
		converted to numeric, and illegal values set to \code{NA} and stored in
		the \code{special.miss} attribute to enhance \code{describe} output.}
	\item{fracnn}{see \code{autodate} and \code{autonum}}
	\item{considerNA}{for \code{autodate} and \code{autonum}, considers
		character values in the vector \code{considerNA} to be the same as
		\code{NA}.  Leading and trailing white space and upper/lower case
		are ignored.} 
  \item{charfactor}{set to \code{TRUE} to change character variables to
	factors if they have fewer than n/2 unique values.  Null strings and
	blanks are converted to \code{NA}s.}
  \item{\dots}{
    for \code{upData}, one or more expressions of the form
    \code{variable=expression}, to derive new variables or change old ones.
  }
	\item{subset}{an expression that evaluates to a logical vector
		specifying which rows of \code{object} should be retained.  The
		expressions should use the original variable names, i.e., before any
	variables are renamed but after \code{lowernames} takes effect.}
  \item{rename}{
    list or named vector specifying old and new names for variables.  Variables are
    renamed before any other operations are done.  For example, to rename
    variables \code{age} and \code{sex} to respectively \code{Age} and
    \code{gender}, specify \code{rename=list(age="Age", sex="gender")} or
    \code{rename=c(age=\dots)}. 
  }
  \item{drop}{a vector of variable names to remove from the data frame}
	\item{keep}{a vector of variable names to keep, with all other
		variables dropped}
  \item{units}{
    a named vector or list defining \code{"units"} attributes of
		variables, in no specific order
  }
  \item{levels}{
    a named list defining \code{"levels"} attributes for factor variables, in
    no specific order.  The values in this list may be character vectors
    redefining \code{levels} (in order) or another list (see
    \code{merge.levels} if using S-Plus).
  }
  \item{caplabels}{
	set to \code{TRUE} to capitalize the first letter of each word in
	each variable label
	}
  \item{classlab}{
    set to \code{TRUE} (the old default behavior) to automatically have \code{upData} make variables having
    a \code{"label"} attribute have \code{class} of \code{"labelled"}.  Note that when the \code{labels}
    argument to \code{upData} is given, these create \code{labelled}-class variables as always.
  }
  \item{moveUnits}{
    set to \code{TRUE} to look for units of measurements in variable
    labels and move them to a \code{"units"} attribute.  If an expression
    in a label is enclosed in parentheses or brackets it is assumed to be
    units if \code{moveUnits=TRUE}.}
  \item{html}{set to \code{TRUE} to print conversion information as html
		vertabim at 0.6 size.  The user will need to put
		\code{results='asis'} in a \code{knitr} chunk header to properly
		render this output.}
  \item{fracmiss}{the maximum permissable proportion of \code{NA}s for a
    variable to be kept.  Default is to keep all variables no matter how
    many \code{NA}s are present.}
  \item{maxlevels}{the maximum number of levels of a character or
    categorical or factor variable before the variable is dropped}
  \item{minprev}{the minimum proportion of non-missing observations in a
    category for a binary variable to be retained, and the minimum
    relative frequency of a category before it will be combined with other
    small categories}
}
\value{a new data frame}
\author{
  Frank Harrell, Vanderbilt University
}
\seealso{
  \code{\link{sas.get}}, \code{\link{data.frame}}, \code{\link{describe}},
  \code{\link{label}}, \code{\link{read.csv}}, \code{\link{strptime}},
  \code{\link{POSIXct}},\code{\link{Date}}
}
\examples{
\dontrun{
dat <- read.table('myfile.asc')
dat <- cleanup.import(dat)
}
dat <- data.frame(a=1:3, d=c('01/02/2004',' 1/3/04',''))
cleanup.import(dat, datevars='d', dateformat='\%m/\%d/\%y', fixdates='year')

dat <- data.frame(a=(1:3)/7, y=c('a','b1','b2'), z=1:3)
dat2 <- upData(dat, x=x^2, x=x-5, m=x/10, 
               rename=c(a='x'), drop='z',
               labels=c(x='X', y='test'),
               levels=list(y=list(a='a',b=c('b1','b2'))))
dat2
describe(dat2)
dat <- dat2    # copy to original name and delete dat2 if OK
rm(dat2)
dat3 <- upData(dat, X=X^2, subset = x < (3/7)^2 - 5, rename=c(x='X'))

# Remove hard to analyze variables from a redundancy analysis of all
# variables in the data frame
d <- dataframeReduce(dat, fracmiss=.1, minprev=.05, maxlevels=5)
# Could run redun(~., data=d) at this point or include dataframeReduce
# arguments in the call to redun

# If you import a SAS dataset created by PROC CONTENTS CNTLOUT=x.datadict,
# the LABELs from this dataset can be added to the data.  Let's also
# convert names to lower case for the main data file
\dontrun{
mydata2 <- cleanup.import(mydata2, lowernames=TRUE, sasdict=datadict)
}
}
\keyword{data}
\keyword{manip}

\name{na.delete}
\alias{na.delete}
\title{
Row-wise Deletion na.action
}
\description{
Does row-wise deletion as \code{na.omit}, but adds frequency of missing values
for each predictor
to the \code{"na.action"} attribute of the returned model frame.
Optionally stores further details if \code{options(na.detail.response=TRUE)}. 
}
\usage{
na.delete(frame)
}
\arguments{
\item{frame}{
a model frame
}}
\value{
a model frame with rows deleted and the \code{"na.action"} attribute added.
}
\author{
Frank Harrell
\cr
Department of Biostatistics
\cr
Vanderbilt University
\cr
\email{fh@fharrell.com}
}
\seealso{
\code{\link{na.omit}}, \code{\link{na.keep}}, \code{\link{na.detail.response}}, \code{\link{model.frame.default}},
\code{\link{naresid}}, \code{\link{naprint}}
}
\examples{
# options(na.action="na.delete")
# ols(y ~ x)
}
\keyword{models}
% Converted by Sd2Rd version 1.21.

\name{GiniMd}
\alias{GiniMd}
\title{Gini's Mean Difference}
\description{
  \code{GiniMD} computes Gini's mean difference on a
  numeric vector.  This index is defined as the mean absolute difference
  between any two distinct elements of a vector.  For a Bernoulli
  (binary) variable with proportion of ones equal to \eqn{p} and sample
  size \eqn{n}, Gini's mean difference is
  \eqn{2\frac{n}{n-1}p(1-p)}{2np(1-p)/(n-1)}.  For a 
  trinomial variable (e.g., predicted values for a 3-level categorical
  predictor using two dummy variables) having (predicted)
  values \eqn{A, B, C} with corresponding proportions \eqn{a, b, c},
  Gini's mean difference is
  \eqn{2\frac{n}{n-1}[ab|A-B|+ac|A-C|+bc|B-C|]}{2n[ab|A-B|+ac|A-C|+bc|B-C|]/(n-1).}
}
\usage{
GiniMd(x, na.rm=FALSE)
}
\arguments{
\item{x}{a numeric vector (for \code{GiniMd})}
\item{na.rm}{set to \code{TRUE} if you suspect there may be \code{NA}s
  in \code{x}; these will then be removed.  Otherwise an error will
  result.}
}
\value{a scalar numeric}
\references{
David HA (1968): Gini's mean difference rediscovered.  Biometrika 55:573--575.
}
\author{
Frank Harrell\cr
Department of Biostatistics\cr
Vanderbilt University\cr
\email{fh@fharrell.com}
}
\examples{
set.seed(1)
x <- rnorm(40)
# Test GiniMd against a brute-force solution
gmd <- function(x) {
  n <- length(x)
  sum(outer(x, x, function(a, b) abs(a - b))) / n / (n - 1)
  }
GiniMd(x)
gmd(x)

z <- c(rep(0,17), rep(1,6))
n <- length(z)
GiniMd(z)
2*mean(z)*(1-mean(z))*n/(n-1)

a <- 12; b <- 13; c <- 7; n <- a + b + c
A <- -.123; B <- -.707; C <- 0.523
xx <- c(rep(A, a), rep(B, b), rep(C, c))
GiniMd(xx)
2*(a*b*abs(A-B) + a*c*abs(A-C) + b*c*abs(B-C))/n/(n-1)
}
\keyword{robust}
\keyword{univar}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hlab.r
\name{vlab}
\alias{vlab}
\title{vlab}
\usage{
vlab(x, name = NULL)
}
\arguments{
\item{x}{a single variable name, unquoted}

\item{name}{optional character string to use as variable name}
}
\value{
character string
}
\description{
Easily Retrieve Text Form of Labels/Units
}
\details{
Uses the same search method as \code{hlab} returns label and units in a character string with units, if present, in brackets
}
\seealso{
\code{\link[=hlab]{hlab()}}
}
\author{
Frank Harrell
}
